﻿(function() {
    AC = window.AC || {};

    var pages = {},
        currentPage,
        overlay,
        inputs = {},
        url = {
            login: "",
            register: ""
        };

    function checkRequiredInput(id) {
        if (inputs[id]) {}
    }

    function doLogin(account) {
        console.log("doLogin");
        showLoading();

        account = account || {};
        var _id = account._id || inputs["login-id"].value,
            password = account.password || inputs["login-password"].value;

        // TODO: validate input

        xhr = new httpClient({
            asynchronous: true,
            method: "get",
            baseUrl: url.login,
            requestData: {
                _id: _id,
                password: password
            }
        });

        xhr.callback(function(xmlhttp) {
            if (xmlhttp.status === 200) {
                console.log('login succeed');

                localStorage.setItem('_id', _id);
                localStorage.setItem('password', password);

                notifyCocoonJSEventListeners('loginSucceed', JSON.parse(xmlhttp.response));
            } else {
                console.log('login failed');
                console.log(xmlhttp.responseText);
                hideLoading();
                alert(xmlhttp.responseText);
            }
        });

        xhr.makeRequest();
    }

    function doRegister() {
        console.log("register");
        showLoading();

        var name = inputs["register-name"].value,
            _id = inputs["register-id"].value,
            password = inputs["register-password"].value,
            confirmPassword = inputs["register-confirm-password"].value,
            error = 'Đăng kí nhân vật không thành công. Lỗi: \n\n\n';

        if (password !== confirmPassword) {
            error += "* Mật khẩu xác nhận không chính xác\n";
            hideLoading();
            alert(error);
            return;
        }
        // TODO: validate input

        xhr = new httpClient({
            asynchronous: true,
            method: "post",
            baseUrl: url.register,
            requestData: {
                _id: _id,
                password: password,
                full_name: name,
                type: "MOBILE"
            }
        });

        xhr.callback(function(xmlhttp) {
            if (xmlhttp.status === 200) {
                console.log('register succeed');

                localStorage.setItem('_id', _id);
                localStorage.setItem('password', password);

                notifyCocoonJSEventListeners("loginSucceed", xmlhttp.response);
            } else {
                console.log('register failed');
                console.log(xmlhttp.responseText);

                var result = JSON.parse(xmlhttp.response);

                if (result._id) {
                    error = error + '*  ' + result._id.msg + '\n';
                }
                if (result.password) {
                    error = error + '*  ' + result.password.msg + '\n';
                }
                if (result.user) {
                    error = error + '*  ' + result.user.msg + '\n';
                }
                hideLoading();
                alert(error);
            }
        });

        xhr.makeRequest(); //json object {ok:true/false, data:{}}
    }

    function playOffline() {
        showLoading();
        setTimeout(function() {
            notifyCocoonJSEventListeners("playOffline");
        }, 500);
    }

    function showLoading() {
        overlay.style.display = "block";
    }

    function hideLoading() {
        overlay.style.display = "none";
    }

    function goToPage(id) {
        for (var page in pages) {
            if (id === page) {
                var btnBack = pages[page].querySelector("header nav button.back");
                if (btnBack) {

                    btnBack.dataset["link"] = pages[page].dataset["backTo"] || currentPage;
                }
                pages[page].style.display = "block";
            } else {
                pages[page].style.display = "none";
            }
        }

        currentPage = id;
    }

    function addClickListenerById(elemId, handler) {
        var elem = document.getElementById(elemId);
        addClickListener(elem, handler);
    }

    function addClickListener(elem, handler) {
        elem.addEventListener("touchend", handler);
        elem.addEventListener("click", handler);
    }

    AC.init = function() {
        // cache DOM elements
        var i,
            _pages = document.getElementsByClassName("page"),
            _inputs = document.getElementsByTagName("input");

        for (i = 0; i < _pages.length; i++) {
            (function(page) {
                (page.id) && (pages[page.id] = page);
            })(_pages[i]);
        }

        overlay = document.getElementsByClassName("overlay")[0];

        for (i = 0; i < _inputs.length; i++) {
            (function(input) {
                (input.id) && (inputs[input.id] = input);
            })(_inputs[i]);
        }

        // add event handlers for navigation buttons
        var navButtons = document.querySelectorAll("[data-link]");

        for (i = 0; i < navButtons.length; i++) {
            (function(navButton) {
                navButton.addEventListener("click", function() {
                    goToPage(this.dataset["link"]);
                });
            })(navButtons[i]);
        }

        // check local storage for previous login record
        if (localStorage._id && localStorage.password) {
            document.getElementById("previous-player-id").textContent = localStorage._id;

            var loginNav = pages["login"].querySelector("header nav");
            loginNav.className = loginNav.className.replace("initial-hide", "");
            pages["login"].style.display = "none";

            currentPage = "play-online";
            pages["play-online"].style.display = "block";
        } else {
            currentPage = "login";
        }

        // add event handlers for other buttons
        addClickListenerById("btn-mode-online-as", doLogin.bind(null, localStorage));
        addClickListenerById("btn-login", doLogin);

        var playOfflineButtons = document.querySelectorAll("button.btn-mode-offline");
        for (i = 0; i < playOfflineButtons.length; i++) {
            addClickListener(playOfflineButtons[i], playOffline);
        }

        addClickListenerById("btn-register", doRegister);
    };

    AC.setUrl = function(name, link) {
        url[name] = link;
        console.log(url[name]);
    };

    AC.showLoading = showLoading;
    AC.hideLoading = hideLoading;

    window.addEventListener("load", AC.init);
})();