/*
client = new httpClient();
client.host('http://www.tiniplanet.com');
client.doesConnectionExist() ->true/false
client.asynchronous(false);
client.method("get");
client.baseUrl("http://192.168.52.11:8181/mobile/login");
client.requestData({
    _id: 'long',
    password: '123'
});         
text = client.makeRequest(); //json object {ok:true/false, data:{}}
*/

function httpClient(settings) {
    settings = settings || {};
    this.$host = settings.host || 'http://www.tiniplanet.com';
    this.$baseUrl = settings.baseUrl || "http://localhost/";
    this.$method = settings.method || "get";
    this.$requestData = "";
    this.requestData(settings.requestData || "");
    this.$asynchronous = settings.asynchronous || false;

    this.$response = "";
}


httpClient.prototype.doesConnectionExist = function() {
    var xhr = new XMLHttpRequest();

    xhr.open('HEAD', this.$host, false);

    try {
        xhr.send();
        if (xhr.status >= 200 && xhr.status < 304) {
            return true;
        } else {
            return false;
        }
    } catch (e) {
        return false;
    }
};

httpClient.prototype.host = function(host) {
    this.$host = host;
};

httpClient.prototype.method = function(requestMethod) {
    this.$method = requestMethod;
};

httpClient.prototype.baseUrl = function(requestBaseUrl) {
    this.$baseUrl = requestBaseUrl;
};

httpClient.prototype.requestResponse = function() {
    return this.$response;
};

$_xmlhttpConstruct = function() {
    var xmlhttp;
    if (window.XMLHttpRequest) { //IE7+, Firefox, Chrome, Opera, Safari
        return new XMLHttpRequest();
    } else { //IE6, IE5
        try {
            return new ActiveXObject("Msxml2.XMLHTTP.6.0");
        } catch (e) {}
        try {
            return new ActiveXObject("Msxml2.XMLHTTP.3.0");
        } catch (e) {}
        try {
            return new ActiveXObject("Microsoft.XMLHTTP");
        } catch (e) {}
    }
};

httpClient.prototype.setRequestHeader = function(header, value) {

};

$_callbackFunction = null;

httpClient.prototype.callback = function(func) {
    $_callbackFunction = func;
};

$_invokeCallback = function(func, response) {
    try {
        func(response);
    } catch (e) {

    }
};

httpClient.prototype.asynchronous = function(boolean) {
    this.$asynchronous = boolean;
};

httpClient.prototype.makeRequest = function() {

    //Initializing the xmlhttp object
    var xmlhttp = $_xmlhttpConstruct();

    if (this.$requestData == undefined) {
        xmlhttp.open(this.$method, this.$baseUrl, this.$asynchronous);
    } else {
        if (this.$method == "post") {

            xmlhttp.open(this.$method, this.$baseUrl, this.$asynchronous);
            // xmlhttp.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
            xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
            try {
                xmlhttp.send(this.$requestData);
            } catch (e) {
                return {
                    ok: false,
                    data: e,
                    xmlhttp: xmlhttp
                };
            }
            if (this.$asynchronous) {
                xmlhttp.onreadystatechange = function() {
                    if (xmlhttp.readyState == 4) {
                        //Callback
                        $_invokeCallback($_callbackFunction, xmlhttp);
                    }
                };
            } else {
                if (xmlhttp.status === 200) return {
                    ok: true,
                    data: JSON.parse(xmlhttp.response),
                    xmlhttp: xmlhttp
                };
                return {
                    ok: false,
                    data: {
                        message: xmlhttp.responseText
                    },
                    xmlhttp: xmlhttp
                };
            }

            //alert("URL: " + this.$baseUrl + "\n" + "Method: " + this.$method + "\n" + "Request data: " + this.$requestData);
        }

        if (this.$method == "get") {

            xmlhttp.open(this.$method, this.$baseUrl + this.$requestData, this.$asynchronous);
            // xmlhttp.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
            try {
                xmlhttp.send(null);
            } catch (e) {
                return {
                    ok: false,
                    data: e,
                    xmlhttp: xmlhttp
                };
            }
            if (this.$asynchronous) {
                xmlhttp.onreadystatechange = function() {
                    if (xmlhttp.readyState == 4) {
                        //Callback
                        $_invokeCallback($_callbackFunction, xmlhttp);
                    }
                };
            } else {
                if (xmlhttp.status === 200) {
                    var data = xmlhttp.response;
                    try {
                        data = JSON.parse(xmlhttp.response);
                    } catch(err) {}

                    return {
                        ok: true,
                        data: data,
                        xmlhttp: xmlhttp
                    };
                }
                return {
                    ok: false,
                    data: {
                        message: xmlhttp.responseText
                    },
                    xmlhttp: xmlhttp
                };
            }

            //alert("URL: " + this.$baseUrl + "\n" + "Full request URL: " + this.$baseUrl + this.$requestData + "\n" + "Method: " + this.$method + "\n" + "Request data: " + this.$requestData);
        }
    }
};

httpClient.prototype.makeRequestObject = function() {

    var requestObject = {
        method: this.$method,
        url: this.$baseUrl,
        requestData: this.$requestData,
        responseData: "",
        MimeType: "",
        charset: ""
    };

    var xmlhttp;
    if (window.XMLHttpRequest) { //IE7+, Firefox, Chrome, Opera, Safari
        xmlhttp = new XMLHttpRequest();
    } else { //IE6, IE5
        xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    }

    if (this.$requestData == undefined) {
        xmlhttp.open(this.$method, this.$baseUrl, false);
    } else {
        //alert(this.$baseUrl + this.$requestData);
        xmlhttp.open(this.$method, this.$baseUrl + this.$requestData, false);
    }

    if (this.$method == "post") {
        xmlhttp.open(this.$method, this.$baseUrl, false);
        // xmlhttp.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
        xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        xmlhttp.send(this.$requestData);

        //alert("URL: " + this.$baseUrl + "\n" + "Method: " + this.$method + "\n" + "Request data: " + this.$requestData);
    }
    if (this.$method == "get") {
        xmlhttp.open(this.$method, this.$baseUrl + this.$requestData, false);
        // xmlhttp.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
        xmlhttp.send();

        //alert("URL: " + this.$baseUrl + "\n" + "Full request URL: " + this.$baseUrl + this.$requestData + "\n" + "Method: " + this.$method + "\n" + "Request data: " + this.$requestData);
    }

    var mc = xmlhttp.getResponseHeader("Content-Type");
    mc = mc.split(";");

    requestObject.MimeType = mc[0];
    requestObject.charset = mc[1].substring(9);

    requestObject.responseData = xmlhttp.responseText;

    return requestObject;
};

httpClient.prototype.requestData = function(data) {

    if (typeof(data) == "object") {
        var i = 0;
        for (key in data) {
            if (i == 0) {
                if (this.$method == "get") {
                    this.$requestData += "?" + key + "=" + data[key];
                }
                if (this.$method == "post") {
                    this.$requestData += key + "=" + data[key];
                }
                i++;
            } else {
                this.$requestData += "&" + key + "=" + data[key];
            }
        }
    } else {
        this.$requestData = data;
    }
};