﻿// Generated by Construct 2, the HTML5 game and app creator :: http://www.scirra.com
/*! CocoonJSExtensions - v2.0.0 - 2014-04-10 www.ludei.com */(function() {
    // There should not be a CocoonJS object when this code is executed.
    // if (typeof window.CocoonJS !== 'undefined') throw("This is strange, a CocoonJS object already exists when trying to create it.");

    /**
     * The basic object for all the CocoonJS related specific APIs === extensions.
     * @namespace
     */
    CocoonJS = window.CocoonJS ? window.CocoonJS : {};

    CocoonJS.nativeExtensionObjectAvailable = typeof window.ext !== 'undefined';

    /**
     * This type represents a 2D size structure with horizontal and vertical values.
     * @class
     */
    CocoonJS.Size = {
        /**
         * The horizontal size value.
         */
        width: 0,

        /**
         * The vertical size value.
         */
        height: 0
    };

    /**
     * This utility function allows to create an object oriented like hierarchy between two functions using their prototypes.
     * This function adds a "superclass" and a "__super" attributes to the subclass and it's functions to reference the super class.
     * @param {function} subc The subclass function.
     * @param {function} superc The superclass function.
     */
    CocoonJS.extend = function(subc, superc) {
        var subcp = subc.prototype;

        // Class pattern.
        var CocoonJSExtendHierarchyChainClass = function() {};
        CocoonJSExtendHierarchyChainClass.prototype = superc.prototype;

        subc.prototype = new CocoonJSExtendHierarchyChainClass(); // chain prototypes.
        subc.superclass = superc.prototype;
        subc.prototype.constructor = subc;

        // Reset constructor. See Object Oriented Javascript for an in-depth explanation of this.
        if (superc.prototype.constructor === Object.prototype.constructor) {
            superc.prototype.constructor = superc;
        }

        // Check all the elements in the subclass prototype and add them to the chain object's prototype.
        for (var method in subcp) {
            if (subcp.hasOwnProperty(method)) {
                subc.prototype[method] = subcp[method];

                // // tenemos en super un metodo con igual nombre.
                // if ( superc.prototype[method]) 
                // {
                //     subc.prototype[method]= (function(fn, fnsuper) 
                //     {
                //         return function() 
                //         {
                //             var prevMethod= this.__super;

                //             this.__super= fnsuper;

                //             var retValue= fn.apply(
                //                     this,
                //                     Array.prototype.slice.call(arguments) );

                //             this.__super= prevMethod;

                //             return retValue;
                //         };
                //     })(subc.prototype[method], superc.prototype[method]);
                // }
            }
        }
    }

    /**
     * IMPORTANT: This function should only be used by Ludei.
     * This function allows a call to the native extension object function reusing the same arguments object.
     * Why is interesting to use this function instead of calling the native object's function directly?
     * As the CocoonJS object functions expicitly receive parameters, if they are not present and the native call is direcly mapped,
     * undefined arguments are passed to the native side. Some native functions do not check the parameters validation
     * correctly (just check the number of parameters passed).
     * Another solution instead of using this function call is to correctly check if the parameters are valid (not undefined) to make the
     * call, but it takes more work than using this approach.
     * @static
     * @param {string} nativeExtensionObjectName The name of the native extension object name. The object that is a member of the 'ext' object.
     * @param {string} nativeFunctionName The name of the function to be called inside the native extension object.
     * @param {object} arguments The arguments object of the CocoonJS extension object function. It contains all the arguments passed to the CocoonJS extension object function and these are the ones that will be passed to the native call too.
     * @param {boolean} [async] A flag to indicate if the makeCall (false or undefined) or the makeCallAsync function should be used to perform the native call.
     * @returns Whatever the native function call returns.
     */
    CocoonJS.makeNativeExtensionObjectFunctionCall = function(nativeExtensionObjectName, nativeFunctionName, args, async) {
        if (CocoonJS.nativeExtensionObjectAvailable) {
            var argumentsArray = Array.prototype.slice.call(args);
            argumentsArray.unshift(nativeFunctionName);
            var nativeExtensionObject = ext[nativeExtensionObjectName];
            var makeCallFunction = async ? nativeExtensionObject.makeCallAsync : nativeExtensionObject.makeCall;
            var ret = makeCallFunction.apply(nativeExtensionObject, argumentsArray);
            var finalRet = ret;
            if (typeof ret === "string") {
                try {
                    finalRet = JSON.parse(ret);
                } catch (error) {}
            }
            return finalRet;
        }
    };

    /**
     * Returns an object retrieved from a path specified by a dot specified text path starting from a given base object.
     * It could be useful to find the reference of an object from a defined base object. For example the base object could be window and the
     * path could be "CocoonJS.App" or "document.body".
     * @param {Object} baseObject The object to start from to find the object using the given text path.
     * @param {string} objectPath The path in the form of a text using the dot notation. i.e. "document.body"
     * For example:
     * var body = getObjectFromPath(window, "document.body");
     */
    CocoonJS.getObjectFromPath = function(baseObject, objectPath) {
        var parts = objectPath.split('.');
        var obj = baseObject;
        for (var i = 0, len = parts.length; i < len; ++i) {
            obj[parts[i]] = obj[parts[i]] || undefined;
            obj = obj[parts[i]];
        }
        return obj;
    };

    /**
     * Returns the key for a value in a dictionary. It looks for an specific value inside a dictionary and returns the corresponding key.
     * @param {Object} dictionary The dictionary to look for the value in and get the corresponding key.
     * @param {Object} value The value to look for inside the dictionary and return it's corresponding key.
     * @return The key that corresponds to the given value it is has been found or null.
     */
    CocoonJS.getKeyForValueInDictionary = function(dictionary, value) {
        var finalKey = null;
        for (var key in dictionary) {
            if (dictionary[key] === value) {
                finalKey = key;
                break;
            }
        }
        return finalKey;
    }

    /**
     * Finds a string inside a given array of strings by looking for a given substring. It can also
     * specify if the search must be performed taking care or not of the case sensitivity.
     * @param {Array} stringArray The array of strings in which to to look for the string.
     * @param {string} subString The substring to look for inside all the strings of the array.
     * @param {boolean} caseSensitive A flag to indicate if the search must be performed taking case of the
     * case sensitiveness (true) or not (false).
     * @return {string} The string that has been found or null if the substring is not inside any of the string of the array.
     */
    CocoonJS.findStringInStringArrayThatIsIndexOf = function(stringArray, subString, caseSensitive) {
        var foundString = null;
        subString = caseSensitive ? subString : subString.toUpperCase();
        for (var i = 0; foundString == null && i < stringArray.length; i++) {
            foundString = caseSensitive ? stringArray[i] : stringArray[i].toUpperCase();
            foundString = foundString.indexOf(subString) >= 0 ? stringArray[i] : null;
        }
        return foundString;
    };

    /**
     * A class that represents objects to handle events. Event handlers have always the same structure:
     * Mainly they provide the addEventListener and removeEventListener functions.
     * Both functions receive a callback function that will be added or removed. All the added callback
     * functions will be called when the event takes place.
     * Additionally they also allow the addEventListenerOnce and notifyEventListeners functions.
     * @constructor
     * @param {string} nativeExtensionObjectName The name of the native extension object (inside the ext object) to be used.
     * @param {string} cocoonJSExtensionObjectName The name of the sugarized extension object.
     * @param {string} nativeEventName The name of the native event inside the ext object.
     * @param {number} [chainFunction] An optional function used to preprocess the listener callbacks. This function, if provided,
     * will be called before any of the other listeners.
     */
    CocoonJS.EventHandler = function(nativeExtensionObjectName, cocoonJSExtensionObjectName, nativeEventName, chainFunction) {
        this.listeners = [];
        this.listenersOnce = [];
        this.chainFunction = chainFunction;

        /**
         * Adds a callback function so it can be called when the event takes place.
         * @param {function} listener The callback function to be added to the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.addEventListener = function(listener) {
            if (chainFunction) {
                var f = function() {
                    chainFunction.call(this, arguments.callee.sourceListener, Array.prototype.slice.call(arguments));
                };
                listener.CocoonJSEventHandlerChainFunction = f;
                f.sourceListener = listener;
                listener = f;
            }

            var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListener(nativeEventName, listener);
            }
            var indexOfListener = this.listeners.indexOf(listener);
            if (indexOfListener < 0) {
                this.listeners.push(listener);
            }
        };

        this.addEventListenerOnce = function(listener) {
            if (chainFunction) {
                var f = function() {
                    chainFunction(arguments.callee.sourceListener, Array.prototype.slice.call(arguments));
                };
                f.sourceListener = listener;
                listener = f;
            }

            var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListenerOnce(nativeEventName, listener);
            } else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0) {
                    this.listenersOnce.push(listener);
                }
            }
        };

        /**
         * Removes a callback function that was added to the event handler so it won't be called when the event takes place.
         * @param {function} listener The callback function to be removed from the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.removeEventListener = function(listener) {

            if (chainFunction) {
                listener = listener.CocoonJSEventHandlerChainFunction;
                delete listener.CocoonJSEventHandlerChainFunction;
            }

            var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].removeEventListener(nativeEventName, listener);
            } else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener >= 0) {
                    this.listeners.splice(indexOfListener, 1);
                }
            }
        };

        this.notifyEventListeners = function() {
            var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            var argumentsArray = Array.prototype.slice.call(arguments);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].notifyEventListeners(nativeEventName, argumentsArray);
            } else {
                var listeners = Array.prototype.slice.call(this.listeners);
                var listenersOnce = Array.prototype.slice.call(this.listenersOnce);
                var _this = this;
                // Notify listeners after a while ;) === do not block this thread.
                setTimeout(function() {
                    for (var i = 0; i < listeners.length; i++) {
                        listeners[i].apply(_this, argumentsArray);
                    }
                    for (var i = 0; i < listenersOnce.length; i++) {
                        listenersOnce[i].apply(_this, argumentsArray);
                    }
                }, 0);

                _this.listenersOnce = [];
            }
        };
        return this;
    };

    /**
     * A simple timer class. Update it every loop iteration and get values from accumulated time to elapsed time in seconds or milliseconds.
     */
    CocoonJS.Timer = function() {
        this.reset();
        return this;
    };

    CocoonJS.Timer.prototype = {
        currentTimeInMillis: 0,
        lastTimeInMillis: 0,
        elapsedTimeInMillis: 0,
        elapsedTimeInSeconds: 0,
        accumTimeInMillis: 0,

        /**
		Resets the timer to 0.
		*/
        reset: function() {
            this.currentTimeInMillis = this.lastTimeInMillis = new Date().getTime();
            this.accumTimeInMillis = this.elapsedTimeInMillis = this.elapsedTimeInSeconds = 0;
        },

        /**
		Updates the timer calculating the elapsed time between update calls.
		*/
        update: function() {
            this.currentTimeInMillis = new Date().getTime();
            this.elapsedTimeInMillis = this.currentTimeInMillis - this.lastTimeInMillis;
            this.elapsedTimeInSeconds = this.elapsedTimeInMillis / 1000.0;
            this.lastTimeInMillis = this.currentTimeInMillis;
            this.accumTimeInMillis += this.elapsedTimeInMillis;
        }
    };

})();;(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents all the basic functionalities available in the CocoonJS extension API.
     * @namespace
     */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_APP !== 'undefined';

    /**
     * The predefined possible layouts for the FPS overlay.
     * @namespace
     * @enum
     */
    CocoonJS.App.FPSLayout = {
        TOP_LEFT:'top-left',
        TOP_RIGHT:'top-right',
        BOTTOM_LEFT:'bottom-left',
        BOTTOM_RIGHT:'bottom-right'
    };

    /**
    * The predefined possible orientations. there can be a bit level combination of them using the OR operator.
    * @namespace
    * @enum
    */
    CocoonJS.App.Orientations = {
        PORTRAIT : 1,
        PORTRAIT_UPSIDE_DOWN : 2,
        LANDSCAPE_LEFT : 4,
        LANDSCAPE_RIGHT : 8,
        PORTRAIT : 1 | 2,
        LANDSCAPE : 4 | 8,
        BOTH : 1 | 2 | 4 | 8
    };

    /**
     * Contains all the possible values to specify the input keyboard type to be used when introducing text.
     * @namespace
     * @enum
     */
    CocoonJS.App.KeyboardType = {
        /**
         * Represents a generic text input keyboard.
         */
        TEXT:"text",

        /**
         * Represents a number like input keyboard.
         */
        NUMBER:"num",

        /**
         * Represents a phone like input keyboard.
         */
        PHONE:"phone",

        /**
         * Represents an email like input keyboard.
         */
        EMAIL:"email",

        /**
         * Represents an URL like input keyboard.
         */
        URL:"url"
    };

    /**
     * The storage types to be used with file system related operations.
     * @namespace
     * @enum
     */
    CocoonJS.App.StorageType = {
        /**
         * Represents the application storage. The application storage is the place where all the resources that come with the application are stored.
         */
        APP_STORAGE:"APP_STORAGE",

        /**
         * Represents the internal storage. The internal storage is a different storage space that the application storage and only the data that the application has stored
         * in it will be in this storage. It is internal to the platform/device.
         */
        INTERNAL_STORAGE:"INTERNAL_STORAGE",

        /**
         * Represents an external storage. The external storage is similar to the internal storage in the sense that it only contains information that the application has written
         * in it but it represents an external storage device like a SD-CARD. If there is no exrernal storage, it will represent the same as the internal storage.
         */
        EXTERNAL_STORAGE:"EXTERNAL_STORAGE",

        /**
         * Represents the temporal storage. Same as the internal and external storage spaces in the sense that it only contains information that the application has written
         * in it but the main difference is that the information in this storage may dissapear without notice.
         */
        TEMPORARY_STORAGE:"TEMPORARY_STORAGE"
    };

    /**
     * The capture types to capture screenshots using CocoonJS native capabilities.
     * @namespace
     * @enum
     */
    CocoonJS.App.CaptureType = {
        /**
         Captures everything, both the CocoonJS GL hardware accelerated surface and the system views (like the WebView).
         */
        EVERYTHING:0,

        /**
         * Captures just the CocoonJS GL hardware accelerated surface.
         */
        JUST_COCOONJS_GL_SURFACE:1,

        /**
         * Captures just the sustem views (like the webview)
         */
        JUST_SYSTEM_VIEWS:2
    };

    /**
     * @ignore
     * Forward service might not be available if only one JS service is included
     */
    function isNativeBridgeServiceAvailable(){
        if (CocoonJS.App.forward.nativeAvailable === 'boolean') {
            //cached value
            return CocoonJS.App.forward.nativeAvailable;
        }
        else {
            var available = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forwardAvailable", arguments);
            available = !!available;
            CocoonJS.App.forward.nativeAvailable = available;
            return available;
        }

    }

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It waits until the code is executed and the result of it is returned === synchronous.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @return {string} The result of the execution of the passed JavaScript code in the different JavaScript environment.
     */
    CocoonJS.App.forward = function (javaScriptCode) {
        if (CocoonJS.App.nativeExtensionObjectAvailable && isNativeBridgeServiceAvailable()) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forward", arguments);
        }
        else {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                //return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                return window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It is asyncrhonous so it does not wait until the code is executed and the result of it is returned. Instead, it calls a callback function when the execution has finished to pass the result.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @param {function} [returnCallback] A function callback that will be called when the passed JavaScript code is executed in a different thread to pass the result of the execution in the different JavaScript environment.
     */
    CocoonJS.App.forwardAsync = function (javaScriptCode, returnCallback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable && isNativeBridgeServiceAvailable()) {
            if (typeof returnCallback !== 'undefined') {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode, returnCallback);
            }
            else {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode);
            }
        }
        else {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                // window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Pops up a text dialog so the user can introduce some text and the application can get it back. It is the first approach CocoonJS has taken to be able to introduce
     * text input in a easy way. The dialog execution events are passed to the application through the {@link CocoonJS.App.onTextDialogFinished} and the {@link CocoonJS.App.onTextDialogCancelled} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [text] Default value is "". The initial text to be introduced in the text input field.
     * @param {CocoonJS.App.KeyboardType} [keyboardType] Default value is {@link CocoonJS.App.KeyboardType.TEXT}. The keyboard type to be used when the text has to be introduced.
     * @param {string} [cancelButtonText] Default value is "". The text to be displayed in the cancel button of the dialog.
     * @param {string} [okButtonText] Default value is "". The text to be displayed in the ok button of the dialog.
     * @see CocoonJS.App.onTextDialogFinished
     * @see CocoonJS.App.onTextDialogCancelled
     */
    CocoonJS.App.showTextDialog = function (title, message, text, keyboardType, cancelButtonText, okButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTextDialog", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            if (!text) {
                text = "";
            }
            setTimeout(function() {
                var result = prompt(message, text);
                var eventObject = result ? CocoonJS.App.onTextDialogFinished : CocoonJS.App.onTextDialogCancelled;
                eventObject.notifyEventListeners(result);
            }, 0);
        }
    };

    /**
     * Pops up a message dialog so the user can decide between a yes or no like confirmation. The message box execution events are passed to the application through the {@link CocoonJS.App.onMessageBoxConfirmed} and the {@link CocoonJS.App.onMessageBoxDenied} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [confirmButtonText] Default value is "Yes". The text to be displayed for the confirm button.
     * @param {string} [denyButtonText] Default value is "No". The text to be displayed for the deny button.
     * @see CocoonJS.App.onMessageBoxConfirmed
     * @see CocoonJS.App.onMessageBoxDenied
     */
    CocoonJS.App.showMessageBox = function (title, message, confirmButtonText, denyButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showMessageBox", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            setTimeout(function() {
                var result = confirm(message);
                var eventObject = result ? CocoonJS.App.onMessageBoxConfirmed : CocoonJS.App.onMessageBoxDenied;
                eventObject.notifyEventListeners();
            }, 0);
        }
    };

    /**
     * It allows to load a new JavaScript/HTML5 resource that can be loaded either locally (inside the platform/device storage) or using a remote URL.
     * @function
     * @param {string} path A path to a resource stored in the platform or in a URL to a remote resource.
     * @param {CocoonJS.App.StorageType} [storageType] If the path argument represents a locally stored resource, the developer can specify the storage where it is stored. If no value is passes, the {@link CocoonJS.App.StorageType.APP_STORAGE} value is used by default.
     */
    CocoonJS.App.load = function (path, storageType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadPath", arguments);
        }
        else if (!navigator.isCocoonJS) {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function (event) {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        // TODO: As window load event is not being called (WHY???), I have decided to call the listeners directly
                        // var callback= function(event){
                        //     window.removeEventListener("load", callback);
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInCocoonJSSucceed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                        // };
                        // window.addEventListener("load", callback);
                        window.location.href = path;
                    }
                    else if (xhr.status === 404) {
                        this.onreadystatechange = null;
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInCocoonJSFailed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the current context.
     * @function
     */
    CocoonJS.App.reload = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reload", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.location.reload();
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.location.reload();
            }
        }
    };

    /**
     * Opens a given URL using a system service that is able to open it. For example, open a HTTP URL using the system WebBrowser.+
     * @function
     * @param {string} url The URL to be opened by a system service.
     */
    CocoonJS.App.openURL = function (url) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "openURL", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            window.open(url, '_blank');
        }
    }

    /**
     * Forces the app to be finished.
     * @function
     */
    CocoonJS.App.forceToFinish = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forceToFinish", arguments);
        }
        else if (!navigator.isCocoonJS) {
            window.close();
        }
    }

    /**
     * Enables or disables the auto lock to control if the screen keeps on after an inactivity period.
     * When the auto lock is enabled and the application has no user input for a short period, the system puts the device into a "sleepâ€ state where the screen dims or turns off.
     * When the auto lock is disabled the screen keeps on even when there is no user input for long times.
     * @param enabled A boolean value that controls whether to enable or disable the auto lock.
     */
    CocoonJS.App.setAutoLockEnabled = function (enabled) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setAutoLockEnabled", arguments);
        }
    }

    /**
     * Creates a canvas element that is automatically resized to the screen size. When the app is being executed
     * inside CocoonJS. This canvas is optimized for rendering so it is higly recommended to use it if it fits
     * your app needs. If your app uses one canvas as the main canvas where all other canvases and images are displayed, Ludei recommends to
     * call this function in order to create this main canvas. A usual 2x performance gain is achieved by doing so
     * depending on the device and the graphics card driver.
     * @function
     * @return {object} The canvas object that should be used as the main canvas and that is resized to the screen resolution.
     */
    CocoonJS.App.createScreenCanvas = function () {
        var screenCanvas;
        if (navigator.isCocoonJS) {
            screenCanvas = document.createElement("screencanvas");
        }
        else if (!navigator.isCocoonJS) {
            screenCanvas = document.createElement("canvas");
            screenCanvas.width = window.innerWidth;
            screenCanvas.height = window.innerHeight;
        }
        return screenCanvas;
    };

    /**
     * Disables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.disableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Enables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.enableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Disables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.disableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "WebView");
        }
    };

    /**
     * Enables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.enableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "WebView");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the accelerometer updates.
     * It defines the rate at which the devicemotion events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setAccelerometerUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setAccelerometerUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for accelerometer related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for accelerometer related events.
     */
    CocoonJS.App.getAccelerometerUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getAccelerometerUpdateIntervalInSeconds");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the gyroscope updates.
     * It defines the rate at which the devicemotion and deviceorientation events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setGyroscopeUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setGyroscopeUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for gyroscope related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for gyroscope related events.
     */
    CocoonJS.App.getGyroscopeUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("getGyroscopeUpdateIntervalInSeconds");
        }
    };


    /**
     * Setups a origin proxy for a given typeName. What this means is that after calling this function the environment that makes this call will suddenly
     * have a way of creating instances of the given typeName and those instances will act as a transparent proxy to counterpart instances in the destination environment.
     * Manipulating attributes, calling funcitions or handling events will all be performed in the destination environment but the developer will think they will be
     * happening in the origin environment.
     * IMPORTANT NOTE: These proxies only work with types that use attributes and function parameters and return types that are primitive like numbers, strings or arrays.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} [attributeNames] A list of the names of the attributes to be proxified.
     * @param {array} [functionNames] A list of the names of the functions to be proxified.
     * @param {array} [eventHandlerNames] A list of the names of the event handlers to be proxified (onXXXX like attributes that represent callbacks).
     * A valid typeName and at least one valid array for attribute, function or event handler names is mandatory.
     */
    CocoonJS.App.setupOriginProxyType = function (typeName, attributeNames, functionNames, eventHandlerNames) {
        // Control the parameters.
        if (!typeName) throw "The given typeName must be valid.";
        if (!attributeNames && !functionNames && !eventHandlerNames) throw "There is no point on setting up a proxy for no attributes, functions nor eventHandlers.";
        attributeNames = attributeNames ? attributeNames : [];
        functionNames = functionNames ? functionNames : [];
        eventHandlerNames = eventHandlerNames ? eventHandlerNames : [];

        // The parent object will be the window. It could be another object but careful, the destination side should know about this.
        // TODO: Specify the parentObject as a parameter, obtain it's path from the window object and pass it to the destination environment so it knows about it.
        var parentObject = window;

        // Setup the destination side too.
        var jsCode = "CocoonJS.App.setupDestinationProxyType(" + JSON.stringify(typeName) + ", " + JSON.stringify(eventHandlerNames) + ");";
        CocoonJS.App.forward(jsCode);

        var originalType = parentObject[typeName];

        // Constructor. This will be the new proxified type in the origin environment. Instances of this type will be created by the developer without knowing that they are
        // internally calling to their counterparts in the destination environment.
        parentObject[typeName] = function () {
            var _this = this;

            // Each proxy object will have a origin object inside with all the necessary information to be a proxy to the destination.
            this._cocoonjs_proxy_object_data = {};
            // The id is obtained calling to the destination side to create an instance of the type.
            var jsCode = "CocoonJS.App.newDestinationProxyObject(" + JSON.stringify(typeName) + ");";
            this._cocoonjs_proxy_object_data.id = CocoonJS.App.forward(jsCode);
            // The eventHandlers dictionary contains objects of the type { eventHandlerName : string, eventHandler : function } to be able to make the callbacks when the 
            // webview makes the corresponding calls.
            this._cocoonjs_proxy_object_data.eventHandlers = {};
            // Also store the typename inside each instance.
            this._cocoonjs_proxy_object_data.typeName = typeName;
            // A dictionary to store the event handlers
            this._cocoonjs_proxy_object_data.eventListeners = {};

            // TODO: eventHandlers and eventListeners should be in the same list ;)

            // Store all the proxy instances in a list that belongs to the type itself.
            parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[this._cocoonjs_proxy_object_data.id] = this;

            // Create a setter and a getter for all the attribute names that have been specified. When the attributes are accessed (set or get) a call to the destination counterpart will be performed.
            for (var i = 0; i < attributeNames.length; i++) {
                (function (attributeName) {
                    _this.__defineSetter__(attributeName, function (value) {
                        var jsCode = "CocoonJS.App.setDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ", " + JSON.stringify(value) + ");";
                        return CocoonJS.App.forward(jsCode);
                    });
                    _this.__defineGetter__(attributeName, function () {
                        var jsCode = "CocoonJS.App.getDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ");";
                        return CocoonJS.App.forward(jsCode);
                    });
                })(attributeNames[i]);
            }

            // Create a function that performs a call to the destination environment counterpart for all the function names that have been specified.
            for (var i = 0; i < functionNames.length; i++) {
                (function (functionName) {
                    _this[functionName] = function () {
                        // Get the arguments as an array and add the typeName, the proxy id and the functionName before all the other arguments before making the call to the destination counterpart.
                        var argumentsArray = Array.prototype.slice.call(arguments);
                        argumentsArray.unshift(functionName);
                        argumentsArray.unshift(this._cocoonjs_proxy_object_data.id);
                        argumentsArray.unshift(typeName);
                        // Use the array to create the correct function call.
                        var jsCode = "CocoonJS.App.callDestinationProxyObjectFunction(";
                        for (var i = 0; i < argumentsArray.length; i++) {
                            // The second argument (the id) should not be stringified
                            jsCode += (i !== 1 ? JSON.stringify(argumentsArray[i]) : argumentsArray[i]) + (i < argumentsArray.length - 1 ? ", " : "");
                        }
                        jsCode += ");";
                        // TODO: This next call should be synchronous but it seems that some customers are experiencing some crash issues. Making it async solves these crashes.
                        // Another possible solution could be to be able to specify which calls could be async and which sync in the proxification array.
                        var ret = CocoonJS.App.forwardAsync(jsCode);
                        return ret;
                    };
                })(functionNames[i]);
            }

            // Create a setter and getter for all the event handler names that have been specified. When the event handlers are accessed, store them inside the corresponding position on the eventHandlers
            // array so they can be called when the destination environment makes the corresponding callback call.
            for (var i = 0; i < eventHandlerNames.length; i++) {
                (function (eventHandlerName) {
                    _this.__defineSetter__(eventHandlerName, function (value) {
                        _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName] = value;
                    });
                    _this.__defineGetter__(eventHandlerName, function () {
                        return _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                    });
                })(eventHandlerNames[i]);
            }

            // Setup the add and remove event listeners in the proxy object
            _this.addEventListener = function (eventTypeName, eventCallback) {
                var addEventCallback = true;
                // Check for the eventListeners
                var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                if (eventListeners) {
                    // As the eventListeners were already added, check that the same callback has not been added.
                    addEventCallback = eventListeners.indexOf(eventCallback) < 0;
                }
                else {
                    // There are no event listeners, so add the one and add the listeners array for the specific event type name
                    eventListeners = [];
                    _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = eventListeners;

                    // Forward the call so the other end registers a event listener (only one is needed).
                    var jsCode = "CocoonJS.App.addDestinationProxyObjectEventListener(" + JSON.stringify(_this._cocoonjs_proxy_object_data.typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                }
                // Only if the alforithm above specify so, add the eventcallback and notify the destination environment to do the same
                if (addEventCallback) {
                    eventListeners.push(eventCallback);
                }
            };

            _this.removeEventListener = function (eventTypeName, eventCallback) {
                // Check for the eventListeners
                var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                if (eventListeners) {
                    var eventCallbackIndex = eventListeners.indexOf(eventCallback);
                    if (eventCallbackIndex >= 0) {
                        eventListeners.splice(eventCallbackIndex, 1);
                    }
                }
            };

            // Return the proxy instance.
            return this;
        };

        // The type will contain a proxy data structure to store all the instances that are created so they are available when the destination environment calls back. 
        parentObject[typeName]._cocoonjs_proxy_type_data =
        {
            originalType:originalType,
            proxyObjects:[]
        };

        /**
         * Deletes a proxy instance from both the CocoonJS environment structures and also deleting it's webview environment counterpart.
         * This function should be manually called whenever a proxy instance won't be accessed anymore.
         * @param {object} object The proxy object to be deleted.
         */
        parentObject[typeName]._cocoonjs_proxy_type_data.deleteProxyObject = function (object) {
            var proxyObjectKey = CocoonJS.getKeyForValueInDictionary(this.proxyObjects, object);
            if (proxyObjectKey) {
                var jsCode = "CocoonJS.App.deleteDestinationProxyObject(" + JSON.stringify(typeName) + ", " + object._cocoonjs_proxy_object_data.id + ");";
                CocoonJS.App.forwardAsync(jsCode);
                object._cocoonjs_proxy_object_data = null;
                delete this.proxyObjects[proxyObjectKey];
            }
        };

        /**
         * Calls a event handler for the given proxy object id and eventHandlerName.
         * @param {number} id The id to be used to look for the proxy object for which to make the call to it's event handler.
         * @param {string} eventHandlerName The name of the handler to be called.
         * NOTE: Events are a complex thing in the HTML specification. This function just performs a call but at least provides a
         * structure to the event passing the target (the proxy object).
         * TODO: The destination should serialize the event object as far as it can so many parameters can be passed to the origin
         * side. Using JSON.stringify in the destination side and parse in origin side maybe? Still must add the target to the event structure though.
         */
        parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler = function (id, eventHandlerName) {
            var object = this.proxyObjects[id];
            var eventHandler = object._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
            if (eventHandler) {
                eventHandler({ target:object });
            }
        };

        parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners = function (id, eventTypeName) {
            var object = this.proxyObjects[id];
            var eventListeners = object._cocoonjs_proxy_object_data.eventListeners[eventTypeName].slice();
            for (var i = 0; i < eventListeners.length; i++) {
                eventListeners[i]({ target:object });
            }
        };
    };

    /**
     * Takes down the proxification of a type and restores it to it's original type. Do not worry if you pass a type name that is not proxified yet. The
     * function will handle it correctly for compativility reasons.
     * @param {string} typeName The name of the type to be deproxified (take down the proxification and restore the type to it's original state)
     */
    CocoonJS.App.takedownOriginProxyType = function (typeName) {
        var parentObject = window;
        if (parentObject[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
            parentObject[typeName] = parentObject[typeName]._cocoonjs_proxy_type_data.originalType;
        }
    };

    /**
     * Deletes everything related to a proxy object in both environments. Do not worry of you do not pass a proxified object to the
     * function. For compatibility reasons, you can still have calls to this function even when no poxification of a type has been done.
     * @param {object} object The proxified object to be deleted.
     */
    CocoonJS.App.deleteOriginProxyObject = function (object) {
        var parentObject = window;
        if (object && object._cocoonjs_proxy_object_data) {
            parentObject[object._cocoonjs_proxy_object_data.typeName]._cocoonjs_proxy_type_data.deleteProxyObject(object);
        }
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when an event handler need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventHandlerName The name of the event handler to be called.
     */
    CocoonJS.App.callOriginProxyObjectEventHandler = function (typeName, id, eventHandlerName) {
        var parentObject = window;
        parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler(id, eventHandlerName);
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when all the event listeners related to a specific event need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventTypeName The name of the event type to call the listeners related to it.
     */
    CocoonJS.App.callOriginProxyObjectEventListeners = function (typeName, id, eventTypeName) {
        var parentObject = window;
        parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners(id, eventTypeName);
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Setups all the structures that are needed to proxify a destination type to an origin type.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} eventHandlerNames An array with al the event handlers to be proxified. Needed in order to be able to create callbacks for all the event handlers
     * and call to the CocoonJS counterparts accordingly.
     */
    CocoonJS.App.setupDestinationProxyType = function (typeName, eventHandlerNames) {
        var parentObject = window;

        // Add a cocoonjs structure to the destination proxified type to store some useful information like all the proxy instances that are created, plus the id counter 
        // and the names of all the event handlers and some utility functions.
        parentObject[typeName]._cocoonjs_proxy_type_data =
        {
            nextId:0,
            proxyObjects:{},
            eventHandlerNames:eventHandlerNames
        }
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Takes down the proxy type at the destination environment. Just removes the data structure related to proxies that was added to the type when proxification tool place.
     * @param {string} typeName The name of the type to take the proxification down.
     */
    CocoonJS.App.takedownDestinationProxyType = function (typeName) {
        var parentObject = window;
        if (parent[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
            delete parentObject[typeName]._cocoonjs_proxy_type_data;
        }
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Creates a new destination object instance and generates a id to reference it from the original environment.
     * @param {string} typeName The name of the type to be proxified and to generate an instance.
     * @return The id to be used from the original environment to identify the corresponding destination object instance.
     */
    CocoonJS.App.newDestinationProxyObject = function (typeName) {
        var parentObject = window;

        var proxyObject = new parentObject[typeName]();
        // Also store some additional information in the proxy object
        proxyObject._cocoonjs_proxy_object_data = {};
        // Like the type name, that could be useful late ;)
        proxyObject._cocoonjs_proxy_object_data.typeName = typeName;
        // Caculate the id for the object. It will be returned to the origin environment so this object can be referenced later
        var proxyObjectId = parentObject[typeName]._cocoonjs_proxy_type_data.nextId;
        // Store the created object in the structure defined in the setup of proxification with an id associated to it
        parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[proxyObjectId] = proxyObject;
        // Also store the id inside the proxy object itself
        proxyObject._cocoonjs_proxy_object_data.id = proxyObjectId;
        // Calculate a new id for the next object.
        parentObject[typeName]._cocoonjs_proxy_type_data.nextId++;

        // Setup all the event handlers.
        for (var i = 0; i < parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames.length; i++) {
            (function (eventHandlerName) {
                proxyObject[eventHandlerName] = function (event) {
                    var proxyObject = this; // event.target;
                    // var eventHandlerName = CocoonJS.getKeyForValueInDictionary(proxyObject, this); // Avoid closures ;)
                    var jsCode = "CocoonJS.App.callOriginProxyObjectEventHandler(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventHandlerName) + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                };
            })(parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames[i]);
        }

        // Add the dictionary where the event listeners (callbacks) will be added.
        proxyObject._cocoonjs_proxy_object_data.eventListeners = {};

        return proxyObjectId;
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the origin environement whenever it is needed to work with proxy objects.
     * Calls a function of a destination object idetified by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} functionName The name of the function to be called.
     * @return Whatever the function call returns.
     */
    CocoonJS.App.callDestinationProxyObjectFunction = function (typeName, id, functionName) {
        var parentObject = window;
        var argumentsArray = Array.prototype.slice.call(arguments);
        argumentsArray.splice(0, 3);
        var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        var result = proxyObject[functionName].apply(proxyObject, argumentsArray);
        return result;
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Sets a value to the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be set.
     * @param {unknown} attributeValue The value to be set to the attribute.
     */
    CocoonJS.App.setDestinationProxyObjectAttribute = function (typeName, id, attributeName, attributeValue) {
        var parentObject = window;
        var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        proxyObject[attributeName] = attributeValue;
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Retrieves the value of the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be retrieved.
     */
    CocoonJS.App.getDestinationProxyObjectAttribute = function (typeName, id, attributeName) {
        var parentObject = window;
        var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        return proxyObject[attributeName];
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Deletes a proxy object identifying it using it's typeName and id. Deleting a proxy object mainly means to remove the instance from the global structure
     * that hold all the instances.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     */
    CocoonJS.App.deleteDestinationProxyObject = function (typeName, id) {
        var parentObject = window;
        delete parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     */
    CocoonJS.App.addDestinationProxyObjectEventListener = function (typeName, id, eventTypeName) {
        var parentObject = window;
        // Look for the proxy object
        var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];

        var callback = function (event) {
            var proxyObject = this; // event.target;
            // var eventTypeName = CocoonJS.getKeyForValueInDictionary(proxyObject._cocoonjs_proxy_object_data.eventListeners, this); // Avoid closures ;)
            // TODO: Is there a way to retrieve the callbackId without a closure?
            var jsCode = "CocoonJS.App.callOriginProxyObjectEventListeners(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
            CocoonJS.App.forwardAsync(jsCode);
        };

        proxyObject._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = callback;

        // Finally add the event listener callback to the proxy object
        proxyObject.addEventListener(eventTypeName, callback);
    };

    // TODO: We could add a removeDestinationProxyObjectEventListener although it seems that is not completely necessary.

    /**
     * Proxifies the XMLHttpRequest type for the environment where this call is made. After calling this function, all the new objects
     * of XMLHttpRequest that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyXHR = function () {
        var ATTRIBUTE_NAMES =
            [
                "timeout",
                "withCredentials",
                "upload",
                "status",
                "statusText",
                "responseType",
                "response",
                "responseText",
                "responseXML",
                "readyState"
            ];
        var FUNCTION_NAMES =
            [
                "open",
                "setRequestHeader",
                "send",
                "abort",
                "getResponseHeader",
                "getAllResponseHeaders",
                "overrideMimeType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onloadstart",
                "onprogress",
                "onabort",
                "onerror",
                "onload",
                "ontimeout",
                "onloadend",
                "onreadystatechange"
            ];
        CocoonJS.App.setupOriginProxyType("XMLHttpRequest", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Proxifies the Audio type for the environment where this call is made. After calling this function, all the new objects
     * of Audio that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyAudio = function () {
        var ATTRIBUTE_NAMES =
            [
                "src",
                "loop",
                "volume",
                "preload"
            ];
        var FUNCTION_NAMES =
            [
                "play",
                "pause",
                "load",
                "canPlayType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onended",
                "oncanplay",
                "oncanplaythrough",
                "onerror"
            ];
        CocoonJS.App.setupOriginProxyType("Audio", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Captures a image of the screen synchronously and saves it to a file. Sync mode allows to capture the screen in the middle of a frame rendering.
     * @param {string} fileName Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} storageType The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @return The URL of the saved file.
     * @throws exception if the image fails to be stored or there is another error.
     * @see CocoonJS.App.onCaptureScreenSucceeded
     * @see CocoonJS.App.onCaptureScreenFailed
     */
    CocoonJS.App.captureScreen = function (fileName, storageType, captureType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("captureScreen", fileName, storageType, captureType);
        }
    };

    /**
     * Captures a image of the screen asynchronously and saves it to a file.
     * Async mode captures a final frame as soon as possible.
     * @param {string} Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} [storageType] The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface, 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @param {function} callback. Response callback, check the error property to monitor errors. Check the 'url' property to get the URL of the saved Image
     */
    CocoonJS.App.captureScreenAsync = function (fileName, storageType, captureType, callback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCallAsync("captureScreen", fileName, storageType, captureType, callback);
        }
    };

    /**
     * Returns the device UUID
     * @return {string} The device UUID
     */
    CocoonJS.App.getDeviceId = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceId");
        }
    };

    /**
     * Structure that defines the getDeviceInfo returned information
     */
    CocoonJS.App.DeviceInfo = {

        /**
        * The operating system name (ios, android,...)
        * @type string
        */
        os: null,

        /**
        * The operating system version (4.2.2, 5.0,...)
        * @type string
        */
        version: null,

        /**
        * The operating system screen density in dpi
        * @type string
        */
        dpi: null,

        /**
        * The device manufacturer (apple, samsung, lg,...)
        * @type string
        */
        brand: null,

        /**
        * The device model (iPhone 4S, SAMSUNG-SGH-I997, SAMSUNG-SGH-I997R, etc)
        * @type string
        */
        model: null,

        /**
        * The phone IMEI
        * Android: The phone IMEI is returned or null if the device has not telepohny
        * iOS: null is returned as we cannot get the IMEI in iOS, no public API available for that yet.
        * @type string
        */
        imei: null,

        /**
        * The platform Id
        * Android: The ANDROID_ID is used.
        * iOS: The OpenUDID is used as there is no Android ANDROID_ID equivalent in iOS
        * @type string
        */
        platformId: null,

        /**
        * The Odin generated id https://code.google.com/p/odinmobile/
        * @type string
        */
        odin: null,

        /**
        * The OpenUDID generated Id https://github.com/ylechelle/OpenUDID
        * @type string
        */
        openudid: null
    };

    /**
     * Returns the device Info
     * @return {CocoonJS.App.DeviceInfo} The device Info
     */
    CocoonJS.App.getDeviceInfo = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceInfo");
        }
    };

    /**
     *
     * @constructor
     */
    CocoonJS.App.WebDialog = function() {

        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            this.webDialogID = window.ext.IDTK_APP.makeCall("createWebDialog");
        }
        else {
            var iframe = document.createElement("iframe");
            iframe.id = "CocoonJSWebDialogIFrame";
            iframe.name = "CocoonJSWebDialogIFrame";
            iframe.style.cssText = "position:fixed;left:0;top:0;bottom:0;right:0; width:100%; height:100%;margin:0;padding:0;";
            var me = this;
            iframe.onload = function(){
                me.iframeloaded = true;
                var js = "CocoonJS = {}; CocoonJS.WebDialog = {}; CocoonJS.WebDialog.close = function()" +
                    "{" +
                    "   window.parent.CocoonJSCloseWebDialog();" +
                    "};";
                me.evalIframe(js);
                for (var i = 0; i < me.pendingEvals.length; ++i) {
                    me.evalIframe(me.pendingEvals[i]);
                }
                me.pendingEvals = [];
            }
            iframe.onerror = function(){
                me.close();
            }
            this.iframe = iframe;
            this.pendingEvals = [];

            window.CocoonJSCloseWebDialog = function() {
               me.close();
            }
        }

    }

    CocoonJS.App.WebDialog.prototype = {

        show: function(url, callback) {
            this.closeCallback = function() {
                CocoonJS.App.enableTouchInCocoonJS();
                if (callback)
                    callback();
            }
            if (CocoonJS.App.nativeExtensionObjectAvailable) {
                CocoonJS.App.disableTouchInCocoonJS();
                return window.ext.IDTK_APP.makeCallAsync("showWebDialog", this.webDialogID, url, this.closeCallback);
            }
            else {
                this.iframe.src = url;
                document.body.appendChild(this.iframe);
            }

        },
        close: function() {
            if (CocoonJS.App.nativeExtensionObjectAvailable) {
                return window.ext.IDTK_APP.makeCallAsync("closeWebDialog", this.webDialogID);
            }
            else {
                if (this.iframe.parentNode) {
                    this.iframe.parentNode.removeChild(this.iframe);
                }
            }
            if (this.closeCallback)
                this.closeCallback();
        },
        evalIframe: function(js) {
            window.frames["CocoonJSWebDialogIFrame"].eval(js);
        },
        eval: function(js) {
            if (CocoonJS.App.nativeExtensionObjectAvailable) {
                return window.ext.IDTK_APP.makeCallAsync("evalWebDialog", this.webDialogID, js);
            }
            else {
                if (this.iframeloaded)
                    this.evalIframe(js);
                else
                    this.pendingEvals.push(js);
            }
        }

    };


    /**
    * Retrieves the preferred orientation that has been set in the system.
    * @return {number} The preferred orientation in the system as a combination of the possible {@link CocoonJS.App.Orientations}
    */
    CocoonJS.App.getPreferredOrientation = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getPreferredOrientation");
        }
        else {
            return 0;
        }
    };

    /**
    * Sets the preferred orientation in the system.
    * @param {number} preferredOrientation The preferred orientation to be set. A combinatio of the possible {@link CocoonJS.App.Orientations}
    */
    CocoonJS.App.setPreferredOrientation = function(preferredOrientation) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("setPreferredOrientation", preferredOrientation);
        }
    }

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function's documentation is represented by {@link CocoonJS.App.OnTextDialogFinishedListener}
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogFinished = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogfinish");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogCancelled = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogcancel");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxConfirmed = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxconfirmed");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxDenied = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxdenied");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is suspended.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onSuspended = new CocoonJS.EventHandler("IDTK_APP", "App", "onsuspended");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is activated.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onActivated = new CocoonJS.EventHandler("IDTK_APP", "App", "onactivated");

})();
;(function()
{
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewSucceed} event calls.
     * @name OnLoadInTheWebViewSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInTheWebViewSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewFailed} event calls.
     * @name OnLoadInTheWebViewFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInTheWebViewFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");

    function checkEmulatedWebViewReady() {
        var emulatedWB = CocoonJS.App.EmulatedWebView;
        if (emulatedWB) {
            return; //ready
        }

        emulatedWB = document.createElement('div'); 
        emulatedWB.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewDiv'); 
        emulatedWB.style.width = 0; 
        emulatedWB.style.height = 0; 
        emulatedWB.style.position = "absolute"; 
        emulatedWB.style.left = 0; 
        emulatedWB.style.top = 0;
        emulatedWB.style.backgroundColor = 'transparent';
        emulatedWB.style.border = "0px solid #000"; 

        var frame = document.createElement("IFRAME");
        frame.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
        frame.setAttribute('name', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
        frame.style.width = 0; 
        frame.style.height = 0; 
        frame.frameBorder = 0;
        frame.allowtransparency = true;

        emulatedWB.appendChild(frame);
        CocoonJS.App.EmulatedWebView = emulatedWB;
        CocoonJS.App.EmulatedWebViewIFrame = frame;

        if(!document.body) {
            document.body = document.createElement("body");
        }
        document.body.appendChild(CocoonJS.App.EmulatedWebView);
    }

    /**
    * Pauses the CocoonJS JavaScript execution loop.
    * @function
    * @augments CocoonJS.App
    */
    CocoonJS.App.pause = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "pause", arguments);
        }
    };

    /**
    * Resumes the CocoonJS JavaScript execution loop.
    * @static
    * @function
    */
    CocoonJS.App.resume = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "resume", arguments);
        }
    };

    /**
    * Loads a resource in the WebView environment from the CocoonJS environment.
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    * @see CocoonJS.App.onLoadInTheWebViewSucceed
    * @see CocoonJS.App.onLoadInTheWebViewFailed
    */
    CocoonJS.App.loadInTheWebView = function(path, storageType)
    {
        if (navigator.isCocoonJS && CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadInTheWebView", arguments)
        }
        else
        {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function(event) {
                if (xhr.readyState === 4)
                {
                    if (xhr.status === 200)
                    {

                        checkEmulatedWebViewReady();
                        var callback= function(event){
                            CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners(path);
                            CocoonJS.App.EmulatedWebViewIFrame.removeEventListener("load", callback);
                        };

                        CocoonJS.App.EmulatedWebViewIFrame.addEventListener(
                            "load", 
                            callback
                        );
                        CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.href= path;
                    }
                    else if (xhr.status === 404)
                    {
                        this.onreadystatechange = null;
                        CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners(path);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the WebView context.
     * @function
     */
    CocoonJS.App.reloadWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable && navigator.isCocoonJS)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reloadWebView", arguments);
        }
        else
        {
            checkEmulatedWebViewReady();
            CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.reload();
        }
    };

    /**
    * Shows the webview.
    * @function
    * @param {int} x The top lef x coordinate of the rectangle where the webview will be shown.
    * @param {int} y The top lef y coordinate of the rectangle where the webview will be shown.
    * @param {width} y The width of the rectangle where the webview will be shown.
    * @param {height} y The height of the rectangle where the webview will be shown.
    */
    CocoonJS.App.showTheWebView = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable && navigator.isCocoonJS)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTheWebView", arguments)
        }
        else
        {
            checkEmulatedWebViewReady();
            CocoonJS.App.EmulatedWebViewIFrame.style.width = (width ? width/window.devicePixelRatio : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebViewIFrame.style.height = (height ? height/window.devicePixelRatio : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.left = (x ? x : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.top = (y ? y : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.width = (width ? width/window.devicePixelRatio : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebView.style.height = (height ? height/window.devicePixelRatio : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.display = "block";

            console.log(CocoonJS.App.EmulatedWebViewIFrame.style.cssText);
        }
    };

    /**
    * Hides the webview.
    * @function
    */
    CocoonJS.App.hideTheWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('hide');";
            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            checkEmulatedWebViewReady();
            CocoonJS.App.EmulatedWebView.style.display = "none";
        }
    };

    /**
    * Marks a audio file to be used as music by the system. CocoonJS, internally, differentiates among music files and sound files.
    * Music files are usually bigger in size and longer in duration that sound files. There can only be just one music file 
    * playing at a specific given time. The developer can mark as many files as he/she wants to be treated as music. When the corresponding
    * HTML5 audio object is used, the system will automatically know how to treat the audio resource as music or as sound.
    * Note that it is not mandatory to use this function. The system automatically tries to identify if a file is suitable to be treated as music
    * or as sound by checking file size and duration thresholds. It is recommended, though, that the developer specifies him/herself what he/she considers
    * to be music.
    * @function
    * @param {string} audioFilePath The same audio file path that will be used to create HTML5 audio objects.
    */
    CocoonJS.App.markAsMusic = function(audioFilePath)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "addForceMusic", arguments);
        }
    };

    /**
    * Activates or deactivates the antialas functionality from the CocoonJS rendering.
    * @function
    * @param {boolean} enable A flag that indicates if the antialas should be activated (true) or deactivated (false).
    */
    CocoonJS.App.setAntialias = function(enable)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultAntialias", arguments);
        }
    };

    /**
    * Sets a callback function that will be called whenever the system tries to finish the app.
    * The developer can specify how the system will react to the finish of the app by returning a
    * boolean value in the callback function: true means, close the app, false means that the developer
    * will handle the app close.
    * A common example of this is the back button in Android devices. When the back button is pressed, this
    * callback will be called and the system will react depending on the developers choice finishing, or not,
    * the application.
    * @function
    * @param {function} appShouldFinishCallback A function object that will be called when the system
    * determines that the app should be finished. This function must return a true or a false value
    * depending on what the developer wants: true === finish the app, false === do not close the app.
    */
    CocoonJS.App.setAppShouldFinishCallback = function(appShouldFinishCallback)
    {
        if (navigator.isCocoonJS)
        {
            window.onidtkappfinish = appShouldFinishCallback;
        }
    }

    /**
    * Sets the texture reduction options. The texture reduction is a process that allows big images to be reduced/scaled down when they are loaded.
    * Although the quality of the images may decrease, it can be very useful in low end devices or those with limited amount of memory.
    * The function sets the threshold on image size (width or height) that will be used in order to know if an image should be reduced or not.
    * It also allows to specify a list of strings to identify in which images file paths should be applied (when they meet the size threshold requirement) 
    * The developer will still think that the image is of the original size. CocoonJS handles all of the internals to be able to show the image correctly.
    * IMPORTANT NOTE: This function should be called when the application is initialized before any image is set to be loaded for obvious reasons ;).
    * and in which sould be forbid (even if they meet the threshold requirement).
    * @function
    * @param {number} sizeThreshold This parameter specifies the minimun size (either width or height) that an image should have in order to be reduced.
    * @param {string or array} [applyTo] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it will be reduced. This parameter can also be null.
    * @param {string or array} [forbidFor] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it won't be reduced. This parameter should be used in order to mantain the 
    * quality of some images even they meet the size threshold requirement.
    */
    CocoonJS.App.setTextureReduction = function(sizeThreshold, applyTo, forbidFor)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultTextureReducerThreshold", arguments);
        }
    };


    /**
    * Prints to the console the memory usage of the currently alive textures
    * @function
    */
    CocoonJS.App.logMemoryInfo = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "logMemoryInfo", arguments);
        }
    };

    /**
    * Enable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.enableFPSInTheWebView = function(fpsLayout, textColor)
    {
        if (!CocoonJS.App.fpsInTheWebViewEnabled)
        {
            fpsLayout = fpsLayout ? fpsLayout : CocoonJS.App.FPSLayout.TOP_RIGHT;
            textColor = textColor ? textColor : "white";
            var jsCode = "" +
                "(function()" +
                "{" +
                    "var COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES = ['js/CocoonJSExtensions/CocoonJS.js', 'js/CocoonJSExtensions/CocoonJS_App.js', 'js/CocoonJSExtensions/CocoonJS_App_ForWebView.js'];" +
                    "var loadedScriptCounter = 0;" + 
                    "var loadedScriptFunction = function() " +
                    "{ " +
                        "loadedScriptCounter++;"+
                        "if (loadedScriptCounter >= COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length)"+
                        "{"+
                            "CocoonJS.App.enableFPS(" + JSON.stringify(fpsLayout) + ", " + JSON.stringify(textColor) + ");"+
                        "}"+
                    "};"+
                    "for (var i = 0; i < COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length; i++)"+
                    "{"+
                        "var s = document.createElement('script');"+
                        "s.onload = loadedScriptFunction;"+
                        "s.src = COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES[i];"+
                        "document.body.appendChild(s);"+
                    "}" +
                "})();";
            setTimeout(function()
            {
                CocoonJS.App.forward(jsCode);
            }, 3000);
            CocoonJS.App.fpsInTheWebViewEnabled = true;
        }
    };

    /**
    * Disable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.disableFPSInTheWebView = function()
    {
        // TODO: Implement this function.
    };

    
})();
;(function(){
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");
    if (navigator.isCocoonJS) return;

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.App.nativeExtensionObjectAvailable;

    /**
    * Shows a transparent WebView on top of the CocoonJS hardware accelerated environment rendering context.
    * @function
    * @param {number} [x] The horizontal position where to show the WebView.
    * @param {number} [y] The vertical position where to show the WebView.
    * @param {number} [width] The horitonzal size of the WebView.
    * @param {number} [height] the vertical size of the WebView.
    */
    CocoonJS.App.show = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "show", arguments);
        }
        else
        {
            var div = window.parent.document.getElementById('CocoonJS_App_ForCocoonJS_WebViewDiv');
            div.style.left = (x ? x : div.style.left)+'px';
            div.style.top = (y ? y : div.style.top)+'px';
            div.style.width = (width ? width/window.devicePixelRatio : window.parent.innerWidth)+'px';
            div.style.height = (height ? height/window.devicePixelRatio : window.parent.innerHeight)+'px';
            div.style.display = "block";
            var iframe = window.parent.document.getElementById('CocoonJS_App_ForCocoonJS_WebViewIFrame');
            iframe.style.width = (width ? width/window.devicePixelRatio : window.parent.innerWidth)+'px';
            iframe.style.height = (height ? height/window.devicePixelRatio : window.parent.innerHeight)+'px';
        }
    };

    /**
    * Hides the transparent WebView on top of the CocoonJS hardware acceleration environment rendering contect.
    * @function
    */
    CocoonJS.App.hide = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "hide", arguments);
        }
        else
        {
            window.parent.document.getElementById('CocoonJS_App_ForCocoonJS_WebViewDiv').style.display = "none";
        }
    };

    /**
    * Loads a resource in the CocoonJS environment from the CocoonJS environment. 
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    */
    CocoonJS.App.loadInCocoonJS = function(path, storageType)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('loadPath'";
            if (typeof path !== 'undefined')
            {
                javaScriptCodeToForward += ", '" + path + "'";
                if (typeof storageType !== 'undefined')
                {
                    javaScriptCodeToForward += ", '" + storageType + "'";
                }
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else
        {
            CocoonJS.App.forwardAsync("CocoonJS.App.load('" + path + "');");
        }
    };

    /**
     * Reloads the last loaded path in the CocoonJS context.
     * @function
     */
    CocoonJS.App.reloadCocoonJS = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.App.forwardAsync("ext.IDTK_APP.makeCall('reload');");
        }
        else if (!navigator.isCocoonJS)
        {
            window.parent.location.reload();
        }
    };

    /**
    * This function allows to forward console messages from the WebView to the CocoonJS
    * debug console. What it does is to change the console object for a new one
    * with all it's methods (log, error, info, debug and warn) forwarding their
    * messages to the CocoonJS environment.
    * The original console object is stored in the CocoonJS.App.originalConsole property.
    * @function
    */
    CocoonJS.App.proxifyConsole = function() 
    {
        if (!CocoonJS.nativeExtensionObjectAvailable) return;

        if (typeof CocoonJS.App.originalConsole === 'undefined')
        {
            CocoonJS.App.originalConsole = window.console;
        }
        var functions = ["log", "error", "info", "debug", "warn"];

        var newConsole = {};
        for (var i = 0; i < functions.length; i++)
        {
            newConsole[functions[i]] = function(functionName)
            {
                return function(message)
                {
                    var jsCode = "console." + functionName + "(" + JSON.stringify(message) + ");";
                    CocoonJS.App.originalConsole.log(jsCode);
                    ext.IDTK_APP.makeCallAsync("forward", jsCode);
                };
            }(functions[i]);
        }
        if (!newConsole.assert) {
            newConsole.assert = function assert() {
                if (arguments.length > 0 && !arguments[0]) {
                    var str = 'Assertion failed: ' + (arguments.length > 1 ? arguments[1] : '');
                    newConsole.error(str);
                }
            }
        }        
        window.console = newConsole;
    };

    /**
    * This function restores the original console object and removes the proxified console object.
    * @function
    */
    CocoonJS.App.deproxifyConsole = function()
    {
        if (window.navigator.isCocoonJS || !CocoonJS.nativeExtensionObjectAvailable) return;
        if (typeof CocoonJS.App.originalConsole !== 'undefined')
        {
            window.console = CocoonJS.App.originalConsole;
            CocoonJS.App.originalConsole = undefined;
        }
    };

    /**
    * Everytime the page is loaded, proxify the console.
    * @ignore
    */
    window.addEventListener("load", function()
    {
        CocoonJS.App.proxifyConsole();
    });

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInCocoonJSSucceed} event calls.
     * @name OnLoadInCocoonJSSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in CocoonJS.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the CocoonJS load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInCocoonJSSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInCocoonJSSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInCocoonJSFailed} event calls.
     * @name OnLoadInCocoonJSFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in CocoonJS.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the CocoonJS load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInCocoonJSFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInCocoonJSFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");

})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Advertisement extension API.
    * @namespace
    */
    CocoonJS.Ad = {};

    CocoonJS.Ad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_AD !== 'undefined';

    /**
    * The predefined possible layouts for a banner ad.
    * @namespace 
    */
	CocoonJS.Ad.BannerLayout = 
	{
		/**
		* Specifies that the banner must be shown in the top of the screen and vertically centered.
		*/
	    TOP_CENTER      : "TOP_CENTER",

		/**
		* Specifies that the banner must be shown in the bottom of the screen and vertically centered.
		*/
	    BOTTOM_CENTER   : "BOTTOM_CENTER"
	};

	/**
    * A rectangle object that contains the banner dimensions
    * @namespace 
    * @constructor
    * @param {int} x The top lef x coordinate of the rectangle.
    * @param {int} y The top lef y coordinate of the rectangle.
    * @param {width} y The rectangle width.
    * @param {height} y The rectangle height.
    */
	CocoonJS.Ad.Rectangle = function(x, y, width, height) 
	{
		/**
		* The top lef x coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.x = x;

		/**
		* The top lef y coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.y = y;

	    /**
		* The rectangle width
		* @field 
		* @type {int}
		*/
	    this.width = width;

	    /**
		* The rectangle height
		* @field 
		* @type {int}
		*/
	    this.height = height;
	};

	CocoonJS.Ad.Banner = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
    	* The callback function does not receive any parameter.
    	* @param {number} width The banner width
    	* @param {number} height The banner height
    	* @static
    	* @event
    	*/
		this.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener(args[1], args[2]);
    		}
    	});
	};

	CocoonJS.Ad.Banner.prototype = {

		/**
		* Shows a banner ad if available.
		* @function
		*/
		showBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", [this.id], true);
			}
		},

		/**
		* Hides the banner ad if it was being shown.
		* @function
		*/
		hideBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", [this.id], true);
			}
		},

		/**
		* Refreshes the banner.
		* @function
		*/
		refreshBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", [this.id], true);
			}
		},

		/**
		* Gets the rectangle representing the banner screen position.
		* @function
		* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
		*/
		getRectangle : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", [this.id]);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* @function
		* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
		*/
		setRectangle : function(rect)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", [this.id, rect],true);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* You can use this method if you want to have better control of the banner screen positioning.
		* @function
		* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
		*/
		setBannerLayout : function(bannerLayout)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", [this.id, bannerLayout],true);
			}
		}
	};

	CocoonJS.Ad.Fullscreen = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
		this.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

    	/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});
	};

	CocoonJS.Ad.Fullscreen.prototype = {

		/**
		* Shows a full screen ad if available.
		* @function
		* @see CocoonJS.Ad.onFullScreenShown
		* @see CocoonJS.Ad.onFullScreenHidden
		*/
		showFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", [this.id], true);
			}
		},

		/**
		* Refreshes the fullscreen.
		* @function
		*/
		refreshFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", [this.id], true);
			}
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Ad.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "requestInitialization", arguments, true);
		}
	};

	/**
	* Creates a new banner ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createBanner = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createBanner", [parameters]);
			var banner = new CocoonJS.Ad.Banner(adId);

			return banner;
		}
	};

	/**
	* Releases a banner.
	* @function
	* @param {object} The banner ad object to be released.
	*/
	CocoonJS.Ad.releaseBanner = function(banner)
	{
		if (typeof banner === "undefined") {
            throw "The banner ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseBanner", [banner.id]);
		}
	};

	/**
	* Creates a new fullscreen ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createFullscreen = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createFullscreen", [parameters]);
			var fullscreen = new CocoonJS.Ad.Fullscreen(adId);

			return fullscreen;
		}
	};

	/**
	* Releases a fullscreen ad.
	* @function
	* @param {object} The fullscreen ad object to be released.
	*/
	CocoonJS.Ad.releaseFullscreen = function(fullscreen)
	{
		if (typeof fullscreen === "undefined") {
            throw "The fullscreen ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseFullscreen", [fullscreen.id]);
		}
	};

	/**
	* Shows a banner ad if available.
	* @function
	* @see CocoonJS.Ad.setBannerLayout
	* @see CocoonJS.Ad.onBannerShown
	*/
	CocoonJS.Ad.showBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", arguments, true);
		}
	};

	/**
	* Hides the banner ad if it was being shown.
	* @function
	*/
	CocoonJS.Ad.hideBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", arguments, true);
		}
	};

	/**
	* Refreshes the banner.
	* @function
	*/
	CocoonJS.Ad.refreshBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", arguments, true);
		}
	};

	/**
	* Shows a full screen ad if available.
	* @function
	* @see CocoonJS.Ad.onFullScreenShown
	* @see CocoonJS.Ad.onFullScreenHidden
	*/
	CocoonJS.Ad.showFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", arguments, true);
		}
	};

	/**
	* Refreshes the fullscreen.
	* @function
	*/
	CocoonJS.Ad.refreshFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", arguments, true);
		}
	};

	/**
	* Makes a request to preload a banner ad.
	* @function
	*/
	CocoonJS.Ad.preloadBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadBanner", arguments, true);
		}
	};

	/**
	* Makes a request to preload a full screen ad.
	* @function
	*/
	CocoonJS.Ad.preloadFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadFullScreen", arguments, true);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* @function
	* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.setRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", arguments, true);
		}
	};

	/**
	* Gets the rectangle representing the banner screen position.
	* @function
	* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.getRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", arguments);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* You can use this method if you want to have better control of the banner screen positioning.
	* @function
	* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
	*/
	CocoonJS.Ad.setBannerLayout = function(bannerLayout)
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", arguments, true);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide"); 

	/**
	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
	* The callback function does not receive any parameter.
	* @param {number} width The banner width
	* @param {number} height The banner height
	* @static
	* @event
	*/
	CocoonJS.Ad.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready"); 

})();;(function() {

    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * @namespace
     */
    CocoonJS.Social = {};

    /**
     * This class provides an abstraction API for all the Social Services
     * Each Social service has it's own official API but can also be used within this API interface
     * @class
     */
    CocoonJS.Social.SocialService = function() {
        /**
         * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login status changes
         * The callback parameters: loggedIn status (boolean) and error
         * @memberOf CocoonJS.Social.SocialService
         */
        this.onLoginStatusChanged = new CocoonJS.EventHandler("", "dummy", "onLoginStatusChanged");

        return this;
    }

    CocoonJS.Social.SocialService.prototype = {

        /**
         * Check if the user is logged in.
         * @return {boolean} true if the user is still logged in, false otherwise.
         */
        isLoggedIn: function() {
             return false;
        },

        /**
         * Authenticate the user
         * @param {function} callback. The callback function. Response params: loggedIn(boolean) and error
         */
        login : function(callback) {
            if (callback)
                callback(false, {message:"Not implemented!"});
        },

        /**
         * Log the user out of your application.
         * @param {function} [callback] The callback function. Response params: error
         */
        logout: function(callback) {
            if (callback)
                callback({message:"Not implemented!"});
        },

        /**
         * Returns the information of the currently logged in user.
         * @return {@link CocoonJS.Social.User}
         */
        getLoggedInUser : function() {
            return null;
        },

        /**
         * Checks if the current logged in user has publish permissions
         * @param callback The callback function. Response params: permissions granted and error
         */
        hasPublishPermissions: function(callback) {
            callback(true);
        },

        /**
         * Requests publish permissions for the current logged in user
         * @param callback The callback function. Response params: granted and error
         */
        requestPublishPermissions: function(callback) {
            if (callback)
                callback(true, null);
        },
        /**
         * Retrieves user information for a specific user ID.
         * @param {function} callback The callback function. Response params: {@link CocoonJS.Social.User} and error.
         * @param {string} [userID] The id of the user to retrieve the information from. If no userID is specified, the currently logged in user is assumed.
         */
        requestUser: function(callback, userID) {
            callback(null, {message:"Not implemented!"});
        },
        /**
         * Request to retrieve the profile image of a user
         * @param {function} callback The callback function. Response params: ImageURL and error.
         * @param {string} [userID] The id of the user to get the image for. If no userID is specified, the currently logged user is used.
         * @param {CocoonJS.Social.ImageSize} [imageSize] The desired size of the image. Default value: SMALL.
         */
        requestUserImage : function(callback, userID, imageSize) {
            callback("", {message:"Not implemented!"})
        },

        /**
         * Retrieves user friends for a specific user ID.
         * @param {function} callback The callback function. Response params: Array of {@link CocoonJS.Social.User} and error.
         * @param {string} [userID] The id of the user to retrieve the information from. If no userID is specified, the currently logged in user is assumed.
         */
        requestFriends: function(callback, userID) {
            callback([], {message:"Not implemented!"});
        },

        /**
         * Shares a message without the intervention of the user
         * This action might require publish permissions. If the user has not publish permissions they are automatically requested.
         * @param {CocoonJS.Social.Message} message A object representing the information to be published.
         * @param {function} [callback] The callback function. Response params: error
         */
        publishMessage: function(message, callback) {
            callback({message:"Not implemented!"});
        },

        /**
         * Presents a native/web dialog that allows the user to share a message
         * @param {CocoonJS.Social.Message} message A object representing the information to be published.
         * @param {function} [callback] The callback function. Response params: error
         */
        publishMessageWithDialog: function(message, callback) {
            callback({message:"Not implemented!"});
        }
    }


    /**
     * This class extends the Social Service API with an extended Social Gaming abstraction API (achievements, leaderboards, etc.)
     * @class
     */
    CocoonJS.Social.SocialGamingService = function() {
        CocoonJS.Social.SocialGamingService.superclass.constructor.call(this);
        return this;
    }

    CocoonJS.Social.SocialGamingService.prototype = {

        _cachedAchievements: null,
        _achievementsMap: null,
        _leaderboardsTemplate: null,
        _achievementsTemplate: null,

        /**
         * Retrieves the score for a user from a specific leaderboard
         * @param {function} callback The callback function. Response params: {@link CocoonJS.Social.Score} and error.
         * @param {CocoonJS.Social.ScoreParams} [params] The params to retrieve the score. If no params are specified, the currently logged in user and the default leaderboard are assumed.
         */
        requestScore: function(callback, params) {
            callback(null, {message:"Not implemented!"})
        },

        /**
         * Submits the score for a user to a specific leaderboard
         * @param {number} score the score to submit
         * @param {function} [callback] The callback function. Response params: error.
         * @param {CocoonJS.Social.ScoreParams} [params] The params to submit the score. If no params are specified, the currently logged in user and the default leaderboard are assumed.
         */
        submitScore: function(score, callback, params ) {
            if (callback)
                callback({message:"Not implemented!"})
        },

        /**
         * Shows a modal leaderboard view using a platform dependant view.
         * @param {CocoonJS.Social.ScoreParams} [params] The params to choose the leaderboard and other settings. If no params are specified the default leaderboard id and settings will be assumed.
         * @param {function} [callback] The callback function invoked when the modal leaderboard view is closed by the user. Response params: error.
         * @see setTemplates
         */
        showLeaderboard : function(callback, params) {
            if (callback)
                callback({message:"Not implemented!"})
        },

        /**
         * Retrieves all the achievements of the application.
         * @param {function} callback The callback function. Response params: array of {@link CocoonJS.Social.Achievement} and error.
         */
        requestAllAchievements : function(callback) {
            callback([], {message:"Not implemented!"})
        },

        /**
         * Retrieves the achievements earned by a user.
         * @param {function} callback The callback function. Response params: array of {@link CocoonJS.Social.Achievement} and error.
         * @param {string} [userId] The id of the user to retrieve the information from. If no userID is specified, the currently logged in user is assumed.
         */
        requestAchievements : function(callback, userID) {
            callback([], {message:"Not implemented!"})
        },
        /**
         * Submits the achievement for the current logged In user
         * @param achievementID The achievement ID to submit
         * @param callback [callback] The callback function. Response params: error.
         */
        submitAchievement: function(achievementID, callback) {
            if (callback)
                callback({message:"Not implemented!"})
        },
        /**
         * Resets all the achievements of the current logged in user
         * @param {function} [callback] The callback function. Response params: error.
         */
        resetAchievements : function(callback) {
            if (callback)
                callback([], {message:"Not implemented!"})
        },
        /**
         * Shows a modal achievements view using a platform dependant view.
         * @param {function} [callback] The callback function invoked when the modal achievements view is closed by the user. Response params: error.
         * @see setTemplates
         */
        showAchievements : function(callback) {
            if (!this._achievementsTemplate)
                throw "Please, provide a html template for achievements with the setTemplates method";
            var dialog = new CocoonJS.App.WebDialog();
            var callbackSent = false;
            dialog.show(this._achievementsTemplate, function(error) {
                dialog.closed = true;
                if (!callbackSent && callback)
                    callback(error);
            });
            var me = this;
            this.requestAchievements(function(achievements, error){
                if (dialog.closed)
                    return;
                if (error) {
                    callbackSent = true;
                    if (callback)
                        callback(error);
                    return;
                }

                var achs = [];
                if (me._cachedAchievements) {
                    for (var i = 0; i < me._cachedAchievements.length; ++i) {
                        var ach = me._cachedAchievements[i];
                        achs.push(ach);
                        if (achievements && achievements.length) {
                            for (var j = 0; j< achievements.length; ++j) {
                                if (achievements[j].achievementID === ach.achievementID) {
                                    ach.achieved = true;
                                    break;
                                }
                            }
                        }
                    }
                }
                var js = "addAchievements(" + JSON.stringify(achs) + ");";
                dialog.eval(js);
            });
        },

        /**
         * Set the map for using custom achievement IDs.
         * The map must be a customID to realID map (accessing map.customID must return the real achievement ID)
         * Whenever this map is enabled users are able to submit achievements with the real achievement ID or with the custom one.
         * @params {object} map The achievements map. A null map disables this feature.
         */
        setAchievementsMap: function(map) {
            this._achievementsMap = map;
            if (this._cachedAchievements) {
               this.syncAchievementsMap(this._cachedAchievements);
            }
        },

        /**
         * Provides some templates to be used in the leaderboards and achievements views
         * Some social services (like Facebook) don't have a native view to show achievements or leaderboards views, and use html templates instead
         * @param {string} leaderboardsTemplate relative path to the leaderboards template
         * @param {string} achievementsTemplate relative path to the achievements template
         * @see showAchievements
         * @see showLeaderboard
         */
        setTemplates: function(leaderboardsTemplate, achievementsTemplate) {
            this._leaderboardsTemplate = leaderboardsTemplate;
            this._achievementsTemplate = achievementsTemplate;
        },

        //Internal utility methods

        /**
         * @ignore
         */
        setCachedAchievements: function(achievements) {
            this._cachedAchievements = achievements;
            if (achievements && this._achievementsMap) {
                this.syncAchievementsMap(this._cachedAchievements);
            }
        },

        /**
         * @ignore
         */
        findAchievement: function(id) {
            if (!this._cachedAchievements)
                return null;
            for (var i = 0; i < this._cachedAchievements.length; ++i) {
                if (id === this._cachedAchievements[i].achievementID) {
                    return this._cachedAchievements[i];
                }
            }
            return null;
        },

        /**
         * @ignore
         */
        translateAchievementID: function(id) {
            if (this._achievementsMap) {
                for (var customID in this._achievementsMap) {
                    if (customID == id) { //important: compare with double equal, because id can be numeric
                        return this._achievementsMap[customID];
                    }
                }
            }
            return id;
        },
        /**
         * @ignore
         * @param {array} achievements array of achievements
         */
        syncAchievementsMap: function(achievements) {
            if (!this._achievementsMap)
                return;
            for (var i = 0; i< achievements.length; ++i) {
                for (var customID in this._achievementsMap) {
                     if (this._achievementsMap[customID] === achievements[i].achievementID) {
                         achievements[i].customID = customID;
                     }
                }
            }

        }
    }

    /**
     * @ignore
     */
    CocoonJS.extend(CocoonJS.Social.SocialGamingService, CocoonJS.Social.SocialService);


    /**
     * This enumeration represents the possible images to be obtained for a user in the social gaming extension.
     * @namespace
     * @enum
     */
    CocoonJS.Social.ImageSize =
    {
        /**
         * Represent a thumbnail like image size.
         */
        THUMB : "thumb",
        /**
         * Represents the small image size.
         */
        SMALL : "small",
        /**
         * Represents the medium image size.
         */
        MEDIUM : "medium",
        /**
         * Represents the large image size.
         */
        LARGE : "large"
    };


    /**
     * The data structure that represents the information of a user inside the social gaming extension.
     * @class
     * @constructor
     * @param {string} userID The id of the user.
     * @param {string} userName The user name of the user.
     */
    CocoonJS.Social.User = function(userID, userName, userImage)
    {
        /**
         * The id of the user.
         * @field
         * @type string
         */
        this.userID = userID;
        /**
         * The user name of the user.
         * @field
         * @type string
         */
        this.userName = userName;

        /**
         * The user image URL
         * If the image URL is not provided by default fetch it using requestUserImage method.
         * @field
         * @type {string}
         */
        this.userImage = userImage;

        return this;
    };

    /**
     * This type represents a message to be published.
     * @class
     * @constructor
     * @param {string} message The message to be published.
     * @param {string} mediaURL An URL to a media (image, video, ...)
     * @param {string} linkURL An URL to add to the message so the user can click on that link to get more information.
     * @param {string} linkText The text that will appear in the message link.
     * @param {string} linkCaption The text caption that will appear in the message link.
     */
    CocoonJS.Social.Message = function(message, mediaURL, linkURL, linkText, linkCaption)
    {
        /**
         * The message to be published.
         * @field
         * @type string
         */
        this.message = message;
        /**
         * An URL to a media (image, video, ...)
         * @field
         * @type string
         */
        this.mediaURL = mediaURL;
        /**
         * An URL to add to the message so the user can click on that link to get more information.
         * @field
         * @type string
         */
        this.linkURL = linkURL;
        /**
         * The text that will appear in the message link.
         * @field
         * @type string
         */
        this.linkText = linkText;
        /**
         * The text caption that will appear in the message link.
         * @field
         * @type string
         */
        this.linkCaption = linkCaption;

        return this;
    };


    /**
     * The data structure that represents the information of the user score in the application.
     * @class
     * @constructor
     * @param {string} userID The user id.
     * @param {number} score The score of the user.
     * @param {string} userName The name of the user.
     * @param {string} imageURL The url of the user image.
     * @param {number} leaderboardID The id of the leaderboard the score belongs to.
     */
    CocoonJS.Social.Score = function(userID, score, userName, imageURL, leaderboardID)
    {
        /**
         * The user id.
         * @type string
         */
        this.userID = userID;
        /**
         * The score of the user.
         * @type number
         */
        this.score = score || 0;
        /**
         * The name of the user.
         * @type string
         */
        this.userName = userName;
        /**
         * The url of the user image.
         * @type string
         */
        this.imageURL = imageURL;
        /**
         * The id of the leaderboard the score belongs to.
         * @type string
         */
        this.leaderboardID = leaderboardID;

        return this;
    };

    /**
     * The data structure that represents params to retrieve or submit scores
     * @class
     * @constructor
     * @param {string} userID The user id. If no userID is specified the current logged in user is assumed.
     * @param {string} leaderboardID The leaderboard ID. If no leaderboard is specified the default leaderboard is assumed.
     * @param {boolean} [friendScope = false] If enabled the query will get only scores from friends in the social network
     * @param {CocoonJS.Social.TimeScope} [timeScope=0] The time scope for the scores.
     */
    CocoonJS.Social.ScoreParams = function(userID, leaderboardID, friends, timeScope) {
        /**
         * The user id.
         * @type string
         */
        this.userID = userID;
        /**
         * The id of the leaderboard.
         * @type string
         */
        this.leaderboardID = leaderboardID;

        /**
         * Friends scope
         * @type {boolean}
         */
        this.friends = !!friends;

        /**
         * The time scope
         * @type {number}
         */
        this.timeScope = timeScope || 2;
    }

    /**
     * @enum
     * This enumeration represents the possible Time Scopes for a leaderboad query.
     */
    CocoonJS.Social.TimeScope =
    {
        ALL_TIME: 0,
        WEEK: 1,
        TODAY:2
    };

    /**
     * The data structure that represents the information of an achievement in the application.
     * @class
     * @constructor
     * @param {string} achievementID The id of the achievement info.
     * @param {string} title The title of the achievement.
     * @param {string} description The description of the achievement.
     * @param {string} imageURL The url to the image representing the achievement.
     * @param {number} points The points value of the achievement
     */
    CocoonJS.Social.Achievement = function(achievementID, title, description, imageURL, points)
    {
        /**
         * The id of the achievement.
         * @type string
         */
        this.achievementID = achievementID;
        /**
         * The optional custom id of the achievement defined by the user.
         * @type string
         */
        this.customID = achievementID;
        /**
         * The title of the achievement.
         * @type string
         */
        this.title = title;
        /**
         * The description of the achievement.
         * @type string
         */
        this.description = description;
        /**
         * The url to the image representing the achievement.
         * @type string
         */
        this.imageURL = imageURL;
        /**
         * The points value of the achievement
         * @type number
         */
        this.points = points || 0;

        return this;
    };

})();(function(){

    // The CocoonJS and CocoonJS.Social must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating the extension types.");
    if (typeof window.CocoonJS.Social === 'undefined' || window.CocoonJS.Social === null) throw("The CocoonJS.Social object must exist and be valid before creating the extension types.");

    /**
     * @class
     * @constructor
     * Represents a type that mimics the original GameCenter API (somehow ;)) with the addition of the possibility to 
     * retrieve an abstract high level interface API to handle a SocialGamingService (APIs defined by Ludei) and multiplayer support.
     */
    CocoonJS.Social.GameCenterExtension = function() {
        this.nativeExtensionName = "IDTK_SRV_GAMECENTER";
        this.extensionName = "Social.GameCenter";
        this.nativeExtensionObjectAvailable =  CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[this.nativeExtensionName] !== 'undefined';

        var me = this;
        if (this.nativeExtensionObjectAvailable) {
            this.onGameCenterLoginStateChanged = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onGameCenterLoginStateChanged");

            this.onGameCenterLoginStateChanged.addEventListener(function(localPlayer,error){
                me._currentPlayer = localPlayer;
            });
        }
        return this;
    };

    CocoonJS.Social.GameCenterExtension.prototype = {

        _currentPlayer: null,

        /**
         * Return a CocoonJS SocialGaming interface for the Game Center Extension
         * You can use the Game Center extension in two ways, with 1:1 official API equivalent or with the CocoonJS Social API abstraction
         * @see CocoonJS.Social.SocialGamingService
         * @returns {CocoonJS.Social.SocialGamingService}
         */
        getSocialInterface: function() {
            if (!this._socialService) {
                this._socialService = new CocoonJS.Social.SocialGamingServiceGameCenter(this);
            }
            return this._socialService;
        },

        /**
         * Return a CocoonJS Multiplayer interface for the Game Center Extension
         * @returns {CocoonJS.Multiplayer.MultiplayerService}
         */
        getMultiplayerInterface: function() {
            return CocoonJS.Multiplayer.GameCenter;
        },

        isLoggedIn: function() {
            return this._currentPlayer && this._currentPlayer.isAuthenticated;
        },

        /**
         * Authenticate the user
         * @params {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.LocalPlayer and error.
         */
        login: function(callback) {
            var me = this;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "login", [function(response, error) {
                    me._currentPlayer = response;
                    if (callback) {
                        callback(response,error);
                    }
                }], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Synchronous accessor for the current authResponse
         * @returns {CocoonJS.Social.GameCenter.LocalPlayer} current Local Player data
         */
        getLocalPlayer: function() {
            if (this._currentPlayer)
                return this._currentPlayer;
            if (this.nativeExtensionObjectAvailable) {
                this._currentPlayer = CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLocalPlayer", []);
                return this._currentPlayer;
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the players for the provided identifiers.
         * @param {array} playerIDs Array of player identifiers
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.Player array and error
         */
        loadPlayers: function(playerIDs, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadPlayers", [playerIDs, callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the friends for the current logged in user.
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.Player array and error
         */
        loadFriends: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadFriends", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the earned achievements for the current logged in user.
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.Achievements array and error
         */
        loadAchievements: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadAchievements", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the application achievement descriptions
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.AchievementDescription array and error
         */
        loadAchievementDescriptions: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadAchievementDescriptions", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the application achievement descriptions
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.Leaderboard object and error
         * @param {CocoonJS.Social.GameCenter.Leaderboard} [query] Optional query parameters
         */
        loadScores: function(callback, query) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadScores", [query,callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Report user score to the server
         * @param {CocoonJS.Social.GameCenter.Score} score definition of the score and it's category (leaderboardID).
         * If no category is specified the default one is used.
         * @param {function} callback The callback function. Response params: error
         */
        submitScore: function(score, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitScore", [score,callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Report user earned achievements to the server
         * @param {array} achievements Array of CocoonJS.Social.GameCenter.Achievement objects
         * @param {function} callback The callback function. Response params: error
         */
        submitAchievements: function(achievements, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitAchievements", [achievements,callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Resets all the achievements of the current logged in user
         * @param {function} [callback] The callback function. Response params: error.
         */
        resetAchievements : function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "resetAchievements", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Shows a native view with the standard user interface for achievements
         * @param {function} callback The callback function when the view is closed by the user. Response params: error
         */
        showAchievements: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showAchievements", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Shows a native view with the standard user interface for leaderboards
         * @param {function} callback The callback function when the view is closed by the user. Response params: error
         * @param {CocoonJS.Social.GameCenter.Leaderboard} [query] Optional parameters
         */
        showLeaderboards: function(callback, query) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showLeaderboards", [query, callback], true);
            }
            else {
                throw "Game Center not available";
            }
        }
    };

    /**
     * @namespace
     * This is the global variable that enables access to the GameCenter API mimic and the high level abstract API
     * to handle Social and Multiplayer aspects created by Ludei.
     * @see CocoonJS.Social.GameCenterExtension
     */
    CocoonJS.Social.GameCenter = new CocoonJS.Social.GameCenterExtension();

    /**
     * @class
     * The data structure that represents the information of a Game Center player (Readonly)
     */
    CocoonJS.Social.GameCenter.Player = function() {
        /**
         * The identifier of the player.
         * @type string
         */
        this.playerID = "";
        /**
         * The alias of the player.
         * @type string
         */
        this.alias = "";
        /**
         * True if the user is friend of the local player
         * @type boolean
         */
        this.isFriend = false;
    }

    /**
     * @class
     * The data structure that represents the information of the Game Center Local Player (Readonly)
     */
    CocoonJS.Social.GameCenter.LocalPlayer = function() {
        /**
         * The identifier of the player.
         * @type string
         */
        this.playerID = "";
        /**
         * The alias of the player.
         * @type string
         */
        this.alias = "";
        /**
         * Indicates the authentication state of the current player
         * @type boolean
         */
        this.isAuthenticated = false;
    }

    /**
     * The data structure that represents an earned achievement by the user
     * @class
     * @constructor
     * @param {string} identifier The id of the achievement.
     * @param {number} [percentComplete] The percentage on which the achievement has been completed. 100% by default.
     */
    CocoonJS.Social.GameCenter.Achievement = function(identifier, percentComplete) {
        /**
         * The identifier of the achievement.
         * @type string
         */
        this.identifier = identifier;
        /**
         * Percentage of achievement complete (from 0 to 100)
         * @type number
         */
        this.percentComplete = percentComplete;
        /**
         *  Date the achievement was last reported (unix time)
         * @type number
         */
        this.lastReportedDate = 0;
    }

    /**
     * @class
     * The data structure that represents achievements defined by the application (Readonly)
     */
    CocoonJS.Social.GameCenter.AchievementDescription = function() {
        /**
         * The identifier of the achievement.
         * @type string
         */
        this.identifier = "";
        /**
         * The title of the achievement
         * @type string
         */
        this.title = "";
        /**
         * The description for an achieved achievement
         * @type string
         */
        this.achievedDescription = "";
        /**
         * The description for an unachieved achievement.
         * @type string
         */
        this.achievedDescription = "";

        /**
         * The maximum points of the achievement
         * @type number
         */
        this.maximumPoints = 0;
    }

    /**
     * @class
     * @constructor
     * The data structure that a score in the leaderboards
     * @param {number} value The value of the score.
     * @param {string} category The category where the score is associated.
     */
    CocoonJS.Social.GameCenter.Score = function(value,category) {
        /**
         * The score value as a 64bit integer.
         * @type number
         */
        this.value = value;
        /**
         * Leaderboard category
         * @type string
         */
        this.category = category;
        /**
         * The identifier of the player that recorded the score
         * @type string
         */
        this.playerID = "";
        /**
         * The rank of the player within the leaderboard
         * @type number
         */
        this.rank = 0;
    }

    /**
     * @class
     * @constructor
     * The data structure that represents the set of high scores for the current game
     * @param {string} category The category of the leaderboard.
     * @param {array} payerIDs
     * @param {CocoonJS.Social.GameCenter.TimeScope} timeScope
     * @param {CocoonJS.Social.GameCenter.PayerScope} payerScope
     * @param {number} rangeStart
     * @param {number} rangeLength
     */
    CocoonJS.Social.GameCenter.Leaderboard = function(category, playerIDs, timeScope, playerScope, rangeStart, rangeLength) {
        /**
         * leaderboard category (query parameter)
         * @type string
         */
        this.category = category;
        /**
         * Player identifiers array (query parameter)
         * @type string
         */
        this.playerIDs = category;
        /**
         * Time scope (query parameter)
         * @type CocoonJS.Social.GameCenter.TimeScope
         */
        this.timeScope = timeScope;
        /**
         * Player scope (query parameter)
         * @type CocoonJS.Social.GameCenter.PlayerScope
         */
        this.playerScope = playerScope;
        /**
         * Leaderboards start at index 1 and the length should be less than 100 (query parameter)
         * @type number
         */
        this.rangeStart = rangeStart;
        /**
         * Leaderboards start at index 1 and the length should be less than 100 (query parameter)
         * @type number
         */
        this.rangeLength = rangeLength;
        /**
         * Scores array (response parameter)
         * @type Array of CocoonJS.Social.GameCenter.Score
         */
        this.scores = [];
        /**
         * Local player score (response parameter)
         * @type CocoonJS.Social.GameCenter.Score
         */
        this.localPlayerScore = [];
        /**
         * Localized category title
         * @type string
         */
        this.localizedTitle = localizedTitle;
    }

    /**
     * @enum
     * This enumeration represents the possible Time Scopes for a leaderboad query.
     */
    CocoonJS.Social.GameCenter.TimeScope =
    {
        TODAY: 0,
        WEEK: 1,
        ALL_TIME:2
    };

    /**
     * @enum
     * This enumeration represents the possible Player Scopes for a leaderboad query.
     */
    CocoonJS.Social.GameCenter.PlayerScope =
    {
        GLOBAL: 0,
        FRIENDS: 1
    };


    //Social API Interface
    CocoonJS.Social.SocialGamingServiceGameCenter = function(gcExtension) {
        CocoonJS.Social.SocialGamingServiceGameCenter.superclass.constructor.call(this);
        this.gc = gcExtension;
        var me = this;
        this.gc.onGameCenterLoginStateChanged.addEventListener(function(localPlayer, error){
            me.onLoginStatusChanged.notifyEventListeners(localPlayer.isAuthenticated,error);
        });
        return this;
    }

    CocoonJS.Social.SocialGamingServiceGameCenter.prototype =  {

        _cachedAchievements: null,

        isLoggedIn: function() {
            return this.gc.isLoggedIn();
        },
        login : function(callback) {
            this.gc.login(function(localPlayer, error){
                if (callback)
                    callback(localPlayer.isAuthenticated, error);
            });
        },
        logout: function(callback) {
            if (callback)
                callback({message:"User has to logout from the Game Center APP"});
        },
        getLoggedInUser : function() {
            return fromGCPLayerToCocoonUser(this.gc._currentPlayer ? this.gc._currentPlayer : this.gc.getLocalPlayer());
        },

        requestUser: function(callback, userId) {
            if (userId) {
                this.gc.loadPlayers([userId], function(response, error) {
                    var user = response && response.length ? fromGCPLayerToCocoonUser(response[0]) : null;
                    callback(user, error);
                });
            }
            else {
                var me = this;
                setTimeout(function(){
                    callback(me.getLoggedInUser());
                })
            }
        },
        requestFriends: function(callback, userId) {
            this.gc.loadFriends(function(friends, error){
                var users = [];
                if (friends && friends.length) {
                    for (var i= 0; i< friends.length; ++i) {
                        users.push(fromGCPLayerToCocoonUser(friends[i]));
                    }
                }
                callback(users, error);
            });
        },
        requestScore: function(callback, params) {
            var query = {};
            var options = params || {};
            if (options.leaderboardID)
                query.category = options.leaderboardID;
            query.playerIDs = [options.userID || this.getLoggedInUser().userID];

            this.gc.loadScores(function(response, error) {
                var gcScore = null;
                if (options.userID && response && response.scores && response.scores.length)
                    gcScore = response.scores[0];
                else if (response && response.localPlayerScore)
                    gcScore = response.localPlayerScore;
                var loadedScore = gcScore ? new CocoonJS.Social.Score(gcScore.playerID, gcScore.value, "","", gcScore.category) : null;
                callback(loadedScore,error);
            }, query);
        },

        submitScore: function(score, callback, params) {
            var options = params || {};
            this.gc.submitScore({value:score, category:options.leaderboardID || ""}, function(error){
                if (callback)
                    callback(error);
            });
        },

        showLeaderboard : function(callback, params) {
            var options = params || {};
            this.gc.showLeaderboards(function(error){
                if (callback)
                    callback(error);
            }, {category:options.leaderboardID || ""});
        },
        //internal utility function
        prepareAchievements: function(reload, callback) {

            if (!this._cachedAchievements || reload) {
                var me = this;
                this.gc.loadAchievementDescriptions(function(response, error){
                    if (error) {
                        callback([],error);
                    }
                    else {
                       var achievements = [];
                       if (response && response.length) {
                           for (var i = 0; i < response.length; i++) {
                               achievements.push(fromGCAchievementDescriptionToCocoonAchievement(response[i]))
                           }
                       }
                       me.setCachedAchievements(achievements);
                       callback(achievements, null);
                    }

                });
            }
            else {
                callback(this._cachedAchievements, null);
            }
        },

        requestAllAchievements : function(callback) {
            this.prepareAchievements(true, callback);
        },

        requestAchievements : function(callback, userID) {
            var me = this;
            this.prepareAchievements(false, function(allAchievements, error){
                if (error) {
                    callback([], error);
                    return;
                }
                me.gc.loadAchievements(function(response, error){
                    if (!error) {
                        var achievements = [];
                        if (response && response.length) {
                            for (var i = 0; i < response.length; i++) {
                                var ach = me.findAchievement(response[i].identifier);
                                if (ach)
                                    achievements.push(ach);
                            }
                        }
                        callback(achievements, null);
                    }
                    else {
                        callback([], response.error);
                    }

                });
            });
        },
        submitAchievement: function(achievementID, callback) {
            if (achievementID === null || typeof achievementID === 'undefined')
                throw "No achievementID specified";
            var achID = this.translateAchievementID(achievementID);
            this.gc.submitAchievements([{identifier:achID, percentComplete:100}], callback);
        },
        resetAchievements : function(callback) {
            this.gc.resetAchievements(callback);
        },
        showAchievements : function(callback) {
            this.gc.showAchievements(function(error){
                if (callback)
                    callback(error);
            });
        }
    }

    CocoonJS.extend(CocoonJS.Social.SocialGamingServiceGameCenter, CocoonJS.Social.SocialGamingService);

    /**
     * @ignore
     */
    function fromGCPLayerToCocoonUser(player){
        return new CocoonJS.Social.User(player.playerID, player.alias);
    }
    /**
     * @ignore
     */
    function fromGCAchievementDescriptionToCocoonAchievement(ach) {
        return new CocoonJS.Social.Achievement(ach.identifier,ach.title, ach.achievedDescription,"", ach.maximumPoints);
    }
})();
;(function() {

    // The CocoonJS and CocoonJS.Social must exist before creating the extension.
    if (!window.CocoonJS) throw("The CocoonJS object must exist and be valid before creating the extension types.");
    if (!window.CocoonJS.Social) throw("The CocoonJS.Social object must exist and be valid before creating the extension types.");

    /**
     * @class
     * @constructor
     * Represents a type that mimics the original Google Play Games API with the addition of the possibility to
     * retrieve an abstract high level interface API to handle a SocialGamingService (APIs defined by Ludei).
     * Original Google Play Games API: https://developers.google.com/api-client-library/javascript/referencedocs/
     */
    CocoonJS.Social.GooglePlayGamesExtension = function (){
        this.nativeExtensionName = "IDTK_SRV_GOOGLE_PLAY_GAMES";
        this.extensionName = "Social.GooglePlayGames";
        this.nativeExtensionObjectAvailable =  CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[this.nativeExtensionName] !== 'undefined';

        this.auth = new CocoonJS.Social.GooglePlayGamesAuthExtension(this);
        this.client = new CocoonJS.Social.GooglePlayGamesClientExtension(this);
        this.defaultScopes = ["https://www.googleapis.com/auth/games","https://www.googleapis.com/auth/plus.login"];
        this.gamesAPI = "/games/v1";
        this.plusAPI = "/plus/v1";

        this.onSessionChanged = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSessionChanged");

        CocoonJS.Social.GooglePlayGames = this; //the object it's being created but the addEventListener needs it now
        var me = this;
        this.onSessionChanged.addEventListener(function(session, error) {
            me.token = fromSessionToAuthTokenObject(session,error);
            if (session && session.access_token) {
                //fetch user data
                me.client.request({path: me.gamesAPI + "/players/me", callback: function(response) {
                    me.currentPlayer = response;
                }});
            }
        });

        return this;
    };

    CocoonJS.Social.GooglePlayGamesExtension.prototype = {

        token: null,
        settings: {},
        socialService: null,
        currentPlayer: null,
        initialized: false,

        auth: null,
        client: null,

        /**
         * Initializes the service and tries to restore the last session
         * @param {Object} params Initialization options
         * params.clientId {string} The application clientID. Omit if its already provided in the native application via cloud configuration.
         * params.defaultLeaderboard {string} The default leaderboard ID. You can omit it if you specify the leaderboardID in all the score queries or submits
         * params.showAchievementNotifications {boolean} Enable or disable the native view notifications when an achievement is unlocked.
         */
        init: function(params) {
            if (!params || typeof params !== 'object')
                throw "Invalid params argument";
            this.settings = params;
            this.initialized = true;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "init", [this.settings.clientId], true);
            }
            else {

                var me = this;
                var initWebAPi = function() {
                    gapi.auth.authorize({immediate: true, scope: me.defaultScopes, client_id:me.settings.clientId},function(response) {
                        me.token = response;
                        if (response && response.access_token) {
                            me.onSessionChanged.notifyEventListeners(response);
                        }
                    })
                }

                if (!window.gapi) {
                    window.onGapiLoadCallback = function() {
                        //initialization timeout recommended by google to avoid some race conditions
                        window.setTimeout(initWebAPi, 1);
                    }
                    var script = document.createElement("script");
                    script.src = "https://apis.google.com/js/client.js?onload=onGapiLoadCallback";
                    document.getElementsByTagName('head')[0].appendChild(script);
                }
                else {
                    initWebAPi();
                }
            }
        },

        /**
         * Return a CocoonJS SocialGaming interface for the Google Play Games Extension
         * You can use the Google Play Games extension in two ways, with the official SDK API equivalent or with the CocoonJS Social API abstraction
         * @see CocoonJS.Social.SocialGamingService
         * @returns {CocoonJS.Social.SocialGamingService}
         */
        getSocialInterface: function() {

            if (!this.initialized) {
                throw "You must call init() before getting the Social Interface";
            }
            if (!this.socialService) {
                this.socialService = new CocoonJS.Social.SocialGamingServiceGooglePlayGames(this);
            }
            return this.socialService;
        },

        /**
         * Return a CocoonJS Multiplayer interface for the Game Center Extension
         * @returns {CocoonJS.Multiplayer.MultiplayerService}
         */
        getMultiplayerInterface: function() {
            return CocoonJS.Multiplayer.GooglePlayGames;
        },

        share: function() {


            window.open(this.href,'', 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=600,width=600');return false;

        }

    };

    CocoonJS.Social.GooglePlayGamesAuthExtension = function(extension) {
        this.extension = extension;
        return this;
    }

    CocoonJS.Social.GooglePlayGamesAuthExtension.prototype = {
        /**
         * Initiates the OAuth 2.0 authorization process.
         * The browser displays a popup window prompting the user authenticate and authorize.
         * After the user authorizes, the popup closes and the callback function fires.
         * @param {object} A key/value map of parameters for the request (client_id, inmediate, response_type, scope)
         * @param {function} callback The function to call once the login process is complete. The function takes an OAuth 2.0 token object as its only parameter.
         */
        authorize: function(params, callback) {
            var me = this;
            if (this.extension.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.extension.nativeExtensionName, "authorize", [params, function(response, error) {
                    me.extension.token = fromSessionToAuthTokenObject(response,error);
                    if (callback) {
                        callback(me.extension.token);
                    }
                }], true);
            }
            else {
                gapi.auth.authorize(params, function(response){
                    me.extension.token = response;
                    me.extension.onSessionChanged.notifyEventListeners(response, response ? response.error : null);
                    if (callback)
                        callback(response);
                });
            }
        },

        /**
         * Log the user out of the application
         * @param callback
         */
        disconnect: function(callback) {

            if (this.extension.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.extension.nativeExtensionName, "disconnect", [callback], true);
            }
            else {
                //TODO
                if (callback)
                    callback({error: "Not implemented yet"});
            }
        },

        /**
         *  Initializes the authorization feature. Call this when the client loads to prevent popup blockers from blocking the auth window on gapi.auth.authorize calls.
         *  @param {Function} callback A callback to execute when the auth feature is ready to make authorization calls
         */
        init: function(callback) {

            if (this.extension.nativeExtensionObjectAvailable) {
                callback();
            }
            else {
                gapi.auth.init(callback);
            }
        },

        /**
         * Retrieves the OAuth 2.0 token for the application.
         */
        getToken: function() {
            if (this.extension.nativeExtensionObjectAvailable) {
                return this.extension.token;
            }
            else {
                return gapi.auth.getToken();
            }
        },
        /*
         * Retrieves the OAuth 2.0 token for the application.
         */
        setToken: function(token) {
            if (this.extension.nativeExtensionObjectAvailable) {
                this.extension.token = token;
            }
            else {
                gapi.auth.setToken(token);
            }
        }
    }


    CocoonJS.Social.GooglePlayGamesClientExtension = function(extension) {
        this.extension = extension;
        return this;
    }

    CocoonJS.Social.GooglePlayGamesClientExtension.prototype = {

        /**
         * Sets the API key for the application, which can be found in the Developer Console. Some APIs require this to be set in order to work.
         * @param apiKey The API key to set
         */
        setApiKey: function(apiKey) {
            if (this.extension.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.extension.nativeExtensionName, "setApiKey", [apiKey],true);
            }
            else {
                gapi.client.setApiKey(apiKey);
            }
        },

        /**
         * Creates a HTTP request for making RESTful requests.
         * @param {object} args (More info: https://developers.google.com/api-client-library/javascript/reference/referencedocs#gapiclientrequest)
         * @return {object} If no callback is supplied, a request object is returned. The request can then be executed using gapi.client.HttpRequest.execute(callback).
         */
        request: function(args) {
            if (this.extension.nativeExtensionObjectAvailable) {
                if (args.callback) {
                    CocoonJS.makeNativeExtensionObjectFunctionCall(this.extension.nativeExtensionName, "request", [args, function(response,error){
                        var result = response;
                        if (error) {
                            result = response || {};
                            result.error = error;
                        }
                        args.callback(result);
                    }],true);
                    return null;
                }
                else {
                    var me = this;
                    //return a function to mimic the HttpRequest class
                    var httpRequest =  {
                        execute: function(callback) {
                            CocoonJS.makeNativeExtensionObjectFunctionCall(me.extension.nativeExtensionName, "request", [args, function(response, error){
                                var result = response;
                                if (error) {
                                    result = response || {};
                                    result.error = error;
                                }
                                callback(result);
                            }],true);
                        }
                    };
                    return httpRequest;
                }
            }
            else {
                return gapi.client.request(args);
            }
        }
    }

    /**
     * @namespace
     * This is the global variable that enables access to the Google Play Games API mimic and the high level abstract API
     * to handle Social aspects, created by Ludei.
     * @see CocoonJS.Social.GooglePlayGamesExtension
     */
    CocoonJS.Social.GooglePlayGames = new CocoonJS.Social.GooglePlayGamesExtension();


    /**
     * @ignore
     */
    function fromSessionToAuthTokenObject(response, error) {
        var obj = response || {};
        return {
            access_token: response.access_token,
            state: response.state,
            error: error,
            expires_in: response.expirationDate ? response.expirationDate - Date.now() : 0,
            player_id: response.playerId
        }
    }


    CocoonJS.Social.SocialGamingServiceGooglePlayGames = function (apiObject) {
        CocoonJS.Social.SocialGamingServiceGooglePlayGames.superclass.constructor.call(this);
        this.gapi = apiObject;
        var me = this;

        this.gapi.onSessionChanged.addEventListener(function(session){
            var obj = session || {};
            me.onLoginStatusChanged.notifyEventListeners(!!obj.access_token, obj.error);
        });

        return this;
    }

    CocoonJS.Social.SocialGamingServiceGooglePlayGames.prototype =  {

        isLoggedIn: function() {
            return (this.gapi.token && this.gapi.token.access_token) ? true: false;
        },
        login : function(callback) {
            var me = this;
            this.gapi.auth.authorize({client_id:this.gapi.settings.clientId, scope: this.gapi.defaultScopes}, function(response) {
                if (callback) {
                    callback(me.isLoggedIn(),response.error);
                }
            });
        },
        logout: function(callback) {
            this.gapi.auth.disconnect(callback);
        },
        getLoggedInUser : function() {
            return this.gapi.currentPlayer ? fromGPUserToCocoonUser(this.gapi.currentPlayer) : null;
        },
        requestUser: function(callback, userId) {
            var playerId = userId || "me";
            this.gapi.client.request({path: this.gapi.gamesAPI + "/players/" + playerId, callback: function(response) {
                var user = response && !response.error ? fromGPPlayerToCocoonUser(response) : null;
                callback(user, response.error);
            }});
        },
        requestUserImage: function(callback, userID, imageSize) {
            this.requestUser(function(user, error){
                if (user && user.userImage) {
                    var pixelSize = fromImageSizeToGPSize(imageSize || CocoonJS.Social.ImageSize.MEDIUM);
                    if (user.userImage.indexOf("sz=") ===  -1) {
                        user.userImage+="?sz=" + pixelSize;
                    }
                    else {
                        user.userImage = user.userImage.replace(/sz=\d+/g,"sz=" + pixelSize);
                    }
                }
                callback(user ? user.userImage : null, error);
            }, userID);

        },
        requestFriends: function(callback, userId) {
            var params = { orderBy: "best"};
            var playerId = userId || "me";
            this.gapi.client.request({path: this.gapi.plusAPI + "/people/" + playerId + "/people/visible", params: params, callback: function(response) {
                if (response && !response.error) {
                    var friends = [];
                    for (var i = 0; i< response.items.length; ++i) {
                        friends.push(fromGPPersonToCocoonUser(response.items[i]));
                    }
                    callback(friends);
                }
                else {
                    callback([], response ? response.error : null);
                }
            }});
        },

        publishMessage: function(message, callback) {
            if (callback)
                callback("Not supported... use publishMessageWithDialog method instead");
        },

        publishMessageWithDialog: function(message, callback) {

            if (this.gapi.nativeExtensionObjectAvailable) {
                var params = {
                    prefilledText: message.message,
                    mediaUrl: message.mediaURL,
                    mediaTitle: message.linkCaption,
                    mediaDescription: message.linkText,
                    url: message.linkURL
                }

                CocoonJS.makeNativeExtensionObjectFunctionCall(this.gapi.nativeExtensionName, "shareMessage", [params, callback], true)
            }
            else {

                var me = this;
                var share = function() {
                    var options = {
                        contenturl: 'https://plus.google.com/pages/',
                        contentdeeplinkid: '/pages',
                        clientid: me.gapi.settings.clientId,
                        cookiepolicy: 'single_host_origin',
                        prefilltext: message.message,
                        calltoactionlabel: 'CREATE',
                        calltoactionurl: 'http://plus.google.com/pages/create',
                        calltoactiondeeplinkid: '/pages/create'
                    };

                    gapi.interactivepost.render('sharePost', options);
                }

                if (!gapi.interactivepost) {
                    var script = document.createElement('script'); script.type = 'text/javascript'; script.async = true;
                    script.src = 'https://apis.google.com/js/plusone.js';
                    script.onload = function() {
                        share();
                    }
                    document.getElementsByTagName('head')[0].appendChild(script);
                }
                else {
                    share();
                }
            }
        },

        requestScore: function(callback, params) {
            params = params || {};
            var playerId = params.userID || "me";
            var leaderboardID = params.leaderboardID || this.gapi.settings.defaultLeaderboard;
            if (!leaderboardID)
                throw "leaderboardID not provided in the params. You can also set the default leaderboard in the init method";

            this.gapi.client.request({path: this.gapi.gamesAPI + "/players/" + playerId + "/leaderboards/" + leaderboardID + "/scores/ALL_TIME", callback: function(response) {
                if (response && response.error) {
                    callback(null, response.error)
                }
                else if (response && response.items && response.items.length > 0) {
                    var item = response.items[0];
                    var data = new CocoonJS.Social.Score(playerId, item.scoreValue,"","", item.leaderboard_id);
                    callback(data, null);
                }
                else {
                    //No score has been submitted yet for the user
                    callback(null,null);
                }
            }});

        },

        submitScore: function(score, callback, params) {
            params = params || {};
            var leaderboardID = params.leaderboardID || this.gapi.settings.defaultLeaderboard;
            if (!leaderboardID)
                throw "leaderboardID not provided in the params. You can also set the default leaderboard in the init method";


            this.gapi.client.request({path: this.gapi.gamesAPI + "/leaderboards/" + leaderboardID + "/scores",
                                      method: "POST", params:{score: score}, callback: function(response) {
                    if (callback) {
                        callback(response ? response.error : null);
                    }
            }});

        },

        showLeaderboard : function(callback, params) {
            params = params || {};
            var leaderboardID = params.leaderboardID || this.gapi.settings.defaultLeaderboard;
            if (!leaderboardID)
                throw "leaderboardID not provided in the params. You can also set the default leaderboard in the init method";

            var ios = /(iPad|iPhone|iPod)/ig.test( navigator.userAgent );
            if (!ios && this.gapi.nativeExtensionObjectAvailable) {
                var timeScope = params.timeScope || 0;
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.gapi.nativeExtensionName, "showLeaderboard", [leaderboardID, timeScope, callback], true);
            }
            else {
                if (!this._leaderboardsTemplate)
                    throw "Please, provide a html template for leaderboards with the setTemplates method";
                var dialog = new CocoonJS.App.WebDialog();
                var callbackSent = false;
                dialog.show(this._leaderboardsTemplate, function(error) {
                    dialog.closed = true;
                    if (!callbackSent && callback)
                        callback(error);
                });
                var me = this;
                var collection = params.friends ? "SOCIAL" : "PUBLIC";
                var timeSpan = "ALL_TIME";
                if (params.timeScope === CocoonJS.Social.TimeScope.WEEK) {
                    timeSpan = "WEEKLY";
                }
                else if (params.timeScope === CocoonJS.Social.TimeScope.TODAY) {
                    timeSpan = "DAILY";
                }
                this.gapi.client.request({path: this.gapi.gamesAPI + "/leaderboards/" + leaderboardID + "/window/" + collection,
                    method: "GET", params:{timeSpan: timeSpan}, callback: function(response) {
                        if (dialog.closed)
                            return;
                        if (response.error) {
                            if (callback) {
                                callbackSent = true;
                                callback(response.error);
                                dialog.close();
                            }
                            return;
                        }
                        var scores = [];
                        var items = [];
                        if (response && response.items) {
                            items = response.items.slice(0);
                        }
                        if (response && response.playerScore) {
                            items.push(response.playerScore);
                        }
                        for (var i = 0; i< items.length; ++i) {
                            var item = items[i];
                            var score = fromGPScoreToCocoonScore(item, leaderboardID);
                            score.imageURL+="?sz=50";
                            score.position = item.scoreRank || i + 1;
                            score.me = false;
                            scores.push(score);
                        }
                        var js = "addScores(" + JSON.stringify(scores) + ")";
                        dialog.eval(js);
                    }});
            }
        },

        //internal utility function
        prepareAchievements: function(reload, callback) {
            if (!this._cachedAchievements || reload) {
                var me = this;
                this.gapi.client.request({path: this.gapi.gamesAPI + "/achievements", callback: function(response) {
                    if (response && !response.error) {
                        var achievements = [];
                        if (response && response.items) {
                            for (var i = 0; i < response.items.length; i++) {
                                achievements.push(fromGPAchievementToCocoonAchievement(response.items[i]))
                            }
                        }
                        me.setCachedAchievements(achievements);
                        callback(achievements, null);
                    }
                    else {
                        callback([], response ? response.error : null);
                    }
                }});
            }
            else {
                callback(this._cachedAchievements, null);
            }
        },

        requestAllAchievements : function(callback) {
            this.prepareAchievements(true, callback);
        },

        requestAchievements : function(callback, userID) {
            var me = this;
            this.prepareAchievements(false, function(allAchievements, error){
                if (error) {
                    callback([], error);
                    return;
                }
                var playerID = userID || "me";
                me.gapi.client.request({path: me.gapi.gamesAPI + "/players/" + playerID + "/achievements",
                                        params: {state: "UNLOCKED"}, callback: function(response) {
                    if (response && !response.error) {
                        var achievements = [];
                        if (response.items) {
                            for (var i = 0; i < response.items.length; i++) {
                                var ach = me.findAchievement(response.items[i].id);
                                if (ach)
                                    achievements.push(ach);
                            }
                        }
                        callback(achievements, null);
                    }
                    else {
                        callback([], response ? response.error : null);
                    }
                }});

            });
        },
        submitAchievement: function(achievementID, callback) {
            if (achievementID === null || typeof achievementID === 'undefined')
                throw "No achievementID specified";
            var achID = this.translateAchievementID(achievementID);
            if (this.gapi.nativeExtensionObjectAvailable) {
                //native API allows to show a native notification view. (REST API doesn't)
                var showNotification = !!this.gapi.settings.showAchievementNotifications;
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.gapi.nativeExtensionName, "unlockAchievement", [achID, showNotification, callback], true);
            }
            else {
                //REST api
                this.gapi.client.request({path: this.gapi.gamesAPI + "/achievements/" + achID + "/unlock",
                    method: "POST", callback: function(response) {
                        if (callback) {
                            callback(response ? response.error : null);
                        }
                    }});
            }
        },
        resetAchievements : function(callback) {
            this.gapi.client.request({path: "/games/v1management/achievements/reset",
                method: "POST", callback: function(response) {
                    if (callback) {
                        callback(response ? response.error : null);
                    }
                }});
        },
        showAchievements : function(callback) {
            var ios = /(iPad|iPhone|iPod)/ig.test( navigator.userAgent );
            if (!ios && this.gapi.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.gapi.nativeExtensionName, "showAchievements", [callback], true);
            }
            else {
                CocoonJS.Social.SocialGamingServiceGooglePlayGames.superclass.showAchievements.call(this);
            }
        }
    }

    CocoonJS.extend(CocoonJS.Social.SocialGamingServiceGooglePlayGames, CocoonJS.Social.SocialGamingService);


    /**
     *@ignore
     */
    function fromGPPlayerToCocoonUser (gpPlayer) {
        return new CocoonJS.Social.User (gpPlayer.playerId, gpPlayer.displayName, gpPlayer.avatarImageUrl);
    }
    /**
     *@ignore
     */
    function fromGPPersonToCocoonUser (gpUser) {
        var avatar = gpUser.image ? gpUser.image.url : "";
        avatar = avatar.replace(/sz=\d+/g,"sz=100");
        return new CocoonJS.Social.User (gpUser.id, gpUser.displayName, avatar);
    }
    /**
     *@ignore
     */
    function fromImageSizeToGPSize (imageSize) {
        if (imageSize === CocoonJS.Social.ImageSize.THUMB) {
            return 100;
        }
        else if (imageSize === CocoonJS.Social.ImageSize.MEDIUM) {
            return 200;
        }
        else if (imageSize === CocoonJS.Social.ImageSize.LARGE) {
            return 512;
        }
    }
    /**
     *@ignore
     */
    function fromGPAchievementToCocoonAchievement(gpItem) {
        var result = new CocoonJS.Social.Achievement (
            gpItem.id,
            gpItem.name,
            gpItem.description,
            gpItem.revealedIconUrl,
            0
        );
        result.gpAchievementData = gpItem;
        return result;
    }
    /**
     *@ignore
     */
    function fromGPScoreToCocoonScore(gpItem, leaderboardID) {
        return new CocoonJS.Social.Score(gpItem.player.playerId, gpItem.scoreValue, gpItem.player.displayName, gpItem.player.avatarImageUrl, leaderboardID);
    }

})();
;(function() {

    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.Social === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.Social object must exist and be valid before creating a Social Manager extension object.");

    CocoonJS.Social.ManagerService = function() {
       this.services = [];
    }

    CocoonJS.Social.ManagerService.prototype = {

        services:null,

        registerSocialService : function(service) {
            this.services.push(service);
        },

        submitAchievement : function(achievementID) {
            for (var i = 0; i < this.services.length; ++i) {
                var service = this.services[i];
                if (!service.readOnlyHint && service.isLoggedIn())  {
                    service.submitAchievement(achievementID, function(error) {
                        if (error)
                            console.error("Error submitting achievement: " + error.message);
                    });
                }
            }
        },

        submitScore : function(score, params) {
            for (var i = 0; i < this.services.length; ++i) {
                var service = this.services[i];
                if (!service.readOnlyHint && service.isLoggedIn())  {
                    service.submitScore(score, function(error) {
                        if (error)
                            console.error("Error submitting score: " + error.message);
                    }, params);
                }
            }
        },

        getLoggedInServices : function() {
            var result= [];

            for (var i = 0; i < this.services.length; ++i) {
                var service = this.services[i];
                if (!service.fakeSocialService &&  service.isLoggedIn())  {
                    result.push(service);
                }
            }
            return result;
        },

        isLoggedInAnySocialService : function() {
            return this.getLoggedInServices().length > 0;
        }
    }

    CocoonJS.Social.Manager = new CocoonJS.Social.ManagerService();

})();;(function() {

    // The CocoonJS and CocoonJS.Social must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating the extension types.");
    if (typeof window.CocoonJS.Social === 'undefined' || window.CocoonJS.Social === null) throw("The CocoonJS.Social object must exist and be valid before creating the extension types.");

    /** 
     * @class
     * @constructor 
     * Represents a type that mimics the original Facebook API with the addition of the possibility to
     * retrieve an abstract high level interface API to handle a SocialGamingService (APIs defined by Ludei).
     */
    CocoonJS.Social.FacebookExtension = function (){
        this.nativeExtensionName = "IDTK_SRV_FACEBOOK";
        this.extensionName = "Social.Facebook";
        this.nativeExtensionObjectAvailable =  CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[this.nativeExtensionName] !== 'undefined';
        this.Event = new CocoonJS.Social.FacebookEvent(this.nativeExtensionObjectAvailable);

        var me = this;
        if (this.nativeExtensionObjectAvailable) {

            this.onFacebookSessionStateChanged = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onFacebookSessionStateChanged");

            CocoonJS.Social.Facebook = this; //the object it's being created but the addEventListener needs it now
            this.onFacebookSessionStateChanged.addEventListener(function(session, error) {
                var data = fromCocoonFBSessionToFBAPISession(session,error);
                if (session.state == 0) {
                    me.Event.notify("auth.login", data);
                }
                me.Event.notify("auth.authResponseChange", data);
                me.Event.notify("auth.statusChange", data);
            });
        }
        return this;
    };

    CocoonJS.Social.FacebookExtension.prototype = {

        _currentSession: null,
        _appId: null,
        _socialService: null,

        /**
         * Initialize the SDK with your app ID. This will let you make calls against the Facebook API. All FB.API methods must be called after FB.init.
         * @param {object} options. Check available options here: https://developers.facebook.com/docs/reference/javascript/FB.init/
         */
        init: function(options) {
            if (!options || !options.appId) {
                throw "appId must be specified!";
            }

            this._appId = options.appId;

            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "init", [options], true);
            }
            else {
                FB.init(options);
            }

            var me = this;
            this.Event.subscribe("auth.authResponseChange", function(session) {
                me._currentSession = session;
                if (session.authResponse && !session.authResponse.user){
                    me.api("me?fields=username", function(response) {
                        me._currentSession.authResponse.user = response;
                    });
                }
            });
        },

        /**
         * Return a CocoonJS SocialGaming interface for the Facebook Extension
         * You can use the Facebook extension in two ways, with the official SDK API equivalent or with the CocoonJS Social API abstraction
         * @see CocoonJS.Social.SocialGamingService
         * @returns {CocoonJS.Social.SocialGamingService}
         */
        getSocialInterface: function() {

            if (!this._appId) {
                throw "You must call init() before getting the Social Interface";
            }
            if (!this._socialService) {
                this._socialService = new CocoonJS.Social.SocialGamingServiceFacebook(this);
            }
            return this._socialService;
        },

        /**
         * Authenticate the user
         * By default, calling login will attempt to authenticate the user with only the basic permissions.
         * If you want one or more additional permissions, call login with an option object,
         * and set the scope parameter with a comma-separated list of the permissions you wish to request from the user
         * @param {object} login options
         * @params {function} callback The callback function with received session data or error.
         */
        login: function(callback, options) {
            var me = this;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "login", [options, function(response, error) {
                    me._currentSession = fromCocoonFBSessionToFBAPISession(response,error);
                    if (callback) {
                        callback(me._currentSession);
                    }

                }], true);
            }
            else {
                FB.login(function(response){
                    me._currentSession = response;
                    if (callback)
                        callback(response);
                }, options);
            }

        },

        /**
         * Log the user out of your application
         * You will need to have a valid access token for the user in order to call the function.
         * @param {function} callback called when the user is logged out
         */
        logout: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "logout", [function(response, error) {
                    if (callback) {
                        callback(fromCocoonFBSessionToFBAPISession(response, error));
                    }

                }],true);
            }
            else {
                FB.logout(function(response){
                    if (callback) {
                        callback(response);
                    }
                });
            }

        },

        /**
         * Synchronous accessor for the current authResponse
         * @returns {object} current Facebook session data
         */
        getAuthResponse: function() {

            if (this.nativeExtensionObjectAvailable) {
                var response = CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getFacebookSession", []);
                return fromCocoonFBSessionToFBAPISession(response);
            }
            else {
                return FB.getAuthResponse();
            }

        },

        /**
         * Allows you to determine if a user is logged in to Facebook and has authenticated your app.
         * There are three possible states for a user:
         * 1. the user is logged into Facebook and has authenticated your application (connected)
         * 2. the user is logged into Facebook but has not authenticated your application (not_authorized)
         * 3. the user is not logged into Facebook at this time and so we don't know if they've authenticated your application or not
         * @param {function} callback The callback function.
         * @param {boolean} force Force reloading the login status (default false).
         */
        getLoginStatus: function(callback, force) {
            if (this.nativeExtensionObjectAvailable) {

                var me = this;
                setTimeout(function(){
                    var response = CocoonJS.makeNativeExtensionObjectFunctionCall(me.nativeExtensionName, "getFacebookSession", []);
                    if (callback) {
                        callback(fromCocoonFBSessionToFBAPISession(response));
                    }

                },50);
            }
            else {
                FB.getLoginStatus(callback, force);
            }

        },
        /**
         * Makes API calls to the Graph API.
         * @param path The Graph API url path
         * @param method the http method (default "GET")
         * @param params the parameters for the query
         * @param cb the callback function to handle the response
         */
        api: function(path, method, params, cb ) {

            if (this.nativeExtensionObjectAvailable) {
                var openGraph = arguments[0];
                var httpMethod = arguments.length > 3 ? arguments[1] : "GET";
                var options = null;
                if (arguments.length == 3) options = arguments[1];
                if (arguments.length == 4) options = arguments[2];
                var callback = arguments.length > 1 ? arguments[arguments.length -1 ] : function(){};

                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "api", [openGraph, httpMethod, options, callback], true);
            }
            else {
                FB.api(path,method,params,cb);
            }
        },

        /**
         * A generic method for triggering Dialogs which allow the user to take some action.
         * @param params The required arguments vary based on the method being used, but specifying the method itself is mandatory
         * @param cb Callback function to handle the result. Not all methods may have a response.
         */
        ui: function(params, cb) {

            if (this.nativeExtensionObjectAvailable){
                var params = arguments[0];
                var callback = arguments.length > 1 ? arguments[1]: function(){};

                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "ui", [params, callback], true);
            }
            else if (!navigator.isCocoonJS)
            {
                FB.ui(params,cb);
            }
        },

        /**
         * @param {string} permissionsType "read" or "publish"
         * @param permissions comma separated Facebook permission names
         * @param callback response authResponse callback
         */

        requestAdditionalPermissions: function(permissionsType, permissions, callback) {
            if (this.nativeExtensionObjectAvailable) {

                var permsArray = permissions.split(',');
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAdditionalPermissions", [permissionsType, permsArray, function(session, error){
                    if (callback) {
                        callback(fromCocoonFBSessionToFBAPISession(session,error));
                    }
                }], true);
            }
            else {
                FB.login(callback, {scope:permissions});
            }
        },

        /**
         * Query the current user facebook permissions
         * @param callback Handler function which receives a dictionary with the granted permissions
         */
        getPermissions: function(callback) {
            this.api('me/permissions', function(response) {
                callback(response.data && response.data[0] ? response.data[0] : {});
            });
        },

        /**
         * Presents a dialog in the Facebook application that allows the user to share a status update
         * If the Facebook Application is not available it does a fallback to a feed dialog
         * No publish permissions are required.
         * @param params Dialog params (description, caption, name, link, picture)
         * @param callback Handler with response data or error
         */
        showShareDialog: function(params, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showShareDialog", [params, callback], true);
            }
            else {
                params.method = "feed";
                FB.ui(params, callback);
            }
        },

        /**
         * Upload a local image file to Facebook and get response
         * @param file The local file url to submit to Facebook (For example the one capture with screenCapture API)
         * @param callback Handler to process response with the photoid and other data or the error
         */
        uploadPhoto: function(file, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "uploadPhoto", [file, callback], true);
            }
            else {
                //TODO
                callback({error: {message: "Not implemented"}});
            }
        },

        /**
         * Shows a native UI component that can be used to pick friends.
         * @param callback Handlerv function. The response contains the boolen 'donePressed' value and an array of selected users in the 'selection' property.
         */
        showFriendPicker: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showFriendPicker", [callback], true);
            }
            else {
                //TODO
                callback({error: {message: "Not implemented"}});
            }
        }

    };

    /**
     * @class
     * @constructor
     */
    CocoonJS.Social.FacebookEvent = function(nativeAvailable ) {
        this.nativeExtensionObjectAvailable = nativeAvailable;
        return this;
    }

    CocoonJS.Social.FacebookEvent.prototype = {
        /**
         * Global Events to which you can subscribe:
         * auth.login - fired when the auth status changes from unknown to connected
         * auth.authResponseChange - fired when the authResponse changes
         * auth.statusChange - fired when the status changes
         * @param name Name of the event
         * @param callback The handler function
         */
        subscribe: function(name, callback){
            if (this.nativeExtensionObjectAvailable)
            {
                var eventKey = name + 'listeners';
                this[eventKey] = this[eventKey] || [];
                this[eventKey].push(callback);
            }
            else if (!navigator.isCocoonJS)
            {
                FB.Event.subscribe(name,callback);
            }
        },
        /**
         * Removes handlers on events so that it no longer invokes your callback when the event fires.
         * @param name Name of the event.
         * @param callback The handler function.
         */
        unsubscribe: function(name, callback) {
            if (this.nativeExtensionObjectAvailable)
            {
                var eventKey = name + 'listeners';
                var array = this[eventKey];
                if (array) {
                    var index = array.indexOf(callback);
                    if (index !== -1) {
                        array.splice(index,1);
                    }
                }
            }
            else if (!navigator.isCocoonJS)
            {
                FB.Event.unsubscribe(name,callback);
            }
        },

        /**
         * @ignore
         */
        notify: function(name, param) {
            var eventKey = name + 'listeners';
            var array = this[eventKey];
            if (array) {
                for (var i = 0; i< array.length; ++i) {
                    array[i](param);
                }
            }

        }
    };

    /**
     * @namespace 
     * This is the global variable that enables access to the Facebook API mimic and the high level abstract API
     * to handle Social aspects, created by Ludei.
     * @see CocoonJS.Social.FacebookExtension
     */
    CocoonJS.Social.Facebook = new CocoonJS.Social.FacebookExtension();

    /**
     * @ignore
     */
    function fromCocoonFBStatusToFBAPIState(state) {
        if (state === 0) {
            return "connected";
        }
        else if (state === 1) {
            return "not_authorized";
        }
        else {
            return "unknown";
        }
    }

    /**
     * @ignore
     */
    function fromCocoonFBSessionToFBAPISession(response, error) {

        var authResponse = null;
        if (response.state === 0) {
            authResponse = {
                accessToken: response.accessToken,
                expirationDate: response.expirationDate,
                userID: response.user ? response.userID : null,
                permissions: response.permissions,
                user: response.user
            }
        }

        return {
            status: fromCocoonFBStatusToFBAPIState(response.state),
            authResponse: authResponse,
            error: error
        }

    }

    CocoonJS.Social.SocialGamingServiceFacebook = function (fbExtension) {
        CocoonJS.Social.SocialGamingServiceFacebook.superclass.constructor.call(this);
        this.fb = fbExtension;
        var me = this;
        this.fb.Event.subscribe("auth.authResponseChange", function(session) {
            me.onLoginStatusChanged.notifyEventListeners(session.status == "connected", session.error);
        });
        return this;
    }

    CocoonJS.Social.SocialGamingServiceFacebook.prototype =  {

        currentPermissions: null,

        isLoggedIn: function() {
            return this.fb._currentSession && this.fb._currentSession.status === "connected";
        },
        login : function(callback) {
            var me = this;
            this.fb.login(function(response){
                if (callback)
                    callback(me.isLoggedIn(), response.error);
            });
        },
        logout: function(callback) {
            this.fb.logout(function(response){
                if (callback)
                    callback(response.error);
            });
        },
        getLoggedInUser : function() {
            var authResponse = this.fb._currentSession ? this.fb._currentSession.authResponse : null;
            if (authResponse && authResponse.user) {
                return fromFBUserToCocoonUser(authResponse.user);
            }
            else if (authResponse && authResponse.userID) {
                return new CocoonJS.Social.User(authResponse.userID, "Loading...");
            }
            return null;
        },
        hasPublishPermissions: function(callback) {
            this.fb.getPermissions(function(perms, error){
               callback(perms.publish_actions, error);
            });
        },
        requestPublishPermissions: function(callback) {
            var me = this;
            this.fb.requestAdditionalPermissions("publish", "publish_actions", function(response){
                if (response.error)
                    callback(false, error);
                else {
                    me.hasPublishPermissions(function(granted, error){
                        callback(granted,error);
                    });
                }
            });
        },
        requestUser: function(calback, userId) {
            var apiCall = (userId || "me");
            this.fb.api(apiCall, function(response){
                var user = response.error ? null : fromFBUserToCocoonUser(response);
                calback(user, response.error);
            });
        },
        requestUserImage: function(callback, userID, imageSize) {
            if (!userID && this.isLoggedIn()) {
                userID = this.fb._currentSession.authResponse.userID;
            }
            var fbPictureSize = "small";
            if (imageSize === CocoonJS.Social.ImageSize.THUMB) {
                  fbPictureSize = "square"
            }
            else if (imageSize === CocoonJS.Social.ImageSize.MEDIUM) {
                fbPictureSize = "normal";
            }
            else if (imageSize === CocoonJS.Social.ImageSize.LARGE) {
                fbPictureSize = "large";
            }
            var url = "https://graph.facebook.com/" + userID + "/picture?type=" + fbPictureSize;
            callback(url);
        },
        requestFriends: function(callback, userId) {
            var apiCall = (userId || "me") + "/friends";
            this.fb.api(apiCall, function(response){
                var friends = [];
                if (!response.error) {
                    for (var i=0; i<response.data.length; i++)
                    {
                        friends.push(fromFBUserToCocoonUser(response.data[i]));
                    }
                }
                callback(friends, response.error);
            });
        },

        //internal utility function
        preparePublishAction: function(callback) {
            if (!this.currentPermissions) {
                var me = this;
                this.fb.getPermissions(function(perms){
                    me.currentPermissions = perms;
                    if (perms)
                        me.preparePublishAction(callback);
                });
            }
            else if (this.currentPermissions.publish_actions) {
                callback(true);
            }
            else{
                this.currentPermissions = null;
                this.fb.requestAdditionalPermissions("publish", "publish_actions", function(response) {
                     callback(response.error ? false : true);
                });
            }

        },
        publishMessage: function(message, callback) {
            this.preparePublishAction(function(granted) {
                if (granted) {
                    var params = fromCocoonMessageToFBMessage(message);
                    var apiCall = "me/feed";
                    this.fb.api(apiCall, params, function(response) {
                        if (callback)
                            callback(response.error);
                    });
                }
                else {
                    if (callback)
                        callback({message: "No publish_actions permission granted"});
                }
            });
        },

        publishMessageWithDialog: function(message, callback) {
            this.fb.showShareDialog(fromCocoonMessageToFBMessage(message), function(response){
                 if (callback) {
                     callback(response.error);
                 }
            });
        },

        requestScore: function(callback, params) {
            var apiCall = ((params && params.userID) ? params.userID : "me") + "/scores";
            this.fb.api(apiCall, function(response) {
                if (response.error) {
                    callback(null, response.error)
                }
                else if (response.data && response.data.length > 0) {
                    var data = fromFBScoreToCocoonScore(response.data[0]);
                    callback(data, null);
                }
                else {
                    //No score has been submitted yet for the user
                    callback(null,null);
                }

            });
        },

        submitScore: function(score, callback, params) {
            var me = this;
            this.preparePublishAction(function(granted) {
                if (granted) {
                    me.requestScore(function(currentScore, error) {
                        if (error) {
                            //can't get the user top score. Don't send the new one because it might be worse than the top score
                            if (callback)
                                callback(error);
                           return;
                        }
                        var topScore = currentScore ? currentScore.score : 0;
                        if (score <= topScore) {
                            //don't submit the new score because a better score is already submitted
                            if (callback)
                                callback(null);
                            return;
                        }
                        var apiCall = "/" + ((params && params.userID) ? params.userID : "me") + "/scores";
                        me.fb.api(apiCall, 'POST', {score:score}, function (response) {
                             if (callback)
                                callback(response.error);
                        });
                    }, params)
                }
                else {
                    if (callback)
                        callback({message: "No publish_actions permission granted"});
                }

            })
        },

        showLeaderboard : function(callback, params) {
            if (!this._leaderboardsTemplate)
                throw "Please, provide a html template for leaderboards with the setTemplates method";
            var dialog = new CocoonJS.App.WebDialog();
            var callbackSent = false;
            dialog.show(this._leaderboardsTemplate, function(error) {
                dialog.closed = true;
                if (!callbackSent && callback)
                    callback(error);
            });
            var me = this;
            this.fb.api(me.fb._appId + "/scores", function(response) {
                if (dialog.closed)
                    return;
                if (response.error) {
                    if (callback) {
                        callbackSent = true;
                        callback(response.error);
                        dialog.close();
                    }
                    return;
                }
                var scores = [];
                if (response.data && response.data.length) {
                    for (var i = 0; i< response.data.length; ++i) {
                        var score = fromFBScoreToCocoonScore(response.data[i]);
                        score.position = i;
                        score.imageURL = "https://graph.facebook.com/" + score.userID + "/picture";
                        score.me = score.userID === me.fb._currentSession.authResponse.userID;
                        scores.push(score);
                    }
                }
                var js = "addScores(" + JSON.stringify(scores) + ")";
                dialog.eval(js);
            });
        },

        //internal utility function
        prepareAchievements: function(reload, callback) {

            if (!this._cachedAchievements || reload) {
                var me = this;
                this.fb.api(this.fb._appId + '/achievements', function(response) {
                    if (!response.error) {
                        var achievements = [];
                        if (response.data) {
                            for (var i = 0; i < response.data.length; i++) {
                                achievements.push(fromFBAchievementToCocoonAchievement(response.data[i]))
                            }
                        }
                        me.setCachedAchievements(achievements);
                        callback(achievements, null);
                    }
                    else {
                        callback([], response.error);
                    }
                });
            }
            else {
                callback(this._cachedAchievements, null);
            }
        },

        requestAllAchievements : function(callback) {
            this.prepareAchievements(true, callback);
        },

        requestAchievements : function(callback, userID) {
            var me = this;
            this.prepareAchievements(false, function(allAchievements, error){

                if (error) {
                    callback([], error);
                    return;
                }
                var apiCall = (userID || "me") + "/achievements";
                me.fb.api(apiCall, function(response) {
                    if (!response.error) {
                        var achievements = [];
                        if (response.data) {
                            for (var i = 0; i < response.data.length; i++) {
                                var ach = me.findAchievement((response.data[i].achievement || response.data[i].data.achievement).id);
                                if (ach)
                                    achievements.push(ach);
                            }
                        }
                        callback(achievements, null);
                    }
                    else {
                        callback([], response.error);
                    }
                });

            });
        },
        submitAchievement: function(achievementID, callback) {
            if (achievementID === null || typeof achievementID === 'undefined')
                throw "No achievementID specified";
            var achID = this.translateAchievementID(achievementID);
            var me = this;
            this.preparePublishAction(function(granted) {
                if (granted) {
                    me.fb.api("me/achievements", "POST", {achievement:achID}, function (response) {
                        if (callback) {
                            callback(response.error);
                        }
                    });
                }
                else {
                    if (callback)
                        callback({message: "No publish_actions permission granted"});
                }

            });
        },
        resetAchievements : function(callback) {
            var me = this;
            this.preparePublishAction(function(granted) {
                if (granted) {
                    me.requestAchievements(function(achievements, error){
                        if (error) {
                            if (callback)
                                callback(error);
                            return;
                        }
                        var someError = null;
                        var remaining = achievements.length;
                        for (var i = 0; i < achievements.length; ++i) {
                            me.fb.api("me/achievements", "DELETE", {achievement:achievements[i].fbAchievementData.url}, function (response) {
                                if (response.error) {
                                   someError = response.error;
                                }
                                remaining--;
                                if (remaining == 0 && callback) {
                                    callback(someError);
                                }
                            });
                        }

                    });
                }
                else {
                    if (callback)
                        callback({message: "No publish_actions permission granted"});
                }

            });
        },
        showAchievements : function(callback) {
            if (!this._achievementsTemplate)
                throw "Please, provide a html template for achievements with the setTemplates method";
            var dialog = new CocoonJS.App.WebDialog();
            var callbackSent = false;
            dialog.show(this._achievementsTemplate, function(error) {
                dialog.closed = true;
                if (!callbackSent && callback)
                    callback(error);
            });
            var me = this;
            this.requestAchievements(function(achievements, error){
                if (dialog.closed)
                    return;
                if (error) {
                    callbackSent = true;
                    if (callback)
                        callback(error);
                    return;
                }

                var achs = [];
                if (me._cachedAchievements) {
                    for (var i = 0; i < me._cachedAchievements.length; ++i) {
                        var ach = me._cachedAchievements[i];
                        achs.push(ach);
                        if (achievements && achievements.length) {
                            for (var j = 0; j< achievements.length; ++j) {
                                if (achievements[j].achievementID === ach.achievementID) {
                                    ach.achieved = true;
                                    break;
                                }
                            }
                        }
                    }
                }
                var js = "addAchievements(" + JSON.stringify(achs) + ");";
                dialog.eval(js);
            });
        }
    }

    CocoonJS.extend(CocoonJS.Social.SocialGamingServiceFacebook, CocoonJS.Social.SocialGamingService);

    /**
     *@ignore
     */
    function fromFBUserToCocoonUser (facebookUser) {
        return new CocoonJS.Social.User (facebookUser.id, facebookUser.username);
    }

    /**
     *@ignore
     */
    function fromCocoonMessageToFBMessage(message) {
        return {
            link: message.linkURL,
            description: message.message,
            name: message.linkText,
            caption: message.linkCaption,
            picture: message.mediaURL
        }
    }
    /**
     *@ignore
     */
    function fromFBScoreToCocoonScore(fbResponse, requestScoreParams) {
        var result = new CocoonJS.Social.Score(fbResponse.user.id, fbResponse.score, fbResponse.user.name);
        if (requestScoreParams) {
            result.leaderboardID = requestScoreParams.leaderboardID;
        }
        result.imageURL = 'https://graph.facebook.com/' + fbResponse.user.id + '/picture';
        return result;
    }
    /**
     *@ignore
     */
    function fromFBAchievementToCocoonAchievement(fbResponse) {
        var result = new CocoonJS.Social.Achievement (
            fbResponse.id,
            fbResponse.title,
            fbResponse.description,
            fbResponse.image[0].url,
            fbResponse.data.points
        );
        result.fbAchievementData = fbResponse;
        return result;
    }

    if (!navigator.isCocoonJS) {
        // Load the Facebook SDK
        var parent = document.getElementsByTagName('script')[0];
        var script = document.createElement('script');
        //script.async = true;
        var prot= location.protocol ? location.protocol : "http:"
        script.src = prot + "//connect.facebook.net/en_US/all.js";
        parent.parentNode.insertBefore(script, parent);
    }

})();;(function() {

    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.Social === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.Social object must exist and be valid before creating a Social Local Storage extension object.");


    /**
     * @constructor
     */
    CocoonJS.Social.LocalStorageService = function() {
        CocoonJS.Social.LocalStorageService.superclass.constructor.call(this);
        this.fakeSocialService = true;
    }

    CocoonJS.Social.LocalStorageService.prototype = {

        loggedIn: false,
        keys: {
            score: "CocoonJS.Social.LocalStorageService.score",
            earnedAchievements: "CocoonJS.Social.LocalStorageService.earned"
        },
        isLoggedIn: function() {
            return this.loggedIn;
        },

        login : function(callback) {
            if (!this.loggedIn)
                this.onLoginStatusChanged.notifyEventListeners(true);
            this.loggedIn = true;
            if (callback)
                setTimeout(function(){callback(true)},0);
        },

        logout: function(callback) {
            if (this.loggedIn)
                this.onLoginStatusChanged.notifyEventListeners(true);
            this.loggedIn = false;

            if (callback)
                setTimeout(function(){callback()},0);
        },

        getLoggedInUser : function() {
            return new CocoonJS.Social.User("me", "LocalStorage");
        },

        requestUser: function(callback, userID) {
            var user = new CocoonJS.Social.User(userID || "me", "LocalStorage");
            if (callback)
                setTimeout(function(){callback(user)},0);
        },

        requestScore: function(callback, params) {
            var scoreItem = localStorage.getItem(this.keys.score);
            var score = parseInt(scoreItem) || 0;
            setTimeout(function(){callback(new CocoonJS.Social.Score("me", score))},0);
        },

        submitScore: function(score, callback, params ) {
            var scoreItem = localStorage.getItem(this.keys.score);
            var topScore = parseInt(scoreItem) || 0;
            if (score > topScore)
                localStorage.setItem(this.keys.score, score);
            if (callback)
                setTimeout(function(){callback()},0);
        },
        getLocalStorageEarnedAchievements: function() {
            var achievementsItem = localStorage.getItem(this.keys.earnedAchievements);
            var earned = [];
            if (achievementsItem) {
                var array = JSON.stringify(achievementsItem);
                if (array && array.length) {
                    earned = array;
                }
            }
            return earned;
        },
        requestAchievements : function(callback, userID) {
            var earned = this.getLocalStorageEarnedAchievements();
            setTimeout(function(){callback(earned)},0);
        },

        submitAchievement: function(achievementID, callback) {
            if (achievementID === null || typeof achievementID === 'undefined')
                throw "No achievementID specified";
            var earned = this.getLocalStorageEarnedAchievements();
            var exists = false;
            for (var i = 0; i< earned.length; ++i) {
               if (earned[i] === achievementID) {
                   exists = true;
                   break;
               }
            }
            if (!exists) {
                earned.push(achievementID);
                localStorage.setItem(this.keys.earnedAchievements, JSON.stringify(earned));
            }

            if (callback)
                setTimeout(function(){callback()},0);
        },
        resetAchievements : function(callback) {
            localStorage.removeItem(this.keys.earnedAchievements);
            if (callback)
                setTimeout(function(){callback()},0);
        }
    };

    CocoonJS.extend(CocoonJS.Social.LocalStorageService, CocoonJS.Social.SocialGamingService);

    CocoonJS.Social.LocalStorage = new CocoonJS.Social.LocalStorageService();

})();;(function() {

    // The CocoonJS must exist before creating the extension.
    if (!window.CocoonJS) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    CocoonJS.Multiplayer = {};

	/**
	* This type represents the access to a native Multiplayer extension API.
    * This service allows to programmatically create matches to invite other players and to receive match invitations sent by other players.
    * Your game must authenticate the related social service before you can use this service.
	* @class
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.Multiplayer.MultiplayerService = function(nativeExtensionName, extensionName)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + nativeExtensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';

        var me = this;

        /**
         * This {@link CocoonJS.EventHandler} object allows listening to events called when an invitation has been received from another player and the user has accepted it
         * The invitation will start loading.
         * While the invitation is loading a system view might appear on the screen.
         * You should pause/stop your current game and prepare it to process a new match
         * @memberOf CocoonJS.Multiplayer.MultiplayerService
         */
        this.onInvitationReceived = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onInvitationReceived");
        /**
         * This {@link CocoonJS.EventHandler} object allows listening to events called when an accepted invitation has been loaded
         * The invitation is ready to be processed (start the match or handle the error)
         * @memberOf CocoonJS.Multiplayer.MultiplayerService
         * Received params: {CocoonJS.Multiplayer.Match} and error
         */
        this.onInvitationLoaded = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onInvitationLoaded", function(sourceListener, args){
            var matchID = args[0];
            var error = args[1];
            if (matchID && !error) {
                me.currentMatch =  new CocoonJS.Multiplayer.Match(me.nativeExtensionName, me.extensionName, matchID);
                sourceListener(me.currentMatch, null)
            }
            else {
                sourceListener(null, error);
            }
        });



        return this;
	};


	CocoonJS.Multiplayer.MultiplayerService.prototype = {

        currentMatch: null,

        /**
         * Presents a system View for the matchmaking and creates a new Match
         * @param {CocoonJS.Multiplayer.MatchRequest} matchRequest The parameters for the match
         * @param {Function} callback The callback function. Response parameters: {CocoonJS.Multiplayer.Match} and error;
         */
        findMatch : function(matchRequest, callback)  {
            var me = this;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "findMatch", [matchRequest, function(matchID,error) {
                    if (matchID && !error) {
                        me.currentMatch =  new CocoonJS.Multiplayer.Match(me.nativeExtensionName, me.extensionName, matchID);
                        callback(me.currentMatch, null)
                    }
                    else {
                        callback(null, error);
                    }
                }], true);
            }
        },

        /**
         * Sends an automatch request to join the authenticated user to a match. It doesn't present a system view while waiting to other players.
         * @param  {CocoonJS.Multiplayer.MatchRequest} matchRequest The parameters for the match
         * @param {Function} callback The callback function. Response parameters: {CocoonJS.Multiplayer.Match} and error;
         */
        findAutoMatch : function(matchRequest, callback) {
            var me = this;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "findAutoMatch", [matchRequest, function(matchID, error){
                    if (matchID && !error) {
                        me.currentMatch =  new CocoonJS.Multiplayer.Match(me.nativeExtensionName, me.extensionName, matchID);
                        callback(me.currentMatch, null)
                    }
                    else {
                        callback(null, error);
                    }
                }], true);
            }
        },

        /**
         * Cancels the ongoing automatch request
         */
        cancelAutoMatch : function() {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "cancelAutoMatch", [], true);
            }
        },

        /**
         * Automatically adds players to an ongoing match owned by the user.
         * @param {CocoonJS.Multiplayer.MatchRequest} matchRequest The parameters for the match
         * @param {CocoonJS.Multiplayer.Match} matchRequest The match where new players will be added
         * @param {Function} callback The callback function. Response parameters: error
         */
        addPlayersToMatch : function(matchRequest, match, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "addPlayersToMatch", [matchRequest, match.matchID, callback], true);
            }
        },
        /**
         * Get the current match reference.
         * @return {CocoonJS.Multiplayer.Match} the current match reference
         */
        getMatch : function() {
            return this.currentMatch;
        }
	};

	/**
	* This type provides a transmission network between a group of users.
	* The match might be returned before connections have been established between players. At this stage, all the players are in the process of connecting to each other.
	* Always check the getExpectedPlayerCount value before starting a match. When its value reaches zero, all expected players are connected, and your game can begin the match.
	* Do not forget to call the start method of the match when your game is ready to process received messages via onMatchDataReceived listener.
	* @class
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	* @param {number} matchID The match ID user for native service bridge.
	*/
	CocoonJS.Multiplayer.Match = function(nativeExtensionName, extensionName, matchID)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + nativeExtensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';
	    this.matchID = matchID;
	    var me = this;


	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a match receives data from the network
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnMatchDataReceivedListener}
	    * @memberOf CocoonJS.Multiplayer.Match
	    * @param {CocoonJS.Multiplayer.Match} match The source match.
	    * @param {string} data The received data
	    * @param {string} playerID The playerID where the data is received from.
	    */
	    this.onMatchDataReceived = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onMatchDataReceived", function(sourceListener, args) {
	    		if (me.matchID === args[0]) {
	    			sourceListener(me, args[1], args[2]);
	    		}
	    	});

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a player connection state changes.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnMatchStateChangedListener}
	    * @memberOf CocoonJS.Multiplayer.Match
	    * @param {CocoonJS.Multiplayer.Match} match The source match.
	    * @param {string} playerID The player whose state has changed
	    * @param {CocoonJS.Multiplayer.ConnectionState} The new connection state of the player
	    */
	    this.onMatchStateChanged = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onMatchStateChanged", function(sourceListener, args) {
	    		if (me.matchID === args[0]) {
	    			sourceListener(me, args[1], args[2]);
	    		}
	    	});

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a netowrk connection with a player fails
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnMatchConnectionWithPlayerFailedListener}
	    * @memberOf CocoonJS.Multiplayer.Match
	    * @param {CocoonJS.Multiplayer.Match} match The source match.
	    * @param {string} playerID The player whose state has changed
	    * @param {string} error The error message
	    */
	    this.onMatchConnectionWithPlayerFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onMatchConnectionWithPlayerFailed", function(sourceListener, args) {
	    		if (me.matchID === args[0]) {
	    			sourceListener(me, args[1], args[2]);
	    		}
	    	});

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the match fails
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnMatchFailedListener}
	    * @memberOf CocoonJS.Multiplayer.Match
	    * @param {CocoonJS.Multiplayer.Match} match The source match.
	    * @param {string} error The error message
	    */
	    this.onMatchFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onMatchFailed", function(sourceListener, args) {
	    		if (me.matchID === args[0]) {
	    			sourceListener(me, args[1]);
	    		}
	    	});
	};

	CocoonJS.Multiplayer.Match.prototype = {

		/**
		* Start processing received messages. The user must call this method when the game is ready to process messages. Messages received before being prepared are stored and processed later.
		* @see CocoonJS.Multiplayer.Match.onMatchDataReceived
		*/
		start : function() {
			if (this.nativeExtensionObjectAvailable) {
				CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "startMatch", [this.matchID], true);
			}
		},

		/**
		* Transmits data to all players connected to the match. The match queues the data and transmits it when the network becomes available.
		* @see CocoonJS.Multiplayer.Match.onMatchDataReceived
		* @see CocoonJS.Multiplayer.Match.onMatchStateChanged
		* @see CocoonJS.Multiplayer.Match.onMatchConnectionWithPlayerFailed
		* @see CocoonJS.Multiplayer.Match.onMatchFailed
		* @param {string} data The data to transmit
		* @param {CocoonJS.Multiplayer.SendDataMode} sendMode The optional {@link CocoonJS.Multiplayer.SendDataMode} value. The default value is RELIABLE.
		* @return {boolean} TRUE if the data was successfully queued for transmission; FALSE if the match was unable to queue the data
		*/
		sendDataToAllPlayers : function(data, sendMode) {
			if (this.nativeExtensionObjectAvailable) {
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "sendDataToAllPlayers", [this.matchID, data, sendMode]);
			}
		},

		/**
		* Transmits data to a list of connected players. The match queues the data and transmits it when the network becomes available.
		* @see CocoonJS.Multiplayer.Match.onMatchDataReceived
		* @see CocoonJS.Multiplayer.Match.onMatchStateChanged
		* @see CocoonJS.Multiplayer.Match.onMatchConnectionWithPlayerFailed
		* @see CocoonJS.Multiplayer.Match.onMatchFailed
		* @param {string} data The data to transmit
		* @param {array} playerIDs An array containing the identifier strings for the list of players who should receive the data
		* @param {CocoonJS.Multiplayer.SendDataMode} sendMode The optional {@link CocoonJS.Multiplayer.SendDataMode} value. The default value is RELIABLE.
		* @return {boolean} TRUE if the data was successfully queued for transmission; FALSE if the match was unable to queue the data
		*/
		sendData : function(data, playerIDs,  sendMode) {
			if (this.nativeExtensionObjectAvailable) {
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "sendData", [this.matchID, data, playerIDs, sendMode]);
			}
		},

		/**
		* Disconnects the local player from the match and releases the match. Calling disconnect notifies other players that you have left the match.
		* @see CocoonJS.Multiplayer.Match.onMatchDataReceived
		* @see CocoonJS.Multiplayer.Match.onMatchStateChanged
		* @see CocoonJS.Multiplayer.Match.onMatchConnectionWithPlayerFailed
		* @see CocoonJS.Multiplayer.Match.onMatchFailed
		*/
		disconnect : function() {
			if (this.nativeExtensionObjectAvailable) {
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "disconnect", [this.matchID], true);
			}
		},

		/**
		* Requests additional information of the current players in the match
        * @param {Function} callback The callback function. Response params: players array and error
		*/
		requestPlayersInfo : function(callback) {
			if (this.nativeExtensionObjectAvailable){
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestPlayersInfo", [this.matchID, callback], true);
			}
		},

		/**
		* Method to request the remaining players count who have not yet connected to the match.
		* @function
		* @return {number} The remaining number of players who have not yet connected to the match
		*/
		getExpectedPlayerCount : function() {
			if (this.nativeExtensionObjectAvailable) {
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getExpectedPlayerCount", [this.matchID]);
			}
		},
		/**
		* This method returns an array with all the player identifiers taking part in the match.
		* @return {array} The player identifiers for the players in the match
		*/
		getPlayerIDs : function() {
			if (this.nativeExtensionObjectAvailable){
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getPlayerIDs", [this.matchID]);
			}
		},

        /**
         * Gets the local playerID taking part in the match.
         * @return {string} the playerID attached to the match manager.
         */
        getLocalPlayerID : function() {
            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLocalPlayerID", [this.matchID]);
            }
            return "";
        },

	};

	/**
	* This enum represents the modes to send data
	* @namespace
	* @enum
	*/
	CocoonJS.Multiplayer.SendDataMode =  {
		/**
		* The data is sent continuously until it is successfully received by the intended recipients or the connection times out
		*/
	    RELIABLE : 0,

		/**
		* The data is sent once and is not sent again if a transmission error occurs.
		*/
	    UNRELIABLE : 1
	};


	/**
	* This enum represents the connection state of a player
	* @namespace
	* @enum
	*/
	CocoonJS.Multiplayer.ConnectionState = {
		/**
		* The connection is in unknown state.
		*/
	    UNKNOWN : 0,

	    /**
		* The connection is in connected state.
		*/
	    CONNECTED : 1,

	    /**
		* The connection is in disconnected state.
		*/
	    DISCONNECTED : 2
	};

	/**
	* The data structure that represents the information of a player inside a multiplayer match.
	* @class
	* @constructor
	* @param {string} The id of the user.
	* @param {string} The name of the user.
	*/
	CocoonJS.Multiplayer.PlayerInfo = function(userID, userName) {
		/**
		* The id of the user.
		* @field
		* @type string
		*/
		this.userID = userID;

		/**
		* The name of the user.
		* @field
		* @type string
		*/
		this.userName = userName;
	};

	/**
	* This data structure is used to specify the parameters for a new new multiplayer match.
	* @class
	* @constructor
	* @param {number} minPlayers The minimum number of players that may join the match.
	* @param {number} maxPlayers The maximum number of players that may join the match.
	* @param {array}  [playersToInvite] Optional list of player identifers for players to invite to the match.
	* @param {number} [playerGroup] Optional number identifying a subset of players allowed to join the match.
	* @param {number} [playerAttributes] Optional mask that specifies the role that the local player would like to play in the game.
	*/
	CocoonJS.Multiplayer.MatchRequest = function(minPlayers, maxPlayers, playersToInvite, playerGroup, playerAttributes) {
		/**
		* The minimum number of players that may join the match.
		* @field
		* @type number
		*/
		this.minPlayers = minPlayers;

		/**
		* The maximum number of players that may join the match.
		* @field
		* @type number
		*/
		this.maxPlayers = maxPlayers;

		/**
		* Optional list of player identifers for players to invite to the match.
		* @field
		* @type Array
		*/
		this.playersToInvite = playersToInvite;

		/**
		* Optional number identifying a subset of players allowed to join the match.
		* @field
		* @type number
		*/
		this.playerGroup = playerGroup;

		/**
		* Optional mask that specifies the role that the local player would like to play in the game.
		* @field
		* @type number
		*/
		this.playerAttributes = playerAttributes;

		return this;
	};

})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (!window) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (!window.CocoonJS.Multiplayer) throw("The CocoonJS.Multiplayer object must exist and be valid before creating a Game Center extension object.");

	/**
	* @namespace
	* This instance represents the extension object to access GameCenter Multiplayer API.
	* @see CocoonJS.Multiplayer.MultiplayerService
	*/
	CocoonJS.Multiplayer.GameCenter = new CocoonJS.Multiplayer.MultiplayerService("IDTK_SRV_MULTIPLAYER_GAMECENTER", "Multiplayer.GameCenter");
})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (!window.CocoonJS) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (!window.CocoonJS.Multiplayer) throw("The CocoonJS.Multiplayer object must exist and be valid before creating a Multiplayer Loopback extension object.");


    var loopbackServices = [];
    var indexCounter = 0;
    var matchServices = [];
    var matchCounter = 0;

    /**
     * This service provides a loopback implementation of the {@link CocoonJS.Multiplayer.MultiplayerService}
     * @constructor
     */
    CocoonJS.Multiplayer.LoopbackService = function() {

        CocoonJS.Multiplayer.LoopbackService.superclass.constructor.call(this, "dummy","dummy");
        loopbackServices.push(this);
        this.playerID = "" + indexCounter;
        indexCounter++;

    }

    CocoonJS.Multiplayer.LoopbackService.prototype =  {

        findMatch : function(request, callback)  {

            this.findMatchCallback = callback;

            //checks if the service is already added to the match list
            var exists = false;
            for (var i = 0; i< matchServices.length; ++i) {
                if (matchServices[i] === this) {
                    exists = true; break;
                }
            }
            if (!exists)
                matchServices.push(this);

            //Create the match is all required players are ready
            //TODO: check more conditions (playerGroup, playerAttributes) to complete a match
            if (matchServices.length >= request.minPlayers) {
                var playerIDs = [];
                //create playerIDs array
                for (var i = 0; i< matchServices.length; ++i) {
                    playerIDs.push(matchServices[i].getPlayerID());
                }

                //notify the found match to each manager
                for (var i = 0; i< matchServices.length; ++i) {
                    var match = new LoopbackMatch(matchServices[i]);
                    match.playerIDs = playerIDs.slice();
                    matchServices[i].currentMatch = match;
                    matchServices[i].findMatchCallback(match, null);
                }
                //clear pending list
                matchServices = [];
            }


        },
        findAutoMatch : function(matchRequest, callback) {
            this.findMatch(matchRequest,callback);
        },
        cancelAutoMatch : function() {

        },

        addPlayersToMatch : function(matchRequest, match, callback) {
            callback({message:"Not implemmented"});
        },
        getPlayerID : function() {
            return this.playerID;
        },

        getMatch : function() {
            return this.currentMatch;
        }
    }

    CocoonJS.extend(CocoonJS.Multiplayer.LoopbackService, CocoonJS.Multiplayer.MultiplayerService);

    var LoopbackMatch = function(service) {
        matchCounter++;
        LoopbackMatch.superclass.constructor.call(this, "","",matchCounter);
        this.started = false;
        this.disconnected = false;
        this.pendingData = [];
        this.service = service;
    }

    LoopbackMatch.prototype = {

        start : function() {
            var me = this;
            setTimeout(function() {
                me.started = true;
                for (var i = 0; i < me.pendingData.length; ++i) {
                    me.onMatchDataReceived.notifyEventListeners(me.matchID,me.pendingData[i].data, me.pendingData[i].player);
                }

            },0);

        },
        sendDataToAllPlayers : function(data, sendMode) {
            this.sendData(data, this.playerIDs, sendMode);
        },

        sendData : function(data, playerIDs,  sendMode) {
            var me = this;
            setTimeout(function() {
                for (var i = 0; i< loopbackServices.length; ++i) {
                    var destService = null;
                    for (var j = 0; j < playerIDs.length; ++j) {
                        if (playerIDs[j] === loopbackServices[i].getPlayerID()) {
                            destService = loopbackServices[i];
                        }
                    }
                    if (destService) {
                        destService.getMatch().notifyDataReceived(data,me.service.getPlayerID());
                    }
                }
            },0);
        },

        disconnect : function() {
            this.disconnected = true;
            for (var i = 0; i < this.playerIDs.length; ++i) {
                var p = this.playerIDs[i];
                for (var j = 0; j < loopbackServices.length; ++j) {
                    if (loopbackServices[j].getPlayerID() === p) {
                        var match = loopbackServices[i].getMatch();
                        if (!match.disconnected) {
                            match.onMatchStateChanged.notifyEventListeners(match, this.service.getPlayerID(), CocoonJS.Multiplayer.ConnectionState.DISCONNECTED);
                        }
                    }
                }
            }
        },

        requestPlayersInfo : function(callback) {
            var me = this;
            setTimeout(function() {
               var playersInfo = [];
                for (var i = 0; i < me.playerIDs.length; ++i) {
                    playersInfo[i] = {userID: me.playerIDs[i], userName: "Player" + me.playerIDs[i]};
                };
                callback(playersInfo);
            },1);
        },

        getExpectedPlayerCount : function() {
            return 0;
        },
        getPlayerIDs : function() {
            return this.playerIDs;
        },
        getLocalPlayerID: function() {
            return this.service.playerID;
        },
        notifyDataReceived: function(data, fromPlayer) {
            if (!this.started) {
                this.pendingData.push({data:data, player:fromPlayer});
            }
            else {
                this.onMatchDataReceived.notifyEventListeners(this.matchID,data,fromPlayer);
            }
        }

    };

    CocoonJS.extend(LoopbackMatch, CocoonJS.Multiplayer.Match);

})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (!window) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (!window.CocoonJS.Multiplayer) throw("The CocoonJS.Multiplayer object must exist and be valid before creating a Google Play Games extension object.");

    /**
     * @namespace
     * This instance represents the extension object to access Google Play Games Multiplayer API.
     * @see CocoonJS.Multiplayer.MultiplayerService
     */
    CocoonJS.Multiplayer.GooglePlayGames = new CocoonJS.Multiplayer.MultiplayerService("IDTK_SRV_MULTIPLAYER_GPG", "Multiplayer.GooglePlayGames");
})();
;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS In-App Purchase extension.
    * @namespace
    */
    CocoonJS.Store = {};

    CocoonJS.Store.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_STORE !== 'undefined';

	/**
	* The data structure that represents the information of a product in the store.
	* @namespace
	* @constructor
	* @param {string} The id of the product.
	* @param {string} The alias of the product.
	* @param {CocoonJS.Store.ProductType} The product type @see CocoonJS.Store.ProductType.
	* @param {string} The title of the product.
	* @param {string} The description of the product.
	* @param {string} The localized price of the product.
	* @param {string} The URL of the asset to be downloaded for this purchase.
	*/
	CocoonJS.Store.ProductInfo = function(productAlias, productId, productType, title, description, price, localizedPrice, downloadURL)
	{
		/**
		* The id of the product.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The alias of the product.
		* @field
		* @type string
		*/
		this.productAlias = productAlias;

		/**
		* The product type @see CocoonJS.Store.ProductType
		* @field
		* @type CocoonJS.Store.ProductType
		*/
		this.productType = productType;

		/**
		* The title of the product.
		* @field
		* @type string
		*/
		this.title = title;

		/**
		* The description of the product.
		* @field
		* @type string
		*/
		this.description = description;

		/**
		* The price of the product.
		* @field
		* @type string
		*/
		this.price = price;

		/**
		* The localized price of the product.
		* @field
		* @type string
		*/
		this.localizedPrice = localizedPrice;

		/**
		* The URL of the asset to be downloaded for this purchase.
		* @field
		* @type string
		*/
		this.downloadURL = downloadURL;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.ProductType = 
	{
		/**
		* A consumable product. See platform documentation for further information.
		*/
	    CONSUMABLE : 0,

		/**
		* A non-cunsumable product. . See platform documentation for further information.
		*/
	    NON_CONSUMABLE : 1,

	    /**
		* An auto-renewable subscription. See platform documentation for further information.
		*/
	    AUTO_RENEWABLE_SUBSCRIPTION : 2,

	    /**
		* A free subscription. See platform documentation for further information.
		*/
	    FREE_SUBSCRIPTION : 3,

	    /**
		* A non-renewable subscription. See platform documentation for further information.
		*/
	    NON_RENEWABLE_SUBSCRIPTION : 4
	};

	/**
    * The predefined possible store types.
    * @namespace 
    */
	CocoonJS.Store.StoreType = 
	{
		/**
		* Apple AppStore
		*/
	    APP_STORE : 0,

	    /**
	    * Android Play Store
	    */
	    PLAY_STORE : 1,

		/**
		* Mock Store
		*/
		MOCK_STORE : 2,

		/**
	    * Amazon AppStore
	    */
	    CHROME_STORE : 3,

	    /**
	    * Amazon AppStore
	    */
	    AMAZON_STORE : 4,

	    /**
	    * Nook Store
	    */
	    NOOK_STORE : 5
	};

	/**
	* The data structure that represents the information of a purchase.
	* @namespace
	* @constructor
	* @param {string} The transaction id of a purchase.
	* @param {string} The time when the purchase was done in seconds since 1970.
	* @param {CocoonJS.Store.PurchaseState} The state of the purchase. @see CocoonJS.Store.PurchaseState
	* @param {string} The product id related to this purchase.
	* @param {number} The number of products of the productId kind purchased in this transaction.
	*/
	CocoonJS.Store.PurchaseInfo = function(transactionId, purchaseTime, purchaseState, productId, quantity)
	{
		/**
		* The transaction id of a purchase.
		* @field
		* @type string
		*/
		this.transactionId = transactionId;

		/**
		* The time when the purchase was done in seconds since 1970.
		* @field
		* @type string
		*/
		this.purchaseTime = purchaseTime;

		/**
		* The state of the purchase. @see CocoonJS.Store.PurchaseState
		* @field
		* @type CocoonJS.Store.PurchaseState
		*/
		this.purchaseState = purchaseState;

		/**
		* The product id related to this purchase.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The number of products of the productId kind purchased in this transaction.
		* @field
		* @type number
		*/
		this.quantity = quantity;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.PurchaseState = 
	{
		/**
		* The product has been successfully purchased. The transaction has ended successfully.
		*/
	    PURCHASED : 0,

		/**
		* The purchase has been canceled.
		*/
	    CANCELED : 1,

	    /**
		* The purchase has been refunded.
		*/
	    REFUNDED : 2,

	    /**
		* The purchase (subscriptions only) has expired and is no longer valid.
		*/
	    EXPIRED : 3
	};

	/**
	* Gets the name of the native store implementation. 
	* @return {CocoonJS.Store.StoreType} The store type
	* @function
	*/ 
	CocoonJS.Store.getStoreType = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getStoreType", arguments);
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Store.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") 
        {
            parameters = {};
        }
        else
        {
        	if (parameters['managed'] !== undefined) parameters['remote'] = parameters['managed'];
        	if (parameters['sandbox'] !== undefined) parameters['debug'] = parameters['sandbox'];
        }

		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "requestInitialization", arguments, true);
		}
	};

	/**
	* Starts the Store Service. 
	* This will make the system to initialize the Store Service and probably Store callbacks will start to be received after calling this method so you should have set your event handler before calling this method so don't lose any callback.
	* @function
	*/ 
	CocoonJS.Store.start = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "start", arguments);
		}
	};

	/**
	* This method allows you to check is the  Store service is available in this platform. 
	* Not all iOS and Android devices will have the Store service available so you should check if it is before calling any other method.
	* @function
	* @return {boolean} True if the service is available and false otherwise.
	*/ 
	CocoonJS.Store.canPurchase = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "canPurchase", arguments);
		}
	};

	/**
	* Fetches the products from the CocoonJS Cloud Compiling service store configuration. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @deprecated You should now use fetchProductsFromStore. We don't support cloud products now.
	* @function
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromServer = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromServer", arguments, true);
		}
	};

	/**
	* Fetches the products information from the Store. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @function
	* @param {array} productIds An array with the ids of the products to retrieve information from.
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromStore = function(productIds)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromStore", arguments, true);
		}
	};

	/**
	* Finish a purchase transaction and removes the transaction from the transaction queue. 
	* This method must be called after a purchase finishes successfully and the  {@link CocoonJS.Store.onProductPurchaseCompleted} callback has been received. 
	* If the purchase includes some asset to download from an external server this method must be called after the asset has been successfully downloaded. 
	* If you do not finish the transaction because the asset has not been correctly downloaded the {@link CocoonJS.Store.onProductPurchaseStarted} method will be called again later on.
	* @function
	* @param {string} transactionId The transactionId of the purchase to finish.
	*/ 
	CocoonJS.Store.finishPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "finishPurchase", arguments, true);
		}
	};

	/**
	* Consumes a purchase. This makes that product to be purchasable again. 
	* @function
	* @param {string} transactionId The transaction Id of the purchase to consume.
	* @param {string} productId The product Id of the product to be consumed.
	*/ 
	CocoonJS.Store.consumePurchase = function(transactionId, productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "consumePurchase", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeature", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id showing a modal progress dialog. 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.puchaseProductModal = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModal", arguments, true);
		}
	};

	/**
	* Request the purchase of a product given it's product id showing a dialog with a preview of the product (title and description). 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProductModalWithPreview = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModalWithPreview", arguments, true);
		}
	};

	/**
	* Returns if a product has been already purchased or not. 
	* @function
	* @param {string} productId The product id or alias of the product to be checked.
	* @returns {boolean} A flag that indicates whether the product has been already purchased (true) or not (false).
	*/
	CocoonJS.Store.isProductPurchased = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "isFeaturePurchased", arguments);
		}
	};

	/**
	* Restores all the purchases from the platform's market. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchases", arguments, true);
		}
	};

	/**
	* Restores all the purchases from the platform's market showing a modal progress dialog. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchasesModal = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchasesModal", arguments, true);
		}
	};

	/**
	* Returns all the products available to be purchased.
	* @function
	* @returns {array} An array with  all the {@link CocoonJS.Store.ProductInfo} objects available for purchase.
	*/
	CocoonJS.Store.getProducts = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getProducts", arguments);
		}
	};

	/**
	* Adds a product to the products local DB. 
	* @function
	* @param {CocoonJS.Store.ProductInfo} product The product to be added to the local products DB.
	*/
	CocoonJS.Store.addProduct = function(product)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addProduct", arguments);
		}
	};

	/**
	* Removes a product from the products local DB given its productId. 
	* @function
	* @param {string} productId The product or alias of the product to be removed from the local products DB.
	*/
	CocoonJS.Store.removeProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removeProduct", arguments);
		}
	};

	/**
	* Returns all the locally stored purchases.
	* @function
	* @returns {array} An array with all the {@link CocoonJS.Store.PurchaseInfo} completed purchases.
	*/
	CocoonJS.Store.getPurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getPurchases", arguments);
		}
	};

	/**
	* Adds a purchase to the local purchases DB. 
	* @function
	* @param {CocoonJS.Store.StorePurchase} purchase The purchase to be added.
	*/ 
	CocoonJS.Store.addPurchase = function(purchase)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addPurchase", arguments);
		}
	};

	/**
	* Removes a purchase from the local purchases DB given it's transaction id. 
	* @function
	* @param {string} transactionId The id of the transaction to be removed.
	*/ 
	CocoonJS.Store.removePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removePurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase cancel. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be canceled.
	*/
	CocoonJS.Store.cancelPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "cancelPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase refundment. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be refunded.
	*/
	CocoonJS.Store.refundPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "refundPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase expiration. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be expired.
	*/
	CocoonJS.Store.expirePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "expirePurchase", arguments);
		}
	};

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onProductsFetchStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchStarted");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has completed.
    * The callback function receives a parameter with an the valid products array.
    * @static
    * @event
    * @param {array} validProducts An array of {@link CocoonJS.Store.ProductInfo} objects representing all the valid fetched products.
    */
	CocoonJS.Store.onProductsFetchCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onProductsFetchFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product starts.
    * The callback function receives a parameters with the information of the purchased product @see CocoonJS.Store.ProductInfo.
    * @static
	* @event
    * @param {string} productId The product id of the product being purchased.
    */
	CocoonJS.Store.onProductPurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseStarted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a request for purchase verification has been received from the Store.
    * The callback function receives two parameters, one with the productId of the purchased product and another one with a JSON object containing the data to be verified.
    * In Andorid this JSON object will containt two keys: signedData and signature. You will need that information to verify the purchase against the backend server.
    * @static
    * @event
    * @param {string} productId The product id of the product to be verified.
    * @param {string} data The string with the data to be verified.
    */
	CocoonJS.Store.onProductPurchaseVerificationRequestReceived = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseVerificationRequestReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product succeeds.
    * The callback function receives as parameter the information of the purchase {@see CocoonJS.Store.PurchaseInfo}.
    * @static
    * @event
    * @param {CocoonJS.Store.PurchaseInfo} purchaseInfo The purchase info.
    */
	CocoonJS.Store.onProductPurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product fails.
    * The callback function receives a parameters with the product id and an error message.
    * @static
    * @event
    * @param {string} productId The product id.
    * @param {string} msg The error message.
    */
	CocoonJS.Store.onProductPurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has completed.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onRestorePurchasesFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesFailed");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has started.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase being consumed.
    */
	CocoonJS.Store.onConsumePurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has completed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the consumed purchase.
    */
	CocoonJS.Store.onConsumePurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has failed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase that couldn't be consumed.
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onConsumePurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseFailed");

})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS camera extension API.
    * @namespace
    */
    CocoonJS.Camera = {};

    CocoonJS.Camera.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_CAMERA !== 'undefined';

    /**
    * The predefined possible camera types.
    * @namespace 
    */
	CocoonJS.Camera.CameraType = {
		/**
		* Represents the front camera on the device.
		*/
	    FRONT : "FRONT",

	    /**
	    * Represents the back camera on the device.
	    */
	    BACK : "BACK"
	};

    /**
    * The predefined possible camera video capturing image format types.
    * @namespace 
    */
	CocoonJS.Camera.CaptureFormatType = {
		/**
		*/
	    JPEG : "JPEG",

		/**
		*/
	    RGB_565 : "RGB_565",

		/**
		*/
	    NV21 : "NV21", 

		/**
		*/
	    NV16 : "NV16",

		/**
		*/
	    YUY2 : "YUY2",

		/**
		*/
	    YV12 : "YV12",

		/**
		*/
	    BGRA32 : "32BGRA"
	};

	/**
	* The data structure that represents the information of a camera. It includes all the information to be able to setup a camera to capture video or to take pictures.
	* @namespace
	*/
	CocoonJS.Camera.CameraInfo =  {
		/**
		* The index of the camera.
		*/
		cameraIndex : 0,

		/**
		* The type of the camera among the possible values in {@link CocoonJS.Camera.CameraType}.
		*/
		cameraType : CocoonJS.Camera.CameraType.BACK,

		/**
		* An array of {@link CocoonJS.Size} values that represent the supported video sizes for the camera.
		*/
		supportedVideoSizes : [],

		/**
		* An array of numbers that represent the supported video frame rates for the camera.
		*/
		supportedVideoFrameRates : [],

		/**
		* An array of {@link CocoonJS.Camera.CaptureFormatType} values that represent the supported video format types for the camera.
		*/
		supportedVideoCaptureImageFormats : []
	};

	/**
	* Returns the number of available camera in the platform/device.
	* @returns {number} The number of cameras available in the platform/device.
	*/
	CocoonJS.Camera.getNumberOfCameras = function()
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "getNumberOfCameras", arguments);
		}
	};

	/**
	* Returns an array of {@link CocoonJS.Camera.CameraInfo} objects representing all the information of all the cameras available in the platform/device.
	* @returns {Array} An array of {@link CocoonJS.Camera.CameraInfo} objects.
	*/
	CocoonJS.Camera.getAllCamerasInfo = function()
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "getAllCamerasInfo", arguments);
		}
	};

	/**
	* Returns the {@link CocoonJS.Camera.CameraInfo} object that represents all the information of the specified camera index in the platform/device.
	* @param {number} cameraIndex The index of the camera to get the info from. The index should be inside 0 and N (N being the value returned by {@link CocoonJS.Camera.getNumberOfCameras}).
	* @returns {CocoonJS.Camera.CameraInfo} The {@link CocoonJS.Camera.CameraInfo} of the given camera index.
	*/
	CocoonJS.Camera.getCameraInfoByIndex = function(cameraIndex)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "getCameraInfoByIndex", arguments);
		}
	};

	/**
	* Returns the {@link CocoonJS.Camera.CameraInfo} object that represents all the information of the first camera of the specified type found in the platform/device.
	* @param {CocoonJS.Camera.CameraType} cameraType The type of the camera to get the info from. 
	* @returns {CocoonJS.Camera.CameraInfo} The {@link CocoonJS.Camera.CameraInfo} of the first camera of the given camera type that has been found in the platform/device.
	*/
	CocoonJS.Camera.getCameraInfoByType = function(cameraType)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "getCameraInfoByType", arguments);
		}
	};

	/**
	* Starts a camera to capture video. The developer must specify at least the index of the camera to be used. Some other setup parameters can also be passed to control the video capture. A image object
	* that will be automatically updated with the captured frames is returned so the developer just need to draw the image in every frame. A null image object is returned if the setup did not work or there is
	* no available camera.
	* @param {number} cameraIndex The index of the camera to start video capture with.
	* @param captureWidth The hozirontal size of the video capture resolution. If the value does not correspond to any of the sizes supported by the camera, the closest one is used. See {@link CocoonJS.Camera.CameraInfo}.
	* If no value is given, the maximum size available is used.
	* @param captureHeight The vertical size of the video capture resolution. If value does not correspond to any of the sizes supported by the camera, the closest one is used. See {@link CocoonJS.Camera.CameraInfo}.
	* If no value is given, the maximum size available is used.
	* @param captureFrameRate The frame rate to capture the video at. If the value does not correspond to any of the frame rates supported by the camera, the closest one is used. See {@link CocoonJS.Camera.CameraInfo}.
	* If no value is given, the maximum frame rate available is used.
	*Â @param captureImageFormat A value from the available {@link CocoonJS.Camera.CaptureFormatType} formats to specify the format of the images that will be captured. See {@link CocoonJS.Camera.CameraInfo}.
	* If no value is given, the first available capture image format is used.
	* @returns {image} A image object that will automatically update itself with the captured frames or null if the camera capture could not start.
	*/
	CocoonJS.Camera.startCapturing = function(cameraIndex, captureWidth, captureHeight, captureFrameRate, captureImageFormat)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "startCapturing", arguments);
		}
	};

	/**
	* Stops a camera that is already started capturing video.
	* @param cameraIndex The index of the camera to stop capturing video.
	*/
	CocoonJS.Camera.stopCapturing = function(cameraIndex)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "stopCapturing", arguments);
		}
	};

	/**
	* Indicates if a camera is capturing video or not.
	* @param cameraIndex The index of the camera to check if is capturing video or not.
	* @returns {boolean} A flag indicating if the given camera (by index) is capturing video (true) or not (false).
	*/
	CocoonJS.Camera.isCapturing = function(cameraIndex)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "isCapturing", arguments);
		}
	};

})();;(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the functionalities related to OUYA android gaming control.
     * @namespace
     */
    CocoonJS.Gamepad = {};

    CocoonJS.Gamepad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.Gamepad !== 'undefined';

    /**
    * This enumeration simplifies the access to the indices for button and axis elements according to the HTML5 gamepad standard API specification.
    * You may use these values to access the buttons and axes arrays inside the Gamepad objects, according to the W3C gamepad API specification.
    * For example: 
    * gamepad.button[CocoonJS.Gamepad.BUTTON_LEFT_TRIGGER]; 
    * gamepad.axes[CocoonJS.Gamepad.AXIS_LEFT_JOYSTICK_X]; 
    * @namespace
    */
    CocoonJS.Gamepad.Indices = {
        /**
        * Represents the button 0 (the A on the XBOX controller, the O on the OUYA controller)
        */
        BUTTON_0                : 0, 
        /**
        * Represents the button 1 (the B on the XBOX controller, the A on the OUYA controller)
        */
        BUTTON_1                : 1,
        /**
        * Represents the button 2 (the X on the XBOX controller, the U on the OUYA controller)
        */
        BUTTON_2                : 2,
        /**
        * Represents the button 3 (the Y on the XBOX controller, the Y on the OUYA controller)
        */
        BUTTON_3                : 3,
        /**
        * Represents the left bumper button.
        */
        BUTTON_LEFT_BUMPER      : 4,
        /**
        * Represents the right bumper button.
        */
        BUTTON_RIGHT_BUMPER     : 5,
        
        /**
        * Represents the left trigger button.
        */
        BUTTON_LEFT_TRIGGER     : 6,
        /**
        * Represents the right trigger button.
        */
        BUTTON_RIGHT_TRIGGER    : 7,
        
        /**
        * Represents the left joystick button.
        */
        BUTTON_LEFT_JOYSTICK    : 10,
        /**
        * Represents the right joystick button.
        */
        BUTTON_RIGHT_JOYSTICK   : 11,
        /**
        * Represents the dpad up button.
        */
        BUTTON_DPAD_UP          : 12,
        /**
        * Represents the dpad down button.
        */
        BUTTON_DPAD_DOWN        : 13,
        /**
        * Represents the dpad left button.
        */
        BUTTON_DPAD_LEFT        : 14,
        /**
        * Represents the dpad right button.
        */
        BUTTON_DPAD_RIGHT       : 15,
        /**
        * Represents the menu button.
        */
        BUTTON_MENU             : 16,
        
        /**
        * Represents the left joystick horizontal axis.
        */
        AXIS_LEFT_JOYSTICK_X     : 0,
        /**
        * Represents the left joystick vertical axis.
        */
        AXIS_LEFT_JOYSTICK_Y     : 1,
        /**
        * Represents the right joystick horizontal axis.
        */
        AXIS_RIGHT_JOYSTICK_X    : 2,
        /**
        * Represents the right joystick vertical axis.
        */
        AXIS_RIGHT_JOYSTICK_Y    : 3
    };

    // If the extension is present and the navigator does not provide the gamepad API:
    // 1.- Add the getGamepads function to the navigator object.
    // 2.- Replace the window add and remove event listener functions to call to the extension for the gamepad related events.
    var systemSupportsGamepads = navigator["getGamepads"] || navigator["webkitGetGamepads"];
    if (systemSupportsGamepads) 
    {
        if (!navigator.getGamepads)
        {
            console.log("navigator.getGamepads does not exist.");
            if (navigator.webkitGetGamepads)
            {
                console.log("navigator.webkitGamepads exists, adding navigator.getGamepads to point to it.");
                navigator.getGamepads = navigator.webkitGetGamepads;
            }
            else
            {
                console.log("navigator.webkitGetGamepads does not exist either.");
            }
        }
    }
})();



;(function() {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw ("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the CocoonJS Notification extension.
     * @namespace
     */
    CocoonJS.Notification = {};

    CocoonJS.Notification.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_NOTIFICATION !== 'undefined';

    /**
     * The data structure that represents the information of a local notification.
     * @namespace
     * @constructor
     * @param {string} message The notification message.
     * @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
     * @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
     * @param {object} userData The JSON data to attached to the notification.
     * @param {string} contentBody The body content to be showed in the expanded notification information.
     * @param {string} contentTitle The title to be showed in the expanded notification information.
     * @param {number} date Time in millisecs from 1970 when the notification will be fired.
     */
    CocoonJS.Notification.createLocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime) {

        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "createLocalNotification", arguments);
        }
    };


    /**
     * The data structure that represents the information of a local notification.
     * @namespace
     * @constructor
     * @deprecated
     * @param {string} message The notification message.
     * @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
     * @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
     * @param {object} userData The JSON data to attached to the notification.
     * @param {string} contentBody The body content to be showed in the expanded notification information.
     * @param {string} contentTitle The title to be showed in the expanded notification information.
     * @param {number} date Time in millisecs from 1970 when the notification will be fired.
     */
    CocoonJS.Notification.LocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime) {
        //The id is initialized with -1 for compatibility issues.
        //The new way to use is createLocalNotification. These can be cancelled and the ID is sent from native code to the 
        this.id = -1;

        /**
         * The notification message.
         * @field
         * @type string
         */
        this.message = message;

        /**
         * A flag that indicates if the sound should be enabled for the notification.
         * @field
         * @type boolean
         */
        this.soundEnabled = soundEnabled;

        /**
         * (iOS only) The number that will appear in the badge of the application icon in the home screen.
         * @field
         * @type number
         */
        this.badgeNumber = badgeNumber;

        /**
         * The JSON data to attached to the notification.
         * @field
         * @type object
         */
        this.userData = userData;

        /**
         * (Android only) The body content to be showed in the expanded notification information.
         * @field
         * @type string
         */
        if (contentBody !== undefined)
            this.contentBody = contentBody;
        else
            this.contentBody = "";

        /**
         * (Android only) The title to be showed in the expanded notification information.
         * @field
         * @type string
         */
        if (contentTitle !== undefined)
            this.contentTitle = contentTitle;
        else
            this.contentTitle = "";

        /**
         * Time in millisecs from 1970 when the local notification will be fired
         * @field
         * @type number
         */
        var currentTime = new Date().getTime();
        if (scheduleTime !== undefined) {
            this.scheduleTime = scheduleTime;
        } else {
            this.scheduleTime = currentTime;
        }
    };

    /**
     * The data structure that represents the information of a push notification.
     * @namespace
     * @constructor
     * @param {string} message The notification message.
     * @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
     * @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
     * @param {object} userData The JSON data to attached to the notification.
     * @param {array} channels An array containing the channels names this notification will be delivered to.
     * @param {number} expirationTime A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
     * @param {number} expirationTimeInterval An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
     */
    CocoonJS.Notification.PushNotification = function(message, soundEnabled, badgeNumber, userData, channels, expirationTime, expirationTimeInterval) {
        /**
         * The notification message.
         * @field
         * @type string
         */
        this.message = message;

        /**
         * A flag that indicates if the sound should be enabled for the notification.
         * @field
         * @type boolean
         */
        this.soundEnabled = soundEnabled;

        /**
         * The number that will appear in the badge of the application icon in the home screen.
         * @field
         * @type number
         */
        this.badgeNumber = badgeNumber;

        /**
         * The JSON data to attached to the notification.
         * @field
         * @type object
         */
        this.userData = userData

        /**
         * An array containing the channels names this notification will be delivered to.
         * @field
         * @type array
         */
        this.channels = channels;

        /**
         * A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
         * @field
         * @type number
         */
        if (expirationTime !== undefined)
            this.expirationTime = expirationTime;
        else
            this.expirationTime = 0;

        /**
         * An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
         * @field
         * @type number
         */
        if (expirationTimeInterval !== undefined)
            this.expirationTimeInterval = expirationTimeInterval;
        else
            this.expirationTimeInterval = 0;
    };

    /**
     * Start processing received notifications. The user must call this method when the game is ready to process notifications. Notifications received before being prepared are stored and processed later.
     */
    CocoonJS.Notification.start = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "start", arguments);
        }
    };


    /**
     * Register to be able to receive push notifications.
     * The registration process is controlled using the {@link CocoonJS.Notification.onRegisterForPushNotificationsSucceed} and {@link CocoonJS.Notification.onRegisterForPushNotificationsFailed} event handlers.
     * @function
     * @see {CocoonJS.Notification.onRegisterForPushNotificationsSucceed}
     * @see {CocoonJS.Notification.onRegisterForPushNotificationsFailed}
     */
    CocoonJS.Notification.registerForPushNotifications = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "registerForPushNotifications", arguments, true);
        }
    };

    /**
     * Unregister from receiving push notifications.
     * The unregistration process is controlled using the {@link CocoonJS.Notification.onUnregisterForPushNotificationsSucceed} event handler.
     * @function
     * @see CocoonJS.Notification.onUnregisterForPushNotificationsSucceed
     */
    CocoonJS.Notification.unregisterForPushNotifications = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unregisterForPushNotifications", arguments, true);
        }
    };

    /**
     * Cancel the local notification with Id provided.
     * The last sent local notification will be remove from the notifications bar.
     * @function
     */
    CocoonJS.Notification.cancelLocalNotification = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments);
        }
    };

    /**
     * Cancel the last sent local notification.
     * The last sent local notification will be remove from the notifications bar.
     * @function
     */

    //TODO: Change this function to be an extension of cancelLocalNotification
    CocoonJS.Notification.cancelLastSentLocalNotificiation = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments, true);
        }
    };

    /**
     * Cancel all sent local notifications.
     * All the notifications will ve removed from the notifications bar.
     * @function
     */
    CocoonJS.Notification.cancelAllLocalNotifications = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelAllLocalNotifications", arguments);
        }
    };

    /**
     * Send a local notification.
     * @function
     * @param {CocoonJS.Notification.LocalNotification} localNotification The local notification to be sent.
     */
    CocoonJS.Notification.sendLocalNotification = function(localNotification) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendLocalNotification", arguments, true);
        }
    };

    /**
     * Subscribe to a channel in order to receive notifications targeted to that channel.
     * @function
     * @param {string} channel The channel id to subscribe to.
     */
    CocoonJS.Notification.subscribeToChannel = function(channel) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "subscribe", arguments, true);
        }
    };

    /**
     * Unsubscribe from a channel in order to stop receiving notifications targeted to it.
     * @function
     * @param {string} channel The channel id to unsubscribe from.
     */
    CocoonJS.Notification.unsubscribeFromChannel = function(channel) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unsubscribe", arguments, true);
        }
    };

    /**
     * Send a push notification.
     * @function
     * @param {CocoonJS.Notification.PushNotification} pushNotification The push notification object to be sent.
     * @see CocoonJS.Notification.onPushNotificationDeliverySucceed
     * @see CocoonJS.Notification.onPushNotificationDeliveryFailed
     */
    CocoonJS.Notification.sendPushNotification = function(pushNotification) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendPushNotification", arguments, true);
        }
    };

    /**
     * (iOS only) Set the badge number for this application.
     * This is useful if you want to modify the badge number set by a notification.
     * @function
     * @param {number} badgeNumber The number of the badge.
     */
    CocoonJS.Notification.setBadgeNumber = function(badgeNumber) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "setBadgeNumber", arguments);
        }
    };

    /**
     * (iOS only) Returns the current badge number.
     * @function
     * @returns {number} The badge number.
     */
    CocoonJS.Notification.getBadgeNumber = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getBadgeNumber", arguments);
        }
    };

    /**
     * Returns the last received user data from a Local notification.
     * @function
     * @returns {object} The last received user data from a Local notification.
     */
    CocoonJS.Notification.getLastReceivedLocalNotificationData = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedLocalNotificationData", arguments);
        }
    };

    /**
     * Returns the last received user data from a Push notification.
     * @function
     * @returns {object} The last received user data from a Push notification.
     */
    CocoonJS.Notification.getLastReceivedPushNotificationData = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedPushNotificationData", arguments);
        }
    };

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notification succeeds.
     * The callback function does not receive any parameter.
     * @static
     * @event
     * @param {string} token The token (apid or device token) received at registration time.
     * @memberOf CocoonJS.Notification
     */
    CocoonJS.Notification.onRegisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceRegistered");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the unregistration for push notifications succeeds.
     * The callback function does not receive any parameter.
     * @static
     * @event
     * @memberOf CocoonJS.Notification
     */
    CocoonJS.Notification.onUnregisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceUnregistered");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notifications fails.
     * The callback function receives a parameter with error information.
     * @static
     * @event
     * @param {string} msg The error message.
     */
    CocoonJS.Notification.onRegisterForPushNotificationsFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceFailedToRegister");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when a push notification is received.
     * The callback function receives a parameter with the userData of the received notification.
     * @static
     * @event
     * @param {object} userData An object with the notification userData information.
     */
    CocoonJS.Notification.onPushNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationReceived");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when a local notification is received.
     * The callback function receives a parameter with the userData of the received notification.
     * @static
     * @event
     * @param {object} userData An object with the notification userData information.
     */
    CocoonJS.Notification.onLocalNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "localNotificationReceived");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when a notification is successfully delivered.
     * The callback function receives a parameter with the notificationId of the delivered notification.
     * @static
     * @event
     * @param {string} userData A string with the notification userData information.
     */
    CocoonJS.Notification.onPushNotificationDeliverySucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationSuccessfullyDelivered");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the delivery of push a notification fails.
     * The callback function receives a parameter with error information.
     * @static
     * @event
     * @param {string} msg The error message.
     */
    CocoonJS.Notification.onPushNotificationDeliveryFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationDeliveryError");

})();
/*! CocoonJSExtensions - v2.0.0 - 2014-04-10 www.ludei.com */window.ext&&"undefined"!=typeof window.ext.IDTK_SRV_BOX2D?(window.Box2D={},window.Box2D.Dynamics={},window.Box2D.Dynamics.Joints={},window.Box2D.Common={},window.Box2D.Common.Math={},window.Box2D.Collision={},window.Box2D.Collision.Shapes={},function(){"use strict";function a(a){console.error(a)}var b=function(a,b){void 0===a&&(a=0),void 0===b&&(b=0),this.x=a,this.y=b};window.Box2D.Common.Math.b2Vec2=b,b.prototype.SetZero=function(){this.x=0,this.y=0},b.prototype.Set=function(a,b){void 0===a&&(a=0),void 0===b&&(b=0),this.x=a,this.y=b},b.prototype.SetV=function(b){void 0===b&&a("undefined 'v' in b2Vec2.SetV"),this.x=b.x,this.y=b.y},b.Make=function(a,c){return void 0===a&&(a=0),void 0===c&&(c=0),new b(a,c)},void 0===b.Get&&(b.Get=b.Make,b._freeCache=[],b.Free=function(){}),b.prototype.Copy=function(){return new b(this.x,this.y)},b.prototype.Add=function(b){void 0===b&&a("undefined 'v' in b2Vec2.Add"),this.x+=b.x,this.y+=b.y},b.prototype.Subtract=function(b){void 0===b&&a("undefined 'v' in b2Vec2.Subtract"),this.x-=b.x,this.y-=b.y},b.prototype.Multiply=function(a){void 0===a&&(a=0),this.x*=a,this.y*=a},b.prototype.Length=function(){return Math.sqrt(this.x*this.x+this.y*this.y)},b.prototype.LengthSquared=function(){return this.x*this.x+this.y*this.y},b.prototype.Normalize=function(){var a=Math.sqrt(this.x*this.x+this.y*this.y);if(a<Number.MIN_VALUE)return 0;var b=1/a;return this.x*=b,this.y*=b,a},b.prototype.NegativeSelf=function(){this.x=-this.x,this.y=-this.y};var c=function(){this.col1=new b,this.col2=new b,this.SetIdentity()};window.Box2D.Common.Math.b2Mat22=c,c.FromAngle=function(a){void 0===a&&(a=0);var b=new c;return b.Set(a),b},c.FromVV=function(a,b){var d=new c;return d.SetVV(a,b),d},c.prototype.Set=function(a){void 0===a&&(a=0);var b=Math.cos(a),c=Math.sin(a);this.col1.x=b,this.col2.x=-c,this.col1.y=c,this.col2.y=b},c.prototype.SetVV=function(a,b){this.col1.SetV(a),this.col2.SetV(b)},c.prototype.Copy=function(){var a=new c;return a.SetM(this),a},c.prototype.SetM=function(a){this.col1.SetV(a.col1),this.col2.SetV(a.col2)},c.prototype.AddM=function(a){this.col1.x+=a.col1.x,this.col1.y+=a.col1.y,this.col2.x+=a.col2.x,this.col2.y+=a.col2.y},c.prototype.SetIdentity=function(){this.col1.x=1,this.col2.x=0,this.col1.y=0,this.col2.y=1},c.prototype.SetZero=function(){this.col1.x=0,this.col2.x=0,this.col1.y=0,this.col2.y=0},c.prototype.GetAngle=function(){return Math.atan2(this.col1.y,this.col1.x)},c.prototype.GetInverse=function(a){var b=this.col1.x,c=this.col2.x,d=this.col1.y,e=this.col2.y,f=b*e-c*d;return 0!==f&&(f=1/f),a.col1.x=f*e,a.col2.x=-f*c,a.col1.y=-f*d,a.col2.y=f*b,a},c.prototype.Solve=function(a,b,c){void 0===b&&(b=0),void 0===c&&(c=0);var d=this.col1.x,e=this.col2.x,f=this.col1.y,g=this.col2.y,h=d*g-e*f;return 0!==h&&(h=1/h),a.x=h*(g*b-e*c),a.y=h*(d*c-f*b),a},c.prototype.Abs=function(){this.col1.Abs(),this.col2.Abs()};var d=function(a,d){this.position=new b,this.R=new c,void 0===a&&(a=null),void 0===d&&(d=null),a&&(this.position.SetV(a),this.R.SetM(d))};window.Box2D.Common.Math.b2Transform=d,d.prototype.Initialize=function(a,b){this.position.SetV(a),this.R.SetM(b)},d.prototype.SetIdentity=function(){this.position.SetZero(),this.R.SetIdentity()},d.prototype.Set=function(a){this.position.SetV(a.position),this.R.SetM(a.R)},d.prototype.SetAngle=function(){return Math.atan2(this.R.col1.y,this.R.col1.x)};var e=function(){};window.Box2D.Common.Math.b2Math=e,e.IsValid=function(a){return void 0===a&&(a=0),isFinite(a)},e.Dot=function(a,b){return a.x*b.x+a.y*b.y},e.CrossVV=function(a,b){return a.x*b.y-a.y*b.x},e.CrossVF=function(a,c){void 0===c&&(c=0);var d=new b(c*a.y,-c*a.x);return d},e.CrossFV=function(a,c){void 0===a&&(a=0);var d=new b(-a*c.y,a*c.x);return d},e.MulMV=function(c,d){void 0===d&&a("undefined 'v' in b2Math.MulMV");var e=new b(c.col1.x*d.x+c.col2.x*d.y,c.col1.y*d.x+c.col2.y*d.y);return e},e.MulTMV=function(a,c){var d=new b(e.Dot(c,a.col1),e.Dot(c,a.col2));return d},e.MulX=function(a,b){var c=e.MulMV(a.R,b);return c.x+=a.position.x,c.y+=a.position.y,c},e.MulXT=function(a,b){var c=e.SubtractVV(b,a.position),d=c.x*a.R.col1.x+c.y*a.R.col1.y;return c.y=c.x*a.R.col2.x+c.y*a.R.col2.y,c.x=d,c},e.AddVV=function(a,c){var d=new b(a.x+c.x,a.y+c.y);return d},e.SubtractVV=function(a,c){var d=new b(a.x-c.x,a.y-c.y);return d},e.Distance=function(a,b){var c=a.x-b.x,d=a.y-b.y;return Math.sqrt(c*c+d*d)},e.DistanceSquared=function(a,b){var c=a.x-b.x,d=a.y-b.y;return c*c+d*d},e.MulFV=function(a,c){void 0===a&&(a=0);var d=new b(a*c.x,a*c.y);return d},e.AddMM=function(a,b){var d=c.FromVV(e.AddVV(a.col1,b.col1),e.AddVV(a.col2,b.col2));return d},e.MulMM=function(a,b){var d=c.FromVV(e.MulMV(a,b.col1),e.MulMV(a,b.col2));return d},e.MulTMM=function(a,d){var f=new b(e.Dot(a.col1,d.col1),e.Dot(a.col2,d.col1)),g=new b(e.Dot(a.col1,d.col2),e.Dot(a.col2,d.col2)),h=c.FromVV(f,g);return h},e.Abs=function(a){return void 0===a&&(a=0),a>0?a:-a},e.AbsV=function(a){var c=new b(e.Abs(a.x),e.Abs(a.y));return c},e.AbsM=function(a){var b=c.FromVV(e.AbsV(a.col1),e.AbsV(a.col2));return b},e.Min=function(a,b){return void 0===a&&(a=0),void 0===b&&(b=0),b>a?a:b},e.MinV=function(a,c){var d=new b(e.Min(a.x,c.x),e.Min(a.y,c.y));return d},e.Max=function(a,b){return void 0===a&&(a=0),void 0===b&&(b=0),a>b?a:b},e.MaxV=function(a,c){var d=new b(e.Max(a.x,c.x),e.Max(a.y,c.y));return d},e.Clamp=function(a,b,c){return void 0===a&&(a=0),void 0===b&&(b=0),void 0===c&&(c=0),b>a?b:a>c?c:a},e.ClampV=function(a,b,c){return e.MaxV(b,e.MinV(a,c))},e.Swap=function(a,b){var c=a[0];a[0]=b[0],b[0]=c},e.Random=function(){return 2*Math.random()-1},e.RandomRange=function(a,b){void 0===a&&(a=0),void 0===b&&(b=0);var c=Math.random();return c=(b-a)*c+a},e.NextPowerOfTwo=function(a){return void 0===a&&(a=0),a|=a>>1&2147483647,a|=a>>2&1073741823,a|=a>>4&268435455,a|=a>>8&16777215,a|=a>>16&65535,a+1},e.IsPowerOfTwo=function(a){void 0===a&&(a=0);var b=a>0&&0===(a&a-1);return b},e.b2Vec2_zero=new b(0,0),e.b2Mat22_identity=c.FromVV(new b(1,0),new b(0,1)),e.b2Transform_identity=new d(e.b2Vec2_zero,e.b2Mat22_identity);var f=function(){this.e_aabbBit=4,this.e_centerOfMassBit=16,this.e_controllerBit=32,this.e_jointBit=2,this.e_pairBit=8,this.e_shapeBit=0};window.Box2D.Dynamics.b2DebugDraw=f,f.prototype.AppendFlags=function(){},f.prototype.ClearFlags=function(){},f.prototype.DrawCircle=function(){},f.prototype.DrawPolygon=function(){},f.prototype.DrawSegment=function(){},f.prototype.DrawSolidCircle=function(){},f.prototype.DrawSolidPolygon=function(){},f.prototype.DrawTransform=function(){},f.prototype.GetAlpha=function(){},f.prototype.GetDrawScale=function(){},f.prototype.GetFillAlpha=function(){},f.prototype.GetFlags=function(){},f.prototype.GetLineThickness=function(){},f.prototype.GetSprite=function(){},f.prototype.GetXFormScale=function(){},f.prototype.SetAlpha=function(){},f.prototype.SetDrawScale=function(){},f.prototype.SetFillAlpha=function(){},f.prototype.SetFlags=function(){},f.prototype.SetLineThickness=function(){},f.prototype.SetSprite=function(){},f.prototype.SetXFormScale=function(){};var g=function(){this.position=new b(0,0),this.linearVelocity=new b,this.userData=null,this.angle=0,this.linearVelocity.Set(0,0),this.angularVelocity=0,this.linearDamping=0,this.angularDamping=0,this.allowSleep=!0,this.awake=!0,this.fixedRotation=!1,this.bullet=!1,this.type=i.b2_staticBody,this.active=!0,this.inertiaScale=1};window.Box2D.Dynamics.b2BodyDef=g;var h=function(a,c,d,e){this.m_body=a,this.m_userData=c,this.m_fixtureID=d,this.m_shape={},this.m_shape.m_centroid=new b,this.m_isSensor=!1,this.m_density=e.density,this.m_friction=e.friction,this.m_restitution=e.restitution,this.m_isSensor=e.isSensor};window.Box2D.Dynamics.b2Fixture=h,h.prototype.GetBody=function(){return this.m_body},h.prototype.GetShape=function(){return console.log("fixture.GetShape not yet supported in CocoonJS Box2D binding"),null},h.prototype.GetUserData=function(){return this.m_userData},h.prototype.SetSensor=function(a){this.m_isSensor=a,window.ext.IDTK_SRV_BOX2D.makeCall("setSensor",this.m_body.m_world.m_worldID,this.m_fixtureID,this.m_isSensor)},h.prototype.IsSensor=function(){return this.m_isSensor},h.prototype.SetDensity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setDensity",this.m_body.m_world.m_worldID,this.m_fixtureID,a),this.m_density=a},h.prototype.SetFriction=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFriction",this.m_body.m_world.m_worldID,this.m_fixtureID,a),this.m_friction=a},h.prototype.SetRestitution=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setRestitution",this.m_body.m_world.m_worldID,this.m_fixtureID,a),this.m_restitution=a},h.prototype.GetDensity=function(){return this.m_density},h.prototype.GetFriction=function(){return this.m_friction},h.prototype.GetRestitution=function(){return this.m_restitution};var i=function(a,b){var e=a.userData;a.userData=null,this.m_world=b,this.m_xf=new d(a.position,c.FromAngle(a.angle)),this.m_fixtures=[],this.m_active=a.active,a.type===i.b2_staticBody&&(a.density=0),this.m_bodyID=window.ext.IDTK_SRV_BOX2D.makeCall("createBody",b.m_worldID,a),this.m_userData=e,a.userData=e};window.Box2D.Dynamics.b2Body=i,i.prototype.CreateFixture=function(a){var b=a.userData;a.userData=null;var c=window.ext.IDTK_SRV_BOX2D.makeCall("createFixture",this.m_world.m_worldID,this.m_bodyID,a);a.userData=b;var d=new h(this,b,c,a);return this.m_world.m_fixturesList[c]=d,this.m_fixtures.push(d),d},i.prototype.GetFixtureList=function(){return 0===this.m_fixtures.length?null:this.m_fixtures[0]},i.prototype.DestroyFixture=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteFixture",this.m_world.m_worldID,a.m_fixtureID),delete this.m_world.m_fixturesList[a.m_fixtureID]},i.prototype.SetPositionAndAngle=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("setBodyTransform",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b),this.m_xf.R.Set(b),this.m_xf.position.SetV(a)},i.prototype.GetPosition=function(){return this.m_xf.position},i.prototype.SetPosition=function(a){this.SetPositionAndAngle(a,this.GetAngle())},i.prototype.GetLinearVelocity=function(){var a=window.ext.IDTK_SRV_BOX2D.makeCall("getLinearVelocity",this.m_world.m_worldID,this.m_bodyID);return new b(a[0],a[1])},i.prototype.GetWorldCenter=function(){var a=window.ext.IDTK_SRV_BOX2D.makeCall("getWorldCenter",this.m_world.m_worldID,this.m_bodyID);return new b(a[0],a[1])},i.prototype.GetLocalCenter=function(){var a=window.ext.IDTK_SRV_BOX2D.makeCall("getLocalCenter",this.m_world.m_worldID,this.m_bodyID);return new b(a[0],a[1])},i.prototype.GetLocalPoint=function(a){return e.MulXT(this.m_xf,a)},i.prototype.ApplyImpulse=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyImpulse",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)},i.prototype.GetMass=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getMass",this.m_world.m_worldID,this.m_bodyID)},i.prototype.IsAwake=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("isAwake",this.m_world.m_worldID,this.m_bodyID)},i.prototype.GetAngularVelocity=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getAngularVelocity",this.m_world.m_worldID,this.m_bodyID)},i.prototype.SetFixedRotation=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFixedRotation",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetAwake=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAwake",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetLinearVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearVelocity",this.m_world.m_worldID,this.m_bodyID,a.x,a.y)},i.prototype.ApplyForceToCenter=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyForceToCenter",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b)},i.prototype.ApplyForce=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyForce",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)},i.prototype.ApplyTorque=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyTorque",this.m_world.m_worldID,this.m_bodyID,a,b)},i.prototype.SetLinearDamping=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearDamping",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetAngularVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAngularVelocity",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetType=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setType",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetActive=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setActive",this.m_world.m_worldID,this.m_bodyID,a),this.m_active=a},i.prototype.IsActive=function(){return this.m_active},i.prototype.GetAngle=function(){return this.m_xf.R.GetAngle()},i.prototype.SetAngle=function(a){void 0===a&&(a=0),this.SetPositionAndAngle(this.GetPosition(),a)},i.prototype.GetContactList=function(){for(var a=window.ext.IDTK_SRV_BOX2D.makeCall("getObjectContacts",this.m_world.m_worldID,this.m_bodyID),b=[],c=0;c<a.length;c++)b.push(this.m_world.m_bodyList[a[c]]);return b},i.prototype.SetUserData=function(a){this.m_userData=a},i.prototype.GetUserData=function(){return this.m_userData},i.prototype.GetWorld=function(){return this.m_world},window.Box2D.Dynamics.b2Body.b2_staticBody=0,window.Box2D.Dynamics.b2Body.b2_kinematicBody=1,window.Box2D.Dynamics.b2Body.b2_dynamicBody=2;var j=function(a,b,c){this.m_fixtureA=a,this.m_fixtureB=b,this.m_touching=c};window.Box2D.Dynamics.b2Contact=j,j.prototype.GetFixtureA=function(){return this.m_fixtureA},j.prototype.GetFixtureB=function(){return this.m_fixtureB},j.prototype.IsTouching=function(){return this.m_touching};var k=function(){};window.Box2D.Dynamics.b2ContactListener=k,k.prototype.BeginContact=function(){},k.prototype.EndContact=function(){},k.prototype.PreSolve=function(){},k.prototype.PostSolve=function(){},window.Box2D.Dynamics.b2ContactListener.b2_defaultListener=new k;var l=function(){};window.Box2D.Dynamics.b2ContactFilter=l;var m=function(a,b){this.m_bodyList=[],this.m_jointList=[],this.m_fixturesList=[],this.m_contactListener=null,this.m_jointsList=[],this.m_worldID=window.ext.IDTK_SRV_BOX2D.makeCall("createWorld",a.x,a.y,b)};window.Box2D.Dynamics.b2World=m,m.prototype.SetContactListener=function(a){this.m_contactListener=a},m.prototype.SetContactFilter=function(a){var b=a,c=this,d=function(a,d){var e=c.m_fixturesList[a],f=c.m_fixturesList[d];return b.ShouldCollide(e,f)};window.ext.IDTK_SRV_BOX2D.makeCall("setContactFilter",this.m_worldID,d)},m.prototype.CreateBody=function(a){var b=new i(a,this);return this.m_bodyList[b.m_bodyID]=b,b},m.prototype.DestroyBody=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteBody",this.m_worldID,a.m_bodyID),delete this.m_bodyList[a.m_bodyID];for(var b=0;b<a.m_fixtures.length;++b)delete this.m_fixturesList[a.m_fixtures[b].m_fixtureID]},m.prototype.CreateJoint=function(a){if(a.bodyA.m_bodyID!==a.bodyB.m_bodyID){var b=a.bodyA,c=a.bodyB;a.bodyA=b.m_bodyID,a.bodyB=c.m_bodyID;var d="createDistanceJoint";a.type===o.e_revoluteJoint&&(d="createRevoluteJoint");var e=new o(a);return e.m_jointID=window.ext.IDTK_SRV_BOX2D.makeCall(d,this.m_worldID,a),a.bodyA=b,a.bodyB=c,this.m_jointsList.push(e),e}},m.prototype.DestroyJoint=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("destroyJoint",this.m_worldID,a.m_jointID)},m.prototype.GetJointList=function(){if(0===this.m_jointsList.length)return null;for(var a=0;a<this.m_jointsList.length-1;++a)this.m_jointsList[a].next=this.m_jointsList[a+1];return this.m_jointsList[this.m_jointsList.length-1].next=null,this.m_jointsList[0]},m.prototype.SetContinuousPhysics=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setContinuous",this.m_worldID,a)},m.prototype.SetGravity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setGravity",this.m_worldID,a.x,a.y)},m.prototype.Step=function(a,b,c){var d,e=window.ext.IDTK_SRV_BOX2D.makeCall("step",this.m_worldID,a,b,c),f=e[0];for(d=1;4*f>=d;d+=4){var g=this.m_bodyList[e[d+0]];if(null===g)break;g.m_xf.position.Set(e[d+1],e[d+2]),g.m_xf.R.Set(e[d+3])}if(null!==this.m_contactListener){var h=window.ext.IDTK_SRV_BOX2D.makeCall("getLastContacts",this.m_worldID);for(f=h[0],d=1;3*f>=d;d+=3){var i=h[d+0],k=h[d+1],l=h[d+2],m=this.m_fixturesList[i],n=this.m_fixturesList[k];"undefined"!=typeof m&&"undefined"!=typeof n?this.m_contactListener.BeginContact(new j(m,n,l)):console.log("One of the fixtures in a contact DOESN'T EXIST!!")}}},m.prototype.ClearForces=function(){window.ext.IDTK_SRV_BOX2D.makeCall("clearForces",this.m_worldID)},m.prototype.SetDebugDraw=function(){},m.prototype.DrawDebugData=function(){},window.Box2D.Collision.Shapes.b2CircleShape=function(a){this.radius=a,this.type="circle"},window.Box2D.Collision.Shapes.b2PolygonShape=function(){this.SetAsBox=function(a,b){this.type="box",this.width=a,this.height=b},this.SetAsEdge=function(a,b){this.type="edge",this.p1x=a.x,this.p1y=a.y,this.p2x=b.x,this.p2y=b.y},this.SetAsArray=function(a,b){this.type="polygon",this.vertices=[];for(var c=0;b>c;c++)this.vertices.push(a[c].x),this.vertices.push(a[c].y)}};var n=function(){this.shape=null,this.userData=null,this.friction=.2,this.restitution=0,this.density=0,this.isSensor=!1,this.filter={categoryBits:1,maskBits:65535,groupIndex:0}};window.Box2D.Dynamics.b2FixtureDef=n;var o=function(a){this.bodyA=a.bodyA,this.bodyB=a.bodyB,this.userData=a.userData,this.type=a.type,this.next=null};window.Box2D.Dynamics.Joints.b2Joint=o,o.prototype.GetBodyA=function(){return this.bodyA},o.prototype.GetBodyB=function(){return this.bodyB},o.prototype.GetUserData=function(){return this.userData},o.prototype.GetType=function(){return this.type},o.prototype.GetNext=function(){return this.next},o.e_distanceJoint=0,o.e_revoluteJoint=1;var p=function(a,c,d,e){if(this.type=o.e_distanceJoint,this.localAnchorA=new b,this.localAnchorB=new b,this.userData=null,void 0!==a&&(this.bodyA=a),void 0!==c&&(this.bodyB=c),void 0!==d&&this.localAnchorA.SetV(d),void 0!==e&&this.localAnchorB.SetV(e),void 0!==d&&void 0!==e){var f=e.x-d.x,g=e.y-d.y;this.length=Math.sqrt(f*f+g*g)}this.frequencyHz=0,this.dampingRatio=0};window.Box2D.Dynamics.Joints.b2DistanceJointDef=p;var q=function(a,c,d,e){this.type=o.e_revoluteJoint,this.localAnchorA=new b,this.localAnchorB=new b,this.userData=null,void 0!==a&&(this.bodyA=a),void 0!==c&&(this.bodyB=c),void 0!==d&&this.localAnchorA.SetV(d),void 0!==e&&this.localAnchorB.SetV(e),this.referenceAngle=0,this.lowerAngle=0,this.upperAngle=0,this.maxMotorTorque=0,this.motorSpeed=0,this.enableLimit=!1,this.enableMotor=!1};q.prototype.Initialize=function(a,b,c){this.bodyA=a,this.bodyB=b,this.localAnchorA=this.bodyA.GetLocalPoint(c),this.localAnchorB=this.bodyB.GetLocalPoint(c),this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()},window.Box2D.Dynamics.Joints.b2RevoluteJointDef=q}()):console.log("The CocoonJS binding for Box2D has been ignored because ext.IDTK_SRV_BOX2D is not available");
(function() {
'use strict';var cr={plugins_:{},behaviors:{}};"function"!==typeof Object.getPrototypeOf&&(Object.getPrototypeOf="object"===typeof"test".__proto__?function(a){return a.__proto__}:function(a){return a.constructor.prototype});
(function(){function a(h,k){this.x=h;this.y=k;cr.seal(this)}function b(h,k,r,a){this.set(h,k,r,a);cr.seal(this)}function e(){this.bly=this.blx=this.bry=this.brx=this.try_=this.trx=this.tly=this.tlx=0;cr.seal(this)}function l(h,k,r,a){h<k?r<a?(u=h<r?h:r,s=k>a?k:a):(u=h<a?h:a,s=k>r?k:r):r<a?(u=k<r?k:r,s=h>a?h:a):(u=k<a?k:a,s=h>r?h:r)}function g(){this.items=this.s=null;this.item_count=0;t&&(this.s=new Set);this.values_cache=[];this.cache_valid=!0;cr.seal(this)}function m(h){w[r++]=h}function c(){this.sum=
this.t=this.y=this.c=0;cr.seal(this)}function p(h){this.pts_cache=[];this.bboxBottom=this.bboxRight=this.bboxTop=this.bboxLeft=0;this.convexpolys=null;this.set_pts(h);cr.seal(this)}function f(h,k){this.cellwidth=h;this.cellheight=k;this.cells={}}function n(h,k,r){var a;f.prototype.totalCellCount++;return x.length?(a=x.pop(),a.grid=h,a.x=k,a.y=r,a):new cr.GridCell(h,k,r)}function d(h,k,r){this.grid=h;this.x=k;this.y=r;this.objects=new cr.ObjectSet}cr.logexport=function(h){window.console&&window.console.log&&
window.console.log(h)};cr.seal=function(h){return h};cr.freeze=function(h){return h};cr.is_undefined=function(h){return"undefined"===typeof h};cr.is_number=function(h){return"number"===typeof h};cr.is_string=function(h){return"string"===typeof h};cr.isPOT=function(h){return 0<h&&0===(h-1&h)};cr.nextHighestPowerOfTwo=function(h){--h;for(var k=1;32>k;k<<=1)h|=h>>k;return h+1};cr.abs=function(h){return 0>h?-h:h};cr.max=function(h,k){return h>k?h:k};cr.min=function(h,k){return h<k?h:k};cr.PI=Math.PI;
cr.round=function(h){return h+0.5|0};cr.floor=function(h){return 0<=h?h|0:(h|0)-1};cr.ceil=function(h){var k=h|0;return k===h?k:k+1};a.prototype.offset=function(h,k){this.x+=h;this.y+=k;return this};a.prototype.mul=function(h,k){this.x*=h;this.y*=k;return this};cr.vector2=a;cr.segments_intersect=function(h,k,r,a,m,c,x,b){var d,f,g,n;h<r?(f=h,d=r):(f=r,d=h);m<x?(n=m,g=x):(n=x,g=m);if(d<n||f>g)return!1;k<a?(f=k,d=a):(f=a,d=k);c<b?(n=c,g=b):(n=b,g=c);if(d<n||f>g)return!1;d=m-h+x-r;f=c-k+b-a;h=r-h;k=
a-k;m=x-m;c=b-c;b=cr.abs(k*m-c*h);return cr.abs(m*f-c*d)>b?!1:cr.abs(h*f-k*d)<=b};b.prototype.set=function(h,k,r,a){this.left=h;this.top=k;this.right=r;this.bottom=a};b.prototype.copy=function(h){this.left=h.left;this.top=h.top;this.right=h.right;this.bottom=h.bottom};b.prototype.width=function(){return this.right-this.left};b.prototype.height=function(){return this.bottom-this.top};b.prototype.offset=function(h,k){this.left+=h;this.top+=k;this.right+=h;this.bottom+=k;return this};b.prototype.normalize=
function(){var h=0;this.left>this.right&&(h=this.left,this.left=this.right,this.right=h);this.top>this.bottom&&(h=this.top,this.top=this.bottom,this.bottom=h)};b.prototype.intersects_rect=function(h){return!(h.right<this.left||h.bottom<this.top||h.left>this.right||h.top>this.bottom)};b.prototype.intersects_rect_off=function(h,k,r){return!(h.right+k<this.left||h.bottom+r<this.top||h.left+k>this.right||h.top+r>this.bottom)};b.prototype.contains_pt=function(h,k){return h>=this.left&&h<=this.right&&k>=
this.top&&k<=this.bottom};b.prototype.equals=function(h){return this.left===h.left&&this.top===h.top&&this.right===h.right&&this.bottom===h.bottom};cr.rect=b;e.prototype.set_from_rect=function(h){this.tlx=h.left;this.tly=h.top;this.trx=h.right;this.try_=h.top;this.brx=h.right;this.bry=h.bottom;this.blx=h.left;this.bly=h.bottom};e.prototype.set_from_rotated_rect=function(h,k){if(0===k)this.set_from_rect(h);else{var r=Math.sin(k),a=Math.cos(k),m=h.left*r,c=h.top*r,x=h.right*r,r=h.bottom*r,b=h.left*
a,d=h.top*a,f=h.right*a,a=h.bottom*a;this.tlx=b-c;this.tly=d+m;this.trx=f-c;this.try_=d+x;this.brx=f-r;this.bry=a+x;this.blx=b-r;this.bly=a+m}};e.prototype.offset=function(h,k){this.tlx+=h;this.tly+=k;this.trx+=h;this.try_+=k;this.brx+=h;this.bry+=k;this.blx+=h;this.bly+=k;return this};var u=0,s=0;e.prototype.bounding_box=function(h){l(this.tlx,this.trx,this.brx,this.blx);h.left=u;h.right=s;l(this.tly,this.try_,this.bry,this.bly);h.top=u;h.bottom=s};e.prototype.contains_pt=function(h,k){var r=this.trx-
this.tlx,a=this.try_-this.tly,m=this.brx-this.tlx,c=this.bry-this.tly,x=h-this.tlx,b=k-this.tly,d=r*r+a*a,f=r*m+a*c,a=r*x+a*b,g=m*m+c*c,n=m*x+c*b,p=1/(d*g-f*f),r=(g*a-f*n)*p,d=(d*n-f*a)*p;if(0<=r&&0<d&&1>r+d)return!0;r=this.blx-this.tlx;a=this.bly-this.tly;d=r*r+a*a;f=r*m+a*c;a=r*x+a*b;p=1/(d*g-f*f);r=(g*a-f*n)*p;d=(d*n-f*a)*p;return 0<=r&&0<d&&1>r+d};e.prototype.at=function(h,k){if(k)switch(h){case 0:return this.tlx;case 1:return this.trx;case 2:return this.brx;case 3:return this.blx;case 4:return this.tlx;
default:return this.tlx}else switch(h){case 0:return this.tly;case 1:return this.try_;case 2:return this.bry;case 3:return this.bly;case 4:return this.tly;default:return this.tly}};e.prototype.midX=function(){return(this.tlx+this.trx+this.brx+this.blx)/4};e.prototype.midY=function(){return(this.tly+this.try_+this.bry+this.bly)/4};e.prototype.intersects_segment=function(h,k,r,a){if(this.contains_pt(h,k)||this.contains_pt(r,a))return!0;var m,c,x,b,d;for(d=0;4>d;d++)if(m=this.at(d,!0),c=this.at(d,!1),
x=this.at(d+1,!0),b=this.at(d+1,!1),cr.segments_intersect(h,k,r,a,m,c,x,b))return!0;return!1};e.prototype.intersects_quad=function(h){var k=h.midX(),r=h.midY();if(this.contains_pt(k,r))return!0;k=this.midX();r=this.midY();if(h.contains_pt(k,r))return!0;var a,m,c,x,d,b,f,g;for(f=0;4>f;f++)for(g=0;4>g;g++)if(k=this.at(f,!0),r=this.at(f,!1),a=this.at(f+1,!0),m=this.at(f+1,!1),c=h.at(g,!0),x=h.at(g,!1),d=h.at(g+1,!0),b=h.at(g+1,!1),cr.segments_intersect(k,r,a,m,c,x,d,b))return!0;return!1};cr.quad=e;cr.RGB=
function(h,k,r){return Math.max(Math.min(h,255),0)|Math.max(Math.min(k,255),0)<<8|Math.max(Math.min(r,255),0)<<16};cr.GetRValue=function(h){return h&255};cr.GetGValue=function(h){return(h&65280)>>8};cr.GetBValue=function(h){return(h&16711680)>>16};cr.shallowCopy=function(h,k,r){for(var a in k)k.hasOwnProperty(a)&&(h[a]=k[a]);return h};cr.arrayRemove=function(h,k){var r,a;k=cr.floor(k);if(!(0>k||k>=h.length))if(0===k)h.shift();else if(k===h.length-1)h.pop();else{r=k;for(a=h.length-1;r<a;r++)h[r]=h[r+
1];h.length=a}};cr.shallowAssignArray=function(h,k){h.length=k.length;var r,a;r=0;for(a=k.length;r<a;r++)h[r]=k[r]};cr.appendArray=function(h,k){h.push.apply(h,k)};cr.arrayFindRemove=function(h,k){var r=h.indexOf(k);-1!==r&&cr.arrayRemove(h,r)};cr.clamp=function(h,k,r){return h<k?k:h>r?r:h};cr.to_radians=function(h){return h/(180/cr.PI)};cr.to_degrees=function(h){return h*(180/cr.PI)};cr.clamp_angle_degrees=function(h){h%=360;0>h&&(h+=360);return h};cr.clamp_angle=function(h){h%=2*cr.PI;0>h&&(h+=
2*cr.PI);return h};cr.to_clamped_degrees=function(h){return cr.clamp_angle_degrees(cr.to_degrees(h))};cr.to_clamped_radians=function(h){return cr.clamp_angle(cr.to_radians(h))};cr.angleTo=function(h,k,r,a){return Math.atan2(a-k,r-h)};cr.angleDiff=function(h,k){if(h===k)return 0;var r=Math.sin(h),a=Math.cos(h),m=Math.sin(k),c=Math.cos(k),r=r*m+a*c;return 1<=r?0:-1>=r?cr.PI:Math.acos(r)};cr.angleRotate=function(h,k,r){var a=Math.sin(h),m=Math.cos(h),c=Math.sin(k),x=Math.cos(k);return Math.acos(a*c+
m*x)>r?0<m*c-a*x?cr.clamp_angle(h+r):cr.clamp_angle(h-r):cr.clamp_angle(k)};cr.angleClockwise=function(h,k){var r=Math.sin(h),a=Math.cos(h),m=Math.sin(k),c=Math.cos(k);return 0>=a*m-r*c};cr.rotatePtAround=function(h,k,r,a,m,c){if(0===r)return c?h:k;var x=Math.sin(r);r=Math.cos(r);h-=a;k-=m;var d=h*x;h=h*r-k*x;k=k*r+d;return c?h+a:k+m};cr.distanceTo=function(h,k,r,a){h=r-h;k=a-k;return Math.sqrt(h*h+k*k)};cr.xor=function(h,k){return!h!==!k};cr.lerp=function(h,k,r){return h+(k-h)*r};cr.unlerp=function(h,
k,r){return h===k?0:(r-h)/(k-h)};cr.anglelerp=function(h,k,r){var a=cr.angleDiff(h,k);return cr.angleClockwise(k,h)?h+a*r:h-a*r};cr.hasAnyOwnProperty=function(h){for(var k in h)if(h.hasOwnProperty(k))return!0;return!1};cr.wipe=function(h){for(var k in h)h.hasOwnProperty(k)&&delete h[k]};var q=+new Date;cr.performance_now=function(){if("undefined"!==typeof window.performance){var h=window.performance;if("undefined"!==typeof h.now)return h.now();if("undefined"!==typeof h.webkitNow)return h.webkitNow();
if("undefined"!==typeof h.mozNow)return h.mozNow();if("undefined"!==typeof h.msNow)return h.msNow()}return Date.now()-q};var t=("undefined"===typeof window||!window.c2ejecta)&&"undefined"!==typeof Set&&"undefined"!==typeof Set.prototype.forEach;g.prototype.contains=function(h){return this.isEmpty()?!1:t?this.s.has(h):this.items&&this.items.hasOwnProperty(h)};g.prototype.add=function(h){if(t)this.s.has(h)||(this.s.add(h),this.cache_valid=!1);else{var k=h.toString(),r=this.items;r?r.hasOwnProperty(k)||
(r[k]=h,this.item_count++,this.cache_valid=!1):(this.items={},this.items[k]=h,this.item_count=1,this.cache_valid=!1)}};g.prototype.remove=function(h){if(!this.isEmpty())if(t)this.s.has(h)&&(this.s["delete"](h),this.cache_valid=!1);else if(this.items){h=h.toString();var k=this.items;k.hasOwnProperty(h)&&(delete k[h],this.item_count--,this.cache_valid=!1)}};g.prototype.clear=function(){this.isEmpty()||(t?this.s.clear():(this.items=null,this.item_count=0),this.values_cache.length=0,this.cache_valid=
!0)};g.prototype.isEmpty=function(){return 0===this.count()};g.prototype.count=function(){return t?this.s.size:this.item_count};var w=null,r=0;g.prototype.update_cache=function(){if(!this.cache_valid){if(t)this.values_cache.length=this.s.size,w=this.values_cache,r=0,this.s.forEach(m),w=null,r=0;else{var h=this.values_cache;h.length=this.item_count;var k,a=0,c=this.items;if(c)for(k in c)c.hasOwnProperty(k)&&(h[a++]=c[k])}this.cache_valid=!0}};g.prototype.valuesRef=function(){this.update_cache();return this.values_cache};
cr.ObjectSet=g;c.prototype.add=function(h){this.y=h-this.c;this.t=this.sum+this.y;this.c=this.t-this.sum-this.y;this.sum=this.t};c.prototype.reset=function(){this.sum=this.t=this.y=this.c=0};cr.KahanAdder=c;cr.regexp_escape=function(h){return h.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")};p.prototype.set_pts=function(h){this.pts_array=h;this.pts_count=h.length/2;this.pts_cache.length=h.length;this.cache_height=this.cache_width=-1;this.cache_angle=0};p.prototype.is_empty=function(){return!this.pts_array.length};
p.prototype.update_bbox=function(){for(var h=this.pts_cache,k=h[0],r=k,a=h[1],m=a,c,x,d=1,b=this.pts_count;d<b;++d)x=2*d,c=h[x],x=h[x+1],c<k&&(k=c),c>r&&(r=c),x<a&&(a=x),x>m&&(m=x);this.bboxLeft=k;this.bboxRight=r;this.bboxTop=a;this.bboxBottom=m};p.prototype.set_from_rect=function(h,k,r){this.pts_cache.length=8;this.pts_count=4;var a=this.pts_cache;a[0]=h.left-k;a[1]=h.top-r;a[2]=h.right-k;a[3]=h.top-r;a[4]=h.right-k;a[5]=h.bottom-r;a[6]=h.left-k;a[7]=h.bottom-r;this.cache_width=h.right-h.left;this.cache_height=
h.bottom-h.top;this.update_bbox()};p.prototype.set_from_quad=function(h,k,r,a,m){this.pts_cache.length=8;this.pts_count=4;var c=this.pts_cache;c[0]=h.tlx-k;c[1]=h.tly-r;c[2]=h.trx-k;c[3]=h.try_-r;c[4]=h.brx-k;c[5]=h.bry-r;c[6]=h.blx-k;c[7]=h.bly-r;this.cache_width=a;this.cache_height=m;this.update_bbox()};p.prototype.set_from_poly=function(h){this.pts_count=h.pts_count;cr.shallowAssignArray(this.pts_cache,h.pts_cache);this.bboxLeft=h.bboxLeft;this.bboxTop-h.bboxTop;this.bboxRight=h.bboxRight;this.bboxBottom=
h.bboxBottom};p.prototype.cache_poly=function(h,k,r){if(this.cache_width!==h||this.cache_height!==k||this.cache_angle!==r){this.cache_width=h;this.cache_height=k;this.cache_angle=r;var a,m,c,x,d,b=0,f=1,g=this.pts_array,n=this.pts_cache;0!==r&&(b=Math.sin(r),f=Math.cos(r));r=0;for(c=this.pts_count;r<c;r++)a=2*r,m=a+1,x=g[a]*h,d=g[m]*k,n[a]=x*f-d*b,n[m]=d*f+x*b;this.update_bbox()}};p.prototype.contains_pt=function(h,k){var r=this.pts_cache;if(h===r[0]&&k===r[1])return!0;var a,m,c,x=this.pts_count,
d=this.bboxLeft-110,b=this.bboxTop-101,f=this.bboxRight+131,g=this.bboxBottom+120,n,p,z=0,q=0;for(a=0;a<x;a++)m=2*a,c=2*((a+1)%x),n=r[m],m=r[m+1],p=r[c],c=r[c+1],cr.segments_intersect(d,b,h,k,n,m,p,c)&&z++,cr.segments_intersect(f,g,h,k,n,m,p,c)&&q++;return 1===z%2||1===q%2};p.prototype.intersects_poly=function(h,k,r){var a=h.pts_cache,m=this.pts_cache;if(this.contains_pt(a[0]+k,a[1]+r)||h.contains_pt(m[0]-k,m[1]-r))return!0;var c,x,d,b,f,g,n,p,z,q,e,u;c=0;for(b=this.pts_count;c<b;c++)for(x=2*c,d=
2*((c+1)%b),p=m[x],x=m[x+1],z=m[d],q=m[d+1],d=0,n=h.pts_count;d<n;d++)if(f=2*d,g=2*((d+1)%n),e=a[f]+k,f=a[f+1]+r,u=a[g]+k,g=a[g+1]+r,cr.segments_intersect(p,x,z,q,e,f,u,g))return!0;return!1};p.prototype.intersects_segment=function(h,k,r,a,m,c){var x=this.pts_cache;if(this.contains_pt(r-h,a-k))return!0;var d,b,f,g,n,p;d=0;for(b=this.pts_count;d<b;d++)if(f=2*d,g=2*((d+1)%b),n=x[f]+h,f=x[f+1]+k,p=x[g]+h,g=x[g+1]+k,cr.segments_intersect(r,a,m,c,n,f,p,g))return!0;return!1};p.prototype.mirror=function(h){var k,
r,a;k=0;for(r=this.pts_count;k<r;++k)a=2*k,this.pts_cache[a]=2*h-this.pts_cache[a]};p.prototype.flip=function(h){var k,r,a;k=0;for(r=this.pts_count;k<r;++k)a=2*k+1,this.pts_cache[a]=2*h-this.pts_cache[a]};p.prototype.diag=function(){var h,k,r,a,m;h=0;for(k=this.pts_count;h<k;++h)r=2*h,a=r+1,m=this.pts_cache[r],this.pts_cache[r]=this.pts_cache[a],this.pts_cache[a]=m};cr.CollisionPoly=p;f.prototype.totalCellCount=0;f.prototype.getCell=function(h,k,r){var a;a=this.cells[h];return a?(a=a[k])?a:r?(a=n(this,
h,k),this.cells[h][k]=a):null:r?(a=n(this,h,k),this.cells[h]={},this.cells[h][k]=a):null};f.prototype.XToCell=function(h){return cr.floor(h/this.cellwidth)};f.prototype.YToCell=function(h){return cr.floor(h/this.cellheight)};f.prototype.update=function(h,k,r){var a,m,c,d,b;if(k)for(a=k.left,m=k.right;a<=m;++a)for(c=k.top,d=k.bottom;c<=d;++c)if(!r||!r.contains_pt(a,c))if(b=this.getCell(a,c,!1))b.remove(h),b.isEmpty()&&(f.prototype.totalCellCount--,b.objects.clear(),1E3>x.length&&x.push(b),this.cells[a][c]=
null);if(r)for(a=r.left,m=r.right;a<=m;++a)for(c=r.top,d=r.bottom;c<=d;++c)k&&k.contains_pt(a,c)||this.getCell(a,c,!0).insert(h)};f.prototype.queryRange=function(h,k){var r,a,m,c,x,d;r=this.XToCell(h.left);m=this.YToCell(h.top);a=this.XToCell(h.right);for(x=this.YToCell(h.bottom);r<=a;++r)for(c=m;c<=x;++c)(d=this.getCell(r,c,!1))&&d.dump(k)};cr.SparseGrid=f;var x=[];d.prototype.isEmpty=function(){return this.objects.isEmpty()};d.prototype.insert=function(h){this.objects.add(h)};d.prototype.remove=
function(h){this.objects.remove(h)};d.prototype.dump=function(h){cr.appendArray(h,this.objects.valuesRef())};cr.GridCell=d;var z="lighter xor copy destination-over source-in destination-in source-out destination-out source-atop destination-atop".split(" ");cr.effectToCompositeOp=function(h){return 0>=h||11<=h?"source-over":z[h-1]};cr.setGLBlend=function(h,k,r){if(r)switch(h.srcBlend=r.ONE,h.destBlend=r.ONE_MINUS_SRC_ALPHA,k){case 1:h.srcBlend=r.ONE;h.destBlend=r.ONE;break;case 3:h.srcBlend=r.ONE;
h.destBlend=r.ZERO;break;case 4:h.srcBlend=r.ONE_MINUS_DST_ALPHA;h.destBlend=r.ONE;break;case 5:h.srcBlend=r.DST_ALPHA;h.destBlend=r.ZERO;break;case 6:h.srcBlend=r.ZERO;h.destBlend=r.SRC_ALPHA;break;case 7:h.srcBlend=r.ONE_MINUS_DST_ALPHA;h.destBlend=r.ZERO;break;case 8:h.srcBlend=r.ZERO;h.destBlend=r.ONE_MINUS_SRC_ALPHA;break;case 9:h.srcBlend=r.DST_ALPHA;h.destBlend=r.ONE_MINUS_SRC_ALPHA;break;case 10:h.srcBlend=r.ONE_MINUS_DST_ALPHA,h.destBlend=r.SRC_ALPHA}};cr.round6dp=function(r){return cr.round(1E6*
r)/1E6};cr.equals_nocase=function(r,k){return"string"!==typeof r||"string"!==typeof k||r.length!==k.length?!1:r===k?!0:r.toLowerCase()===k.toLowerCase()}})();var MatrixArray="undefined"!==typeof Float32Array?Float32Array:Array,glMatrixArrayType=MatrixArray,vec3={},mat3={},mat4={},quat4={};vec3.create=function(a){var b=new MatrixArray(3);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2]);return b};vec3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];return b};
vec3.add=function(a,b,e){if(!e||a===e)return a[0]+=b[0],a[1]+=b[1],a[2]+=b[2],a;e[0]=a[0]+b[0];e[1]=a[1]+b[1];e[2]=a[2]+b[2];return e};vec3.subtract=function(a,b,e){if(!e||a===e)return a[0]-=b[0],a[1]-=b[1],a[2]-=b[2],a;e[0]=a[0]-b[0];e[1]=a[1]-b[1];e[2]=a[2]-b[2];return e};vec3.negate=function(a,b){b||(b=a);b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];return b};vec3.scale=function(a,b,e){if(!e||a===e)return a[0]*=b,a[1]*=b,a[2]*=b,a;e[0]=a[0]*b;e[1]=a[1]*b;e[2]=a[2]*b;return e};
vec3.normalize=function(a,b){b||(b=a);var e=a[0],l=a[1],g=a[2],m=Math.sqrt(e*e+l*l+g*g);if(m){if(1===m)return b[0]=e,b[1]=l,b[2]=g,b}else return b[0]=0,b[1]=0,b[2]=0,b;m=1/m;b[0]=e*m;b[1]=l*m;b[2]=g*m;return b};vec3.cross=function(a,b,e){e||(e=a);var l=a[0],g=a[1];a=a[2];var m=b[0],c=b[1];b=b[2];e[0]=g*b-a*c;e[1]=a*m-l*b;e[2]=l*c-g*m;return e};vec3.length=function(a){var b=a[0],e=a[1];a=a[2];return Math.sqrt(b*b+e*e+a*a)};vec3.dot=function(a,b){return a[0]*b[0]+a[1]*b[1]+a[2]*b[2]};
vec3.direction=function(a,b,e){e||(e=a);var l=a[0]-b[0],g=a[1]-b[1];a=a[2]-b[2];b=Math.sqrt(l*l+g*g+a*a);if(!b)return e[0]=0,e[1]=0,e[2]=0,e;b=1/b;e[0]=l*b;e[1]=g*b;e[2]=a*b;return e};vec3.lerp=function(a,b,e,l){l||(l=a);l[0]=a[0]+e*(b[0]-a[0]);l[1]=a[1]+e*(b[1]-a[1]);l[2]=a[2]+e*(b[2]-a[2]);return l};vec3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+"]"};
mat3.create=function(a){var b=new MatrixArray(9);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8]);return b};mat3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];return b};mat3.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=1;a[5]=0;a[6]=0;a[7]=0;a[8]=1;return a};
mat3.transpose=function(a,b){if(!b||a===b){var e=a[1],l=a[2],g=a[5];a[1]=a[3];a[2]=a[6];a[3]=e;a[5]=a[7];a[6]=l;a[7]=g;return a}b[0]=a[0];b[1]=a[3];b[2]=a[6];b[3]=a[1];b[4]=a[4];b[5]=a[7];b[6]=a[2];b[7]=a[5];b[8]=a[8];return b};mat3.toMat4=function(a,b){b||(b=mat4.create());b[15]=1;b[14]=0;b[13]=0;b[12]=0;b[11]=0;b[10]=a[8];b[9]=a[7];b[8]=a[6];b[7]=0;b[6]=a[5];b[5]=a[4];b[4]=a[3];b[3]=0;b[2]=a[2];b[1]=a[1];b[0]=a[0];return b};
mat3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+"]"};mat4.create=function(a){var b=new MatrixArray(16);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8],b[9]=a[9],b[10]=a[10],b[11]=a[11],b[12]=a[12],b[13]=a[13],b[14]=a[14],b[15]=a[15]);return b};
mat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=a[12];b[13]=a[13];b[14]=a[14];b[15]=a[15];return b};mat4.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=0;a[5]=1;a[6]=0;a[7]=0;a[8]=0;a[9]=0;a[10]=1;a[11]=0;a[12]=0;a[13]=0;a[14]=0;a[15]=1;return a};
mat4.transpose=function(a,b){if(!b||a===b){var e=a[1],l=a[2],g=a[3],m=a[6],c=a[7],p=a[11];a[1]=a[4];a[2]=a[8];a[3]=a[12];a[4]=e;a[6]=a[9];a[7]=a[13];a[8]=l;a[9]=m;a[11]=a[14];a[12]=g;a[13]=c;a[14]=p;return a}b[0]=a[0];b[1]=a[4];b[2]=a[8];b[3]=a[12];b[4]=a[1];b[5]=a[5];b[6]=a[9];b[7]=a[13];b[8]=a[2];b[9]=a[6];b[10]=a[10];b[11]=a[14];b[12]=a[3];b[13]=a[7];b[14]=a[11];b[15]=a[15];return b};
mat4.determinant=function(a){var b=a[0],e=a[1],l=a[2],g=a[3],m=a[4],c=a[5],p=a[6],f=a[7],n=a[8],d=a[9],u=a[10],s=a[11],q=a[12],t=a[13],w=a[14];a=a[15];return q*d*p*g-n*t*p*g-q*c*u*g+m*t*u*g+n*c*w*g-m*d*w*g-q*d*l*f+n*t*l*f+q*e*u*f-b*t*u*f-n*e*w*f+b*d*w*f+q*c*l*s-m*t*l*s-q*e*p*s+b*t*p*s+m*e*w*s-b*c*w*s-n*c*l*a+m*d*l*a+n*e*p*a-b*d*p*a-m*e*u*a+b*c*u*a};
mat4.inverse=function(a,b){b||(b=a);var e=a[0],l=a[1],g=a[2],m=a[3],c=a[4],p=a[5],f=a[6],n=a[7],d=a[8],u=a[9],s=a[10],q=a[11],t=a[12],w=a[13],r=a[14],x=a[15],z=e*p-l*c,h=e*f-g*c,k=e*n-m*c,y=l*f-g*p,v=l*n-m*p,H=g*n-m*f,A=d*w-u*t,E=d*r-s*t,B=d*x-q*t,C=u*r-s*w,L=u*x-q*w,D=s*x-q*r,G=1/(z*D-h*L+k*C+y*B-v*E+H*A);b[0]=(p*D-f*L+n*C)*G;b[1]=(-l*D+g*L-m*C)*G;b[2]=(w*H-r*v+x*y)*G;b[3]=(-u*H+s*v-q*y)*G;b[4]=(-c*D+f*B-n*E)*G;b[5]=(e*D-g*B+m*E)*G;b[6]=(-t*H+r*k-x*h)*G;b[7]=(d*H-s*k+q*h)*G;b[8]=(c*L-p*B+n*A)*G;
b[9]=(-e*L+l*B-m*A)*G;b[10]=(t*v-w*k+x*z)*G;b[11]=(-d*v+u*k-q*z)*G;b[12]=(-c*C+p*E-f*A)*G;b[13]=(e*C-l*E+g*A)*G;b[14]=(-t*y+w*h-r*z)*G;b[15]=(d*y-u*h+s*z)*G;return b};mat4.toRotationMat=function(a,b){b||(b=mat4.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
mat4.toMat3=function(a,b){b||(b=mat3.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[4];b[4]=a[5];b[5]=a[6];b[6]=a[8];b[7]=a[9];b[8]=a[10];return b};mat4.toInverseMat3=function(a,b){var e=a[0],l=a[1],g=a[2],m=a[4],c=a[5],p=a[6],f=a[8],n=a[9],d=a[10],u=d*c-p*n,s=-d*m+p*f,q=n*m-c*f,t=e*u+l*s+g*q;if(!t)return null;t=1/t;b||(b=mat3.create());b[0]=u*t;b[1]=(-d*l+g*n)*t;b[2]=(p*l-g*c)*t;b[3]=s*t;b[4]=(d*e-g*f)*t;b[5]=(-p*e+g*m)*t;b[6]=q*t;b[7]=(-n*e+l*f)*t;b[8]=(c*e-l*m)*t;return b};
mat4.multiply=function(a,b,e){e||(e=a);var l=a[0],g=a[1],m=a[2],c=a[3],p=a[4],f=a[5],n=a[6],d=a[7],u=a[8],s=a[9],q=a[10],t=a[11],w=a[12],r=a[13],x=a[14];a=a[15];var z=b[0],h=b[1],k=b[2],y=b[3],v=b[4],H=b[5],A=b[6],E=b[7],B=b[8],C=b[9],L=b[10],D=b[11],G=b[12],I=b[13],U=b[14];b=b[15];e[0]=z*l+h*p+k*u+y*w;e[1]=z*g+h*f+k*s+y*r;e[2]=z*m+h*n+k*q+y*x;e[3]=z*c+h*d+k*t+y*a;e[4]=v*l+H*p+A*u+E*w;e[5]=v*g+H*f+A*s+E*r;e[6]=v*m+H*n+A*q+E*x;e[7]=v*c+H*d+A*t+E*a;e[8]=B*l+C*p+L*u+D*w;e[9]=B*g+C*f+L*s+D*r;e[10]=B*
m+C*n+L*q+D*x;e[11]=B*c+C*d+L*t+D*a;e[12]=G*l+I*p+U*u+b*w;e[13]=G*g+I*f+U*s+b*r;e[14]=G*m+I*n+U*q+b*x;e[15]=G*c+I*d+U*t+b*a;return e};mat4.multiplyVec3=function(a,b,e){e||(e=b);var l=b[0],g=b[1];b=b[2];e[0]=a[0]*l+a[4]*g+a[8]*b+a[12];e[1]=a[1]*l+a[5]*g+a[9]*b+a[13];e[2]=a[2]*l+a[6]*g+a[10]*b+a[14];return e};
mat4.multiplyVec4=function(a,b,e){e||(e=b);var l=b[0],g=b[1],m=b[2];b=b[3];e[0]=a[0]*l+a[4]*g+a[8]*m+a[12]*b;e[1]=a[1]*l+a[5]*g+a[9]*m+a[13]*b;e[2]=a[2]*l+a[6]*g+a[10]*m+a[14]*b;e[3]=a[3]*l+a[7]*g+a[11]*m+a[15]*b;return e};
mat4.translate=function(a,b,e){var l=b[0],g=b[1];b=b[2];var m,c,p,f,n,d,u,s,q,t,w,r;if(!e||a===e)return a[12]=a[0]*l+a[4]*g+a[8]*b+a[12],a[13]=a[1]*l+a[5]*g+a[9]*b+a[13],a[14]=a[2]*l+a[6]*g+a[10]*b+a[14],a[15]=a[3]*l+a[7]*g+a[11]*b+a[15],a;m=a[0];c=a[1];p=a[2];f=a[3];n=a[4];d=a[5];u=a[6];s=a[7];q=a[8];t=a[9];w=a[10];r=a[11];e[0]=m;e[1]=c;e[2]=p;e[3]=f;e[4]=n;e[5]=d;e[6]=u;e[7]=s;e[8]=q;e[9]=t;e[10]=w;e[11]=r;e[12]=m*l+n*g+q*b+a[12];e[13]=c*l+d*g+t*b+a[13];e[14]=p*l+u*g+w*b+a[14];e[15]=f*l+s*g+r*b+
a[15];return e};mat4.scale=function(a,b,e){var l=b[0],g=b[1];b=b[2];if(!e||a===e)return a[0]*=l,a[1]*=l,a[2]*=l,a[3]*=l,a[4]*=g,a[5]*=g,a[6]*=g,a[7]*=g,a[8]*=b,a[9]*=b,a[10]*=b,a[11]*=b,a;e[0]=a[0]*l;e[1]=a[1]*l;e[2]=a[2]*l;e[3]=a[3]*l;e[4]=a[4]*g;e[5]=a[5]*g;e[6]=a[6]*g;e[7]=a[7]*g;e[8]=a[8]*b;e[9]=a[9]*b;e[10]=a[10]*b;e[11]=a[11]*b;e[12]=a[12];e[13]=a[13];e[14]=a[14];e[15]=a[15];return e};
mat4.rotate=function(a,b,e,l){var g=e[0],m=e[1];e=e[2];var c=Math.sqrt(g*g+m*m+e*e),p,f,n,d,u,s,q,t,w,r,x,z,h,k,y,v,H,A,E,B;if(!c)return null;1!==c&&(c=1/c,g*=c,m*=c,e*=c);p=Math.sin(b);f=Math.cos(b);n=1-f;b=a[0];c=a[1];d=a[2];u=a[3];s=a[4];q=a[5];t=a[6];w=a[7];r=a[8];x=a[9];z=a[10];h=a[11];k=g*g*n+f;y=m*g*n+e*p;v=e*g*n-m*p;H=g*m*n-e*p;A=m*m*n+f;E=e*m*n+g*p;B=g*e*n+m*p;g=m*e*n-g*p;m=e*e*n+f;l?a!==l&&(l[12]=a[12],l[13]=a[13],l[14]=a[14],l[15]=a[15]):l=a;l[0]=b*k+s*y+r*v;l[1]=c*k+q*y+x*v;l[2]=d*k+t*
y+z*v;l[3]=u*k+w*y+h*v;l[4]=b*H+s*A+r*E;l[5]=c*H+q*A+x*E;l[6]=d*H+t*A+z*E;l[7]=u*H+w*A+h*E;l[8]=b*B+s*g+r*m;l[9]=c*B+q*g+x*m;l[10]=d*B+t*g+z*m;l[11]=u*B+w*g+h*m;return l};
mat4.rotateX=function(a,b,e){var l=Math.sin(b);b=Math.cos(b);var g=a[4],m=a[5],c=a[6],p=a[7],f=a[8],n=a[9],d=a[10],u=a[11];e?a!==e&&(e[0]=a[0],e[1]=a[1],e[2]=a[2],e[3]=a[3],e[12]=a[12],e[13]=a[13],e[14]=a[14],e[15]=a[15]):e=a;e[4]=g*b+f*l;e[5]=m*b+n*l;e[6]=c*b+d*l;e[7]=p*b+u*l;e[8]=g*-l+f*b;e[9]=m*-l+n*b;e[10]=c*-l+d*b;e[11]=p*-l+u*b;return e};
mat4.rotateY=function(a,b,e){var l=Math.sin(b);b=Math.cos(b);var g=a[0],m=a[1],c=a[2],p=a[3],f=a[8],n=a[9],d=a[10],u=a[11];e?a!==e&&(e[4]=a[4],e[5]=a[5],e[6]=a[6],e[7]=a[7],e[12]=a[12],e[13]=a[13],e[14]=a[14],e[15]=a[15]):e=a;e[0]=g*b+f*-l;e[1]=m*b+n*-l;e[2]=c*b+d*-l;e[3]=p*b+u*-l;e[8]=g*l+f*b;e[9]=m*l+n*b;e[10]=c*l+d*b;e[11]=p*l+u*b;return e};
mat4.rotateZ=function(a,b,e){var l=Math.sin(b);b=Math.cos(b);var g=a[0],m=a[1],c=a[2],p=a[3],f=a[4],n=a[5],d=a[6],u=a[7];e?a!==e&&(e[8]=a[8],e[9]=a[9],e[10]=a[10],e[11]=a[11],e[12]=a[12],e[13]=a[13],e[14]=a[14],e[15]=a[15]):e=a;e[0]=g*b+f*l;e[1]=m*b+n*l;e[2]=c*b+d*l;e[3]=p*b+u*l;e[4]=g*-l+f*b;e[5]=m*-l+n*b;e[6]=c*-l+d*b;e[7]=p*-l+u*b;return e};
mat4.frustum=function(a,b,e,l,g,m,c){c||(c=mat4.create());var p=b-a,f=l-e,n=m-g;c[0]=2*g/p;c[1]=0;c[2]=0;c[3]=0;c[4]=0;c[5]=2*g/f;c[6]=0;c[7]=0;c[8]=(b+a)/p;c[9]=(l+e)/f;c[10]=-(m+g)/n;c[11]=-1;c[12]=0;c[13]=0;c[14]=-(2*m*g)/n;c[15]=0;return c};mat4.perspective=function(a,b,e,l,g){a=e*Math.tan(a*Math.PI/360);b*=a;return mat4.frustum(-b,b,-a,a,e,l,g)};
mat4.ortho=function(a,b,e,l,g,m,c){c||(c=mat4.create());var p=b-a,f=l-e,n=m-g;c[0]=2/p;c[1]=0;c[2]=0;c[3]=0;c[4]=0;c[5]=2/f;c[6]=0;c[7]=0;c[8]=0;c[9]=0;c[10]=-2/n;c[11]=0;c[12]=-(a+b)/p;c[13]=-(l+e)/f;c[14]=-(m+g)/n;c[15]=1;return c};
mat4.lookAt=function(a,b,e,l){l||(l=mat4.create());var g,m,c,p,f,n,d,u,s=a[0],q=a[1];a=a[2];m=e[0];c=e[1];g=e[2];e=b[1];n=b[2];if(s===b[0]&&q===e&&a===n)return mat4.identity(l);e=s-b[0];n=q-b[1];d=a-b[2];u=1/Math.sqrt(e*e+n*n+d*d);e*=u;n*=u;d*=u;b=c*d-g*n;g=g*e-m*d;m=m*n-c*e;(u=Math.sqrt(b*b+g*g+m*m))?(u=1/u,b*=u,g*=u,m*=u):m=g=b=0;c=n*m-d*g;p=d*b-e*m;f=e*g-n*b;(u=Math.sqrt(c*c+p*p+f*f))?(u=1/u,c*=u,p*=u,f*=u):f=p=c=0;l[0]=b;l[1]=c;l[2]=e;l[3]=0;l[4]=g;l[5]=p;l[6]=n;l[7]=0;l[8]=m;l[9]=f;l[10]=d;l[11]=
0;l[12]=-(b*s+g*q+m*a);l[13]=-(c*s+p*q+f*a);l[14]=-(e*s+n*q+d*a);l[15]=1;return l};mat4.fromRotationTranslation=function(a,b,e){e||(e=mat4.create());var l=a[0],g=a[1],m=a[2],c=a[3],p=l+l,f=g+g,n=m+m;a=l*p;var d=l*f,l=l*n,u=g*f,g=g*n,m=m*n,p=p*c,f=f*c,c=c*n;e[0]=1-(u+m);e[1]=d+c;e[2]=l-f;e[3]=0;e[4]=d-c;e[5]=1-(a+m);e[6]=g+p;e[7]=0;e[8]=l+f;e[9]=g-p;e[10]=1-(a+u);e[11]=0;e[12]=b[0];e[13]=b[1];e[14]=b[2];e[15]=1;return e};
mat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+", "+a[9]+", "+a[10]+", "+a[11]+", "+a[12]+", "+a[13]+", "+a[14]+", "+a[15]+"]"};quat4.create=function(a){var b=new MatrixArray(4);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3]);return b};quat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];return b};
quat4.calculateW=function(a,b){var e=a[0],l=a[1],g=a[2];if(!b||a===b)return a[3]=-Math.sqrt(Math.abs(1-e*e-l*l-g*g)),a;b[0]=e;b[1]=l;b[2]=g;b[3]=-Math.sqrt(Math.abs(1-e*e-l*l-g*g));return b};quat4.inverse=function(a,b){if(!b||a===b)return a[0]*=-1,a[1]*=-1,a[2]*=-1,a;b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];b[3]=a[3];return b};quat4.length=function(a){var b=a[0],e=a[1],l=a[2];a=a[3];return Math.sqrt(b*b+e*e+l*l+a*a)};
quat4.normalize=function(a,b){b||(b=a);var e=a[0],l=a[1],g=a[2],m=a[3],c=Math.sqrt(e*e+l*l+g*g+m*m);if(0===c)return b[0]=0,b[1]=0,b[2]=0,b[3]=0,b;c=1/c;b[0]=e*c;b[1]=l*c;b[2]=g*c;b[3]=m*c;return b};quat4.multiply=function(a,b,e){e||(e=a);var l=a[0],g=a[1],m=a[2];a=a[3];var c=b[0],p=b[1],f=b[2];b=b[3];e[0]=l*b+a*c+g*f-m*p;e[1]=g*b+a*p+m*c-l*f;e[2]=m*b+a*f+l*p-g*c;e[3]=a*b-l*c-g*p-m*f;return e};
quat4.multiplyVec3=function(a,b,e){e||(e=b);var l=b[0],g=b[1],m=b[2];b=a[0];var c=a[1],p=a[2];a=a[3];var f=a*l+c*m-p*g,n=a*g+p*l-b*m,d=a*m+b*g-c*l,l=-b*l-c*g-p*m;e[0]=f*a+l*-b+n*-p-d*-c;e[1]=n*a+l*-c+d*-b-f*-p;e[2]=d*a+l*-p+f*-c-n*-b;return e};quat4.toMat3=function(a,b){b||(b=mat3.create());var e=a[0],l=a[1],g=a[2],m=a[3],c=e+e,p=l+l,f=g+g,n=e*c,d=e*p,e=e*f,u=l*p,l=l*f,g=g*f,c=c*m,p=p*m,m=m*f;b[0]=1-(u+g);b[1]=d+m;b[2]=e-p;b[3]=d-m;b[4]=1-(n+g);b[5]=l+c;b[6]=e+p;b[7]=l-c;b[8]=1-(n+u);return b};
quat4.toMat4=function(a,b){b||(b=mat4.create());var e=a[0],l=a[1],g=a[2],m=a[3],c=e+e,p=l+l,f=g+g,n=e*c,d=e*p,e=e*f,u=l*p,l=l*f,g=g*f,c=c*m,p=p*m,m=m*f;b[0]=1-(u+g);b[1]=d+m;b[2]=e-p;b[3]=0;b[4]=d-m;b[5]=1-(n+g);b[6]=l+c;b[7]=0;b[8]=e+p;b[9]=l-c;b[10]=1-(n+u);b[11]=0;b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
quat4.slerp=function(a,b,e,l){l||(l=a);var g=a[0]*b[0]+a[1]*b[1]+a[2]*b[2]+a[3]*b[3],m,c;if(1<=Math.abs(g))return l!==a&&(l[0]=a[0],l[1]=a[1],l[2]=a[2],l[3]=a[3]),l;m=Math.acos(g);c=Math.sqrt(1-g*g);if(0.001>Math.abs(c))return l[0]=0.5*a[0]+0.5*b[0],l[1]=0.5*a[1]+0.5*b[1],l[2]=0.5*a[2]+0.5*b[2],l[3]=0.5*a[3]+0.5*b[3],l;g=Math.sin((1-e)*m)/c;e=Math.sin(e*m)/c;l[0]=a[0]*g+b[0]*e;l[1]=a[1]*g+b[1]*e;l[2]=a[2]*g+b[2]*e;l[3]=a[3]*g+b[3]*e;return l};
quat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+"]"};
(function(){function a(a,c){this.isIE=/msie/i.test(navigator.userAgent)||/trident/i.test(navigator.userAgent);this.height=this.width=0;this.cam=vec3.create([0,0,100]);this.look=vec3.create([0,0,0]);this.up=vec3.create([0,1,0]);this.worldScale=vec3.create([1,1,1]);this.matP=mat4.create();this.matMV=mat4.create();this.lastMV=mat4.create();this.currentMV=mat4.create();this.gl=a;this.initState()}function b(a,c,b){this.gl=a;this.shaderProgram=c;this.name=b;this.locAPos=a.getAttribLocation(c,"aPos");this.locATex=
a.getAttribLocation(c,"aTex");this.locMatP=a.getUniformLocation(c,"matP");this.locMatMV=a.getUniformLocation(c,"matMV");this.locOpacity=a.getUniformLocation(c,"opacity");this.locSamplerFront=a.getUniformLocation(c,"samplerFront");this.locSamplerBack=a.getUniformLocation(c,"samplerBack");this.locDestStart=a.getUniformLocation(c,"destStart");this.locDestEnd=a.getUniformLocation(c,"destEnd");this.locSeconds=a.getUniformLocation(c,"seconds");this.locPixelWidth=a.getUniformLocation(c,"pixelWidth");this.locPixelHeight=
a.getUniformLocation(c,"pixelHeight");this.locLayerScale=a.getUniformLocation(c,"layerScale");this.locLayerAngle=a.getUniformLocation(c,"layerAngle");this.locViewOrigin=a.getUniformLocation(c,"viewOrigin");this.hasAnyOptionalUniforms=!!(this.locPixelWidth||this.locPixelHeight||this.locSeconds||this.locSamplerBack||this.locDestStart||this.locDestEnd||this.locLayerScale||this.locLayerAngle||this.locViewOrigin);this.locOpacity&&a.uniform1f(this.locOpacity,1);this.locSamplerFront&&a.uniform1i(this.locSamplerFront,
0);this.locSamplerBack&&a.uniform1i(this.locSamplerBack,1);this.locDestStart&&a.uniform2f(this.locDestStart,0,0);this.locDestEnd&&a.uniform2f(this.locDestEnd,1,1);this.locLayerScale&&a.uniform1f(this.locLayerScale,1);this.locLayerAngle&&a.uniform1f(this.locLayerAngle,0);this.locViewOrigin&&a.uniform2f(this.locViewOrigin,0,0);this.hasCurrentMatMV=!1}function e(a,c){this.type=a;this.glwrap=c;this.gl=c.gl;this.indexCount=this.startIndex=this.opacityParam=0;this.mat4param=this.texParam=null;this.shaderParams=
[];cr.seal(this)}a.prototype.initState=function(){var a=this.gl,c;this.lastOpacity=1;this.lastTexture1=this.lastTexture0=null;this.currentOpacity=1;a.clearColor(0,0,0,0);a.clear(a.COLOR_BUFFER_BIT);a.enable(a.BLEND);a.blendFunc(a.ONE,a.ONE_MINUS_SRC_ALPHA);a.disable(a.CULL_FACE);a.disable(a.DEPTH_TEST);this.maxTextureSize=a.getParameter(a.MAX_TEXTURE_SIZE);this.lastSrcBlend=a.ONE;this.lastDestBlend=a.ONE_MINUS_SRC_ALPHA;this.pointBuffer=a.createBuffer();a.bindBuffer(a.ARRAY_BUFFER,this.pointBuffer);
this.vertexBuffers=Array(4);this.texcoordBuffers=Array(4);for(c=0;4>c;c++)this.vertexBuffers[c]=a.createBuffer(),a.bindBuffer(a.ARRAY_BUFFER,this.vertexBuffers[c]),this.texcoordBuffers[c]=a.createBuffer(),a.bindBuffer(a.ARRAY_BUFFER,this.texcoordBuffers[c]);this.curBuffer=0;this.indexBuffer=a.createBuffer();a.bindBuffer(a.ELEMENT_ARRAY_BUFFER,this.indexBuffer);this.vertexData=new Float32Array(16E3);this.texcoordData=new Float32Array(16E3);this.pointData=new Float32Array(32E3);for(var b=new Uint16Array(12E3),
f=c=0;12E3>c;)b[c++]=f,b[c++]=f+1,b[c++]=f+2,b[c++]=f,b[c++]=f+2,b[c++]=f+3,f+=4;a.bufferData(a.ELEMENT_ARRAY_BUFFER,b,a.STATIC_DRAW);this.pointPtr=this.vertexPtr=0;this.shaderPrograms=[];c=this.createShaderProgram({src:"varying mediump vec2 vTex;\nuniform lowp float opacity;\nuniform lowp sampler2D samplerFront;\nvoid main(void) {\n\tgl_FragColor = texture2D(samplerFront, vTex);\n\tgl_FragColor *= opacity;\n}"},"attribute highp vec2 aPos;\nattribute mediump vec2 aTex;\nvarying mediump vec2 vTex;\nuniform highp mat4 matP;\nuniform highp mat4 matMV;\nvoid main(void) {\n\tgl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);\n\tvTex = aTex;\n}",
"<default>");this.shaderPrograms.push(c);c=this.createShaderProgram({src:"uniform mediump sampler2D samplerFront;\nvarying lowp float opacity;\nvoid main(void) {\n\tgl_FragColor = texture2D(samplerFront, gl_PointCoord);\n\tgl_FragColor *= opacity;\n}"},"attribute vec4 aPos;\nvarying float opacity;\nuniform mat4 matP;\nuniform mat4 matMV;\nvoid main(void) {\n\tgl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);\n\tgl_PointSize = aPos.z;\n\topacity = aPos.w;\n}","<point>");this.shaderPrograms.push(c);
for(var g in cr.shaders)cr.shaders.hasOwnProperty(g)&&this.shaderPrograms.push(this.createShaderProgram(cr.shaders[g],"attribute highp vec2 aPos;\nattribute mediump vec2 aTex;\nvarying mediump vec2 vTex;\nuniform highp mat4 matP;\nuniform highp mat4 matMV;\nvoid main(void) {\n\tgl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);\n\tvTex = aTex;\n}",g));a.activeTexture(a.TEXTURE0);a.bindTexture(a.TEXTURE_2D,null);this.batch=[];this.batchPtr=0;this.hasPointBatchTop=this.hasQuadBatchTop=!1;
this.currentProgram=this.lastProgram=-1;this.currentShader=null;this.fbo=a.createFramebuffer();this.renderToTex=null;this.tmpVec3=vec3.create([0,0,0]);a=a.getParameter(a.ALIASED_POINT_SIZE_RANGE);this.minPointSize=a[0];this.maxPointSize=a[1];this.switchProgram(0);cr.seal(this)};a.prototype.createShaderProgram=function(a,c,g){var f=this.gl,n=f.createShader(f.FRAGMENT_SHADER);f.shaderSource(n,a.src);f.compileShader(n);if(!f.getShaderParameter(n,f.COMPILE_STATUS))return f.deleteShader(n),null;var d=
f.createShader(f.VERTEX_SHADER);f.shaderSource(d,c);f.compileShader(d);if(!f.getShaderParameter(d,f.COMPILE_STATUS))return f.deleteShader(n),f.deleteShader(d),null;c=f.createProgram();f.attachShader(c,n);f.attachShader(c,d);f.linkProgram(c);if(!f.getProgramParameter(c,f.LINK_STATUS))return f.deleteShader(n),f.deleteShader(d),f.deleteProgram(c),null;f.useProgram(c);f.deleteShader(n);f.deleteShader(d);g=new b(f,c,g);g.extendBoxHorizontal=a.extendBoxHorizontal||0;g.extendBoxVertical=a.extendBoxVertical||
0;g.crossSampling=!!a.crossSampling;g.animated=!!a.animated;g.parameters=a.parameters||[];a=0;for(n=g.parameters.length;a<n;a++)g.parameters[a][1]=f.getUniformLocation(c,g.parameters[a][0]),f.uniform1f(g.parameters[a][1],0);cr.seal(g);return g};a.prototype.getShaderIndex=function(a){var c,b;c=0;for(b=this.shaderPrograms.length;c<b;c++)if(this.shaderPrograms[c].name===a)return c;return-1};a.prototype.project=function(a,c,b){var f=this.matMV,g=this.matP,d=[0,0,0,0,0,0,0,0];d[0]=f[0]*a+f[4]*c+f[12];
d[1]=f[1]*a+f[5]*c+f[13];d[2]=f[2]*a+f[6]*c+f[14];d[3]=f[3]*a+f[7]*c+f[15];d[4]=g[0]*d[0]+g[4]*d[1]+g[8]*d[2]+g[12]*d[3];d[5]=g[1]*d[0]+g[5]*d[1]+g[9]*d[2]+g[13]*d[3];d[6]=g[2]*d[0]+g[6]*d[1]+g[10]*d[2]+g[14]*d[3];d[7]=-d[2];0!==d[7]&&(d[7]=1/d[7],d[4]*=d[7],d[5]*=d[7],d[6]*=d[7],b[0]=(0.5*d[4]+0.5)*this.width,b[1]=(0.5*d[5]+0.5)*this.height)};a.prototype.setSize=function(a,c,b){if(this.width!==a||this.height!==c||b){this.endBatch();this.width=a;this.height=c;this.gl.viewport(0,0,a,c);mat4.perspective(45,
a/c,1,1E3,this.matP);mat4.lookAt(this.cam,this.look,this.up,this.matMV);a=[0,0];c=[0,0];this.project(0,0,a);this.project(1,1,c);this.worldScale[0]=1/(c[0]-a[0]);this.worldScale[1]=-1/(c[1]-a[1]);a=0;for(c=this.shaderPrograms.length;a<c;a++)b=this.shaderPrograms[a],b.hasCurrentMatMV=!1,b.locMatP&&(this.gl.useProgram(b.shaderProgram),this.gl.uniformMatrix4fv(b.locMatP,!1,this.matP));this.gl.useProgram(this.shaderPrograms[this.lastProgram].shaderProgram);this.gl.bindTexture(this.gl.TEXTURE_2D,null);
this.gl.activeTexture(this.gl.TEXTURE1);this.gl.bindTexture(this.gl.TEXTURE_2D,null);this.gl.activeTexture(this.gl.TEXTURE0);this.lastTexture1=this.lastTexture0=null}};a.prototype.resetModelView=function(){mat4.lookAt(this.cam,this.look,this.up,this.matMV);mat4.scale(this.matMV,this.worldScale)};a.prototype.translate=function(a,c){if(0!==a||0!==c)this.tmpVec3[0]=a,this.tmpVec3[1]=c,this.tmpVec3[2]=0,mat4.translate(this.matMV,this.tmpVec3)};a.prototype.scale=function(a,c){if(1!==a||1!==c)this.tmpVec3[0]=
a,this.tmpVec3[1]=c,this.tmpVec3[2]=1,mat4.scale(this.matMV,this.tmpVec3)};a.prototype.rotateZ=function(a){0!==a&&mat4.rotateZ(this.matMV,a)};a.prototype.updateModelView=function(){for(var a=!1,c=0;16>c;c++)if(this.lastMV[c]!==this.matMV[c]){a=!0;break}a&&(a=this.pushBatch(),a.type=5,a.mat4param?mat4.set(this.matMV,a.mat4param):a.mat4param=mat4.create(this.matMV),mat4.set(this.matMV,this.lastMV),this.hasPointBatchTop=this.hasQuadBatchTop=!1)};e.prototype.doSetTexture=function(){this.gl.bindTexture(this.gl.TEXTURE_2D,
this.texParam)};e.prototype.doSetTexture1=function(){var a=this.gl;a.activeTexture(a.TEXTURE1);a.bindTexture(a.TEXTURE_2D,this.texParam);a.activeTexture(a.TEXTURE0)};e.prototype.doSetOpacity=function(){var a=this.opacityParam,c=this.glwrap;c.currentOpacity=a;c=c.currentShader;c.locOpacity&&this.gl.uniform1f(c.locOpacity,a)};e.prototype.doQuad=function(){this.gl.drawElements(this.gl.TRIANGLES,this.indexCount,this.gl.UNSIGNED_SHORT,2*this.startIndex)};e.prototype.doSetBlend=function(){this.gl.blendFunc(this.startIndex,
this.indexCount)};e.prototype.doUpdateModelView=function(){var a,c,b,f=this.glwrap.shaderPrograms,g=this.glwrap.currentProgram;a=0;for(c=f.length;a<c;a++)b=f[a],a===g&&b.locMatMV?(this.gl.uniformMatrix4fv(b.locMatMV,!1,this.mat4param),b.hasCurrentMatMV=!0):b.hasCurrentMatMV=!1;mat4.set(this.mat4param,this.glwrap.currentMV)};e.prototype.doRenderToTexture=function(){var a=this.gl,c=this.glwrap;this.texParam?(c.lastTexture1===this.texParam&&(a.activeTexture(a.TEXTURE1),a.bindTexture(a.TEXTURE_2D,null),
c.lastTexture1=null,a.activeTexture(a.TEXTURE0)),a.bindFramebuffer(a.FRAMEBUFFER,c.fbo),a.framebufferTexture2D(a.FRAMEBUFFER,a.COLOR_ATTACHMENT0,a.TEXTURE_2D,this.texParam,0)):(a.framebufferTexture2D(a.FRAMEBUFFER,a.COLOR_ATTACHMENT0,a.TEXTURE_2D,null,0),a.bindFramebuffer(a.FRAMEBUFFER,null))};e.prototype.doClear=function(){var a=this.gl;0===this.startIndex?(a.clearColor(this.mat4param[0],this.mat4param[1],this.mat4param[2],this.mat4param[3]),a.clear(a.COLOR_BUFFER_BIT)):(a.enable(a.SCISSOR_TEST),
a.scissor(this.mat4param[0],this.mat4param[1],this.mat4param[2],this.mat4param[3]),a.clearColor(0,0,0,0),a.clear(this.gl.COLOR_BUFFER_BIT),a.disable(a.SCISSOR_TEST))};e.prototype.doPoints=function(){var a=this.gl,c=this.glwrap,b=c.shaderPrograms[1];a.useProgram(b.shaderProgram);!b.hasCurrentMatMV&&b.locMatMV&&(a.uniformMatrix4fv(b.locMatMV,!1,c.currentMV),b.hasCurrentMatMV=!0);a.enableVertexAttribArray(b.locAPos);a.bindBuffer(a.ARRAY_BUFFER,c.pointBuffer);a.vertexAttribPointer(b.locAPos,4,a.FLOAT,
!1,0,0);a.drawArrays(a.POINTS,this.startIndex/4,this.indexCount);b=c.currentShader;a.useProgram(b.shaderProgram);0<=b.locAPos&&(a.enableVertexAttribArray(b.locAPos),a.bindBuffer(a.ARRAY_BUFFER,c.vertexBuffers[c.curBuffer]),a.vertexAttribPointer(b.locAPos,2,a.FLOAT,!1,0,0));0<=b.locATex&&(a.enableVertexAttribArray(b.locATex),a.bindBuffer(a.ARRAY_BUFFER,c.texcoordBuffers[c.curBuffer]),a.vertexAttribPointer(b.locATex,2,a.FLOAT,!1,0,0))};e.prototype.doSetProgram=function(){var a=this.gl,c=this.glwrap,
b=c.shaderPrograms[this.startIndex];c.currentProgram=this.startIndex;c.currentShader=b;a.useProgram(b.shaderProgram);!b.hasCurrentMatMV&&b.locMatMV&&(a.uniformMatrix4fv(b.locMatMV,!1,c.currentMV),b.hasCurrentMatMV=!0);b.locOpacity&&a.uniform1f(b.locOpacity,c.currentOpacity);0<=b.locAPos&&(a.enableVertexAttribArray(b.locAPos),a.bindBuffer(a.ARRAY_BUFFER,c.vertexBuffers[c.curBuffer]),a.vertexAttribPointer(b.locAPos,2,a.FLOAT,!1,0,0));0<=b.locATex&&(a.enableVertexAttribArray(b.locATex),a.bindBuffer(a.ARRAY_BUFFER,
c.texcoordBuffers[c.curBuffer]),a.vertexAttribPointer(b.locATex,2,a.FLOAT,!1,0,0))};e.prototype.doSetProgramParameters=function(){var a,c,b=this.glwrap.currentShader,f=this.gl;a=this.mat4param;b.locSamplerBack&&this.glwrap.lastTexture1!==this.texParam&&(f.activeTexture(f.TEXTURE1),f.bindTexture(f.TEXTURE_2D,this.texParam),this.glwrap.lastTexture1=this.texParam,f.activeTexture(f.TEXTURE0));b.locPixelWidth&&f.uniform1f(b.locPixelWidth,a[0]);b.locPixelHeight&&f.uniform1f(b.locPixelHeight,a[1]);b.locDestStart&&
f.uniform2f(b.locDestStart,a[2],a[3]);b.locDestEnd&&f.uniform2f(b.locDestEnd,a[4],a[5]);b.locLayerScale&&f.uniform1f(b.locLayerScale,a[6]);b.locLayerAngle&&f.uniform1f(b.locLayerAngle,a[7]);b.locViewOrigin&&f.uniform2f(b.locViewOrigin,a[8],a[9]);b.locSeconds&&f.uniform1f(b.locSeconds,cr.performance_now()/1E3);if(b.parameters.length)for(a=0,c=b.parameters.length;a<c;a++)f.uniform1f(b.parameters[a][1],this.shaderParams[a])};a.prototype.pushBatch=function(){this.batchPtr===this.batch.length&&this.batch.push(new e(0,
this));return this.batch[this.batchPtr++]};a.prototype.endBatch=function(){if(0!==this.batchPtr&&!this.gl.isContextLost()){var a=this.gl;0<this.pointPtr&&(a.bindBuffer(a.ARRAY_BUFFER,this.pointBuffer),a.bufferData(a.ARRAY_BUFFER,this.pointData.subarray(0,this.pointPtr),a.STREAM_DRAW),c&&0<=c.locAPos&&"<point>"===c.name&&a.vertexAttribPointer(c.locAPos,4,a.FLOAT,!1,0,0));if(0<this.vertexPtr){var c=this.currentShader;a.bindBuffer(a.ARRAY_BUFFER,this.vertexBuffers[this.curBuffer]);a.bufferData(a.ARRAY_BUFFER,
this.vertexData.subarray(0,this.vertexPtr),a.STREAM_DRAW);c&&0<=c.locAPos&&"<point>"!==c.name&&a.vertexAttribPointer(c.locAPos,2,a.FLOAT,!1,0,0);a.bindBuffer(a.ARRAY_BUFFER,this.texcoordBuffers[this.curBuffer]);a.bufferData(a.ARRAY_BUFFER,this.texcoordData.subarray(0,this.vertexPtr),a.STREAM_DRAW);c&&0<=c.locATex&&"<point>"!==c.name&&a.vertexAttribPointer(c.locATex,2,a.FLOAT,!1,0,0)}for(var b,a=0,c=this.batchPtr;a<c;a++)switch(b=this.batch[a],b.type){case 1:b.doQuad();break;case 2:b.doSetTexture();
break;case 3:b.doSetOpacity();break;case 4:b.doSetBlend();break;case 5:b.doUpdateModelView();break;case 6:b.doRenderToTexture();break;case 7:b.doClear();break;case 8:b.doPoints();break;case 9:b.doSetProgram();break;case 10:b.doSetProgramParameters();break;case 11:b.doSetTexture1()}this.pointPtr=this.vertexPtr=this.batchPtr=0;this.hasPointBatchTop=this.hasQuadBatchTop=!1;this.curBuffer++;4<=this.curBuffer&&(this.curBuffer=0)}};a.prototype.setOpacity=function(a){if(a!==this.lastOpacity){var c=this.pushBatch();
c.type=3;this.lastOpacity=c.opacityParam=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.setTexture=function(a){if(a!==this.lastTexture0){var c=this.pushBatch();c.type=2;this.lastTexture0=c.texParam=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.setBlend=function(a,c){if(a!==this.lastSrcBlend||c!==this.lastDestBlend){var b=this.pushBatch();b.type=4;b.startIndex=a;b.indexCount=c;this.lastSrcBlend=a;this.lastDestBlend=c;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.isPremultipliedAlphaBlend=
function(){return this.lastSrcBlend===this.gl.ONE&&this.lastDestBlend===this.gl.ONE_MINUS_SRC_ALPHA};a.prototype.setAlphaBlend=function(){this.setBlend(this.gl.ONE,this.gl.ONE_MINUS_SRC_ALPHA)};a.prototype.setNoPremultiplyAlphaBlend=function(){this.setBlend(this.gl.SRC_ALPHA,this.gl.ONE_MINUS_SRC_ALPHA)};a.prototype.quad=function(a,c,b,f,g,d,e,l){15992<=this.vertexPtr&&this.endBatch();var q=this.vertexPtr,t=this.vertexData,w=this.texcoordData;if(this.hasQuadBatchTop)this.batch[this.batchPtr-1].indexCount+=
6;else{var r=this.pushBatch();r.type=1;r.startIndex=3*(q/4);r.indexCount=6;this.hasQuadBatchTop=!0;this.hasPointBatchTop=!1}t[q]=a;w[q++]=0;t[q]=c;w[q++]=0;t[q]=b;w[q++]=1;t[q]=f;w[q++]=0;t[q]=g;w[q++]=1;t[q]=d;w[q++]=1;t[q]=e;w[q++]=0;t[q]=l;w[q++]=1;this.vertexPtr=q};a.prototype.quadTex=function(a,c,b,f,g,d,e,l,q){15992<=this.vertexPtr&&this.endBatch();var t=this.vertexPtr,w=this.vertexData,r=this.texcoordData;if(this.hasQuadBatchTop)this.batch[this.batchPtr-1].indexCount+=6;else{var x=this.pushBatch();
x.type=1;x.startIndex=3*(t/4);x.indexCount=6;this.hasQuadBatchTop=!0;this.hasPointBatchTop=!1}var x=q.left,z=q.top,h=q.right;q=q.bottom;w[t]=a;r[t++]=x;w[t]=c;r[t++]=z;w[t]=b;r[t++]=h;w[t]=f;r[t++]=z;w[t]=g;r[t++]=h;w[t]=d;r[t++]=q;w[t]=e;r[t++]=x;w[t]=l;r[t++]=q;this.vertexPtr=t};a.prototype.quadTexUV=function(a,c,b,f,g,d,e,l,q,t,w,r,x,z,h,k){15992<=this.vertexPtr&&this.endBatch();var y=this.vertexPtr,v=this.vertexData,H=this.texcoordData;if(this.hasQuadBatchTop)this.batch[this.batchPtr-1].indexCount+=
6;else{var A=this.pushBatch();A.type=1;A.startIndex=3*(y/4);A.indexCount=6;this.hasQuadBatchTop=!0;this.hasPointBatchTop=!1}v[y]=a;H[y++]=q;v[y]=c;H[y++]=t;v[y]=b;H[y++]=w;v[y]=f;H[y++]=r;v[y]=g;H[y++]=x;v[y]=d;H[y++]=z;v[y]=e;H[y++]=h;v[y]=l;H[y++]=k;this.vertexPtr=y};a.prototype.point=function(a,c,b,f){7996<=this.pointPtr&&this.endBatch();var g=this.pointPtr,d=this.pointData;if(this.hasPointBatchTop)this.batch[this.batchPtr-1].indexCount++;else{var e=this.pushBatch();e.type=8;e.startIndex=g;e.indexCount=
1;this.hasPointBatchTop=!0;this.hasQuadBatchTop=!1}d[g++]=a;d[g++]=c;d[g++]=b;d[g++]=f;this.pointPtr=g};a.prototype.switchProgram=function(a){if(this.lastProgram!==a){if(!this.shaderPrograms[a]){if(0===this.lastProgram)return;a=0}var c=this.pushBatch();c.type=9;this.lastProgram=c.startIndex=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.programUsesDest=function(a){a=this.shaderPrograms[a];return!(!a.locDestStart&&!a.locDestEnd)};a.prototype.programUsesCrossSampling=function(a){a=this.shaderPrograms[a];
return!!(a.locDestStart||a.locDestEnd||a.crossSampling)};a.prototype.programExtendsBox=function(a){a=this.shaderPrograms[a];return 0!==a.extendBoxHorizontal||0!==a.extendBoxVertical};a.prototype.getProgramBoxExtendHorizontal=function(a){return this.shaderPrograms[a].extendBoxHorizontal};a.prototype.getProgramBoxExtendVertical=function(a){return this.shaderPrograms[a].extendBoxVertical};a.prototype.getProgramParameterType=function(a,c){return this.shaderPrograms[a].parameters[c][2]};a.prototype.programIsAnimated=
function(a){return this.shaderPrograms[a].animated};a.prototype.setProgramParameters=function(a,c,b,g,n,d,e,l,q,t,w,r){var x=this.shaderPrograms[this.lastProgram],z,h;if(x.hasAnyOptionalUniforms||r.length){z=this.pushBatch();z.type=10;z.mat4param?mat4.set(this.matMV,z.mat4param):z.mat4param=mat4.create();h=z.mat4param;h[0]=c;h[1]=b;h[2]=g;h[3]=n;h[4]=d;h[5]=e;h[6]=l;h[7]=q;h[8]=t;h[9]=w;z.texParam=x.locSamplerBack?a:null;if(r.length)for(b=z.shaderParams,b.length=r.length,a=0,c=r.length;a<c;a++)b[a]=
r[a];this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.clear=function(a,c,b,g){var n=this.pushBatch();n.type=7;n.startIndex=0;n.mat4param||(n.mat4param=mat4.create());n.mat4param[0]=a;n.mat4param[1]=c;n.mat4param[2]=b;n.mat4param[3]=g;this.hasPointBatchTop=this.hasQuadBatchTop=!1};a.prototype.clearRect=function(a,c,b,g){if(!(0>b||0>g)){var n=this.pushBatch();n.type=7;n.startIndex=1;n.mat4param||(n.mat4param=mat4.create());n.mat4param[0]=a;n.mat4param[1]=c;n.mat4param[2]=b;n.mat4param[3]=
g;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.present=function(){this.endBatch();this.gl.flush()};var l=[],g={};a.prototype.loadTexture=function(a,c,b,f,n){c=!!c;b=!!b;var d=a.src+","+c+","+b+(c?","+n:""),e=null;if("undefined"!==typeof a.src&&g.hasOwnProperty(d))return e=g[d],e.c2refcount++,e;this.endBatch();var s=this.gl,q=cr.isPOT(a.width)&&cr.isPOT(a.height),e=s.createTexture();s.bindTexture(s.TEXTURE_2D,e);s.pixelStorei(s.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!0);var t=s.RGBA,w=s.RGBA,
r=s.UNSIGNED_BYTE;if(f&&!this.isIE)switch(f){case 1:w=t=s.RGB;break;case 2:r=s.UNSIGNED_SHORT_4_4_4_4;break;case 3:r=s.UNSIGNED_SHORT_5_5_5_1;break;case 4:w=t=s.RGB,r=s.UNSIGNED_SHORT_5_6_5}if(!q&&c){f=document.createElement("canvas");f.width=cr.nextHighestPowerOfTwo(a.width);f.height=cr.nextHighestPowerOfTwo(a.height);var x=f.getContext("2d");x.webkitImageSmoothingEnabled=b;x.mozImageSmoothingEnabled=b;x.msImageSmoothingEnabled=b;x.imageSmoothingEnabled=b;x.drawImage(a,0,0,a.width,a.height,0,0,f.width,
f.height);s.texImage2D(s.TEXTURE_2D,0,t,w,r,f)}else s.texImage2D(s.TEXTURE_2D,0,t,w,r,a);c?"repeat-x"===n?(s.texParameteri(s.TEXTURE_2D,s.TEXTURE_WRAP_S,s.REPEAT),s.texParameteri(s.TEXTURE_2D,s.TEXTURE_WRAP_T,s.CLAMP_TO_EDGE)):("repeat-y"===n?s.texParameteri(s.TEXTURE_2D,s.TEXTURE_WRAP_S,s.CLAMP_TO_EDGE):s.texParameteri(s.TEXTURE_2D,s.TEXTURE_WRAP_S,s.REPEAT),s.texParameteri(s.TEXTURE_2D,s.TEXTURE_WRAP_T,s.REPEAT)):(s.texParameteri(s.TEXTURE_2D,s.TEXTURE_WRAP_S,s.CLAMP_TO_EDGE),s.texParameteri(s.TEXTURE_2D,
s.TEXTURE_WRAP_T,s.CLAMP_TO_EDGE));b?(s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MAG_FILTER,s.LINEAR),q?(s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MIN_FILTER,s.LINEAR_MIPMAP_LINEAR),s.generateMipmap(s.TEXTURE_2D)):s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MIN_FILTER,s.LINEAR)):(s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MAG_FILTER,s.NEAREST),s.texParameteri(s.TEXTURE_2D,s.TEXTURE_MIN_FILTER,s.NEAREST));s.bindTexture(s.TEXTURE_2D,null);this.lastTexture0=null;e.c2width=a.width;e.c2height=a.height;e.c2refcount=1;
e.c2texkey=d;l.push(e);return g[d]=e};a.prototype.createEmptyTexture=function(a,c,b,g,n){this.endBatch();var d=this.gl;this.isIE&&(g=!1);var e=d.createTexture();d.bindTexture(d.TEXTURE_2D,e);d.texImage2D(d.TEXTURE_2D,0,d.RGBA,a,c,0,d.RGBA,g?d.UNSIGNED_SHORT_4_4_4_4:d.UNSIGNED_BYTE,null);n?(d.texParameteri(d.TEXTURE_2D,d.TEXTURE_WRAP_S,d.REPEAT),d.texParameteri(d.TEXTURE_2D,d.TEXTURE_WRAP_T,d.REPEAT)):(d.texParameteri(d.TEXTURE_2D,d.TEXTURE_WRAP_S,d.CLAMP_TO_EDGE),d.texParameteri(d.TEXTURE_2D,d.TEXTURE_WRAP_T,
d.CLAMP_TO_EDGE));d.texParameteri(d.TEXTURE_2D,d.TEXTURE_MAG_FILTER,b?d.LINEAR:d.NEAREST);d.texParameteri(d.TEXTURE_2D,d.TEXTURE_MIN_FILTER,b?d.LINEAR:d.NEAREST);d.bindTexture(d.TEXTURE_2D,null);this.lastTexture0=null;e.c2width=a;e.c2height=c;l.push(e);return e};a.prototype.videoToTexture=function(a,c,b){this.endBatch();var g=this.gl;this.isIE&&(b=!1);g.bindTexture(g.TEXTURE_2D,c);g.pixelStorei(g.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!0);g.texImage2D(g.TEXTURE_2D,0,g.RGBA,g.RGBA,b?g.UNSIGNED_SHORT_4_4_4_4:
g.UNSIGNED_BYTE,a);g.bindTexture(g.TEXTURE_2D,null);this.lastTexture0=null};a.prototype.deleteTexture=function(a){a&&("undefined"!==typeof a.c2refcount&&1<a.c2refcount?a.c2refcount--:(this.endBatch(),a===this.lastTexture0&&(this.gl.bindTexture(this.gl.TEXTURE_2D,null),this.lastTexture0=null),a===this.lastTexture1&&(this.gl.activeTexture(this.gl.TEXTURE1),this.gl.bindTexture(this.gl.TEXTURE_2D,null),this.gl.activeTexture(this.gl.TEXTURE0),this.lastTexture1=null),cr.arrayFindRemove(l,a),"undefined"!==
typeof a.c2texkey&&delete g[a.c2texkey],this.gl.deleteTexture(a)))};a.prototype.estimateVRAM=function(){var a=8*this.width*this.height,c,b,g;c=0;for(b=l.length;c<b;c++)g=l[c],a+=4*g.c2width*g.c2height;return a};a.prototype.textureCount=function(){return l.length};a.prototype.setRenderingToTexture=function(a){if(a!==this.renderToTex){var c=this.pushBatch();c.type=6;this.renderToTex=c.texParam=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};cr.GLWrap=a})();
(function(){function a(a){if(a&&(a.getContext||a.dc)&&!a.c2runtime){a.c2runtime=this;var c=this;this.isCrosswalk=/crosswalk/i.test(navigator.userAgent)||/xwalk/i.test(navigator.userAgent)||!("undefined"===typeof window.c2isCrosswalk||!window.c2isCrosswalk);this.isPhoneGap=!this.isCrosswalk&&"undefined"!==typeof window.device&&("undefined"!==typeof window.device.cordova||"undefined"!==typeof window.device.phonegap);this.isDirectCanvas=!!a.dc;this.isAppMobi="undefined"!==typeof window.AppMobi||this.isDirectCanvas;
this.isCocoonJs=!!window.c2cocoonjs;this.isEjecta=!!window.c2ejecta;this.isCocoonJs&&(CocoonJS.App.onSuspended.addEventListener(function(){c.setSuspended(!0)}),CocoonJS.App.onActivated.addEventListener(function(){c.setSuspended(!1)}));this.isEjecta&&(document.addEventListener("pagehide",function(){c.setSuspended(!0)}),document.addEventListener("pageshow",function(){c.setSuspended(!1)}),document.addEventListener("resize",function(){c.setSize(window.innerWidth,window.innerHeight)}));this.isDomFree=
this.isDirectCanvas||this.isCocoonJs||this.isEjecta;this.isTizen=/tizen/i.test(navigator.userAgent);this.isAndroid=/android/i.test(navigator.userAgent)&&!this.isTizen;this.isIE=/msie/i.test(navigator.userAgent)||/trident/i.test(navigator.userAgent);this.isiPhone=/iphone/i.test(navigator.userAgent)||/ipod/i.test(navigator.userAgent);this.isiPad=/ipad/i.test(navigator.userAgent);this.isiOS=this.isiPhone||this.isiPad||this.isEjecta;this.isiPhoneiOS6=this.isiPhone&&/os\s6/i.test(navigator.userAgent);
this.isChrome=/chrome/i.test(navigator.userAgent)||/chromium/i.test(navigator.userAgent);this.isAmazonWebApp=/amazonwebappplatform/i.test(navigator.userAgent);this.isFirefox=/firefox/i.test(navigator.userAgent);this.isSafari=!this.isChrome&&/safari/i.test(navigator.userAgent);this.isWindows=/windows/i.test(navigator.userAgent);this.isNodeWebkit="undefined"!==typeof window.c2nodewebkit||/nodewebkit/i.test(navigator.userAgent);this.isArcade="undefined"!==typeof window.is_scirra_arcade;this.isWindows8App=
!("undefined"===typeof window.c2isWindows8||!window.c2isWindows8);this.isWindows8Capable=!("undefined"===typeof window.c2isWindows8Capable||!window.c2isWindows8Capable);this.isWindowsPhone8=!("undefined"===typeof window.c2isWindowsPhone8||!window.c2isWindowsPhone8);this.isWindowsPhone81=!("undefined"===typeof window.c2isWindowsPhone81||!window.c2isWindowsPhone81);this.isWinJS=this.isWindows8App||this.isWindows8Capable||this.isWindowsPhone81;this.isBlackberry10=!("undefined"===typeof window.c2isBlackberry10||
!window.c2isBlackberry10);this.isAndroidStockBrowser=this.isAndroid&&!this.isChrome&&!this.isFirefox&&!this.isAmazonWebApp&&!this.isDomFree;this.devicePixelRatio=1;this.isMobile=this.isPhoneGap||this.isCrosswalk||this.isAppMobi||this.isCocoonJs||this.isAndroid||this.isiOS||this.isWindowsPhone8||this.isWindowsPhone81||this.isBlackberry10||this.isTizen||this.isEjecta;this.isMobile||(this.isMobile=/(blackberry|bb10|playbook|palm|symbian|nokia|windows\s+ce|phone|mobile|tablet|kindle|silk)/i.test(navigator.userAgent));
"undefined"===typeof cr_is_preview||this.isNodeWebkit||"?nw"!==window.location.search&&!/nodewebkit/i.test(navigator.userAgent)||(this.isNodeWebkit=!0);this.isDebug="undefined"!==typeof cr_is_preview&&-1<window.location.search.indexOf("debug");this.canvas=a;this.canvasdiv=document.getElementById("c2canvasdiv");this.ctx=this.glwrap=this.gl=null;this.fullscreenOldMarginCss="";this.firstInFullscreen=!1;this.oldHeight=this.oldWidth=0;this.canvas.oncontextmenu=function(a){a.preventDefault&&a.preventDefault();
return!1};this.canvas.onselectstart=function(a){a.preventDefault&&a.preventDefault();return!1};this.isDirectCanvas&&(window.c2runtime=this);this.isNodeWebkit&&(window.ondragover=function(a){a.preventDefault();return!1},window.ondrop=function(a){a.preventDefault();return!1},require("nw.gui").App.clearCache());this.width=a.width;this.height=a.height;this.draw_width=this.width;this.draw_height=this.height;this.cssWidth=this.width;this.cssHeight=this.height;this.lastWindowWidth=window.innerWidth;this.lastWindowHeight=
window.innerHeight;this.redraw=!0;this.isSuspended=!1;Date.now||(Date.now=function(){return+new Date});this.plugins=[];this.types={};this.types_by_index=[];this.behaviors=[];this.layouts={};this.layouts_by_index=[];this.eventsheets={};this.eventsheets_by_index=[];this.wait_for_textures=[];this.triggers_to_postinit=[];this.all_global_vars=[];this.all_local_vars=[];this.jumpthruBehavior=this.solidBehavior=null;this.deathRow=new cr.ObjectSet;this.isInClearDeathRow=!1;this.isInOnDestroy=0;this.isRunningEvents=
!1;this.createRow=[];this.isLoadingState=!1;this.lastSaveJson=this.loadFromJson=this.loadFromSlot=this.saveToSlot="";this.suspendDrawing=this.signalledContinuousPreview=!1;this.zeroDtCount=this.cpuutilisation=this.logictime=this.dt1=this.dt=0;this.timescale=1;this.kahanTime=new cr.KahanAdder;this.last_tick_time=0;this.measuring_dt=!0;this.objectcount=this.framecount=this.execcount=this.tickcount=this.last_fps_time=this.fps=0;this.changelayout=null;this.destroycallbacks=[];this.event_stack=[];this.event_stack_index=
-1;this.localvar_stack=[[]];this.trigger_depth=this.localvar_stack_index=0;this.pushEventStack(null);this.loop_stack=[];this.loop_stack_index=-1;this.next_puid=this.next_uid=0;this.layout_first_tick=!0;this.family_count=0;this.suspend_events=[];this.timeout_id=this.raf_id=-1;this.isloading=!0;this.loadingprogress=0;this.isNodeFullscreen=!1;this.stackLocalCount=0;this.halfFramerateMode=!1;this.lastRafTime=0;this.isInUserInputEvent=this.had_a_click=this.ranLastRaf=!1;this.objects_to_tick=new cr.ObjectSet;
this.objects_to_tick2=new cr.ObjectSet;this.registered_collisions=[];this.temp_poly=new cr.CollisionPoly([]);this.temp_poly2=new cr.CollisionPoly([]);this.allGroups=[];this.groups_by_name={};this.cndsBySid={};this.actsBySid={};this.varsBySid={};this.blocksBySid={};this.layout_ctx=this.layout_canvas=this.layout_tex=this.layer_tex=this.layer_ctx=this.layer_canvas=this.running_layout=null;this.uses_background_blending=this.is_WebGL_context_lost=!1;this.fx_tex=[null,null];this.fullscreen_scaling=0;this.files_subfolder=
"";this.objectsByUid={};this.snapshotCanvas=this.loaderlogo=null;this.snapshotData="";this.load();this.devicePixelRatio=(this.isRetina=(!this.isDomFree||this.isEjecta)&&this.useHighDpi&&!this.isAndroidStockBrowser)?window.devicePixelRatio||window.webkitDevicePixelRatio||window.mozDevicePixelRatio||window.msDevicePixelRatio||1:1;this.ClearDeathRow();var b,h=this.alphaBackground&&!(this.isNodeWebkit||this.isWinJS||this.isWindowsPhone8||this.isCrosswalk);0<this.fullscreen_mode&&this.setSize(window.innerWidth,
window.innerHeight,!0);try{this.enableWebGL&&(this.isCocoonJs||this.isEjecta||!this.isDomFree)&&(b={alpha:h,depth:!1,antialias:!1,failIfMajorPerformanceCaveat:!0},this.gl=a.getContext("webgl",b)||a.getContext("experimental-webgl",b))}catch(k){}if(this.gl){this.isDomFree||(this.overlay_canvas=document.createElement("canvas"),jQuery(this.overlay_canvas).appendTo(this.canvas.parentNode),this.overlay_canvas.oncontextmenu=function(a){return!1},this.overlay_canvas.onselectstart=function(a){return!1},this.overlay_canvas.width=
this.cssWidth,this.overlay_canvas.height=this.cssHeight,jQuery(this.overlay_canvas).css({width:this.cssWidth+"px",height:this.cssHeight+"px"}),this.positionOverlayCanvas(),this.overlay_ctx=this.overlay_canvas.getContext("2d"));this.glwrap=new cr.GLWrap(this.gl,this.isMobile);this.glwrap.setSize(a.width,a.height);this.ctx=null;this.canvas.addEventListener("webglcontextlost",function(a){a.preventDefault();c.onContextLost();console.log("[Construct 2] WebGL context lost");window.cr_setSuspended(!0)},
!1);this.canvas.addEventListener("webglcontextrestored",function(a){c.glwrap.initState();c.glwrap.setSize(c.glwrap.width,c.glwrap.height,!0);c.layer_tex=null;c.layout_tex=null;c.fx_tex[0]=null;c.fx_tex[1]=null;c.onContextRestored();c.redraw=!0;console.log("[Construct 2] WebGL context restored");window.cr_setSuspended(!1)},!1);var y,d,g,f,m,n;a=0;for(b=this.types_by_index.length;a<b;a++)for(d=this.types_by_index[a],h=0,y=d.effect_types.length;h<y;h++)f=d.effect_types[h],f.shaderindex=this.glwrap.getShaderIndex(f.id),
this.uses_background_blending=this.uses_background_blending||this.glwrap.programUsesDest(f.shaderindex);a=0;for(b=this.layouts_by_index.length;a<b;a++){m=this.layouts_by_index[a];h=0;for(y=m.effect_types.length;h<y;h++)f=m.effect_types[h],f.shaderindex=this.glwrap.getShaderIndex(f.id);h=0;for(y=m.layers.length;h<y;h++)for(n=m.layers[h],d=0,g=n.effect_types.length;d<g;d++)f=n.effect_types[d],f.shaderindex=this.glwrap.getShaderIndex(f.id),this.uses_background_blending=this.uses_background_blending||
this.glwrap.programUsesDest(f.shaderindex)}}else{if(0<this.fullscreen_mode&&this.isDirectCanvas){this.canvas=null;document.oncontextmenu=function(a){return!1};document.onselectstart=function(a){return!1};this.ctx=AppMobi.canvas.getContext("2d");try{this.ctx.samplingMode=this.linearSampling?"smooth":"sharp",this.ctx.globalScale=1,this.ctx.HTML5CompatibilityMode=!0,this.ctx.imageSmoothingEnabled=this.linearSampling}catch(e){}0!==this.width&&0!==this.height&&(this.ctx.width=this.width,this.ctx.height=
this.height)}this.ctx||(b=this.isCocoonJs?{antialias:!!this.linearSampling,alpha:h}:{alpha:h},this.ctx=a.getContext("2d",b),this.ctx.webkitImageSmoothingEnabled=this.linearSampling,this.ctx.mozImageSmoothingEnabled=this.linearSampling,this.ctx.msImageSmoothingEnabled=this.linearSampling,this.ctx.imageSmoothingEnabled=this.linearSampling);this.overlay_ctx=this.overlay_canvas=null}this.tickFunc=function(){c.tick(!1)};window==window.top||this.isDomFree||this.isWinJS||this.isWindowsPhone8||(document.addEventListener("mousedown",
function(){window.focus()},!0),document.addEventListener("touchstart",function(){window.focus()},!0));"undefined"!==typeof cr_is_preview&&(this.isCocoonJs&&console.log("[Construct 2] In preview-over-wifi via CocoonJS mode"),-1<window.location.search.indexOf("continuous")&&(cr.logexport("Reloading for continuous preview"),this.loadFromSlot="__c2_continuouspreview",this.suspendDrawing=!0),this.pauseOnBlur&&!this.isMobile&&(jQuery(window).focus(function(){c.setSuspended(!1)}),jQuery(window).blur(function(){c.setSuspended(!0)})));
0===this.fullscreen_mode&&this.isRetina&&1<this.devicePixelRatio&&this.setSize(this.original_width,this.original_height,!0);this.tryLockOrientation();this.go();this.extra={};cr.seal(this)}}function b(a){a.target.result.createObjectStore("saves",{keyPath:"slot"})}function e(a,c,d,h){var k=indexedDB.open("_C2SaveStates");k.onupgradeneeded=b;k.onerror=h;k.onsuccess=function(k){k=k.target.result;k.onerror=h;k.transaction(["saves"],"readwrite").objectStore("saves").put({slot:a,data:c}).onsuccess=d}}function l(a,
c,d){var h=indexedDB.open("_C2SaveStates");h.onupgradeneeded=b;h.onerror=d;h.onsuccess=function(k){k=k.target.result;k.onerror=d;var h=k.transaction(["saves"]).objectStore("saves").get(a);h.onsuccess=function(a){h.result?c(h.result.data):c(null)}}}function g(){cr.logexport("Reloading for continuous preview");window.c2cocoonjs?CocoonJS.App.reload():-1<window.location.search.indexOf("continuous")?window.location.reload(!0):window.location+="?continuous"}function m(a){var c,b={};for(c in a)!a.hasOwnProperty(c)||
a[c]instanceof cr.ObjectSet||a[c]&&"undefined"!==typeof a[c].c2userdata||(b[c]=a[c]);return b}a.prototype.setSize=function(a,c,b){var h=0,k=0,d=0,g=0,g=0,f=this.isiPhoneiOS6&&this.isSafari&&!navigator.standalone&&!this.isDomFree&&!this.isPhoneGap;f&&(c+=60);if(this.lastWindowWidth!==a||this.lastWindowHeight!==c||b){this.lastWindowWidth=a;this.lastWindowHeight=c;var m=this.fullscreen_mode,n=document.mozFullScreen||document.webkitIsFullScreen||!!document.msFullscreenElement||document.fullScreen||this.isNodeFullscreen;
if(n||0!==this.fullscreen_mode||b)n&&0<this.fullscreen_scaling&&(m=this.fullscreen_scaling),4<=m?(b=this.original_width/this.original_height,a/c>b?(d=c*b,5===m?(g=d/this.original_width,1<g?g=Math.floor(g):1>g&&(g=1/Math.ceil(1/g)),d=this.original_width*g,g*=this.original_height,h=(a-d)/2,k=(c-g)/2,a=d,c=g):(h=(a-d)/2,a=d)):(g=a/b,5===m?(g/=this.original_height,1<g?g=Math.floor(g):1>g&&(g=1/Math.ceil(1/g)),d=this.original_width*g,g*=this.original_height,h=(a-d)/2,k=(c-g)/2,a=d):k=(c-g)/2,c=g),n&&!this.isNodeWebkit&&
(k=h=0),h=Math.floor(h),k=Math.floor(k),a=Math.floor(a),c=Math.floor(c)):this.isNodeWebkit&&this.isNodeFullscreen&&0===this.fullscreen_mode_set&&(h=Math.floor((a-this.original_width)/2),k=Math.floor((c-this.original_height)/2),a=this.original_width,c=this.original_height),2>m&&(this.aspect_scale=this.devicePixelRatio),this.isRetina&&this.isiPad&&1<this.devicePixelRatio&&(1024<=a&&(a=1023),1024<=c&&(c=1023)),n=this.devicePixelRatio,this.cssWidth=a,this.cssHeight=c,this.width=Math.round(a*n),this.height=
Math.round(c*n),this.redraw=!0,this.wantFullscreenScalingQuality?(this.draw_width=this.width,this.draw_height=this.height,this.fullscreenScalingQuality=!0):this.width<this.original_width&&this.height<this.original_height||1===m?(this.draw_width=this.width,this.draw_height=this.height,this.fullscreenScalingQuality=!0):(this.draw_width=this.original_width,this.draw_height=this.original_height,this.fullscreenScalingQuality=!1,2===m?(b=this.original_width/this.original_height,m=this.lastWindowWidth/this.lastWindowHeight,
m<b?this.draw_width=this.draw_height*m:m>b&&(this.draw_height=this.draw_width/m)):3===m&&(b=this.original_width/this.original_height,m=this.lastWindowWidth/this.lastWindowHeight,m>b?this.draw_width=this.draw_height*m:m<b&&(this.draw_height=this.draw_width/m))),this.canvasdiv&&!this.isDomFree&&(jQuery(this.canvasdiv).css({width:a+"px",height:c+"px","margin-left":h,"margin-top":k}),"undefined"!==typeof cr_is_preview&&jQuery("#borderwrap").css({width:a+"px",height:c+"px"})),this.canvas&&(this.canvas.width=
Math.round(a*n),this.canvas.height=Math.round(c*n),this.isEjecta?(this.canvas.style.left=h+"px",this.canvas.style.top=k+"px",this.canvas.style.width=a+"px",this.canvas.style.height=c+"px"):this.isRetina&&!this.isDomFree&&jQuery(this.canvas).css({width:a+"px",height:c+"px"})),this.overlay_canvas&&(this.overlay_canvas.width=a,this.overlay_canvas.height=c,jQuery(this.overlay_canvas).css({width:a+"px",height:c+"px"})),this.glwrap&&this.glwrap.setSize(Math.round(a*n),Math.round(c*n)),this.isDirectCanvas&&
this.ctx&&(this.ctx.width=a,this.ctx.height=c),this.ctx&&(this.ctx.webkitImageSmoothingEnabled=this.linearSampling,this.ctx.mozImageSmoothingEnabled=this.linearSampling,this.ctx.msImageSmoothingEnabled=this.linearSampling,this.ctx.imageSmoothingEnabled=this.linearSampling),this.tryLockOrientation(),this.isDomFree||!f&&!this.isiPhone||window.setTimeout(function(){window.scrollTo(0,1)},100)}};a.prototype.tryLockOrientation=function(){if(this.autoLockOrientation&&0!==this.orientations){var a="portrait";
2===this.orientations&&(a="landscape");screen.lockOrientation?screen.lockOrientation(a):screen.webkitLockOrientation?screen.webkitLockOrientation(a):screen.mozLockOrientation?screen.mozLockOrientation(a):screen.msLockOrientation&&screen.msLockOrientation(a)}};a.prototype.onContextLost=function(){this.is_WebGL_context_lost=!0;var a,c,b;a=0;for(c=this.types_by_index.length;a<c;a++)if(b=this.types_by_index[a],b.onLostWebGLContext)b.onLostWebGLContext()};a.prototype.onContextRestored=function(){this.is_WebGL_context_lost=
!1;var a,c,b;a=0;for(c=this.types_by_index.length;a<c;a++)if(b=this.types_by_index[a],b.onRestoreWebGLContext)b.onRestoreWebGLContext()};a.prototype.positionOverlayCanvas=function(){if(!this.isDomFree){var a=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||document.msFullscreenElement||this.isNodeFullscreen?jQuery(this.canvas).offset():jQuery(this.canvas).position();a.position="absolute";jQuery(this.overlay_canvas).css(a)}};var c=window.cancelAnimationFrame||window.mozCancelAnimationFrame||
window.webkitCancelAnimationFrame||window.msCancelAnimationFrame||window.oCancelAnimationFrame;a.prototype.setSuspended=function(a){var b;if(a&&!this.isSuspended)for(cr.logexport("[Construct 2] Suspending"),this.isSuspended=!0,-1!==this.raf_id&&c&&c(this.raf_id),-1!==this.timeout_id&&clearTimeout(this.timeout_id),a=0,b=this.suspend_events.length;a<b;a++)this.suspend_events[a](!0);else if(!a&&this.isSuspended){cr.logexport("[Construct 2] Resuming");this.isSuspended=!1;this.last_tick_time=cr.performance_now();
this.last_fps_time=cr.performance_now();a=this.logictime=this.framecount=0;for(b=this.suspend_events.length;a<b;a++)this.suspend_events[a](!1);this.tick(!1)}};a.prototype.addSuspendCallback=function(a){this.suspend_events.push(a)};a.prototype.load=function(){var a=cr.getProjectModel();this.name=a[0];this.first_layout=a[1];this.fullscreen_mode=a[11];this.fullscreen_mode_set=a[11];this.original_width=a[9];this.original_height=a[10];this.parallax_x_origin=this.original_width/2;this.parallax_y_origin=
this.original_height/2;this.isDomFree&&!this.isEjecta&&(4<=a[11]||0===a[11])&&(cr.logexport("[Construct 2] Letterbox scale fullscreen modes are not supported on this platform - falling back to 'Scale outer'"),this.fullscreen_mode_set=this.fullscreen_mode=3);this.uses_loader_layout=a[17];this.loaderstyle=a[18];0===this.loaderstyle&&(this.loaderlogo=new Image,this.loaderlogo.src="loading-logo.png");this.next_uid=a[20];this.system=new cr.system_object(this);var c,b,h,k,g,d,f,m,n;c=0;for(b=a[2].length;c<
b;c++){f=a[2][c];cr.add_common_aces(f);n=new f[0](this);n.singleglobal=f[1];n.is_world=f[2];n.must_predraw=f[9];if(n.onCreate)n.onCreate();cr.seal(n);this.plugins.push(n)}a=cr.getProjectModel();c=0;for(b=a[3].length;c<b;c++){f=a[3][c];g=f[1];n=null;h=0;for(k=this.plugins.length;h<k;h++)if(this.plugins[h]instanceof g){n=this.plugins[h];break}var e=new n.Type(n);e.name=f[0];e.is_family=f[2];e.instvar_sids=f[3].slice(0);e.vars_count=f[3].length;e.behs_count=f[4];e.fx_count=f[5];e.sid=f[11];e.is_family?
(e.members=[],e.family_index=this.family_count++,e.families=null):(e.members=null,e.family_index=-1,e.families=[]);e.family_var_map=null;e.family_beh_map=null;e.family_fx_map=null;e.is_contained=!1;e.container=null;f[6]?(e.texture_file=f[6][0],e.texture_filesize=f[6][1],e.texture_pixelformat=f[6][2]):(e.texture_file=null,e.texture_filesize=0,e.texture_pixelformat=0);e.animations=f[7]?f[7]:null;e.index=c;e.instances=[];e.deadCache=[];e.solstack=[new cr.selection(e)];e.cur_sol=0;e.default_instance=
null;e.default_layerindex=0;e.stale_iids=!0;e.updateIIDs=cr.type_updateIIDs;e.getFirstPicked=cr.type_getFirstPicked;e.getPairedInstance=cr.type_getPairedInstance;e.getCurrentSol=cr.type_getCurrentSol;e.pushCleanSol=cr.type_pushCleanSol;e.pushCopySol=cr.type_pushCopySol;e.popSol=cr.type_popSol;e.getBehaviorByName=cr.type_getBehaviorByName;e.getBehaviorIndexByName=cr.type_getBehaviorIndexByName;e.getEffectIndexByName=cr.type_getEffectIndexByName;e.applySolToContainer=cr.type_applySolToContainer;e.getInstanceByIID=
cr.type_getInstanceByIID;e.collision_grid=new cr.SparseGrid(this.original_width,this.original_height);e.any_cell_changed=!0;e.any_instance_parallaxed=!1;e.extra={};e.toString=cr.type_toString;e.behaviors=[];h=0;for(k=f[8].length;h<k;h++){m=f[8][h];var q=m[1],l=null;g=0;for(d=this.behaviors.length;g<d;g++)if(this.behaviors[g]instanceof q){l=this.behaviors[g];break}if(!l){l=new q(this);l.my_types=[];l.my_instances=new cr.ObjectSet;if(l.onCreate)l.onCreate();cr.seal(l);this.behaviors.push(l);cr.behaviors.solid&&
l instanceof cr.behaviors.solid&&(this.solidBehavior=l);cr.behaviors.jumpthru&&l instanceof cr.behaviors.jumpthru&&(this.jumpthruBehavior=l)}-1===l.my_types.indexOf(e)&&l.my_types.push(e);g=new l.Type(l,e);g.name=m[0];g.sid=m[2];g.onCreate();cr.seal(g);e.behaviors.push(g)}e.global=f[9];e.isOnLoaderLayout=f[10];e.effect_types=[];h=0;for(k=f[12].length;h<k;h++)e.effect_types.push({id:f[12][h][0],name:f[12][h][1],shaderindex:-1,active:!0,index:h});e.tile_poly_data=f[13];if(!this.uses_loader_layout||
e.is_family||e.isOnLoaderLayout||!n.is_world)e.onCreate(),cr.seal(e);e.name&&(this.types[e.name]=e);this.types_by_index.push(e);n.singleglobal&&(h=new n.Instance(e),h.uid=this.next_uid++,h.puid=this.next_puid++,h.iid=0,h.get_iid=cr.inst_get_iid,h.toString=cr.inst_toString,h.properties=f[14],h.onCreate(),cr.seal(h),e.instances.push(h),this.objectsByUid[h.uid.toString()]=h)}c=0;for(b=a[4].length;c<b;c++)for(g=a[4][c],d=this.types_by_index[g[0]],h=1,k=g.length;h<k;h++)f=this.types_by_index[g[h]],f.families.push(d),
d.members.push(f);c=0;for(b=a[23].length;c<b;c++){g=a[23][c];d=[];h=0;for(k=g.length;h<k;h++)d.push(this.types_by_index[g[h]]);h=0;for(k=d.length;h<k;h++)d[h].is_contained=!0,d[h].container=d}if(0<this.family_count)for(c=0,b=this.types_by_index.length;c<b;c++)if(f=this.types_by_index[c],!f.is_family&&f.families.length){f.family_var_map=Array(this.family_count);f.family_beh_map=Array(this.family_count);f.family_fx_map=Array(this.family_count);e=[];h=l=q=m=0;for(k=f.families.length;h<k;h++)for(n=f.families[h],
f.family_var_map[n.family_index]=m,m+=n.vars_count,f.family_beh_map[n.family_index]=q,q+=n.behs_count,f.family_fx_map[n.family_index]=l,l+=n.fx_count,g=0,d=n.effect_types.length;g<d;g++)e.push(cr.shallowCopy({},n.effect_types[g]));f.effect_types=e.concat(f.effect_types);h=0;for(k=f.effect_types.length;h<k;h++)f.effect_types[h].index=h}c=0;for(b=a[5].length;c<b;c++)f=a[5][c],h=new cr.layout(this,f),cr.seal(h),this.layouts[h.name]=h,this.layouts_by_index.push(h);c=0;for(b=a[6].length;c<b;c++)f=a[6][c],
h=new cr.eventsheet(this,f),cr.seal(h),this.eventsheets[h.name]=h,this.eventsheets_by_index.push(h);c=0;for(b=this.eventsheets_by_index.length;c<b;c++)this.eventsheets_by_index[c].postInit();c=0;for(b=this.eventsheets_by_index.length;c<b;c++)this.eventsheets_by_index[c].updateDeepIncludes();c=0;for(b=this.triggers_to_postinit.length;c<b;c++)this.triggers_to_postinit[c].postInit();this.triggers_to_postinit.length=0;this.files_subfolder=a[7];this.pixel_rounding=a[8];this.aspect_scale=1;this.enableWebGL=
a[12];this.linearSampling=a[13];this.alphaBackground=a[14];this.versionstr=a[15];this.useHighDpi=a[16];this.orientations=a[19];this.autoLockOrientation=0<this.orientations;this.pauseOnBlur=a[21];this.fullscreenScalingQuality=this.wantFullscreenScalingQuality=a[22];this.start_time=Date.now()};var p=!1;a.prototype.waitForImageLoad=function(a){a.onerror=function(c){p=a.c2error=!0;console&&console.error&&console.error("Error loading image '"+a.src+"': ",c)};this.wait_for_textures.push(a)};a.prototype.findWaitingTexture=
function(a){var c,b;c=0;for(b=this.wait_for_textures.length;c<b;c++)if(this.wait_for_textures[c].cr_src===a)return this.wait_for_textures[c];return null};a.prototype.areAllTexturesLoaded=function(){var a=0,c=0,b=!0,h,k,g;h=0;for(k=this.wait_for_textures.length;h<k;h++){g=this.wait_for_textures[h];var d=g.cr_filesize;if(!d||0>=d)d=5E4;a+=d;!g.complete&&!g.loaded||g.c2error?b=!1:c+=d}this.progress=0==a?0:c/a;return b};a.prototype.go=function(){if(this.ctx||this.glwrap){var a=this.ctx||this.overlay_ctx;
this.overlay_canvas&&this.positionOverlayCanvas();this.progress=0;this.last_progress=-1;if(this.areAllTexturesLoaded())this.go_textures_done();else{var c=Date.now()-this.start_time;if(a){var b=this.width,h=this.height,k=this.devicePixelRatio;this.overlay_canvas&&(b=this.cssWidth,h=this.cssHeight,k=1);if(3!==this.loaderstyle&&(this.isCocoonJs||500<=c&&this.last_progress!=this.progress)){a.clearRect(0,0,b,h);var c=b/2,h=h/2,b=0===this.loaderstyle&&this.loaderlogo.complete,g=40*k,d=0,f=80*k,m;b&&(f=
this.loaderlogo.width*k,m=this.loaderlogo.height*k,g=f/2,d=m/2,a.drawImage(this.loaderlogo,cr.floor(c-g),cr.floor(h-d),f,m));1>=this.loaderstyle?(h+=d+(b?12*k:0),c=cr.floor(c-g)+0.5,h=cr.floor(h)+0.5,a.fillStyle=p?"red":"DodgerBlue",a.fillRect(c,h,Math.floor(f*this.progress),6*k),a.strokeStyle="black",a.strokeRect(c,h,f,6*k),a.strokeStyle="white",a.strokeRect(c-1*k,h-1*k,f+2*k,8*k)):2===this.loaderstyle&&(a.font=this.isEjecta?"12pt ArialMT":"12pt Arial",a.fillStyle=p?"#f00":"#999",a.textBaseLine=
"middle",k=Math.round(100*this.progress)+"%",b=a.measureText?a.measureText(k):null,a.fillText(k,c-(b?b.width:0)/2,h))}this.last_progress=this.progress}setTimeout(function(a){return function(){a.go()}}(this),this.isCocoonJs?10:100)}}};a.prototype.go_textures_done=function(){this.overlay_canvas&&(this.canvas.parentNode.removeChild(this.overlay_canvas),this.overlay_canvas=this.overlay_ctx=null);this.start_time=Date.now();this.last_fps_time=cr.performance_now();var a,c,b;if(this.uses_loader_layout)for(a=
0,c=this.types_by_index.length;a<c;a++)b=this.types_by_index[a],b.is_family||b.isOnLoaderLayout||!b.plugin.is_world||(b.onCreate(),cr.seal(b));else this.isloading=!1;a=0;for(c=this.layouts_by_index.length;a<c;a++)this.layouts_by_index[a].createGlobalNonWorlds();2<=this.fullscreen_mode&&(a=this.original_width/this.original_height,c=this.width/this.height,this.aspect_scale=2!==this.fullscreen_mode&&c>a||2===this.fullscreen_mode&&c<a?this.height/this.original_height:this.width/this.original_width);this.first_layout?
this.layouts[this.first_layout].startRunning():this.layouts_by_index[0].startRunning();this.uses_loader_layout||(this.loadingprogress=1,this.trigger(cr.system_object.prototype.cnds.OnLoadFinished,null));navigator.splashscreen&&navigator.splashscreen.hide&&navigator.splashscreen.hide();a=0;for(c=this.types_by_index.length;a<c;a++)if(b=this.types_by_index[a],b.onAppBegin)b.onAppBegin();this.tick(!1);this.isDirectCanvas&&AppMobi.webview.execute("onGameReady();")};var f=window.requestAnimationFrame||
window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame||window.oRequestAnimationFrame;a.prototype.tick=function(a){if(this.running_layout){var c=cr.performance_now();if(this.halfFramerateMode&&this.ranLastRaf&&29>c-this.lastRafTime)this.ranLastRaf=!1,this.lastRafTime=c,f?this.raf_id=f(this.tickFunc,this.canvas):this.timeout_id=setTimeout(this.tickFunc,this.isMobile?1:16);else{this.ranLastRaf=!0;this.lastRafTime=c;var b=this.fullscreen_mode,h=document.mozFullScreen||
document.webkitIsFullScreen||document.fullScreen||!!document.msFullscreenElement;(h||this.isNodeFullscreen)&&0<this.fullscreen_scaling&&(b=this.fullscreen_scaling);if(0<b&&(!this.isiPhone||window.self!==window.top)){var b=window.innerWidth,k=window.innerHeight;this.lastWindowWidth===b&&this.lastWindowHeight===k||this.setSize(b,k)}this.isDomFree||(h?(this.firstInFullscreen||(this.fullscreenOldMarginCss=jQuery(this.canvas).css("margin")||"0",this.firstInFullscreen=!0),this.isChrome||this.isNodeWebkit||
jQuery(this.canvas).css({"margin-left":""+Math.floor((screen.width-this.width/this.devicePixelRatio)/2)+"px","margin-top":""+Math.floor((screen.height-this.height/this.devicePixelRatio)/2)+"px"})):this.firstInFullscreen?(this.isChrome||this.isNodeWebkit||jQuery(this.canvas).css("margin",this.fullscreenOldMarginCss),this.fullscreenOldMarginCss="",this.firstInFullscreen=!1,0===this.fullscreen_mode&&this.setSize(Math.round(this.oldWidth/this.devicePixelRatio),Math.round(this.oldHeight/this.devicePixelRatio),
!0)):(this.oldWidth=this.width,this.oldHeight=this.height));this.isloading&&(h=this.areAllTexturesLoaded(),this.loadingprogress=this.progress,h&&(this.isloading=!1,this.progress=1,this.trigger(cr.system_object.prototype.cnds.OnLoadFinished,null)));this.logic();!this.redraw&&!this.isCocoonJs||this.is_WebGL_context_lost||this.suspendDrawing||a||(this.redraw=!1,this.glwrap?this.drawGL():this.draw(),this.snapshotCanvas&&(this.canvas&&this.canvas.toDataURL&&(this.snapshotData=this.canvas.toDataURL(this.snapshotCanvas[0],
this.snapshotCanvas[1]),this.trigger(cr.system_object.prototype.cnds.OnCanvasSnapshot,null)),this.snapshotCanvas=null));this.hit_breakpoint||(this.tickcount++,this.execcount++,this.framecount++);this.logictime+=cr.performance_now()-c;this.isSuspended||a||(f?this.raf_id=f(this.tickFunc,this.canvas):this.timeout_id=setTimeout(this.tickFunc,this.isMobile?1:16))}}};a.prototype.logic=function(){var a,c,b,h,k,g,d,f,m;a=cr.performance_now();1E3<=a-this.last_fps_time&&(this.last_fps_time+=1E3,this.fps=this.framecount,
this.framecount=0,this.cpuutilisation=this.logictime,this.logictime=0);this.measuring_dt&&(0!==this.last_tick_time&&(c=a-this.last_tick_time,0!==c||this.isDebug?(this.dt1=c/1E3,0.5<this.dt1?this.dt1=0:0.1<this.dt1&&(this.dt1=0.1)):(this.zeroDtCount++,10<=this.zeroDtCout&&(this.measuring_dt=!1),this.dt1=1/60)),this.last_tick_time=a);this.dt=this.dt1*this.timescale;this.kahanTime.add(this.dt);a=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||!!document.msFullscreenElement||
this.isNodeFullscreen;2<=this.fullscreen_mode||a&&0<this.fullscreen_scaling?(c=this.original_width/this.original_height,b=this.width/this.height,h=this.fullscreen_mode,a&&0<this.fullscreen_scaling&&(h=this.fullscreen_scaling),this.aspect_scale=2!==h&&b>c||2===h&&b<c?this.height/this.original_height:this.width/this.original_width,this.running_layout&&(this.running_layout.scrollToX(this.running_layout.scrollX),this.running_layout.scrollToY(this.running_layout.scrollY))):this.aspect_scale=this.isRetina?
this.devicePixelRatio:1;this.ClearDeathRow();this.isInOnDestroy++;this.system.runWaits();this.isInOnDestroy--;this.ClearDeathRow();this.isInOnDestroy++;a=0;for(c=this.types_by_index.length;a<c;a++)if(d=this.types_by_index[a],!d.is_family&&(d.behaviors.length||d.families.length))for(b=0,h=d.instances.length;b<h;b++)for(f=d.instances[b],k=0,g=f.behavior_insts.length;k<g;k++)f.behavior_insts[k].tick();a=0;for(c=this.types_by_index.length;a<c;a++)if(d=this.types_by_index[a],!d.is_family&&(d.behaviors.length||
d.families.length))for(b=0,h=d.instances.length;b<h;b++)for(f=d.instances[b],k=0,g=f.behavior_insts.length;k<g;k++)m=f.behavior_insts[k],m.posttick&&m.posttick();b=this.objects_to_tick.valuesRef();a=0;for(c=b.length;a<c;a++)b[a].tick();this.isInOnDestroy--;this.handleSaveLoad();for(a=0;this.changelayout&&10>a++;)this.doChangeLayout(this.changelayout);a=0;for(c=this.eventsheets_by_index.length;a<c;a++)this.eventsheets_by_index[a].hasRun=!1;this.running_layout.event_sheet&&this.running_layout.event_sheet.run();
this.registered_collisions.length=0;this.layout_first_tick=!1;this.isInOnDestroy++;a=0;for(c=this.types_by_index.length;a<c;a++)if(d=this.types_by_index[a],!d.is_family&&(d.behaviors.length||d.families.length))for(b=0,h=d.instances.length;b<h;b++)for(f=d.instances[b],k=0,g=f.behavior_insts.length;k<g;k++)m=f.behavior_insts[k],m.tick2&&m.tick2();b=this.objects_to_tick2.valuesRef();a=0;for(c=b.length;a<c;a++)b[a].tick2();this.isInOnDestroy--};a.prototype.doChangeLayout=function(a){var c=this.running_layout;
this.running_layout.stopRunning();var b,h,k,g,d,f,m;if(this.glwrap)for(b=0,h=this.types_by_index.length;b<h;b++)d=this.types_by_index[b],d.is_family||!d.unloadTextures||d.global&&0!==d.instances.length||-1!==a.initial_types.indexOf(d)||d.unloadTextures();c==a&&(this.system.waits.length=0);a.startRunning();b=0;for(h=this.types_by_index.length;b<h;b++)if(d=this.types_by_index[b],d.global||d.plugin.singleglobal)for(a=0,c=d.instances.length;a<c;a++){f=d.instances[a];if(f.onLayoutChange)f.onLayoutChange();
if(f.behavior_insts)for(k=0,g=f.behavior_insts.length;k<g;k++)if(m=f.behavior_insts[k],m.onLayoutChange)m.onLayoutChange()}this.layout_first_tick=this.redraw=!0;this.ClearDeathRow()};a.prototype.tickMe=function(a){this.objects_to_tick.add(a)};a.prototype.untickMe=function(a){this.objects_to_tick.remove(a)};a.prototype.tick2Me=function(a){this.objects_to_tick2.add(a)};a.prototype.untick2Me=function(a){this.objects_to_tick2.remove(a)};a.prototype.getDt=function(a){return a&&-1!==a.my_timescale?this.dt1*
a.my_timescale:this.dt};a.prototype.draw=function(){this.running_layout.draw(this.ctx);this.isDirectCanvas&&this.ctx.present()};a.prototype.drawGL=function(){this.running_layout.drawGL(this.glwrap);this.glwrap.present()};a.prototype.addDestroyCallback=function(a){a&&this.destroycallbacks.push(a)};a.prototype.removeDestroyCallback=function(a){cr.arrayFindRemove(this.destroycallbacks,a)};a.prototype.getObjectByUID=function(a){a=a.toString();return this.objectsByUid.hasOwnProperty(a)?this.objectsByUid[a]:
null};a.prototype.DestroyInstance=function(a){var c,b;if(!this.deathRow.contains(a)){this.deathRow.add(a);if(a.is_contained)for(c=0,b=a.siblings.length;c<b;c++)this.DestroyInstance(a.siblings[c]);this.isInClearDeathRow&&this.deathRow.values_cache.push(a);this.isInOnDestroy++;this.trigger(Object.getPrototypeOf(a.type.plugin).cnds.OnDestroyed,a);this.isInOnDestroy--}};a.prototype.ClearDeathRow=function(){var a,c,b,h,k,d,g,f,m,e;this.isInClearDeathRow=!0;h=0;for(d=this.createRow.length;h<d;h++)for(a=
this.createRow[h],c=a.type,c.instances.push(a),k=0,g=c.families.length;k<g;k++)c.families[k].instances.push(a),c.families[k].stale_iids=!0;this.createRow.length=0;d=this.deathRow.valuesRef();for(h=0;h<d.length;h++){a=d[h];c=a.type;b=c.instances;k=0;for(g=this.destroycallbacks.length;k<g;k++)this.destroycallbacks[k](a);cr.arrayFindRemove(b,a);0===b.length&&(c.any_instance_parallaxed=!1);a.collcells&&c.collision_grid.update(a,a.collcells,null);a.layer&&(cr.arrayRemove(a.layer.instances,a.get_zindex()),
a.layer.zindices_stale=!0);k=0;for(g=c.families.length;k<g;k++)cr.arrayFindRemove(c.families[k].instances,a),c.families[k].stale_iids=!0;if(a.behavior_insts)for(k=0,g=a.behavior_insts.length;k<g;k++){b=a.behavior_insts[k];if(b.onDestroy)b.onDestroy();b.behavior.my_instances.remove(a)}this.objects_to_tick.remove(a);this.objects_to_tick2.remove(a);k=0;for(g=this.system.waits.length;k<g;k++)if(m=this.system.waits[k],m.sols.hasOwnProperty(c.index)&&cr.arrayFindRemove(m.sols[c.index].insts,a),!c.is_family)for(b=
0,f=c.families.length;b<f;b++)e=c.families[b],m.sols.hasOwnProperty(e.index)&&cr.arrayFindRemove(m.sols[e.index].insts,a);if(a.onDestroy)a.onDestroy();this.objectsByUid.hasOwnProperty(a.uid.toString())&&delete this.objectsByUid[a.uid.toString()];this.objectcount--;64>c.deadCache.length&&c.deadCache.push(a);c.stale_iids=!0}this.deathRow.isEmpty()||(this.redraw=!0);this.deathRow.clear();this.isInClearDeathRow=!1};a.prototype.createInstance=function(a,c,b,h){if(a.is_family){var k=cr.floor(Math.random()*
a.members.length);return this.createInstance(a.members[k],c,b,h)}return a.default_instance?this.createInstanceFromInit(a.default_instance,c,!1,b,h,!1):null};var n=[];a.prototype.createInstanceFromInit=function(a,c,b,h,k,g){var d,f,m,e;if(!a)return null;var q=this.types_by_index[a[1]],l=q.plugin.is_world;if(this.isloading&&l&&!q.isOnLoaderLayout||l&&!this.glwrap&&11===a[0][11])return null;var u=c;l||(c=null);var p;q.deadCache.length?(p=q.deadCache.pop(),p.recycled=!0,q.plugin.Instance.call(p,q)):(p=
new q.plugin.Instance(q),p.recycled=!1);p.uid=b&&!g?a[2]:this.next_uid++;this.objectsByUid[p.uid.toString()]=p;p.puid=this.next_puid++;p.iid=q.instances.length;d=0;for(f=this.createRow.length;d<f;++d)this.createRow[d].type===q&&p.iid++;p.get_iid=cr.inst_get_iid;m=a[3];if(p.recycled)cr.wipe(p.extra);else{p.extra={};if("undefined"!==typeof cr_is_preview)for(p.instance_var_names=[],p.instance_var_names.length=m.length,d=0,f=m.length;d<f;d++)p.instance_var_names[d]=m[d][1];p.instance_vars=[];p.instance_vars.length=
m.length}d=0;for(f=m.length;d<f;d++)p.instance_vars[d]=m[d][0];if(l){var t=a[0];p.x=cr.is_undefined(h)?t[0]:h;p.y=cr.is_undefined(k)?t[1]:k;p.z=t[2];p.width=t[3];p.height=t[4];p.depth=t[5];p.angle=t[6];p.opacity=t[7];p.hotspotX=t[8];p.hotspotY=t[9];p.blend_mode=t[10];d=t[11];!this.glwrap&&q.effect_types.length&&(p.blend_mode=d);p.compositeOp=cr.effectToCompositeOp(p.blend_mode);this.gl&&cr.setGLBlend(p,p.blend_mode,this.gl);if(p.recycled){d=0;for(f=t[12].length;d<f;d++)for(m=0,e=t[12][d].length;m<
e;m++)p.effect_params[d][m]=t[12][d][m];p.bbox.set(0,0,0,0);p.collcells.set(0,0,-1,-1);p.bquad.set_from_rect(p.bbox);p.bbox_changed_callbacks.length=0}else{p.effect_params=t[12].slice(0);d=0;for(f=p.effect_params.length;d<f;d++)p.effect_params[d]=t[12][d].slice(0);p.active_effect_types=[];p.active_effect_flags=[];p.active_effect_flags.length=q.effect_types.length;p.bbox=new cr.rect(0,0,0,0);p.collcells=new cr.rect(0,0,-1,-1);p.bquad=new cr.quad;p.bbox_changed_callbacks=[];p.set_bbox_changed=cr.set_bbox_changed;
p.add_bbox_changed_callback=cr.add_bbox_changed_callback;p.contains_pt=cr.inst_contains_pt;p.update_bbox=cr.update_bbox;p.update_collision_cell=cr.update_collision_cell;p.get_zindex=cr.inst_get_zindex}p.tilemap_exists=!1;p.tilemap_width=0;p.tilemap_height=0;p.tilemap_data=null;14===t.length&&(p.tilemap_exists=!0,p.tilemap_width=t[13][0],p.tilemap_height=t[13][1],p.tilemap_data=t[13][2]);d=0;for(f=q.effect_types.length;d<f;d++)p.active_effect_flags[d]=!0;p.updateActiveEffects=cr.inst_updateActiveEffects;
p.updateActiveEffects();p.uses_shaders=!!p.active_effect_types.length;p.bbox_changed=!0;p.cell_changed=!0;q.any_cell_changed=!0;p.visible=!0;p.my_timescale=-1;p.layer=c;p.zindex=c.instances.length;"undefined"===typeof p.collision_poly&&(p.collision_poly=null);this.redraw=p.collisionsEnabled=!0}p.toString=cr.inst_toString;var s;d=n.length=0;for(f=q.families.length;d<f;d++)n.push.apply(n,q.families[d].behaviors);n.push.apply(n,q.behaviors);if(p.recycled)for(d=0,f=n.length;d<f;d++){var w=n[d];s=p.behavior_insts[d];
s.recycled=!0;w.behavior.Instance.call(s,w,p);t=a[4][d];m=0;for(e=t.length;m<e;m++)s.properties[m]=t[m];s.onCreate();w.behavior.my_instances.add(p)}else for(p.behavior_insts=[],d=0,f=n.length;d<f;d++)w=n[d],s=new w.behavior.Instance(w,p),s.recycled=!1,s.properties=a[4][d].slice(0),s.onCreate(),cr.seal(s),p.behavior_insts.push(s),w.behavior.my_instances.add(p);t=a[5];if(p.recycled)for(d=0,f=t.length;d<f;d++)p.properties[d]=t[d];else p.properties=t.slice(0);this.createRow.push(p);c&&(c.instances.push(p),
1!==c.parallaxX||1!==c.parallaxY)&&(q.any_instance_parallaxed=!0);this.objectcount++;if(q.is_contained){if(p.is_contained=!0,p.recycled?p.siblings.length=0:p.siblings=[],!b&&!g){d=0;for(f=q.container.length;d<f;d++)if(q.container[d]!==q){if(!q.container[d].default_instance)return null;p.siblings.push(this.createInstanceFromInit(q.container[d].default_instance,u,!1,l?p.x:h,l?p.y:k,!0))}d=0;for(f=p.siblings.length;d<f;d++)for(p.siblings[d].siblings.push(p),m=0;m<f;m++)d!==m&&p.siblings[d].siblings.push(p.siblings[m])}}else p.is_contained=
!1,p.siblings=null;p.onCreate();p.recycled||cr.seal(p);d=0;for(f=p.behavior_insts.length;d<f;d++)p.behavior_insts[d].postCreate&&p.behavior_insts[d].postCreate();return p};a.prototype.getLayerByName=function(a){var c,b;c=0;for(b=this.running_layout.layers.length;c<b;c++){var h=this.running_layout.layers[c];if(cr.equals_nocase(h.name,a))return h}return null};a.prototype.getLayerByNumber=function(a){a=cr.floor(a);0>a&&(a=0);a>=this.running_layout.layers.length&&(a=this.running_layout.layers.length-
1);return this.running_layout.layers[a]};a.prototype.getLayer=function(a){return cr.is_number(a)?this.getLayerByNumber(a):this.getLayerByName(a.toString())};a.prototype.clearSol=function(a){var c,b;c=0;for(b=a.length;c<b;c++)a[c].getCurrentSol().select_all=!0};a.prototype.pushCleanSol=function(a){var c,b;c=0;for(b=a.length;c<b;c++)a[c].pushCleanSol()};a.prototype.pushCopySol=function(a){var c,b;c=0;for(b=a.length;c<b;c++)a[c].pushCopySol()};a.prototype.popSol=function(a){var c,b;c=0;for(b=a.length;c<
b;c++)a[c].popSol()};a.prototype.updateAllCells=function(a){if(a.any_cell_changed){var c,b,h=a.instances;c=0;for(b=h.length;c<b;++c)h[c].update_collision_cell();h=this.createRow;c=0;for(b=h.length;c<b;++c)h[c].type===a&&h[c].update_collision_cell();a.any_cell_changed=!1}};a.prototype.getCollisionCandidates=function(a,c,b,h){var k,d,g=a?1!==a.parallaxX||1!==a.parallaxY:!1;if(c.is_family)for(a=0,k=c.members.length;a<k;++a)d=c.members[a],g||d.any_instance_parallaxed?cr.appendArray(h,d.instances):(this.updateAllCells(d),
d.collision_grid.queryRange(b,h));else g||c.any_instance_parallaxed?cr.appendArray(h,c.instances):(this.updateAllCells(c),c.collision_grid.queryRange(b,h))};a.prototype.getTypesCollisionCandidates=function(a,c,b,h){var k,d;k=0;for(d=c.length;k<d;++k)this.getCollisionCandidates(a,c[k],b,h)};a.prototype.getSolidCollisionCandidates=function(a,c,b){var h=this.getSolidBehavior();if(!h)return null;this.getTypesCollisionCandidates(a,h.my_types,c,b)};a.prototype.getJumpthruCollisionCandidates=function(a,
c,b){var h=this.getJumpthruBehavior();if(!h)return null;this.getTypesCollisionCandidates(a,h.my_types,c,b)};a.prototype.testAndSelectCanvasPointOverlap=function(a,c,b,h){var k=a.getCurrentSol(),d,g,f,m,e,n;if(k.select_all)for(h||(k.select_all=!1,k.instances.length=0),d=0,m=a.instances.length;d<m;d++){if(f=a.instances[d],f.update_bbox(),e=f.layer.canvasToLayer(c,b,!0),n=f.layer.canvasToLayer(c,b,!1),f.contains_pt(e,n)){if(h)return!1;k.instances.push(f)}}else{d=g=0;for(m=k.instances.length;d<m;d++)if(f=
k.instances[d],f.update_bbox(),e=f.layer.canvasToLayer(c,b,!0),n=f.layer.canvasToLayer(c,b,!1),f.contains_pt(e,n)){if(h)return!1;k.instances[g]=k.instances[d];g++}h||(k.instances.length=g)}a.applySolToContainer();return h?!0:k.hasObjects()};a.prototype.testOverlap=function(a,c){if(!(a&&c&&a!==c&&a.collisionsEnabled&&c.collisionsEnabled))return!1;a.update_bbox();c.update_bbox();var b=a.layer,h=c.layer,k,d,g,f,m,e,n,q;if(b===h||b.parallaxX===h.parallaxX&&h.parallaxY===h.parallaxY&&b.scale===h.scale&&
b.angle===h.angle&&b.zoomRate===h.zoomRate){if(!a.bbox.intersects_rect(c.bbox)||!a.bquad.intersects_quad(c.bquad)||a.tilemap_exists&&c.tilemap_exists)return!1;if(a.tilemap_exists)return this.testTilemapOverlap(a,c);if(c.tilemap_exists)return this.testTilemapOverlap(c,a);n=a.collision_poly&&!a.collision_poly.is_empty();k=c.collision_poly&&!c.collision_poly.is_empty();if(!n&&!k)return!0;n?(a.collision_poly.cache_poly(a.width,a.height,a.angle),n=a.collision_poly):(this.temp_poly.set_from_quad(a.bquad,
a.x,a.y,a.width,a.height),n=this.temp_poly);k?(c.collision_poly.cache_poly(c.width,c.height,c.angle),q=c.collision_poly):(this.temp_poly.set_from_quad(c.bquad,c.x,c.y,c.width,c.height),q=this.temp_poly);return n.intersects_poly(q,c.x-a.x,c.y-a.y)}n=a.collision_poly&&!a.collision_poly.is_empty();k=c.collision_poly&&!c.collision_poly.is_empty();n?(a.collision_poly.cache_poly(a.width,a.height,a.angle),this.temp_poly.set_from_poly(a.collision_poly)):this.temp_poly.set_from_quad(a.bquad,a.x,a.y,a.width,
a.height);n=this.temp_poly;k?(c.collision_poly.cache_poly(c.width,c.height,c.angle),this.temp_poly2.set_from_poly(c.collision_poly)):this.temp_poly2.set_from_quad(c.bquad,c.x,c.y,c.width,c.height);q=this.temp_poly2;k=0;for(d=n.pts_count;k<d;k++)g=2*k,f=g+1,m=n.pts_cache[g],e=n.pts_cache[f],n.pts_cache[g]=b.layerToCanvas(m+a.x,e+a.y,!0),n.pts_cache[f]=b.layerToCanvas(m+a.x,e+a.y,!1);n.update_bbox();k=0;for(d=q.pts_count;k<d;k++)g=2*k,f=g+1,m=q.pts_cache[g],e=q.pts_cache[f],q.pts_cache[g]=h.layerToCanvas(m+
c.x,e+c.y,!0),q.pts_cache[f]=h.layerToCanvas(m+c.x,e+c.y,!1);q.update_bbox();return n.intersects_poly(q,0,0)};var d=new cr.quad,u=new cr.rect(0,0,0,0),s=[];a.prototype.testTilemapOverlap=function(a,c){var b,h,k,g,f=c.bbox,m=a.x,e=a.y;a.getCollisionRectCandidates(f,s);var n=c.collision_poly&&!c.collision_poly.is_empty();b=0;for(h=s.length;b<h;++b)if(k=s[b],g=k.rc,f.intersects_rect_off(g,m,e)&&(d.set_from_rect(g),d.offset(m,e),d.intersects_quad(c.bquad)))if(n)if(c.collision_poly.cache_poly(c.width,
c.height,c.angle),k.poly){if(k.poly.intersects_poly(c.collision_poly,c.x-(m+g.left),c.y-(e+g.top)))return s.length=0,!0}else{if(this.temp_poly.set_from_quad(d,0,0,g.right-g.left,g.bottom-g.top),this.temp_poly.intersects_poly(c.collision_poly,c.x,c.y))return s.length=0,!0}else if(k.poly){if(this.temp_poly.set_from_quad(c.bquad,0,0,c.width,c.height),k.poly.intersects_poly(this.temp_poly,-(m+g.left),-(e+g.top)))return s.length=0,!0}else return s.length=0,!0;s.length=0;return!1};a.prototype.testRectOverlap=
function(a,c){if(!c||!c.collisionsEnabled)return!1;c.update_bbox();if(!c.bbox.intersects_rect(a))return!1;if(c.tilemap_exists){c.getCollisionRectCandidates(a,s);var b,h,k,g,f=c.x,m=c.y;b=0;for(h=s.length;b<h;++b)if(k=s[b],g=k.rc,a.intersects_rect_off(g,f,m))if(k.poly){if(this.temp_poly.set_from_rect(a,0,0),k.poly.intersects_poly(this.temp_poly,-(f+g.left),-(m+g.top)))return s.length=0,!0}else return s.length=0,!0;s.length=0;return!1}d.set_from_rect(a);if(!c.bquad.intersects_quad(d))return!1;if(!c.collision_poly||
c.collision_poly.is_empty())return!0;c.collision_poly.cache_poly(c.width,c.height,c.angle);d.offset(-a.left,-a.top);this.temp_poly.set_from_quad(d,0,0,1,1);return c.collision_poly.intersects_poly(this.temp_poly,a.left-c.x,a.top-c.y)};a.prototype.testSegmentOverlap=function(a,c,b,h,k){if(!k||!k.collisionsEnabled)return!1;k.update_bbox();u.set(cr.min(a,b),cr.min(c,h),cr.max(a,b),cr.max(c,h));if(!k.bbox.intersects_rect(u))return!1;if(k.tilemap_exists){k.getCollisionRectCandidates(u,s);var g,f,m,e=k.x,
n=k.y;k=0;for(g=s.length;k<g;++k)if(f=s[k],m=f.rc,u.intersects_rect_off(m,e,n)&&(d.set_from_rect(m),d.offset(e,n),d.intersects_segment(a,c,b,h)))if(f.poly){if(f.poly.intersects_segment(e+m.left,n+m.top,a,c,b,h))return s.length=0,!0}else return s.length=0,!0;s.length=0;return!1}if(!k.bquad.intersects_segment(a,c,b,h))return!1;if(!k.collision_poly||k.collision_poly.is_empty())return!0;k.collision_poly.cache_poly(k.width,k.height,k.angle);return k.collision_poly.intersects_segment(k.x,k.y,a,c,b,h)};
a.prototype.typeHasBehavior=function(a,c){if(!c)return!1;var b,h,k,d,g;b=0;for(h=a.behaviors.length;b<h;b++)if(a.behaviors[b].behavior instanceof c)return!0;if(!a.is_family)for(b=0,h=a.families.length;b<h;b++)for(g=a.families[b],k=0,d=g.behaviors.length;k<d;k++)if(g.behaviors[k].behavior instanceof c)return!0;return!1};a.prototype.typeHasNoSaveBehavior=function(a){return this.typeHasBehavior(a,cr.behaviors.NoSave)};a.prototype.typeHasPersistBehavior=function(a){return this.typeHasBehavior(a,cr.behaviors.Persist)};
a.prototype.getSolidBehavior=function(){return this.solidBehavior};a.prototype.getJumpthruBehavior=function(){return this.jumpthruBehavior};var q=[];a.prototype.testOverlapSolid=function(a){var c,b,h;a.update_bbox();this.getSolidCollisionCandidates(a.layer,a.bbox,q);c=0;for(b=q.length;c<b;++c)if(h=q[c],h.extra.solidEnabled&&this.testOverlap(a,h))return q.length=0,h;q.length=0;return null};a.prototype.testRectOverlapSolid=function(a){var c,b,h;this.getSolidCollisionCandidates(null,a,q);c=0;for(b=q.length;c<
b;++c)if(h=q[c],h.extra.solidEnabled&&this.testRectOverlap(a,h))return q.length=0,h;q.length=0;return null};var t=[];a.prototype.testOverlapJumpThru=function(a,c){var b=null;c&&(b=t,b.length=0);a.update_bbox();this.getJumpthruCollisionCandidates(a.layer,a.bbox,q);var h,k,d;h=0;for(k=q.length;h<k;++h)if(d=q[h],d.extra.jumpthruEnabled&&this.testOverlap(a,d))if(c)b.push(d);else return q.length=0,d;q.length=0;return b};a.prototype.pushOutSolid=function(a,c,b,h,k,d){h=h||50;var g=a.x,f=a.y,m,e=null,n=
null;for(m=0;m<h;m++)if(a.x=g+c*m,a.y=f+b*m,a.set_bbox_changed(),!this.testOverlap(a,e)&&((e=this.testOverlapSolid(a))&&(n=e),!e&&(k&&(e=d?this.testOverlap(a,d)?d:null:this.testOverlapJumpThru(a))&&(n=e),!e)))return n&&this.pushInFractional(a,c,b,n,16),!0;a.x=g;a.y=f;a.set_bbox_changed();return!1};a.prototype.pushOut=function(a,c,b,h,k){h=h||50;var d=a.x,g=a.y,f;for(f=0;f<h;f++)if(a.x=d+c*f,a.y=g+b*f,a.set_bbox_changed(),!this.testOverlap(a,k))return!0;a.x=d;a.y=g;a.set_bbox_changed();return!1};a.prototype.pushInFractional=
function(a,c,b,h,k){var d=2,g,f=!1;g=!1;for(var m=a.x,e=a.y;d<=k;)g=1/d,d*=2,a.x+=c*g*(f?1:-1),a.y+=b*g*(f?1:-1),a.set_bbox_changed(),this.testOverlap(a,h)?g=f=!0:(g=f=!1,m=a.x,e=a.y);g&&(a.x=m,a.y=e,a.set_bbox_changed())};a.prototype.pushOutSolidNearest=function(a,c){var b=cr.is_undefined(c)?100:c,h=0,k=a.x,d=a.y,g=0,f=0,m=0,e=this.testOverlapSolid(a);if(!e)return!0;for(;h<=b;){switch(g){case 0:f=0;m=-1;h++;break;case 1:f=1;m=-1;break;case 2:f=1;m=0;break;case 3:m=f=1;break;case 4:f=0;m=1;break;
case 5:f=-1;m=1;break;case 6:f=-1;m=0;break;case 7:m=f=-1}g=(g+1)%8;a.x=cr.floor(k+f*h);a.y=cr.floor(d+m*h);a.set_bbox_changed();if(!this.testOverlap(a,e)&&(e=this.testOverlapSolid(a),!e))return!0}a.x=k;a.y=d;a.set_bbox_changed();return!1};a.prototype.registerCollision=function(a,c){a.collisionsEnabled&&c.collisionsEnabled&&this.registered_collisions.push([a,c])};a.prototype.checkRegisteredCollision=function(a,c){var b,h,k;b=0;for(h=this.registered_collisions.length;b<h;b++)if(k=this.registered_collisions[b],
k[0]==a&&k[1]==c||k[0]==c&&k[1]==a)return!0;return!1};a.prototype.calculateSolidBounceAngle=function(a,c,b,h){var k=a.x,d=a.y,g=cr.max(10,cr.distanceTo(c,b,k,d)),f=cr.angleTo(c,b,k,d),m=h||this.testOverlapSolid(a);if(!m)return cr.clamp_angle(f+cr.PI);var e=m,n,q,p,l,u=cr.to_radians(5);for(n=1;36>n;n++)if(q=f-n*u,a.x=c+Math.cos(q)*g,a.y=b+Math.sin(q)*g,a.set_bbox_changed(),!this.testOverlap(a,e)&&(e=h?null:this.testOverlapSolid(a),!e)){p=q;break}36===n&&(p=cr.clamp_angle(f+cr.PI));e=m;for(n=1;36>n;n++)if(q=
f+n*u,a.x=c+Math.cos(q)*g,a.y=b+Math.sin(q)*g,a.set_bbox_changed(),!this.testOverlap(a,e)&&(e=h?null:this.testOverlapSolid(a),!e)){l=q;break}36===n&&(l=cr.clamp_angle(f+cr.PI));a.x=k;a.y=d;a.set_bbox_changed();if(l===p)return l;a=cr.angleDiff(l,p)/2;a=cr.angleClockwise(l,p)?cr.clamp_angle(p+a+cr.PI):cr.clamp_angle(l+a);p=Math.cos(f);f=Math.sin(f);l=Math.cos(a);a=Math.sin(a);c=p*l+f*a;return cr.angleTo(0,0,p-2*c*l,f-2*c*a)};var w=-1;a.prototype.trigger=function(a,c,b){if(!this.running_layout)return!1;
var h=this.running_layout.event_sheet;if(!h)return!1;var k=!1,d,g,f;w++;var m=h.deep_includes;g=0;for(f=m.length;g<f;++g)d=this.triggerOnSheet(a,c,m[g],b),k=k||d;d=this.triggerOnSheet(a,c,h,b);w--;return k||d};a.prototype.triggerOnSheet=function(a,c,b,h){var k=!1,d,g,f,m;if(c)for(f=this.triggerOnSheetForTypeName(a,c,c.type.name,b,h),k=k||f,m=c.type.families,d=0,g=m.length;d<g;++d)f=this.triggerOnSheetForTypeName(a,c,m[d].name,b,h),k=k||f;else f=this.triggerOnSheetForTypeName(a,c,"system",b,h),k=k||
f;return k};a.prototype.triggerOnSheetForTypeName=function(a,c,b,h,k){var d,g=!1,f=!1,f="undefined"!==typeof k,m=(f?h.fasttriggers:h.triggers)[b];if(!m)return g;var e=null;h=0;for(d=m.length;h<d;++h)if(m[h].method==a){e=m[h].evs;break}if(!e)return g;a=f?e[k]:e;if(!a)return null;h=0;for(d=a.length;h<d;h++)k=a[h][0],f=a[h][1],f=this.executeSingleTrigger(c,b,k,f),g=g||f;return g};a.prototype.executeSingleTrigger=function(a,c,b,h){var k,d,g=!1;this.trigger_depth++;var f=this.getCurrentEventStack().current_event;
f&&this.pushCleanSol(f.solModifiersIncludingParents);var m=1<this.trigger_depth;this.pushCleanSol(b.solModifiersIncludingParents);m&&this.pushLocalVarStack();var e=this.pushEventStack(b);e.current_event=b;a&&(k=this.types[c].getCurrentSol(),k.select_all=!1,k.instances.length=1,k.instances[0]=a,this.types[c].applySolToContainer());a=!0;if(b.parent){c=e.temp_parents_arr;for(k=b.parent;k;)c.push(k),k=k.parent;c.reverse();k=0;for(d=c.length;k<d;k++)if(!c[k].run_pretrigger()){a=!1;break}}a&&(this.execcount++,
b.orblock?b.run_orblocktrigger(h):b.run(),g=g||e.last_event_true);this.popEventStack();m&&this.popLocalVarStack();this.popSol(b.solModifiersIncludingParents);f&&this.popSol(f.solModifiersIncludingParents);0!==this.isInOnDestroy||0!==w||this.isRunningEvents||this.deathRow.isEmpty()&&!this.createRow.length||this.ClearDeathRow();this.trigger_depth--;return g};a.prototype.getCurrentCondition=function(){var a=this.getCurrentEventStack();return a.current_event.conditions[a.cndindex]};a.prototype.getCurrentAction=
function(){var a=this.getCurrentEventStack();return a.current_event.actions[a.actindex]};a.prototype.pushLocalVarStack=function(){this.localvar_stack_index++;this.localvar_stack_index>=this.localvar_stack.length&&this.localvar_stack.push([])};a.prototype.popLocalVarStack=function(){this.localvar_stack_index--};a.prototype.getCurrentLocalVarStack=function(){return this.localvar_stack[this.localvar_stack_index]};a.prototype.pushEventStack=function(a){this.event_stack_index++;this.event_stack_index>=
this.event_stack.length&&this.event_stack.push(new cr.eventStackFrame);var c=this.getCurrentEventStack();c.reset(a);return c};a.prototype.popEventStack=function(){this.event_stack_index--};a.prototype.getCurrentEventStack=function(){return this.event_stack[this.event_stack_index]};a.prototype.pushLoopStack=function(a){this.loop_stack_index++;this.loop_stack_index>=this.loop_stack.length&&this.loop_stack.push(cr.seal({name:a,index:0,stopped:!1}));var c=this.getCurrentLoop();c.name=a;c.index=0;c.stopped=
!1;return c};a.prototype.popLoopStack=function(){this.loop_stack_index--};a.prototype.getCurrentLoop=function(){return this.loop_stack[this.loop_stack_index]};a.prototype.getEventVariableByName=function(a,c){for(var b,h,k,d,g,f;c;){b=0;for(h=c.subevents.length;b<h;b++)if(f=c.subevents[b],f instanceof cr.eventvariable&&cr.equals_nocase(a,f.name))return f;c=c.parent}b=0;for(h=this.eventsheets_by_index.length;b<h;b++)for(g=this.eventsheets_by_index[b],k=0,d=g.events.length;k<d;k++)if(f=g.events[k],f instanceof
cr.eventvariable&&cr.equals_nocase(a,f.name))return f;return null};a.prototype.getLayoutBySid=function(a){var c,b;c=0;for(b=this.layouts_by_index.length;c<b;c++)if(this.layouts_by_index[c].sid===a)return this.layouts_by_index[c];return null};a.prototype.getObjectTypeBySid=function(a){var c,b;c=0;for(b=this.types_by_index.length;c<b;c++)if(this.types_by_index[c].sid===a)return this.types_by_index[c];return null};a.prototype.getGroupBySid=function(a){var c,b;c=0;for(b=this.allGroups.length;c<b;c++)if(this.allGroups[c].sid===
a)return this.allGroups[c];return null};a.prototype.signalContinuousPreview=function(){this.signalledContinuousPreview=!0};a.prototype.handleSaveLoad=function(){var a=this,c=this.saveToSlot,b=this.lastSaveJson,h=this.loadFromSlot,k=!1;this.signalledContinuousPreview&&(k=!0,c="__c2_continuouspreview",this.signalledContinuousPreview=!1);if(c.length){this.ClearDeathRow();b=this.saveToJSONString();if(window.indexedDB&&!this.isCocoonJs)e(c,b,function(){cr.logexport("Saved state to IndexedDB storage ("+
b.length+" bytes)");a.lastSaveJson=b;a.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null);a.lastSaveJson="";k&&g()},function(h){try{localStorage.setItem("__c2save_"+c,b),cr.logexport("Saved state to WebStorage ("+b.length+" bytes)"),a.lastSaveJson=b,a.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null),a.lastSaveJson="",k&&g()}catch(d){cr.logexport("Failed to save game state: "+h+"; "+d)}});else try{localStorage.setItem("__c2save_"+c,b),cr.logexport("Saved state to WebStorage ("+
b.length+" bytes)"),a.lastSaveJson=b,this.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null),a.lastSaveJson="",k&&g()}catch(d){cr.logexport("Error saving to WebStorage: "+d)}this.loadFromJson=this.loadFromSlot=this.saveToSlot=""}h.length&&(window.indexedDB&&!this.isCocoonJs?l(h,function(k){k?(a.loadFromJson=k,cr.logexport("Loaded state from IndexedDB storage ("+a.loadFromJson.length+" bytes)")):(a.loadFromJson=localStorage.getItem("__c2save_"+h)||"",cr.logexport("Loaded state from WebStorage ("+
a.loadFromJson.length+" bytes)"));a.suspendDrawing=!1;a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)},function(k){a.loadFromJson=localStorage.getItem("__c2save_"+h)||"";cr.logexport("Loaded state from WebStorage ("+a.loadFromJson.length+" bytes)");a.suspendDrawing=!1;a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)}):(this.loadFromJson=localStorage.getItem("__c2save_"+h)||"",cr.logexport("Loaded state from WebStorage ("+this.loadFromJson.length+
" bytes)"),this.suspendDrawing=!1,a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)),this.saveToSlot=this.loadFromSlot="");this.loadFromJson.length&&(this.ClearDeathRow(),this.loadFromJSONString(this.loadFromJson),this.lastSaveJson=this.loadFromJson,this.trigger(cr.system_object.prototype.cnds.OnLoadComplete,null),this.loadFromJson=this.lastSaveJson="")};a.prototype.saveToJSONString=function(){var a,c,b,h,k,d,g,f={c2save:!0,version:1,rt:{time:this.kahanTime.sum,timescale:this.timescale,
tickcount:this.tickcount,execcount:this.execcount,next_uid:this.next_uid,running_layout:this.running_layout.sid,start_time_offset:Date.now()-this.start_time},types:{},layouts:{},events:{groups:{},cnds:{},acts:{},vars:{}}};a=0;for(c=this.types_by_index.length;a<c;a++)if(k=this.types_by_index[a],!k.is_family&&!this.typeHasNoSaveBehavior(k)){d={instances:[]};cr.hasAnyOwnProperty(k.extra)&&(d.ex=m(k.extra));b=0;for(h=k.instances.length;b<h;b++)d.instances.push(this.saveInstanceToJSON(k.instances[b]));
f.types[k.sid.toString()]=d}a=0;for(c=this.layouts_by_index.length;a<c;a++)b=this.layouts_by_index[a],f.layouts[b.sid.toString()]=b.saveToJSON();h=f.events.groups;a=0;for(c=this.allGroups.length;a<c;a++)b=this.allGroups[a],h[b.sid.toString()]=this.groups_by_name[b.group_name].group_active;c=f.events.cnds;for(g in this.cndsBySid)this.cndsBySid.hasOwnProperty(g)&&(a=this.cndsBySid[g],cr.hasAnyOwnProperty(a.extra)&&(c[g]={ex:m(a.extra)}));c=f.events.acts;for(g in this.actsBySid)this.actsBySid.hasOwnProperty(g)&&
(a=this.actsBySid[g],cr.hasAnyOwnProperty(a.extra)&&(c[g]={ex:a.extra}));c=f.events.vars;for(g in this.varsBySid)this.varsBySid.hasOwnProperty(g)&&(a=this.varsBySid[g],a.is_constant||a.parent&&!a.is_static||(c[g]=a.data));f.system=this.system.saveToJSON();return JSON.stringify(f)};a.prototype.refreshUidMap=function(){var a,c,b,h,k,d;this.objectsByUid={};a=0;for(c=this.types_by_index.length;a<c;a++)if(b=this.types_by_index[a],!b.is_family)for(h=0,k=b.instances.length;h<k;h++)d=b.instances[h],this.objectsByUid[d.uid.toString()]=
d};a.prototype.loadFromJSONString=function(a){a=JSON.parse(a);if(a.c2save&&!(1<a.version)){var c=a.rt;this.kahanTime.reset();this.kahanTime.sum=c.time;this.timescale=c.timescale;this.tickcount=c.tickcount;this.start_time=Date.now()-c.start_time_offset;var b=c.running_layout;if(b!==this.running_layout.sid)if(b=this.getLayoutBySid(b))this.doChangeLayout(b);else return;this.isLoadingState=!0;var h,k,d,g,f,m,e;m=a.types;for(k in m)if(m.hasOwnProperty(k)&&(g=this.getObjectTypeBySid(parseInt(k,10)))&&!g.is_family&&
!this.typeHasNoSaveBehavior(g)){m[k].ex?g.extra=m[k].ex:cr.wipe(g.extra);f=g.instances;d=m[k].instances;b=0;for(h=cr.min(f.length,d.length);b<h;b++)this.loadInstanceFromJSON(f[b],d[b]);b=d.length;for(h=f.length;b<h;b++)this.DestroyInstance(f[b]);b=f.length;for(h=d.length;b<h;b++){f=null;if(g.plugin.is_world&&(f=this.running_layout.getLayerBySid(d[b].w.l),!f))continue;f=this.createInstanceFromInit(g.default_instance,f,!1,0,0,!0);this.loadInstanceFromJSON(f,d[b])}g.stale_iids=!0}this.ClearDeathRow();
this.refreshUidMap();h=a.layouts;for(k in h)h.hasOwnProperty(k)&&(b=this.getLayoutBySid(parseInt(k,10)))&&b.loadFromJSON(h[k]);h=a.events.groups;for(k in h)h.hasOwnProperty(k)&&(b=this.getGroupBySid(parseInt(k,10)))&&this.groups_by_name[b.group_name]&&(this.groups_by_name[b.group_name].group_active=h[k]);b=a.events.cnds;for(k in b)b.hasOwnProperty(k)&&this.cndsBySid.hasOwnProperty(k)&&(this.cndsBySid[k].extra=b[k].ex);b=a.events.acts;for(k in b)b.hasOwnProperty(k)&&this.actsBySid.hasOwnProperty(k)&&
(this.actsBySid[k].extra=b[k].ex);b=a.events.vars;for(k in b)b.hasOwnProperty(k)&&this.varsBySid.hasOwnProperty(k)&&(this.varsBySid[k].data=b[k]);this.next_uid=c.next_uid;this.isLoadingState=!1;this.system.loadFromJSON(a.system);b=0;for(h=this.types_by_index.length;b<h;b++)if(g=this.types_by_index[b],!g.is_family)for(k=0,a=g.instances.length;k<a;k++){f=g.instances[k];if(g.is_contained)for(m=f.get_iid(),c=f.siblings.length=0,d=g.container.length;c<d;c++)e=g.container[c],g!==e&&f.siblings.push(e.instances[m]);
f.afterLoad&&f.afterLoad();if(f.behavior_insts)for(c=0,d=f.behavior_insts.length;c<d;c++)m=f.behavior_insts[c],m.afterLoad&&m.afterLoad()}this.redraw=!0}};a.prototype.saveInstanceToJSON=function(a,c){var b,h,k,d,g;d=a.type;k=d.plugin;var f={};c?f.c2=!0:f.uid=a.uid;cr.hasAnyOwnProperty(a.extra)&&(f.ex=m(a.extra));if(a.instance_vars&&a.instance_vars.length)for(f.ivs={},b=0,h=a.instance_vars.length;b<h;b++)f.ivs[a.type.instvar_sids[b].toString()]=a.instance_vars[b];if(k.is_world){k={x:a.x,y:a.y,w:a.width,
h:a.height,l:a.layer.sid,zi:a.get_zindex()};0!==a.angle&&(k.a=a.angle);1!==a.opacity&&(k.o=a.opacity);0.5!==a.hotspotX&&(k.hX=a.hotspotX);0.5!==a.hotspotY&&(k.hY=a.hotspotY);0!==a.blend_mode&&(k.bm=a.blend_mode);a.visible||(k.v=a.visible);a.collisionsEnabled||(k.ce=a.collisionsEnabled);-1!==a.my_timescale&&(k.mts=a.my_timescale);if(d.effect_types.length)for(k.fx=[],b=0,h=d.effect_types.length;b<h;b++)g=d.effect_types[b],k.fx.push({name:g.name,active:a.active_effect_flags[g.index],params:a.effect_params[g.index]});
f.w=k}if(a.behavior_insts&&a.behavior_insts.length)for(f.behs={},b=0,h=a.behavior_insts.length;b<h;b++)d=a.behavior_insts[b],d.saveToJSON&&(f.behs[d.type.sid.toString()]=d.saveToJSON());a.saveToJSON&&(f.data=a.saveToJSON());return f};a.prototype.getInstanceVarIndexBySid=function(a,c){var b,h;b=0;for(h=a.instvar_sids.length;b<h;b++)if(a.instvar_sids[b]===c)return b;return-1};a.prototype.getBehaviorIndexBySid=function(a,c){var b,h;b=0;for(h=a.behavior_insts.length;b<h;b++)if(a.behavior_insts[b].type.sid===
c)return b;return-1};a.prototype.loadInstanceFromJSON=function(a,c,b){var h,k,d,g,f;f=a.type;d=f.plugin;if(b){if(!c.c2)return}else a.uid=c.uid;c.ex?a.extra=c.ex:cr.wipe(a.extra);if(k=c.ivs)for(h in k)k.hasOwnProperty(h)&&(b=this.getInstanceVarIndexBySid(f,parseInt(h,10)),0>b||b>=a.instance_vars.length||(a.instance_vars[b]=k[h]));if(d.is_world){d=c.w;a.layer.sid!==d.l&&(b=a.layer,a.layer=this.running_layout.getLayerBySid(d.l),a.layer?(a.layer.instances.push(a),a.layer.zindices_stale=!0,cr.arrayFindRemove(b.instances,
a),b.zindices_stale=!0):(a.layer=b,this.DestroyInstance(a)));a.x=d.x;a.y=d.y;a.width=d.w;a.height=d.h;a.zindex=d.zi;a.angle=d.hasOwnProperty("a")?d.a:0;a.opacity=d.hasOwnProperty("o")?d.o:1;a.hotspotX=d.hasOwnProperty("hX")?d.hX:0.5;a.hotspotY=d.hasOwnProperty("hY")?d.hY:0.5;a.visible=d.hasOwnProperty("v")?d.v:!0;a.collisionsEnabled=d.hasOwnProperty("ce")?d.ce:!0;a.my_timescale=d.hasOwnProperty("mts")?d.mts:-1;a.blend_mode=d.hasOwnProperty("bm")?d.bm:0;a.compositeOp=cr.effectToCompositeOp(a.blend_mode);
this.gl&&cr.setGLBlend(a,a.blend_mode,this.gl);a.set_bbox_changed();if(d.hasOwnProperty("fx"))for(b=0,k=d.fx.length;b<k;b++)g=f.getEffectIndexByName(d.fx[b].name),0>g||(a.active_effect_flags[g]=d.fx[b].active,a.effect_params[g]=d.fx[b].params);a.updateActiveEffects()}if(f=c.behs)for(h in f)f.hasOwnProperty(h)&&(d=this.getBehaviorIndexBySid(a,parseInt(h,10)),0>d||a.behavior_insts[d].loadFromJSON(f[h]));c.data&&a.loadFromJSON(c.data)};cr.runtime=a;cr.createRuntime=function(c){return new a(document.getElementById(c))};
cr.createDCRuntime=function(c,b){return new a({dc:!0,width:c,height:b})};window.cr_createRuntime=cr.createRuntime;window.cr_createDCRuntime=cr.createDCRuntime;window.createCocoonJSRuntime=function(){window.c2cocoonjs=!0;var c=document.createElement("screencanvas")||document.createElement("canvas");c.screencanvas=!0;document.body.appendChild(c);c=new a(c);window.c2runtime=c;window.addEventListener("orientationchange",function(){window.c2runtime.setSize(window.innerWidth,window.innerHeight)});window.c2runtime.setSize(window.innerWidth,
window.innerHeight);return c};window.createEjectaRuntime=function(){var c=document.getElementById("canvas"),c=new a(c);window.c2runtime=c;window.c2runtime.setSize(window.innerWidth,window.innerHeight);return c}})();window.cr_getC2Runtime=function(){var a=document.getElementById("c2canvas");return a?a.c2runtime:window.c2runtime?window.c2runtime:null};window.cr_sizeCanvas=function(a,b){if(0!==a&&0!==b){var e=window.cr_getC2Runtime();e&&e.setSize(a,b)}};
window.cr_setSuspended=function(a){var b=window.cr_getC2Runtime();b&&b.setSuspended(a)};
(function(){function a(a,b){this.runtime=a;this.event_sheet=null;this.scrollX=this.runtime.original_width/2;this.scrollY=this.runtime.original_height/2;this.scale=1;this.angle=0;this.first_visit=!0;this.name=b[0];this.width=b[1];this.height=b[2];this.unbounded_scrolling=b[3];this.sheetname=b[4];this.sid=b[5];var c=b[6],e,f;this.layers=[];this.initial_types=[];e=0;for(f=c.length;e<f;e++){var n=new cr.layer(this,c[e]);n.number=e;cr.seal(n);this.layers.push(n)}c=b[7];this.initial_nonworld=[];e=0;for(f=
c.length;e<f;e++){var n=c[e],d=this.runtime.types_by_index[n[1]];d.default_instance||(d.default_instance=n);this.initial_nonworld.push(n);-1===this.initial_types.indexOf(d)&&this.initial_types.push(d)}this.effect_types=[];this.active_effect_types=[];this.effect_params=[];e=0;for(f=b[8].length;e<f;e++)this.effect_types.push({id:b[8][e][0],name:b[8][e][1],shaderindex:-1,active:!0,index:e}),this.effect_params.push(b[8][e][2].slice(0));this.updateActiveEffects();this.rcTex=new cr.rect(0,0,1,1);this.rcTex2=
new cr.rect(0,0,1,1);this.persist_data={}}function b(a,b){this.layout=a;this.runtime=a.runtime;this.instances=[];this.scale=1;this.angle=0;this.disableAngle=!1;this.tmprect=new cr.rect(0,0,0,0);this.tmpquad=new cr.quad;this.viewBottom=this.viewTop=this.viewRight=this.viewLeft=0;this.zindices_stale=!1;this.name=b[0];this.index=b[1];this.sid=b[2];this.visible=b[3];this.background_color=b[4];this.transparent=b[5];this.parallaxX=b[6];this.parallaxY=b[7];this.opacity=b[8];this.forceOwnTexture=b[9];this.zoomRate=
b[10];this.blend_mode=b[11];this.effect_fallback=b[12];this.compositeOp="source-over";this.destBlend=this.srcBlend=0;this.render_offscreen=!1;var c=b[13],e,f;this.initial_instances=[];e=0;for(f=c.length;e<f;e++){var n=c[e],d=this.runtime.types_by_index[n[1]];d.default_instance||(d.default_instance=n,d.default_layerindex=this.index);this.initial_instances.push(n);-1===this.layout.initial_types.indexOf(d)&&this.layout.initial_types.push(d)}this.effect_types=[];this.active_effect_types=[];this.effect_params=
[];e=0;for(f=b[14].length;e<f;e++)this.effect_types.push({id:b[14][e][0],name:b[14][e][1],shaderindex:-1,active:!0,index:e}),this.effect_params.push(b[14][e][2].slice(0));this.updateActiveEffects();this.rcTex=new cr.rect(0,0,1,1);this.rcTex2=new cr.rect(0,0,1,1)}function e(a,b){return a.zindex-b.zindex}a.prototype.saveObjectToPersist=function(a){var b=a.type.sid.toString();this.persist_data.hasOwnProperty(b)||(this.persist_data[b]=[]);this.persist_data[b].push(this.runtime.saveInstanceToJSON(a))};
a.prototype.hasOpaqueBottomLayer=function(){var a=this.layers[0];return!a.transparent&&1===a.opacity&&!a.forceOwnTexture&&a.visible};a.prototype.updateActiveEffects=function(){this.active_effect_types.length=0;var a,b,c;a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],c.active&&this.active_effect_types.push(c)};a.prototype.getEffectByName=function(a){var b,c,e;b=0;for(c=this.effect_types.length;b<c;b++)if(e=this.effect_types[b],e.name===a)return e;return null};var l=[];a.prototype.startRunning=
function(){this.sheetname&&(this.event_sheet=this.runtime.eventsheets[this.sheetname],this.event_sheet.updateDeepIncludes());this.runtime.running_layout=this;this.scrollX=this.runtime.original_width/2;this.scrollY=this.runtime.original_height/2;var a,b,c,p,f,n,d;a=0;for(c=this.runtime.types_by_index.length;a<c;a++)if(b=this.runtime.types_by_index[a],!b.is_family)for(f=b.instances,b=0,p=f.length;b<p;b++)if(n=f[b],n.layer){var u=n.layer.number;u>=this.layers.length&&(u=this.layers.length-1);n.layer=
this.layers[u];n.layer.instances.push(n);n.layer.zindices_stale=!0}l.length=0;this.boundScrolling();a=0;for(c=this.layers.length;a<c;a++)n=this.layers[a],n.createInitialInstances(),n.disableAngle=!0,b=n.canvasToLayer(0,0,!0,!0),p=n.canvasToLayer(0,0,!1,!0),n.disableAngle=!1,this.runtime.pixel_rounding&&(b=b+0.5|0,p=p+0.5|0),n.rotateViewport(b,p,null);f=!1;if(!this.first_visit){for(d in this.persist_data)if(this.persist_data.hasOwnProperty(d)&&(b=this.runtime.getObjectTypeBySid(parseInt(d,10)))&&!b.is_family&&
this.runtime.typeHasPersistBehavior(b)){p=this.persist_data[d];a=0;for(c=p.length;a<c;a++){n=null;if(b.plugin.is_world&&(n=this.getLayerBySid(p[a].w.l),!n))continue;n=this.runtime.createInstanceFromInit(b.default_instance,n,!1,0,0,!0);this.runtime.loadInstanceFromJSON(n,p[a]);f=!0;l.push(n)}p.length=0}a=0;for(c=this.layers.length;a<c;a++)this.layers[a].instances.sort(e),this.layers[a].zindices_stale=!0}f&&(this.runtime.ClearDeathRow(),this.runtime.refreshUidMap());for(a=0;a<l.length;a++)if(n=l[a],
n.type.is_contained)for(c=n.get_iid(),b=0,p=n.type.container.length;b<p;b++)d=n.type.container[b],n.type!==d&&(d.instances.length>c?n.siblings.push(d.instances[c]):d.default_instance&&(f=this.runtime.createInstanceFromInit(d.default_instance,n.layer,!0,n.x,n.y,!0),this.runtime.ClearDeathRow(),d.updateIIDs(),n.siblings.push(f),l.push(f)));a=0;for(c=this.initial_nonworld.length;a<c;a++)this.runtime.createInstanceFromInit(this.initial_nonworld[a],null,!0);this.runtime.changelayout=null;this.runtime.ClearDeathRow();
if(this.runtime.ctx&&!this.runtime.isDomFree)for(a=0,c=this.runtime.types_by_index.length;a<c;a++)d=this.runtime.types_by_index[a],!d.is_family&&d.instances.length&&d.preloadCanvas2D&&d.preloadCanvas2D(this.runtime.ctx);a=0;for(c=l.length;a<c;a++)n=l[a],this.runtime.trigger(Object.getPrototypeOf(n.type.plugin).cnds.OnCreated,n);l.length=0;this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutStart,null);this.first_visit=!1};a.prototype.createGlobalNonWorlds=function(){var a,b,c,e,f;b=a=0;for(c=
this.initial_nonworld.length;a<c;a++)e=this.initial_nonworld[a],f=this.runtime.types_by_index[e[1]],f.global?this.runtime.createInstanceFromInit(e,null,!0):(this.initial_nonworld[b]=e,b++);this.initial_nonworld.length=b};a.prototype.stopRunning=function(){this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutEnd,null);this.runtime.system.waits.length=0;var a,b,c,e,f,n;a=0;for(b=this.layers.length;a<b;a++){f=this.layers[a].instances;c=0;for(e=f.length;c<e;c++)n=f[c],n.type.global||(this.runtime.typeHasPersistBehavior(n.type)&&
this.saveObjectToPersist(n),this.runtime.DestroyInstance(n));this.runtime.ClearDeathRow();f.length=0;this.layers[a].zindices_stale=!0}a=0;for(b=this.runtime.types_by_index.length;a<b;a++)if(f=this.runtime.types_by_index[a],!(f.global||f.plugin.is_world||f.plugin.singleglobal||f.is_family)){c=0;for(e=f.instances.length;c<e;c++)this.runtime.DestroyInstance(f.instances[c]);this.runtime.ClearDeathRow()}};a.prototype.draw=function(a){var b,c=a,e=!1,f=!this.runtime.fullscreenScalingQuality;f&&(this.runtime.layout_canvas||
(this.runtime.layout_canvas=document.createElement("canvas"),b=this.runtime.layout_canvas,b.width=this.runtime.draw_width,b.height=this.runtime.draw_height,this.runtime.layout_ctx=b.getContext("2d"),e=!0),b=this.runtime.layout_canvas,c=this.runtime.layout_ctx,b.width!==this.runtime.draw_width&&(b.width=this.runtime.draw_width,e=!0),b.height!==this.runtime.draw_height&&(b.height=this.runtime.draw_height,e=!0),e&&(c.webkitImageSmoothingEnabled=this.runtime.linearSampling,c.mozImageSmoothingEnabled=
this.runtime.linearSampling,c.msImageSmoothingEnabled=this.runtime.linearSampling,c.imageSmoothingEnabled=this.runtime.linearSampling));c.globalAlpha=1;c.globalCompositeOperation="source-over";this.runtime.alphaBackground&&!this.hasOpaqueBottomLayer()&&c.clearRect(0,0,this.runtime.draw_width,this.runtime.draw_height);var n,d,e=0;for(n=this.layers.length;e<n;e++)d=this.layers[e],d.visible&&0<d.opacity&&11!==d.blend_mode&&d.draw(c);f&&a.drawImage(b,0,0,this.runtime.width,this.runtime.height)};a.prototype.drawGL=
function(a){var b=0<this.active_effect_types.length||this.runtime.uses_background_blending||!this.runtime.fullscreenScalingQuality;if(b){this.runtime.layout_tex||(this.runtime.layout_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling));if(this.runtime.layout_tex.c2width!==this.runtime.draw_width||this.runtime.layout_tex.c2height!==this.runtime.draw_height)a.deleteTexture(this.runtime.layout_tex),this.runtime.layout_tex=a.createEmptyTexture(this.runtime.draw_width,
this.runtime.draw_height,this.runtime.linearSampling);a.setRenderingToTexture(this.runtime.layout_tex);this.runtime.fullscreenScalingQuality||a.setSize(this.runtime.draw_width,this.runtime.draw_height)}else this.runtime.layout_tex&&(a.setRenderingToTexture(null),a.deleteTexture(this.runtime.layout_tex),this.runtime.layout_tex=null);this.runtime.alphaBackground&&!this.hasOpaqueBottomLayer()&&a.clear(0,0,0,0);var c,e;c=0;for(e=this.layers.length;c<e;c++)this.layers[c].visible&&0<this.layers[c].opacity&&
this.layers[c].drawGL(a);b&&(0===this.active_effect_types.length||1===this.active_effect_types.length&&this.runtime.fullscreenScalingQuality?(1===this.active_effect_types.length?(b=this.active_effect_types[0].index,a.switchProgram(this.active_effect_types[0].shaderindex),a.setProgramParameters(null,1/this.runtime.draw_width,1/this.runtime.draw_height,0,0,1,1,this.scale,this.angle,0,0,this.effect_params[b]),a.programIsAnimated(this.active_effect_types[0].shaderindex)&&(this.runtime.redraw=!0)):a.switchProgram(0),
this.runtime.fullscreenScalingQuality||a.setSize(this.runtime.width,this.runtime.height),a.setRenderingToTexture(null),a.setOpacity(1),a.setTexture(this.runtime.layout_tex),a.setAlphaBlend(),a.resetModelView(),a.updateModelView(),b=this.runtime.width/2,c=this.runtime.height/2,a.quad(-b,c,b,c,b,-c,-b,-c),a.setTexture(null)):this.renderEffectChain(a,null,null,null))};a.prototype.getRenderTarget=function(){return 0<this.active_effect_types.length||this.runtime.uses_background_blending||!this.runtime.fullscreenScalingQuality?
this.runtime.layout_tex:null};a.prototype.getMinLayerScale=function(){var a=this.layers[0].getScale(),b,c,e;b=1;for(c=this.layers.length;b<c;b++)e=this.layers[b],(0!==e.parallaxX||0!==e.parallaxY)&&e.getScale()<a&&(a=e.getScale());return a};a.prototype.scrollToX=function(a){if(!this.unbounded_scrolling){var b=this.runtime.draw_width*(1/this.getMinLayerScale())/2;a>this.width-b&&(a=this.width-b);a<b&&(a=b)}this.scrollX!==a&&(this.scrollX=a,this.runtime.redraw=!0)};a.prototype.scrollToY=function(a){if(!this.unbounded_scrolling){var b=
this.runtime.draw_height*(1/this.getMinLayerScale())/2;a>this.height-b&&(a=this.height-b);a<b&&(a=b)}this.scrollY!==a&&(this.scrollY=a,this.runtime.redraw=!0)};a.prototype.boundScrolling=function(){this.scrollToX(this.scrollX);this.scrollToY(this.scrollY)};a.prototype.renderEffectChain=function(a,b,c,e){var f=c?c.active_effect_types:b?b.active_effect_types:this.active_effect_types,n=1,d=0,l=0,s=0;c?(n=c.layer.getScale(),d=c.layer.getAngle(),l=c.layer.viewLeft,s=c.layer.viewTop):b&&(n=b.getScale(),
d=b.getAngle(),l=b.viewLeft,s=b.viewTop);var q=this.runtime.fx_tex,t,w,r,x,z=0,h=1,k,y=this.runtime.draw_width,v=this.runtime.draw_height,H=y/2,A=v/2,E=b?b.rcTex:this.rcTex,B=b?b.rcTex2:this.rcTex2,C=0,L=0,D=0,G=0,I=y,U=y,O=v,M=v,J=r=0,F=c?c.layer.getAngle():0;if(c){t=0;for(w=f.length;t<w;t++)r+=a.getProgramBoxExtendHorizontal(f[t].shaderindex),J+=a.getProgramBoxExtendVertical(f[t].shaderindex);x=c.bbox;C=b.layerToCanvas(x.left,x.top,!0,!0);D=b.layerToCanvas(x.left,x.top,!1,!0);I=b.layerToCanvas(x.right,
x.bottom,!0,!0);O=b.layerToCanvas(x.right,x.bottom,!1,!0);0!==F&&(t=b.layerToCanvas(x.right,x.top,!0,!0),w=b.layerToCanvas(x.right,x.top,!1,!0),L=b.layerToCanvas(x.left,x.bottom,!0,!0),G=b.layerToCanvas(x.left,x.bottom,!1,!0),x=Math.min(C,I,t,L),I=Math.max(C,I,t,L),C=x,x=Math.min(D,O,w,G),O=Math.max(D,O,w,G),D=x);C-=r;D-=J;I+=r;O+=J;B.left=C/y;B.top=1-D/v;B.right=I/y;B.bottom=1-O/v;L=C=cr.floor(C);G=D=cr.floor(D);U=I=cr.ceil(I);M=O=cr.ceil(O);L-=r;G-=J;U+=r;M+=J;0>C&&(C=0);0>D&&(D=0);I>y&&(I=y);O>
v&&(O=v);0>L&&(L=0);0>G&&(G=0);U>y&&(U=y);M>v&&(M=v);E.left=C/y;E.top=1-D/v;E.right=I/y;E.bottom=1-O/v}else E.left=B.left=0,E.top=B.top=0,E.right=B.right=1,E.bottom=B.bottom=1;J=c&&((c.angle||F)&&a.programUsesDest(f[0].shaderindex)||0!==r||0!==J||1!==c.opacity||c.type.plugin.must_predraw)||b&&!c&&1!==b.opacity;a.setAlphaBlend();if(J){q[z]||(q[z]=a.createEmptyTexture(y,v,this.runtime.linearSampling));if(q[z].c2width!==y||q[z].c2height!==v)a.deleteTexture(q[z]),q[z]=a.createEmptyTexture(y,v,this.runtime.linearSampling);
a.switchProgram(0);a.setRenderingToTexture(q[z]);k=M-G;a.clearRect(L,v-G-k,U-L,k);c?c.drawGL(a):(a.setTexture(this.runtime.layer_tex),a.setOpacity(b.opacity),a.resetModelView(),a.translate(-H,-A),a.updateModelView(),a.quadTex(C,O,I,O,I,D,C,D,E));B.left=B.top=0;B.right=B.bottom=1;c&&(x=E.top,E.top=E.bottom,E.bottom=x);z=1;h=0}a.setOpacity(1);r=f.length-1;var F=a.programUsesCrossSampling(f[r].shaderindex)||!b&&!c&&!this.runtime.fullscreenScalingQuality,P=0;t=0;for(w=f.length;t<w;t++){q[z]||(q[z]=a.createEmptyTexture(y,
v,this.runtime.linearSampling));if(q[z].c2width!==y||q[z].c2height!==v)a.deleteTexture(q[z]),q[z]=a.createEmptyTexture(y,v,this.runtime.linearSampling);a.switchProgram(f[t].shaderindex);P=f[t].index;a.programIsAnimated(f[t].shaderindex)&&(this.runtime.redraw=!0);0!=t||J?(a.setProgramParameters(e,1/y,1/v,B.left,B.top,B.right,B.bottom,n,d,l,s,c?c.effect_params[P]:b?b.effect_params[P]:this.effect_params[P]),a.setTexture(null),t!==r||F?(a.setRenderingToTexture(q[z]),k=M-G,x=v-G-k,a.clearRect(L,x,U-L,
k)):(c?a.setBlend(c.srcBlend,c.destBlend):b&&a.setBlend(b.srcBlend,b.destBlend),a.setRenderingToTexture(e)),a.setTexture(q[h]),a.resetModelView(),a.translate(-H,-A),a.updateModelView(),a.quadTex(C,O,I,O,I,D,C,D,E),t!==r||F||a.setTexture(null)):(a.setRenderingToTexture(q[z]),k=M-G,x=v-G-k,a.clearRect(L,x,U-L,k),c?(a.setProgramParameters(e,1/c.width,1/c.height,B.left,B.top,B.right,B.bottom,n,d,l,s,c.effect_params[P]),c.drawGL(a)):(a.setProgramParameters(e,1/y,1/v,0,0,1,1,n,d,l,s,b?b.effect_params[P]:
this.effect_params[P]),a.setTexture(b?this.runtime.layer_tex:this.runtime.layout_tex),a.resetModelView(),a.translate(-H,-A),a.updateModelView(),a.quadTex(C,O,I,O,I,D,C,D,E)),B.left=B.top=0,B.right=B.bottom=1,c&&!F&&(x=O,O=D,D=x));z=0===z?1:0;h=0===z?1:0}F&&(a.switchProgram(0),c?a.setBlend(c.srcBlend,c.destBlend):b?a.setBlend(b.srcBlend,b.destBlend):this.runtime.fullscreenScalingQuality||(a.setSize(this.runtime.width,this.runtime.height),H=this.runtime.width/2,A=this.runtime.height/2,D=C=0,I=this.runtime.width,
O=this.runtime.height),a.setRenderingToTexture(e),a.setTexture(q[h]),a.resetModelView(),a.translate(-H,-A),a.updateModelView(),c&&1===f.length&&!J?a.quadTex(C,D,I,D,I,O,C,O,E):a.quadTex(C,O,I,O,I,D,C,D,E),a.setTexture(null))};a.prototype.getLayerBySid=function(a){var b,c;b=0;for(c=this.layers.length;b<c;b++)if(this.layers[b].sid===a)return this.layers[b];return null};a.prototype.saveToJSON=function(){var a,b,c,e={sx:this.scrollX,sy:this.scrollY,s:this.scale,a:this.angle,w:this.width,h:this.height,
fv:this.first_visit,persist:this.persist_data,fx:[],layers:{}};a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],e.fx.push({name:c.name,active:c.active,params:this.effect_params[c.index]});a=0;for(b=this.layers.length;a<b;a++)c=this.layers[a],e.layers[c.sid.toString()]=c.saveToJSON();return e};a.prototype.loadFromJSON=function(a){var b,c,e,f;this.scrollX=a.sx;this.scrollY=a.sy;this.scale=a.s;this.angle=a.a;this.width=a.w;this.height=a.h;this.persist_data=a.persist;"undefined"!==typeof a.fv&&
(this.first_visit=a.fv);var n=a.fx;b=0;for(c=n.length;b<c;b++)if(e=this.getEffectByName(n[b].name))e.active=n[b].active,this.effect_params[e.index]=n[b].params;this.updateActiveEffects();b=a.layers;for(f in b)b.hasOwnProperty(f)&&(a=this.getLayerBySid(parseInt(f,10)))&&a.loadFromJSON(b[f])};cr.layout=a;b.prototype.updateActiveEffects=function(){this.active_effect_types.length=0;var a,b,c;a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],c.active&&this.active_effect_types.push(c)};
b.prototype.getEffectByName=function(a){var b,c,e;b=0;for(c=this.effect_types.length;b<c;b++)if(e=this.effect_types[b],e.name===a)return e;return null};b.prototype.createInitialInstances=function(){var a,b,c,e,f,n;b=a=0;for(c=this.initial_instances.length;a<c;a++){e=this.initial_instances[a];f=this.runtime.types_by_index[e[1]];n=this.runtime.typeHasPersistBehavior(f);f=!0;if(!n||this.layout.first_visit)e=this.runtime.createInstanceFromInit(e,this,!0),l.push(e),e.type.global&&(f=!1);f&&(this.initial_instances[b]=
this.initial_instances[a],b++)}this.initial_instances.length=b;this.runtime.ClearDeathRow();!this.runtime.glwrap&&this.effect_types.length&&(this.blend_mode=this.effect_fallback);this.compositeOp=cr.effectToCompositeOp(this.blend_mode);this.runtime.gl&&cr.setGLBlend(this,this.blend_mode,this.runtime.gl)};b.prototype.updateZIndices=function(){if(this.zindices_stale){var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].zindex=a;this.zindices_stale=!1}};b.prototype.getScale=function(a){return this.getNormalScale()*
(this.runtime.fullscreenScalingQuality||a?this.runtime.aspect_scale:1)};b.prototype.getNormalScale=function(){return(this.scale*this.layout.scale-1)*this.zoomRate+1};b.prototype.getAngle=function(){return this.disableAngle?0:cr.clamp_angle(this.layout.angle+this.angle)};b.prototype.draw=function(a){this.render_offscreen=this.forceOwnTexture||1!==this.opacity||0!==this.blend_mode;var b=this.runtime.canvas,c=a,e=!1;this.render_offscreen&&(this.runtime.layer_canvas||(this.runtime.layer_canvas=document.createElement("canvas"),
b=this.runtime.layer_canvas,b.width=this.runtime.draw_width,b.height=this.runtime.draw_height,this.runtime.layer_ctx=b.getContext("2d"),e=!0),b=this.runtime.layer_canvas,c=this.runtime.layer_ctx,b.width!==this.runtime.draw_width&&(b.width=this.runtime.draw_width,e=!0),b.height!==this.runtime.draw_height&&(b.height=this.runtime.draw_height,e=!0),e&&(c.webkitImageSmoothingEnabled=this.runtime.linearSampling,c.mozImageSmoothingEnabled=this.runtime.linearSampling,c.msImageSmoothingEnabled=this.runtime.linearSampling,
c.imageSmoothingEnabled=this.runtime.linearSampling),this.transparent&&c.clearRect(0,0,this.runtime.draw_width,this.runtime.draw_height));c.globalAlpha=1;c.globalCompositeOperation="source-over";this.transparent||(c.fillStyle="rgb("+this.background_color[0]+","+this.background_color[1]+","+this.background_color[2]+")",c.fillRect(0,0,this.runtime.draw_width,this.runtime.draw_height));c.save();this.disableAngle=!0;var e=this.canvasToLayer(0,0,!0,!0),f=this.canvasToLayer(0,0,!1,!0);this.disableAngle=
!1;this.runtime.pixel_rounding&&(e=e+0.5|0,f=f+0.5|0);this.rotateViewport(e,f,c);var n=this.getScale();c.scale(n,n);c.translate(-e,-f);for(var d,e=0,f=this.instances.length;e<f;e++)n=this.instances[e],n.visible&&0!==n.width&&0!==n.height&&(n.update_bbox(),d=n.bbox,d.right<this.viewLeft||d.bottom<this.viewTop||d.left>this.viewRight||d.top>this.viewBottom||(c.globalCompositeOperation=n.compositeOp,n.draw(c)));c.restore();this.render_offscreen&&(a.globalCompositeOperation=this.compositeOp,a.globalAlpha=
this.opacity,a.drawImage(b,0,0))};b.prototype.rotateViewport=function(a,b,c){var e=this.getScale();this.viewLeft=a;this.viewTop=b;this.viewRight=a+this.runtime.draw_width*(1/e);this.viewBottom=b+this.runtime.draw_height*(1/e);a=this.getAngle();0!==a&&(c&&(c.translate(this.runtime.draw_width/2,this.runtime.draw_height/2),c.rotate(-a),c.translate(this.runtime.draw_width/-2,this.runtime.draw_height/-2)),this.tmprect.set(this.viewLeft,this.viewTop,this.viewRight,this.viewBottom),this.tmprect.offset((this.viewLeft+
this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2),this.tmpquad.set_from_rotated_rect(this.tmprect,a),this.tmpquad.bounding_box(this.tmprect),this.tmprect.offset((this.viewLeft+this.viewRight)/2,(this.viewTop+this.viewBottom)/2),this.viewLeft=this.tmprect.left,this.viewTop=this.tmprect.top,this.viewRight=this.tmprect.right,this.viewBottom=this.tmprect.bottom)};b.prototype.drawGL=function(a){var b=this.runtime.draw_width,c=this.runtime.draw_height,e=0,f=0;if(this.render_offscreen=this.forceOwnTexture||
1!==this.opacity||0<this.active_effect_types.length||0!==this.blend_mode){this.runtime.layer_tex||(this.runtime.layer_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling));if(this.runtime.layer_tex.c2width!==this.runtime.draw_width||this.runtime.layer_tex.c2height!==this.runtime.draw_height)a.deleteTexture(this.runtime.layer_tex),this.runtime.layer_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling);
a.setRenderingToTexture(this.runtime.layer_tex);this.transparent&&a.clear(0,0,0,0)}this.transparent||a.clear(this.background_color[0]/255,this.background_color[1]/255,this.background_color[2]/255,1);this.disableAngle=!0;var f=this.canvasToLayer(0,0,!0,!0),n=this.canvasToLayer(0,0,!1,!0);this.disableAngle=!1;this.runtime.pixel_rounding&&(f=f+0.5|0,n=n+0.5|0);this.rotateViewport(f,n,null);n=this.getScale();a.resetModelView();a.scale(n,n);a.rotateZ(-this.getAngle());a.translate((this.viewLeft+this.viewRight)/
-2,(this.viewTop+this.viewBottom)/-2);a.updateModelView();var d,l,s;d=0;for(l=this.instances.length;d<l;d++)if(s=this.instances[d],s.visible&&0!==s.width&&0!==s.height&&(s.update_bbox(),e=s.bbox,!(e.right<this.viewLeft||e.bottom<this.viewTop||e.left>this.viewRight||e.top>this.viewBottom)))if(s.uses_shaders)if(e=s.active_effect_types[0].shaderindex,f=s.active_effect_types[0].index,1!==s.active_effect_types.length||a.programUsesCrossSampling(e)||a.programExtendsBox(e)||(s.angle||s.layer.getAngle())&&
a.programUsesDest(e)||1!==s.opacity||s.type.plugin.must_predraw)this.layout.renderEffectChain(a,this,s,this.render_offscreen?this.runtime.layer_tex:this.layout.getRenderTarget()),a.resetModelView(),a.scale(n,n),a.rotateZ(-this.getAngle()),a.translate((this.viewLeft+this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2),a.updateModelView();else{a.switchProgram(e);a.setBlend(s.srcBlend,s.destBlend);a.programIsAnimated(e)&&(this.runtime.redraw=!0);var q=0,t=0,w=0,r=0;a.programUsesDest(e)&&(e=s.bbox,q=
this.layerToCanvas(e.left,e.top,!0,!0),t=this.layerToCanvas(e.left,e.top,!1,!0),w=this.layerToCanvas(e.right,e.bottom,!0,!0),e=this.layerToCanvas(e.right,e.bottom,!1,!0),q/=b,t=1-t/c,w/=b,r=1-e/c);a.setProgramParameters(this.render_offscreen?this.runtime.layer_tex:this.layout.getRenderTarget(),1/s.width,1/s.height,q,t,w,r,this.getScale(),this.getAngle(),this.viewLeft,this.viewTop,s.effect_params[f]);s.drawGL(a)}else a.switchProgram(0),a.setBlend(s.srcBlend,s.destBlend),s.drawGL(a);this.render_offscreen&&
(e=this.active_effect_types.length?this.active_effect_types[0].shaderindex:0,f=this.active_effect_types.length?this.active_effect_types[0].index:0,0===this.active_effect_types.length||1===this.active_effect_types.length&&!a.programUsesCrossSampling(e)&&1===this.opacity?(1===this.active_effect_types.length?(a.switchProgram(e),a.setProgramParameters(this.layout.getRenderTarget(),1/this.runtime.draw_width,1/this.runtime.draw_height,0,0,1,1,this.getScale(),this.getAngle(),this.viewLeft,this.viewTop,this.effect_params[f]),
a.programIsAnimated(e)&&(this.runtime.redraw=!0)):a.switchProgram(0),a.setRenderingToTexture(this.layout.getRenderTarget()),a.setOpacity(this.opacity),a.setTexture(this.runtime.layer_tex),a.setBlend(this.srcBlend,this.destBlend),a.resetModelView(),a.updateModelView(),b=this.runtime.draw_width/2,c=this.runtime.draw_height/2,a.quad(-b,c,b,c,b,-c,-b,-c),a.setTexture(null)):this.layout.renderEffectChain(a,this,null,this.layout.getRenderTarget()))};b.prototype.canvasToLayer=function(a,b,c,e){var f=this.runtime.devicePixelRatio;
this.runtime.isRetina&&(a*=f,b*=f);var f=this.runtime.parallax_x_origin,n=this.runtime.parallax_y_origin,f=(this.layout.scrollX-f)*this.parallaxX+f,n=(this.layout.scrollY-n)*this.parallaxY+n,d=1/this.getScale(!e);e?(f-=this.runtime.draw_width*d/2,n-=this.runtime.draw_height*d/2):(f-=this.runtime.width*d/2,n-=this.runtime.height*d/2);f+=a*d;n+=b*d;b=this.getAngle();0!==b&&(f-=this.layout.scrollX,n-=this.layout.scrollY,a=Math.cos(b),b=Math.sin(b),e=f*a-n*b,n=n*a+f*b,f=e+this.layout.scrollX,n+=this.layout.scrollY);
return c?f:n};b.prototype.layerToCanvas=function(a,b,c,e){var f=this.getAngle();if(0!==f){a-=this.layout.scrollX;b-=this.layout.scrollY;var n=Math.cos(-f),f=Math.sin(-f),d=a*n-b*f;b=b*n+a*f;a=d+this.layout.scrollX;b+=this.layout.scrollY}n=this.runtime.parallax_x_origin;f=this.runtime.parallax_y_origin;n=(this.layout.scrollX-n)*this.parallaxX+n;f=(this.layout.scrollY-f)*this.parallaxY+f;d=1/this.getScale(!e);e?(n-=this.runtime.draw_width*d/2,f-=this.runtime.draw_height*d/2):(n-=this.runtime.width*
d/2,f-=this.runtime.height*d/2);n=(a-n)/d;f=(b-f)/d;a=this.runtime.devicePixelRatio;this.runtime.isRetina&&(n/=a,f/=a);return c?n:f};b.prototype.rotatePt=function(a,b,c){if(0===this.getAngle())return c?a:b;var e=this.layerToCanvas(a,b,!0);b=this.layerToCanvas(a,b,!1);this.disableAngle=!0;a=this.canvasToLayer(e,b,!0);e=this.canvasToLayer(e,b,!0);this.disableAngle=!1;return c?a:e};b.prototype.saveToJSON=function(){var a,b,c,e={s:this.scale,a:this.angle,vl:this.viewLeft,vt:this.viewTop,vr:this.viewRight,
vb:this.viewBottom,v:this.visible,bc:this.background_color,t:this.transparent,px:this.parallaxX,py:this.parallaxY,o:this.opacity,zr:this.zoomRate,fx:[],instances:[]};a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],e.fx.push({name:c.name,active:c.active,params:this.effect_params[c.index]});return e};b.prototype.loadFromJSON=function(a){var b,c;this.scale=a.s;this.angle=a.a;this.viewLeft=a.vl;this.viewTop=a.vt;this.viewRight=a.vr;this.viewBottom=a.vb;this.visible=a.v;this.background_color=
a.bc;this.transparent=a.t;this.parallaxX=a.px;this.parallaxY=a.py;this.opacity=a.o;this.zoomRate=a.zr;var l=a.fx;a=0;for(b=l.length;a<b;a++)if(c=this.getEffectByName(l[a].name))c.active=l[a].active,this.effect_params[c.index]=l[a].params;this.updateActiveEffects();this.instances.sort(e);this.zindices_stale=!0};cr.layer=b})();
(function(){function a(a,b){var c,h=a.length;switch(h){case 0:return!0;case 1:return a[0]===b[0];case 2:return a[0]===b[0]&&a[1]===b[1];default:for(c=0;c<h;c++)if(a[c]!==b[c])return!1;return!0}}function b(a,b){return a.index-b.index}function e(c){var d,f,h,k;2===c.length?c[0].index>c[1].index&&(d=c[0],c[0]=c[1],c[1]=d):2<c.length&&c.sort(b);c.length>=q.length&&(q.length=c.length+1);q[c.length]||(q[c.length]=[]);k=q[c.length];d=0;for(f=k.length;d<f;d++)if(h=k[d],a(c,h))return h;k.push(c);return c}
function l(a,b){this.runtime=a;this.triggers={};this.fasttriggers={};this.hasRun=!1;this.includes=new cr.ObjectSet;this.deep_includes=[];this.already_included_sheets=[];this.name=b[0];var c=b[1];this.events=[];var h,k;h=0;for(k=c.length;h<k;h++)this.init_event(c[h],null,this.events)}function g(a){this.type=a;this.instances=[];this.else_instances=[];this.select_all=!0}function m(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.solModifiersIncludingParents=[];this.has_else_block=
this.toplevelgroup=this.toplevelevent=this.initially_activated=this.group=this.solWriterAfterCnds=!1;this.conditions=[];this.actions=[];this.subevents=[];this.group_name="";this.group_active=this.initially_activated=this.group=!1;this.contained_includes=null;c[1]&&(this.group_name=c[1][1].toLowerCase(),this.group=!0,this.initially_activated=!!c[1][0],this.contained_includes=[],this.group_active=this.initially_activated,this.runtime.allGroups.push(this),this.runtime.groups_by_name[this.group_name]=
this);this.orblock=c[2];this.sid=c[4];this.group||(this.runtime.blocksBySid[this.sid.toString()]=this);var h=c[5];a=0;for(b=h.length;a<b;a++){var k=new cr.condition(this,h[a]);k.index=a;cr.seal(k);this.conditions.push(k);this.addSolModifier(k.type)}h=c[6];a=0;for(b=h.length;a<b;a++)k=new cr.action(this,h[a]),k.index=a,cr.seal(k),this.actions.push(k);if(8===c.length)for(c=c[7],a=0,b=c.length;a<b;a++)this.sheet.init_event(c[a],this,this.subevents);this.is_else_block=!1;this.conditions.length&&(this.is_else_block=
null==this.conditions[0].type&&this.conditions[0].func==cr.system_object.prototype.cnds.Else)}function c(a,b){var c,h,k;if(a&&(-1===b.indexOf(a)&&b.push(a),a.is_contained))for(c=0,h=a.container.length;c<h;c++)k=a.container[c],a!==k&&-1===b.indexOf(k)&&b.push(k)}function p(a,b){this.block=a;this.sheet=a.sheet;this.runtime=a.runtime;this.parameters=[];this.results=[];this.extra={};this.index=-1;this.anyParamVariesPerInstance=!1;this.func=b[1];this.trigger=0<b[3];this.fasttrigger=2===b[3];this.looping=
b[4];this.inverted=b[5];this.isstatic=b[6];this.sid=b[7];this.runtime.cndsBySid[this.sid.toString()]=this;-1===b[0]?(this.type=null,this.run=this.run_system,this.behaviortype=null,this.beh_index=-1):(this.type=this.runtime.types_by_index[b[0]],this.run=this.isstatic?this.run_static:this.run_object,b[2]?(this.behaviortype=this.type.getBehaviorByName(b[2]),this.beh_index=this.type.getBehaviorIndexByName(b[2])):(this.behaviortype=null,this.beh_index=-1),this.block.parent&&this.block.parent.setSolWriterAfterCnds());
this.fasttrigger&&(this.run=this.run_true);if(10===b.length){var c,h,k=b[9];c=0;for(h=k.length;c<h;c++){var d=new cr.parameter(this,k[c]);cr.seal(d);this.parameters.push(d)}this.results.length=k.length}}function f(a,b){this.block=a;this.sheet=a.sheet;this.runtime=a.runtime;this.parameters=[];this.results=[];this.extra={};this.index=-1;this.anyParamVariesPerInstance=!1;this.func=b[1];-1===b[0]?(this.type=null,this.run=this.run_system,this.behaviortype=null,this.beh_index=-1):(this.type=this.runtime.types_by_index[b[0]],
this.run=this.run_object,b[2]?(this.behaviortype=this.type.getBehaviorByName(b[2]),this.beh_index=this.type.getBehaviorIndexByName(b[2])):(this.behaviortype=null,this.beh_index=-1));this.sid=b[3];this.runtime.actsBySid[this.sid.toString()]=this;if(6===b.length){var c,h,k=b[5];c=0;for(h=k.length;c<h;c++){var d=new cr.parameter(this,k[c]);cr.seal(d);this.parameters.push(d)}this.results.length=k.length}}function n(a,b){this.owner=a;this.block=a.block;this.sheet=a.sheet;this.runtime=a.runtime;this.type=
b[0];this.expression=null;this.solindex=0;this.get=null;this.combosel=0;this.layout=null;this.key=0;this.object=null;this.index=0;this.variadicret=this.subparams=this.variadicret=this.subparams=this.fileinfo=this.eventvar=this.varname=null;this.variesPerInstance=!1;var c,h,k;switch(b[0]){case 0:case 7:this.expression=new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_exp;break;case 1:this.expression=new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_exp_str;break;case 5:this.expression=
new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_layer;break;case 3:case 8:this.combosel=b[1];this.get=this.get_combosel;break;case 6:this.layout=this.runtime.layouts[b[1]];this.get=this.get_layout;break;case 9:this.key=b[1];this.get=this.get_key;break;case 4:this.object=this.runtime.types_by_index[b[1]];this.get=this.get_object;this.block.addSolModifier(this.object);this.owner instanceof cr.action?this.block.setSolWriterAfterCnds():this.block.parent&&this.block.parent.setSolWriterAfterCnds();
break;case 10:this.index=b[1];a.type.is_family?(this.get=this.get_familyvar,this.variesPerInstance=!0):this.get=this.get_instvar;break;case 11:this.varname=b[1];this.eventvar=null;this.get=this.get_eventvar;break;case 2:case 12:this.fileinfo=b[1];this.get=this.get_audiofile;break;case 13:for(this.get=this.get_variadic,this.subparams=[],this.variadicret=[],c=1,h=b.length;c<h;c++)k=new cr.parameter(this.owner,b[c]),cr.seal(k),this.subparams.push(k),this.variadicret.push(0)}}function d(a,b,c){this.sheet=
a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.name=c[1];this.vartype=c[2];this.initial=c[3];this.is_static=!!c[4];this.is_constant=!!c[5];this.sid=c[6];this.runtime.varsBySid[this.sid.toString()]=this;this.data=this.initial;this.parent?(this.localIndex=this.is_static||this.is_constant?-1:this.runtime.stackLocalCount++,this.runtime.all_local_vars.push(this)):(this.localIndex=-1,this.runtime.all_global_vars.push(this))}function u(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;
this.solModifiers=[];this.include_sheet=null;this.include_sheet_name=c[1];this.active=!0}function s(){this.temp_parents_arr=[];this.reset(null);cr.seal(this)}var q=[];l.prototype.toString=function(){return this.name};l.prototype.init_event=function(a,b,c){switch(a[0]){case 0:a=new cr.eventblock(this,b,a);cr.seal(a);if(a.orblock)for(c.push(a),c=0,b=a.conditions.length;c<b;c++)a.conditions[c].trigger&&this.init_trigger(a,c);else a.is_trigger()?this.init_trigger(a,0):c.push(a);break;case 1:a=new cr.eventvariable(this,
b,a);cr.seal(a);c.push(a);break;case 2:a=new cr.eventinclude(this,b,a),cr.seal(a),c.push(a)}};l.prototype.postInit=function(){var a,b;a=0;for(b=this.events.length;a<b;a++)this.events[a].postInit(a<b-1&&this.events[a+1].is_else_block)};l.prototype.updateDeepIncludes=function(){this.deep_includes.length=0;this.already_included_sheets.length=0;this.addDeepIncludes(this);this.already_included_sheets.length=0};l.prototype.addDeepIncludes=function(a){var b,c,h,k,d=a.deep_includes,f=a.already_included_sheets,
e=this.includes.valuesRef();b=0;for(c=e.length;b<c;++b)h=e[b],k=h.include_sheet,!h.isActive()||a===k||-1<f.indexOf(k)||(f.push(k),k.addDeepIncludes(a),d.push(k))};l.prototype.run=function(a){this.runtime.resuming_breakpoint||(this.hasRun=!0,a||(this.runtime.isRunningEvents=!0));var b,c;b=0;for(c=this.events.length;b<c;b++){var h=this.events[b];h.run();this.runtime.clearSol(h.solModifiers);this.runtime.deathRow.isEmpty()&&!this.runtime.createRow.length||this.runtime.ClearDeathRow()}a||(this.runtime.isRunningEvents=
!1)};l.prototype.init_trigger=function(a,b){a.orblock||this.runtime.triggers_to_postinit.push(a);var c,h,k=a.conditions[b],d;d=k.type?k.type.name:"system";var f=(c=k.fasttrigger)?this.fasttriggers:this.triggers;f[d]||(f[d]=[]);d=f[d];f=k.func;if(c){if(k.parameters.length&&(k=k.parameters[0],1===k.type&&2===k.expression.type)){k=k.expression.value.toLowerCase();c=0;for(h=d.length;c<h;c++)if(d[c].method==f){c=d[c].evs;c[k]?c[k].push([a,b]):c[k]=[[a,b]];return}c={};c[k]=[[a,b]];d.push({method:f,evs:c})}}else{c=
0;for(h=d.length;c<h;c++)if(d[c].method==f){d[c].evs.push([a,b]);return}k=cr.plugins_.Sprite&&f===cr.plugins_.Sprite.prototype.cnds.OnFrameChanged?!0:!1;k?d.unshift({method:f,evs:[[a,b]]}):d.push({method:f,evs:[[a,b]]})}};cr.eventsheet=l;g.prototype.hasObjects=function(){return this.select_all?this.type.instances.length:this.instances.length};g.prototype.getObjects=function(){return this.select_all?this.type.instances:this.instances};g.prototype.pick_one=function(a){a&&(a.runtime.getCurrentEventStack().current_event.orblock?
(this.select_all&&(this.instances.length=0,cr.shallowAssignArray(this.else_instances,a.type.instances),this.select_all=!1),a=this.else_instances.indexOf(a),-1!==a&&(this.instances.push(this.else_instances[a]),this.else_instances.splice(a,1))):(this.select_all=!1,this.instances.length=1,this.instances[0]=a))};cr.selection=g;window._c2hh_="106FC8FAA71857530F21FF84BC16F83AFB53D46C";m.prototype.postInit=function(a){var b,c=this.parent;if(this.group)for(this.toplevelgroup=!0;c;){if(!c.group){this.toplevelgroup=
!1;break}c=c.parent}this.toplevelevent=!this.is_trigger()&&(!this.parent||this.parent.group&&this.parent.toplevelgroup);this.has_else_block=!!a;this.solModifiersIncludingParents=this.solModifiers.slice(0);for(c=this.parent;c;){a=0;for(b=c.solModifiers.length;a<b;a++)this.addParentSolModifier(c.solModifiers[a]);c=c.parent}this.solModifiers=e(this.solModifiers);this.solModifiersIncludingParents=e(this.solModifiersIncludingParents);a=0;for(b=this.conditions.length;a<b;a++)this.conditions[a].postInit();
a=0;for(b=this.actions.length;a<b;a++)this.actions[a].postInit();a=0;for(b=this.subevents.length;a<b;a++)this.subevents[a].postInit(a<b-1&&this.subevents[a+1].is_else_block)};m.prototype.setGroupActive=function(a){if(this.group_active!==!!a){this.group_active=!!a;var b;a=0;for(b=this.contained_includes.length;a<b;++a)this.contained_includes[a].updateActive();0<b&&this.runtime.running_layout.event_sheet&&this.runtime.running_layout.event_sheet.updateDeepIncludes()}};m.prototype.addSolModifier=function(a){c(a,
this.solModifiers)};m.prototype.addParentSolModifier=function(a){c(a,this.solModifiersIncludingParents)};m.prototype.setSolWriterAfterCnds=function(){this.solWriterAfterCnds=!0;this.parent&&this.parent.setSolWriterAfterCnds()};m.prototype.is_trigger=function(){return this.conditions.length?this.conditions[0].trigger:!1};m.prototype.run=function(){var a,b=!1,c,h=this.runtime,k=this.runtime.getCurrentEventStack();k.current_event=this;var d=this.conditions;this.is_else_block||(k.else_branch_ran=!1);
if(this.orblock){0===d.length&&(b=!0);k.cndindex=0;for(a=d.length;k.cndindex<a;k.cndindex++)d[k.cndindex].trigger||(c=d[k.cndindex].run())&&(b=!0);(k.last_event_true=b)&&this.run_actions_and_subevents()}else{k.cndindex=0;for(a=d.length;k.cndindex<a;k.cndindex++)if(c=d[k.cndindex].run(),!c){k.last_event_true=!1;!this.toplevelevent||h.deathRow.isEmpty()&&!h.createRow.length||h.ClearDeathRow();return}k.last_event_true=!0;this.run_actions_and_subevents()}this.end_run(k)};m.prototype.end_run=function(a){a.last_event_true&&
this.has_else_block&&(a.else_branch_ran=!0);!this.toplevelevent||this.runtime.deathRow.isEmpty()&&!this.runtime.createRow.length||this.runtime.ClearDeathRow()};m.prototype.run_orblocktrigger=function(a){this.runtime.getCurrentEventStack().current_event=this;this.conditions[a].run()&&(this.run_actions_and_subevents(),this.runtime.getCurrentEventStack().last_event_true=!0)};m.prototype.run_actions_and_subevents=function(){var a=this.runtime.getCurrentEventStack(),b;a.actindex=0;for(b=this.actions.length;a.actindex<
b;a.actindex++)if(this.actions[a.actindex].run())return;this.run_subevents()};m.prototype.resume_actions_and_subevents=function(){var a=this.runtime.getCurrentEventStack(),b;for(b=this.actions.length;a.actindex<b;a.actindex++)if(this.actions[a.actindex].run())return;this.run_subevents()};m.prototype.run_subevents=function(){if(this.subevents.length){var a,b,c,h,k=this.subevents.length-1;this.runtime.pushEventStack(this);if(this.solWriterAfterCnds)for(a=0,b=this.subevents.length;a<b;a++)c=this.subevents[a],
(h=!this.toplevelgroup||!this.group&&a<k)&&this.runtime.pushCopySol(c.solModifiers),c.run(),h?this.runtime.popSol(c.solModifiers):this.runtime.clearSol(c.solModifiers);else for(a=0,b=this.subevents.length;a<b;a++)this.subevents[a].run();this.runtime.popEventStack()}};m.prototype.run_pretrigger=function(){var a=this.runtime.getCurrentEventStack();a.current_event=this;var b=!1,c;a.cndindex=0;for(c=this.conditions.length;a.cndindex<c;a.cndindex++)if(this.conditions[a.cndindex].run())b=!0;else if(!this.orblock)return!1;
return this.orblock?b:!0};m.prototype.retrigger=function(){this.runtime.execcount++;var a=this.runtime.getCurrentEventStack().cndindex,b=this.runtime.pushEventStack(this);if(!this.orblock)for(b.cndindex=a+1,a=this.conditions.length;b.cndindex<a;b.cndindex++)if(!this.conditions[b.cndindex].run())return this.runtime.popEventStack(),!1;this.run_actions_and_subevents();this.runtime.popEventStack();return!0};m.prototype.isFirstConditionOfType=function(a){var b=a.index;if(0===b)return!0;for(--b;0<=b;--b)if(this.conditions[b].type===
a.type)return!1;return!0};cr.eventblock=m;p.prototype.postInit=function(){var a,b,c;a=0;for(b=this.parameters.length;a<b;a++)c=this.parameters[a],c.postInit(),c.variesPerInstance&&(this.anyParamVariesPerInstance=!0)};p.prototype.run_true=function(){return!0};p.prototype.run_system=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get();return cr.xor(this.func.apply(this.runtime.system,this.results),this.inverted)};p.prototype.run_static=function(){var a,
b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get();a=this.func.apply(this.behaviortype?this.behaviortype:this.type,this.results);this.type.applySolToContainer();return a};p.prototype.run_object=function(){var a,b,c,h,k,d,f,e,n=this.type,q=n.getCurrentSol(),g=this.block.orblock&&!this.trigger;b=0;var l=n.is_contained,m=n.is_family,u=n.family_index,p=this.beh_index,t=-1<p,s=this.anyParamVariesPerInstance,w=this.parameters,M=this.results,J=this.inverted,F=this.func,P;
if(s)for(b=0,k=w.length;b<k;++b)d=w[b],d.variesPerInstance||(M[b]=d.get(0));else for(b=0,k=w.length;b<k;++b)M[b]=w[b].get(0);if(q.select_all){q.instances.length=0;q.else_instances.length=0;P=n.instances;a=0;for(h=P.length;a<h;++a){e=P[a];if(s)for(b=0,k=w.length;b<k;++b)d=w[b],d.variesPerInstance&&(M[b]=d.get(a));t?(b=0,m&&(b=e.type.family_beh_map[u]),b=F.apply(e.behavior_insts[p+b],M)):b=F.apply(e,M);(f=cr.xor(b,J))?q.instances.push(e):g&&q.else_instances.push(e)}n.finish&&n.finish(!0);q.select_all=
!1;n.applySolToContainer();return q.hasObjects()}c=0;P=(f=g&&!this.block.isFirstConditionOfType(this))?q.else_instances:q.instances;var V=!1;a=0;for(h=P.length;a<h;++a){e=P[a];if(s)for(b=0,k=w.length;b<k;++b)d=w[b],d.variesPerInstance&&(M[b]=d.get(a));t?(b=0,m&&(b=e.type.family_beh_map[u]),b=F.apply(e.behavior_insts[p+b],M)):b=F.apply(e,M);if(cr.xor(b,J))if(V=!0,f){if(q.instances.push(e),l)for(b=0,k=e.siblings.length;b<k;b++)d=e.siblings[b],d.type.getCurrentSol().instances.push(d)}else{P[c]=e;if(l)for(b=
0,k=e.siblings.length;b<k;b++)d=e.siblings[b],d.type.getCurrentSol().instances[c]=d;c++}else if(f){P[c]=e;if(l)for(b=0,k=e.siblings.length;b<k;b++)d=e.siblings[b],d.type.getCurrentSol().else_instances[c]=d;c++}else if(g&&(q.else_instances.push(e),l))for(b=0,k=e.siblings.length;b<k;b++)d=e.siblings[b],d.type.getCurrentSol().else_instances.push(d)}P.length=c;if(l)for(m=n.container,a=0,h=m.length;a<h;a++)e=m[a].getCurrentSol(),f?e.else_instances.length=c:e.instances.length=c;c=V;if(f&&!V)for(a=0,h=q.instances.length;a<
h;a++){e=q.instances[a];if(s)for(b=0,k=w.length;b<k;b++)d=w[b],d.variesPerInstance&&(M[b]=d.get(a));b=t?F.apply(e.behavior_insts[p],M):F.apply(e,M);if(cr.xor(b,J)){V=!0;break}}n.finish&&n.finish(c||g);return g?V:q.hasObjects()};cr.condition=p;f.prototype.postInit=function(){var a,b,c;a=0;for(b=this.parameters.length;a<b;a++)c=this.parameters[a],c.postInit(),c.variesPerInstance&&(this.anyParamVariesPerInstance=!0)};f.prototype.run_system=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=
this.parameters[a].get();return this.func.apply(this.runtime.system,this.results)};f.prototype.run_object=function(){var a=this.type.getCurrentSol().getObjects(),b=this.type.is_family,c=this.type.family_index,h=this.beh_index,k=-1<h,d=this.anyParamVariesPerInstance,f=this.parameters,e=this.results,n=this.func,q,g,l,m,u,p;if(d)for(g=0,m=f.length;g<m;++g)u=f[g],u.variesPerInstance||(e[g]=u.get(0));else for(g=0,m=f.length;g<m;++g)e[g]=f[g].get(0);q=0;for(l=a.length;q<l;++q){p=a[q];if(d)for(g=0,m=f.length;g<
m;++g)u=f[g],u.variesPerInstance&&(e[g]=u.get(q));k?(g=0,b&&(g=p.type.family_beh_map[c]),n.apply(p.behavior_insts[h+g],e)):n.apply(p,e)}return!1};cr.action=f;var t=[],w=-1;n.prototype.postInit=function(){var a,b;if(11===this.type)this.eventvar=this.runtime.getEventVariableByName(this.varname,this.block.parent);else if(13===this.type)for(a=0,b=this.subparams.length;a<b;a++)this.subparams[a].postInit();this.expression&&this.expression.postInit()};n.prototype.maybeVaryForType=function(a){this.variesPerInstance||
!a||a.plugin.singleglobal||(this.variesPerInstance=!0)};n.prototype.setVaries=function(){this.variesPerInstance=!0};n.prototype.pushTempValue=function(){w++;t.length===w&&t.push(new cr.expvalue);return t[w]};n.prototype.popTempValue=function(){w--};n.prototype.get_exp=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();return a.data};n.prototype.get_exp_str=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();
return cr.is_string(a.data)?a.data:""};n.prototype.get_object=function(){return this.object};n.prototype.get_combosel=function(){return this.combosel};n.prototype.get_layer=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();return a.is_number()?this.runtime.getLayerByNumber(a.data):this.runtime.getLayerByName(a.data)};n.prototype.get_layout=function(){return this.layout};n.prototype.get_key=function(){return this.key};n.prototype.get_instvar=function(){return this.index};
n.prototype.get_familyvar=function(a){a=a||0;var b=this.owner.type,c=null,c=b.getCurrentSol(),h=c.getObjects();if(h.length)c=h[a%h.length].type;else if(c.else_instances.length)c=c.else_instances[a%c.else_instances.length].type;else if(b.instances.length)c=b.instances[a%b.instances.length].type;else return 0;return this.index+c.family_var_map[b.family_index]};n.prototype.get_eventvar=function(){return this.eventvar};n.prototype.get_audiofile=function(){return this.fileinfo};n.prototype.get_variadic=
function(){var a,b;a=0;for(b=this.subparams.length;a<b;a++)this.variadicret[a]=this.subparams[a].get();return this.variadicret};cr.parameter=n;d.prototype.postInit=function(){this.solModifiers=e(this.solModifiers)};d.prototype.setValue=function(a){var b=this.runtime.getCurrentLocalVarStack();this.parent&&!this.is_static&&b?(this.localIndex>=b.length&&(b.length=this.localIndex+1),b[this.localIndex]=a):this.data=a};d.prototype.getValue=function(){var a=this.runtime.getCurrentLocalVarStack();return!this.parent||
this.is_static||!a||this.is_constant?this.data:this.localIndex>=a.length||"undefined"===typeof a[this.localIndex]?this.initial:a[this.localIndex]};d.prototype.run=function(){!this.parent||this.is_static||this.is_constant||this.setValue(this.initial)};cr.eventvariable=d;u.prototype.toString=function(){return"include:"+this.include_sheet.toString()};u.prototype.postInit=function(){this.include_sheet=this.runtime.eventsheets[this.include_sheet_name];this.sheet.includes.add(this);this.solModifiers=e(this.solModifiers);
for(var a=this.parent;a;)a.group&&a.contained_includes.push(this),a=a.parent;this.updateActive()};u.prototype.run=function(){this.parent&&this.runtime.pushCleanSol(this.runtime.types_by_index);this.include_sheet.hasRun||this.include_sheet.run(!0);this.parent&&this.runtime.popSol(this.runtime.types_by_index)};u.prototype.updateActive=function(){for(var a=this.parent;a;){if(a.group&&!a.group_active){this.active=!1;return}a=a.parent}this.active=!0};u.prototype.isActive=function(){return this.active};
cr.eventinclude=u;s.prototype.reset=function(a){this.current_event=a;this.actindex=this.cndindex=0;this.temp_parents_arr.length=0;this.any_true_state=this.else_branch_ran=this.last_event_true=!1};s.prototype.isModifierAfterCnds=function(){return this.current_event.solWriterAfterCnds?!0:this.cndindex<this.current_event.conditions.length-1?!!this.current_event.solModifiers.length:!1};cr.eventStackFrame=s})();
(function(){function a(a,b){this.owner=a;this.runtime=a.runtime;this.type=b[0];this.get=[this.eval_int,this.eval_float,this.eval_string,this.eval_unaryminus,this.eval_add,this.eval_subtract,this.eval_multiply,this.eval_divide,this.eval_mod,this.eval_power,this.eval_and,this.eval_or,this.eval_equal,this.eval_notequal,this.eval_less,this.eval_lessequal,this.eval_greater,this.eval_greaterequal,this.eval_conditional,this.eval_system_exp,this.eval_object_behavior_exp,this.eval_instvar_exp,this.eval_object_behavior_exp,
this.eval_eventvar_exp][this.type];var g=null;this.object_type=this.parameters=this.results=this.func=this.third=this.second=this.first=this.value=null;this.beh_index=-1;this.instance_expr=null;this.varindex=-1;this.eventvar=this.varname=this.behavior_type=null;this.return_string=!1;switch(this.type){case 0:case 1:case 2:this.value=b[1];break;case 3:this.first=new cr.expNode(a,b[1]);break;case 18:this.first=new cr.expNode(a,b[1]);this.second=new cr.expNode(a,b[2]);this.third=new cr.expNode(a,b[3]);
break;case 19:this.func=b[1];this.func!==cr.system_object.prototype.exps.random&&this.func!==cr.system_object.prototype.exps.choose||this.owner.setVaries();this.results=[];this.parameters=[];3===b.length?(g=b[2],this.results.length=g.length+1):this.results.length=1;break;case 20:this.object_type=this.runtime.types_by_index[b[1]];this.beh_index=-1;this.func=b[2];this.return_string=b[3];cr.plugins_.Function&&this.func===cr.plugins_.Function.prototype.exps.Call&&this.owner.setVaries();this.instance_expr=
b[4]?new cr.expNode(a,b[4]):null;this.results=[];this.parameters=[];6===b.length?(g=b[5],this.results.length=g.length+1):this.results.length=1;break;case 21:this.object_type=this.runtime.types_by_index[b[1]];this.return_string=b[2];this.instance_expr=b[3]?new cr.expNode(a,b[3]):null;this.varindex=b[4];break;case 22:this.object_type=this.runtime.types_by_index[b[1]];this.behavior_type=this.object_type.getBehaviorByName(b[2]);this.beh_index=this.object_type.getBehaviorIndexByName(b[2]);this.func=b[3];
this.return_string=b[4];this.instance_expr=b[5]?new cr.expNode(a,b[5]):null;this.results=[];this.parameters=[];7===b.length?(g=b[6],this.results.length=g.length+1):this.results.length=1;break;case 23:this.varname=b[1],this.eventvar=null}this.owner.maybeVaryForType(this.object_type);4<=this.type&&17>=this.type&&(this.first=new cr.expNode(a,b[1]),this.second=new cr.expNode(a,b[2]));if(g){var m,c;m=0;for(c=g.length;m<c;m++)this.parameters.push(new cr.expNode(a,g[m]))}cr.seal(this)}function b(a,b){this.type=
a||cr.exptype.Integer;this.data=b||0;this.object_class=null;this.type==cr.exptype.Integer&&(this.data=Math.floor(this.data));cr.seal(this)}a.prototype.postInit=function(){23===this.type&&(this.eventvar=this.owner.runtime.getEventVariableByName(this.varname,this.owner.block.parent));this.first&&this.first.postInit();this.second&&this.second.postInit();this.third&&this.third.postInit();this.instance_expr&&this.instance_expr.postInit();if(this.parameters){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.parameters[a].postInit()}};
a.prototype.eval_system_exp=function(a){this.results[0]=a;a=this.owner.pushTempValue();var b,g;b=0;for(g=this.parameters.length;b<g;b++)this.parameters[b].get(a),this.results[b+1]=a.data;this.owner.popTempValue();this.func.apply(this.runtime.system,this.results)};a.prototype.eval_object_behavior_exp=function(a){var b=this.object_type.getCurrentSol(),g=b.getObjects();if(!g.length)if(b.else_instances.length)g=b.else_instances;else{this.return_string?a.set_string(""):a.set_int(0);return}this.results[0]=
a;a.object_class=this.object_type;a=this.owner.pushTempValue();var m,b=0;for(m=this.parameters.length;b<m;b++)this.parameters[b].get(a),this.results[b+1]=a.data;b=this.owner.solindex;this.instance_expr&&(this.instance_expr.get(a),a.is_number()&&(b=a.data,g=this.object_type.instances));this.owner.popTempValue();b%=g.length;0>b&&(b+=g.length);g=g[b];-1<this.beh_index?(a=0,this.object_type.is_family&&(a=g.type.family_beh_map[this.object_type.family_index]),this.func.apply(g.behavior_insts[this.beh_index+
a],this.results)):this.func.apply(g,this.results)};a.prototype.eval_instvar_exp=function(a){var b=this.object_type.getCurrentSol(),g=b.getObjects();if(!g.length)if(b.else_instances.length)g=b.else_instances;else{this.return_string?a.set_string(""):a.set_int(0);return}b=this.owner.solindex;if(this.instance_expr){var m=this.owner.pushTempValue();this.instance_expr.get(m);if(m.is_number()){b=m.data;g=this.object_type.instances;b%=g.length;0>b&&(b+=g.length);g=g[b].instance_vars[this.varindex];cr.is_string(g)?
a.set_string(g):a.set_float(g);this.owner.popTempValue();return}this.owner.popTempValue()}b%=g.length;0>b&&(b+=g.length);g=g[b];b=0;this.object_type.is_family&&(b=g.type.family_var_map[this.object_type.family_index]);g=g.instance_vars[this.varindex+b];cr.is_string(g)?a.set_string(g):a.set_float(g)};a.prototype.eval_int=function(a){a.type=cr.exptype.Integer;a.data=this.value};a.prototype.eval_float=function(a){a.type=cr.exptype.Float;a.data=this.value};a.prototype.eval_string=function(a){a.type=cr.exptype.String;
a.data=this.value};a.prototype.eval_unaryminus=function(a){this.first.get(a);a.is_number()&&(a.data=-a.data)};a.prototype.eval_add=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data+=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_subtract=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data-=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};
a.prototype.eval_multiply=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data*=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_divide=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data/=b.data,a.make_float());this.owner.popTempValue()};a.prototype.eval_mod=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);
a.is_number()&&b.is_number()&&(a.data%=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_power=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data=Math.pow(a.data,b.data),b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_and=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()?b.is_string()?a.set_string(a.data.toString()+b.data):a.data&&
b.data?a.set_int(1):a.set_int(0):a.is_string()&&(b.is_string()?a.data+=b.data:a.data+=(Math.round(1E10*b.data)/1E10).toString());this.owner.popTempValue()};a.prototype.eval_or=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data||b.data?a.set_int(1):a.set_int(0));this.owner.popTempValue()};a.prototype.eval_conditional=function(a){this.first.get(a);a.data?this.second.get(a):this.third.get(a)};a.prototype.eval_equal=function(a){this.first.get(a);
var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data===b.data?1:0);this.owner.popTempValue()};a.prototype.eval_notequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data!==b.data?1:0);this.owner.popTempValue()};a.prototype.eval_less=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data<b.data?1:0);this.owner.popTempValue()};a.prototype.eval_lessequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();
this.second.get(b);a.set_int(a.data<=b.data?1:0);this.owner.popTempValue()};a.prototype.eval_greater=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data>b.data?1:0);this.owner.popTempValue()};a.prototype.eval_greaterequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data>=b.data?1:0);this.owner.popTempValue()};a.prototype.eval_eventvar_exp=function(a){var b=this.eventvar.getValue();cr.is_number(b)?a.set_float(b):
a.set_string(b)};cr.expNode=a;b.prototype.is_int=function(){return this.type===cr.exptype.Integer};b.prototype.is_float=function(){return this.type===cr.exptype.Float};b.prototype.is_number=function(){return this.type===cr.exptype.Integer||this.type===cr.exptype.Float};b.prototype.is_string=function(){return this.type===cr.exptype.String};b.prototype.make_int=function(){this.is_int()||(this.is_float()?this.data=Math.floor(this.data):this.is_string()&&(this.data=parseInt(this.data,10)),this.type=cr.exptype.Integer)};
b.prototype.make_float=function(){this.is_float()||(this.is_string()&&(this.data=parseFloat(this.data)),this.type=cr.exptype.Float)};b.prototype.make_string=function(){this.is_string()||(this.data=this.data.toString(),this.type=cr.exptype.String)};b.prototype.set_int=function(a){this.type=cr.exptype.Integer;this.data=Math.floor(a)};b.prototype.set_float=function(a){this.type=cr.exptype.Float;this.data=a};b.prototype.set_string=function(a){this.type=cr.exptype.String;this.data=a};b.prototype.set_any=
function(a){cr.is_number(a)?(this.type=cr.exptype.Float,this.data=a):cr.is_string(a)?(this.type=cr.exptype.String,this.data=a.toString()):(this.type=cr.exptype.Integer,this.data=0)};cr.expvalue=b;cr.exptype={Integer:0,Float:1,String:2}})();cr.system_object=function(a){this.runtime=a;this.waits=[]};
cr.system_object.prototype.saveToJSON=function(){var a={},b,e,l,g,m,c,p,f;a.waits=[];var n=a.waits,d;b=0;for(e=this.waits.length;b<e;b++){c=this.waits[b];d={t:c.time,ev:c.ev.sid,sm:[],sols:{}};c.ev.actions[c.actindex]&&(d.act=c.ev.actions[c.actindex].sid);l=0;for(g=c.solModifiers.length;l<g;l++)d.sm.push(c.solModifiers[l].sid);for(m in c.sols)if(c.sols.hasOwnProperty(m)){p=this.runtime.types_by_index[parseInt(m,10)];f={sa:c.sols[m].sa,insts:[]};l=0;for(g=c.sols[m].insts.length;l<g;l++)f.insts.push(c.sols[m].insts[l].uid);
d.sols[p.sid.toString()]=f}n.push(d)}return a};
cr.system_object.prototype.loadFromJSON=function(a){a=a.waits;var b,e,l,g,m,c,p,f,n,d,u;b=this.waits.length=0;for(e=a.length;b<e;b++)if(c=a[b],f=this.runtime.blocksBySid[c.ev.toString()]){n=-1;l=0;for(g=f.actions.length;l<g;l++)if(f.actions[l].sid===c.act){n=l;break}if(-1!==n){p={sols:{},solModifiers:[],deleteme:!1};p.time=c.t;p.ev=f;p.actindex=n;l=0;for(g=c.sm.length;l<g;l++)(f=this.runtime.getObjectTypeBySid(c.sm[l]))&&p.solModifiers.push(f);for(m in c.sols)if(c.sols.hasOwnProperty(m)&&(f=this.runtime.getObjectTypeBySid(parseInt(m,
10)))){n=c.sols[m];d={sa:n.sa,insts:[]};l=0;for(g=n.insts.length;l<g;l++)(u=this.runtime.getObjectByUID(n.insts[l]))&&d.insts.push(u);p.sols[f.index.toString()]=d}this.waits.push(p)}}};
(function(){function a(){}function b(a,b){var c=a.extra.c2_foreachordered_val,d=b.extra.c2_foreachordered_val;if(cr.is_number(c)&&cr.is_number(d))return c-d;c=""+c;d=""+d;return c<d?-1:c>d?1:0}function e(a,b){n&&a===d&&b===u||(n=RegExp(a,b),d=a,u=b);n.lastIndex=0;return n}function l(){}function g(){}function m(a,b,c){if(a!==r||b!==x||c!==z){var d=e(b,c);w=a.match(d);r=a;x=b;z=c}}var c=cr.system_object.prototype;a.prototype.EveryTick=function(){return!0};a.prototype.OnLayoutStart=function(){return!0};
a.prototype.OnLayoutEnd=function(){return!0};a.prototype.Compare=function(a,b,c){return cr.do_cmp(a,b,c)};a.prototype.CompareTime=function(a,b){var c=this.runtime.kahanTime.sum;if(0===a){var d=this.runtime.getCurrentCondition();return!d.extra.CompareTime_executed&&c>=b?d.extra.CompareTime_executed=!0:!1}return cr.do_cmp(c,a,b)};a.prototype.LayerVisible=function(a){return a?a.visible:!1};a.prototype.LayerCmpOpacity=function(a,b,c){return a?cr.do_cmp(100*a.opacity,b,c):!1};a.prototype.Repeat=function(a){var b=
this.runtime.getCurrentEventStack(),c=b.current_event,d=b.isModifierAfterCnds(),b=this.runtime.pushLoopStack();if(d)for(d=0;d<a&&!b.stopped;d++)this.runtime.pushCopySol(c.solModifiers),b.index=d,c.retrigger(),this.runtime.popSol(c.solModifiers);else for(d=0;d<a&&!b.stopped;d++)b.index=d,c.retrigger();this.runtime.popLoopStack();return!1};a.prototype.While=function(a){var b=this.runtime.getCurrentEventStack();a=b.current_event;var c=b.isModifierAfterCnds(),b=this.runtime.pushLoopStack();if(c)for(c=
0;!b.stopped;c++)this.runtime.pushCopySol(a.solModifiers),b.index=c,a.retrigger()||(b.stopped=!0),this.runtime.popSol(a.solModifiers);else for(c=0;!b.stopped;c++)b.index=c,a.retrigger()||(b.stopped=!0);this.runtime.popLoopStack();return!1};a.prototype.For=function(a,b,c){var d=this.runtime.getCurrentEventStack(),f=d.current_event,d=d.isModifierAfterCnds();a=this.runtime.pushLoopStack(a);if(c<b)if(d)for(;b>=c&&!a.stopped;--b)this.runtime.pushCopySol(f.solModifiers),a.index=b,f.retrigger(),this.runtime.popSol(f.solModifiers);
else for(;b>=c&&!a.stopped;--b)a.index=b,f.retrigger();else if(d)for(;b<=c&&!a.stopped;++b)this.runtime.pushCopySol(f.solModifiers),a.index=b,f.retrigger(),this.runtime.popSol(f.solModifiers);else for(;b<=c&&!a.stopped;++b)a.index=b,f.retrigger();this.runtime.popLoopStack();return!1};var p=[],f=-1;a.prototype.ForEach=function(a){var b=a.getCurrentSol();f++;p.length===f&&p.push([]);var c=p[f];cr.shallowAssignArray(c,b.getObjects());var d=this.runtime.getCurrentEventStack(),e=d.current_event,n=d.isModifierAfterCnds(),
d=this.runtime.pushLoopStack(),q,g,m,u,l,t,s=a.is_contained;if(n)for(n=0,q=c.length;n<q&&!d.stopped;n++){this.runtime.pushCopySol(e.solModifiers);u=c[n];b=a.getCurrentSol();b.select_all=!1;b.instances.length=1;b.instances[0]=u;if(s)for(g=0,m=u.siblings.length;g<m;g++)l=u.siblings[g],t=l.type.getCurrentSol(),t.select_all=!1,t.instances.length=1,t.instances[0]=l;d.index=n;e.retrigger();this.runtime.popSol(e.solModifiers)}else for(b.select_all=!1,b.instances.length=1,n=0,q=c.length;n<q&&!d.stopped;n++){u=
c[n];b.instances[0]=u;if(s)for(g=0,m=u.siblings.length;g<m;g++)l=u.siblings[g],t=l.type.getCurrentSol(),t.select_all=!1,t.instances.length=1,t.instances[0]=l;d.index=n;e.retrigger()}c.length=0;this.runtime.popLoopStack();f--;return!1};a.prototype.ForEachOrdered=function(a,c,d){c=a.getCurrentSol();f++;p.length===f&&p.push([]);var e=p[f];cr.shallowAssignArray(e,c.getObjects());var n=this.runtime.getCurrentEventStack(),q=n.current_event,g=this.runtime.getCurrentCondition(),m=n.isModifierAfterCnds(),
n=this.runtime.pushLoopStack(),u,l,t,s,w;u=0;for(l=e.length;u<l;u++)e[u].extra.c2_foreachordered_val=g.parameters[1].get(u);e.sort(b);1===d&&e.reverse();d=a.is_contained;if(m)for(u=0,l=e.length;u<l&&!n.stopped;u++){this.runtime.pushCopySol(q.solModifiers);t=e[u];c=a.getCurrentSol();c.select_all=!1;c.instances.length=1;c.instances[0]=t;if(d)for(g=0,m=t.siblings.length;g<m;g++)s=t.siblings[g],w=s.type.getCurrentSol(),w.select_all=!1,w.instances.length=1,w.instances[0]=s;n.index=u;q.retrigger();this.runtime.popSol(q.solModifiers)}else for(c.select_all=
!1,c.instances.length=1,u=0,l=e.length;u<l&&!n.stopped;u++){t=e[u];c.instances[0]=t;if(d)for(g=0,m=t.siblings.length;g<m;g++)s=t.siblings[g],w=s.type.getCurrentSol(),w.select_all=!1,w.instances.length=1,w.instances[0]=s;n.index=u;q.retrigger()}e.length=0;this.runtime.popLoopStack();f--;return!1};a.prototype.PickByComparison=function(a,b,c,d){var e,n,g,q;if(a){f++;p.length===f&&p.push([]);var m=p[f],u=a.getCurrentSol();cr.shallowAssignArray(m,u.getObjects());u.select_all&&(u.else_instances.length=
0);var l=this.runtime.getCurrentCondition();g=e=0;for(n=m.length;e<n;e++)q=m[e],m[g]=q,b=l.parameters[1].get(e),d=l.parameters[3].get(e),cr.do_cmp(b,c,d)?g++:u.else_instances.push(q);m.length=g;u.select_all=!1;cr.shallowAssignArray(u.instances,m);m.length=0;f--;a.applySolToContainer();return!!u.instances.length}};a.prototype.PickByEvaluate=function(a,b){var c,d,e,n;if(a){f++;p.length===f&&p.push([]);var g=p[f],q=a.getCurrentSol();cr.shallowAssignArray(g,q.getObjects());q.select_all&&(q.else_instances.length=
0);var m=this.runtime.getCurrentCondition();e=c=0;for(d=g.length;c<d;c++)n=g[c],g[e]=n,(b=m.parameters[1].get(c))?e++:q.else_instances.push(n);g.length=e;q.select_all=!1;cr.shallowAssignArray(q.instances,g);g.length=0;f--;a.applySolToContainer();return!!q.instances.length}};a.prototype.TriggerOnce=function(){var a=this.runtime.getCurrentCondition().extra;"undefined"===typeof a.TriggerOnce_lastTick&&(a.TriggerOnce_lastTick=-1);var b=a.TriggerOnce_lastTick,c=this.runtime.tickcount;a.TriggerOnce_lastTick=
c;return this.runtime.layout_first_tick||b!==c-1};a.prototype.Every=function(a){var b=this.runtime.getCurrentCondition(),c=b.extra.Every_lastTime||0,d=this.runtime.kahanTime.sum;"undefined"===typeof b.extra.Every_seconds&&(b.extra.Every_seconds=a);var f=b.extra.Every_seconds;if(d>=c+f)return b.extra.Every_lastTime=c+f,d>=b.extra.Every_lastTime+0.04&&(b.extra.Every_lastTime=d),b.extra.Every_seconds=a,!0;d<c-0.1&&(b.extra.Every_lastTime=d);return!1};a.prototype.PickNth=function(a,b){if(!a)return!1;
var c=a.getCurrentSol(),d=c.getObjects();b=cr.floor(b);if(0>b||b>=d.length)return!1;c.pick_one(d[b]);a.applySolToContainer();return!0};a.prototype.PickRandom=function(a){if(!a)return!1;var b=a.getCurrentSol(),c=b.getObjects(),d=cr.floor(Math.random()*c.length);if(d>=c.length)return!1;b.pick_one(c[d]);a.applySolToContainer();return!0};a.prototype.CompareVar=function(a,b,c){return cr.do_cmp(a.getValue(),b,c)};a.prototype.IsGroupActive=function(a){return(a=this.runtime.groups_by_name[a.toLowerCase()])&&
a.group_active};a.prototype.IsPreview=function(){return"undefined"!==typeof cr_is_preview};a.prototype.PickAll=function(a){if(!a||!a.instances.length)return!1;a.getCurrentSol().select_all=!0;a.applySolToContainer();return!0};a.prototype.IsMobile=function(){return this.runtime.isMobile};a.prototype.CompareBetween=function(a,b,c){return a>=b&&a<=c};a.prototype.Else=function(){var a=this.runtime.getCurrentEventStack();return a.else_branch_ran?!1:!a.last_event_true};a.prototype.OnLoadFinished=function(){return!0};
a.prototype.OnCanvasSnapshot=function(){return!0};a.prototype.EffectsSupported=function(){return!!this.runtime.glwrap};a.prototype.OnSaveComplete=function(){return!0};a.prototype.OnLoadComplete=function(){return!0};a.prototype.OnLoadFailed=function(){return!0};a.prototype.ObjectUIDExists=function(a){return!!this.runtime.getObjectByUID(a)};a.prototype.IsOnPlatform=function(a){var b=this.runtime;switch(a){case 0:return!b.isDomFree&&!b.isNodeWebkit&&!b.isPhoneGap&&!b.isCrosswalk&&!b.isWinJS&&!b.isWindowsPhone8&&
!b.isBlackberry10&&!b.isAmazonWebApp;case 1:return b.isiOS;case 2:return b.isAndroid;case 3:return b.isWindows8App;case 4:return b.isWindowsPhone8;case 5:return b.isBlackberry10;case 6:return b.isTizen;case 7:return b.isCocoonJs;case 8:return b.isPhoneGap;case 9:return b.isArcade;case 10:return b.isNodeWebkit;case 11:return b.isCrosswalk;case 12:return b.isAmazonWebApp;default:return!1}};var n=null,d="",u="";a.prototype.RegexTest=function(a,b,c){return e(b,c).test(a)};var s=[];a.prototype.PickOverlappingPoint=
function(a,b,c){if(!a)return!1;var d=a.getCurrentSol(),f=d.getObjects(),e=this.runtime.getCurrentEventStack().current_event.orblock,n=this.runtime.getCurrentCondition(),g,q;d.select_all?(cr.shallowAssignArray(s,f),d.else_instances.length=0,d.select_all=!1,d.instances.length=0):e?(cr.shallowAssignArray(s,d.else_instances),d.else_instances.length=0):(cr.shallowAssignArray(s,f),d.instances.length=0);f=0;for(e=s.length;f<e;++f)g=s[f],g.update_bbox(),(q=cr.xor(g.contains_pt(b,c),n.inverted))?d.instances.push(g):
d.else_instances.push(g);a.applySolToContainer();return cr.xor(!!d.instances.length,n.inverted)};c.cnds=new a;l.prototype.GoToLayout=function(a){this.runtime.isloading||this.runtime.changelayout||(this.runtime.changelayout=a)};l.prototype.CreateObject=function(a,b,c,d){if(b&&a&&(b=this.runtime.createInstance(a,b,c,d))){this.runtime.isInOnDestroy++;var f;this.runtime.trigger(Object.getPrototypeOf(a.plugin).cnds.OnCreated,b);if(b.is_contained)for(c=0,d=b.siblings.length;c<d;c++)f=b.siblings[c],this.runtime.trigger(Object.getPrototypeOf(f.type.plugin).cnds.OnCreated,
f);this.runtime.isInOnDestroy--;a=a.getCurrentSol();a.select_all=!1;a.instances.length=1;a.instances[0]=b;if(b.is_contained)for(c=0,d=b.siblings.length;c<d;c++)f=b.siblings[c],a=f.type.getCurrentSol(),a.select_all=!1,a.instances.length=1,a.instances[0]=f}};l.prototype.SetLayerVisible=function(a,b){a&&a.visible!==b&&(a.visible=b,this.runtime.redraw=!0)};l.prototype.SetLayerOpacity=function(a,b){a&&(b=cr.clamp(b/100,0,1),a.opacity!==b&&(a.opacity=b,this.runtime.redraw=!0))};l.prototype.SetLayerScaleRate=
function(a,b){a&&a.zoomRate!==b&&(a.zoomRate=b,this.runtime.redraw=!0)};l.prototype.SetLayoutScale=function(a){this.runtime.running_layout&&this.runtime.running_layout.scale!==a&&(this.runtime.running_layout.scale=a,this.runtime.running_layout.boundScrolling(),this.runtime.redraw=!0)};l.prototype.ScrollX=function(a){this.runtime.running_layout.scrollToX(a)};l.prototype.ScrollY=function(a){this.runtime.running_layout.scrollToY(a)};l.prototype.Scroll=function(a,b){this.runtime.running_layout.scrollToX(a);
this.runtime.running_layout.scrollToY(b)};l.prototype.ScrollToObject=function(a){if(a=a.getFirstPicked())this.runtime.running_layout.scrollToX(a.x),this.runtime.running_layout.scrollToY(a.y)};l.prototype.SetVar=function(a,b){0===a.vartype?cr.is_number(b)?a.setValue(b):a.setValue(parseFloat(b)):1===a.vartype&&a.setValue(b.toString())};l.prototype.AddVar=function(a,b){0===a.vartype?cr.is_number(b)?a.setValue(a.getValue()+b):a.setValue(a.getValue()+parseFloat(b)):1===a.vartype&&a.setValue(a.getValue()+
b.toString())};l.prototype.SubVar=function(a,b){0===a.vartype&&(cr.is_number(b)?a.setValue(a.getValue()-b):a.setValue(a.getValue()-parseFloat(b)))};l.prototype.SetGroupActive=function(a,b){var c=this.runtime.groups_by_name[a.toLowerCase()];if(c)switch(b){case 0:c.setGroupActive(!1);break;case 1:c.setGroupActive(!0);break;case 2:c.setGroupActive(!c.group_active)}};l.prototype.SetTimescale=function(a){0>a&&(a=0);this.runtime.timescale=a};l.prototype.SetObjectTimescale=function(a,b){var c=b;0>c&&(c=
0);if(a){var d=a.getCurrentSol().getObjects(),f,e;f=0;for(e=d.length;f<e;f++)d[f].my_timescale=c}};l.prototype.RestoreObjectTimescale=function(a){if(!a)return!1;a=a.getCurrentSol().getObjects();var b,c;b=0;for(c=a.length;b<c;b++)a[b].my_timescale=-1};var q=[],t=[];l.prototype.Wait=function(a){if(!(0>a)){var b,c,d,f=this.runtime.getCurrentEventStack(),e;e=q.length?q.pop():{sols:{},solModifiers:[]};e.deleteme=!1;e.time=this.runtime.kahanTime.sum+a;e.ev=f.current_event;e.actindex=f.actindex+1;a=0;for(b=
this.runtime.types_by_index.length;a<b;a++)d=this.runtime.types_by_index[a],c=d.getCurrentSol(),c.select_all&&-1===f.current_event.solModifiers.indexOf(d)||(e.solModifiers.push(d),d=void 0,d=t.length?t.pop():{insts:[]},d.sa=!1,d.sa=c.select_all,cr.shallowAssignArray(d.insts,c.instances),e.sols[a.toString()]=d);this.waits.push(e);return!0}};l.prototype.SetLayerScale=function(a,b){a&&a.scale!==b&&(a.scale=b,this.runtime.redraw=!0)};l.prototype.ResetGlobals=function(){var a,b,c;a=0;for(b=this.runtime.all_global_vars.length;a<
b;a++)c=this.runtime.all_global_vars[a],c.data=c.initial};l.prototype.SetLayoutAngle=function(a){a=cr.to_radians(a);a=cr.clamp_angle(a);this.runtime.running_layout&&this.runtime.running_layout.angle!==a&&(this.runtime.running_layout.angle=a,this.runtime.redraw=!0)};l.prototype.SetLayerAngle=function(a,b){a&&(b=cr.to_radians(b),b=cr.clamp_angle(b),a.angle!==b&&(a.angle=b,this.runtime.redraw=!0))};l.prototype.SetLayerParallax=function(a,b,c){if(a&&(a.parallaxX!==b/100||a.parallaxY!==c/100)){a.parallaxX=
b/100;a.parallaxY=c/100;if(1!==a.parallaxX||1!==a.parallaxY)for(c=a.instances,a=0,b=c.length;a<b;++a)c[a].type.any_instance_parallaxed=!0;this.runtime.redraw=!0}};l.prototype.SetLayerBackground=function(a,b){if(a){var c=cr.GetRValue(b),d=cr.GetGValue(b),f=cr.GetBValue(b);if(a.background_color[0]!==c||a.background_color[1]!==d||a.background_color[2]!==f)a.background_color[0]=c,a.background_color[1]=d,a.background_color[2]=f,this.runtime.redraw=!0}};l.prototype.SetLayerTransparent=function(a,b){a&&
!!b!==!!a.transparent&&(a.transparent=!!b,this.runtime.redraw=!0)};l.prototype.StopLoop=function(){0>this.runtime.loop_stack_index||(this.runtime.getCurrentLoop().stopped=!0)};l.prototype.GoToLayoutByName=function(a){if(!this.runtime.isloading&&!this.runtime.changelayout)for(var b in this.runtime.layouts)if(this.runtime.layouts.hasOwnProperty(b)&&cr.equals_nocase(b,a)){this.runtime.changelayout=this.runtime.layouts[b];break}};l.prototype.RestartLayout=function(a){if(!this.runtime.isloading&&!this.runtime.changelayout&&
this.runtime.running_layout){this.runtime.changelayout=this.runtime.running_layout;var b,c;a=0;for(b=this.runtime.allGroups.length;a<b;a++)c=this.runtime.allGroups[a],c.setGroupActive(c.initially_activated)}};l.prototype.SnapshotCanvas=function(a,b){this.runtime.snapshotCanvas=[0===a?"image/png":"image/jpeg",b/100];this.runtime.redraw=!0};l.prototype.SetCanvasSize=function(a,b){if(!(0>=a||0>=b)){var c=this.runtime.fullscreen_mode;(document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||
document.fullScreen||this.runtime.isNodeFullscreen)&&0<this.runtime.fullscreen_scaling&&(c=this.runtime.fullscreen_scaling);0===c?this.runtime.setSize(a,b,!0):(this.runtime.original_width=a,this.runtime.original_height=b,this.runtime.setSize(this.runtime.lastWindowWidth,this.runtime.lastWindowHeight,!0))}};l.prototype.SetLayoutEffectEnabled=function(a,b){if(this.runtime.running_layout&&this.runtime.glwrap){var c=this.runtime.running_layout.getEffectByName(b);if(c){var d=1===a;c.active!=d&&(c.active=
d,this.runtime.running_layout.updateActiveEffects(),this.runtime.redraw=!0)}}};l.prototype.SetLayerEffectEnabled=function(a,b,c){a&&this.runtime.glwrap&&(c=a.getEffectByName(c))&&(b=1===b,c.active!=b&&(c.active=b,a.updateActiveEffects(),this.runtime.redraw=!0))};l.prototype.SetLayoutEffectParam=function(a,b,c){if(this.runtime.running_layout&&this.runtime.glwrap&&(a=this.runtime.running_layout.getEffectByName(a))){var d=this.runtime.running_layout.effect_params[a.index];b=Math.floor(b);0>b||b>=d.length||
(1===this.runtime.glwrap.getProgramParameterType(a.shaderindex,b)&&(c/=100),d[b]!==c&&(d[b]=c,a.active&&(this.runtime.redraw=!0)))}};l.prototype.SetLayerEffectParam=function(a,b,c,d){a&&this.runtime.glwrap&&(b=a.getEffectByName(b))&&(a=a.effect_params[b.index],c=Math.floor(c),0>c||c>=a.length||(1===this.runtime.glwrap.getProgramParameterType(b.shaderindex,c)&&(d/=100),a[c]!==d&&(a[c]=d,b.active&&(this.runtime.redraw=!0))))};l.prototype.SaveState=function(a){this.runtime.saveToSlot=a};l.prototype.LoadState=
function(a){this.runtime.loadFromSlot=a};l.prototype.LoadStateJSON=function(a){this.runtime.loadFromJson=a};l.prototype.SetHalfFramerateMode=function(a){this.runtime.halfFramerateMode=0!==a};l.prototype.SetFullscreenQuality=function(a){if(document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||document.fullScreen||this.isNodeFullscreen||0!==this.runtime.fullscreen_mode)this.runtime.wantFullscreenScalingQuality=0!==a,this.runtime.setSize(this.runtime.lastWindowWidth,this.runtime.lastWindowHeight,
!0)};c.acts=new l;g.prototype["int"]=function(a,b){cr.is_string(b)?(a.set_int(parseInt(b,10)),isNaN(a.data)&&(a.data=0)):a.set_int(b)};g.prototype["float"]=function(a,b){cr.is_string(b)?(a.set_float(parseFloat(b)),isNaN(a.data)&&(a.data=0)):a.set_float(b)};g.prototype.str=function(a,b){cr.is_string(b)?a.set_string(b):a.set_string(b.toString())};g.prototype.len=function(a,b){a.set_int(b.length||0)};g.prototype.random=function(a,b,c){void 0===c?a.set_float(Math.random()*b):a.set_float(Math.random()*
(c-b)+b)};g.prototype.sqrt=function(a,b){a.set_float(Math.sqrt(b))};g.prototype.abs=function(a,b){a.set_float(Math.abs(b))};g.prototype.round=function(a,b){a.set_int(Math.round(b))};g.prototype.floor=function(a,b){a.set_int(Math.floor(b))};g.prototype.ceil=function(a,b){a.set_int(Math.ceil(b))};g.prototype.sin=function(a,b){a.set_float(Math.sin(cr.to_radians(b)))};g.prototype.cos=function(a,b){a.set_float(Math.cos(cr.to_radians(b)))};g.prototype.tan=function(a,b){a.set_float(Math.tan(cr.to_radians(b)))};
g.prototype.asin=function(a,b){a.set_float(cr.to_degrees(Math.asin(b)))};g.prototype.acos=function(a,b){a.set_float(cr.to_degrees(Math.acos(b)))};g.prototype.atan=function(a,b){a.set_float(cr.to_degrees(Math.atan(b)))};g.prototype.exp=function(a,b){a.set_float(Math.exp(b))};g.prototype.ln=function(a,b){a.set_float(Math.log(b))};g.prototype.log10=function(a,b){a.set_float(Math.log(b)/Math.LN10)};g.prototype.max=function(a){var b=arguments[1],c,d;c=2;for(d=arguments.length;c<d;c++)b<arguments[c]&&(b=
arguments[c]);a.set_float(b)};g.prototype.min=function(a){var b=arguments[1],c,d;c=2;for(d=arguments.length;c<d;c++)b>arguments[c]&&(b=arguments[c]);a.set_float(b)};g.prototype.dt=function(a){a.set_float(this.runtime.dt)};g.prototype.timescale=function(a){a.set_float(this.runtime.timescale)};g.prototype.wallclocktime=function(a){a.set_float((Date.now()-this.runtime.start_time)/1E3)};g.prototype.time=function(a){a.set_float(this.runtime.kahanTime.sum)};g.prototype.tickcount=function(a){a.set_int(this.runtime.tickcount)};
g.prototype.objectcount=function(a){a.set_int(this.runtime.objectcount)};g.prototype.fps=function(a){a.set_int(this.runtime.fps)};g.prototype.loopindex=function(a,b){var c,d,f;if(this.runtime.loop_stack.length)if(b){d=0;for(f=this.runtime.loop_stack.length;d<f;d++)if(c=this.runtime.loop_stack[d],c.name===b){a.set_int(c.index);return}a.set_int(0)}else c=this.runtime.getCurrentLoop(),a.set_int(c?c.index:-1);else a.set_int(0)};g.prototype.distance=function(a,b,c,d,f){a.set_float(cr.distanceTo(b,c,d,
f))};g.prototype.angle=function(a,b,c,d,f){a.set_float(cr.to_degrees(cr.angleTo(b,c,d,f)))};g.prototype.scrollx=function(a){a.set_float(this.runtime.running_layout.scrollX)};g.prototype.scrolly=function(a){a.set_float(this.runtime.running_layout.scrollY)};g.prototype.newline=function(a){a.set_string("\n")};g.prototype.lerp=function(a,b,c,d){a.set_float(cr.lerp(b,c,d))};g.prototype.windowwidth=function(a){a.set_int(this.runtime.width)};g.prototype.windowheight=function(a){a.set_int(this.runtime.height)};
g.prototype.uppercase=function(a,b){a.set_string(cr.is_string(b)?b.toUpperCase():"")};g.prototype.lowercase=function(a,b){a.set_string(cr.is_string(b)?b.toLowerCase():"")};g.prototype.clamp=function(a,b,c,d){b<c?a.set_float(c):b>d?a.set_float(d):a.set_float(b)};g.prototype.layerscale=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(c.scale):a.set_float(0)};g.prototype.layeropacity=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.opacity):a.set_float(0)};g.prototype.layerscalerate=
function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(c.zoomRate):a.set_float(0)};g.prototype.layerparallaxx=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.parallaxX):a.set_float(0)};g.prototype.layerparallaxy=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.parallaxY):a.set_float(0)};g.prototype.layoutscale=function(a){this.runtime.running_layout?a.set_float(this.runtime.running_layout.scale):a.set_float(0)};g.prototype.layoutangle=function(a){a.set_float(cr.to_degrees(this.runtime.running_layout.angle))};
g.prototype.layerangle=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(cr.to_degrees(c.angle)):a.set_float(0)};g.prototype.layoutwidth=function(a){a.set_int(this.runtime.running_layout.width)};g.prototype.layoutheight=function(a){a.set_int(this.runtime.running_layout.height)};g.prototype.find=function(a,b,c){cr.is_string(b)&&cr.is_string(c)?a.set_int(b.search(RegExp(cr.regexp_escape(c),"i"))):a.set_int(-1)};g.prototype.left=function(a,b,c){a.set_string(cr.is_string(b)?b.substr(0,c):"")};
g.prototype.right=function(a,b,c){a.set_string(cr.is_string(b)?b.substr(b.length-c):"")};g.prototype.mid=function(a,b,c,d){a.set_string(cr.is_string(b)?b.substr(c,d):"")};g.prototype.tokenat=function(a,b,c,d){cr.is_string(b)&&cr.is_string(d)?(b=b.split(d),c=cr.floor(c),0>c||c>=b.length?a.set_string(""):a.set_string(b[c])):a.set_string("")};g.prototype.tokencount=function(a,b,c){cr.is_string(b)&&b.length?a.set_int(b.split(c).length):a.set_int(0)};g.prototype.replace=function(a,b,c,d){cr.is_string(b)&&
cr.is_string(c)&&cr.is_string(d)?a.set_string(b.replace(RegExp(cr.regexp_escape(c),"gi"),d)):a.set_string(cr.is_string(b)?b:"")};g.prototype.trim=function(a,b){a.set_string(cr.is_string(b)?b.trim():"")};g.prototype.pi=function(a){a.set_float(cr.PI)};g.prototype.layoutname=function(a){this.runtime.running_layout?a.set_string(this.runtime.running_layout.name):a.set_string("")};g.prototype.renderer=function(a){a.set_string(this.runtime.gl?"webgl":"canvas2d")};g.prototype.anglediff=function(a,b,c){a.set_float(cr.to_degrees(cr.angleDiff(cr.to_radians(b),
cr.to_radians(c))))};g.prototype.choose=function(a){var b=cr.floor(Math.random()*(arguments.length-1));a.set_any(arguments[b+1])};g.prototype.rgb=function(a,b,c,d){a.set_int(cr.RGB(b,c,d))};g.prototype.projectversion=function(a){a.set_string(this.runtime.versionstr)};g.prototype.anglelerp=function(a,b,c,d){b=cr.to_radians(b);c=cr.to_radians(c);var f=cr.angleDiff(b,c);cr.angleClockwise(c,b)?a.set_float(cr.to_clamped_degrees(b+f*d)):a.set_float(cr.to_clamped_degrees(b-f*d))};g.prototype.anglerotate=
function(a,b,c,d){b=cr.to_radians(b);c=cr.to_radians(c);d=cr.to_radians(d);a.set_float(cr.to_clamped_degrees(cr.angleRotate(b,c,d)))};g.prototype.zeropad=function(a,b,c){var d=0>b?"-":"";0>b&&(b=-b);c-=b.toString().length;for(var f=0;f<c;f++)d+="0";a.set_string(d+b.toString())};g.prototype.cpuutilisation=function(a){a.set_float(this.runtime.cpuutilisation/1E3)};g.prototype.viewportleft=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewLeft:0)};g.prototype.viewporttop=function(a,b){var c=
this.runtime.getLayer(b);a.set_float(c?c.viewTop:0)};g.prototype.viewportright=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewRight:0)};g.prototype.viewportbottom=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewBottom:0)};g.prototype.loadingprogress=function(a){a.set_float(this.runtime.loadingprogress)};g.prototype.unlerp=function(a,b,c,d){a.set_float(cr.unlerp(b,c,d))};g.prototype.canvassnapshot=function(a){a.set_string(this.runtime.snapshotData)};g.prototype.urlencode=
function(a,b){a.set_string(encodeURIComponent(b))};g.prototype.urldecode=function(a,b){a.set_string(decodeURIComponent(b))};g.prototype.canvastolayerx=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.canvasToLayer(c,d,!0):0)};g.prototype.canvastolayery=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.canvasToLayer(c,d,!1):0)};g.prototype.layertocanvasx=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.layerToCanvas(c,d,!0):0)};g.prototype.layertocanvasy=function(a,
b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.layerToCanvas(c,d,!1):0)};g.prototype.savestatejson=function(a){a.set_string(this.runtime.lastSaveJson)};g.prototype.imagememoryusage=function(a){this.runtime.glwrap?a.set_float(Math.round(100*this.runtime.glwrap.estimateVRAM()/1048576)/100):a.set_float(0)};g.prototype.regexsearch=function(a,b,c,d){c=e(c,d);a.set_int(b?b.search(c):-1)};g.prototype.regexreplace=function(a,b,c,d,f){c=e(c,d);a.set_string(b?b.replace(c,f):"")};var w=[],r="",x="",z="";
g.prototype.regexmatchcount=function(a,b,c,d){e(c,d);m(b,c,d);a.set_int(w?w.length:0)};g.prototype.regexmatchat=function(a,b,c,d,f){f=Math.floor(f);e(c,d);m(b,c,d);!w||0>f||f>=w.length?a.set_string(""):a.set_string(w[f])};g.prototype.infinity=function(a){a.set_float(Infinity)};g.prototype.setbit=function(a,b,c,d){c|=0;a.set_int((b|0)&~(1<<c)|(0!==d?1:0)<<c)};g.prototype.togglebit=function(a,b,c){a.set_int((b|0)^1<<(c|0))};g.prototype.getbit=function(a,b,c){a.set_int((b|0)&1<<(c|0)?1:0)};c.exps=new g;
c.runWaits=function(){var a,b,c,d,f,e,n=this.runtime.getCurrentEventStack();a=0;for(c=this.waits.length;a<c;a++)if(d=this.waits[a],!(d.time>this.runtime.kahanTime.sum)){n.current_event=d.ev;n.actindex=d.actindex;n.cndindex=0;for(b in d.sols)d.sols.hasOwnProperty(b)&&(f=this.runtime.types_by_index[parseInt(b,10)].getCurrentSol(),e=d.sols[b],f.select_all=e.sa,cr.shallowAssignArray(f.instances,e.insts),f=e,f.insts.length=0,t.push(f));d.ev.resume_actions_and_subevents();this.runtime.clearSol(d.solModifiers);
d.deleteme=!0}b=a=0;for(c=this.waits.length;a<c;a++)d=this.waits[a],this.waits[b]=d,d.deleteme?(cr.wipe(d.sols),d.solModifiers.length=0,q.push(d)):b++;this.waits.length=b}})();
(function(){cr.add_common_aces=function(a){var e=a[0].prototype,l=a[1],g=a[3],m=a[4],c=a[5],p=a[6],f=a[7];a=a[8];e.cnds||(e.cnds={});e.acts||(e.acts={});e.exps||(e.exps={});var n=e.cnds,d=e.acts,e=e.exps;g&&(n.CompareX=function(a,b){return cr.do_cmp(this.x,a,b)},n.CompareY=function(a,b){return cr.do_cmp(this.y,a,b)},n.IsOnScreen=function(){var a=this.layer;this.update_bbox();var b=this.bbox;return!(b.right<a.viewLeft||b.bottom<a.viewTop||b.left>a.viewRight||b.top>a.viewBottom)},n.IsOutsideLayout=
function(){this.update_bbox();var a=this.bbox,b=this.runtime.running_layout;return 0>a.right||0>a.bottom||a.left>b.width||a.top>b.height},n.PickDistance=function(a,b,c){var d=this.getCurrentSol(),f=d.getObjects();if(!f.length)return!1;var e=f[0],n=e,g=cr.distanceTo(e.x,e.y,b,c),h,k,m;h=1;for(k=f.length;h<k;h++)if(e=f[h],m=cr.distanceTo(e.x,e.y,b,c),0===a&&m<g||1===a&&m>g)g=m,n=e;d.pick_one(n);return!0},d.SetX=function(a){this.x!==a&&(this.x=a,this.set_bbox_changed())},d.SetY=function(a){this.y!==
a&&(this.y=a,this.set_bbox_changed())},d.SetPos=function(a,b){if(this.x!==a||this.y!==b)this.x=a,this.y=b,this.set_bbox_changed()},d.SetPosToObject=function(a,b){var c=a.getPairedInstance(this);if(c){var d;c.getImagePoint?(d=c.getImagePoint(b,!0),c=c.getImagePoint(b,!1)):(d=c.x,c=c.y);if(this.x!==d||this.y!==c)this.x=d,this.y=c,this.set_bbox_changed()}},d.MoveForward=function(a){0!==a&&(this.x+=Math.cos(this.angle)*a,this.y+=Math.sin(this.angle)*a,this.set_bbox_changed())},d.MoveAtAngle=function(a,
b){0!==b&&(this.x+=Math.cos(cr.to_radians(a))*b,this.y+=Math.sin(cr.to_radians(a))*b,this.set_bbox_changed())},e.X=function(a){a.set_float(this.x)},e.Y=function(a){a.set_float(this.y)},e.dt=function(a){a.set_float(this.runtime.getDt(this))});m&&(n.CompareWidth=function(a,b){return cr.do_cmp(this.width,a,b)},n.CompareHeight=function(a,b){return cr.do_cmp(this.height,a,b)},d.SetWidth=function(a){this.width!==a&&(this.width=a,this.set_bbox_changed())},d.SetHeight=function(a){this.height!==a&&(this.height=
a,this.set_bbox_changed())},d.SetSize=function(a,b){if(this.width!==a||this.height!==b)this.width=a,this.height=b,this.set_bbox_changed()},e.Width=function(a){a.set_float(this.width)},e.Height=function(a){a.set_float(this.height)},e.BBoxLeft=function(a){this.update_bbox();a.set_float(this.bbox.left)},e.BBoxTop=function(a){this.update_bbox();a.set_float(this.bbox.top)},e.BBoxRight=function(a){this.update_bbox();a.set_float(this.bbox.right)},e.BBoxBottom=function(a){this.update_bbox();a.set_float(this.bbox.bottom)});
c&&(n.AngleWithin=function(a,b){return cr.angleDiff(this.angle,cr.to_radians(b))<=cr.to_radians(a)},n.IsClockwiseFrom=function(a){return cr.angleClockwise(this.angle,cr.to_radians(a))},n.IsBetweenAngles=function(a,b){var c=cr.to_clamped_radians(a),d=cr.to_clamped_radians(b),f=cr.clamp_angle(this.angle);return cr.angleClockwise(d,c)?cr.angleClockwise(f,c)&&!cr.angleClockwise(f,d):!(!cr.angleClockwise(f,c)&&cr.angleClockwise(f,d))},d.SetAngle=function(a){a=cr.to_radians(cr.clamp_angle_degrees(a));isNaN(a)||
this.angle===a||(this.angle=a,this.set_bbox_changed())},d.RotateClockwise=function(a){0===a||isNaN(a)||(this.angle+=cr.to_radians(a),this.angle=cr.clamp_angle(this.angle),this.set_bbox_changed())},d.RotateCounterclockwise=function(a){0===a||isNaN(a)||(this.angle-=cr.to_radians(a),this.angle=cr.clamp_angle(this.angle),this.set_bbox_changed())},d.RotateTowardAngle=function(a,b){var c=cr.angleRotate(this.angle,cr.to_radians(b),cr.to_radians(a));isNaN(c)||this.angle===c||(this.angle=c,this.set_bbox_changed())},
d.RotateTowardPosition=function(a,b,c){b=Math.atan2(c-this.y,b-this.x);a=cr.angleRotate(this.angle,b,cr.to_radians(a));isNaN(a)||this.angle===a||(this.angle=a,this.set_bbox_changed())},d.SetTowardPosition=function(a,b){var c=Math.atan2(b-this.y,a-this.x);isNaN(c)||this.angle===c||(this.angle=c,this.set_bbox_changed())},e.Angle=function(a){a.set_float(cr.to_clamped_degrees(this.angle))});l||(n.CompareInstanceVar=function(a,b,c){return cr.do_cmp(this.instance_vars[a],b,c)},n.IsBoolInstanceVarSet=function(a){return this.instance_vars[a]},
n.PickInstVarHiLow=function(a,b){var c=this.getCurrentSol(),d=c.getObjects();if(!d.length)return!1;var f=d[0],e=f,n=f.instance_vars[b],g,h,k;g=1;for(h=d.length;g<h;g++)if(f=d[g],k=f.instance_vars[b],0===a&&k<n||1===a&&k>n)n=k,e=f;c.pick_one(e);return!0},n.PickByUID=function(a){var b,c,d,f,e;if(this.runtime.getCurrentCondition().inverted){e=this.getCurrentSol();if(e.select_all)for(e.select_all=!1,e.instances.length=0,e.else_instances.length=0,d=this.instances,b=0,c=d.length;b<c;b++)f=d[b],f.uid===
a?e.else_instances.push(f):e.instances.push(f);else{d=b=0;for(c=e.instances.length;b<c;b++)f=e.instances[b],e.instances[d]=f,f.uid===a?e.else_instances.push(f):d++;e.instances.length=d}this.applySolToContainer();return!!e.instances.length}f=this.runtime.getObjectByUID(a);if(!f)return!1;e=this.getCurrentSol();if(!e.select_all&&-1===e.instances.indexOf(f))return!1;if(this.is_family)for(a=f.type.families,b=0,c=a.length;b<c;b++){if(a[b]===this)return e.pick_one(f),this.applySolToContainer(),!0}else if(f.type===
this)return e.pick_one(f),this.applySolToContainer(),!0;return!1},n.OnCreated=function(){return!0},n.OnDestroyed=function(){return!0},d.SetInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])?cr.is_number(b)?c[a]=b:c[a]=parseFloat(b):cr.is_string(c[a])&&(cr.is_string(b)?c[a]=b:c[a]=b.toString())},d.AddInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])?cr.is_number(b)?c[a]+=b:c[a]+=parseFloat(b):cr.is_string(c[a])&&(cr.is_string(b)?c[a]+=b:c[a]+=b.toString())},d.SubInstanceVar=
function(a,b){var c=this.instance_vars;cr.is_number(c[a])&&(cr.is_number(b)?c[a]-=b:c[a]-=parseFloat(b))},d.SetBoolInstanceVar=function(a,b){this.instance_vars[a]=b?1:0},d.ToggleBoolInstanceVar=function(a){this.instance_vars[a]=1-this.instance_vars[a]},d.Destroy=function(){this.runtime.DestroyInstance(this)},d.LoadFromJsonString||(d.LoadFromJsonString=function(a){var b,c;try{b=JSON.parse(a)}catch(d){return}this.runtime.loadInstanceFromJSON(this,b,!0);this.afterLoad&&this.afterLoad();if(this.behavior_insts)for(a=
0,b=this.behavior_insts.length;a<b;++a)c=this.behavior_insts[a],c.afterLoad&&c.afterLoad()}),e.Count=function(a){var b=a.object_class.instances.length,c,d,f;c=0;for(d=this.runtime.createRow.length;c<d;c++)f=this.runtime.createRow[c],a.object_class.is_family?0<=f.type.families.indexOf(a.object_class)&&b++:f.type===a.object_class&&b++;a.set_int(b)},e.PickedCount=function(a){a.set_int(a.object_class.getCurrentSol().getObjects().length)},e.UID=function(a){a.set_int(this.uid)},e.IID=function(a){a.set_int(this.get_iid())},
e.AsJSON||(e.AsJSON=function(a){a.set_string(JSON.stringify(this.runtime.saveInstanceToJSON(this,!0)))}));p&&(n.IsVisible=function(){return this.visible},d.SetVisible=function(a){!a!==!this.visible&&(this.visible=a,this.runtime.redraw=!0)},n.CompareOpacity=function(a,b){return cr.do_cmp(cr.round6dp(100*this.opacity),a,b)},d.SetOpacity=function(a){a/=100;0>a?a=0:1<a&&(a=1);a!==this.opacity&&(this.opacity=a,this.runtime.redraw=!0)},e.Opacity=function(a){a.set_float(cr.round6dp(100*this.opacity))});
f&&(n.IsOnLayer=function(a){return a?this.layer===a:!1},n.PickTopBottom=function(a){var b=this.getCurrentSol(),c=b.getObjects();if(!c.length)return!1;var d=c[0],f=d,e,n;e=1;for(n=c.length;e<n;e++)if(d=c[e],0===a){if(d.layer.index>f.layer.index||d.layer.index===f.layer.index&&d.get_zindex()>f.get_zindex())f=d}else if(d.layer.index<f.layer.index||d.layer.index===f.layer.index&&d.get_zindex()<f.get_zindex())f=d;b.pick_one(f);return!0},d.MoveToTop=function(){var a=this.get_zindex();a!==this.layer.instances.length-
1&&(cr.arrayRemove(this.layer.instances,a),this.layer.instances.push(this),this.runtime.redraw=!0,this.layer.zindices_stale=!0)},d.MoveToBottom=function(){var a=this.get_zindex();0!==a&&(cr.arrayRemove(this.layer.instances,a),this.layer.instances.unshift(this),this.runtime.redraw=!0,this.layer.zindices_stale=!0)},d.MoveToLayer=function(a){a&&a!=this.layer&&(cr.arrayRemove(this.layer.instances,this.get_zindex()),this.layer.zindices_stale=!0,this.layer=a,this.zindex=a.instances.length,a.instances.push(this),
this.runtime.redraw=!0)},d.ZMoveToObject=function(a,b){var c=0===a;if(b){var d=b.getFirstPicked(this);if(d&&d.uid!==this.uid){this.layer.index!==d.layer.index&&(cr.arrayRemove(this.layer.instances,this.get_zindex()),this.layer.zindices_stale=!0,this.layer=d.layer,this.zindex=d.layer.instances.length,d.layer.instances.push(this));var f=this.get_zindex(),d=d.get_zindex();cr.arrayRemove(this.layer.instances,f);f<d&&d--;c&&d++;d===this.layer.instances.length?this.layer.instances.push(this):this.layer.instances.splice(d,
0,this);this.layer.zindices_stale=!0;this.runtime.redraw=!0}}},e.LayerNumber=function(a){a.set_int(this.layer.number)},e.LayerName=function(a){a.set_string(this.layer.name)},e.ZIndex=function(a){a.set_int(this.get_zindex())});a&&(d.SetEffectEnabled=function(a,b){if(this.runtime.glwrap){var c=this.type.getEffectIndexByName(b);if(!(0>c)){var d=1===a;this.active_effect_flags[c]!==d&&(this.active_effect_flags[c]=d,this.updateActiveEffects(),this.runtime.redraw=!0)}}},d.SetEffectParam=function(a,b,c){if(this.runtime.glwrap){var d=
this.type.getEffectIndexByName(a);0>d||(a=this.type.effect_types[d],d=this.effect_params[d],b=Math.floor(b),0>b||b>=d.length||(1===this.runtime.glwrap.getProgramParameterType(a.shaderindex,b)&&(c/=100),d[b]!==c&&(d[b]=c,a.active&&(this.runtime.redraw=!0))))}})};cr.set_bbox_changed=function(){this.cell_changed=this.bbox_changed=!0;this.type.any_cell_changed=!0;this.runtime.redraw=!0;var a,e,l=this.bbox_changed_callbacks;a=0;for(e=l.length;a<e;++a)l[a](this)};cr.add_bbox_changed_callback=function(a){a&&
this.bbox_changed_callbacks.push(a)};cr.update_bbox=function(){if(this.bbox_changed){var a=this.bbox,e=this.bquad;a.set(this.x,this.y,this.x+this.width,this.y+this.height);a.offset(-this.hotspotX*this.width,-this.hotspotY*this.height);this.angle?(a.offset(-this.x,-this.y),e.set_from_rotated_rect(a,this.angle),e.offset(this.x,this.y),e.bounding_box(a)):e.set_from_rect(a);a.normalize();this.bbox_changed=!1}};var a=new cr.rect(0,0,0,0);cr.update_collision_cell=function(){if(this.cell_changed&&this.collisionsEnabled){this.update_bbox();
var b=this.type.collision_grid,e=this.collcells,l=this.bbox;a.set(b.XToCell(l.left),b.YToCell(l.top),b.XToCell(l.right),b.YToCell(l.bottom));e.equals(a)||(e.right<e.left?b.update(this,null,a):b.update(this,e,a),e.copy(a),this.cell_changed=!1)}};cr.inst_contains_pt=function(a,e){return this.bbox.contains_pt(a,e)&&this.bquad.contains_pt(a,e)?this.collision_poly&&!this.collision_poly.is_empty()?(this.collision_poly.cache_poly(this.width,this.height,this.angle),this.collision_poly.contains_pt(a-this.x,
e-this.y)):!0:!1};cr.inst_get_iid=function(){this.type.updateIIDs();return this.iid};cr.inst_get_zindex=function(){this.layer.updateZIndices();return this.zindex};cr.inst_updateActiveEffects=function(){this.active_effect_types.length=0;var a,e;a=0;for(e=this.active_effect_flags.length;a<e;a++)this.active_effect_flags[a]&&this.active_effect_types.push(this.type.effect_types[a]);this.uses_shaders=!!this.active_effect_types.length};cr.inst_toString=function(){return"Inst"+this.puid};cr.type_getFirstPicked=
function(a){if(a&&a.is_contained&&a.type!=this){var e,l,g;e=0;for(l=a.siblings.length;e<l;e++)if(g=a.siblings[e],g.type==this)return g}a=this.getCurrentSol().getObjects();return a.length?a[0]:null};cr.type_getPairedInstance=function(a){var e=this.getCurrentSol().getObjects();return e.length?e[a.get_iid()%e.length]:null};cr.type_updateIIDs=function(){if(this.stale_iids&&!this.is_family){var a,e;a=0;for(e=this.instances.length;a<e;a++)this.instances[a].iid=a;var l=a,g=this.runtime.createRow;a=0;for(e=
g.length;a<e;++a)g[a].type===this&&(g[a].iid=l++);this.stale_iids=!1}};cr.type_getInstanceByIID=function(a){if(a<this.instances.length)return this.instances[a];a-=this.instances.length;var e=this.runtime.createRow,l,g;l=0;for(g=e.length;l<g;++l)if(e[l].type===this){if(0===a)return e[l];--a}return null};cr.type_getCurrentSol=function(){return this.solstack[this.cur_sol]};cr.type_pushCleanSol=function(){this.cur_sol++;this.cur_sol===this.solstack.length?this.solstack.push(new cr.selection(this)):this.solstack[this.cur_sol].select_all=
!0};cr.type_pushCopySol=function(){this.cur_sol++;this.cur_sol===this.solstack.length&&this.solstack.push(new cr.selection(this));var a=this.solstack[this.cur_sol],e=this.solstack[this.cur_sol-1];e.select_all?a.select_all=!0:(a.select_all=!1,cr.shallowAssignArray(a.instances,e.instances),cr.shallowAssignArray(a.else_instances,e.else_instances))};cr.type_popSol=function(){this.cur_sol--};cr.type_getBehaviorByName=function(a){var e,l,g,m,c,p=0;if(!this.is_family)for(e=0,l=this.families.length;e<l;e++)for(c=
this.families[e],g=0,m=c.behaviors.length;g<m;g++){if(a===c.behaviors[g].name)return this.extra.lastBehIndex=p,c.behaviors[g];p++}e=0;for(l=this.behaviors.length;e<l;e++){if(a===this.behaviors[e].name)return this.extra.lastBehIndex=p,this.behaviors[e];p++}return null};cr.type_getBehaviorIndexByName=function(a){return this.getBehaviorByName(a)?this.extra.lastBehIndex:-1};cr.type_getEffectIndexByName=function(a){var e,l;e=0;for(l=this.effect_types.length;e<l;e++)if(this.effect_types[e].name===a)return e;
return-1};cr.type_applySolToContainer=function(){if(this.is_contained&&!this.is_family){var a,e,l,g,m,c,p;this.updateIIDs();c=this.getCurrentSol();var f=c.select_all,n=(a=this.runtime.getCurrentEventStack())&&a.current_event&&a.current_event.orblock;a=0;for(e=this.container.length;a<e;a++)if(m=this.container[a],m!==this&&(m.updateIIDs(),p=m.getCurrentSol(),p.select_all=f,!f)){p.instances.length=c.instances.length;l=0;for(g=c.instances.length;l<g;l++)p.instances[l]=m.getInstanceByIID(c.instances[l].iid);
if(n)for(p.else_instances.length=c.else_instances.length,l=0,g=c.else_instances.length;l<g;l++)p.else_instances[l]=m.getInstanceByIID(c.else_instances[l].iid)}}};cr.type_toString=function(){return"Type"+this.sid};cr.do_cmp=function(a,e,l){if("undefined"===typeof a||"undefined"===typeof l)return!1;switch(e){case 0:return a===l;case 1:return a!==l;case 2:return a<l;case 3:return a<=l;case 4:return a>l;case 5:return a>=l;default:return!1}}})();cr.shaders={};
cr.plugins_.AJAX=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(){}var l=!1,g=null,m=null,c="",p=cr.plugins_.AJAX.prototype;p.Type=function(a){this.plugin=a;this.runtime=a.runtime};p.Type.prototype.onCreate=function(){};p.Instance=function(a){this.type=a;this.runtime=a.runtime;this.curTag=this.lastData="";this.progress=0;this.timeout=-1;if(l=this.runtime.isNodeWebkit)g=require("path"),m=require("fs"),c=g.dirname(process.execPath)+"\\"};var f=p.Instance.prototype,n=null;window.C2_AJAX_DCSide=function(a,b,c){n&&
("success"===a?(n.curTag=b,n.lastData=c,n.runtime.trigger(cr.plugins_.AJAX.prototype.cnds.OnComplete,n)):"error"===a?(n.curTag=b,n.runtime.trigger(cr.plugins_.AJAX.prototype.cnds.OnError,n)):"progress"===a&&(n.progress=c,n.curTag=b,n.runtime.trigger(cr.plugins_.AJAX.prototype.cnds.OnProgress,n)))};f.onCreate=function(){n=this};f.saveToJSON=function(){return{lastData:this.lastData}};f.loadFromJSON=function(a){this.lastData=a.lastData;this.curTag="";this.progress=0};f.doRequest=function(a,b,f,e){if(this.runtime.isDirectCanvas)AppMobi.webview.execute('C2_AJAX_WebSide("'+
a+'", "'+b+'", "'+f+'", '+(e?'"'+e+'"':"null")+");");else{var n=this,g=null,p=function(){n.curTag=a;n.runtime.trigger(cr.plugins_.AJAX.prototype.cnds.OnError,n)},x=function(){if(l){var a=c+b;m.existsSync(a)?m.readFile(a,{encoding:"utf8"},function(a,b){a?p():(n.lastData=b.replace(/\r\n/g,"\n"),n.runtime.trigger(cr.plugins_.AJAX.prototype.cnds.OnComplete,n))}):p()}else p()},z=function(b){b.lengthComputable&&(n.progress=b.loaded/b.total,n.curTag=a,n.runtime.trigger(cr.plugins_.AJAX.prototype.cnds.OnProgress,
n))};try{g=this.runtime.isWindowsPhone8?new ActiveXObject("Microsoft.XMLHTTP"):new XMLHttpRequest;g.onreadystatechange=function(){4===g.readyState&&(n.curTag=a,n.lastData=g.responseText?g.responseText.replace(/\r\n/g,"\n"):"",400<=g.status?n.runtime.trigger(cr.plugins_.AJAX.prototype.cnds.OnError,n):l&&!n.lastData.length||n.runtime.trigger(cr.plugins_.AJAX.prototype.cnds.OnComplete,n))};this.runtime.isWindowsPhone8||(g.onerror=x,g.ontimeout=x,g.onabort=x,g.onprogress=z,0<=this.timeout&&"undefined"!==
typeof g.timeout&&(g.timeout=this.timeout));g.open(f,b);try{g.responseType="text"}catch(h){}"POST"===f&&e?(g.setRequestHeader&&g.setRequestHeader("Content-Type","application/x-www-form-urlencoded"),g.send(e)):g.send()}catch(k){x()}}};a.prototype.OnComplete=function(a){return cr.equals_nocase(a,this.curTag)};a.prototype.OnError=function(a){return cr.equals_nocase(a,this.curTag)};a.prototype.OnProgress=function(a){return cr.equals_nocase(a,this.curTag)};p.cnds=new a;b.prototype.Request=function(a,b){this.doRequest(a,
b,"GET")};b.prototype.RequestFile=function(a,b){this.doRequest(a,b,"GET")};b.prototype.Post=function(a,b,c){this.doRequest(a,b,"POST",c)};b.prototype.SetTimeout=function(a){this.timeout=1E3*a};p.acts=new b;e.prototype.LastData=function(a){a.set_string(this.lastData)};e.prototype.Progress=function(a){a.set_float(this.progress)};p.exps=new e})();cr.plugins_.Arr=function(a){this.runtime=a};
(function(){function a(){return f.length?f.pop():[]}function b(a){var c,e;c=0;for(e=a.length;c<e;c++)Array.isArray(a[c])&&b(a[c]);a.length=0;f.push(a)}function e(){}function l(){}function g(a,b){if(cr.is_number(a)&&cr.is_number(b))return a-b;var c=""+a,f=""+b;return c<f?-1:c>f?1:0}function m(){}var c=cr.plugins_.Arr.prototype;c.Type=function(a){this.plugin=a;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a){this.type=a;this.runtime=a.runtime};var p=c.Instance.prototype,
f=[];Array.isArray||(Array.isArray=function(a){return"[object Array]"===Object.prototype.toString.call(a)});p.onCreate=function(){this.cx=this.properties[0];this.cy=this.properties[1];this.cz=this.properties[2];this.recycled||(this.arr=a());var b=this.arr;b.length=this.cx;var c,f,e;for(c=0;c<this.cx;c++)for(b[c]||(b[c]=a()),b[c].length=this.cy,f=0;f<this.cy;f++)for(b[c][f]||(b[c][f]=a()),b[c][f].length=this.cz,e=0;e<this.cz;e++)b[c][f][e]=0;this.forZ=this.forY=this.forX=0};p.onDestroy=function(){var a;
for(a=0;a<this.cx;a++)b(this.arr[a]);this.arr.length=0};p.at=function(a,b,c){a=Math.floor(a);b=Math.floor(b);c=Math.floor(c);return isNaN(a)||0>a||a>this.cx-1||isNaN(b)||0>b||b>this.cy-1||isNaN(c)||0>c||c>this.cz-1?0:this.arr[a][b][c]};p.set=function(a,b,c,f){a=Math.floor(a);b=Math.floor(b);c=Math.floor(c);isNaN(a)||0>a||a>this.cx-1||isNaN(b)||0>b||b>this.cy-1||isNaN(c)||0>c||c>this.cz-1||(this.arr[a][b][c]=f)};p.getAsJSON=function(){return JSON.stringify({c2array:!0,size:[this.cx,this.cy,this.cz],
data:this.arr})};p.saveToJSON=function(){return{size:[this.cx,this.cy,this.cz],data:this.arr}};p.loadFromJSON=function(a){var b=a.size;this.cx=b[0];this.cy=b[1];this.cz=b[2];this.arr=a.data};p.setSize=function(b,c,f){0>b&&(b=0);0>c&&(c=0);0>f&&(f=0);if(this.cx!==b||this.cy!==c||this.cz!==f){this.cx=b;this.cy=c;this.cz=f;var e,g,m=this.arr;m.length=b;for(b=0;b<this.cx;b++)for(cr.is_undefined(m[b])&&(m[b]=a()),m[b].length=c,e=0;e<this.cy;e++)for(cr.is_undefined(m[b][e])&&(m[b][e]=a()),m[b][e].length=
f,g=0;g<this.cz;g++)cr.is_undefined(m[b][e][g])&&(m[b][e][g]=0)}};e.prototype.CompareX=function(a,b,c){return cr.do_cmp(this.at(a,0,0),b,c)};e.prototype.CompareXY=function(a,b,c,f){return cr.do_cmp(this.at(a,b,0),c,f)};e.prototype.CompareXYZ=function(a,b,c,f,e){return cr.do_cmp(this.at(a,b,c),f,e)};p.doForEachTrigger=function(a){this.runtime.pushCopySol(a.solModifiers);a.retrigger();this.runtime.popSol(a.solModifiers)};e.prototype.ArrForEach=function(a){var b=this.runtime.getCurrentEventStack().current_event;
this.forZ=this.forY=this.forX=0;switch(a){case 0:for(this.forX=0;this.forX<this.cx;this.forX++)for(this.forY=0;this.forY<this.cy;this.forY++)for(this.forZ=0;this.forZ<this.cz;this.forZ++)this.doForEachTrigger(b);break;case 1:for(this.forX=0;this.forX<this.cx;this.forX++)for(this.forY=0;this.forY<this.cy;this.forY++)this.doForEachTrigger(b);break;case 2:for(this.forX=0;this.forX<this.cx;this.forX++)this.doForEachTrigger(b)}this.forZ=this.forY=this.forX=0;return!1};e.prototype.CompareCurrent=function(a,
b){return cr.do_cmp(this.at(this.forX,this.forY,this.forZ),a,b)};e.prototype.Contains=function(a){var b,c,f;for(b=0;b<this.cx;b++)for(c=0;c<this.cy;c++)for(f=0;f<this.cz;f++)if(this.arr[b][c][f]===a)return!0;return!1};e.prototype.IsEmpty=function(){return 0===this.cx||0===this.cy||0===this.cz};e.prototype.CompareSize=function(a,b,c){var f=0;switch(a){case 0:f=this.cx;break;case 1:f=this.cy;break;case 2:f=this.cz}return cr.do_cmp(f,b,c)};c.cnds=new e;l.prototype.Clear=function(){var a,b,c;for(a=0;a<
this.cx;a++)for(b=0;b<this.cy;b++)for(c=0;c<this.cz;c++)this.arr[a][b][c]=0};l.prototype.SetSize=function(a,b,c){this.setSize(a,b,c)};l.prototype.SetX=function(a,b){this.set(a,0,0,b)};l.prototype.SetXY=function(a,b,c){this.set(a,b,0,c)};l.prototype.SetXYZ=function(a,b,c,f){this.set(a,b,c,f)};l.prototype.Push=function(b,c,f){var e=0,g=0,m=0,p=this.arr;switch(f){case 0:0===b?(e=p.length,p.push(a())):(e=0,p.unshift(a()));for(p[e].length=this.cy;g<this.cy;g++)for(p[e][g]=a(),p[e][g].length=this.cz,m=
0;m<this.cz;m++)p[e][g][m]=c;this.cx++;break;case 1:for(;e<this.cx;e++)for(0===b?(g=p[e].length,p[e].push(a())):(g=0,p[e].unshift(a())),p[e][g].length=this.cz,m=0;m<this.cz;m++)p[e][g][m]=c;this.cy++;break;case 2:for(;e<this.cx;e++)for(g=0;g<this.cy;g++)0===b?p[e][g].push(c):p[e][g].unshift(c);this.cz++}};l.prototype.Pop=function(a,c){var f=0,e=0,g=this.arr;switch(c){case 0:if(0===this.cx)break;0===a?b(g.pop()):b(g.shift());this.cx--;break;case 1:if(0===this.cy)break;for(;f<this.cx;f++)0===a?b(g[f].pop()):
b(g[f].shift());this.cy--;break;case 2:if(0===this.cz)break;for(;f<this.cx;f++)for(e=0;e<this.cy;e++)0===a?g[f][e].pop():g[f][e].shift();this.cz--}};l.prototype.Reverse=function(a){var b=0,c=0,f=this.arr;if(0!==this.cx&&0!==this.cy&&0!==this.cz)switch(a){case 0:f.reverse();break;case 1:for(;b<this.cx;b++)f[b].reverse();break;case 2:for(;b<this.cx;b++)for(c=0;c<this.cy;c++)f[b][c].reverse();this.cz--}};l.prototype.Sort=function(a){var b=0,c=0,f=this.arr;if(0!==this.cx&&0!==this.cy&&0!==this.cz)switch(a){case 0:f.sort(function(a,
b){return g(a[0][0],b[0][0])});break;case 1:for(;b<this.cx;b++)f[b].sort(function(a,b){return g(a[0],b[0])});break;case 2:for(;b<this.cx;b++)for(c=0;c<this.cy;c++)f[b][c].sort(g)}};l.prototype.Delete=function(a,c){var f=0,e=0;a=Math.floor(a);var g=this.arr;if(!(0>a))switch(c){case 0:if(a>=this.cx)break;b(g[a]);g.splice(a,1);this.cx--;break;case 1:if(a>=this.cy)break;for(;f<this.cx;f++)b(g[f][a]),g[f].splice(a,1);this.cy--;break;case 2:if(a>=this.cz)break;for(;f<this.cx;f++)for(e=0;e<this.cy;e++)g[f][e].splice(a,
1);this.cz--}};l.prototype.Insert=function(b,c,f){var e=0,g=0,m=0;c=Math.floor(c);var p=this.arr;if(!(0>c))switch(f){case 0:if(c>this.cx)break;e=c;p.splice(e,0,a());for(p[e].length=this.cy;g<this.cy;g++)for(p[e][g]=a(),p[e][g].length=this.cz,m=0;m<this.cz;m++)p[e][g][m]=b;this.cx++;break;case 1:if(c>this.cy)break;for(;e<this.cx;e++)for(g=c,p[e].splice(g,0,a()),p[e][g].length=this.cz,m=0;m<this.cz;m++)p[e][g][m]=b;this.cy++;break;case 2:if(c>this.cz)break;for(;e<this.cx;e++)for(g=0;g<this.cy;g++)p[e][g].splice(c,
0,b);this.cz++}};l.prototype.JSONLoad=function(a){var b;try{b=JSON.parse(a)}catch(c){return}b.c2array&&(a=b.size,this.cx=a[0],this.cy=a[1],this.cz=a[2],this.arr=b.data)};l.prototype.JSONDownload=function(a){var b=document.createElement("a");if("undefined"===typeof b.download)b="data:text/html,"+encodeURIComponent("<p><a download='"+a+"' href=\"data:application/json,"+encodeURIComponent(this.getAsJSON())+'">Download link</a></p>'),window.open(b);else{var c=document.getElementsByTagName("body")[0];
b.textContent=a;b.href="data:application/json,"+encodeURIComponent(this.getAsJSON());b.download=a;c.appendChild(b);a=document.createEvent("MouseEvent");a.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null);b.dispatchEvent(a);c.removeChild(b)}};c.acts=new l;m.prototype.At=function(a,b,c,f){a.set_any(this.at(b,c||0,f||0))};m.prototype.Width=function(a){a.set_int(this.cx)};m.prototype.Height=function(a){a.set_int(this.cy)};m.prototype.Depth=function(a){a.set_int(this.cz)};m.prototype.CurX=
function(a){a.set_int(this.forX)};m.prototype.CurY=function(a){a.set_int(this.forY)};m.prototype.CurZ=function(a){a.set_int(this.forZ)};m.prototype.CurValue=function(a){a.set_any(this.at(this.forX,this.forY,this.forZ))};m.prototype.Front=function(a){a.set_any(this.at(0,0,0))};m.prototype.Back=function(a){a.set_any(this.at(this.cx-1,0,0))};m.prototype.IndexOf=function(a,b){for(var c=0;c<this.cx;c++)if(this.arr[c][0][0]===b){a.set_int(c);return}a.set_int(-1)};m.prototype.LastIndexOf=function(a,b){for(var c=
this.cx-1;0<=c;c--)if(this.arr[c][0][0]===b){a.set_int(c);return}a.set_int(-1)};m.prototype.AsJSON=function(a){a.set_string(this.getAsJSON())};c.exps=new m})();cr.plugins_.Audio=function(a){this.runtime=a};
(function(){function a(a){a=Math.pow(10,a/20);0>a&&(a=0);1<a&&(a=1);return a}function b(a){0>a&&(a=0);1<a&&(a=1);return 20*(Math.log(a)/Math.log(10))}function e(a){a=a.toLowerCase();return R.hasOwnProperty(a)&&R[a].length?R[a][0].getInputNode():K.destination}function l(){return K.createGain?K.createGain():K.createGainNode()}function g(a){return K.createDelay?K.createDelay(a):K.createDelayNode(a)}function m(a){a.start?a.start(0):a.noteOn(0)}function c(a,b,c){a.start?a.start(0,b):a.noteGrainOn(0,b,
c-b)}function p(a){try{a.stop?a.stop(0):a.noteOff(0)}catch(b){}}function f(a,b,c,d){if(a)if(a.cancelScheduledValues(0),0===d)a.value=b;else{var f=K.currentTime;d+=f;switch(c){case 0:a.setValueAtTime(b,d);break;case 1:a.setValueAtTime(a.value,f);a.linearRampToValueAtTime(b,d);break;case 2:a.setValueAtTime(a.value,f),a.exponentialRampToValueAtTime(b,d)}}}function n(a,b,c,d,f,k){this.type="filter";this.params=[a,b,c,d,f,k];this.inputNode=l();this.wetNode=l();this.wetNode.gain.value=k;this.dryNode=l();
this.dryNode.gain.value=1-k;this.filterNode=K.createBiquadFilter();this.filterNode.type="number"===typeof this.filterNode.type?a:la[a];this.filterNode.frequency.value=b;this.filterNode.detune&&(this.filterNode.detune.value=c);this.filterNode.Q.value=d;this.filterNode.gain.value=f;this.inputNode.connect(this.filterNode);this.inputNode.connect(this.dryNode);this.filterNode.connect(this.wetNode)}function d(a,b,c){this.type="delay";this.params=[a,b,c];this.inputNode=l();this.wetNode=l();this.wetNode.gain.value=
c;this.dryNode=l();this.dryNode.gain.value=1-c;this.mainNode=l();this.delayNode=g(a);this.delayNode.delayTime.value=a;this.delayGainNode=l();this.delayGainNode.gain.value=b;this.inputNode.connect(this.mainNode);this.inputNode.connect(this.dryNode);this.mainNode.connect(this.wetNode);this.mainNode.connect(this.delayNode);this.delayNode.connect(this.delayGainNode);this.delayGainNode.connect(this.mainNode)}function u(a,b,c,d){this.type="convolve";this.params=[b,c,d];this.inputNode=l();this.wetNode=l();
this.wetNode.gain.value=c;this.dryNode=l();this.dryNode.gain.value=1-c;this.convolveNode=K.createConvolver();a&&(this.convolveNode.normalize=b,this.convolveNode.buffer=a);this.inputNode.connect(this.convolveNode);this.inputNode.connect(this.dryNode);this.convolveNode.connect(this.wetNode)}function s(a,b,c,d,f){this.type="flanger";this.params=[a,b,c,d,f];this.inputNode=l();this.dryNode=l();this.dryNode.gain.value=1-f/2;this.wetNode=l();this.wetNode.gain.value=f/2;this.feedbackNode=l();this.feedbackNode.gain.value=
d;this.delayNode=g(a+b);this.delayNode.delayTime.value=a;this.oscNode=K.createOscillator();this.oscNode.frequency.value=c;this.oscGainNode=l();this.oscGainNode.gain.value=b;this.inputNode.connect(this.delayNode);this.inputNode.connect(this.dryNode);this.delayNode.connect(this.wetNode);this.delayNode.connect(this.feedbackNode);this.feedbackNode.connect(this.delayNode);this.oscNode.connect(this.oscGainNode);this.oscGainNode.connect(this.delayNode.delayTime);m(this.oscNode)}function q(a,b,c,d,f,k){this.type=
"phaser";this.params=[a,b,c,d,f,k];this.inputNode=l();this.dryNode=l();this.dryNode.gain.value=1-k/2;this.wetNode=l();this.wetNode.gain.value=k/2;this.filterNode=K.createBiquadFilter();this.filterNode.type="number"===typeof this.filterNode.type?7:"allpass";this.filterNode.frequency.value=a;this.filterNode.detune&&(this.filterNode.detune.value=b);this.filterNode.Q.value=c;this.oscNode=K.createOscillator();this.oscNode.frequency.value=f;this.oscGainNode=l();this.oscGainNode.gain.value=d;this.inputNode.connect(this.filterNode);
this.inputNode.connect(this.dryNode);this.filterNode.connect(this.wetNode);this.oscNode.connect(this.oscGainNode);this.oscGainNode.connect(this.filterNode.frequency);m(this.oscNode)}function t(a){this.type="gain";this.params=[a];this.node=l();this.node.gain.value=a}function w(a,b){this.type="tremolo";this.params=[a,b];this.node=l();this.node.gain.value=1-b/2;this.oscNode=K.createOscillator();this.oscNode.frequency.value=a;this.oscGainNode=l();this.oscGainNode.gain.value=b/2;this.oscNode.connect(this.oscGainNode);
this.oscGainNode.connect(this.node.gain);m(this.oscNode)}function r(a,b){this.type="ringmod";this.params=[a,b];this.inputNode=l();this.wetNode=l();this.wetNode.gain.value=b;this.dryNode=l();this.dryNode.gain.value=1-b;this.ringNode=l();this.ringNode.gain.value=0;this.oscNode=K.createOscillator();this.oscNode.frequency.value=a;this.oscNode.connect(this.ringNode.gain);m(this.oscNode);this.inputNode.connect(this.ringNode);this.inputNode.connect(this.dryNode);this.ringNode.connect(this.wetNode)}function x(a,
b,c,d,f){this.type="distortion";this.params=[a,b,c,d,f];this.inputNode=l();this.preGain=l();this.postGain=l();this.setDrive(c,Math.pow(10,d/20));this.wetNode=l();this.wetNode.gain.value=f;this.dryNode=l();this.dryNode.gain.value=1-f;this.waveShaper=K.createWaveShaper();this.curve=new Float32Array(65536);this.generateColortouchCurve(a,b);this.waveShaper.curve=this.curve;this.inputNode.connect(this.preGain);this.inputNode.connect(this.dryNode);this.preGain.connect(this.waveShaper);this.waveShaper.connect(this.postGain);
this.postGain.connect(this.wetNode)}function z(a,b,c,d,f){this.type="compressor";this.params=[a,b,c,d,f];this.node=K.createDynamicsCompressor();try{this.node.threshold.value=a,this.node.knee.value=b,this.node.ratio.value=c,this.node.attack.value=d,this.node.release.value=f}catch(k){}}function h(a,b){this.type="analyser";this.params=[a,b];this.node=K.createAnalyser();this.node.fftSize=a;this.node.smoothingTimeConstant=b;this.freqBins=new Float32Array(this.node.frequencyBinCount);this.signal=new Uint8Array(a);
this.rms=this.peak=0}function k(){this.obj=null;this.loadUid=0;this.speeds=[];this.moveAngle=this.lastY=this.lastX=0}function y(a,b){this.src=a;this.myapi=N;this.is_music=b;this.added_end_listener=!1;var c=this;this.mediaSourceNode=this.outNode=null;this.panWhenReady=[];this.seekWhenReady=0;this.supportWebAudioAPI=this.pauseWhenReady=!1;N===F&&b&&(this.myapi=J,this.outNode=l());this.audioData=this.bufferObject=null;var d;switch(this.myapi){case J:this.bufferObject=new Audio;N!==F||!K.createMediaElementSource||
I.isFirefox||/wiiu/i.test(navigator.userAgent)||(this.supportWebAudioAPI=!0,this.bufferObject.addEventListener("canplay",function(){c.mediaSourceNode||(c.mediaSourceNode=K.createMediaElementSource(c.bufferObject),c.mediaSourceNode.connect(c.outNode))}));this.bufferObject.autoplay=!1;this.bufferObject.preload="auto";this.bufferObject.src=a;break;case F:d=new XMLHttpRequest;d.open("GET",a,!0);d.responseType="arraybuffer";d.onload=function(){c.audioData=d.response;c.decodeAudioBuffer()};d.send();break;
case P:this.bufferObject=!0;break;case V:this.bufferObject=!0}}function v(a,b){var c=this;this.tag=b;this.stopped=this.fresh=!0;this.src=a.src;this.buffer=a;this.myapi=N;this.is_music=a.is_music;this.playbackRate=1;this.pgended=!0;this.is_paused=this.resume_me=!1;this.resume_position=0;this.is_silent=this.is_muted=this.looping=!1;this.mutevol=this.volume=1;this.startTime=I.kahanTime.sum;this.pannerNode=this.gainNode=null;this.pannerEnabled=!1;this.objectTracker=null;this.panConeOuterGain=this.panConeOuter=
this.panConeInner=this.panAngle=this.panY=this.panX=0;this.instanceObject=null;var d=!1;this.myapi!==F||this.buffer.myapi!==J||this.buffer.supportWebAudioAPI||(this.myapi=J);switch(this.myapi){case J:this.is_music?(this.instanceObject=a.bufferObject,d=!a.added_end_listener,a.added_end_listener=!0):(this.instanceObject=new Audio,this.instanceObject.autoplay=!1,this.instanceObject.src=a.bufferObject.src,d=!0);d&&this.instanceObject.addEventListener("ended",function(){O=c.tag;c.stopped=!0;I.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,
U)});break;case F:this.gainNode=l();this.gainNode.connect(e(b));this.buffer.myapi===F?a.bufferObject&&(this.instanceObject=K.createBufferSource(),this.instanceObject.buffer=a.bufferObject,this.instanceObject.connect(this.gainNode)):(this.instanceObject=this.buffer.bufferObject,this.buffer.outNode.connect(this.gainNode));break;case P:this.instanceObject=new window.Media(M+this.src,null,null,function(a){a===window.Media.MEDIA_STOPPED&&(c.pgended=!0,c.stopped=!0,O=c.tag,I.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,
U))});break;case V:this.instanceObject=!0}}function H(a){S.length=0;if(a.length){var b,c,d;b=0;for(c=Q.length;b<c;b++)d=Q[b],cr.equals_nocase(a,d.tag)&&S.push(d)}else T&&!T.hasEnded()&&(S.length=1,S[0]=T)}function A(a){var b,c,d,f,k=K.destination;if(R.hasOwnProperty(a)&&(d=R[a],d.length))for(k=d[0].getInputNode(),b=0,c=d.length;b<c;b++)f=d[b],b+1===c?f.connectTo(K.destination):f.connectTo(d[b+1].getInputNode());H(a);b=0;for(c=S.length;b<c;b++)S[b].reconnect(k);ca&&ia===a&&(ca.disconnect(),ca.connect(k))}
function E(a,b){R.hasOwnProperty(a)?R[a].push(b):R[a]=[b];A(a)}function B(){}function C(){}function L(){}function D(a,b){var c=null;R.hasOwnProperty(a)&&(c=R[a]);return c&&0<=b&&b<c.length&&c[b].freqBins?c[b]:null}var G=cr.plugins_.Audio.prototype;G.Type=function(a){this.plugin=a;this.runtime=a.runtime};G.Type.prototype.onCreate=function(){};var I=null,U=null,O="",M="",J=0,F=1,P=2,V=3,N=J,K=null,da=[],Q=[],T=null,Y=!1,ha=0,W=!1,X=1,Z=0,aa=0,ja=1,ka=1,ma=10,na=1E4,oa=1,ca=null,ia="",ea=!1,fa=[],R=
{},la="lowpass highpass bandpass lowshelf highshelf peaking notch allpass".split(" ");n.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};n.prototype.remove=function(){this.inputNode.disconnect();this.filterNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};n.prototype.getInputNode=function(){return this.inputNode};n.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=
1);this.params[5]=b;f(this.wetNode.gain,b,c,d);f(this.dryNode.gain,1-b,c,d);break;case 1:this.params[1]=b;f(this.filterNode.frequency,b,c,d);break;case 2:this.params[2]=b;f(this.filterNode.detune,b,c,d);break;case 3:this.params[3]=b;f(this.filterNode.Q,b,c,d);break;case 4:this.params[4]=b,f(this.filterNode.gain,b,c,d)}};d.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};d.prototype.remove=function(){this.inputNode.disconnect();
this.mainNode.disconnect();this.delayNode.disconnect();this.delayGainNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};d.prototype.getInputNode=function(){return this.inputNode};d.prototype.setParam=function(b,c,d,k){switch(b){case 0:c/=100;0>c&&(c=0);1<c&&(c=1);this.params[2]=c;f(this.wetNode.gain,c,d,k);f(this.dryNode.gain,1-c,d,k);break;case 4:this.params[1]=a(c);f(this.delayGainNode.gain,a(c),d,k);break;case 5:this.params[0]=c,f(this.delayNode.delayTime,c,d,k)}};u.prototype.connectTo=
function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};u.prototype.remove=function(){this.inputNode.disconnect();this.convolveNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};u.prototype.getInputNode=function(){return this.inputNode};u.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100,0>b&&(b=0),1<b&&(b=1),this.params[1]=b,f(this.wetNode.gain,b,c,d),f(this.dryNode.gain,1-b,c,d)}};s.prototype.connectTo=function(a){this.dryNode.disconnect();
this.dryNode.connect(a);this.wetNode.disconnect();this.wetNode.connect(a)};s.prototype.remove=function(){this.inputNode.disconnect();this.delayNode.disconnect();this.oscNode.disconnect();this.oscGainNode.disconnect();this.dryNode.disconnect();this.wetNode.disconnect();this.feedbackNode.disconnect()};s.prototype.getInputNode=function(){return this.inputNode};s.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[4]=b;f(this.wetNode.gain,b/2,c,d);f(this.dryNode.gain,
1-b/2,c,d);break;case 6:this.params[1]=b/1E3;f(this.oscGainNode.gain,b/1E3,c,d);break;case 7:this.params[2]=b;f(this.oscNode.frequency,b,c,d);break;case 8:this.params[3]=b/100,f(this.feedbackNode.gain,b/100,c,d)}};q.prototype.connectTo=function(a){this.dryNode.disconnect();this.dryNode.connect(a);this.wetNode.disconnect();this.wetNode.connect(a)};q.prototype.remove=function(){this.inputNode.disconnect();this.filterNode.disconnect();this.oscNode.disconnect();this.oscGainNode.disconnect();this.dryNode.disconnect();
this.wetNode.disconnect()};q.prototype.getInputNode=function(){return this.inputNode};q.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[5]=b;f(this.wetNode.gain,b/2,c,d);f(this.dryNode.gain,1-b/2,c,d);break;case 1:this.params[0]=b;f(this.filterNode.frequency,b,c,d);break;case 2:this.params[1]=b;f(this.filterNode.detune,b,c,d);break;case 3:this.params[2]=b;f(this.filterNode.Q,b,c,d);break;case 6:this.params[3]=b;f(this.oscGainNode.gain,b,c,d);break;case 7:this.params[4]=
b,f(this.oscNode.frequency,b,c,d)}};t.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};t.prototype.remove=function(){this.node.disconnect()};t.prototype.getInputNode=function(){return this.node};t.prototype.setParam=function(b,c,d,k){switch(b){case 4:this.params[0]=a(c),f(this.node.gain,a(c),d,k)}};w.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};w.prototype.remove=function(){this.oscNode.disconnect();this.oscGainNode.disconnect();this.node.disconnect()};
w.prototype.getInputNode=function(){return this.node};w.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[1]=b;f(this.node.gain.value,1-b/2,c,d);f(this.oscGainNode.gain.value,b/2,c,d);break;case 7:this.params[0]=b,f(this.oscNode.frequency,b,c,d)}};r.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};r.prototype.remove=function(){this.oscNode.disconnect();this.ringNode.disconnect();
this.inputNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};r.prototype.getInputNode=function(){return this.inputNode};r.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[1]=b;f(this.wetNode.gain,b,c,d);f(this.dryNode.gain,1-b,c,d);break;case 7:this.params[0]=b,f(this.oscNode.frequency,b,c,d)}};x.prototype.setDrive=function(a,b){0.01>a&&(a=0.01);this.preGain.gain.value=a;this.postGain.gain.value=Math.pow(1/a,0.6)*b};x.prototype.shape=
function(a,b,c){var d=1.05*c*b-b;c=0>a?-1:1;a=0>a?-a:a;b=a<b?a:b+d*(1-Math.exp(-(1/d)*(a-b)));return b*c};x.prototype.generateColortouchCurve=function(a,b){for(var c=Math.pow(10,a/20),d=Math.pow(10,b/20),f=0,k=0;32768>k;++k)f=k/32768,f=this.shape(f,c,d),this.curve[32768+k]=f,this.curve[32768-k-1]=-f};x.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};x.prototype.remove=function(){this.inputNode.disconnect();this.preGain.disconnect();
this.waveShaper.disconnect();this.postGain.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};x.prototype.getInputNode=function(){return this.inputNode};x.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100,0>b&&(b=0),1<b&&(b=1),this.params[4]=b,f(this.wetNode.gain,b,c,d),f(this.dryNode.gain,1-b,c,d)}};z.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};z.prototype.remove=function(){this.node.disconnect()};z.prototype.getInputNode=function(){return this.node};
z.prototype.setParam=function(a,b,c,d){};h.prototype.tick=function(){this.node.getFloatFrequencyData(this.freqBins);this.node.getByteTimeDomainData(this.signal);for(var a=this.node.fftSize,c=0,d=this.peak=0,f=0;c<a;c++)f=(this.signal[c]-128)/128,0>f&&(f=-f),this.peak<f&&(this.peak=f),d+=f*f;this.peak=b(this.peak);this.rms=b(Math.sqrt(d/a))};h.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};h.prototype.remove=function(){this.node.disconnect()};h.prototype.getInputNode=
function(){return this.node};h.prototype.setParam=function(a,b,c,d){};k.prototype.setObject=function(a){if(this.obj=a)this.lastX=this.obj.x,this.lastY=this.obj.y;this.speeds.length=0};k.prototype.hasObject=function(){return!!this.obj};k.prototype.tick=function(a){this.obj&&0!==a&&(this.moveAngle=cr.angleTo(this.lastX,this.lastY,this.obj.x,this.obj.y),a=cr.distanceTo(this.lastX,this.lastY,this.obj.x,this.obj.y)/a,4>this.speeds.length||this.speeds.shift(),this.speeds.push(a),this.lastX=this.obj.x,this.lastY=
this.obj.y)};k.prototype.getSpeed=function(){if(!this.speeds.length)return 0;var a,b,c=0;a=0;for(b=this.speeds.length;a<b;a++)c+=this.speeds[a];return c/this.speeds.length};k.prototype.getVelocityX=function(){return Math.cos(this.moveAngle)*this.getSpeed()};k.prototype.getVelocityY=function(){return Math.sin(this.moveAngle)*this.getSpeed()};var pa=!1;y.prototype.decodeAudioBuffer=function(){if(!this.bufferObject&&this.audioData){var a=this;if(K.decodeAudioData)K.decodeAudioData(this.audioData,function(b){a.bufferObject=
b;var c,d,f;if(cr.is_undefined(a.playTagWhenReady)||W)cr.is_undefined(a.convolveWhenReady)||(c=a.convolveWhenReady.convolveNode,c.normalize=a.normalizeWhenReady,c.buffer=b);else if(a.panWhenReady.length){c=0;for(d=a.panWhenReady.length;c<d;c++){b=a.panWhenReady[c];f=new v(a,b.thistag);f.setPannerEnabled(!0);if("undefined"!==typeof b.objUid&&(b.obj=I.getObjectByUID(b.objUid),!b.obj))continue;if(b.obj){var k=cr.rotatePtAround(b.obj.x,b.obj.y,-b.obj.layer.getAngle(),Z,aa,!0),e=cr.rotatePtAround(b.obj.x,
b.obj.y,-b.obj.layer.getAngle(),Z,aa,!1);f.setPan(k,e,cr.to_degrees(b.obj.angle-b.obj.layer.getAngle()),b.ia,b.oa,b.og);f.setObject(b.obj)}else f.setPan(b.x,b.y,b.a,b.ia,b.oa,b.og);f.play(a.loopWhenReady,a.volumeWhenReady,a.seekWhenReady);a.pauseWhenReady&&f.pause();Q.push(f)}a.panWhenReady.length=0}else f=new v(a,a.playTagWhenReady),f.play(a.loopWhenReady,a.volumeWhenReady,a.seekWhenReady),a.pauseWhenReady&&f.pause(),Q.push(f)});else if(this.bufferObject=K.createBuffer(this.audioData,!1),cr.is_undefined(this.playTagWhenReady)||
W)cr.is_undefined(this.convolveWhenReady)||(b=this.convolveWhenReady.convolveNode,b.normalize=this.normalizeWhenReady,b.buffer=this.bufferObject);else{var b=new v(this,this.playTagWhenReady);b.play(this.loopWhenReady,this.volumeWhenReady,this.seekWhenReady);this.pauseWhenReady&&b.pause();Q.push(b)}}};y.prototype.isLoaded=function(){switch(this.myapi){case J:return 4===this.bufferObject.readyState;case F:return!!this.audioData;case P:return!0;case V:return!0}return!1};v.prototype.hasEnded=function(){switch(this.myapi){case J:return this.instanceObject.ended;
case F:return this.buffer.myapi===F?!this.fresh&&!this.stopped&&this.instanceObject.loop||this.is_paused?!1:I.kahanTime.sum-this.startTime>this.buffer.bufferObject.duration:this.instanceObject.ended;case P:return this.pgended;case V:!0}return!0};v.prototype.canBeRecycled=function(){return this.fresh||this.stopped?!0:this.hasEnded()};v.prototype.setPannerEnabled=function(a){N===F&&(!this.pannerEnabled&&a?this.gainNode&&(this.pannerNode||(this.pannerNode=K.createPanner(),this.pannerNode.panningModel=
"number"===typeof this.pannerNode.panningModel?ja:["equalpower","HRTF","soundfield"][ja],this.pannerNode.distanceModel="number"===typeof this.pannerNode.distanceModel?ka:["linear","inverse","exponential"][ka],this.pannerNode.refDistance=ma,this.pannerNode.maxDistance=na,this.pannerNode.rolloffFactor=oa),this.gainNode.disconnect(),this.gainNode.connect(this.pannerNode),this.pannerNode.connect(e(this.tag)),this.pannerEnabled=!0):this.pannerEnabled&&!a&&this.gainNode&&(this.pannerNode.disconnect(),this.gainNode.disconnect(),
this.gainNode.connect(e(this.tag)),this.pannerEnabled=!1))};v.prototype.setPan=function(a,b,c,d,f,k){this.pannerEnabled&&N===F&&(this.pannerNode.setPosition(a,b,0),this.pannerNode.setOrientation(Math.cos(cr.to_radians(c)),Math.sin(cr.to_radians(c)),0),this.pannerNode.coneInnerAngle=d,this.pannerNode.coneOuterAngle=f,this.pannerNode.coneOuterGain=k,this.panX=a,this.panY=b,this.panAngle=c,this.panConeInner=d,this.panConeOuter=f,this.panConeOuterGain=k)};v.prototype.setObject=function(a){this.pannerEnabled&&
N===F&&(this.objectTracker||(this.objectTracker=new k),this.objectTracker.setObject(a))};v.prototype.tick=function(a){if(this.pannerEnabled&&N===F&&this.objectTracker&&this.objectTracker.hasObject()&&this.isPlaying()){this.objectTracker.tick(a);a=this.objectTracker.obj;var b=cr.rotatePtAround(a.x,a.y,-a.layer.getAngle(),Z,aa,!0),c=cr.rotatePtAround(a.x,a.y,-a.layer.getAngle(),Z,aa,!1);this.pannerNode.setPosition(b,c,0);b=0;"undefined"!==typeof this.objectTracker.obj.angle&&(b=a.angle-a.layer.getAngle(),
this.pannerNode.setOrientation(Math.cos(b),Math.sin(b),0));b=cr.rotatePtAround(this.objectTracker.getVelocityX(),this.objectTracker.getVelocityY(),-a.layer.getAngle(),0,0,!0);c=cr.rotatePtAround(this.objectTracker.getVelocityX(),this.objectTracker.getVelocityY(),-a.layer.getAngle(),0,0,!1);this.pannerNode.setVelocity(b,c,0)}};v.prototype.play=function(a,b,d){var f=this.instanceObject;this.looping=a;this.volume=b;d=d||0;switch(this.myapi){case J:1!==f.playbackRate&&(f.playbackRate=1);f.volume!==b*
X&&(f.volume=b*X);f.loop!==a&&(f.loop=a);f.muted&&(f.muted=!1);if(f.currentTime!==d)try{f.currentTime=d}catch(k){}if(this.is_music&&ea&&!I.isInUserInputEvent)fa.push(this);else try{this.instanceObject.play()}catch(e){}break;case F:this.muted=!1;this.mutevol=1;if(this.buffer.myapi===F)this.fresh||(this.instanceObject=K.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode)),this.instanceObject.loop=a,this.gainNode.gain.value=b*X,0===d?m(this.instanceObject):
c(this.instanceObject,d,this.getDuration());else{1!==f.playbackRate&&(f.playbackRate=1);f.loop!==a&&(f.loop=a);this.gainNode.gain.value=b*X;if(f.currentTime!==d)try{f.currentTime=d}catch(h){}this.is_music&&ea&&!I.isInUserInputEvent?fa.push(this):f.play()}break;case P:(!this.fresh&&this.stopped||0!==d)&&f.seekTo(d);f.play();this.pgended=!1;break;case V:I.isDirectCanvas?AppMobi.context.playSound(this.src,a):AppMobi.player.playSound(this.src,a)}this.playbackRate=1;this.startTime=I.kahanTime.sum-d;this.is_paused=
this.stopped=this.fresh=!1};v.prototype.stop=function(){switch(this.myapi){case J:this.instanceObject.paused||this.instanceObject.pause();break;case F:this.buffer.myapi===F?p(this.instanceObject):this.instanceObject.paused||this.instanceObject.pause();break;case P:this.instanceObject.stop();break;case V:I.isDirectCanvas&&AppMobi.context.stopSound(this.src)}this.stopped=!0;this.is_paused=!1};v.prototype.pause=function(){if(!(this.fresh||this.stopped||this.hasEnded()||this.is_paused)){switch(this.myapi){case J:this.instanceObject.paused||
this.instanceObject.pause();break;case F:this.buffer.myapi===F?(this.resume_position=this.getPlaybackTime(),this.looping&&(this.resume_position%=this.getDuration()),p(this.instanceObject)):this.instanceObject.paused||this.instanceObject.pause();break;case P:this.instanceObject.pause();break;case V:I.isDirectCanvas&&AppMobi.context.stopSound(this.src)}this.is_paused=!0}};v.prototype.resume=function(){if(!this.fresh&&!this.stopped&&!this.hasEnded()&&this.is_paused){switch(this.myapi){case J:this.instanceObject.play();
break;case F:this.buffer.myapi===F?(this.instanceObject=K.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode),this.instanceObject.loop=this.looping,this.gainNode.gain.value=X*this.volume*this.mutevol,this.startTime=I.kahanTime.sum-this.resume_position,c(this.instanceObject,this.resume_position,this.getDuration())):this.instanceObject.play();break;case P:this.instanceObject.play();break;case V:I.isDirectCanvas&&AppMobi.context.resumeSound(this.src)}this.is_paused=
!1}};v.prototype.seek=function(a){if(!(this.fresh||this.stopped||this.hasEnded()))switch(this.myapi){case J:try{this.instanceObject.currentTime=a}catch(b){}break;case F:if(this.buffer.myapi===F)this.is_paused?this.resume_position=a:(this.pause(),this.resume_position=a,this.resume());else try{this.instanceObject.currentTime=a}catch(c){}break;case V:I.isDirectCanvas&&AppMobi.context.seekSound(this.src,a)}};v.prototype.reconnect=function(a){this.myapi===F&&(this.pannerEnabled?(this.pannerNode.disconnect(),
this.pannerNode.connect(a)):(this.gainNode.disconnect(),this.gainNode.connect(a)))};v.prototype.getDuration=function(){switch(this.myapi){case J:if("undefined"!==typeof this.instanceObject.duration)return this.instanceObject.duration;break;case F:return this.buffer.bufferObject.duration;case P:return this.instanceObject.getDuration();case V:if(I.isDirectCanvas)return AppMobi.context.getDurationSound(this.src)}return 0};v.prototype.getPlaybackTime=function(){var a=this.getDuration(),b=0;switch(this.myapi){case J:"undefined"!==
typeof this.instanceObject.currentTime&&(b=this.instanceObject.currentTime);break;case F:if(this.buffer.myapi===F){if(this.is_paused)return this.resume_position;b=I.kahanTime.sum-this.startTime}else"undefined"!==typeof this.instanceObject.currentTime&&(b=this.instanceObject.currentTime);break;case V:I.isDirectCanvas&&(b=AppMobi.context.getPlaybackTimeSound(this.src))}!this.looping&&b>a&&(b=a);return b};v.prototype.isPlaying=function(){return!this.is_paused&&!this.fresh&&!this.stopped&&!this.hasEnded()};
v.prototype.setVolume=function(a){this.volume=a;this.updateVolume()};v.prototype.updateVolume=function(){var a=this.volume*X;switch(this.myapi){case J:this.instanceObject.volume&&this.instanceObject.volume!==a&&(this.instanceObject.volume=a);break;case F:this.gainNode.gain.value=a*this.mutevol}};v.prototype.getVolume=function(){return this.volume};v.prototype.doSetMuted=function(a){switch(this.myapi){case J:this.instanceObject.muted!==!!a&&(this.instanceObject.muted=!!a);break;case F:this.mutevol=
a?0:1,this.gainNode.gain.value=X*this.volume*this.mutevol}};v.prototype.setMuted=function(a){this.is_muted=!!a;this.doSetMuted(this.is_muted||this.is_silent)};v.prototype.setSilent=function(a){this.is_silent=!!a;this.doSetMuted(this.is_muted||this.is_silent)};v.prototype.setLooping=function(a){this.looping=a;switch(this.myapi){case J:this.instanceObject.loop!==!!a&&(this.instanceObject.loop=!!a);break;case F:this.instanceObject.loop!==!!a&&(this.instanceObject.loop=!!a);break;case V:I.isDirectCanvas&&
AppMobi.context.setLoopingSound(this.src,a)}};v.prototype.setPlaybackRate=function(a){this.playbackRate=a;this.updatePlaybackRate()};v.prototype.updatePlaybackRate=function(){var a=this.playbackRate;if(1===ha&&!this.is_music||2===ha)a*=I.timescale;switch(this.myapi){case J:this.instanceObject.playbackRate!==a&&(this.instanceObject.playbackRate=a);break;case F:this.buffer.myapi===F?this.instanceObject.playbackRate.value!==a&&(this.instanceObject.playbackRate.value=a):this.instanceObject.playbackRate!==
a&&(this.instanceObject.playbackRate=a)}};v.prototype.setSuspended=function(a){switch(this.myapi){case J:a?this.isPlaying()?(this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&this.instanceObject.play();break;case F:a?this.isPlaying()?(this.buffer.myapi===F?(this.resume_position=this.getPlaybackTime(),this.looping&&(this.resume_position%=this.getDuration()),p(this.instanceObject)):this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&(this.buffer.myapi===
F?(this.instanceObject=K.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode),this.instanceObject.loop=this.looping,this.gainNode.gain.value=X*this.volume*this.mutevol,this.startTime=I.kahanTime.sum-this.resume_position,c(this.instanceObject,this.resume_position,this.getDuration())):this.instanceObject.play());break;case P:a?this.isPlaying()?(this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&this.instanceObject.play()}};
G.Instance=function(a){this.type=a;I=this.runtime=a.runtime;U=this;this.listenerTracker=null;this.listenerZ=-600;!(this.runtime.isiOS||this.runtime.isAndroid&&(this.runtime.isChrome||this.runtime.isAndroidStockBrowser))||this.runtime.isCrosswalk||this.runtime.isDomFree||(ea=!0);K=null;"undefined"!==typeof AudioContext?(N=F,K=new AudioContext):"undefined"!==typeof webkitAudioContext&&(N=F,K=new webkitAudioContext);(this.runtime.isiOS&&N===F||ea)&&document.addEventListener("touchstart",function(){var a,
b,c;!pa&&K&&(a=K.createBuffer(1,1,22050),b=K.createBufferSource(),b.buffer=a,b.connect(K.destination),m(b),pa=!0);if(ea){if(!W)for(a=0,b=fa.length;a<b;++a)c=fa[a],c.stopped||c.is_paused||c.instanceObject.play();fa.length=0}},!0);N!==F&&(this.runtime.isPhoneGap?N=P:this.runtime.isAppMobi&&(N=V));N===P&&(M=location.href,a=M.lastIndexOf("/"),-1<a&&(M=M.substr(0,a+1)),M=M.replace("file://",""));if(this.runtime.isSafari&&this.runtime.isWindows&&"undefined"===typeof Audio)alert("It looks like you're using Safari for Windows without Quicktime.  Audio cannot be played until Quicktime is installed."),
this.runtime.DestroyInstance(this);else{if(this.runtime.isDirectCanvas)Y=this.runtime.isAndroid;else try{Y=!!(new Audio).canPlayType('audio/ogg; codecs="vorbis"')}catch(b){Y=!1}this.runtime.tickMe(this)}};var ba=G.Instance.prototype;ba.onCreate=function(){ha=this.properties[0];this.saveload=this.properties[1];ja=this.properties[2];ka=this.properties[3];this.listenerZ=-this.properties[4];ma=this.properties[5];na=this.properties[6];oa=this.properties[7];this.listenerTracker=new k;N===F&&(K.listener.speedOfSound=
this.properties[8],K.listener.dopplerFactor=this.properties[9],K.listener.setPosition(this.runtime.draw_width/2,this.runtime.draw_height/2,this.listenerZ),K.listener.setOrientation(0,0,1,0,-1,0),window.c2OnAudioMicStream=function(a,b){ca&&ca.disconnect();ia=b.toLowerCase();ca=K.createMediaStreamSource(a);ca.connect(e(ia))});this.runtime.addSuspendCallback(function(a){U.onSuspend(a)});var a=this;this.runtime.addDestroyCallback(function(b){a.onInstanceDestroyed(b)})};ba.onInstanceDestroyed=function(a){var b,
c,d;b=0;for(c=Q.length;b<c;b++)d=Q[b],d.objectTracker&&d.objectTracker.obj===a&&(d.objectTracker.obj=null,d.pannerEnabled&&d.isPlaying()&&d.looping&&d.stop());this.listenerTracker.obj===a&&(this.listenerTracker.obj=null)};ba.saveToJSON=function(){var a={silent:W,masterVolume:X,listenerZ:this.listenerZ,listenerUid:this.listenerTracker.hasObject()?this.listenerTracker.obj.uid:-1,playing:[],effects:{}},b=a.playing,c,d,f,k,e,h;c=0;for(d=Q.length;c<d;c++)f=Q[c],!f.isPlaying()||3===this.saveload||f.is_music&&
1===this.saveload||!f.is_music&&2===this.saveload||(k=f.getPlaybackTime(),f.looping&&(k%=f.getDuration()),k={tag:f.tag,buffersrc:f.buffer.src,is_music:f.is_music,playbackTime:k,volume:f.volume,looping:f.looping,muted:f.is_muted,playbackRate:f.playbackRate,paused:f.is_paused,resume_position:f.resume_position},f.pannerEnabled&&(k.pan={},h=k.pan,f.objectTracker&&f.objectTracker.hasObject()?h.objUid=f.objectTracker.obj.uid:(h.x=f.panX,h.y=f.panY,h.a=f.panAngle),h.ia=f.panConeInner,h.oa=f.panConeOuter,
h.og=f.panConeOuterGain),b.push(k));b=a.effects;for(e in R)if(R.hasOwnProperty(e)){f=[];c=0;for(d=R[e].length;c<d;c++)f.push({type:R[e][c].type,params:R[e][c].params});b[e]=f}return a};var ga=[];ba.loadFromJSON=function(a){var b=a.silent;X=a.masterVolume;this.listenerZ=a.listenerZ;this.listenerTracker.setObject(null);var c=a.listenerUid;-1!==c&&(this.listenerTracker.loadUid=c,ga.push(this.listenerTracker));var c=a.playing,f,e,g,m,p,l,C,L,y,v,D;if(3!==this.saveload)for(f=0,e=Q.length;f<e;f++)y=Q[f],
y.is_music&&1===this.saveload||(y.is_music||2!==this.saveload)&&y.stop();for(p in R)if(R.hasOwnProperty(p))for(f=0,e=R[p].length;f<e;f++)R[p][f].remove();cr.wipe(R);for(p in a.effects)if(a.effects.hasOwnProperty(p))for(l=a.effects[p],f=0,e=l.length;f<e;f++)switch(g=l[f].type,v=l[f].params,g){case "filter":E(p,new n(v[0],v[1],v[2],v[3],v[4],v[5]));break;case "delay":E(p,new d(v[0],v[1],v[2]));break;case "convolve":g=v[2];y=this.getAudioBuffer(g,!1);y.bufferObject?g=new u(y.bufferObject,v[0],v[1],g):
(g=new u(null,v[0],v[1],g),y.normalizeWhenReady=v[0],y.convolveWhenReady=g);E(p,g);break;case "flanger":E(p,new s(v[0],v[1],v[2],v[3],v[4]));break;case "phaser":E(p,new q(v[0],v[1],v[2],v[3],v[4],v[5]));break;case "gain":E(p,new t(v[0]));break;case "tremolo":E(p,new w(v[0],v[1]));break;case "ringmod":E(p,new r(v[0],v[1]));break;case "distortion":E(p,new x(v[0],v[1],v[2],v[3],v[4]));break;case "compressor":E(p,new z(v[0],v[1],v[2],v[3],v[4]));break;case "analyser":E(p,new h(v[0],v[1]))}f=0;for(e=c.length;f<
e;f++)3===this.saveload||(a=c[f],g=a.buffersrc,m=a.is_music,p=a.tag,l=a.playbackTime,C=a.looping,L=a.volume,D=(v=a.pan)&&v.hasOwnProperty("objUid")?v.objUid:-1,m&&1===this.saveload)||!m&&2===this.saveload||((y=this.getAudioInstance(g,p,m,C,L))?(y.resume_position=a.resume_position,y.setPannerEnabled(!!v),y.play(C,L,l),y.updatePlaybackRate(),y.updateVolume(),y.doSetMuted(y.is_muted||y.is_silent),a.paused&&y.pause(),a.muted&&y.setMuted(!0),y.doSetMuted(y.is_muted||y.is_silent),v&&(-1!==D?(y.objectTracker=
y.objectTracker||new k,y.objectTracker.loadUid=D,ga.push(y.objectTracker)):y.setPan(v.x,v.y,v.a,v.ia,v.oa,v.og))):(y=this.getAudioBuffer(g,m),y.seekWhenReady=l,y.pauseWhenReady=a.paused,v&&(-1!==D?y.panWhenReady.push({objUid:D,ia:v.ia,oa:v.oa,og:v.og,thistag:p}):y.panWhenReady.push({x:v.x,y:v.y,a:v.a,ia:v.ia,oa:v.oa,og:v.og,thistag:p}))));if(b&&!W){f=0;for(e=Q.length;f<e;f++)Q[f].setSilent(!0);W=!0}else if(!b&&W){f=0;for(e=Q.length;f<e;f++)Q[f].setSilent(!1);W=!1}};ba.afterLoad=function(){var a,b,
c,d;a=0;for(b=ga.length;a<b;a++)c=ga[a],d=this.runtime.getObjectByUID(c.loadUid),c.setObject(d),c.loadUid=-1,d&&(Z=d.x,aa=d.y);ga.length=0};ba.onSuspend=function(a){var b,c;b=0;for(c=Q.length;b<c;b++)Q[b].setSuspended(a)};ba.tick=function(){var a=this.runtime.dt,b,c,d;b=0;for(c=Q.length;b<c;b++)d=Q[b],d.tick(a),d.myapi===J||d.myapi===V||d.fresh||d.stopped||!d.hasEnded()||(d.stopped=!0,O=d.tag,I.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,U)),0!==ha&&d.updatePlaybackRate();var f,k;for(f in R)if(R.hasOwnProperty(f))for(d=
R[f],b=0,c=d.length;b<c;b++)k=d[b],k.tick&&k.tick();N===F&&this.listenerTracker.hasObject()&&(this.listenerTracker.tick(a),Z=this.listenerTracker.obj.x,aa=this.listenerTracker.obj.y,K.listener.setPosition(this.listenerTracker.obj.x,this.listenerTracker.obj.y,this.listenerZ),K.listener.setVelocity(this.listenerTracker.getVelocityX(),this.listenerTracker.getVelocityY(),0))};ba.getAudioBuffer=function(a,b){var c,d,f,k=null;c=0;for(d=da.length;c<d;c++)if(f=da[c],f.src===a){k=f;break}k||(k=new y(a,b),
da.push(k));return k};ba.getAudioInstance=function(a,b,c,d,f){var k,e,h;k=0;for(e=Q.length;k<e;k++)if(h=Q[k],h.src===a&&(h.canBeRecycled()||c))return h.tag=b,h;a=this.getAudioBuffer(a,c);if(!a.bufferObject)return"<preload>"!==b&&(a.playTagWhenReady=b,a.loopWhenReady=d,a.volumeWhenReady=f),null;h=new v(a,b);Q.push(h);return h};var S=[];B.prototype.OnEnded=function(a){return cr.equals_nocase(O,a)};B.prototype.PreloadsComplete=function(){var a,b;a=0;for(b=da.length;a<b;a++)if(!da[a].isLoaded())return!1;
return!0};B.prototype.AdvancedAudioSupported=function(){return N===F};B.prototype.IsSilent=function(){return W};B.prototype.IsAnyPlaying=function(){var a,b;a=0;for(b=Q.length;a<b;a++)if(Q[a].isPlaying())return!0;return!1};B.prototype.IsTagPlaying=function(a){H(a);var b;a=0;for(b=S.length;a<b;a++)if(S[a].isPlaying())return!0;return!1};G.cnds=new B;C.prototype.Play=function(b,c,d,f){!W&&(d=a(d),T=this.getAudioInstance(this.runtime.files_subfolder+b[0]+(Y?".ogg":".m4a"),f,b[1],0!==c,d))&&(T.setPannerEnabled(!1),
T.play(0!==c,d))};C.prototype.PlayAtPosition=function(b,c,d,f,k,e,h,g,m,n){if(!W){d=a(d);var q=b[1];b=this.runtime.files_subfolder+b[0]+(Y?".ogg":".m4a");(T=this.getAudioInstance(b,n,q,0!==c,d))?(T.setPannerEnabled(!0),T.setPan(f,k,e,h,g,a(m)),T.play(0!==c,d)):this.getAudioBuffer(b,q).panWhenReady.push({x:f,y:k,a:e,ia:h,oa:g,og:a(m),thistag:n})}};C.prototype.PlayAtObject=function(b,c,d,f,k,e,h,g){if(!W&&f&&(f=f.getFirstPicked())){d=a(d);var m=b[1];b=this.runtime.files_subfolder+b[0]+(Y?".ogg":".m4a");
(T=this.getAudioInstance(b,g,m,0!==c,d))?(T.setPannerEnabled(!0),g=cr.rotatePtAround(f.x,f.y,-f.layer.getAngle(),Z,aa,!0),b=cr.rotatePtAround(f.x,f.y,-f.layer.getAngle(),Z,aa,!1),T.setPan(g,b,cr.to_degrees(f.angle-f.layer.getAngle()),k,e,a(h)),T.setObject(f),T.play(0!==c,d)):this.getAudioBuffer(b,m).panWhenReady.push({obj:f,ia:k,oa:e,og:a(h),thistag:g})}};C.prototype.PlayByName=function(b,c,d,f,k){!W&&(f=a(f),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(Y?".ogg":".m4a"),T=this.getAudioInstance(c,
k,b,0!==d,f))&&(T.setPannerEnabled(!1),T.play(0!==d,f))};C.prototype.PlayAtPositionByName=function(b,c,d,f,k,e,h,g,m,n,q){W||(f=a(f),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(Y?".ogg":".m4a"),(T=this.getAudioInstance(c,q,b,0!==d,f))?(T.setPannerEnabled(!0),T.setPan(k,e,h,g,m,a(n)),T.play(0!==d,f)):this.getAudioBuffer(c,b).panWhenReady.push({x:k,y:e,a:h,ia:g,oa:m,og:a(n),thistag:q}))};C.prototype.PlayAtObjectByName=function(b,c,d,f,k,e,h,g,m){!W&&k&&(k=k.getFirstPicked())&&(f=a(f),b=
1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(Y?".ogg":".m4a"),(T=this.getAudioInstance(c,m,b,0!==d,f))?(T.setPannerEnabled(!0),m=cr.rotatePtAround(k.x,k.y,-k.layer.getAngle(),Z,aa,!0),c=cr.rotatePtAround(k.x,k.y,-k.layer.getAngle(),Z,aa,!1),T.setPan(m,c,cr.to_degrees(k.angle-k.layer.getAngle()),e,h,a(g)),T.setObject(k),T.play(0!==d,f)):this.getAudioBuffer(c,b).panWhenReady.push({obj:k,ia:e,oa:h,og:a(g),thistag:m}))};C.prototype.SetLooping=function(a,b){H(a);var c,d;c=0;for(d=S.length;c<d;c++)S[c].setLooping(0===
b)};C.prototype.SetMuted=function(a,b){H(a);var c,d;c=0;for(d=S.length;c<d;c++)S[c].setMuted(0===b)};C.prototype.SetVolume=function(b,c){H(b);var d=a(c),f,k;f=0;for(k=S.length;f<k;f++)S[f].setVolume(d)};C.prototype.Preload=function(a){if(!W){var b=a[1];a=this.runtime.files_subfolder+a[0]+(Y?".ogg":".m4a");N===V?this.runtime.isDirectCanvas?AppMobi.context.loadSound(a):AppMobi.player.loadSound(a):N!==P&&this.getAudioInstance(a,"<preload>",b,!1)}};C.prototype.PreloadByName=function(a,b){if(!W){var c=
1===a,d=this.runtime.files_subfolder+b.toLowerCase()+(Y?".ogg":".m4a");N===V?this.runtime.isDirectCanvas?AppMobi.context.loadSound(d):AppMobi.player.loadSound(d):N!==P&&this.getAudioInstance(d,"<preload>",c,!1)}};C.prototype.SetPlaybackRate=function(a,b){H(a);0>b&&(b=0);var c,d;c=0;for(d=S.length;c<d;c++)S[c].setPlaybackRate(b)};C.prototype.Stop=function(a){H(a);var b;a=0;for(b=S.length;a<b;a++)S[a].stop()};C.prototype.StopAll=function(){var a,b;a=0;for(b=Q.length;a<b;a++)Q[a].stop()};C.prototype.SetPaused=
function(a,b){H(a);var c,d;c=0;for(d=S.length;c<d;c++)0===b?S[c].pause():S[c].resume()};C.prototype.Seek=function(a,b){H(a);var c,d;c=0;for(d=S.length;c<d;c++)S[c].seek(b)};C.prototype.SetSilent=function(a){var b;2===a&&(a=W?1:0);if(0===a&&!W){a=0;for(b=Q.length;a<b;a++)Q[a].setSilent(!0);W=!0}else if(1===a&&W){a=0;for(b=Q.length;a<b;a++)Q[a].setSilent(!1);W=!1}};C.prototype.SetMasterVolume=function(b){X=a(b);var c;b=0;for(c=Q.length;b<c;b++)Q[b].updateVolume()};C.prototype.AddFilterEffect=function(a,
b,c,d,f,k,e){N!==F||0>b||b>=la.length||!K.createBiquadFilter||(a=a.toLowerCase(),e/=100,0>e&&(e=0),1<e&&(e=1),E(a,new n(b,c,d,f,k,e)))};C.prototype.AddDelayEffect=function(b,c,f,k){N===F&&(b=b.toLowerCase(),k/=100,0>k&&(k=0),1<k&&(k=1),E(b,new d(c,a(f),k)))};C.prototype.AddFlangerEffect=function(a,b,c,d,f,k){N===F&&K.createOscillator&&(a=a.toLowerCase(),k/=100,0>k&&(k=0),1<k&&(k=1),E(a,new s(b/1E3,c/1E3,d,f/100,k)))};C.prototype.AddPhaserEffect=function(a,b,c,d,f,k,e){N===F&&K.createOscillator&&(a=
a.toLowerCase(),e/=100,0>e&&(e=0),1<e&&(e=1),E(a,new q(b,c,d,f,k,e)))};C.prototype.AddConvolutionEffect=function(a,b,c,d){if(N===F&&K.createConvolver){c=0===c;var f=this.runtime.files_subfolder+b[0]+(Y?".ogg":".m4a");b=this.getAudioBuffer(f,!1);a=a.toLowerCase();d/=100;0>d&&(d=0);1<d&&(d=1);b.bufferObject?d=new u(b.bufferObject,c,d,f):(d=new u(null,c,d,f),b.normalizeWhenReady=c,b.convolveWhenReady=d);E(a,d)}};C.prototype.AddGainEffect=function(b,c){N===F&&(b=b.toLowerCase(),E(b,new t(a(c))))};C.prototype.AddMuteEffect=
function(a){N===F&&(a=a.toLowerCase(),E(a,new t(0)))};C.prototype.AddTremoloEffect=function(a,b,c){N===F&&K.createOscillator&&(a=a.toLowerCase(),c/=100,0>c&&(c=0),1<c&&(c=1),E(a,new w(b,c)))};C.prototype.AddRingModEffect=function(a,b,c){N===F&&K.createOscillator&&(a=a.toLowerCase(),c/=100,0>c&&(c=0),1<c&&(c=1),E(a,new r(b,c)))};C.prototype.AddDistortionEffect=function(a,b,c,d,f,k){N===F&&K.createWaveShaper&&(a=a.toLowerCase(),k/=100,0>k&&(k=0),1<k&&(k=1),E(a,new x(b,c,d,f,k)))};C.prototype.AddCompressorEffect=
function(a,b,c,d,f,k){N===F&&K.createDynamicsCompressor&&(a=a.toLowerCase(),E(a,new z(b,c,d,f/1E3,k/1E3)))};C.prototype.AddAnalyserEffect=function(a,b,c){N===F&&(a=a.toLowerCase(),E(a,new h(b,c)))};C.prototype.RemoveEffects=function(a){if(N===F){a=a.toLowerCase();var b,c,d;if(R.hasOwnProperty(a)&&(d=R[a],d.length)){b=0;for(c=d.length;b<c;b++)d[b].remove();d.length=0;A(a)}}};C.prototype.SetEffectParameter=function(a,b,c,d,f,k){N===F&&(a=a.toLowerCase(),b=Math.floor(b),R.hasOwnProperty(a)&&(a=R[a],
0>b||b>=a.length||a[b].setParam(c,d,f,k)))};C.prototype.SetListenerObject=function(a){a&&N===F&&(a=a.getFirstPicked())&&(this.listenerTracker.setObject(a),Z=a.x,aa=a.y)};C.prototype.SetListenerZ=function(a){this.listenerZ=a};G.acts=new C;L.prototype.Duration=function(a,b){H(b);S.length?a.set_float(S[0].getDuration()):a.set_float(0)};L.prototype.PlaybackTime=function(a,b){H(b);S.length?a.set_float(S[0].getPlaybackTime()):a.set_float(0)};L.prototype.Volume=function(a,c){H(c);if(S.length){var d=S[0].getVolume();
a.set_float(b(d))}else a.set_float(0)};L.prototype.MasterVolume=function(a){a.set_float(X)};L.prototype.EffectCount=function(a,b){b=b.toLowerCase();var c=null;R.hasOwnProperty(b)&&(c=R[b]);a.set_int(c?c.length:0)};L.prototype.AnalyserFreqBinCount=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);b=D(b,c);a.set_int(b?b.node.frequencyBinCount:0)};L.prototype.AnalyserFreqBinAt=function(a,b,c,d){b=b.toLowerCase();c=Math.floor(c);d=Math.floor(d);(b=D(b,c))?0>d||d>=b.node.frequencyBinCount?a.set_float(0):
a.set_float(b.freqBins[d]):a.set_float(0)};L.prototype.AnalyserPeakLevel=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);(b=D(b,c))?a.set_float(b.peak):a.set_float(0)};L.prototype.AnalyserRMSLevel=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);(b=D(b,c))?a.set_float(b.rms):a.set_float(0)};G.exps=new L})();cr.plugins_.Browser=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(){"undefined"!==typeof jQuery&&c.setSize(jQuery(window).width(),jQuery(window).height())}function l(){}var g=cr.plugins_.Browser.prototype;g.Type=function(a){this.plugin=a;this.runtime=a.runtime};g.Type.prototype.onCreate=function(){};g.Instance=function(a){this.type=a;this.runtime=a.runtime};g.Instance.prototype.onCreate=function(){var a=this;window.addEventListener("resize",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnResize,
a)});"undefined"!==typeof navigator.onLine&&(window.addEventListener("online",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOnline,a)}),window.addEventListener("offline",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOffline,a)}));"undefined"!==typeof window.applicationCache&&(window.applicationCache.addEventListener("updateready",function(){a.runtime.loadingprogress=1;a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady,a)}),window.applicationCache.addEventListener("progress",
function(b){a.runtime.loadingprogress=b.loaded/b.total}));this.runtime.isDirectCanvas||(document.addEventListener("appMobi.device.update.available",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady,a)}),document.addEventListener("backbutton",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,a)}),document.addEventListener("menubutton",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton,a)}),document.addEventListener("searchbutton",
function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnSearchButton,a)}),document.addEventListener("tizenhwkey",function(b){var c;switch(b.keyName){case "back":c=a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,a);!c&&window.tizen&&window.tizen.application.getCurrentApplication().exit();break;case "menu":(c=a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton,a))||b.preventDefault()}}));this.runtime.isWindowsPhone81&&(WinJS.Application.onbackclick=function(b){return!!a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,
a)});this.runtime.addSuspendCallback(function(b){b?a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageHidden,a):a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageVisible,a)});this.is_arcade="undefined"!==typeof window.is_scirra_arcade};a.prototype.CookiesEnabled=function(){return navigator?navigator.cookieEnabled:!1};a.prototype.IsOnline=function(){return navigator?navigator.onLine:!1};a.prototype.HasJava=function(){return navigator?navigator.javaEnabled():!1};a.prototype.OnOnline=
function(){return!0};a.prototype.OnOffline=function(){return!0};a.prototype.IsDownloadingUpdate=function(){return"undefined"===typeof window.applicationCache?!1:window.applicationCache.status===window.applicationCache.DOWNLOADING};a.prototype.OnUpdateReady=function(){return!0};a.prototype.PageVisible=function(){return!this.runtime.isSuspended};a.prototype.OnPageVisible=function(){return!0};a.prototype.OnPageHidden=function(){return!0};a.prototype.OnResize=function(){return!0};a.prototype.IsFullscreen=
function(){return!!(document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||this.runtime.isNodeFullscreen)};a.prototype.OnBackButton=function(){return!0};a.prototype.OnMenuButton=function(){return!0};a.prototype.OnSearchButton=function(){return!0};a.prototype.IsMetered=function(){var a=navigator.connection||navigator.mozConnection||navigator.webkitConnection;return a?a.metered:!1};a.prototype.IsCharging=function(){var a=navigator.battery||navigator.mozBattery||navigator.webkitBattery;
return a?a.charging:!0};a.prototype.IsPortraitLandscape=function(a){return(window.innerWidth<=window.innerHeight?0:1)===a};g.cnds=new a;b.prototype.Alert=function(a){this.runtime.isDomFree||alert(a.toString())};b.prototype.Close=function(){this.runtime.isCocoonJs?CocoonJS.App.forceToFinish():window.tizen?window.tizen.application.getCurrentApplication().exit():navigator.app&&navigator.app.exitApp?navigator.app.exitApp():navigator.device&&navigator.device.exitApp?navigator.device.exitApp():this.is_arcade||
this.runtime.isDomFree||window.close()};b.prototype.Focus=function(){this.runtime.isNodeWebkit?window.nwgui.Window.get().focus():this.is_arcade||this.runtime.isDomFree||window.focus()};b.prototype.Blur=function(){this.runtime.isNodeWebkit?window.nwgui.Window.get().blur():this.is_arcade||this.runtime.isDomFree||window.blur()};b.prototype.GoBack=function(){navigator.app&&navigator.app.backHistory?navigator.app.backHistory():this.is_arcade||this.runtime.isDomFree||!window.back||window.back()};b.prototype.GoForward=
function(){this.is_arcade||this.runtime.isDomFree||!window.forward||window.forward()};b.prototype.GoHome=function(){this.is_arcade||this.runtime.isDomFree||!window.home||window.home()};b.prototype.GoToURL=function(a){this.runtime.isCocoonJs?CocoonJS.App.openURL(a):this.runtime.isEjecta?ejecta.openURL(a):this.runtime.isWinJS?Windows.System.Launcher.launchUriAsync(new Windows.Foundation.Uri(a)):this.is_arcade||this.runtime.isDomFree||(window.location=a)};b.prototype.GoToURLWindow=function(a,b){this.runtime.isCocoonJs?
CocoonJS.App.openURL(a):this.runtime.isEjecta?ejecta.openURL(a):this.runtime.isWinJS?Windows.System.Launcher.launchUriAsync(new Windows.Foundation.Uri(a)):this.is_arcade||this.runtime.isDomFree||window.open(a,b)};b.prototype.Reload=function(){this.is_arcade||this.runtime.isDomFree||window.location.reload()};var m=!0,c=null;b.prototype.RequestFullScreen=function(a){this.runtime.isDomFree?cr.logexport("[Construct 2] Requesting fullscreen is not supported on this platform - the request has been ignored"):
(2<=a&&(a+=1),6===a&&(a=2),this.runtime.isNodeWebkit?this.runtime.isNodeFullscreen||(window.nwgui.Window.get().enterFullscreen(),this.runtime.isNodeFullscreen=!0,this.runtime.fullscreen_scaling=2<=a?a:0):document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||document.fullScreen||(this.runtime.fullscreen_scaling=2<=a?a:0,a=this.runtime.canvasdiv||this.runtime.canvas,m&&(m=!1,c=this.runtime,a.addEventListener("mozfullscreenerror",e),a.addEventListener("webkitfullscreenerror",
e),a.addEventListener("msfullscreenerror",e),a.addEventListener("fullscreenerror",e)),cr.is_undefined(a.requestFullscreen)?cr.is_undefined(a.webkitRequestFullScreen)?cr.is_undefined(a.mozRequestFullScreen)?cr.is_undefined(a.msRequestFullscreen)||a.msRequestFullscreen():a.mozRequestFullScreen():"undefined"!==typeof Element&&"undefined"!==typeof Element.ALLOW_KEYBOARD_INPUT?a.webkitRequestFullScreen(Element.ALLOW_KEYBOARD_INPUT):a.webkitRequestFullScreen():a.requestFullscreen()))};b.prototype.CancelFullScreen=
function(){this.runtime.isDomFree?cr.logexport("[Construct 2] Exiting fullscreen is not supported on this platform - the request has been ignored"):this.runtime.isNodeWebkit?this.runtime.isNodeFullscreen&&(window.nwgui.Window.get().leaveFullscreen(),this.runtime.isNodeFullscreen=!1):cr.is_undefined(document.exitFullscreen)?cr.is_undefined(document.webkitCancelFullScreen)?cr.is_undefined(document.mozCancelFullScreen)?cr.is_undefined(document.msExitFullscreen)||document.msExitFullscreen():document.mozCancelFullScreen():
document.webkitCancelFullScreen():document.exitFullscreen()};b.prototype.Vibrate=function(a){try{var b=a.split(","),c,e;c=0;for(e=b.length;c<e;c++)b[c]=parseInt(b[c],10);navigator.vibrate?navigator.vibrate(b):navigator.mozVibrate?navigator.mozVibrate(b):navigator.webkitVibrate?navigator.webkitVibrate(b):navigator.msVibrate&&navigator.msVibrate(b)}catch(g){}};b.prototype.InvokeDownload=function(a,b){var c=document.createElement("a");if("undefined"===typeof c.download)window.open(a);else{var e=document.getElementsByTagName("body")[0];
c.textContent=b;c.href=a;c.download=b;e.appendChild(c);var g=document.createEvent("MouseEvent");g.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null);c.dispatchEvent(g);e.removeChild(c)}};b.prototype.InvokeDownloadString=function(a,b,c){var e="data:"+b+","+encodeURIComponent(a);a=document.createElement("a");"undefined"===typeof a.download?window.open(e):(b=document.getElementsByTagName("body")[0],a.textContent=c,a.href=e,a.download=c,b.appendChild(a),c=document.createEvent("MouseEvent"),
c.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null),a.dispatchEvent(c),b.removeChild(a))};b.prototype.ConsoleLog=function(a,b){"undefined"!==typeof console&&(0===a&&console.log&&console.log(b.toString()),1===a&&console.warn&&console.warn(b.toString()),2===a&&console.error&&console.error(b.toString()))};b.prototype.ConsoleGroup=function(a){console&&console.group&&console.group(a)};b.prototype.ConsoleGroupEnd=function(){console&&console.groupEnd&&console.groupEnd()};b.prototype.ExecJs=
function(a){eval&&eval(a)};var p="portrait landscape portrait-primary portrait-secondary landscape-primary landscape-secondary".split(" ");b.prototype.LockOrientation=function(a){a=Math.floor(a);0>a||a>=p.length||(this.runtime.autoLockOrientation=!1,a=p[a],screen.lockOrientation?screen.lockOrientation(a):screen.webkitLockOrientation?screen.webkitLockOrientation(a):screen.mozLockOrientation?screen.mozLockOrientation(a):screen.msLockOrientation&&screen.msLockOrientation(a))};b.prototype.UnlockOrientation=
function(){this.runtime.autoLockOrientation=!1;screen.unlockOrientation?screen.unlockOrientation():screen.webkitUnlockOrientation?screen.webkitUnlockOrientation():screen.mozUnlockOrientation?screen.mozUnlockOrientation():screen.msUnlockOrientation&&screen.msUnlockOrientation()};g.acts=new b;l.prototype.URL=function(a){a.set_string(this.runtime.isDomFree?"":window.location.toString())};l.prototype.Protocol=function(a){a.set_string(this.runtime.isDomFree?"":window.location.protocol)};l.prototype.Domain=
function(a){a.set_string(this.runtime.isDomFree?"":window.location.hostname)};l.prototype.PathName=function(a){a.set_string(this.runtime.isDomFree?"":window.location.pathname)};l.prototype.Hash=function(a){a.set_string(this.runtime.isDomFree?"":window.location.hash)};l.prototype.Referrer=function(a){a.set_string(this.runtime.isDomFree?"":document.referrer)};l.prototype.Title=function(a){a.set_string(this.runtime.isDomFree?"":document.title)};l.prototype.Name=function(a){a.set_string(this.runtime.isDomFree?
"":navigator.appName)};l.prototype.Version=function(a){a.set_string(this.runtime.isDomFree?"":navigator.appVersion)};l.prototype.Language=function(a){navigator&&navigator.language?a.set_string(navigator.language):a.set_string("")};l.prototype.Platform=function(a){a.set_string(this.runtime.isDomFree?"":navigator.platform)};l.prototype.Product=function(a){navigator&&navigator.product?a.set_string(navigator.product):a.set_string("")};l.prototype.Vendor=function(a){navigator&&navigator.vendor?a.set_string(navigator.vendor):
a.set_string("")};l.prototype.UserAgent=function(a){a.set_string(this.runtime.isDomFree?"":navigator.userAgent)};l.prototype.QueryString=function(a){a.set_string(this.runtime.isDomFree?"":window.location.search)};l.prototype.QueryParam=function(a,b){if(this.runtime.isDomFree)a.set_string("");else{var c=RegExp("[?&]"+b+"=([^&]*)").exec(window.location.search);c?a.set_string(decodeURIComponent(c[1].replace(/\+/g," "))):a.set_string("")}};l.prototype.Bandwidth=function(a){var b=navigator.connection||
navigator.mozConnection||navigator.webkitConnection;b?a.set_float(b.bandwidth):a.set_float(Number.POSITIVE_INFINITY)};l.prototype.BatteryLevel=function(a){var b=navigator.battery||navigator.mozBattery||navigator.webkitBattery;b?a.set_float(b.level):a.set_float(1)};l.prototype.BatteryTimeLeft=function(a){var b=navigator.battery||navigator.mozBattery||navigator.webkitBattery;b?a.set_float(b.dischargingTime):a.set_float(Number.POSITIVE_INFINITY)};l.prototype.ExecJS=function(a,b){if(eval){var c=eval(b);
"number"===typeof c?a.set_any(c):"string"===typeof c?a.set_any(c):"boolean"===typeof c?a.set_any(c?1:0):a.set_any(0)}else a.set_any(0)};l.prototype.ScreenWidth=function(a){a.set_int(screen.width)};l.prototype.ScreenHeight=function(a){a.set_int(screen.height)};l.prototype.DevicePixelRatio=function(a){a.set_float(this.runtime.devicePixelRatio)};g.exps=new l})();cr.plugins_.CJSAds=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(a,b){a?h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceLoginSuccess,h):(console.log(b),h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenLeaderBoardClosed,h))}function l(a){a?(console.log(a),h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitScoreFailed,h)):h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitScoreSuccess,h)}function g(a,b){b?(console.log(b),h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceRequestScoreFailed,
h)):(t=a.score||0,h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceRequestScoreSuccess,h))}function m(a){a&&console.log(a);h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenLeaderBoardClosed,h)}function c(a){a&&console.log(a);h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenAchievementsClosed,h)}function p(a){if(a){try{console.log(JSON.stringify(a))}catch(b){for(var c in a)console.log(a[c]);console.log(b)}h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceResetAchievementsFailed,
h)}else h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceResetAchievementsCompleted,h)}function f(a){if(a){try{console.log(JSON.stringify(a))}catch(b){for(var c in a)console.log(a[c]);console.log(b)}h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitAchievementFailed,h)}else h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitAchievementCompleted,h)}function n(){}var d="",u="",s="",q=[],t=0,w=0,r=!1,x=!1,z=cr.plugins_.CJSAds.prototype;z.Type=
function(a){this.plugin=a;this.runtime=a.runtime};z.Type.prototype.onCreate=function(){};z.Instance=function(a){this.type=a;this.runtime=a.runtime};var h;z.Instance.prototype.onCreate=function(){this.isShowingFullscreen=this.isShowingBanner=!1;this.triggerProduct="";this.socialService=null;this.socialServiceAvailable=!1;this.socialServiceSelected=this.properties[2];this.storeServiceAvailable=this.runtime.isCocoonJs&&"undefined"!==typeof CocoonJS.Store.nativeExtensionObjectAvailable;this.storeManaged=
1!==this.properties[1];this.storeSandboxed=0!==this.properties[3];this.socialServiceClientID=this.properties[4];this.onPurchaseCompleteInfo=this.onConsumePurchaseCompleted=this.onConsumePurchaseFailedTransactionId="";h=this;h.runtime.isCocoonJs&&(CocoonJS.App.onTextDialogFinished.addEventListener(function(a){d=a;h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardOK,h)}),CocoonJS.App.onTextDialogCancelled.addEventListener(function(){h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardCancelled,
h)}),CocoonJS.Ad.onBannerShown.addEventListener(function(){h.isShowingBanner=!0;h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnBannerShown,h)}),CocoonJS.Ad.onBannerReady.addEventListener(function(){r=!0;h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onBannerReady,h)}),CocoonJS.Ad.onBannerHidden.addEventListener(function(){h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onBannerHidden,h)}),CocoonJS.Ad.onFullScreenShown.addEventListener(function(){h.isShowingFullscreen=!0;h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenShown,
h)}),CocoonJS.Ad.onFullScreenHidden.addEventListener(function(){h.isShowingFullscreen=!1;h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenHidden,h)}),CocoonJS.Ad.onFullScreenReady.addEventListener(function(){x=!0;h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onFullScreenReady,h)}),h.storeServiceAvailable&&(CocoonJS.Store.onConsumePurchaseFailed.addEventListener(function(a,b){h.onConsumePurchaseFailedTransactionId=a;h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseFailed,
h)}),CocoonJS.Store.onConsumePurchaseStarted.addEventListener(function(){h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseStarted,h)}),CocoonJS.Store.onConsumePurchaseCompleted.addEventListener(function(a){h.onConsumePurchaseCompleted=a;h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseCompleted,h)}),CocoonJS.Store.onProductPurchaseCompleted.addEventListener(function(a){console.log("onProductPurchaseCompleted "+a.productId);h.triggerProduct=a.productId;u=a.transactionId;
s=a.productId;CocoonJS.Store.addPurchase(a);CocoonJS.Store.finishPurchase(a.transactionId);h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,h)}),CocoonJS.Store.onProductPurchaseFailed.addEventListener(function(a,b){console.log("onProductPurchaseFailed "+a);h.triggerProduct=a;console.log(b);h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,h)}),CocoonJS.Store.onProductPurchaseStarted.addEventListener(function(a){console.log("onProductPurchaseStarted "+a);h.triggerProduct=
a;h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseStart,h)}),CocoonJS.Store.onProductsFetchStarted.addEventListener(function(){h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchStarted,h)}),CocoonJS.Store.onProductsFetchFailed.addEventListener(function(){h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchFailed,h)}),CocoonJS.Store.onProductsFetchCompleted.addEventListener(function(a){for(var b=a.length-1;0<=b;b--)console.log("Product fetched: "+a[b].productId),
CocoonJS.Store.addProduct(a[b]);h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchCompleted,h)}),CocoonJS.Store.onRestorePurchasesStarted.addEventListener(function(){console.log("onRestorePurchasesStarted ");h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onRestorePurchasesStarted,h)}),CocoonJS.Store.onRestorePurchasesCompleted.addEventListener(function(){console.log("onRestorePurchasesCompleted ");h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onRestorePurchasesCompleted,
h)}),CocoonJS.Store.onRestorePurchasesFailed.addEventListener(function(){console.log("onRestorePurchasesFailed ");h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onRestorePurchasesFailed,h)}),CocoonJS.Store.requestInitialization({managed:h.storeManaged,sandbox:h.storeSandboxed}),CocoonJS.Store.start()),0!==this.socialServiceSelected&&(this.startGameCenter=function(){console.log("GameCenter selected as social service");if(this.socialService=CocoonJS.Social.GameCenter)this.socialService.nativeExtensionObjectAvailable&&
(this.socialServiceInterface=this.socialService.getSocialInterface());else throw Error("Cannot find GameCenter service, are you using the latest CocoonJS Extensions?");},this.startGooglePlay=function(){console.log("GooglePlayGames selected as social service");if(this.socialService=CocoonJS.Social.GooglePlayGames){var a={};this.socialServiceClientID&&(a.clientId=this.socialServiceClientID);this.socialService.init(a);this.socialService.nativeExtensionObjectAvailable&&(this.socialServiceInterface=this.socialService.getSocialInterface())}else throw Error("Cannot find GooglePlayGames service, are you using the latest CocoonJS Extensions?");
},2===this.socialServiceSelected&&this.startGameCenter.apply(this,[]),3===this.socialServiceSelected&&this.startGooglePlay.apply(this,[]),1===this.socialServiceSelected&&(CocoonJS.Social.GooglePlayGames.nativeExtensionObjectAvailable?this.startGooglePlay.apply(this,[]):CocoonJS.Social.GameCenter.nativeExtensionObjectAvailable&&this.startGameCenter.apply(this,[]))))};a.prototype.IsShowingBanner=function(){return this.isShowingBanner};a.prototype.IsCocoonJS=function(){return this.runtime.isCocoonJs};
a.prototype.OnBannerShown=function(){return!0};a.prototype.OnFullscreenShown=function(){return!0};a.prototype.OnFullscreenHidden=function(){return!0};a.prototype.onFullScreenReady=function(){return!0};a.prototype.onBannerReady=function(){return!0};a.prototype.onBannerHidden=function(){return!0};a.prototype.IsShowingFullscreen=function(){return this.isShowingFullscreen};a.prototype.PreloadFullscreen=function(){return!0};a.prototype.IsStoreAvailable=function(){return this.runtime.isCocoonJs?this.storeServiceAvailable&&
CocoonJS.Store.canPurchase():!1};a.prototype.OnPurchaseStart=function(a){console.log("OnPurchaseStart");return this.triggerProduct===a};a.prototype.OnPurchaseComplete=function(a){console.log("OnPurchaseComplete");return this.triggerProduct===a};a.prototype.OnPurchaseFail=function(a){console.log("OnPurchaseFail");return this.triggerProduct===a};a.prototype.onProductsFetchStarted=function(){return!0};a.prototype.onConsumePurchaseFailed=function(){return!0};a.prototype.onConsumePurchaseCompleted=function(){return!0};
a.prototype.onConsumePurchaseStarted=function(){return!0};a.prototype.onProductsFetchCompleted=function(){return!0};a.prototype.onProductsFetchFailed=function(){return!0};a.prototype.IsProductPurchased=function(a){return this.runtime.isCocoonJs?CocoonJS.Store.isProductPurchased(a):!1};a.prototype.OnKeyboardCancelled=function(){return!0};a.prototype.OnKeyboardOK=function(){return!0};a.prototype.onSocialServiceLoginSuccess=function(){return!0};a.prototype.onSocialServiceLoginFailed=function(){return!0};
a.prototype.onSocialServiceSubmitScoreSuccess=function(){return!0};a.prototype.onSocialServiceSubmitScoreFailed=function(){return!0};a.prototype.onSocialServiceRequestScoreSuccess=function(){return!0};a.prototype.onSocialServiceRequestScoreFailed=function(){return!0};a.prototype.onSocialServiceOpenLeaderBoardSuccess=function(){return!0};a.prototype.onSocialServiceOpenLeaderBoardClosed=function(){return!0};a.prototype.onSocialServiceOpenAchievementsSuccess=function(){return!0};a.prototype.onSocialServiceOpenAchievementsClosed=
function(){return!0};a.prototype.onSocialServiceResetAchievementsCompleted=function(){return!0};a.prototype.onSocialServiceResetAchievementsFailed=function(){return!0};a.prototype.onSocialServiceSubmitAchievementCompleted=function(){return!0};a.prototype.onSocialServiceSubmitAchievementFailed=function(){return!0};a.prototype.onRestorePurchasesStarted=function(){return!0};a.prototype.onRestorePurchasesCompleted=function(){return!0};a.prototype.onRestorePurchasesFailed=function(){return!0};z.cnds=new a;
b.prototype.ShowBanner=function(a){this.runtime.isCocoonJs&&(w=0===a?CocoonJS.Ad.BannerLayout.TOP_CENTER:CocoonJS.Ad.BannerLayout.BOTTOM_CENTER,r?(CocoonJS.Ad.setBannerLayout(w),CocoonJS.Ad.showBanner()):CocoonJS.Ad.preloadBanner())};b.prototype.ShowFullscreen=function(){this.runtime.isCocoonJs&&(x?CocoonJS.Ad.showFullScreen():CocoonJS.Ad.preloadFullScreen())};b.prototype.HideBanner=function(){this.runtime.isCocoonJs&&(CocoonJS.Ad.hideBanner(),this.isShowingBanner=!1)};b.prototype.PreloadBanner=function(){this.runtime.isCocoonJs&&
CocoonJS.Ad.preloadBanner()};b.prototype.PreloadFullscreen=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.preloadFullScreen()};b.prototype.RefreshBanner=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.refreshBanner()};b.prototype.RefreshFullScreen=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.refreshFullScreen()};b.prototype.Purchase=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.purchaseProduct(a)};b.prototype.ConsumePurchase=function(a,b){this.runtime.isCocoonJs&&CocoonJS.Store.consumePurchase(a,
b)};b.prototype.fetchProductsFromStore=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.fetchProductsFromStore(a.split(","))};b.prototype.PurchasePreview=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.purchaseProductModalWithPreview(a)};b.prototype.RestorePurchases=function(){this.runtime.isCocoonJs&&CocoonJS.Store.restorePurchases()};b.prototype.PromptKeyboard=function(a,b,c,d,f,e){this.runtime.isCocoonJs&&CocoonJS.App.showTextDialog(a,b,c,["text","num","phone","email","url"][d],f,e)};b.prototype.UpdateProductsList=
function(){this.runtime.isCocoonJs&&CocoonJS.Store.canPurchase()&&(q=CocoonJS.Store.getProducts())};b.prototype.socialServiceRequestLogin=function(){this.socialServiceInterface&&(this.socialServiceInterface.isLoggedIn()?h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceLoginSuccess,h):this.socialServiceInterface.login(e))};b.prototype.socialServiceRequestLogout=function(){this.socialServiceInterface&&this.socialServiceInterface.isLoggedIn()&&this.socialServiceInterface.logout(e)};
b.prototype.socialServiceSubmitScore=function(a,b){this.socialServiceInterface&&this.socialServiceInterface.isLoggedIn()&&this.socialServiceInterface.submitScore(a,l,{leaderboardID:b})};b.prototype.socialServiceRequestScore=function(a){this.socialServiceInterface&&this.socialServiceInterface.isLoggedIn()&&this.socialServiceInterface.requestScore(g,{leaderboardID:a})};b.prototype.socialServiceOpenLeaderboard=function(a){this.socialServiceInterface&&this.socialServiceInterface.isLoggedIn()&&(h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenLeaderBoardSuccess,
h),this.socialServiceInterface.showLeaderboard(m,{leaderboardID:a}))};b.prototype.socialServiceOpenAchievements=function(){this.socialServiceInterface&&this.socialServiceInterface.isLoggedIn()&&(h.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenAchievementsSuccess,h),this.socialServiceInterface.showAchievements(c))};b.prototype.socialServiceResetAchievements=function(){this.socialServiceInterface&&this.socialServiceInterface.isLoggedIn()&&this.socialServiceInterface.resetAchievements(p)};
b.prototype.socialServiceSubmitAchievement=function(a){this.socialServiceInterface&&this.socialServiceInterface.isLoggedIn()&&this.socialServiceInterface.submitAchievement(a,f)};z.acts=new b;n.prototype.InputText=function(a){a.set_string(d)};n.prototype.PurchaseTransactionId=function(a){a.set_string(u)};n.prototype.PurchaseProductId=function(a){a.set_string(s)};n.prototype.ProductCount=function(a){a.set_int(q.length)};n.prototype.ProductDescription=function(a,b){b=Math.floor(b);0>b||b>=q.length?a.set_string(""):
a.set_string(q[b].description)};n.prototype.ProductLocalizedPrice=function(a,b){b=Math.floor(b);0>b||b>=q.length?a.set_string(""):a.set_string(q[b].localizedPrice)};n.prototype.ProductPrice=function(a,b){b=Math.floor(b);0>b||b>=q.length?a.set_string(""):a.set_string(q[b].price)};n.prototype.ProductAlias=function(a,b){b=Math.floor(b);0>b||b>=q.length?a.set_string(""):a.set_string(q[b].productAlias)};n.prototype.ProductID=function(a,b){b=Math.floor(b);0>b||b>=q.length?a.set_string(""):a.set_string(q[b].productId)};
n.prototype.ProductTitle=function(a,b){b=Math.floor(b);0>b||b>=q.length?a.set_string(""):a.set_string(q[b].title)};n.prototype.PlayerScore=function(a){a.set_float(t)};z.exps=new n})();cr.plugins_.CocoonJSAppForCocoonJS=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(){}function l(a,b,c){return c===b.length-1?a[b[c]]:l(a[b[c]],b,c+1)}function g(a,b){if(!a)return null;if(!b)return a;var c=b.split(".");return l(a,c,0)}function m(a,b){if("number"===typeof b)return a.set_any(b);if("boolean"===typeof b)return a.set_any(+b);if("string"===typeof b)return a.set_any(b.toString());a.set_any(JSON.stringify(b))}var c=cr.plugins_.CocoonJSAppForCocoonJS.prototype;c.Type=function(a){this.plugin=a;this.runtime=a.runtime};c.Type.prototype.onCreate=
function(){};c.Instance=function(a){this.type=a;this.runtime=a.runtime;this.lastEvent=null;this.data={};this.dialogs={};this.lastClosedDialog=null};c.Instance.prototype.onCreate=function(){var a=this,b=a.runtime;CocoonJS.App.onLoadInTheWebViewSucceed.addEventListener(function(e){CocoonJS.App.forward("notifyCocoonJSEventListeners = "+function(a,b){var c="CocoonJS['App']['onWebViewEvent']['notifyEventListeners']("+JSON.stringify(a)+", "+JSON.stringify(b)+");";CocoonJS&&CocoonJS.App&&CocoonJS.App.forward(c)}.toString()+
";");b.trigger(c.cnds.OnLoadInTheWebViewSucceed,a)});CocoonJS.App.onLoadInTheWebViewFailed.addEventListener(function(){b.trigger(c.cnds.OnLoadInTheWebViewFailed,a)});CocoonJS.App.onWebViewEvent=CocoonJS.App.onWebViewEvent?CocoonJS.App.onWebViewEvent:new CocoonJS.EventHandler("IDTK_APP","App","onwebviewevent");CocoonJS.App.onWebViewEvent.addEventListener(function(e,d){1===arguments.length&&Array.isArray(e)&&(d=e[1],e=e[0]);a.lastEvent=e;try{a.lastEvent=JSON.parse(e)}catch(g){}a.data[a.lastEvent]=d;
try{a.data[a.lastEvent]=JSON.parse(d)}catch(m){}console.log("Receive onWebViewEvent event",a.lastEvent,"data",a.data[a.lastEvent]);b.trigger(c.cnds.OnEvent,a);b.trigger(c.cnds.OnAnyEvent,a)})};a.prototype.OnEvent=function(a){if(a===this.lastEvent)return!0};a.prototype.OnAnyEvent=function(){if(null!==this.lastEvent)return!0};a.prototype.OnLoadInTheWebViewFailed=function(){return!0};a.prototype.OnLoadInTheWebViewSucceed=function(){return!0};a.prototype.OnWebDialogClosed=function(a){if(a===this.lastClosedDialog&&
!this.dialogs[a])return!0};c.cnds=new a;b.prototype.LoadInTheWebView=function(a){CocoonJS.App.loadInTheWebView(a)};b.prototype.Forward=function(a){CocoonJS.App.forward(a)};b.prototype.HideTheWebView=function(){CocoonJS.App.hideTheWebView()};b.prototype.ShowTheWebView=function(){CocoonJS.App.showTheWebView()};b.prototype.CreateWebDialog=function(a,b){var e=this,d=e.runtime,g=this.dialogs[a];g?console.warn("Web dialog '"+a+"' already created, close it first or create dialog with different name"):(g=
this.dialogs[a]=new CocoonJS.App.WebDialog,g.show(b,function(){console.log("dialog",a,"closed");delete e.dialogs[a];e.lastClosedDialog=a;d.trigger(c.cnds.OnWebDialogClosed,e)}),g.iframe&&(g.iframe.style.border=0))};b.prototype.WDEval=function(a,b){var c=this.dialogs[a];c?c.eval(b):console.warn("Web dialog "+a+" not found")};c.acts=new b;e.prototype.GetEventData=function(a,b,c){b=this.data[b];console.log("GetEventData - event data",c,b);if(void 0===b)return m(a,b);c=g(b,c);m(a,c)};e.prototype.GetLastEventData=
function(a,b){var c=this.data[this.lastEvent];console.log("GetLastEventData - event data",b,c);if(void 0===c)return m(a,c);c=g(c,b);m(a,c)};c.exps=new e})();cr.plugins_.Dictionary=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(){}var l=cr.plugins_.Dictionary.prototype;l.Type=function(a){this.plugin=a;this.runtime=a.runtime};l.Type.prototype.onCreate=function(){};l.Instance=function(a){this.type=a;this.runtime=a.runtime};var g=l.Instance.prototype;g.onCreate=function(){this.dictionary={};this.cur_key="";this.key_count=0};g.saveToJSON=function(){return this.dictionary};g.loadFromJSON=function(a){this.dictionary=a;this.key_count=0;for(var b in this.dictionary)this.dictionary.hasOwnProperty(b)&&
this.key_count++};a.prototype.CompareValue=function(a,b,e){return cr.do_cmp(this.dictionary[a],b,e)};a.prototype.ForEachKey=function(){var a=this.runtime.getCurrentEventStack().current_event,b;for(b in this.dictionary)this.dictionary.hasOwnProperty(b)&&(this.cur_key=b,this.runtime.pushCopySol(a.solModifiers),a.retrigger(),this.runtime.popSol(a.solModifiers));this.cur_key="";return!1};a.prototype.CompareCurrentValue=function(a,b){return cr.do_cmp(this.dictionary[this.cur_key],a,b)};a.prototype.HasKey=
function(a){return this.dictionary.hasOwnProperty(a)};a.prototype.IsEmpty=function(){return 0===this.key_count};l.cnds=new a;b.prototype.AddKey=function(a,b){this.dictionary.hasOwnProperty(a)||this.key_count++;this.dictionary[a]=b};b.prototype.SetKey=function(a,b){this.dictionary.hasOwnProperty(a)&&(this.dictionary[a]=b)};b.prototype.DeleteKey=function(a){this.dictionary.hasOwnProperty(a)&&(delete this.dictionary[a],this.key_count--)};b.prototype.Clear=function(){cr.wipe(this.dictionary);this.key_count=
0};b.prototype.JSONLoad=function(a){var b;try{b=JSON.parse(a)}catch(e){return}if(b.c2dictionary){this.dictionary=b.data;this.key_count=0;for(var f in this.dictionary)this.dictionary.hasOwnProperty(f)&&this.key_count++}};b.prototype.JSONDownload=function(a){var b=document.createElement("a");if("undefined"===typeof b.download)b="data:text/html,"+encodeURIComponent("<p><a download='data.json' href=\"data:application/json,"+encodeURIComponent(JSON.stringify({c2dictionary:!0,data:this.dictionary}))+'">Download link</a></p>'),
window.open(b);else{var e=document.getElementsByTagName("body")[0];b.textContent=a;b.href="data:application/json,"+encodeURIComponent(JSON.stringify({c2dictionary:!0,data:this.dictionary}));b.download=a;e.appendChild(b);a=document.createEvent("MouseEvent");a.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null);b.dispatchEvent(a);e.removeChild(b)}};l.acts=new b;e.prototype.Get=function(a,b){this.dictionary.hasOwnProperty(b)?a.set_any(this.dictionary[b]):a.set_int(0)};e.prototype.KeyCount=
function(a){a.set_int(this.key_count)};e.prototype.CurrentKey=function(a){a.set_string(this.cur_key)};e.prototype.CurrentValue=function(a){this.dictionary.hasOwnProperty(this.cur_key)?a.set_any(this.dictionary[this.cur_key]):a.set_int(0)};e.prototype.AsJSON=function(a){a.set_string(JSON.stringify({c2dictionary:!0,data:this.dictionary}))};l.exps=new e})();cr.plugins_.Function=function(a){this.runtime=a};
(function(){function a(){this.name="";this.retVal=0;this.params=[]}function b(){f++;f===p.length&&p.push(new a);return p[f]}function e(){return 0>f?null:p[f]}function l(){}function g(){}function m(){}var c=cr.plugins_.Function.prototype;c.Type=function(a){this.plugin=a;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a){this.type=a;this.runtime=a.runtime};var p=[],f=-1;c.Instance.prototype.onCreate=function(){};l.prototype.OnFunction=function(a){var b=e();return b?
cr.equals_nocase(a,b.name):!1};l.prototype.CompareParam=function(a,b,c){var f=e();if(!f)return!1;a=cr.floor(a);return 0>a||a>=f.params.length?!1:cr.do_cmp(f.params[a],b,c)};c.cnds=new l;g.prototype.CallFunction=function(a,c){var e=b();e.name=a.toLowerCase();e.retVal=0;cr.shallowAssignArray(e.params,c);this.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction,this,e.name);f--};g.prototype.SetReturnValue=function(a){var b=e();b&&(b.retVal=a)};c.acts=new g;m.prototype.ReturnValue=function(a){var b;
p.length?(b=f+1,b>=p.length&&(b=p.length-1),b=p[b]):b=null;b?a.set_any(b.retVal):a.set_int(0)};m.prototype.ParamCount=function(a){var b=e();b?a.set_int(b.params.length):a.set_int(0)};m.prototype.Param=function(a,b){b=cr.floor(b);var c=e();c?0<=b&&b<c.params.length?a.set_any(c.params[b]):a.set_int(0):a.set_int(0)};m.prototype.Call=function(a,c){var e=b();e.name=c.toLowerCase();e.retVal=0;e.params.length=0;var g,m;g=2;for(m=arguments.length;g<m;g++)e.params.push(arguments[g]);this.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction,
this,e.name);f--;a.set_any(e.retVal)};c.exps=new m})();cr.plugins_.GameConfig=function(a){this.runtime=a};
(function(){function a(a){return decodeURI((RegExp(a+"=(.+?)(&|$)").exec(location.search)||[,""])[1])}function b(){}function e(){}function l(a,b){jQuery.getScript(void 0!==window.parent.server?window.parent.server:"http://"+a.host+":"+a.port+"/api/systems/getenvironment?u="+a.env).done(function(){b(null)}).fail(function(a,c,d){b(d)})}function g(a,b,c,d){return window.io.connect("http://"+a+":"+b+"/"+c+(d?"?sessionID="+d:""),{"force new connection":!0})}function m(a,b){l(a,function(c){if(c)return b(c);
c=window.SERVER.Game;var d=g(c.Address,c.Port,a.namespace);d.on("connect",function(){b(null,d)});d.on("connect_failed",function(){b(Error("Socket IO cannot connect to server"))})})}function c(a,b,c,d){a.emit(b,JSON.stringify({player:c.playerName,uuid:c.uuid}),d)}function p(a){var b=this.runtime;a.ok?(eval(a.data),this.messages=window.Types.Messages,this.commonMessages=this.messages.Common.Game,b.trigger(t.cnds.OnGetEnvironmentSucceed,this)):(w.error(a.data.message),b.trigger(t.cnds.OnGetEnvironmentFailed,
this))}function f(){}function n(a,b,c){return c===b.length-1?a[b[c]]:n(a[b[c]],b,c+1)}function d(a,b){if(!a)return null;if(!b)return a;var c=b.split(".");return n(a,c,0)}function u(a,b){if("number"===typeof b)return a.set_any(b);if("boolean"===typeof b)return a.set_any(+b);if("string"===typeof b)return a.set_any(b.toString());a.set_any(JSON.stringify(b))}function s(a,b){b=b||0;return 3<=b?a:0>=b?s([a],1):a.map(function(a){return Array.isArray(a)?s(a,b):s([a],b+1)})}function q(a,b){b=b||[];if(!Array.isArray(a))return b;
b.push(a.length);return q(a[0],b)}var t=cr.plugins_.GameConfig.prototype;t.Type=function(a){this.plugin=a;this.runtime=a.runtime};t.Type.prototype.onCreate=function(){};var w=window.console,r=window.httpClient;window.SERVER={};window.API_URL={};window.Types={};t.Instance=function(a){this.type=a;this.runtime=a.runtime;this.commonMessages=this.messages=this.socket=null;this.config={host:"",port:0,envApiPath:"",env:"",namespace:"",playerName:null,uuid:null};this.gameData=null;this.playerInfo={_id:"",
uuid:"",level:0,energy:0,txu:0,tinidiem:0};this.data={};this.socketError="";this.lastReceivedEvent=null};var x=t.Instance.prototype;x.onCreate=function(){this.config.host=this.properties[0];this.config.port=this.properties[1];this.config.envApiPath=this.properties[2];this.config.env=this.properties[3];this.config.namespace=this.properties[4];this.config.playerName=a("name")||this.properties[5];this.config.uuid=a("uuid")||this.properties[6];w=this.properties[6]?window.console:{log:function(){},info:function(){},
warn:function(){},error:function(){},debug:function(){}};w.log("gameConfig created",this.config)};x.draw=function(a){};x.drawGL=function(a){};b.prototype.OnConnectError=function(){return!0};b.prototype.OnConnectSuccess=function(){return!0};b.prototype.OnEvent=function(a){if(this.lastReceivedEvent===a)return!0};b.prototype.OnEventError=function(a){if(this.lastReceivedEvent===a)return!0};b.prototype.OnGetEnvironmentFailed=function(){return!0};b.prototype.OnGetEnvironmentSucceed=function(){return!0};
b.prototype.OnConnectSocketIOFailed=function(){return!0};b.prototype.OnConnectSocketIOSucceed=function(){return!0};b.prototype.OnSocketError=function(){return!0};b.prototype.OnSocketDisconnect=function(){return!0};b.prototype.OnSocketReconnect=function(){return!0};b.prototype.OnPlayerInfo=function(){return!0};t.cnds=new b;e.prototype.Connect=function(a){var b=this,d=b.runtime,f=b.config;m(f,function(a,e){if(a)return w.error(a),d.trigger(t.cnds.OnConnectError,b);b.socket=e;c(e,b.commonMessages.JOIN,
f,function(a,c){function f(a){e.on(a,function(c){var f;try{f=JSON.parse(c)}catch(e){f=c}b.data[a]=f;b.lastReceivedEvent=a;w.log("Receive message",a,"data",f);d.trigger(t.cnds.OnEvent,b)})}function g(a){if("string"===typeof a)f(a);else for(var b in a)a.hasOwnProperty(b)&&g(a[b])}if(a)return w.error(a),d.trigger(t.cnds.OnConnectError,b);b.gameData=c;w.log("Actions.Connect",b);g(b.messages);d.trigger(t.cnds.OnConnectSuccess,b)})})};e.prototype.Send=function(a,b){var c,d=this,f=d.runtime;try{JSON.parse(b),
c=b}catch(e){c=JSON.stringify(b)}this.socket&&(w.log("Send message",a,"data",c),this.socket.emit(a,c,function(b,c){b&&(c=b);var e;try{e=JSON.parse(c)}catch(k){e=c}d.data[a]=e;d.lastReceivedEvent=a;w.log("Receive message",a,b?"error":"data",e);b?f.trigger(t.cnds.OnEventError,d):f.trigger(t.cnds.OnEvent,d)}))};e.prototype.BackToScene=function(){"function"===typeof parent.showLoadingMask&&parent.showLoadingMask();window.history.back()};e.prototype.ShowLoadingMask=function(){"function"===typeof parent.showLoadingMask&&
parent.showLoadingMask()};e.prototype.HideLoadingMask=function(){"function"===typeof parent.hideLoadingMask&&parent.hideLoadingMask()};e.prototype.GetWebEnvironment=function(){var a=this.config,a=(new r({asynchronous:!1,baseUrl:void 0!==window.parent.server?window.parent.server:"http://"+a.host+":"+a.port+a.envApiPath+"?u="+a.env})).makeRequest();p.call(this,a)};e.prototype.GetAppEnvironment=function(a){var b=this.config;!a&&(a="http://"+b.host+":"+b.port+b.envApiPath+"?u="+b.env);a=(new r({asynchronous:!1,
baseUrl:a})).makeRequest();p.call(this,a)};e.prototype.ConnectSocketIO=function(a,b,d){var f=this,e=f.runtime,m=f.config;b=window.SERVER.Game;var q=g(b.Address,b.Port,m.namespace,a);q.on("connect_failed",function(){w.log("Socket connect failed ");return e.trigger(t.cnds.OnConnectSocketIOFailed,f)});q.on("error",function(a){w.error("Socket error: ",arguments);f.socketError=a&&"string"===typeof a?a:"Unknown socket error";return e.trigger(t.cnds.OnSocketError,f)});q.on("disconnect",function(){w.log("Socket disconnect");
return e.trigger(t.cnds.OnSocketDisconnect,f)});q.on("reconnect",function(){w.log("Socket reconnect");return e.trigger(t.cnds.OnSocketReconnect,f)});q.on("connect",function(){function a(b){q.on(b,function(a){var c;try{c=JSON.parse(a)}catch(d){c=a}f.data[b]=c;f.lastReceivedEvent=b;w.log("Receive message",b,"data",c);e.trigger(t.cnds.OnEvent,f)})}function b(c){if("string"===typeof c)a(c);else for(var d in c)c.hasOwnProperty(d)&&b(c[d])}f.socket=q;q.on(f.commonMessages.PLAYER_INFO,function(a){a=JSON.parse(a);
var b=!1,c;for(c in f.playerInfo)if(a[c]||0===a[c]||""===a[c])f.playerInfo[c]=a[c],b=!0;b&&e.trigger(t.cnds.OnPlayerInfo,f)});b(f.messages);c(q,f.commonMessages.JOIN,m,function(a,b){if(a)return w.error(a),e.trigger(t.cnds.OnConnectSocketIOFailed,f);f.gameData=b;e.trigger(t.cnds.OnConnectSocketIOSucceed,f)})})};e.prototype.DisconnectSocketIO=function(){var a=this.socket;a&&(a.socket.disconnect(),a.socket.reconnecting&&(a.$events={},a.once("reconnect",function(){a.socket.disconnect()})))};e.prototype.SetPlayer_id=
function(a){this.config.playerName=a};e.prototype.SetPlayerUuid=function(a){this.config.uuid=a};e.prototype.ClearEventsData=function(){this.data={};this.socketError=""};t.acts=new e;f.prototype.GetGameConfigAtKey=function(a,b){var c=d(this.gameData,b);w.log("GetGameConfigAtKey - data",c);u(a,c)};f.prototype.GetGameConfigAsDictionaryJSONAtKey=function(a,b){var c=d(this.gameData,b);w.log("GetGameConfigAsDictionaryJSONAtKey - data",c);if(null===c)return u(a,c);u(a,JSON.stringify({c2dictionary:!0,data:c}))};
f.prototype.GetGameConfigAsArrayJSONAtKey=function(a,b,c){b=d(this.gameData,b);w.log("GetGameConfigAsArrayJSONAtKey - data",b);if(null===b)return u(a,b);c=s(b,c);u(a,JSON.stringify({c2array:!0,size:q(c),data:c}))};f.prototype.GetMessageByKey=function(a,b){var c=d(this.messages,b);w.log("GetMessageByKey - message",c);u(a,c)};f.prototype.GetEventData=function(a,b,c){b=this.data[b];w.log("GetEventData - message data",c,b);if(void 0===b)return u(a,b);c=d(b,c);u(a,c)};f.prototype.GetLastEventData=function(a,
b){var c=this.data[this.lastReceivedEvent];w.log("GetLastEventData - message data",b,c);if(void 0===c)return u(a,c);c=d(c,b);u(a,c)};f.prototype.GetSocketErrorMessage=function(a){a.set_string(this.socketError)};f.prototype.GetPlayerInfoAtKey=function(a,b){var c=d(this.playerInfo,b);w.log("GetPlayerInfoAtKey - data",c);u(a,c)};t.exps=new f})();cr.plugins_.Mouse=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(){}var l=cr.plugins_.Mouse.prototype;l.Type=function(a){this.plugin=a;this.runtime=a.runtime};l.Type.prototype.onCreate=function(){};l.Instance=function(a){this.type=a;this.runtime=a.runtime;this.buttonMap=Array(4);this.triggerDir=this.triggerType=this.triggerButton=this.mouseYcanvas=this.mouseXcanvas=0;this.handled=!1};var g=l.Instance.prototype;g.onCreate=function(){var a=this;if(!this.runtime.isDomFree){jQuery(document).mousemove(function(b){a.onMouseMove(b)});
jQuery(document).mousedown(function(b){a.onMouseDown(b)});jQuery(document).mouseup(function(b){a.onMouseUp(b)});jQuery(document).dblclick(function(b){a.onDoubleClick(b)});var b=function(b){a.onWheel(b)};document.addEventListener("mousewheel",b,!1);document.addEventListener("DOMMouseScroll",b,!1)}};var m={left:0,top:0};g.onMouseMove=function(a){var b=this.runtime.isDomFree?m:jQuery(this.runtime.canvas).offset();this.mouseXcanvas=a.pageX-b.left;this.mouseYcanvas=a.pageY-b.top};g.mouseInGame=function(){return 0<
this.runtime.fullscreen_mode?!0:0<=this.mouseXcanvas&&0<=this.mouseYcanvas&&this.mouseXcanvas<this.runtime.width&&this.mouseYcanvas<this.runtime.height};g.onMouseDown=function(a){this.mouseInGame()&&(this.runtime.had_a_click&&!this.runtime.isMobile&&a.preventDefault(),this.buttonMap[a.which]=!0,this.runtime.isInUserInputEvent=!0,this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnAnyClick,this),this.triggerButton=a.which-1,this.triggerType=0,this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnClick,
this),this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnObjectClicked,this),this.runtime.isInUserInputEvent=!1)};g.onMouseUp=function(a){this.buttonMap[a.which]&&(this.runtime.had_a_click&&!this.runtime.isMobile&&a.preventDefault(),this.runtime.had_a_click=!0,this.buttonMap[a.which]=!1,this.runtime.isInUserInputEvent=!0,this.triggerButton=a.which-1,this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnRelease,this),this.runtime.isInUserInputEvent=!1)};g.onDoubleClick=function(a){this.mouseInGame()&&
(a.preventDefault(),this.runtime.isInUserInputEvent=!0,this.triggerButton=a.which-1,this.triggerType=1,this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnClick,this),this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnObjectClicked,this),this.runtime.isInUserInputEvent=!1)};g.onWheel=function(a){this.triggerDir=0>(a.wheelDelta?a.wheelDelta:a.detail?-a.detail:0)?0:1;this.handled=!1;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnWheel,this);this.runtime.isInUserInputEvent=
!1;this.handled&&a.preventDefault()};a.prototype.OnClick=function(a,b){return a===this.triggerButton&&b===this.triggerType};a.prototype.OnAnyClick=function(){return!0};a.prototype.IsButtonDown=function(a){return this.buttonMap[a+1]};a.prototype.OnRelease=function(a){return a===this.triggerButton};a.prototype.IsOverObject=function(a){var b=this.runtime.getCurrentCondition();return cr.xor(this.runtime.testAndSelectCanvasPointOverlap(a,this.mouseXcanvas,this.mouseYcanvas,b.inverted),b.inverted)};a.prototype.OnObjectClicked=
function(a,b,f){return a!==this.triggerButton||b!==this.triggerType?!1:this.runtime.testAndSelectCanvasPointOverlap(f,this.mouseXcanvas,this.mouseYcanvas,!1)};a.prototype.OnWheel=function(a){this.handled=!0;return a===this.triggerDir};l.cnds=new a;b.prototype.SetCursor=function(a){a="auto pointer text crosshair move help wait none".split(" ")[a];this.runtime.canvas&&this.runtime.canvas.style&&(this.runtime.canvas.style.cursor=a)};b.prototype.SetCursorSprite=function(a){this.runtime.isDomFree||this.runtime.isMobile||
!a||(a=a.getFirstPicked())&&a.curFrame&&(a=a.curFrame,a="url("+a.getDataUri()+") "+Math.round(a.hotspotX*a.width)+" "+Math.round(a.hotspotY*a.height)+", auto",jQuery(this.runtime.canvas).css("cursor",a))};l.acts=new b;e.prototype.X=function(a,b){var f,e,d,g,m;cr.is_undefined(b)?(f=this.runtime.getLayerByNumber(0),e=f.scale,d=f.zoomRate,g=f.parallaxX,m=f.angle,f.scale=this.runtime.running_layout.scale,f.zoomRate=1,f.parallaxX=1,f.angle=this.runtime.running_layout.angle,a.set_float(f.canvasToLayer(this.mouseXcanvas,
this.mouseYcanvas,!0)),f.scale=e,f.zoomRate=d,f.parallaxX=g,f.angle=m):(f=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(f.canvasToLayer(this.mouseXcanvas,this.mouseYcanvas,!0)):a.set_float(0)};e.prototype.Y=function(a,b){var f,e,d,g,m;cr.is_undefined(b)?(f=this.runtime.getLayerByNumber(0),e=f.scale,d=f.zoomRate,g=f.parallaxY,m=f.angle,f.scale=this.runtime.running_layout.scale,f.zoomRate=1,f.parallaxY=1,f.angle=this.runtime.running_layout.angle,a.set_float(f.canvasToLayer(this.mouseXcanvas,
this.mouseYcanvas,!1)),f.scale=e,f.zoomRate=d,f.parallaxY=g,f.angle=m):(f=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(f.canvasToLayer(this.mouseXcanvas,this.mouseYcanvas,!1)):a.set_float(0)};e.prototype.AbsoluteX=function(a){a.set_float(this.mouseXcanvas)};e.prototype.AbsoluteY=function(a){a.set_float(this.mouseYcanvas)};l.exps=new e})();cr.plugins_.NinePatch=function(a){this.runtime=a};
(function(){function a(a,b,e,f,g,d,l,s,q,t){a.save();a.fillStyle=b;b=g%e;var w=d%f;0>b&&(b+=e);0>w&&(w+=f);a.translate(b+q,w+t);a.fillRect(g-b-q,d-w-t,l,s);a.restore()}function b(){}function e(){}var l=cr.plugins_.NinePatch.prototype;l.Type=function(a){this.plugin=a;this.runtime=a.runtime};var g=l.Type.prototype;g.onCreate=function(){this.is_family||(this.texture_img=new Image,this.texture_img.idtkLoadDisposed=!0,this.texture_img.src=this.texture_file,this.texture_img.cr_filesize=this.texture_filesize,
this.runtime.waitForImageLoad(this.texture_img),this.webGL_bottomTexture=this.webGL_topTexture=this.webGL_rightTexture=this.webGL_leftTexture=this.webGL_fillTexture=this.webGL_texture=this.bottomPattern=this.topPattern=this.rightPattern=this.leftPattern=this.fillPattern=null)};g.onLostWebGLContext=function(){this.is_family||(this.webGL_bottomTexture=this.webGL_topTexture=this.webGL_rightTexture=this.webGL_leftTexture=this.webGL_fillTexture=this.webGL_texture=null)};g.onRestoreWebGLContext=function(){this.is_family||
!this.instances.length||this.webGL_texture||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,this.texture_pixelformat))};g.unloadTextures=function(){this.is_family||this.instances.length||!this.runtime.glwrap||(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.runtime.glwrap.deleteTexture(this.webGL_fillTexture),this.runtime.glwrap.deleteTexture(this.webGL_leftTexture),this.runtime.glwrap.deleteTexture(this.webGL_rightTexture),this.runtime.glwrap.deleteTexture(this.webGL_topTexture),
this.runtime.glwrap.deleteTexture(this.webGL_bottomTexture),this.webGL_bottomTexture=this.webGL_topTexture=this.webGL_rightTexture=this.webGL_leftTexture=this.webGL_fillTexture=this.webGL_texture=null)};g.slicePatch=function(a,b,e,f){var g=document.createElement("canvas");e-=a;f-=b;g.width=e;g.height=f;g.getContext("2d").drawImage(this.texture_img,a,b,e,f,0,0,e,f);return g};g.createPatch=function(a,b,e,f){var g=this.texture_img.width,d=this.texture_img.height,l=g-b,s=d-f;if(this.runtime.glwrap){if(!this.webGL_fillTexture){var q=
this.runtime.glwrap,t=this.runtime.linearSampling,w=this.texture_pixelformat;l>a&&s>e&&(this.webGL_fillTexture=q.loadTexture(this.slicePatch(a,e,l,s),!0,t,w));0<a&&s>e&&(this.webGL_leftTexture=q.loadTexture(this.slicePatch(0,e,a,s),!0,t,w,"repeat-y"));0<b&&s>e&&(this.webGL_rightTexture=q.loadTexture(this.slicePatch(l,e,g,s),!0,t,w,"repeat-y"));0<e&&l>a&&(this.webGL_topTexture=q.loadTexture(this.slicePatch(a,0,l,e),!0,t,w,"repeat-x"));0<f&&l>a&&(this.webGL_bottomTexture=q.loadTexture(this.slicePatch(a,
s,l,d),!0,t,w,"repeat-x"))}}else this.fillPattern||(q=this.runtime.ctx,l>a&&s>e&&(this.fillPattern=q.createPattern(this.slicePatch(a,e,l,s),"repeat")),0<a&&s>e&&(this.leftPattern=q.createPattern(this.slicePatch(0,e,a,s),"repeat")),0<b&&s>e&&(this.rightPattern=q.createPattern(this.slicePatch(l,e,g,s),"repeat")),0<e&&l>a&&(this.topPattern=q.createPattern(this.slicePatch(a,0,l,e),"repeat")),0<f&&l>a&&(this.bottomPattern=q.createPattern(this.slicePatch(a,s,l,d),"repeat")))};l.Instance=function(a){this.type=
a;this.runtime=a.runtime};g=l.Instance.prototype;g.onCreate=function(){this.leftMargin=this.properties[0];this.rightMargin=this.properties[1];this.topMargin=this.properties[2];this.bottomMargin=this.properties[3];this.edges=this.properties[4];this.fill=this.properties[5];this.visible=0===this.properties[6];this.seamless=0!==this.properties[8];this.recycled?this.rcTex.set(0,0,0,0):this.rcTex=new cr.rect(0,0,0,0);this.runtime.glwrap&&!this.type.webGL_texture&&(this.type.webGL_texture=this.runtime.glwrap.loadTexture(this.type.texture_img,
!1,this.runtime.linearSampling,this.type.texture_pixelformat));this.type.createPatch(this.leftMargin,this.rightMargin,this.topMargin,this.bottomMargin)};g.draw=function(b){var c=this.type.texture_img,e=this.leftMargin,f=this.rightMargin,g=this.topMargin,d=this.bottomMargin,l=c.width,s=c.height,q=l-f,t=s-d;b.globalAlpha=this.opacity;b.save();var w=this.x,r=this.y,x=this.width,z=this.height;this.runtime.pixel_rounding&&(w=w+0.5|0,r=r+0.5|0);var h=-(this.hotspotX*this.width),k=-(this.hotspotY*this.height),
y=h%l,v=k%s;0>y&&(y+=l);0>v&&(v+=s);b.translate(w+y,r+v);l=h-y;k-=v;v=this.seamless?1:0;0<e&&0<g&&b.drawImage(c,0,0,e+v,g+v,l,k,e+v,g+v);0<f&&0<g&&b.drawImage(c,q-v,0,f+v,g+v,l+x-f-v,k,f+v,g+v);0<f&&0<d&&b.drawImage(c,q-v,t-v,f+v,d+v,l+x-f-v,k+z-d-v,f+v,d+v);0<e&&0<d&&b.drawImage(c,0,t-v,e+v,d+v,l,k+z-d-v,e+v,d+v);0===this.edges?(v=2===this.fill?0:v,0<e&&t>g&&a(b,this.type.leftPattern,e,t-g,l,k+g,e+v,z-g-d,0,0),0<f&&t>g&&a(b,this.type.rightPattern,f,t-g,l+x-f-v,k+g,f+v,z-g-d,v,0),0<g&&q>e&&a(b,this.type.topPattern,
q-e,g,l+e,k,x-e-f,g+v,0,0),0<d&&q>e&&a(b,this.type.bottomPattern,q-e,d,l+e,k+z-d-v,x-e-f,d+v,0,v)):1===this.edges&&(0<e&&t>g&&b.drawImage(c,0,g,e,t-g,l,k+g,e,z-g-d),0<f&&t>g&&b.drawImage(c,q,g,f,t-g,l+x-f,k+g,f,z-g-d),0<g&&q>e&&b.drawImage(c,e,0,q-e,g,l+e,k,x-e-f,g),0<d&&q>e&&b.drawImage(c,e,t,q-e,d,l+e,k+z-d,x-e-f,d));t>g&&q>e&&(0===this.fill?a(b,this.type.fillPattern,q-e,t-g,l+e,k+g,x-e-f,z-g-d,0,0):1===this.fill&&b.drawImage(c,e,g,q-e,t-g,l+e,k+g,x-e-f,z-g-d));b.restore()};g.drawPatch=function(a,
b,e,f,g,d,l,s,q,t){a.setTexture(b);var w=this.rcTex;w.left=e/b.c2width;w.top=f/b.c2height;w.right=(e+g)/b.c2width;w.bottom=(f+d)/b.c2height;a.quadTex(l,s,l+q,s,l+q,s+t,l,s+t,w)};g.tilePatch=function(a,b,e,f,g,d,l,s){a.setTexture(b);var q=this.rcTex;q.left=-l/b.c2width;q.top=-s/b.c2height;q.right=(g-l)/b.c2width;q.bottom=(d-s)/b.c2height;a.quadTex(e,f,e+g,f,e+g,f+d,e,f+d,q)};g.drawGL=function(a){var b=this.leftMargin,e=this.rightMargin,f=this.topMargin,g=this.bottomMargin,d=this.type.texture_img.width-
e,l=this.type.texture_img.height-g;a.setOpacity(this.opacity);var s=this.bquad,q=s.tlx,s=s.tly,t=this.width,w=this.height;this.runtime.pixel_rounding&&(q=q+0.5|0,s=s+0.5|0);var r=this.seamless?1:0;0<b&&0<f&&this.drawPatch(a,this.type.webGL_texture,0,0,b+r,f+r,q,s,b+r,f+r);0<e&&0<f&&this.drawPatch(a,this.type.webGL_texture,d-r,0,e+r,f+r,q+t-e-r,s,e+r,f+r);0<e&&0<g&&this.drawPatch(a,this.type.webGL_texture,d-r,l-r,e+r,g+r,q+t-e-r,s+w-g-r,e+r,g+r);0<b&&0<g&&this.drawPatch(a,this.type.webGL_texture,0,
l-r,b+r,g+r,q,s+w-g-r,b+r,g+r);0===this.edges?(r=2===this.fill?0:r,0<b&&l>f&&this.tilePatch(a,this.type.webGL_leftTexture,q,s+f,b+r,w-f-g,0,0),0<e&&l>f&&this.tilePatch(a,this.type.webGL_rightTexture,q+t-e-r,s+f,e+r,w-f-g,r,0),0<f&&d>b&&this.tilePatch(a,this.type.webGL_topTexture,q+b,s,t-b-e,f+r,0,0),0<g&&d>b&&this.tilePatch(a,this.type.webGL_bottomTexture,q+b,s+w-g-r,t-b-e,g+r,0,r)):1===this.edges&&(0<b&&l>f&&this.drawPatch(a,this.type.webGL_texture,0,f,b,l-f,q,s+f,b,w-f-g),0<e&&l>f&&this.drawPatch(a,
this.type.webGL_texture,d,f,e,l-f,q+t-e,s+f,e,w-f-g),0<f&&d>b&&this.drawPatch(a,this.type.webGL_texture,b,0,d-b,f,q+b,s,t-b-e,f),0<g&&d>b&&this.drawPatch(a,this.type.webGL_texture,b,l,d-b,g,q+b,s+w-g,t-b-e,g));l>f&&d>b&&(0===this.fill?this.tilePatch(a,this.type.webGL_fillTexture,q+b,s+f,t-b-e,w-f-g,0,0):1===this.fill&&this.drawPatch(a,this.type.webGL_texture,b,f,d-b,l-f,q+b,s+f,t-b-e,w-f-g))};b.prototype.OnURLLoaded=function(){return!0};l.cnds=new b;e.prototype.SetEffect=function(a){this.compositeOp=
cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};l.acts=new e;l.exps=new function(){}})();cr.plugins_.ShakeItUtils=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(){}function l(a,b){var c=this;this.config={};this.remainingCustomers=[];this.queueingCustomers=[];this.activeCustomers=[];this.currentDrink=null;this.currentFruits=[];p(this.config,a.settings["default"].level,b);var d=a.settings.customers;this.remainingCustomers=this.config.customers.map(function(b){return new g(a,c,d[b])});this.addCustomerToQueue=function(){if(0!==this.remainingCustomers.length){var a=u(0,this.remainingCustomers.length-1),a=this.remainingCustomers.splice(a,
1);Array.prototype.push.apply(this.queueingCustomers,a)}};this.start=function(){console.log("level started")};this.stop=function(){function a(b){b.stop()}this.remainingCustomers.forEach(a);this.queueingCustomers.forEach(a);this.activeCustomers.forEach(a)};this.addCustomer=function(a,b,c){if(!(this.config.maxActiveCustomers<=this.activeCustomers.length||0>=this.queueingCustomers.length)){var d=this.queueingCustomers.shift();this.activeCustomers.push(d);d.createInstance(a,b,c)}};this.onCustomerLeave=
function(a){var b=f(this.activeCustomers,function(b){return a===b.instance.uid});b&&this.activeCustomers.splice(this.activeCustomers.indexOf(b),1)};this.addDrink=function(b){this.currentDrink||(b=a.settings.drinks.indexOf(b),1<=b&&(this.currentDrink=a.settings.charMap["drink"+b]))};this.addFruit=function(b){this.currentFruits=this.currentFruits||[];a.settings.maxMixerFruits<=this.currentFruits.length||(b=a.settings.fruits.indexOf(b),1<=b&&this.currentFruits.push(a.settings.charMap["fruit"+b]))};this.getDrink=
function(){if(!this.currentDrink||!this.currentFruits.length)return"";var a=this.currentDrink+this.currentFruits.join("");this.restartDrink();return a};this.restartDrink=function(){this.currentDrink=null;this.currentFruits=[]};console.log("New level ",this)}function g(a,b,c){var f={},e=a.runtime;this.instance=null;p(f,a.settings["default"].customer,c);c=u(2,b.config.maxOrderSize);var g=a.settings.charMap,k=[],m=b.config.drinks,m=m[u(0,m.length-1)];k.push(g["drink"+m]);b=b.config.fruits;for(m=0;m<
c-1;m++){var q=b[u(0,b.length-1)];k.push(g["fruit"+q])}d(k);this.createInstance=function(b,c,d){var g=a.crTypes.customers[f.name];if(!g)return console.error("Cannot create instance of customer "+f.name);this.instance=e.createInstance(g,e.getLayerByName(b),c,d);this.instance.instance_vars[0]=f.score;this.instance.instance_vars[1]=k.join("");this.instance.instance_vars[2]=f.stateInterval;e.trigger(cr.plugins_.Sprite.prototype.cnds.OnCreated,this.instance);return this.instance};this.stop=function(){}}
function m(a,b){if(!a)return null;if(!b)return a;var d=b.split(".");return c(a,d,0)}function c(a,b,d){return d===b.length-1?a[b[d]]:c(a[b[d]],b,d+1)}function p(){var a=arguments[0];Array.prototype.slice.call(arguments,1).forEach(function(b){for(var c in b){var d=b[c];"object"!==typeof d||null===d?a[c]=d:(a[c]&&"object"===typeof a[c]||(a[c]=d instanceof Array?[]:{}),p(a[c],d))}});return a}function f(a,b){for(var c in a)if(a.hasOwnProperty(c)&&b(a[c]))return a[c]}function n(a,b){return f(a,function(a){for(var c in b)if(!b.hasOwnProperty(c)||
!a.hasOwnProperty(c)||b[c]!==a[c])return!1;return!0})}function d(a){for(var b,c,d=a.length;d;b=Math.floor(Math.random()*d),c=a[--d],a[d]=a[b],a[b]=c);return a}function u(a,b){return Math.floor(Math.random()*(b-a+1))+a}var s=cr.plugins_.ShakeItUtils.prototype;s.Type=function(a){this.plugin=a;this.runtime=a.runtime};s.Type.prototype.onCreate=function(){};s.Instance=function(a){this.type=a;this.runtime=a.runtime;this.settings=this.settingsJson=null;this.crTypes={customers:{}};this.currentLevel=-1;this.levelData=
null};var q=s.Instance.prototype;q.onCreate=function(){};q.startLevel=function(){this.levelData.start()};q.stopLevel=function(){this.levelData.stop();this.levelData=null};a.prototype.CompareDrinkStrings=function(a,b){var c=a.split(""),d=b.split("");c.sort();d.sort();return c.toString()===d.toString()};a.prototype.OnInitialized=function(){return!0};a.prototype.OnInitializingFailed=function(){return!0};s.cnds=new a;b.prototype.LoadSettingsFromJson=function(a){var b=this.runtime;this.settingsJson=a;
var c;try{c=JSON.parse(a)}catch(d){console.log("Load settings failed: "+d);b.trigger(s.cnds.OnInitializingFailed,this);return}c&&(this.settings=c,console.log("LoadSettingsFromJson",this.settings),b.trigger(s.cnds.OnInitialized,this))};b.prototype.ReloadSettingsFromJson=function(){this.settings=JSON.parse(this.settingsJson)};b.prototype.LoadSettings=function(){var a=this,b=this.runtime;jQuery.ajax({dataType:"json",url:"settings.json",isLocal:!0,success:function(c){a.settings=c;return b.trigger(s.cnds.OnInitialized,
a)},error:function(c,d,f){console.log("Load settings.json failed: "+d+" - "+f);return b.trigger(s.cnds.OnInitializingFailed,a)}});console.log("LoadSettings",this.settings)};b.prototype.RegisterCustomer=function(a,b){this.crTypes.customers[a]=b};b.prototype.InitializeBoosters=function(a){var b;try{b=JSON.parse(a)}catch(c){console.error(c)}b&&b.forEach(function(a){var b=n(this.settings.boosters,{id:a._id});p(b,a)}.bind(this))};b.prototype.SetCurrentLevel=function(a){this.currentLevel=a;var b;this.settings&&
(b=this.settings.levels[a]);this.levelData&&this.stopLevel();this.levelData=b?new l(this,b):null;console.log("SetCurrentLevel",this.levelData)};b.prototype.StartLevel=function(){this.levelData?this.startLevel():console.error("Level data not found")};b.prototype.AddCustomerToQueue=function(){this.levelData?this.levelData.addCustomerToQueue():console.error("Level data not found")};b.prototype.AddCustomer=function(a,b,c){this.levelData?this.levelData.addCustomer(a,b,c):console.error("Level data not found")};
b.prototype.MarkLeavingCustomer=function(a){if(this.levelData)this.levelData.onCustomerLeave(a);else console.error("Level data not found")};b.prototype.AddDrink=function(a){this.levelData?this.levelData.addDrink(a):console.error("Level data not found")};b.prototype.AddFruit=function(a){this.levelData?this.levelData.addFruit(a):console.error("Level data not found")};s.acts=new b;e.prototype.GetSettingsData=function(a,b){if(!this.settings)return console.error("Settings not found"),a.set_any(null);var c=
m(this.settings,b);"string"===typeof c||"number"===typeof c?a.set_any(c):a.set_any(JSON.stringify(c))};e.prototype.GetCurrentLevel=function(a){a.set_int(this.currentLevel)};e.prototype.GetLevelData=function(a,b){if(!this.levelData)return console.error("Level data not found"),a.set_any(null);var c=m(this.levelData,b);"string"===typeof c||"number"===typeof c?a.set_any(c):a.set_any(JSON.stringify(c))};e.prototype.GetDrink=function(a){if(!this.levelData)return console.error("Level data not found"),a.set_string(null);
a.set_string(this.levelData.getDrink())};s.exps=new e})();cr.plugins_.Sprite=function(a){this.runtime=a};
(function(){function a(){if(0===this.datauri.length){var a=document.createElement("canvas");a.width=this.width;a.height=this.height;var b=a.getContext("2d");this.spritesheeted?b.drawImage(this.texture_img,this.offx,this.offy,this.width,this.height,0,0,this.width,this.height):b.drawImage(this.texture_img,0,0,this.width,this.height);this.datauri=a.toDataURL("image/png")}return this.datauri}function b(){}function e(a){a[0]=0;a[1]=0;a[2]=0;t.push(a)}function l(a,b){return a<b?""+a+","+b:""+b+","+a}function g(a,
b,c,d){b=b.uid;c=c.uid;var f=l(b,c);if(a.hasOwnProperty(f))a[f][2]=d;else{var e;e=t.length?t.pop():[0,0,0];e[0]=b;e[1]=c;e[2]=d;a[f]=e}}function m(a,b,c){b=l(b.uid,c.uid);a.hasOwnProperty(b)&&(e(a[b]),delete a[b])}function c(a,b,c){b=l(b.uid,c.uid);if(a.hasOwnProperty(b))return w=a[b][2],!0;w=-2;return!1}function p(a,b,c){if(!a)return!1;var d=0!==b||0!==c,f,e,g=!1,m,q=this.runtime.getCurrentCondition(),l=q.type,q=q.inverted,n=a.getCurrentSol();m=this.runtime.getCurrentEventStack().current_event.orblock;
n.select_all?(this.update_bbox(),this.runtime.getCollisionCandidates(this.layer,a,this.bbox,r),n=r):n=m?n.else_instances:n.instances;x=a;h=l!==a&&!q;d&&(f=this.x,e=this.y,this.x+=b,this.y+=c,this.set_bbox_changed());b=0;for(c=n.length;b<c;b++)if(m=n[b],this.runtime.testOverlap(this,m)){g=!0;if(q)break;l!==a&&z.add(m)}d&&(this.x=f,this.y=e,this.set_bbox_changed());r.length=0;return g}function f(){}function n(){}var d=cr.plugins_.Sprite.prototype;d.Type=function(a){this.plugin=a;this.runtime=a.runtime};
var u=d.Type.prototype;u.onCreate=function(){if(!this.is_family){var b,c,d,f,e,g,h,m,q;this.all_frames=[];this.has_loaded_textures=!1;b=0;for(c=this.animations.length;b<c;b++){e=this.animations[b];h={};h.name=e[0];h.speed=e[1];h.loop=e[2];h.repeatcount=e[3];h.repeatto=e[4];h.pingpong=e[5];h.sid=e[6];h.frames=[];d=0;for(f=e[7].length;d<f;d++)g=e[7][d],m={},m.texture_file=g[0],m.texture_filesize=g[1],m.offx=g[2],m.offy=g[3],m.width=g[4],m.height=g[5],m.duration=g[6],m.hotspotX=g[7],m.hotspotY=g[8],
m.image_points=g[9],m.poly_pts=g[10],m.pixelformat=g[11],m.spritesheeted=0!==m.width,m.datauri="",m.getDataUri=a,q={left:0,top:0,right:1,bottom:1},m.sheetTex=q,m.webGL_texture=null,(q=this.runtime.findWaitingTexture(g[0]))?m.texture_img=q:(m.texture_img=new Image,m.texture_img.idtkLoadDisposed=!0,m.texture_img.src=g[0],m.texture_img.cr_src=g[0],m.texture_img.cr_filesize=g[1],m.texture_img.c2webGL_texture=null,this.runtime.waitForImageLoad(m.texture_img)),cr.seal(m),h.frames.push(m),this.all_frames.push(m);
cr.seal(h);this.animations[b]=h}}};u.updateAllCurrentTexture=function(){var a,b,c;a=0;for(b=this.instances.length;a<b;a++)c=this.instances[a],c.curWebGLTexture=c.curFrame.webGL_texture};u.onLostWebGLContext=function(){if(!this.is_family){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.texture_img.c2webGL_texture=null,c.webGL_texture=null}};u.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],
c.webGL_texture=this.runtime.glwrap.loadTexture(c.texture_img,!1,this.runtime.linearSampling,c.pixelformat);this.updateAllCurrentTexture()}};u.loadTextures=function(){if(!this.is_family&&!this.has_loaded_textures&&this.runtime.glwrap){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.webGL_texture=this.runtime.glwrap.loadTexture(c.texture_img,!1,this.runtime.linearSampling,c.pixelformat);this.has_loaded_textures=!0}};u.unloadTextures=function(){if(!this.is_family&&!this.instances.length&&
this.has_loaded_textures){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],this.runtime.glwrap.deleteTexture(c.webGL_texture),c.webGL_texture=null;this.has_loaded_textures=!1}};var s=[];u.preloadCanvas2D=function(a){var b,c,d;b=s.length=0;for(c=this.all_frames.length;b<c;++b)d=this.all_frames[b].texture_img,-1===s.indexOf(d)&&(a.drawImage(d,0,0),s.push(d))};d.Instance=function(a){this.type=a;this.runtime=a.runtime;a=this.type.animations[0].frames[0].poly_pts;this.recycled?this.collision_poly.set_pts(a):
this.collision_poly=new cr.CollisionPoly(a)};var q=d.Instance.prototype;q.onCreate=function(){this.visible=0===this.properties[0];this.inAnimTrigger=this.isTicking=!1;this.collisionsEnabled=0!==this.properties[3];1===this.type.animations.length&&1===this.type.animations[0].frames.length||0===this.type.animations[0].speed||(this.runtime.tickMe(this),this.isTicking=!0);this.cur_animation=this.getAnimationByName(this.properties[1])||this.type.animations[0];this.cur_frame=this.properties[2];0>this.cur_frame&&
(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);var a=this.cur_animation.frames[this.cur_frame];this.collision_poly.set_pts(a.poly_pts);this.hotspotX=a.hotspotX;this.hotspotY=a.hotspotY;this.cur_anim_speed=this.cur_animation.speed;this.recycled?this.animTimer.reset():this.animTimer=new cr.KahanAdder;this.frameStart=this.getNowTime();this.animPlaying=!0;this.animRepeats=0;this.animForwards=!0;this.changeAnimName=this.animTriggerName=
"";this.changeAnimFrom=0;this.changeAnimFrame=-1;this.type.loadTextures();var b,c,d,f,e,g,h,a=0;for(b=this.type.animations.length;a<b;a++)for(f=this.type.animations[a],c=0,d=f.frames.length;c<d;c++)e=f.frames[c],0===e.width&&(e.width=e.texture_img.width,e.height=e.texture_img.height),e.spritesheeted&&(h=e.texture_img,g=e.sheetTex,g.left=e.offx/h.width,g.top=e.offy/h.height,g.right=(e.offx+e.width)/h.width,g.bottom=(e.offy+e.height)/h.height,0===e.offx&&0===e.offy&&e.width===h.width&&e.height===h.height&&
(e.spritesheeted=!1));this.curFrame=this.cur_animation.frames[this.cur_frame];this.curWebGLTexture=this.curFrame.webGL_texture};q.saveToJSON=function(){var a={a:this.cur_animation.sid,f:this.cur_frame,cas:this.cur_anim_speed,fs:this.frameStart,ar:this.animRepeats,at:this.animTimer.sum};this.animPlaying||(a.ap=this.animPlaying);this.animForwards||(a.af=this.animForwards);return a};q.loadFromJSON=function(a){var b=this.getAnimationBySid(a.a);b&&(this.cur_animation=b);this.cur_frame=a.f;0>this.cur_frame&&
(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);this.cur_anim_speed=a.cas;this.frameStart=a.fs;this.animRepeats=a.ar;this.animTimer.reset();this.animTimer.sum=a.at;this.animPlaying=a.hasOwnProperty("ap")?a.ap:!0;this.animForwards=a.hasOwnProperty("af")?a.af:!0;this.curFrame=this.cur_animation.frames[this.cur_frame];this.curWebGLTexture=this.curFrame.webGL_texture;this.collision_poly.set_pts(this.curFrame.poly_pts);this.hotspotX=
this.curFrame.hotspotX;this.hotspotY=this.curFrame.hotspotY};q.animationFinish=function(a){this.cur_frame=a?0:this.cur_animation.frames.length-1;this.animPlaying=!1;this.animTriggerName=this.cur_animation.name;this.inAnimTrigger=!0;this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,this);this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,this);this.inAnimTrigger=!1;this.animRepeats=0};q.getNowTime=function(){return this.animTimer.sum};q.tick=function(){this.animTimer.add(this.runtime.getDt(this));
this.changeAnimName.length&&this.doChangeAnim();0<=this.changeAnimFrame&&this.doChangeAnimFrame();var a=this.getNowTime(),b=this.cur_animation,c=b.frames[this.cur_frame],d=c.duration/this.cur_anim_speed;this.animPlaying&&a>=this.frameStart+d&&(this.animForwards?this.cur_frame++:this.cur_frame--,this.frameStart+=d,this.cur_frame>=b.frames.length&&(b.pingpong?(this.animForwards=!1,this.cur_frame=b.frames.length-2):b.loop?this.cur_frame=b.repeatto:(this.animRepeats++,this.animRepeats>=b.repeatcount?
this.animationFinish(!1):this.cur_frame=b.repeatto)),0>this.cur_frame&&(b.pingpong?(this.cur_frame=1,this.animForwards=!0,b.loop||(this.animRepeats++,this.animRepeats>=b.repeatcount&&this.animationFinish(!0))):b.loop?this.cur_frame=b.repeatto:(this.animRepeats++,this.animRepeats>=b.repeatcount?this.animationFinish(!0):this.cur_frame=b.repeatto)),0>this.cur_frame?this.cur_frame=0:this.cur_frame>=b.frames.length&&(this.cur_frame=b.frames.length-1),a>this.frameStart+b.frames[this.cur_frame].duration/
this.cur_anim_speed&&(this.frameStart=a),a=b.frames[this.cur_frame],this.OnFrameChanged(c,a),this.runtime.redraw=!0)};q.getAnimationByName=function(a){var b,c,d;b=0;for(c=this.type.animations.length;b<c;b++)if(d=this.type.animations[b],cr.equals_nocase(d.name,a))return d;return null};q.getAnimationBySid=function(a){var b,c,d;b=0;for(c=this.type.animations.length;b<c;b++)if(d=this.type.animations[b],d.sid===a)return d;return null};q.doChangeAnim=function(){var a=this.cur_animation.frames[this.cur_frame],
b=this.getAnimationByName(this.changeAnimName);this.changeAnimName="";!b||cr.equals_nocase(b.name,this.cur_animation.name)&&this.animPlaying||(this.cur_animation=b,this.cur_anim_speed=b.speed,0>this.cur_frame&&(this.cur_frame=0),this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1),1===this.changeAnimFrom&&(this.cur_frame=0),this.animPlaying=!0,this.frameStart=this.getNowTime(),this.animForwards=!0,this.OnFrameChanged(a,this.cur_animation.frames[this.cur_frame]),
this.runtime.redraw=!0)};q.doChangeAnimFrame=function(){var a=this.cur_animation.frames[this.cur_frame],b=this.cur_frame;this.cur_frame=cr.floor(this.changeAnimFrame);0>this.cur_frame&&(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);b!==this.cur_frame&&(this.OnFrameChanged(a,this.cur_animation.frames[this.cur_frame]),this.frameStart=this.getNowTime(),this.runtime.redraw=!0);this.changeAnimFrame=-1};q.OnFrameChanged=function(a,
b){var c=a.width,d=a.height,f=b.width,e=b.height;c!=f&&(this.width*=f/c);d!=e&&(this.height*=e/d);this.hotspotX=b.hotspotX;this.hotspotY=b.hotspotY;this.collision_poly.set_pts(b.poly_pts);this.set_bbox_changed();this.curFrame=b;this.curWebGLTexture=b.webGL_texture;c=0;for(d=this.behavior_insts.length;c<d;c++)if(f=this.behavior_insts[c],f.onSpriteFrameChanged)f.onSpriteFrameChanged(a,b);this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnFrameChanged,this)};q.draw=function(a){a.globalAlpha=this.opacity;
var b=this.curFrame,c=b.spritesheeted,d=b.texture_img,f=this.x,e=this.y,g=this.width,h=this.height;if(0===this.angle&&0<=g&&0<=h)f-=this.hotspotX*g,e-=this.hotspotY*h,this.runtime.pixel_rounding&&(f=f+0.5|0,e=e+0.5|0),c?a.drawImage(d,b.offx,b.offy,b.width,b.height,f,e,g,h):a.drawImage(d,f,e,g,h);else{this.runtime.pixel_rounding&&(f=f+0.5|0,e=e+0.5|0);a.save();var m=0<g?1:-1,q=0<h?1:-1;a.translate(f,e);1===m&&1===q||a.scale(m,q);a.rotate(this.angle*m*q);f=0-this.hotspotX*cr.abs(g);e=0-this.hotspotY*
cr.abs(h);c?a.drawImage(d,b.offx,b.offy,b.width,b.height,f,e,cr.abs(g),cr.abs(h)):a.drawImage(d,f,e,cr.abs(g),cr.abs(h));a.restore()}};q.drawGL=function(a){a.setTexture(this.curWebGLTexture);a.setOpacity(this.opacity);var b=this.curFrame,c=this.bquad;if(this.runtime.pixel_rounding){var d=(this.x+0.5|0)-this.x,f=(this.y+0.5|0)-this.y;b.spritesheeted?a.quadTex(c.tlx+d,c.tly+f,c.trx+d,c.try_+f,c.brx+d,c.bry+f,c.blx+d,c.bly+f,b.sheetTex):a.quad(c.tlx+d,c.tly+f,c.trx+d,c.try_+f,c.brx+d,c.bry+f,c.blx+d,
c.bly+f)}else b.spritesheeted?a.quadTex(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly,b.sheetTex):a.quad(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly)};q.getImagePointIndexByName=function(a){var b=this.curFrame,c,d;c=0;for(d=b.image_points.length;c<d;c++)if(cr.equals_nocase(a,b.image_points[c][0]))return c;return-1};q.getImagePoint=function(a,b){var c=this.curFrame,d=c.image_points,f;f=cr.is_string(a)?this.getImagePointIndexByName(a):a-1;f=cr.floor(f);if(0>f||f>=d.length)return b?this.x:this.y;
var e=(d[f][1]-c.hotspotX)*this.width,d=d[f][2],d=(d-c.hotspotY)*this.height,c=Math.cos(this.angle);f=Math.sin(this.angle);var g=e*c-d*f,d=d*c+e*f,e=g+this.x,d=d+this.y;return b?e:d};var t=[],w=-2,r=[];b.prototype.OnCollision=function(a){if(!a)return!1;var b=this.runtime,d=b.getCurrentCondition(),f=d.type;d.extra.collmemory||(d.extra.collmemory={},b.addDestroyCallback(function(a){return function(b){b=b.uid;var c,d;for(c in a)a.hasOwnProperty(c)&&(d=a[c],d[0]===b||d[1]===b)&&(e(a[c]),delete a[c])}}(d.extra.collmemory)));
var d=d.extra.collmemory,h=f.getCurrentSol(),q=a.getCurrentSol(),h=h.getObjects(),l,n,p,t,s,u,x,z=this.runtime.tickcount,M=z-1,J=b.getCurrentEventStack().current_event;for(n=0;n<h.length;n++){p=h[n];q.select_all?(p.update_bbox(),this.runtime.getCollisionCandidates(p.layer,a,p.bbox,r),l=r):l=q.getObjects();for(t=0;t<l.length;t++)s=l[t],b.testOverlap(p,s)||b.checkRegisteredCollision(p,s)?(u=c(d,p,s),u=!u||w<M,g(d,p,s,z),u&&(b.pushCopySol(J.solModifiers),u=f.getCurrentSol(),x=a.getCurrentSol(),u.select_all=
!1,x.select_all=!1,f===a?(u.instances.length=2,u.instances[0]=p,u.instances[1]=s,f.applySolToContainer()):(u.instances.length=1,x.instances.length=1,u.instances[0]=p,x.instances[0]=s,f.applySolToContainer(),a.applySolToContainer()),J.retrigger(),b.popSol(J.solModifiers))):m(d,p,s);r.length=0}return!1};var x=null,z=new cr.ObjectSet,h=!1;u.finish=function(a){if(h){if(a){var b=this.runtime.getCurrentEventStack().current_event.orblock;a=x.getCurrentSol();var c=z.valuesRef(),d,f;if(a.select_all){a.select_all=
!1;a.instances.length=c.length;d=0;for(f=c.length;d<f;d++)a.instances[d]=c[d];if(b)for(d=a.else_instances.length=0,f=x.instances.length;d<f;d++)c=x.instances[d],z.contains(c)||a.else_instances.push(c)}else if(b)for(b=a.instances.length,a.instances.length=b+c.length,d=0,f=c.length;d<f;d++)a.instances[b+d]=c[d],cr.arrayFindRemove(a.else_instances,c[d]);else cr.shallowAssignArray(a.instances,c);x.applySolToContainer()}z.clear();h=!1}};b.prototype.IsOverlapping=function(a){return p.call(this,a,0,0)};
b.prototype.IsOverlappingOffset=function(a,b,c){return p.call(this,a,b,c)};b.prototype.IsAnimPlaying=function(a){return this.changeAnimName.length?cr.equals_nocase(this.changeAnimName,a):cr.equals_nocase(this.cur_animation.name,a)};b.prototype.CompareFrame=function(a,b){return cr.do_cmp(this.cur_frame,a,b)};b.prototype.CompareAnimSpeed=function(a,b){return cr.do_cmp(this.animForwards?this.cur_anim_speed:-this.cur_anim_speed,a,b)};b.prototype.OnAnimFinished=function(a){return cr.equals_nocase(this.animTriggerName,
a)};b.prototype.OnAnyAnimFinished=function(){return!0};b.prototype.OnFrameChanged=function(){return!0};b.prototype.IsMirrored=function(){return 0>this.width};b.prototype.IsFlipped=function(){return 0>this.height};b.prototype.OnURLLoaded=function(){return!0};b.prototype.IsCollisionEnabled=function(){return this.collisionsEnabled};d.cnds=new b;f.prototype.Spawn=function(a,b,c){if(a&&b&&(b=this.runtime.createInstance(a,b,this.getImagePoint(c,!0),this.getImagePoint(c,!1)))){"undefined"!==typeof b.angle&&
(b.angle=this.angle,b.set_bbox_changed());this.runtime.isInOnDestroy++;var d,f,e;this.runtime.trigger(Object.getPrototypeOf(a.plugin).cnds.OnCreated,b);if(b.is_contained)for(d=0,f=b.siblings.length;d<f;d++)e=b.siblings[d],this.runtime.trigger(Object.getPrototypeOf(e.type.plugin).cnds.OnCreated,e);this.runtime.isInOnDestroy--;d=this.runtime.getCurrentAction();c=!1;if(cr.is_undefined(d.extra.Spawn_LastExec)||d.extra.Spawn_LastExec<this.runtime.execcount)c=!0,d.extra.Spawn_LastExec=this.runtime.execcount;
if(a!=this.type&&(a=a.getCurrentSol(),a.select_all=!1,c?(a.instances.length=1,a.instances[0]=b):a.instances.push(b),b.is_contained))for(d=0,f=b.siblings.length;d<f;d++)e=b.siblings[d],a=e.type.getCurrentSol(),a.select_all=!1,c?(a.instances.length=1,a.instances[0]=e):a.instances.push(e)}};f.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};f.prototype.StopAnim=function(){this.animPlaying=!1};f.prototype.StartAnim=
function(a){this.animPlaying=!0;this.frameStart=this.getNowTime();1===a&&0!==this.cur_frame&&(this.changeAnimFrame=0,this.inAnimTrigger||this.doChangeAnimFrame());this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0)};f.prototype.SetAnim=function(a,b){this.changeAnimName=a;this.changeAnimFrom=b;this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0);this.inAnimTrigger||this.doChangeAnim()};f.prototype.SetAnimFrame=function(a){this.changeAnimFrame=a;this.isTicking||(this.runtime.tickMe(this),
this.isTicking=!0);this.inAnimTrigger||this.doChangeAnimFrame()};f.prototype.SetAnimSpeed=function(a){this.cur_anim_speed=cr.abs(a);this.animForwards=0<=a;this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0)};f.prototype.SetMirrored=function(a){a=cr.abs(this.width)*(0===a?-1:1);this.width!==a&&(this.width=a,this.set_bbox_changed())};f.prototype.SetFlipped=function(a){a=cr.abs(this.height)*(0===a?-1:1);this.height!==a&&(this.height=a,this.set_bbox_changed())};f.prototype.SetScale=function(a){var b=
this.curFrame,c=b.width*a*(0>this.width?-1:1);a=b.height*a*(0>this.height?-1:1);if(this.width!==c||this.height!==a)this.width=c,this.height=a,this.set_bbox_changed()};f.prototype.LoadURL=function(a,b){var c=new Image,d=this,f=this.curFrame;c.onload=function(){f.texture_img.src===c.src?d.runtime.glwrap&&d.curFrame===f&&(d.curWebGLTexture=f.webGL_texture):(f.texture_img=c,f.offx=0,f.offy=0,f.width=c.width,f.height=c.height,f.spritesheeted=!1,f.datauri="",d.runtime.glwrap&&(f.webGL_texture&&d.runtime.glwrap.deleteTexture(f.webGL_texture),
f.webGL_texture=d.runtime.glwrap.loadTexture(c,!1,d.runtime.linearSampling),d.curFrame===f&&(d.curWebGLTexture=f.webGL_texture),d.type.updateAllCurrentTexture()),0===b&&(d.width=c.width,d.height=c.height,d.set_bbox_changed()));d.runtime.redraw=!0;d.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded,d)};"data:"!==a.substr(0,5)&&(c.crossOrigin="anonymous");c.src=a};f.prototype.SetCollisions=function(a){this.collisionsEnabled!==(0!==a)&&((this.collisionsEnabled=0!==a)?this.set_bbox_changed():
(this.collcells.right>=this.collcells.left&&this.type.collision_grid.update(this,this.collcells,null),this.collcells.set(0,0,-1,-1)))};d.acts=new f;n.prototype.AnimationFrame=function(a){a.set_int(this.cur_frame)};n.prototype.AnimationFrameCount=function(a){a.set_int(this.cur_animation.frames.length)};n.prototype.AnimationName=function(a){a.set_string(this.cur_animation.name)};n.prototype.AnimationSpeed=function(a){a.set_float(this.animForwards?this.cur_anim_speed:-this.cur_anim_speed)};n.prototype.ImagePointX=
function(a,b){a.set_float(this.getImagePoint(b,!0))};n.prototype.ImagePointY=function(a,b){a.set_float(this.getImagePoint(b,!1))};n.prototype.ImagePointCount=function(a){a.set_int(this.curFrame.image_points.length)};n.prototype.ImageWidth=function(a){a.set_float(this.curFrame.width)};n.prototype.ImageHeight=function(a){a.set_float(this.curFrame.height)};d.exps=new n})();cr.plugins_.Spritefont2=function(a){this.runtime=a};
(function(){function a(a,b,c){if(c){var d;c=0;for(d=b.length;c<d;c++)a.length<p&&a.push(b[c]);b.length=0}else for(d in b)Object.prototype.hasOwnProperty.call(b,d)&&(a.length<p&&a.push(b[d]),delete b[d])}function b(a,b,c){var d=a.lines;c=c.replace(/\s\s*$/,"");b>=d.length&&d.push(f.length?f.pop():{});b=d[b];b.text=c;b.width=a.measureWidth(c);a.textWidth=cr.max(a.textWidth,b.width)}function e(){}function l(){}function g(){}var m=cr.plugins_.Spritefont2.prototype;m.onCreate=function(){};m.Type=function(a){this.plugin=
a;this.runtime=a.runtime};var c=m.Type.prototype;c.onCreate=function(){this.is_family||(this.texture_img=new Image,this.texture_img.idtkLoadDisposed=!0,this.texture_img.src=this.texture_file,this.runtime.waitForImageLoad(this.texture_img),this.webGL_texture=null)};c.onLostWebGLContext=function(){this.is_family||(this.webGL_texture=null)};c.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){this.webGL_texture||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,
!1,this.runtime.linearSampling,this.texture_pixelformat));var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].webGL_texture=this.webGL_texture}};c.unloadTextures=function(){this.is_family||this.instances.length||!this.webGL_texture||(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};c.preloadCanvas2D=function(a){a.drawImage(this.texture_img,0,0)};m.Instance=function(a){this.type=a;this.runtime=a.runtime};c=m.Instance.prototype;c.onDestroy=function(){a(f,
this.lines,!0);a(n,this.clipList,!1);a(d,this.clipUV,!1);cr.wipe(this.characterWidthList)};c.onCreate=function(){this.texture_img=this.type.texture_img;this.characterWidth=this.properties[0];this.characterHeight=this.properties[1];this.characterSet=this.properties[2];this.text=this.properties[3];this.characterScale=this.properties[4];this.visible=0===this.properties[5];this.halign=this.properties[6]/2;this.valign=this.properties[7]/2;this.wrapbyword=0===this.properties[9];this.characterSpacing=this.properties[10];
this.lineHeight=this.properties[11];this.textHeight=this.textWidth=0;this.recycled?(this.lines.length=0,cr.wipe(this.clipList),cr.wipe(this.clipUV),cr.wipe(this.characterWidthList)):(this.lines=[],this.clipList={},this.clipUV={},this.characterWidthList={});this.text_changed=!0;this.lastwrapwidth=this.width;this.runtime.glwrap&&(this.type.webGL_texture||(this.type.webGL_texture=this.runtime.glwrap.loadTexture(this.type.texture_img,!1,this.runtime.linearSampling,this.type.texture_pixelformat)),this.webGL_texture=
this.type.webGL_texture);this.SplitSheet()};c.saveToJSON=function(){var a={t:this.text,csc:this.characterScale,csp:this.characterSpacing,lh:this.lineHeight,tw:this.textWidth,th:this.textHeight,lrt:this.last_render_tick,cw:{}},b;for(b in this.characterWidthList)a.cw[b]=this.characterWidthList[b];return a};c.loadFromJSON=function(a){this.text=a.t;this.characterScale=a.csc;this.characterSpacing=a.csp;this.lineHeight=a.lh;this.textWidth=a.tw;this.textHeight=a.th;this.last_render_tick=a.lrt;for(var b in a.cw)this.characterWidthList[b]=
a.cw[b];this.text_changed=!0;this.lastwrapwidth=this.width};var p=1E3,f=[],n=[],d=[];c.SplitSheet=function(){for(var a=this.texture_img,b=a.width,c=a.height,a=this.characterWidth,f=this.characterHeight,e=a/b,g=f/c,h=this.characterSet,b=Math.floor(b/a),c=Math.floor(c/f),k=0;k<h.length&&!(k>=b*c);k++){var m=k%b,l=Math.floor(k/b),p=h.charAt(k);if(this.runtime.glwrap){var s=this.clipUV,u=m*e,B=l*g,m=(m+1)*e,l=(l+1)*g;void 0===s[p]&&(s[p]=d.length?d.pop():new cr.rect);s[p].left=u;s[p].top=B;s[p].right=
m;s[p].bottom=l}else s=this.clipList,m*=a,l*=f,u=a,B=f,void 0===s[p]&&(s[p]=n.length?n.pop():{}),s[p].x=m,s[p].y=l,s[p].w=u,s[p].h=B}};var u=[];m.TokeniseWords=function(a){u.length=0;for(var b="",c,d=0;d<a.length;)if(c=a.charAt(d),"\n"===c)b.length&&(u.push(b),b=""),u.push("\n"),++d;else if(" "===c||"\t"===c||"-"===c){do b+=a.charAt(d),d++;while(d<a.length&&(" "===a.charAt(d)||"\t"===a.charAt(d)));u.push(b);b=""}else d<a.length&&(b+=c,d++);b.length&&u.push(b)};m.WordWrap=function(b){var c=b.text,
d=b.lines;if(c&&c.length){var e=b.width;if(2>=e)a(f,d,!0);else{var g=b.characterScale,m=b.characterSpacing;if(c.length*(b.characterWidth*g+m)-m<=e&&-1===c.indexOf("\n")&&(m=b.measureWidth(c),m<=e)){a(f,d,!0);d.push(f.length?f.pop():{});d[0].text=c;d[0].width=m;b.textWidth=m;b.textHeight=b.characterHeight*g+b.lineHeight;return}this.WrapText(b);b.textHeight=d.length*(b.characterHeight*g+b.lineHeight)}}else a(f,d,!0)};m.WrapText=function(a){var c=a.wrapbyword,d=a.text,e=a.lines,g=a.width;c&&(this.TokeniseWords(d),
d=u);var m="",h,k,l,n=0,s=!1;for(l=0;l<d.length;l++)"\n"===d[l]?(!0===s?s=!1:(b(a,n,m),n++),m=""):(s=!1,h=m,m+=d[l],k=a.measureWidth(m.replace(/\s\s*$/,"")),k>g&&(""===h?(b(a,n,m),m="",s=!0):(b(a,n,h),m=d[l]),n++,c||" "!==m||(m="")));m.replace(/\s\s*$/,"").length&&(b(a,n,m),n++);for(l=n;l<e.length;l++)f.length<p&&f.push(e[l]);e.length=n};c.measureWidth=function(a){for(var b=this.characterSpacing,c=a.length,d=0,f=0;f<c;f++)d+=this.getCharacterWidth(a.charAt(f))*this.characterScale+b;return d-(0<d?
b:0)};c.getCharacterWidth=function(a){var b=this.characterWidthList;return void 0!==b[a]?b[a]:this.characterWidth};c.rebuildText=function(){if(this.text_changed||this.width!==this.lastwrapwidth)this.textHeight=this.textWidth=0,this.type.plugin.WordWrap(this),this.text_changed=!1,this.lastwrapwidth=this.width};c.draw=function(a,b){var c=this.texture_img;if(""!==this.text&&null!=c&&(this.rebuildText(),!(this.height<this.characterHeight*this.characterScale+this.lineHeight))){a.globalAlpha=this.opacity;
var c=this.x,d=this.y;this.runtime.pixel_rounding&&(c=c+0.5|0,d=d+0.5|0);a.save();a.translate(c,d);a.rotate(this.angle);for(var c=this.halign,d=this.characterScale,f=this.characterHeight*d,e=this.lineHeight,g=this.characterSpacing,k=this.lines,m,l=this.valign*cr.max(0,this.height-this.textHeight),n=-(this.hotspotX*this.width),p=-(this.hotspotY*this.height),l=p+l,s,u,p=0;p<k.length;p++){var C=k[p].text;m=c*cr.max(0,this.width-k[p].width);m=n+m;for(var l=l+e,L=0;L<C.length;L++){var D=C.charAt(L),G=
this.clipList[D];if(m+this.getCharacterWidth(D)*d>this.width+1E-5)break;void 0!==G&&(s=m,u=l,0===this.angle&&(s=Math.round(s),u=Math.round(u)),a.drawImage(this.texture_img,G.x,G.y,G.w,G.h,s,u,G.w*d,G.h*d));m+=this.getCharacterWidth(D)*d+g}l+=f;if(l+f+e>this.height)break}a.restore()}};var s=new cr.quad;c.drawGL=function(a){a.setTexture(this.webGL_texture);a.setOpacity(this.opacity);if(""!==this.text&&(this.rebuildText(),!(this.height<this.characterHeight*this.characterScale+this.lineHeight))){this.update_bbox();
var b=this.bquad,c=0,d=0;this.runtime.pixel_rounding&&(c=(this.x+0.5|0)-this.x,d=(this.y+0.5|0)-this.y);var f=this.angle,e=this.halign,g=this.valign,k=this.characterScale,m=this.characterHeight*k,l=this.lineHeight,n=this.characterSpacing,p=this.lines,u=this.textHeight,B,C;0!==f&&(B=Math.cos(f),C=Math.sin(f));for(var L,g=g*cr.max(0,this.height-u),c=b.tlx+c,b=b.tly+d,d=g,D,G,g=0;g<p.length;g++){u=p[g].text;L=e*cr.max(0,this.width-p[g].width);for(var d=d+l,I=0;I<u.length;I++){var U=u.charAt(I),O=this.clipUV[U];
if(L+this.getCharacterWidth(U)*k>this.width+1E-5)break;if(void 0!==O){var M=this.characterWidth*k,J=this.characterHeight*k;D=L;G=d;0===f&&(D=Math.round(D),G=Math.round(G));s.tlx=D;s.tly=G;s.trx=D+M;s.try_=G;s.blx=D;s.bly=G+J;s.brx=D+M;s.bry=G+J;0!==f&&(D=s,G=B,M=C,J=void 0,J=D.tlx*G-D.tly*M,D.tly=D.tly*G+D.tlx*M,D.tlx=J,J=D.trx*G-D.try_*M,D.try_=D.try_*G+D.trx*M,D.trx=J,J=D.blx*G-D.bly*M,D.bly=D.bly*G+D.blx*M,D.blx=J,J=D.brx*G-D.bry*M,D.bry=D.bry*G+D.brx*M,D.brx=J);s.offset(c,b);a.quadTex(s.tlx,s.tly,
s.trx,s.try_,s.brx,s.bry,s.blx,s.bly,O)}L+=this.getCharacterWidth(U)*k+n}d+=m;if(d+m+l>this.height)break}}};e.prototype.CompareText=function(a,b){return b?this.text==a:cr.equals_nocase(this.text,a)};m.cnds=new e;l.prototype.SetText=function(a){cr.is_number(a)&&1E9>a&&(a=Math.round(1E10*a)/1E10);a=a.toString();this.text!==a&&(this.text=a,this.text_changed=!0,this.runtime.redraw=!0)};l.prototype.AppendText=function(a){cr.is_number(a)&&(a=Math.round(1E10*a)/1E10);if(a=a.toString())this.text+=a,this.text_changed=
!0,this.runtime.redraw=!0};l.prototype.SetScale=function(a){a!==this.characterScale&&(this.characterScale=a,this.text_changed=!0,this.runtime.redraw=!0)};l.prototype.SetCharacterSpacing=function(a){a!==this.CharacterSpacing&&(this.characterSpacing=a,this.text_changed=!0,this.runtime.redraw=!0)};l.prototype.SetLineHeight=function(a){a!==this.lineHeight&&(this.lineHeight=a,this.text_changed=!0,this.runtime.redraw=!0)};c.SetCharWidth=function(a,b){var c=parseInt(b,10);this.characterWidthList[a]!==c&&
(this.characterWidthList[a]=c,this.text_changed=!0,this.runtime.redraw=!0)};l.prototype.SetCharacterWidth=function(a,b){if(""!==a)for(var c=0;c<a.length;c++)this.SetCharWidth(a.charAt(c),b)};l.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};l.prototype.SetHAlign=function(a){this.halign=a/2;this.text_changed=!0;this.runtime.redraw=!0};l.prototype.SetVAlign=function(a){this.valign=a/2;this.text_changed=!0;this.runtime.redraw=
!0};m.acts=new l;g.prototype.CharacterWidth=function(a,b){a.set_int(this.getCharacterWidth(b))};g.prototype.CharacterHeight=function(a){a.set_int(this.characterHeight)};g.prototype.CharacterScale=function(a){a.set_float(this.characterScale)};g.prototype.CharacterSpacing=function(a){a.set_int(this.characterSpacing)};g.prototype.LineHeight=function(a){a.set_int(this.lineHeight)};g.prototype.Text=function(a){a.set_string(this.text)};g.prototype.TextWidth=function(a){this.rebuildText();a.set_float(this.textWidth)};
g.prototype.TextHeight=function(a){this.rebuildText();a.set_float(this.textHeight)};m.exps=new g})();cr.plugins_.Spriter=function(a){this.runtime=a};
(function(){function a(){this.name="";this.animations=[]}function b(){this.name="";this.length=1;this.looping="true";this.loopTo=0;this.mainlineKeys=[];this.timelines=[];this.soundlines=[];this.localTime=this.cur_frame=0}function e(){this.keys=[];this.name="";this.c2Object=0;this.objectType="sprite";this.currentObjectState={};this.currentMappedState={};this.lastTimeSoundCheck=0}function l(){this.bones=[];this.objects=[];this.time=0;this.spin=1;this.curveType="linear";this.c4=this.c3=this.c2=this.c1=
0}function g(){this.type="sprite";this.angle=this.y=this.x=0;this.yScale=this.xScale=this.a=1;this.pivotY=this.pivotX=0;this.defaultPivot=!1;this.storedFrame=this.frame=0}function m(){this.type="sound";this.name="";this.trigger=!0;this.panning=0;this.volume=1}function c(a){if(a){var b=new g;b.type=a.type;b.x=a.x;b.y=a.y;b.angle=a.angle;b.a=a.a;b.xScale=a.xScale;b.yScale=a.yScale;b.pivotX=a.pivotX;b.pivotY=a.pivotY;b.defaultPivot=a.defaultPivot;b.frame=a.frame;b.storedFrame=b.storedFrame;return b}return null}
function p(a,b,c){return a===b?0:(c-a)/(b-a)}function f(a,b,c,d){return cr.lerp(cr.lerp(a,b,d),cr.lerp(b,c,d),d)}function n(a,b,c,d,e){return cr.lerp(f(a,b,c,e),f(b,c,d,e),e)}function d(a,b){switch(a.curveType){case "linear":return b;case "quadratic":return f(0,a.c1,1,b);case "cubic":return n(0,a.c1,a.c2,1,b);case "quartic":return cr.lerp(n(0,a.c1,a.c2,a.c3,b),n(a.c1,a.c2,a.c3,1,b),b);case "quintic":return cr.lerp(cr.lerp(n(a.c1,a.c2,a.c3,a.c4,void 0),n(a.c2,a.c3,a.c4,b,void 0),void 0),cr.lerp(n(a.c2,
a.c3,a.c4,b,void 0),n(a.c3,a.c4,b,void 0,void 0),void 0),void 0);case "bezier":var c=a.c1,d=a.c2,e=0,g=0,h=0,k=0,g=3*c,e=3*(a.c3-c)-g,k=3*d,h=3*(a.c4-d)-k,c=1-g-e,d=g,g=1-k-h;a:{var m,l,q,p;q=b;for(l=0;8>l;l++){p=((c*q+e)*q+d)*q-b;if(0.005>(0<=p?p:0-p)){c=q;break a}m=(3*c*q+2*e)*q+d;if(1E-6>(0<=m?m:0-m))break;q-=p/m}m=0;l=1;q=b;if(q<m)c=m;else if(q>l)c=l;else{for(;m<l;){p=((c*q+e)*q+d)*q;if(0.005>(0<=p-b?p-b:0-(p-b))){c=q;break a}b>p?m=q:l=q;q=0.5*(l-m)+m}c=q}}return((g*c+h)*c+k)*c;case "instant":if(1<=
b)return 1}return 0}function u(a,b,c,d,f,e){f=new g;f.type=a.type;f.x=cr.lerp(a.x,b.x,c);f.y=cr.lerp(a.y,b.y,c);e=a.angle;if(0===d)d=e;else{var h=cr.angleDiff(e,b.angle);d=-1==d?e+h*c:e-h*c}f.angle=d;f.a=cr.lerp(a.a,b.a,c);f.xScale=cr.lerp(a.xScale,b.xScale,c);f.yScale=cr.lerp(a.yScale,b.yScale,c);f.pivotX=a.pivotX;f.pivotY=a.pivotY;f.defaultPivot=a.defaultPivot;f.frame=a.frame;f.storedFrame=a.storedFrame;return f}function s(){this.type="reference";this.key=this.timeline=0;this.parent=-1}function q(){this.files=
[]}function t(){this.fileName="";this.pivotY=this.pivotX=0;this.h=this.w=1}function w(a,b,c){a&&(c&&void 0!==c.appliedMap[b]&&(-1===c.appliedMap[b]?a.visible=!1:b=c.appliedMap[b]),a.changeAnimFrame=b,a.isTicking||(a.runtime.tickMe(a),a.isTicking=!0),a.inAnimTrigger||a.doChangeAnimFrame())}function r(a,b){for(var c=0;c<b.length;c++)if(b[c]==a)return c;return-1}function x(a,b){if(a===b)return 0;for(;-3.141592653589793>b-a;)a-=6.283185307179586;for(;3.141592653589793<b-a;)b-=6.283185307179586;return b>
a?-1:1}function z(a,b,c){for(var d=0;d<b.length;d++){var f=b[d];if(f&&(f.name===a||f.entityName===c&&f.originalName===a))return d}return-1}function h(a,b,c,d){this.name=b;this.fullTypeName=a+"_"+b;this.spriterType="sprite";this.frames=[];this.pivots=[];this.imageSizes=[];this.charMaps=[];this.height=this.width=0;this.entityName=c;this.originalName=d}function k(){}function y(){}function v(){}var H=cr.plugins_.Spriter.prototype;H.Type=function(a){this.plugin=a;this.runtime=a.runtime};H.Type.prototype.onCreate=
function(){this.scmlFiles=[];this.objectArrays=[]};H.Instance=function(a){this.type=a;this.runtime=a.runtime;this.lastData="";this.entity=this.progress=0;this.entities=[];this.secondTime=this.currentAdjustedTime=this.currentSpriterTime=0;this.start_time=cr.performance_now();this.lastKnownTime=this.getNowTime()};var A=H.Instance.prototype;A.setEntitiesToOtherEntities=function(d){for(var f=0,g=0;g<d.length;g++){var h=d[g],k=new a,f=h;k.name=f.name;for(var h=h.animations,m=0;m<h.length;m++){var n=h[m],
f=n,q=new b;q.name=f.name;q.length=f.length;q.looping=f.looping;q.loopTo=f.loop_to;for(var p=n.mainlineKeys,r=new e,t=0;t<p.length;t++){var w=p[t],u=new l,f=w;u.time=f.time;u.curveType=f.curveType;u.c1=f.c1;u.c2=f.c2;u.c3=f.c3;u.c4=f.c4;var x=w.bones;if(x)for(var v=0;v<x.length;v++){var f=x[v],y=new s;y.timeline=f.timeline;y.key=f.key;y.parent=f.parent;u.bones.push(y)}if(w=w.objects)for(v=0;v<w.length;v++)f=w[v],x=new s,x.timeline=f.timeline,x.key=f.key,x.parent=f.parent,u.objects.push(x);q.mainlineKeys.push(u)}q.mainline=
r;if(n=n.timelines)for(r=0;r<n.length;r++){f=p=n[r];x=new e;x.objectType=f.objectType;y=f.name;x.name=y;if(p=p.keys)for(t=0;t<p.length;t++){w=p[t];u=new l;f=w;u.time=f.time;u.spin=f.spin;u.curveType=f.curveType;u.c1=f.c1;u.c2=f.c2;u.c3=f.c3;u.c4=f.c4;if(f=w.objects)for(v=0;v<f.length;v++){var A=c(f[v]);u.objects.push(A)}if(f=w.bones)for(v=0;v<f.length;v++)w=c(f[v]),u.bones.push(w);x.keys.push(u)}x.c2Object=this.c2ObjectArray[z(y,this.objectArray,k.name)];q.timelines.push(x)}k.animations.push(q)}this.entities.push(k);
this.entity&&this.properties[1]!==k.name||(this.entity=k)}};A.getCharacterFromPreload=function(){return this.type.scmlFiles.hasOwnProperty(this.properties[0])?(this.setEntitiesToOtherEntities(this.type.scmlFiles[this.properties[0]]),this.type.objectArrays.hasOwnProperty(this.properties[0])&&(this.objectArray=this.type.objectArrays[this.properties[0]]),this.c2ObjectArray=this.generateTestC2ObjectArray(this.objectArray),this.startingEntName?this.setEntTo(this.startingEntName):this.setEntTo(this.properties[1]),
this.associateAllTypes(),this.initDOMtoPairedObjects(),this.startingAnimName?this.setAnimTo(this.startingAnimName):this.setAnimTo(this.properties[2]),!this.currentAnimation&&this.entity&&this.entity.animations.length&&this.setAnimTo(this.entity.animations[0].name),this.startingLoopType&&this.currentAnimation&&(this.currentAnimation.looping=startingLoopType),!0):!1};A.onCreate=function(){this.nodeStack=[];this.isDestroyed=!1;this.folders=[];this.secondAnimation=this.currentAnimation="";this.blendPoseTime=
this.blendEndTime=this.blendStartTime=this.animBlend=0;this.lastKnownInstDataAsObj=null;this.c2ObjectArray=[];this.objectArray=[];this.animPlaying=!0;this.speedRatio=1;this.scaleRatio=this.width/50;this.yFlip=this.xFlip=!1;this.playTo=-1;this.changeToStartFrom=0;this.runtime.tick2Me(this);this.startingLoopType=this.startingAnimName=this.startingEntName=null;this.pauseWhenOutsideBuffer=this.bottomBuffer=this.topBuffer=this.rightBuffer=this.leftBuffer=0;this.properties[0]=this.properties[0].toLowerCase();
-1<this.properties[0].lastIndexOf(".scml")&&(this.properties[0]=this.properties[0].replace(".scml",".scon"));if(!this.getCharacterFromPreload()){var a=this,b=null,c=function(){},b=new XMLHttpRequest;b.onreadystatechange=function(){4!==b.readyState||a.isDestroyed||400<=b.status||(b.responseText.replace(/\r\n/g,"\n"),a.doRequest(JSON.parse(b.responseText)),a.startingEntName&&a.setEntTo(a.startingEntName),a.startingAnimName&&a.setAnimTo(a.startingAnimName),a.startingLoopType&&a.currentAnimation&&(a.currentAnimation.looping=
a.startingLoopType))};b.onerror=c;b.ontimeout=c;b.onabort=c;b.onprogress=function(a){};b.open("GET",this.properties[0]);b.send()}this.inAnimTrigger=this.force=!1;this.changeAnimTo=null};A.onDestroy=function(){this.isDestroyed=!0};A.isOutsideViewportBox=function(){var a=this.layer;return a&&(this.x<a.viewLeft-this.leftBuffer||this.x>a.viewRight+this.rightBuffer||this.y<a.viewTop-this.topBuffer||this.y>a.viewBottom+this.bottomBuffer)?!0:!1};A.MoveToLayer=function(a,b){b&&b!=a.layer&&(cr.arrayRemove(a.layer.instances,
a.get_zindex()),a.layer.zindices_stale=!0,a.layer=b,a.zindex=b.instances.length,b.instances.push(a),a.runtime.redraw=!0)};A.animationFinish=function(a){this.animTriggerName=this.currentAnimation.name;!1===this.inAnimTrigger&&(this.inAnimTrigger=!0,this.runtime.trigger(cr.plugins_.Spriter.prototype.cnds.OnAnyAnimFinished,this),this.runtime.trigger(cr.plugins_.Spriter.prototype.cnds.OnAnimFinished,this),this.inAnimTrigger=!1)};A.clearAnimationState=function(){var a=this.currentAnimation;if(a)for(var b=
0;b<a.timelines.length;b++)a.timelines[b].currentObjectState={}};A.getNowTime=function(){return(cr.performance_now()-this.start_time)/1E3};A.doAnimChange=function(){if(this.currentAnimation)var a=this.currentSpriterTime/this.currentAnimation.length;var b=this.changeToStartFrom;3>b&&(this.currentAnimation=this.changeAnimTo,this.changeAnimTo=null,0===b?(this.currentSpriterTime=0<this.speedRatio?0:this.currentAnimation.length,this.lastKnownTime=this.getNowTime()):2==b&&(this.currentSpriterTime=this.currentAnimation.length*
a,this.lastKnownTime=this.getNowTime()))};A.endBlendAndSwap=function(){this.secondAnimation&&(this.blendPoseTime=this.animBlend=this.blendStartTime=this.blendEndTime=0,this.changeToStartFrom===E&&(this.currentSpriterTime=0),this.currentSpriterTime=this.secondAnimation.localTime,this.changeAnimTo=null,this.currentAnimation=this.secondAnimation,this.secondAnimation=null,this.changeToStartFrom=1)};A.tickCurrentAnimationTime=function(){var a=this.lastKnownTime,b=this.getNowTime();this.lastKnownTime=b;
var c=this.currentSpriterTime,d=this.runtime.timescale,f=this.currentAnimation;-1!==this.my_timescale&&(d=this.my_timescale);this.animPlaying&&(this.currentSpriterTime+=1E3*(this.getNowTime()-a)*this.speedRatio*d);d=this.playTo;a=!1;0<=d?this.animPlaying&&0>(c-d)*(this.currentSpriterTime-d)&&(this.animPlaying=!1,this.currentSpriterTime=this.playTo,this.playTo=-1,a=!0):0<=this.speedRatio?this.currentSpriterTime>=f.length&&(this.changeToStartFrom===E&&this.secondAnimation&&0<this.blendEndTime?this.endBlendAndSwap():
("false"==f.looping&&(this.currentSpriterTime=f.length,this.animPlaying=!1),a=!0)):0>this.speedRatio&&0>this.currentSpriterTime&&(this.changeToStartFrom===E&&this.secondAnimation&&0<this.blendEndTime?this.endBlendAndSwap():("false"==f.looping&&(this.currentSpriterTime=0,this.animPlaying=!1),a=!0));for(f=this.currentAnimation;0>this.currentSpriterTime;)this.currentSpriterTime+=f.length;this.currentSpriterTime!==f.length&&(this.currentSpriterTime%=f.length);this.secondAnimation&&(this.secondAnimation.localTime=
this.changeToStartFrom===E?0:cr.lerp(0,this.secondAnimation.length,p(0,this.currentAnimation.length,this.currentSpriterTime)));c=this.blendEndTime;0<c&&(c<=b?this.endBlendAndSwap():this.animBlend=p(this.blendStartTime,c,this.lastKnownTime));return a};A.setMainlineKeyByTime=function(a){if(a="undefined"!==typeof a?a:this.currentAnimation){var b=0,b=a===this.currentAnimation?this.changeToStartFrom===E?this.blendPoseTime:this.currentSpriterTime:a.localTime,c=a.mainlineKeys;a.cur_frame=c.length;for(var f=
a.length,e=1;e<c.length;e++)if(b<c[e].time){f=c[e].time;a.cur_frame=e-1;break}e=0;a===this.currentAnimation&&(this.currentAdjustedTime=b);0>a.cur_frame?a.cur_frame=0:a.cur_frame>=a.mainlineKeys.length&&(a.cur_frame=a.mainlineKeys.length-1);if(b=c[a.cur_frame])e=b.time,a===this.currentAnimation?(c=p(e,f,this.currentSpriterTime),this.currentAdjustedTime=cr.lerp(e,f,d(b,c))):(c=p(e,f,a.localTime),a.localTime=this.changeToStartFrom===E?0:cr.lerp(e,f,d(b,c)))}};A.doSecondAnimation=function(){return 0!==
this.animBlend&&this.secondAnimation};A.currentTweenedBones=function(a){var b=[];a="undefined"!==typeof a?a:this.currentAnimation;for(var f=a.mainlineKeys[a.cur_frame],e=0,g=0,g=a===this.currentAnimation?this.changeToStartFrom===E?this.blendPoseTime:this.currentAdjustedTime:a.localTime,h=0;h<f.bones.length;h++){var k=f.bones[h],m=null,l=null,n=k.parent;if("reference"==k.type){var q=a.timelines[k.timeline],p=q.keys[k.key],l=k.key,s=p.time,r=q.keys.length,k=p.bones[0];1<r&&(l+1>=r&&"true"==a.looping?
(l=q.keys[0],e=l.time,g>s&&(e+=a.length),m=l.bones[0]):l+1<r&&(l=q.keys[l+1],e=l.time,m=l.bones[0]));var l=1==this.xFlip?-1:1,r=1==this.yFlip?-1:1,t=1,w="";if(m&&"instant"!==f.curveType&&"instant"!==p.curveType){var s=p.time,v=0;g<s&&(s-=a.length);e>s&&(v=(g-s)/(e-s));v=d(p,v);b[h]=u(k,m,v,p.spin)}else b[h]=c(k);q.currentMappedState=c(b[h]);a===this.currentAnimation&&0!==this.animBlend&&this.secondAnimation&&(k=this.timelineFromName(q.name,this.secondAnimation))&&(k=k.currentObjectState)&&(m=b[h],
b[h]=u(m,k,this.animBlend,x(m.angle,k.angle)));-1<n?(a===this.currentAnimation&&(t=b[n].xScale*b[n].yScale),w=b[n]):a===this.currentAnimation&&(b[h].x=b[h].x*l*this.scaleRatio,b[h].y=b[h].y*r*this.scaleRatio,b[h].xScale=b[h].xScale*l*this.scaleRatio,b[h].yScale=b[h].yScale*r*this.scaleRatio,w=this.objFromInst(this),t=l*r);a===this.currentAnimation&&(b[h]=this.mapObjToObj(w,b[h],t));q.currentObjectState=c(b[h])}}return b};A.tick=function(){};A.tick2=function(a){this.secondAnimation===this.currentAnimation&&
(this.blendPoseTime=this.blendEndTime=this.blendStartTime=0,this.secondAnimation=null,this.changeAnimTo=0,this.changeToStartFrom===E?this.changeToStartFrom=0:this.changeToStartFrom===B&&(this.changeToStartFrom=1));this.changeAnimTo&&!this.inAnimTrigger&&this.doAnimChange();var b=this.currentAnimation;if(b&&!this.inAnimTrigger){b=null;this.animPlaying||this.lastKnownInstDataAsObj&&this.instsEqual(this.lastKnownInstDataAsObj,this)||(b=!0,this.lastKnownInstDataAsObj=this.objFromInst(this));!b&&this.force&&
(b=!0);var c=this.force=!1,d=!1;0!=this.pauseWhenOutsideBuffer&&this.isOutsideViewportBox()&&(1==this.pauseWhenOutsideBuffer?d=!0:2==this.pauseWhenOutsideBuffer&&(c=!0),this.setAllInvisible());if(this.animPlaying||b||a){if(this.animPlaying&&!a&&this.tickCurrentAnimationTime()&&(this.animationFinish(0>this.speedRatio),this.changeAnimTo&&!this.inAnimTrigger&&!this.animPlaying)){this.tick2();return}d||(b=this.currentAnimation,this.setAllCollisionsAndVisibility(!1),this.setMainlineKeyByTime(),this.runtime.redraw=
!0,b.mainlineKeys[b.cur_frame]&&(c||(0!==this.animBlend&&this.secondAnimation&&(this.secondAnimation.localTime=this.changeToStartFrom===E?0:this.currentSpriterTime/this.currentAnimation.length*this.secondAnimation.length,this.setMainlineKeyByTime(this.secondAnimation),a=this.currentTweenedBones(this.secondAnimation),this.animateCharacter(a,this.secondAnimation,!1)),a=this.currentTweenedBones(),this.animateCharacter(a)),this.animPlaying&&this.animateSounds()))}}};A.animateCharacter=function(a,b,f){if(b=
"undefined"!==typeof b?b:this.currentAnimation){var e,g,h=null,k=0,m=0,l=this.layer,n=r(this,l.instances);f="undefined"!==typeof applyToInstance?f:!0;var q=b.mainlineKeys[b.cur_frame],p,l=l.instances;this.clearAnimationState();var s=0,s=b===this.currentAnimation?this.changeToStartFrom===E?this.blendPoseTime:this.currentAdjustedTime:b.localTime;if(f){for(var t=0;t<q.objects.length;t++)if(e=q.objects[t],"reference"==e.type){var v=b.timelines[e.timeline],z=v.c2Object;if(z){var y=z.inst;if(y){var A=r(y,
l);1<=A&&A<=n&&(l.splice(A,1),n--)}}}t=r(this,l);n!=t&&(l.splice(t,1),l.splice(n,0,this))}for(t=A=0;t<q.objects.length;t++)if(e=q.objects[t],g=q.objects[t],y=h=null,"reference"==e.type&&(v=b.timelines[e.timeline],p=v.keys[e.key],y=e.key,k=p.time,z=v.keys.length,e=p.objects[0],1<z&&(y+1>=z&&"true"==b.looping?(y=v.keys[0],m=y.time,s>k&&(m+=b.length),h=y.objects[0]):y+1<z&&(y=v.keys[y+1],m=y.time,h=y.objects[0]))),(z=v.c2Object)||"point"===v.objectType)if((y=z?z.inst:null)||"point"===v.objectType){f&&
y&&(y.collisionsEnabled=!0,y.visible=this.visible,this.MoveToLayer(y,this.layer));f&&z&&"sprite"==z.spriterType&&w(y,e.frame,z);var B=null;h&&"instant"!==q.curveType&&"instant"!==p.curveType?(B=0,s<k&&(k-=b.length),0<m-k&&(B=(s-k)/(m-k)),B=d(p,B),B=u(e,h,B,p.spin)):B=c(e);e=1==this.xFlip?-1:1;h=1==this.yFlip?-1:1;g=g.parent;v.currentMappedState=c(B);if(b===this.currentAnimation&&0!==this.animBlend&&this.secondAnimation){var H=this.timelineFromName(v.name,this.secondAnimation);if(H){var X=H.currentObjectState;
X&&(0.5<this.animBlend&&w(y,H.currentObjectState.frame,z),B=u(B,X,this.animBlend,x(B.angle,X.angle)))}}b===this.currentAnimation&&(-1<g?(B=this.mapObjToObj(a[g],B,a[g].xScale*a[g].yScale),B.xScale*=e,B.yScale*=h):(B.x=B.x*e*this.scaleRatio,B.y=B.y*h*this.scaleRatio,B=this.mapObjToObj(this.objFromInst(this),B,e*h)));y&&f&&this.applyObjToInst(B,y,-1<g,z);v.currentObjectState=B;y&&f&&(z=n+1+A++,l[z]!==y&&(g=r(y,l),0<=g&&l.splice(g,1),l.splice(z,0,y)))}}};A.animateSounds=function(a){if(a="undefined"!==
typeof a?a:this.currentAnimation)for(var b=0;b<a.soundlines.length;b++){var c=a.soundlines[b];c&&this.animateSound(c,a.length)}};A.animateSound=function(a,b,c){var f=a.keys,e=f.length;b=f[0];for(var g,h=1;h<f.length;h++)if(this.currentAdjustedTime<f[h].time){e=h-1;b=f[e];break}b&&b.objects&&b.objects[0]&&(g=b.objects[0]);c="undefined"!==typeof c?c:this.currentAnimation;var h=a.keys.length,k,l;1<h&&(e+1>=h&&"true"==c.looping?(k=a.keys[0],l=k.time,this.currentSpriterTime>q&&(l+=c.length),k=k.objects[0]):
e+1<h&&(k=a.keys[e+1],l=k.time,k=k.objects[0]));for(var n=this.currentAdjustedTime,q=a.lastTimeSoundCheck,h=0;h<f.length;h++){var s=f[h];if(s){var t=s.objects[0];if(t){if(n===s.time){this.playSound(a,t.name);break}e=-1;if(0<n-q&&n-q<q+(c.length-n)||q-n>n+(c.length-q))e=0<n-q&&n-q<q+(c.length-n)?p(q,n,s.time):p(q-c.length,n,s.time);else if(0>n-q||q-n<n+(c.length-q))e=0>n-q?p(n,q,s.time):p(n-c.length,q,s.time);0<e&&1>e&&this.playSound(a,t.name)}}}k?(q=b.time,this.currentAdjustedTime<q&&(q-=c.length),
e=p(q,l,this.currentAdjustedTime),c=g,g=k,b=d(b,e),l=new m,l.trigger=c.trigger,l.volume=cr.lerp(c.volume,g.volume,b),l.panning=cr.lerp(c.panning,g.panning,b),l.name=c.name,b=l):b=this.cloneSound(g);this.changeVolume(a,b.volume);this.changePanning(a,b.panning);a.lastTimeSoundCheck=this.currentAdjustedTime;a.currentObjectState=b};A.draw=function(a){};A.drawGL=function(a){};A.playSound=function(a,b){this.soundToTrigger=b;this.soundLineToTrigger=a;this.runtime.trigger(cr.plugins_.Spriter.prototype.cnds.OnSoundTriggered,
this)};A.changeVolume=function(a,b){a.currentObjectState.volume!=b&&(a.currentObjectState.volume=b,this.soundToTrigger="",this.soundLineToTrigger=a,this.runtime.trigger(cr.plugins_.Spriter.prototype.cnds.OnSoundVolumeChangeTriggered,this))};A.changePanning=function(a,b){a.currentObjectState.panning!=b&&(a.currentObjectState.panning=b,this.soundToTrigger="",this.soundLineToTrigger=a,this.runtime.trigger(cr.plugins_.Spriter.prototype.cnds.OnSoundPanningChangeTriggered,this))};A.timelineFromName=function(a,
b){if(b="undefined"!==typeof b?b:this.currentAnimation)for(var c=0;c<b.timelines.length;c++){var d=b.timelines[c];if(d&&d.name===a)return d}};A.findSprites=function(a){if(a){for(var b=this.type.name,c,d=a.folder,f=0;f<d.length;f++){var e=d[f];this.folders.push(new q);for(var e=e.file,g=0;g<e.length;g++){var k=e[g];c=k;var m=new t;m.fileName=c.name;k.hasOwnProperty("pivot_x")&&(m.pivotX=c.pivot_x);k.hasOwnProperty("pivot_y")&&(m.pivotY=1-c.pivot_y);k.hasOwnProperty("width")&&(m.w=c.width);k.hasOwnProperty("height")&&
(m.h=c.height);this.folders[f].files.push(m)}}d=[];a=a.entity;for(f=0;f<a.length;f++)if(c=k=a[f],e=k.obj_info,k=k.character_map,c=c.name,e)for(m=0;m<e.length;m++)if((g=e[m])&&("sprite"===g.type||"box"===g.type)){d.push(new h(b,g.name,c,g.realname));var l=d[d.length-1];if("box"===g.type){l.width=g.w;l.height=g.h;l.isBox=!0;l.spriterType="box";var n={};n.w=l.width;n.h=l.height;l.imageSizes.push(n)}else if("sprite"===g.type){var p=g.frames;if(p)for(g=0;g<p.length;g++){var s=p[g];this.folders[s.folder]&&
this.folders[s.folder].files[s.file]&&(l.frames.push(this.folders[s.folder].files[s.file].fileName),n={x:0,y:0},n.x=this.folders[s.folder].files[s.file].pivotX,n.y=this.folders[s.folder].files[s.file].pivotY,l.pivots.push(n),n={w:1,h:1},n.w=this.folders[s.folder].files[s.file].w,n.h=this.folders[s.folder].files[s.file].h,l.imageSizes.push(n))}if(k)for(g=0;g<k.length;g++)if(p=k[g],s=p.map)for(n=0;n<s.length;n++){var r=s[n];if("undefined"!==typeof r.folder&&"undefined"!==typeof r.file&&this.folders[r.folder]&&
this.folders[r.folder].files[r.file]){var w={};w.oldFrame=l.frames.indexOf(this.folders[r.folder].files[r.file].fileName);-1<w.oldFrame&&(w.newFrame=-1,"undefined"!==typeof r.target_folder&&"undefined"!==typeof r.target_file&&(w.newFrame=l.frames.indexOf(this.folders[r.target_folder].files[r.target_file].fileName)),l.charMaps[p.name]||(l.charMaps[p.name]=[]),l.charMaps[p.name].push(w))}}}}return d}};A.generateTestC2ObjectArray=function(a){var b=[],c=this.runtime.types,d;for(d in a){var f={};f.type=
c[a[d].fullTypeName];f.spriterType=a[d].spriterType;f.inst=null;f.appliedMap=[];f.obj=a[d];b.push(f)}return b};A.cloneSound=function(a){var b=new m;b.trigger=a.trigger;b.volume=a.volume;b.panning=a.panning;b.name=a.name;return b};A.cloneObject=function(a){var b=new g;b.type=a.type;b.frame=a.frame;b.storedFrame=a.storedFrame;b.x=a.x;b.y=-a.y;b.angle=a.angle;b.a=a.a;b.angle=a.angle;b.xScale=a.xScale;b.yScale=a.yScale;b.pivotX=a.pivotX;b.pivotY=a.pivotY;b.defaultPivot=a.defaultPivot;return b};A.objectFromTag=
function(a,b,c,d,f){var e=-0,h=null,k=new g;k.type=d;"sprite"===d&&(e=a.folder,h=a.file,m=this.folders[e].files[h],b=b[z(c,b,f)],k.frame=b.frames.indexOf(m.fileName),k.storedFrame=k.frame);a.hasOwnProperty("x")&&(k.x=a.x);a.hasOwnProperty("y")&&(k.y=-a.y);a.hasOwnProperty("angle")&&(k.angle=a.angle);a.hasOwnProperty("a")&&(k.a=a.a);k.angle=360-k.angle;k.angle/=360;0.5<k.angle&&(k.angle-=1);k.angle*=6.283185307179586;a.hasOwnProperty("scale_x")&&(k.xScale=a.scale_x);a.hasOwnProperty("scale_y")&&(k.yScale=
a.scale_y);if(a.hasOwnProperty("pivot_x"))k.pivotX=a.pivot_x;else if("sprite"===d&&(m=this.folders,m=m[e],k.defaultPivot=!0,m)){var m=m.files[h];m&&(k.pivotX=m.pivotX)}a.hasOwnProperty("pivot_y")?k.pivotY=1-a.pivot_y:"sprite"===d&&(m=this.folders,m=m[e],k.defaultPivot=!0,m&&(m=m.files[h]))&&(k.pivotY=m.pivotY);return k};A.soundFromTag=function(a){var b=new m;if(void 0!==a.folder&&void 0!==a.file){var c=this.folders[a.folder].files[a.file];c&&(b.name=c.fileName,b.name=b.name.substr(0,b.name.lastIndexOf(".")))}a.hasOwnProperty("trigger")&&
(b.trigger=a.trigger);a.hasOwnProperty("panning")&&(b.panning=a.panning);a.hasOwnProperty("volume")&&(b.volume=a.volume);return b};A.initDOMtoPairedObjects=function(){for(var a=this.entities,b=0;b<a.length;b++){var c=a[b];if(c){var d=c.animations;if(d)for(var f=0;f<d.length;f++){var e=d[f];if(e&&(e=e.timelines))for(var g=0;g<e.length;g++){var h=e[g];h&&(h.c2Object=this.c2ObjectArray[z(h.name,this.objectArray,c.name)])}}}}};A.associateAllTypes=function(){var a=this.c2ObjectArray,b=this.objectArray,
c;for(c in b){var d=b[c],f=this.siblings;if(0<f.length)for(var e=0;e<f.length;e++){var g=f[e];if(g){var h=g.type;if(h.name===d.fullTypeName){f=a[c];f.type=h;h=g;f.inst=h;h=this.entity.animations;d=d.name;for(g=0;g<h.length;g++)for(var e=h[g].timelines,k=0;k<e.length;k++){var m=e[k];d==m.name&&(m.c2Object=f)}break}}}else{d=b[c];f=a[c];if(h=f.type)d.fullTypeName=h.name,f.type=h,a=this.get_iid(),h=h.instances[a],f.inst=h;break}}};A.loadSCML=function(c){this.objectArray=this.findSprites(c);this.type.objectArrays[this.properties[0]]||
(this.type.objectArrays[this.properties[0]]=this.objectArray);this.c2ObjectArray=this.generateTestC2ObjectArray(this.objectArray);var d;c=c.entity;for(var f=0;f<c.length;f++){var g=c[f],h=new a;d=g;h.name=d.name;for(var g=g.animation,k=0;k<g.length;k++){var m=g[k];d=m;var n=new b;n.name=d.name;n.length=d.length;m.hasOwnProperty("looping")&&(n.looping=d.looping);m.hasOwnProperty("loop_to")&&(n.loopTo=d.loop_to);for(var q=m.mainline,p=new e,q=q.key,r=0;r<q.length;r++){var t=q[r],w=new l;d=t;t.hasOwnProperty("time")&&
(w.time=d.time);t.hasOwnProperty("curve_type")&&(w.curveType=d.curve_type);t.hasOwnProperty("c1")&&(w.c1=d.c1);t.hasOwnProperty("c2")&&(w.c2=d.c2);t.hasOwnProperty("c3")&&(w.c3=d.c3);t.hasOwnProperty("c4")&&(w.c4=d.c4);var u=t.bone_ref;if(u)for(var x=0;x<u.length;x++){var v=u[x];d=v;var y=new s;y.timeline=d.timeline;y.key=d.key;v.hasOwnProperty("parent")&&(y.parent=d.parent);w.bones.push(y)}if(t=t.object_ref)for(x=0;x<t.length;x++)d=u=t[x],v=new s,v.timeline=d.timeline,v.key=d.key,u.hasOwnProperty("parent")&&
(v.parent=d.parent),w.objects.push(v);n.mainlineKeys.push(w)}n.mainline=p;if(p=m.timeline)for(x=0;x<p.length;x++){d=q=p[x];u=new e;q.hasOwnProperty("object_type")&&(u.objectType=d.object_type);v=d.name;u.name=v;if(q=q.key)for(r=0;r<q.length;r++){t=q[r];w=new l;d=t;t.hasOwnProperty("time")&&(w.time=d.time);t.hasOwnProperty("spin")&&(w.spin=d.spin);t.hasOwnProperty("curve_type")&&(w.curveType=d.curve_type);t.hasOwnProperty("c1")&&(w.c1=d.c1);t.hasOwnProperty("c2")&&(w.c2=d.c2);t.hasOwnProperty("c3")&&
(w.c3=d.c3);t.hasOwnProperty("c4")&&(w.c4=d.c4);if(d=t.object)d=this.objectFromTag(d,this.objectArray,v,u.objectType,h.name),w.objects.push(d);if(d=t.bone)d=this.objectFromTag(d,this.objectArray,v,u.objectType,h.name),w.bones.push(d);u.keys.push(w)}u.c2Object=this.c2ObjectArray[z(v,this.objectArray,h.name)];n.timelines.push(u)}if(p=m.soundline)for(x=0;x<p.length;x++){d=q=p[x];u=new e;u.objectType="sound";v=d.name;u.name=v;if(q=q.key)for(r=0;r<q.length;r++){t=q[r];w=new l;d=t;t.hasOwnProperty("time")&&
(w.time=d.time);t.hasOwnProperty("spin")&&(w.spin=d.spin);t.hasOwnProperty("curve_type")&&(w.curveType=d.curve_type);t.hasOwnProperty("c1")&&(w.c1=d.c1);t.hasOwnProperty("c2")&&(w.c2=d.c2);t.hasOwnProperty("c3")&&(w.c3=d.c3);t.hasOwnProperty("c4")&&(w.c4=d.c4);if(m=t.object)m=this.soundFromTag(m),w.objects.push(m);u.keys.push(w)}n.soundlines.push(u)}h.animations.push(n)}this.entities.push(h);this.entity&&this.properties[1]!==h.name||(this.entity=h)}};A.doRequest=function(a,b,c){try{this.loadSCML(a),
this.type.scmlFiles[this.properties[0]]=this.entities,this.runtime.trigger(cr.plugins_.Spriter.prototype.cnds.readyForSetup,this),this.setAnimTo(this.properties[2],!0),!this.currentAnimation&&this.entity&&this.entity.animations.length&&this.setAnimTo(this.entity.animations[0].name,!0)}catch(d){}};A.getAnimFromEntity=function(a){for(var b in this.entity.animations)if(this.entity.animations[b].name==a)return this.entity.animations[b]};A.mapObjToObj=function(a,b,c){var d=new g;d.xScale=b.xScale*a.xScale;
d.yScale=b.yScale*a.yScale;d.angle=0>c?6.283185307179586-b.angle+a.angle:b.angle+a.angle;c=b.x*a.xScale;var f=b.y*a.yScale,e=a.angle,h=0,k=1;0!=e&&(h=Math.sin(e),k=Math.cos(e));d.a=a.a*b.a;d.pivotX=b.pivotX;d.pivotY=b.pivotY;d.defaultPivot=b.defaultPivot;d.x=c*k-f*h+a.x;d.y=c*h+f*k+a.y;return d};A.instsEqual=function(a,b){return a.x==b.x&&a.y==b.y&&a.a==b.opacity&&a.angle==b.angle};A.objFromInst=function(a){var b=new g;b.pivotX=a.hotspotX;b.pivotY=a.hotspotY;b.defaultPivot=!1;b.x=a.x;b.y=a.y;b.a=
a.opacity;b.angle=a.angle;b.frame=a.curFrame;b.storedFrame=a.storedFrame;return b};A.currentFrame=function(){return this.currentAnimation?this.currentAnimation.cur_frame:0};A.applyPivotToInst=function(a,b,c,d,f){b=-1*b*d;c=-1*c*f;f=a.angle;d=0;var e=1;0!=f&&(d=Math.sin(f),e=Math.cos(f));a.x=b*e-c*d+a.x;a.y=b*d+c*e+a.y};A.applyObjToInst=function(a,b,c,d){b.angle=a.angle;b.opacity=a.a;b.hotspotX=0;b.hotspotY=0;b.x=a.x;b.y=a.y;var f=b.width,e=b.height;d.obj.imageSizes&&d.obj.imageSizes.length>b.cur_frame&&
(f=d.obj.imageSizes[b.cur_frame].w,e=d.obj.imageSizes[b.cur_frame].h);f=(c?1:this.scaleRatio)*f*a.xScale*(1==this.xFlip?-1:1);c=(c?1:this.scaleRatio)*e*a.yScale*(1==this.yFlip?-1:1);if(b.width!==f||b.height!==c)b.width=f,b.height=c;var e=a.pivotX,g=a.pivotY;a.defaultPivot&&(e=d.obj.pivots[b.cur_frame].x,g=d.obj.pivots[b.cur_frame].y);this.applyPivotToInst(b,e,g,f,c);b.set_bbox_changed()};A.setEntTo=function(a){var b=this.entities,c;for(c in b){var d=b[c];d&&a==d.name&&(this.entity=d)}!this.entity&&
this.entities.length&&(this.entity=b[0]);this.entity||(this.startingEntName=a)};A.setAllCollisionsAndVisibility=function(a){var b=this.c2ObjectArray;if(b)for(var c=0;c<b.length;c++){var d=b[c],f=d.inst;!f&&d.obj&&0<d.obj.frames.length&&(this.associateAllTypes(),f=d.inst);f&&(f.collisionsEnabled=a,f.visible=a)}};A.setAllInvisible=function(){var a=this.c2ObjectArray;if(a)for(var b=0;b<a.length;b++){var c=a[b],d=c.inst;d||(this.associateAllTypes(),d=c.inst);d&&(d.visible=!1)}};A.setAnimTo=function(a,
b){b="undefined"!==typeof b?b:!0;this.playTo=-1;this.changeAnimTo=this.getAnimFromEntity(a);this.changeAnimTo||this.currentAnimation||!this.entity||(this.changeAnimTo=this.entity.animations[0]);this.changeAnimTo||(this.startingAnimName=a,this.blendEndTime=this.blendStartTime=this.changeToStartFrom=0,this.secondAnimation=null,this.blendPoseTime=0);this.currentAnimation&&(this.animPlaying=!0);this.setAllCollisionsAndVisibility(!1);this.runtime.tick2Me(this);b&&this.tick2()};A.soundlineFromName=function(a){if(this.soundLineToTrigger&&
this.soundLineToTrigger.name===a)return this.soundLineToTrigger;var b=this.currentAnimation;if(b)for(var c=0;c<b.soundlines.length;c++){var d=b.soundlines[c];if(d&&d.name===a)return d}};k.prototype.readyForSetup=function(){return!0};k.prototype.outsidePaddedViewport=function(){return this.isOutsideViewportBox()};k.prototype.actionPointExists=function(a){return(a=this.timelineFromName(name))&&a.currentObjectState&&void 0!==a.currentObjectState.x?!0:!1};k.prototype.OnAnimFinished=function(a){return this.currentAnimation.name.toLowerCase()===
a.toLowerCase()};k.prototype.OnSoundTriggered=function(){return!0};k.prototype.OnSoundVolumeChangeTriggered=function(){return!0};k.prototype.OnSoundPanningChangeTriggered=function(){return!0};k.prototype.OnAnyAnimFinished=function(){return!0};k.prototype.CompareCurrentKey=function(a,b){return cr.do_cmp(this.currentFrame(),a,b)};k.prototype.CompareCurrentTime=function(a,b,c){return 0===c?cr.do_cmp(this.currentSpriterTime,a,b):this.currentAnimation?cr.do_cmp(this.currentSpriterTime/this.currentAnimation.length,
a,b):!1};k.prototype.CompareAnimation=function(a){var b=this.secondAnimation;return b&&b.name===a&&0<this.blendEndTime?!0:(b=this.currentAnimation)&&b.name===a?!0:!1};k.prototype.AnimationPaused=function(){return!this.animPlaying};k.prototype.AnimationLooping=function(){var a=this.currentAnimation;return a&&"true"===a.looping?!0:!1};k.prototype.isMirrored=function(){return this.xFlip};k.prototype.isFlipped=function(){return this.yFlip};H.cnds=new k;y.prototype.setPlaybackSpeedRatio=function(a){this.speedRatio=
a};y.prototype.setVisible=function(a){this.visible=1===a?!0:!1};y.prototype.setAutomaticPausing=function(a,b,c,d,f){this.pauseWhenOutsideBuffer=a;this.leftBuffer=b;this.rightBuffer=c;this.topBuffer=d;this.bottomBuffer=f};y.prototype.setObjectScaleRatio=function(a,b,c){this.scaleRatio=a;this.xFlip=b;this.yFlip=c};y.prototype.setObjectXFlip=function(a){this.xFlip=a};y.prototype.setObjectYFlip=function(a){this.yFlip=a};var E=3,B=4;y.prototype.setAnim=function(a,b,c){if(1!=b&&2!=b||!this.currentAnimation||
a!=this.currentAnimation.name){if(2<b&&0<c){var d=this.getAnimFromEntity(a);if(d===this.secondAnimation&&0<this.blendEndTime)return;if(d===this.currentAnimation)if(this.secondAnimation)this.currentAnimation=this.secondAnimation,this.animBlend=1-this.animBlend;else{this.blendPoseTime=this.blendEndTime=this.blendStartTime=0;this.secondAnimation=null;this.animBlend=0;this.changeAnimTo=null;return}else this.animBlend=0;this.secondAnimation=d;this.blendStartTime=this.getNowTime();this.blendPoseTime=0;
b===E&&"false"===this.currentAnimation.looping&&(c=Math.min(c,this.currentAnimation.length-this.currentSpriterTime));this.blendEndTime=this.blendStartTime+c/1E3/this.runtime.timescale}else 0>=c&&(b===B?b=2:b==E&&(b=0)),this.blendPoseTime=this.blendEndTime=this.blendStartTime=0,this.secondAnimation=null;this.changeToStartFrom=b;b===E&&this.secondAnimation&&(this.blendPoseTime=this.currentSpriterTime,this.secondAnimation.localTime=0,this.setMainlineKeyByTime(this.secondAnimation),b=this.currentTweenedBones(this.secondAnimation),
this.animateCharacter(b,this.secondAnimation,!1));this.setAnimTo(a,!1);a=this.animPlaying;this.animPlaying=!1;this.tick2(!0);this.animPlaying=a}};y.prototype.setSecondAnim=function(a){this.secondAnimation=this.getAnimFromEntity(a);this.secondAnimation===this.currentAnimation&&(this.secondAnimation=null)};y.prototype.stopSecondAnim=function(a){this.secondAnimation=null;this.animBlend=0};y.prototype.setAnimBlendRatio=function(a){this.animBlend=a};y.prototype.setEnt=function(a,b){var c=b;this.entity&&
this.currentAnimation&&this.entity.name==a&&this.currentAnimation.name==b||(""===a||this.entity&&a==this.entity.name||this.setEntTo(a),this.currentAnimation&&""===c&&(c=this.currentAnimation.name),this.setAnimTo(c))};y.prototype.playAnimTo=function(a,b){if(0===a){var c=this.currentAnimation.mainlineKeys;if(c)if(c=c[b])this.playTo=c.time;else{this.playTo=-1;return}}else 1==a?this.playTo=b:2==a&&(this.playTo=b*this.currentAnimation.length);if(this.playTo==this.currentSpriterTime)this.playTo=-1;else{c=
1;if("true"==this.currentAnimation.looping){var d=0,f=0;this.playTo>this.currentSpriterTime?(d=this.playTo-this.currentSpriterTime,f=this.currentAnimation.length-this.playTo+this.currentSpriterTime):(d=this.playTo+(this.currentAnimation.length-this.currentSpriterTime),f=this.currentSpriterTime-this.playTo);f<d&&(c=-1)}else this.playTo<this.currentSpriterTime&&(c=-1);this.speedRatio=Math.abs(this.speedRatio)*c;this.animPlaying=!0;this.tick2()}};y.prototype.associateTypeWithName=function(a,b){var c=
this.c2ObjectArray,d=this.objectArray,f;for(f in d){var e=d[f];if(e.entityName+"_"+b==e.name){e.fullTypeName=a.name;c=c[f];c.type=a;d=this.get_iid();c.inst=a.instances[d];var d=this.entity.animations,g;for(g in d){f=d[g].timelines;for(var h in f)e=f[h],b==e.name&&(e.c2Object=c)}break}}};y.prototype.setAnimationLoop=function(a){var b=this.currentAnimation;b?0===a?b.looping="false":1==a&&(b.looping="true"):0===a?this.startingLoopType="false":1==a&&(this.startingLoopType="true")};y.prototype.setAnimationTime=
function(a,b){var c=this.currentAnimation,d=this.currentSpriterTime;c&&(0===a?this.currentSpriterTime=b:1==a&&(this.currentSpriterTime=b*c.length));d!=this.currentSpriterTime&&(this.force=!0)};y.prototype.pauseAnimation=function(){this.animPlaying=!1};y.prototype.resumeAnimation=function(){this.animPlaying=!0;var a=this.currentAnimation;a&&(0<this.speedRatio?this.currentSpriterTime==a.length&&(this.currentSpriterTime=0):0===this.currentSpriterTime&&(this.currentSpriterTime=this.currentAnimation.length))};
y.prototype.removeAllCharMaps=function(){for(var a=this.c2ObjectArray,b=0;b<a.length;b++)a[b].appliedMap=[];this.tick2(!0)};y.prototype.appendCharMap=function(a){for(var b=this.c2ObjectArray,c=0;c<b.length;c++){var d=b[c];if(d&&d.obj){var f=d.obj.charMaps[a];if(f)for(var e=0;e<f.length;e++){var g=f[e];g&&(d.appliedMap[g.oldFrame]=g.newFrame)}}}this.tick2(!0)};H.acts=new y;v.prototype.time=function(a){a.set_int(this.currentSpriterTime)};v.prototype.pointX=function(a,b){var c=this.timelineFromName(b);
c&&c.currentObjectState&&void 0!==c.currentObjectState.x?a.set_float(c.currentObjectState.x):a.set_float(0)};v.prototype.pointY=function(a,b){var c=this.timelineFromName(b);c&&c.currentObjectState&&void 0!==c.currentObjectState.y?a.set_float(c.currentObjectState.y):a.set_float(0)};v.prototype.pointAngle=function(a,b){var c=this.timelineFromName(b);c&&c.currentObjectState&&void 0!==c.currentObjectState.angle?a.set_float(cr.to_degrees(c.currentObjectState.angle)):a.set_float(0)};v.prototype.timeRatio=
function(a){this.currentAnimation?a.set_float(this.currentSpriterTime/this.currentAnimation.length):a.set_float(0)};v.prototype.ScaleRatio=function(a){a.set_float(this.scaleRatio)};v.prototype.key=function(a){a.set_int(this.currentframe())};v.prototype.PlayTo=function(a){a.set_int(this.playTo)};v.prototype.animationName=function(a){this.changeAnimTo?a.set_string(this.changeAnimTo.name):this.currentAnimation?a.set_string(this.currentAnimation.name):a.set_string("")};v.prototype.secondAnimationName=
function(a){this.secondAnimation?a.set_string(this.secondAnimation.name):a.set_string("")};v.prototype.entityName=function(a){this.entity?a.set_string(this.entity.name):a.set_string("")};v.prototype.PlayToTimeLeft=function(a){return 0>this.playTo?a.set_float(0):"true"==this.currentAnimation.looping?0<=speedRatio?this.playTo>this.currentSpriterTime?a.set_float(this.playTo-this.currentSpriterTime):a.set_float(this.playTo+(this.currentAnimation.length-this.currentSpriterTime)):this.playTo>this.currentSpriterTime?
a.set_float(this.currentAnimation.length-this.playTo+this.currentSpriterTime):a.set_float(this.currentSpriterTime-this.playTo):a.set_float(Math.abs(this.playTo-this.currentSpriterTime))};v.prototype.triggeredSound=function(a){a.set_string(this.soundToTrigger)};v.prototype.triggeredSoundTag=function(a){this.soundLineToTrigger?a.set_string(this.soundLineToTrigger.name):a.set_string("")};v.prototype.soundVolume=function(a,b){var c=this.soundlineFromName(b);c&&c.currentObjectState?a.set_float(c.currentObjectState.volume):
a.set_float(0)};v.prototype.soundPanning=function(a,b){var c=this.soundlineFromName(b);c&&c.currentObjectState?a.set_float(c.currentObjectState.panning):a.set_float(0)};v.prototype.blendRatio=function(a){a.set_float(this.animBlend)};H.exps=new v})();cr.plugins_.Text=function(a){this.runtime=a};
(function(){function a(){return n.length?n.pop():{}}function b(a){var b,c;b=0;for(c=a.length;b<c;b++)n.push(a[b]);a.length=0}function e(){}function l(){}function g(){}var m=cr.plugins_.Text.prototype;m.onCreate=function(){m.acts.SetWidth=function(a){this.width!==a&&(this.width=a,this.text_changed=!0,this.set_bbox_changed())}};m.Type=function(a){this.plugin=a;this.runtime=a.runtime};var c=m.Type.prototype;c.onCreate=function(){};c.onLostWebGLContext=function(){if(!this.is_family){var a,b,c;a=0;for(b=
this.instances.length;a<b;a++)c=this.instances[a],c.mycanvas=null,c.myctx=null,c.mytex=null}};m.Instance=function(a){this.type=a;this.runtime=a.runtime;this.recycled?this.lines.length=0:this.lines=[];this.text_changed=!0};var c=m.Instance.prototype,p={};c.onCreate=function(){this.text=this.properties[0];this.visible=0===this.properties[1];this.font=this.properties[2];this.color=this.properties[3];this.halign=this.properties[4];this.valign=this.properties[5];this.wrapbyword=0===this.properties[7];
this.lastwrapwidth=this.lastwidth=this.width;this.lastheight=this.height;this.line_height_offset=this.properties[8];this.fontstyle=this.facename="";this.textHeight=this.textWidth=this.ptSize=0;this.parseFont();this.mytex=this.myctx=this.mycanvas=null;this.need_text_redraw=!1;this.last_render_tick=this.runtime.tickcount;this.recycled?this.rcTex.set(0,0,1,1):this.rcTex=new cr.rect(0,0,1,1);this.runtime.glwrap&&this.runtime.tickMe(this)};c.parseFont=function(){var a=this.font.split(" "),b;for(b=0;b<
a.length;b++)if("pt"===a[b].substr(a[b].length-2,2)){this.ptSize=parseInt(a[b].substr(0,a[b].length-2));this.pxHeight=Math.ceil(96*(this.ptSize/72))+4;0<b&&(this.fontstyle=a[b-1]);this.facename=a[b+1];for(b+=2;b<a.length;b++)this.facename+=" "+a[b];break}};c.saveToJSON=function(){return{t:this.text,f:this.font,c:this.color,ha:this.halign,va:this.valign,wr:this.wrapbyword,lho:this.line_height_offset,fn:this.facename,fs:this.fontstyle,ps:this.ptSize,pxh:this.pxHeight,tw:this.textWidth,th:this.textHeight,
lrt:this.last_render_tick}};c.loadFromJSON=function(a){this.text=a.t;this.font=a.f;this.color=a.c;this.halign=a.ha;this.valign=a.va;this.wrapbyword=a.wr;this.line_height_offset=a.lho;this.facename=a.fn;this.fontstyle=a.fs;this.ptSize=a.ps;this.pxHeight=a.pxh;this.textWidth=a.tw;this.textHeight=a.th;this.last_render_tick=a.lrt;this.text_changed=!0;this.lastwrapwidth=this.lastwidth=this.width;this.lastheight=this.height};c.tick=function(){if(this.runtime.glwrap&&this.mytex&&300<=this.runtime.tickcount-
this.last_render_tick){var a=this.layer;this.update_bbox();var b=this.bbox;if(b.right<a.viewLeft||b.bottom<a.viewTop||b.left>a.viewRight||b.top>a.viewBottom)this.runtime.glwrap.deleteTexture(this.mytex),this.mycanvas=this.myctx=this.mytex=null}};c.onDestroy=function(){this.mycanvas=this.myctx=null;this.runtime.glwrap&&this.mytex&&this.runtime.glwrap.deleteTexture(this.mytex);this.mytex=null};c.updateFont=function(){this.font=this.fontstyle+" "+this.ptSize.toString()+"pt "+this.facename;this.text_changed=
!0;this.runtime.redraw=!0};c.draw=function(a,b){a.font=this.font;a.textBaseline="top";a.fillStyle=this.color;a.globalAlpha=b?1:this.opacity;var c=1;b&&(c=this.layer.getScale(),a.save(),a.scale(c,c));if(this.text_changed||this.width!==this.lastwrapwidth)this.type.plugin.WordWrap(this.text,this.lines,a,this.width,this.wrapbyword),this.text_changed=!1,this.lastwrapwidth=this.width;this.update_bbox();var c=b?0:this.bquad.tlx,f=b?0:this.bquad.tly;this.runtime.pixel_rounding&&(c=c+0.5|0,f=f+0.5|0);0===
this.angle||b||(a.save(),a.translate(c,f),a.rotate(this.angle),f=c=0);var e=f+this.height,g=this.pxHeight,g=g+this.line_height_offset,m,l;1===this.valign?f+=Math.max(this.height/2-this.lines.length*g/2,0):2===this.valign&&(f+=Math.max(this.height-this.lines.length*g-2,0));for(l=0;l<this.lines.length&&!(m=c,1===this.halign?m=c+(this.width-this.lines[l].width)/2:2===this.halign&&(m=c+(this.width-this.lines[l].width)),a.fillText(this.lines[l].text,m,f),f+=g,f>=e-g);l++);(0!==this.angle||b)&&a.restore();
this.last_render_tick=this.runtime.tickcount};c.drawGL=function(a){if(!(1>this.width||1>this.height)){var b=this.text_changed||this.need_text_redraw;this.need_text_redraw=!1;var c=this.layer.getScale(),f=this.layer.getAngle(),e=this.rcTex,g=c*this.width,m=c*this.height,l=Math.ceil(g),n=Math.ceil(m),h=this.runtime.draw_width/2,k=this.runtime.draw_height/2;this.myctx||(this.mycanvas=document.createElement("canvas"),this.mycanvas.width=l,this.mycanvas.height=n,this.lastwidth=l,this.lastheight=n,b=!0,
this.myctx=this.mycanvas.getContext("2d"));if(l!==this.lastwidth||n!==this.lastheight)this.mycanvas.width=l,this.mycanvas.height=n,this.mytex&&(a.deleteTexture(this.mytex),this.mytex=null),b=!0;b&&(this.myctx.clearRect(0,0,l,n),this.draw(this.myctx,!0),this.mytex||(this.mytex=a.createEmptyTexture(l,n,this.runtime.linearSampling,this.runtime.isMobile)),a.videoToTexture(this.mycanvas,this.mytex,this.runtime.isMobile));this.lastwidth=l;this.lastheight=n;a.setTexture(this.mytex);a.setOpacity(this.opacity);
a.resetModelView();a.translate(-h,-k);a.updateModelView();var p=this.bquad,v=this.runtime.devicePixelRatio;this.runtime.devicePixelRatio=1;var b=this.layer.layerToCanvas(p.tlx,p.tly,!0,!0),h=this.layer.layerToCanvas(p.tlx,p.tly,!1,!0),k=this.layer.layerToCanvas(p.trx,p.try_,!0,!0),H=this.layer.layerToCanvas(p.trx,p.try_,!1,!0),A=this.layer.layerToCanvas(p.brx,p.bry,!0,!0),E=this.layer.layerToCanvas(p.brx,p.bry,!1,!0),B=this.layer.layerToCanvas(p.blx,p.bly,!0,!0),p=this.layer.layerToCanvas(p.blx,p.bly,
!1,!0);this.runtime.devicePixelRatio=v;if(this.runtime.pixel_rounding||0===this.angle&&0===f)var v=(b+0.5|0)-b,C=(h+0.5|0)-h,b=b+v,h=h+C,k=k+v,H=H+C,A=A+v,E=E+C,B=B+v,p=p+C;0===this.angle&&0===f?(k=b+l,H=h,A=k,E=h+n,B=b,p=E,e.right=1,e.bottom=1):(e.right=g/l,e.bottom=m/n);a.quadTex(b,h,k,H,A,E,B,p,e);a.resetModelView();a.scale(c,c);a.rotateZ(-this.layer.getAngle());a.translate((this.layer.viewLeft+this.layer.viewRight)/-2,(this.layer.viewTop+this.layer.viewBottom)/-2);a.updateModelView();this.last_render_tick=
this.runtime.tickcount}};var f=[];m.TokeniseWords=function(a){f.length=0;for(var b="",c,e=0;e<a.length;)if(c=a.charAt(e),"\n"===c)b.length&&(f.push(b),b=""),f.push("\n"),++e;else if(" "===c||"\t"===c||"-"===c){do b+=a.charAt(e),e++;while(e<a.length&&(" "===a.charAt(e)||"\t"===a.charAt(e)));f.push(b);b=""}else e<a.length&&(b+=c,e++);b.length&&f.push(b)};var n=[];m.WordWrap=function(c,f,e,g,m){if(c&&c.length)if(2>=g)b(f);else{if(100>=c.length&&-1===c.indexOf("\n")){var l=e.measureText(c).width;if(l<=
g){b(f);f.push(a());f[0].text=c;f[0].width=l;return}}this.WrapText(c,f,e,g,m)}else b(f)};m.WrapText=function(b,c,e,g,m){m&&(this.TokeniseWords(b),b=f);var l="",p,x,z,h=0;for(z=0;z<b.length;z++)"\n"===b[z]?(h>=c.length&&c.push(a()),x=c[h],x.text=l,x.width=e.measureText(l).width,h++,l=""):(p=l,l+=b[z],x=e.measureText(l).width,x>=g&&(h>=c.length&&c.push(a()),x=c[h],x.text=p,x.width=e.measureText(p).width,h++,l=b[z],m||" "!==l||(l="")));l.length&&(h>=c.length&&c.push(a()),x=c[h],x.text=l,x.width=e.measureText(l).width,
h++);for(z=h;z<c.length;z++)n.push(c[z]);c.length=h};e.prototype.CompareText=function(a,b){return b?this.text==a:cr.equals_nocase(this.text,a)};m.cnds=new e;l.prototype.SetText=function(a){cr.is_number(a)&&1E9>a&&(a=Math.round(1E10*a)/1E10);a=a.toString();this.text!==a&&(this.text=a,this.text_changed=!0,this.runtime.redraw=!0)};l.prototype.AppendText=function(a){cr.is_number(a)&&(a=Math.round(1E10*a)/1E10);if(a=a.toString())this.text+=a,this.text_changed=!0,this.runtime.redraw=!0};l.prototype.SetFontFace=
function(a,b){var c="";switch(b){case 1:c="bold";break;case 2:c="italic";break;case 3:c="bold italic"}if(a!==this.facename||c!==this.fontstyle)this.facename=a,this.fontstyle=c,this.updateFont()};l.prototype.SetFontSize=function(a){this.ptSize!==a&&(this.ptSize=a,this.pxHeight=Math.ceil(96*(this.ptSize/72))+4,this.updateFont())};l.prototype.SetFontColor=function(a){a="rgb("+cr.GetRValue(a).toString()+","+cr.GetGValue(a).toString()+","+cr.GetBValue(a).toString()+")";a!==this.color&&(this.color=a,this.need_text_redraw=
!0,this.runtime.redraw=!0)};l.prototype.SetWebFont=function(a,b){if(this.runtime.isDomFree)cr.logexport("[Construct 2] Text plugin: 'Set web font' not supported on this platform - the action has been ignored");else{var c=this,f=function(){c.runtime.redraw=!0;c.text_changed=!0};if(p.hasOwnProperty(b)){var e="'"+a+"'";if(this.facename!==e)for(this.facename=e,this.updateFont(),e=1;10>e;e++)setTimeout(f,100*e),setTimeout(f,1E3*e)}else for(e=document.createElement("link"),e.href=b,e.rel="stylesheet",e.type=
"text/css",e.onload=f,document.getElementsByTagName("head")[0].appendChild(e),p[b]=!0,this.facename="'"+a+"'",this.updateFont(),e=1;10>e;e++)setTimeout(f,100*e),setTimeout(f,1E3*e)}};l.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};m.acts=new l;g.prototype.Text=function(a){a.set_string(this.text)};g.prototype.FaceName=function(a){a.set_string(this.facename)};g.prototype.FaceSize=function(a){a.set_int(this.ptSize)};
g.prototype.TextWidth=function(a){var b=0,c,f,e;c=0;for(f=this.lines.length;c<f;c++)e=this.lines[c].width,b<e&&(b=e);a.set_int(b)};g.prototype.TextHeight=function(a){a.set_int(this.lines.length*(this.pxHeight+this.line_height_offset)-this.line_height_offset)};m.exps=new g})();cr.plugins_.TiledBg=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(){}var l=cr.plugins_.TiledBg.prototype;l.Type=function(a){this.plugin=a;this.runtime=a.runtime};var g=l.Type.prototype;g.onCreate=function(){this.is_family||(this.texture_img=new Image,this.texture_img.idtkLoadDisposed=!0,this.texture_img.src=this.texture_file,this.texture_img.cr_filesize=this.texture_filesize,this.runtime.waitForImageLoad(this.texture_img),this.webGL_texture=this.pattern=null)};g.onLostWebGLContext=function(){this.is_family||(this.webGL_texture=
null)};g.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){this.webGL_texture||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,this.texture_pixelformat));var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].webGL_texture=this.webGL_texture}};g.loadTextures=function(){this.is_family||this.webGL_texture||!this.runtime.glwrap||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,
this.texture_pixelformat))};g.unloadTextures=function(){this.is_family||this.instances.length||!this.webGL_texture||(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};g.preloadCanvas2D=function(a){a.drawImage(this.texture_img,0,0)};l.Instance=function(a){this.type=a;this.runtime=a.runtime};g=l.Instance.prototype;g.onCreate=function(){this.visible=0===this.properties[0];this.rcTex=new cr.rect(0,0,0,0);this.has_own_texture=!1;this.texture_img=this.type.texture_img;this.runtime.glwrap?
(this.type.loadTextures(),this.webGL_texture=this.type.webGL_texture):(this.type.pattern||(this.type.pattern=this.runtime.ctx.createPattern(this.type.texture_img,"repeat")),this.pattern=this.type.pattern)};g.afterLoad=function(){this.has_own_texture=!1;this.texture_img=this.type.texture_img};g.onDestroy=function(){this.runtime.glwrap&&this.has_own_texture&&this.webGL_texture&&(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};g.draw=function(a){a.globalAlpha=this.opacity;
a.save();a.fillStyle=this.pattern;var b=this.x,e=this.y;this.runtime.pixel_rounding&&(b=b+0.5|0,e=e+0.5|0);var f=-(this.hotspotX*this.width),g=-(this.hotspotY*this.height),d=f%this.texture_img.width,l=g%this.texture_img.height;0>d&&(d+=this.texture_img.width);0>l&&(l+=this.texture_img.height);a.translate(b,e);a.rotate(this.angle);a.translate(d,l);a.fillRect(f-d,g-l,this.width,this.height);a.restore()};g.drawGL=function(a){a.setTexture(this.webGL_texture);a.setOpacity(this.opacity);var b=this.rcTex;
b.right=this.width/this.texture_img.width;b.bottom=this.height/this.texture_img.height;var e=this.bquad;if(this.runtime.pixel_rounding){var f=(this.x+0.5|0)-this.x,g=(this.y+0.5|0)-this.y;a.quadTex(e.tlx+f,e.tly+g,e.trx+f,e.try_+g,e.brx+f,e.bry+g,e.blx+f,e.bly+g,b)}else a.quadTex(e.tlx,e.tly,e.trx,e.try_,e.brx,e.bry,e.blx,e.bly,b)};a.prototype.OnURLLoaded=function(){return!0};l.cnds=new a;b.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);
this.runtime.redraw=!0};b.prototype.LoadURL=function(a){var b=new Image,e=this;b.onload=function(){e.texture_img=b;e.runtime.glwrap?(e.has_own_texture&&e.webGL_texture&&e.runtime.glwrap.deleteTexture(e.webGL_texture),e.webGL_texture=e.runtime.glwrap.loadTexture(b,!0,e.runtime.linearSampling)):e.pattern=e.runtime.ctx.createPattern(b,"repeat");e.has_own_texture=!0;e.runtime.redraw=!0;e.runtime.trigger(cr.plugins_.TiledBg.prototype.cnds.OnURLLoaded,e)};"data:"!==a.substr(0,5)&&(b.crossOrigin="anonymous");
b.src=a};l.acts=new b;e.prototype.ImageWidth=function(a){a.set_float(this.texture_img.width)};e.prototype.ImageHeight=function(a){a.set_float(this.texture_img.height)};l.exps=new e})();cr.plugins_.Touch=function(a){this.runtime=a};
(function(){function a(a){p=a.x;f=a.y;n=a.z}function b(a){d=a.x;u=a.y;s=a.z}function e(){}function l(){}var g=cr.plugins_.Touch.prototype;g.Type=function(a){this.plugin=a;this.runtime=a.runtime};g.Type.prototype.onCreate=function(){};g.Instance=function(a){this.type=a;this.runtime=a.runtime;this.touches=[];this.mouseDown=!1};var m=g.Instance.prototype,c={left:0,top:0};m.findTouch=function(a){var b,c;b=0;for(c=this.touches.length;b<c;b++)if(this.touches[b].id===a)return b;return-1};var p=0,f=0,n=0,
d=0,u=0,s=0;m.onCreate=function(){this.isWindows8=!("undefined"===typeof window.c2isWindows8||!window.c2isWindows8);this.trigger_id=this.trigger_index=this.curTouchY=this.curTouchX=this.acc_z=this.acc_y=this.acc_x=this.acc_g_z=this.acc_g_y=this.acc_g_x=this.orient_gamma=this.orient_beta=this.orient_alpha=0;this.useMouseInput=0!==this.properties[0];var c=0<this.runtime.fullscreen_mode?document:this.runtime.canvas,d=document;this.runtime.isDirectCanvas?d=c=window.Canvas:this.runtime.isCocoonJs&&(d=
c=window);var f=this;window.navigator.pointerEnabled?(c.addEventListener("pointerdown",function(a){f.onPointerStart(a)},!1),c.addEventListener("pointermove",function(a){f.onPointerMove(a)},!1),d.addEventListener("pointerup",function(a){f.onPointerEnd(a)},!1),d.addEventListener("pointercancel",function(a){f.onPointerEnd(a)},!1),this.runtime.canvas&&(this.runtime.canvas.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1),document.addEventListener("MSGestureHold",function(a){a.preventDefault()},
!1),this.runtime.canvas.addEventListener("gesturehold",function(a){a.preventDefault()},!1),document.addEventListener("gesturehold",function(a){a.preventDefault()},!1))):window.navigator.msPointerEnabled?(c.addEventListener("MSPointerDown",function(a){f.onPointerStart(a)},!1),c.addEventListener("MSPointerMove",function(a){f.onPointerMove(a)},!1),d.addEventListener("MSPointerUp",function(a){f.onPointerEnd(a)},!1),d.addEventListener("MSPointerCancel",function(a){f.onPointerEnd(a)},!1),this.runtime.canvas&&
(this.runtime.canvas.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1),document.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1))):(c.addEventListener("touchstart",function(a){f.onTouchStart(a)},!1),c.addEventListener("touchmove",function(a){f.onTouchMove(a)},!1),d.addEventListener("touchend",function(a){f.onTouchEnd(a)},!1),d.addEventListener("touchcancel",function(a){f.onTouchEnd(a)},!1));if(this.isWindows8){var e=function(a){a=a.reading;f.acc_x=a.accelerationX;
f.acc_y=a.accelerationY;f.acc_z=a.accelerationZ},g=function(a){a=a.reading;f.orient_alpha=a.yawDegrees;f.orient_beta=a.pitchDegrees;f.orient_gamma=a.rollDegrees},m=Windows.Devices.Sensors.Accelerometer.getDefault();m&&(m.reportInterval=Math.max(m.minimumReportInterval,16),m.addEventListener("readingchanged",e));var h=Windows.Devices.Sensors.Inclinometer.getDefault();h&&(h.reportInterval=Math.max(h.minimumReportInterval,16),h.addEventListener("readingchanged",g));document.addEventListener("visibilitychange",
function(a){document.hidden||document.msHidden?(m&&m.removeEventListener("readingchanged",e),h&&h.removeEventListener("readingchanged",g)):(m&&m.addEventListener("readingchanged",e),h&&h.addEventListener("readingchanged",g))},!1)}else window.addEventListener("deviceorientation",function(a){f.orient_alpha=a.alpha||0;f.orient_beta=a.beta||0;f.orient_gamma=a.gamma||0},!1),window.addEventListener("devicemotion",function(a){a.accelerationIncludingGravity&&(f.acc_g_x=a.accelerationIncludingGravity.x||0,
f.acc_g_y=a.accelerationIncludingGravity.y||0,f.acc_g_z=a.accelerationIncludingGravity.z||0);a.acceleration&&(f.acc_x=a.acceleration.x||0,f.acc_y=a.acceleration.y||0,f.acc_z=a.acceleration.z||0)},!1);this.useMouseInput&&!this.runtime.isDomFree&&(jQuery(document).mousemove(function(a){f.onMouseMove(a)}),jQuery(document).mousedown(function(a){f.onMouseDown(a)}),jQuery(document).mouseup(function(a){f.onMouseUp(a)}));this.runtime.isAppMobi&&!this.runtime.isDirectCanvas&&AppMobi.accelerometer.watchAcceleration(a,
{frequency:40,adjustForRotation:!0});this.runtime.isPhoneGap&&navigator.accelerometer&&navigator.accelerometer.watchAcceleration&&navigator.accelerometer.watchAcceleration(b,null,{frequency:40});this.runtime.tick2Me(this)};m.onPointerMove=function(a){if(a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType){a.preventDefault&&a.preventDefault();var b=this.findTouch(a.pointerId),d=cr.performance_now();if(0<=b){var f=this.runtime.isDomFree?c:jQuery(this.runtime.canvas).offset(),b=this.touches[b];
2>d-b.time||(b.lasttime=b.time,b.lastx=b.x,b.lasty=b.y,b.time=d,b.x=a.pageX-f.left,b.y=a.pageY-f.top)}}};m.onPointerStart=function(a){if(a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType){a.preventDefault&&a.preventDefault();var b=this.runtime.isDomFree?c:jQuery(this.runtime.canvas).offset(),d=a.pageX-b.left,b=a.pageY-b.top,f=cr.performance_now();this.trigger_index=this.touches.length;this.trigger_id=a.pointerId;this.touches.push({time:f,x:d,y:b,lasttime:f,lastx:d,lasty:b,id:a.pointerId,
startindex:this.trigger_index});this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart,this);this.curTouchX=d;this.curTouchY=b;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject,this);this.runtime.isInUserInputEvent=!1}};m.onPointerEnd=function(a){a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),a=this.findTouch(a.pointerId),
this.trigger_index=0<=a?this.touches[a].startindex:-1,this.trigger_id=0<=a?this.touches[a].id:-1,this.runtime.isInUserInputEvent=!0,this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,this),this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd,this),this.runtime.isInUserInputEvent=!1,0<=a&&this.touches.splice(a,1))};m.onTouchMove=function(a){a.preventDefault&&a.preventDefault();var b=cr.performance_now(),d,f,e,g;d=0;for(f=a.changedTouches.length;d<f;d++)if(e=a.changedTouches[d],
g=this.findTouch(e.identifier),0<=g){var h=this.runtime.isDomFree?c:jQuery(this.runtime.canvas).offset();g=this.touches[g];2>b-g.time||(g.lasttime=g.time,g.lastx=g.x,g.lasty=g.y,g.time=b,g.x=e.pageX-h.left,g.y=e.pageY-h.top)}};m.onTouchStart=function(a){a.preventDefault&&a.preventDefault();var b=this.runtime.isDomFree?c:jQuery(this.runtime.canvas).offset(),d=cr.performance_now();this.runtime.isInUserInputEvent=!0;var f,e,g,h;f=0;for(e=a.changedTouches.length;f<e;f++)if(g=a.changedTouches[f],h=this.findTouch(g.identifier),
-1===h){h=g.pageX-b.left;var k=g.pageY-b.top;this.trigger_index=this.touches.length;this.trigger_id=g.identifier;this.touches.push({time:d,x:h,y:k,lasttime:d,lastx:h,lasty:k,id:g.identifier,startindex:this.trigger_index});this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart,this);this.curTouchX=h;this.curTouchY=k;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject,this)}this.runtime.isInUserInputEvent=
!1};m.onTouchEnd=function(a){a.preventDefault&&a.preventDefault();this.runtime.isInUserInputEvent=!0;var b,c,d;b=0;for(c=a.changedTouches.length;b<c;b++)d=a.changedTouches[b],d=this.findTouch(d.identifier),0<=d&&(this.trigger_index=this.touches[d].startindex,this.trigger_id=this.touches[d].id,this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,this),this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd,this),this.touches.splice(d,1));this.runtime.isInUserInputEvent=!1};
m.getAlpha=function(){return this.runtime.isAppMobi&&0===this.orient_alpha&&0!==n?90*n:this.runtime.isPhoneGap&&0===this.orient_alpha&&0!==s?90*s:this.orient_alpha};m.getBeta=function(){return this.runtime.isAppMobi&&0===this.orient_beta&&0!==f?-90*f:this.runtime.isPhoneGap&&0===this.orient_beta&&0!==u?-90*u:this.orient_beta};m.getGamma=function(){return this.runtime.isAppMobi&&0===this.orient_gamma&&0!==p?90*p:this.runtime.isPhoneGap&&0===this.orient_gamma&&0!==d?90*d:this.orient_gamma};m.onMouseDown=
function(a){a.preventDefault&&this.runtime.had_a_click&&!this.runtime.isMobile&&a.preventDefault();this.onTouchStart({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]});this.mouseDown=!0};m.onMouseMove=function(a){if(this.mouseDown)this.onTouchMove({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]})};m.onMouseUp=function(a){a.preventDefault&&this.runtime.had_a_click&&!this.runtime.isMobile&&a.preventDefault();this.runtime.had_a_click=!0;this.onTouchEnd({changedTouches:[{pageX:a.pageX,
pageY:a.pageY,identifier:0}]});this.mouseDown=!1};m.tick2=function(){var a,b,c,d=cr.performance_now();a=0;for(b=this.touches.length;a<b;a++)c=this.touches[a],c.time<=d-50&&(c.lasttime=d)};e.prototype.OnTouchStart=function(){return!0};e.prototype.OnTouchEnd=function(){return!0};e.prototype.IsInTouch=function(){return this.touches.length};e.prototype.OnTouchObject=function(a){return a?this.runtime.testAndSelectCanvasPointOverlap(a,this.curTouchX,this.curTouchY,!1):!1};e.prototype.IsTouchingObject=function(a){if(!a)return!1;
var b=a.getCurrentSol(),c=b.getObjects(),d,f,e=[],g,k,m,l;g=0;for(k=c.length;g<k;g++){var n=c[g];n.update_bbox();m=0;for(l=this.touches.length;m<l;m++)if(f=this.touches[m],d=n.layer.canvasToLayer(f.x,f.y,!0),f=n.layer.canvasToLayer(f.x,f.y,!1),n.contains_pt(d,f)){e.push(n);break}}return e.length?(b.select_all=!1,b.instances=e,a.applySolToContainer(),!0):!1};e.prototype.CompareTouchSpeed=function(a,b,c){a=Math.floor(a);if(0>a||a>=this.touches.length)return!1;var d=this.touches[a];a=cr.distanceTo(d.x,
d.y,d.lastx,d.lasty);var d=(d.time-d.lasttime)/1E3,f=0;0<d&&(f=a/d);return cr.do_cmp(f,b,c)};e.prototype.OrientationSupported=function(){return"undefined"!==typeof window.DeviceOrientationEvent};e.prototype.MotionSupported=function(){return"undefined"!==typeof window.DeviceMotionEvent};e.prototype.CompareOrientation=function(a,b,c){var d=0,d=0===a?this.getAlpha():1===a?this.getBeta():this.getGamma();return cr.do_cmp(d,b,c)};e.prototype.CompareAcceleration=function(a,b,c){var d=0;0===a?d=this.acc_g_x:
1===a?d=this.acc_g_y:2===a?d=this.acc_g_z:3===a?d=this.acc_x:4===a?d=this.acc_y:5===a&&(d=this.acc_z);return cr.do_cmp(d,b,c)};e.prototype.OnNthTouchStart=function(a){a=Math.floor(a);return a===this.trigger_index};e.prototype.OnNthTouchEnd=function(a){a=Math.floor(a);return a===this.trigger_index};e.prototype.HasNthTouch=function(a){a=Math.floor(a);return this.touches.length>=a+1};g.cnds=new e;l.prototype.TouchCount=function(a){a.set_int(this.touches.length)};l.prototype.X=function(a,b){if(this.touches.length){var c,
d,f,e,g;cr.is_undefined(b)?(c=this.runtime.getLayerByNumber(0),d=c.scale,f=c.zoomRate,e=c.parallaxX,g=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!0)),c.scale=d,c.zoomRate=f,c.parallaxX=e,c.angle=g):(c=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!0)):a.set_float(0)}else a.set_float(0)};
l.prototype.XAt=function(a,b,c){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var d,f,e,g;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,f=c.zoomRate,e=c.parallaxX,g=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!0)),c.scale=d,c.zoomRate=f,c.parallaxX=e,c.angle=g):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?
a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!0)):a.set_float(0)}};l.prototype.XForID=function(a,b,c){b=this.findTouch(b);if(0>b)a.set_float(0);else{b=this.touches[b];var d,f,e,g;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,f=c.zoomRate,e=c.parallaxX,g=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(b.x,b.y,!0)),c.scale=d,c.zoomRate=f,c.parallaxX=e,c.angle=g):(c=
cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(b.x,b.y,!0)):a.set_float(0)}};l.prototype.Y=function(a,b){if(this.touches.length){var c,d,f,e,g;cr.is_undefined(b)?(c=this.runtime.getLayerByNumber(0),d=c.scale,f=c.zoomRate,e=c.parallaxY,g=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!1)),c.scale=d,c.zoomRate=
f,c.parallaxY=e,c.angle=g):(c=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!1)):a.set_float(0)}else a.set_float(0)};l.prototype.YAt=function(a,b,c){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var d,f,e,g;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,f=c.zoomRate,e=c.parallaxY,g=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=
this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!1)),c.scale=d,c.zoomRate=f,c.parallaxY=e,c.angle=g):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!1)):a.set_float(0)}};l.prototype.YForID=function(a,b,c){b=this.findTouch(b);if(0>b)a.set_float(0);else{b=this.touches[b];var d,f,e,g;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,f=c.zoomRate,
e=c.parallaxY,g=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(b.x,b.y,!1)),c.scale=d,c.zoomRate=f,c.parallaxY=e,c.angle=g):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(b.x,b.y,!1)):a.set_float(0)}};l.prototype.AbsoluteX=function(a){this.touches.length?a.set_float(this.touches[0].x):a.set_float(0)};l.prototype.AbsoluteXAt=function(a,
b){b=Math.floor(b);0>b||b>=this.touches.length?a.set_float(0):a.set_float(this.touches[b].x)};l.prototype.AbsoluteXForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):a.set_float(this.touches[c].x)};l.prototype.AbsoluteY=function(a){this.touches.length?a.set_float(this.touches[0].y):a.set_float(0)};l.prototype.AbsoluteYAt=function(a,b){b=Math.floor(b);0>b||b>=this.touches.length?a.set_float(0):a.set_float(this.touches[b].y)};l.prototype.AbsoluteYForID=function(a,b){var c=this.findTouch(b);
0>c?a.set_float(0):a.set_float(this.touches[c].y)};l.prototype.SpeedAt=function(a,b){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var c=this.touches[b],d=cr.distanceTo(c.x,c.y,c.lastx,c.lasty),c=(c.time-c.lasttime)/1E3;0===c?a.set_float(0):a.set_float(d/c)}};l.prototype.SpeedForID=function(a,b){var c=this.findTouch(b);if(0>c)a.set_float(0);else{var d=this.touches[c],c=cr.distanceTo(d.x,d.y,d.lastx,d.lasty),d=(d.time-d.lasttime)/1E3;0===d?a.set_float(0):a.set_float(c/d)}};l.prototype.AngleAt=
function(a,b){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var c=this.touches[b];a.set_float(cr.to_degrees(cr.angleTo(c.lastx,c.lasty,c.x,c.y)))}};l.prototype.AngleForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):(c=this.touches[c],a.set_float(cr.to_degrees(cr.angleTo(c.lastx,c.lasty,c.x,c.y))))};l.prototype.Alpha=function(a){a.set_float(this.getAlpha())};l.prototype.Beta=function(a){a.set_float(this.getBeta())};l.prototype.Gamma=function(a){a.set_float(this.getGamma())};
l.prototype.AccelerationXWithG=function(a){a.set_float(this.acc_g_x)};l.prototype.AccelerationYWithG=function(a){a.set_float(this.acc_g_y)};l.prototype.AccelerationZWithG=function(a){a.set_float(this.acc_g_z)};l.prototype.AccelerationX=function(a){a.set_float(this.acc_x)};l.prototype.AccelerationY=function(a){a.set_float(this.acc_y)};l.prototype.AccelerationZ=function(a){a.set_float(this.acc_z)};l.prototype.TouchIndex=function(a){a.set_int(this.trigger_index)};l.prototype.TouchID=function(a){a.set_float(this.trigger_id)};
g.exps=new l})();cr.plugins_.WebStorage=function(a){this.runtime=a};
(function(){function a(){f||(cr.logexport("[Construct 2] Webstorage plugin: session storage is not supported on this platform. Try using local storage or global variables instead."),f=!0)}function b(){}function e(){}function l(){}var g=cr.plugins_.WebStorage.prototype;g.Type=function(a){this.plugin=a;this.runtime=a.runtime};g.Type.prototype.onCreate=function(){};g.Instance=function(a){this.type=a;this.runtime=a.runtime};var m=g.Instance.prototype,c="",p="undefined"!==typeof window.is_scirra_arcade;
p&&(c="arcade"+window.scirra_arcade_id);var f=!1;m.onCreate=function(){};b.prototype.LocalStorageEnabled=function(){return!0};b.prototype.SessionStorageEnabled=function(){return!0};b.prototype.LocalStorageExists=function(a){return null!=localStorage.getItem(c+a)};b.prototype.SessionStorageExists=function(b){return this.runtime.isCocoonJs||!sessionStorage?(a(),!1):null!=sessionStorage.getItem(c+b)};b.prototype.OnQuotaExceeded=function(){return!0};b.prototype.CompareKeyText=function(a,b,f){a=localStorage.getItem(c+
a)||"";return f?a==b:cr.equals_nocase(a,b)};b.prototype.CompareKeyNumber=function(a,b,f){a=localStorage.getItem(c+a)||"";return cr.do_cmp(parseFloat(a),b,f)};g.cnds=new b;e.prototype.StoreLocal=function(a,b){try{localStorage.setItem(c+a,b)}catch(f){this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded,this)}};e.prototype.StoreSession=function(b,d){if(this.runtime.isCocoonJs||!sessionStorage)a();else try{sessionStorage.setItem(c+b,d)}catch(f){this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded,
this)}};e.prototype.RemoveLocal=function(a){localStorage.removeItem(c+a)};e.prototype.RemoveSession=function(b){this.runtime.isCocoonJs||!sessionStorage?a():sessionStorage.removeItem(c+b)};e.prototype.ClearLocal=function(){p||localStorage.clear()};e.prototype.ClearSession=function(){this.runtime.isCocoonJs||!sessionStorage?a():p||sessionStorage.clear()};e.prototype.JSONLoad=function(a,b){var f;try{f=JSON.parse(a)}catch(e){return}if(f.c2dictionary){f=f.data;0!==b||p||localStorage.clear();for(var g in f)if(f.hasOwnProperty(g))try{localStorage.setItem(c+
g,f[g])}catch(m){this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded,this);break}}};g.acts=new e;l.prototype.LocalValue=function(a,b){a.set_string(localStorage.getItem(c+b)||"")};l.prototype.SessionValue=function(b,d){this.runtime.isCocoonJs||!sessionStorage?(a(),b.set_string("")):b.set_string(sessionStorage.getItem(c+d)||"")};l.prototype.LocalCount=function(a){a.set_int(p?0:localStorage.length)};l.prototype.SessionCount=function(b){this.runtime.isCocoonJs||!sessionStorage?
(a(),b.set_int(0)):b.set_int(p?0:sessionStorage.length)};l.prototype.LocalAt=function(a,b){p?a.set_string(""):a.set_string(localStorage.getItem(localStorage.key(b))||"")};l.prototype.SessionAt=function(b,c){this.runtime.isCocoonJs||!sessionStorage?(a(),b.set_string("")):p?b.set_string(""):b.set_string(sessionStorage.getItem(sessionStorage.key(c))||"")};l.prototype.LocalKeyAt=function(a,b){p?a.set_string(""):a.set_string(localStorage.key(b)||"")};l.prototype.SessionKeyAt=function(b,c){this.runtime.isCocoonJs||
!sessionStorage?(a(),b.set_string("")):p?b.set_string(""):b.set_string(sessionStorage.key(c)||"")};l.prototype.AsJSON=function(a){var b={},f,e,g;f=0;for(e=localStorage.length;f<e;f++)g=localStorage.key(f),p?g.substr(0,c.length)===c&&(b[g.substr(c.length)]=localStorage.getItem(g)):b[g]=localStorage.getItem(g);a.set_string(JSON.stringify({c2dictionary:!0,data:b}))};g.exps=new l})();cr.plugins_.win8=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(a){var b,c,f,e,g=0,m=[];do b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(a.charAt(g++)),c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(a.charAt(g++)),f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(a.charAt(g++)),e="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(a.charAt(g++)),f=b<<18|c<<12|f<<6|e,b=f>>16&255,c=f>>8&255,f&=255,
m.push(b),m.push(c),m.push(f);while(g<a.length);return m}function l(a,b){if("data:"!==a.substr(0,5))return!1;var c=a.substring(5).split(",");if(2!==c.length)return!1;var f;if(-1<c[0].indexOf("image/png"))f="png";else if(-1<c[0].indexOf("image/jpeg"))f="jpg";else return!1;f="shareimage."+f;if(-1===c[0].indexOf(";base64"))return!1;var g=e(c[1]);Windows.Storage.ApplicationData.current.localFolder.createFileAsync(f,Windows.Storage.CreationCollisionOption.replaceExisting).then(function(a){Windows.Storage.FileIO.writeBytesAsync(a,
g).then(function(){b&&b(a)})})}function g(){}var m=cr.plugins_.win8.prototype;m.Type=function(a){this.plugin=a;this.runtime=a.runtime};m.Type.prototype.onCreate=function(){};m.Instance=function(a){this.type=a;this.runtime=a.runtime};var c=m.Instance.prototype,p=null,f=!1;c.onCreate=function(){this.isWindows8=this.runtime.isWindows8App;this.triggerViewState=0;this.isTestMode=0!==this.properties[0];this.showAbout=0!==this.properties[1];this.showSupport=0!==this.properties[2];this.showPrivacy=0!==this.properties[3];
this.appFormattedPrice="";this.currentApp=this.lastProductListings=null;var a=this;if(this.isWindows8){var b=Windows.ApplicationModel.Store;this.currentApp=this.isTestMode?b.CurrentAppSimulator:b.CurrentApp;this.isTestMode&&(new Windows.UI.Popups.MessageDialog("Note: this Windows 8 app is in Test Mode, designed for testing purchases. Before publishing, be sure to set Test Mode to 'No' in the Windows 8 object's properties.")).showAsync();window.addEventListener("resize",function(){a.triggerViewState=
Windows.UI.ViewManagement.ApplicationView.value;a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnViewStateChange,a)});Windows.Storage.ApplicationData.current.addEventListener("datachanged",function(){a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnDataChanged,a)});Windows.ApplicationModel.DataTransfer.DataTransferManager.getForCurrentView().addEventListener("datarequested",function(b){p=b;f=!1;a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnShare,a);p=null;f||b.request.failWithDisplayText("Try selecting a different option before sharing.")});
this.currentApp.licenseInformation.addEventListener("licensechanged",function(){a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnLicenseChanged,a)});(this.showAbout||this.showSupport||this.showPrivacy)&&WinJS.Application.addEventListener("settings",function(b){var c={};a.showAbout&&(c.about={title:"About",href:"/about.html"});a.showSupport&&(c.support={title:"Support",href:"/support.html"});a.showPrivacy&&(c.privacy={title:"Privacy Policy",href:"/privacy.html"});b.detail.applicationcommands=c;
WinJS.UI.SettingsFlyout.populateSettings(b)});this.isTestMode&&Windows.ApplicationModel.Package.current.installedLocation.getFileAsync("WindowsStoreProxy.xml").done(function(a){Windows.ApplicationModel.Store.CurrentAppSimulator.reloadSimulatorAsync(a).done(function(){console.log("[Construct 2] Test mode; loaded WindowsStoreProxy.xml")},function(a){console.log("[Construct 2] Error loading WindowsStoreProxy.xml: "+a)})},function(a){console.log("[Construct 2] Error loading WindowsStoreProxy.xml: "+a)})}};
c.roamingValues=function(){return this.isWindows8?Windows.Storage.ApplicationData.current.roamingSettings.values:null};a.prototype.IsWindows8=function(){return this.isWindows8};a.prototype.OnViewStateChange=function(a){return this.isWindows8?a===this.triggerViewState:!1};a.prototype.CompareViewState=function(a){return this.isWindows8?Windows.UI.ViewManagement.ApplicationView.value===a:!1};a.prototype.OnDataChanged=function(){return!0};a.prototype.RoamingKeyExists=function(a){return this.isWindows8?
this.roamingValues().hasKey(a):!1};a.prototype.OnShare=function(){return!0};a.prototype.OnLicenseChanged=function(){return!0};a.prototype.OnPurchaseSuccess=function(){return!0};a.prototype.OnPurchaseFail=function(){return!0};a.prototype.OnStoreListing=function(){return!0};a.prototype.IsTrial=function(){return this.isWindows8&&this.currentApp.licenseInformation.isTrial&&this.currentApp.licenseInformation.isActive};a.prototype.IsLicensed=function(){return this.isWindows8&&!this.currentApp.licenseInformation.isTrial&&
this.currentApp.licenseInformation.isActive};a.prototype.IsExpiredTrial=function(){return this.isWindows8&&this.currentApp.licenseInformation.isTrial&&!this.currentApp.licenseInformation.isActive};a.prototype.HasProduct=function(a){if(!this.isWindows8)return!1;var b=this.currentApp.licenseInformation.productLicenses;return b.hasKey(a)?b.lookup(a).isActive:!1};m.cnds=new a;b.prototype.TryUnsnap=function(){this.isWindows8&&Windows.UI.ViewManagement.ApplicationView.tryUnsnap()};b.prototype.SetRoamingValue=
function(a,b){this.isWindows8&&(this.roamingValues()[a]=b.toString())};b.prototype.RemoveRoamingValue=function(a){this.isWindows8&&this.roamingValues().remove(a)};b.prototype.ClearRoamingData=function(){this.isWindows8&&this.roamingValues().clear()};b.prototype.ShowShareUI=function(){this.isWindows8&&Windows.ApplicationModel.DataTransfer.DataTransferManager.showShareUI()};b.prototype.ShareText=function(a,b,c){if(this.isWindows8&&p){var e=p.request;e.data.properties.title=a;e.data.properties.description=
b;e.data.setText(c);f=!0}};b.prototype.ShareLink=function(a,b,c){if(this.isWindows8&&p){var e=p.request;e.data.properties.title=a;e.data.properties.description=b;e.data.setUri(new Windows.Foundation.Uri(c));f=!0}};b.prototype.ShareHTML=function(a,b,c){if(this.isWindows8&&p){var e=p.request;e.data.properties.title=a;e.data.properties.description=b;a=Windows.ApplicationModel.DataTransfer.HtmlFormatHelper.createHtmlFormat(c);e.data.setHtmlFormat(a);f=!0}};b.prototype.ShareSpriteImage=function(a,b,c){if(this.isWindows8&&
p&&c&&(c=c.getFirstPicked())&&c.curFrame){c=c.curFrame.getDataUri();var e=p.request;e.data.properties.title=a;e.data.properties.description=b;var g=e.getDeferral();l(c,function(a){e.data.setBitmap(Windows.Storage.Streams.RandomAccessStreamReference.createFromFile(a));g.complete()});f=!0}};b.prototype.ShareDataUri=function(a,b,c){if(this.isWindows8&&p){var e=p.request;e.data.properties.title=a;e.data.properties.description=b;var g=e.getDeferral();l(c,function(a){e.data.setBitmap(Windows.Storage.Streams.RandomAccessStreamReference.createFromFile(a));
g.complete()});f=!0}};b.prototype.FailShare=function(a){this.isWindows8&&p&&(p.request.failWithDisplayText(a),f=!0)};var n="tileSquareBlock tileSquareText02 tileSquareText04 tileWideText03 tileWideText04 tileWideText09".split(" ");b.prototype.SetLiveTileText=function(a,b,c){a=Math.floor(a);if(this.isWindows8&&0<=a&&a<n.length){var f=Windows.UI.Notifications;a=f.TileUpdateManager.getTemplateContent(f.TileTemplateType[n[a]]);var e=a.getElementsByTagName("text");e[0].appendChild(a.createTextNode(b));
2<=e.length&&e[1].appendChild(a.createTextNode(c));b=new f.TileNotification(a);f.TileUpdateManager.createTileUpdaterForApplication().update(b)}};b.prototype.PurchaseApp=function(){if(this.isWindows8){var a=this;this.currentApp.requestAppPurchaseAsync(!1).then(function(){console.log("[Construct 2] App purchased OK");a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnPurchaseSuccess,a)},function(b){console.log("[Construct 2] App purchase failed: "+b);a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnPurchaseFail,
a)})}};b.prototype.PurchaseProduct=function(a){if(this.isWindows8){var b=this,c=this.currentApp.licenseInformation.productLicenses;this.currentApp.requestProductPurchaseAsync(a,!1).then(function(){c.hasKey(a)&&c.lookup(a).isActive?(console.log("[Construct 2] Product '"+a+"' purchased OK"),b.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnPurchaseSuccess,b)):(console.log("[Construct 2] Product '"+a+"' purchase finished but product not active (cancelled?)"),b.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnPurchaseFail,
b))},function(c){console.log("[Construct 2] Product '"+a+"' purchase failed: "+c);b.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnPurchaseFail,b)})}};b.prototype.RequestStoreListing=function(){if(this.isWindows8){var a=this;this.currentApp.loadListingInformationAsync().then(function(b){console.log("[Construct 2] Listing information loaded");a.appFormattedPrice=b.formattedPrice;a.lastProductListings=b.productListings;a.runtime.trigger(cr.plugins_.win8.prototype.cnds.OnStoreListing,a)})}};b.prototype.OpenWindowsStore=
function(a){if(this.isWindows8){var b="ms-windows-store:",c=Windows.ApplicationModel.Package.current,f=c.id;switch(a){case 0:b+="PDP?PFN="+f.familyName;break;case 1:b+="Publisher?name="+encodeURIComponent(c.publisherDisplayName);break;case 2:b+="REVIEW?PFN="+f.familyName}console.log("Opening Windows Store: "+b);Windows.System.Launcher.launchUriAsync(new Windows.Foundation.Uri(b))}};m.acts=new b;g.prototype.RoamingValue=function(a,b){if(this.isWindows8){var c=this.roamingValues()[b];a.set_string(c?
c.toString():"")}else a.set_string("")};g.prototype.TrialTimeLeft=function(a){this.isWindows8?a.set_float((this.currentApp.licenseInformation.expirationDate.getTime()-Date.now())/1E3):a.set_float(0)};g.prototype.AppFormattedPrice=function(a){a.set_string(this.appFormattedPrice)};g.prototype.ProductName=function(a,b){var c="";this.isWindows8&&this.lastProductListings&&this.lastProductListings.hasKey(b)&&(c=this.lastProductListings.lookup(b).name);a.set_string(c)};g.prototype.ProductFormattedPrice=
function(a,b){var c="";this.isWindows8&&this.lastProductListings&&this.lastProductListings.hasKey(b)&&(c=this.lastProductListings.lookup(b).formattedPrice);a.set_string(c)};m.exps=new g})();cr.behaviors.Bullet=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(){}var l=cr.behaviors.Bullet.prototype;l.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};l.Type.prototype.onCreate=function(){};l.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var g=l.Instance.prototype;g.onCreate=function(){var a=this.properties[0];this.acc=this.properties[1];this.g=this.properties[2];this.bounceOffSolid=0!==this.properties[3];this.setAngle=0!==this.properties[4];
this.dx=Math.cos(this.inst.angle)*a;this.dy=Math.sin(this.inst.angle)*a;this.lastx=this.inst.x;this.lasty=this.inst.y;this.lastKnownAngle=this.inst.angle;this.travelled=0;this.enabled=0!==this.properties[5]};g.saveToJSON=function(){return{acc:this.acc,g:this.g,dx:this.dx,dy:this.dy,lx:this.lastx,ly:this.lasty,lka:this.lastKnownAngle,t:this.travelled,e:this.enabled}};g.loadFromJSON=function(a){this.acc=a.acc;this.g=a.g;this.dx=a.dx;this.dy=a.dy;this.lastx=a.lx;this.lasty=a.ly;this.lastKnownAngle=a.lka;
this.travelled=a.t;this.enabled=a.e};g.tick=function(){if(this.enabled){var a=this.runtime.getDt(this.inst),b,e;this.inst.angle!==this.lastKnownAngle&&(this.setAngle&&(b=cr.distanceTo(0,0,this.dx,this.dy),this.dx=Math.cos(this.inst.angle)*b,this.dy=Math.sin(this.inst.angle)*b),this.lastKnownAngle=this.inst.angle);0!==this.acc&&(b=cr.distanceTo(0,0,this.dx,this.dy),e=0===this.dx&&0===this.dy?this.inst.angle:cr.angleTo(0,0,this.dx,this.dy),b+=this.acc*a,0>b&&(b=0),this.dx=Math.cos(e)*b,this.dy=Math.sin(e)*
b);0!==this.g&&(this.dy+=this.g*a);this.lastx=this.inst.x;this.lasty=this.inst.y;if(0!==this.dx||0!==this.dy)if(this.inst.x+=this.dx*a,this.inst.y+=this.dy*a,this.travelled+=cr.distanceTo(0,0,this.dx*a,this.dy*a),this.setAngle&&(this.inst.angle=cr.angleTo(0,0,this.dx,this.dy),this.inst.set_bbox_changed(),this.lastKnownAngle=this.inst.angle),this.inst.set_bbox_changed(),this.bounceOffSolid&&(b=this.runtime.testOverlapSolid(this.inst)))this.runtime.registerCollision(this.inst,b),b=cr.distanceTo(0,0,
this.dx,this.dy),e=this.runtime.calculateSolidBounceAngle(this.inst,this.lastx,this.lasty),this.dx=Math.cos(e)*b,this.dy=Math.sin(e)*b,this.inst.x+=this.dx*a,this.inst.y+=this.dy*a,this.inst.set_bbox_changed(),this.setAngle&&(this.lastKnownAngle=this.inst.angle=e,this.inst.set_bbox_changed()),this.runtime.pushOutSolid(this.inst,this.dx/b,this.dy/b,Math.max(2.5*b*a,30))||this.runtime.pushOutSolidNearest(this.inst,100)}};a.prototype.CompareSpeed=function(a,b){return cr.do_cmp(cr.distanceTo(0,0,this.dx,
this.dy),a,b)};a.prototype.CompareTravelled=function(a,b){return cr.do_cmp(this.travelled,a,b)};l.cnds=new a;b.prototype.SetSpeed=function(a){var b=cr.angleTo(0,0,this.dx,this.dy);this.dx=Math.cos(b)*a;this.dy=Math.sin(b)*a};b.prototype.SetAcceleration=function(a){this.acc=a};b.prototype.SetGravity=function(a){this.g=a};b.prototype.SetAngleOfMotion=function(a){a=cr.to_radians(a);var b=cr.distanceTo(0,0,this.dx,this.dy);this.dx=Math.cos(a)*b;this.dy=Math.sin(a)*b};b.prototype.Bounce=function(a){if(a&&
(a=a.getFirstPicked(this.inst))){var b=this.runtime.getDt(this.inst),e=cr.distanceTo(0,0,this.dx,this.dy),f=this.runtime.calculateSolidBounceAngle(this.inst,this.lastx,this.lasty,a);this.dx=Math.cos(f)*e;this.dy=Math.sin(f)*e;this.inst.x+=this.dx*b;this.inst.y+=this.dy*b;this.inst.set_bbox_changed();this.setAngle&&(this.lastKnownAngle=this.inst.angle=f,this.inst.set_bbox_changed());this.bounceOffSolid?this.runtime.pushOutSolid(this.inst,this.dx/e,this.dy/e,Math.max(2.5*e*b,30))||this.runtime.pushOutSolidNearest(this.inst,
100):this.runtime.pushOut(this.inst,this.dx/e,this.dy/e,Math.max(2.5*e*b,30),a)}};b.prototype.SetEnabled=function(a){this.enabled=1===a};l.acts=new b;e.prototype.Speed=function(a){var b=cr.distanceTo(0,0,this.dx,this.dy),b=cr.round6dp(b);a.set_float(b)};e.prototype.Acceleration=function(a){a.set_float(this.acc)};e.prototype.AngleOfMotion=function(a){a.set_float(cr.to_degrees(cr.angleTo(0,0,this.dx,this.dy)))};e.prototype.DistanceTravelled=function(a){a.set_float(this.travelled)};l.exps=new e})();
cr.behaviors.DragnDrop=function(a){this.runtime=a;var b=this;this.runtime.isDomFree||(jQuery(document).mousemove(function(a){b.onMouseMove(a)}),jQuery(document).mousedown(function(a){b.onMouseDown(a)}),jQuery(document).mouseup(function(a){b.onMouseUp(a)}));a=0<this.runtime.fullscreen_mode?document:this.runtime.canvas;this.runtime.isDirectCanvas?a=window.Canvas:this.runtime.isCocoonJs&&(a=window);window.navigator.pointerEnabled?(a.addEventListener("pointerdown",function(a){b.onPointerStart(a)},!1),
a.addEventListener("pointermove",function(a){b.onPointerMove(a)},!1),a.addEventListener("pointerup",function(a){b.onPointerEnd(a)},!1),a.addEventListener("pointercancel",function(a){b.onPointerEnd(a)},!1)):window.navigator.msPointerEnabled?(a.addEventListener("MSPointerDown",function(a){b.onPointerStart(a)},!1),a.addEventListener("MSPointerMove",function(a){b.onPointerMove(a)},!1),a.addEventListener("MSPointerUp",function(a){b.onPointerEnd(a)},!1),a.addEventListener("MSPointerCancel",function(a){b.onPointerEnd(a)},
!1)):(a.addEventListener("touchstart",function(a){b.onTouchStart(a)},!1),a.addEventListener("touchmove",function(a){b.onTouchMove(a)},!1),a.addEventListener("touchend",function(a){b.onTouchEnd(a)},!1),a.addEventListener("touchcancel",function(a){b.onTouchEnd(a)},!1))};
(function(){function a(a){var b,f;b=0;for(f=a.behavior_insts.length;b<f;b++)if(a.behavior_insts[b]instanceof l.Instance)return a.behavior_insts[b];return null}function b(){}function e(){}var l=cr.behaviors.DragnDrop.prototype,g={left:0,top:0};l.onMouseDown=function(a){if(1===a.which)this.onInputDown("leftmouse",a.pageX,a.pageY)};l.onMouseMove=function(a){if(1===a.which)this.onInputMove("leftmouse",a.pageX,a.pageY)};l.onMouseUp=function(a){if(1===a.which)this.onInputUp("leftmouse")};l.onTouchStart=
function(a){a.preventDefault&&a.preventDefault();var b,f,e,d;b=0;for(f=a.changedTouches.length;b<f;b++)e=a.changedTouches[b],d=e.identifier,this.onInputDown(d?d.toString():"<none>",e.pageX,e.pageY)};l.onTouchMove=function(a){a.preventDefault&&a.preventDefault();var b,f,e,d;b=0;for(f=a.changedTouches.length;b<f;b++)e=a.changedTouches[b],d=e.identifier,this.onInputMove(d?d.toString():"<none>",e.pageX,e.pageY)};l.onTouchEnd=function(a){a.preventDefault&&a.preventDefault();var b,f,e;b=0;for(f=a.changedTouches.length;b<
f;b++)e=a.changedTouches[b],e=e.identifier,this.onInputUp(e?e.toString():"<none>")};l.onPointerStart=function(a){a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),this.onInputDown(a.pointerId.toString(),a.pageX,a.pageY))};l.onPointerMove=function(a){a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),this.onInputMove(a.pointerId.toString(),a.pageX,a.pageY))};l.onPointerEnd=function(a){a.pointerType!==
a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),this.onInputUp(a.pointerId.toString()))};l.onInputDown=function(b,e,f){var l=this.runtime.isDomFree?g:jQuery(this.runtime.canvas).offset();e-=l.left;f-=l.top;var d,m,s,q,l=this.my_instances.valuesRef(),t,w,r,x=null;t=0;for(w=l.length;t<w;t++)if(r=l[t],d=a(r),d.enabled&&!d.dragging&&(d=r.layer.canvasToLayer(e,f,!0),m=r.layer.canvasToLayer(e,f,!1),r.update_bbox(),r.contains_pt(d,m)))x?r.layer.index>x.layer.index?
(x=r,s=d,q=m):r.layer.index===x.layer.index&&r.get_zindex()>x.get_zindex()&&(x=r,s=d,q=m):(x=r,s=d,q=m);if(x)a(x).onDown(b,s,q)};l.onInputMove=function(b,e,f){var l=this.runtime.isDomFree?g:jQuery(this.runtime.canvas).offset();e-=l.left;f-=l.top;var d,m=this.my_instances.valuesRef(),s,q,t;s=0;for(q=m.length;s<q;s++)d=m[s],t=a(d),!t.enabled||!t.dragging||t.dragging&&t.dragsource!==b||(l=d.layer.canvasToLayer(e,f,!0),d=d.layer.canvasToLayer(e,f,!1),t.onMove(l,d))};l.onInputUp=function(b){var e=this.my_instances.valuesRef(),
f,g,d;f=0;for(g=e.length;f<g;f++)if(d=e[f],d=a(d),d.dragging&&d.dragsource===b)d.onUp()};l.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};l.Type.prototype.onCreate=function(){};l.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var m=l.Instance.prototype;m.onCreate=function(){this.dragging=!1;this.dy=this.dx=0;this.dragsource="<none>";this.axes=this.properties[0];this.enabled=0!==this.properties[1]};m.saveToJSON=function(){return{enabled:this.enabled}};
m.loadFromJSON=function(a){this.enabled=a.enabled;this.dragging=!1};m.onDown=function(a,b,f){this.dx=b-this.inst.x;this.dy=f-this.inst.y;this.dragging=!0;this.dragsource=a;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.behaviors.DragnDrop.prototype.cnds.OnDragStart,this.inst);this.runtime.isInUserInputEvent=!1};m.onMove=function(a,b){var f=a-this.dx,e=b-this.dy;if(0===this.axes){if(this.inst.x!==f||this.inst.y!==e)this.inst.x=f,this.inst.y=e,this.inst.set_bbox_changed()}else 1===this.axes?
this.inst.x!==f&&(this.inst.x=f,this.inst.set_bbox_changed()):2===this.axes&&this.inst.y!==e&&(this.inst.y=e,this.inst.set_bbox_changed())};m.onUp=function(){this.dragging=!1;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.behaviors.DragnDrop.prototype.cnds.OnDrop,this.inst);this.runtime.isInUserInputEvent=!1};m.tick=function(){};b.prototype.IsDragging=function(){return this.dragging};b.prototype.OnDragStart=function(){return!0};b.prototype.OnDrop=function(){return!0};b.prototype.IsEnabled=
function(){return!!this.enabled};l.cnds=new b;e.prototype.SetEnabled=function(a){this.enabled=0!==a;this.enabled||(this.dragging=!1)};e.prototype.Drop=function(){if(this.dragging)this.onUp()};l.acts=new e;l.exps=new function(){}})();cr.behaviors.Fade=function(a){this.runtime=a};
(function(){function a(){}function b(){}var e=cr.behaviors.Fade.prototype;e.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var l=e.Instance.prototype;l.onCreate=function(){var a=1===this.properties[0];this.fadeInTime=this.properties[1];this.waitTime=this.properties[2];this.fadeOutTime=this.properties[3];this.destroy=this.properties[4];
this.stage=a?0:3;this.recycled?this.stageTime.reset():this.stageTime=new cr.KahanAdder;this.maxOpacity=this.inst.opacity?this.inst.opacity:1;a&&(0===this.fadeInTime?(this.stage=1,0===this.waitTime&&(this.stage=2)):(this.inst.opacity=0,this.runtime.redraw=!0))};l.saveToJSON=function(){return{fit:this.fadeInTime,wt:this.waitTime,fot:this.fadeOutTime,s:this.stage,st:this.stageTime.sum,mo:this.maxOpacity}};l.loadFromJSON=function(a){this.fadeInTime=a.fit;this.waitTime=a.wt;this.fadeOutTime=a.fot;this.stage=
a.s;this.stageTime.reset();this.stageTime.sum=a.st;this.maxOpacity=a.mo};l.tick=function(){this.stageTime.add(this.runtime.getDt(this.inst));0===this.stage&&(this.inst.opacity=this.stageTime.sum/this.fadeInTime*this.maxOpacity,this.runtime.redraw=!0,this.inst.opacity>=this.maxOpacity&&(this.inst.opacity=this.maxOpacity,this.stage=1,this.stageTime.reset()));1===this.stage&&this.stageTime.sum>=this.waitTime&&(this.stage=2,this.stageTime.reset());2===this.stage&&0!==this.fadeOutTime&&(this.inst.opacity=
this.maxOpacity-this.stageTime.sum/this.fadeOutTime*this.maxOpacity,this.runtime.redraw=!0,0>this.inst.opacity&&(this.inst.opacity=0,this.stage=3,this.stageTime.reset(),this.runtime.trigger(cr.behaviors.Fade.prototype.cnds.OnFadeOutEnd,this.inst),1===this.destroy&&this.runtime.DestroyInstance(this.inst)))};l.doStart=function(){this.stage=0;this.stageTime.reset();0===this.fadeInTime?(this.stage=1,0===this.waitTime&&(this.stage=2)):(this.inst.opacity=0,this.runtime.redraw=!0)};a.prototype.OnFadeOutEnd=
function(){return!0};e.cnds=new a;b.prototype.StartFade=function(){3===this.stage&&this.doStart()};b.prototype.RestartFade=function(){this.doStart()};e.acts=new b})();cr.behaviors.Flash=function(a){this.runtime=a};
(function(){function a(){}function b(){}var e=cr.behaviors.Flash.prototype;e.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var l=e.Instance.prototype;l.onCreate=function(){this.timeleft=this.stagetimeleft=this.stage=this.offtime=this.ontime=0};l.saveToJSON=function(){return{ontime:this.ontime,offtime:this.offtime,stage:this.stage,stagetimeleft:this.stagetimeleft,
timeleft:this.timeleft}};l.loadFromJSON=function(a){this.ontime=a.ontime;this.offtime=a.offtime;this.stage=a.stage;this.stagetimeleft=a.stagetimeleft;this.timeleft=a.timeleft};l.tick=function(){if(!(0>=this.timeleft)){var a=this.runtime.getDt(this.inst);this.timeleft-=a;0>=this.timeleft?(this.timeleft=0,this.inst.visible=!0,this.runtime.redraw=!0,this.runtime.trigger(cr.behaviors.Flash.prototype.cnds.OnFlashEnded,this.inst)):(this.stagetimeleft-=a,0>=this.stagetimeleft&&(0===this.stage?(this.inst.visible=
!1,this.stage=1,this.stagetimeleft+=this.offtime):(this.inst.visible=!0,this.stage=0,this.stagetimeleft+=this.ontime),this.runtime.redraw=!0))}};a.prototype.IsFlashing=function(){return 0<this.timeleft};a.prototype.OnFlashEnded=function(){return!0};e.cnds=new a;b.prototype.Flash=function(a,b,c){this.ontime=a;this.offtime=b;this.stage=1;this.stagetimeleft=b;this.timeleft=c;this.inst.visible=!1;this.runtime.redraw=!0};b.prototype.StopFlashing=function(){this.timeleft=0;this.inst.visible=!0;this.runtime.redraw=
!0};e.acts=new b;e.exps=new function(){}})();cr.behaviors.Persist=function(a){this.runtime=a};
(function(){var a=cr.behaviors.Persist.prototype;a.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};a.Type.prototype.onCreate=function(){};a.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var b=a.Instance.prototype;b.onCreate=function(){this.myProperty=this.properties[0]};b.onDestroy=function(){};b.tick=function(){this.runtime.getDt(this.inst)};a.cnds=new function(){};a.acts=new function(){};a.exps=new function(){}})();
cr.behaviors.Pin=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(){}var l=cr.behaviors.Pin.prototype;l.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};l.Type.prototype.onCreate=function(){};l.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var g=l.Instance.prototype;g.onCreate=function(){this.pinObject=null;this.pinObjectUid=-1;this.mode=this.lastKnownAngle=this.theirStartAngle=this.myStartAngle=this.pinDist=this.pinAngle=0;var a=this;this.recycled||
(this.myDestroyCallback=function(b){a.onInstanceDestroyed(b)});this.runtime.addDestroyCallback(this.myDestroyCallback)};g.saveToJSON=function(){return{uid:this.pinObject?this.pinObject.uid:-1,pa:this.pinAngle,pd:this.pinDist,msa:this.myStartAngle,tsa:this.theirStartAngle,lka:this.lastKnownAngle,m:this.mode}};g.loadFromJSON=function(a){this.pinObjectUid=a.uid;this.pinAngle=a.pa;this.pinDist=a.pd;this.myStartAngle=a.msa;this.theirStartAngle=a.tsa;this.lastKnownAngle=a.lka;this.mode=a.m};g.afterLoad=
function(){this.pinObject=-1===this.pinObjectUid?null:this.runtime.getObjectByUID(this.pinObjectUid);this.pinObjectUid=-1};g.onInstanceDestroyed=function(a){this.pinObject==a&&(this.pinObject=null)};g.onDestroy=function(){this.pinObject=null;this.runtime.removeDestroyCallback(this.myDestroyCallback)};g.tick=function(){};g.tick2=function(){if(this.pinObject){this.lastKnownAngle!==this.inst.angle&&(this.myStartAngle=cr.clamp_angle(this.myStartAngle+(this.inst.angle-this.lastKnownAngle)));var a=this.inst.x,
b=this.inst.y;if(3===this.mode||4===this.mode){var e=cr.distanceTo(this.inst.x,this.inst.y,this.pinObject.x,this.pinObject.y);if(e>this.pinDist||4===this.mode&&e<this.pinDist)b=cr.angleTo(this.pinObject.x,this.pinObject.y,this.inst.x,this.inst.y),a=this.pinObject.x+Math.cos(b)*this.pinDist,b=this.pinObject.y+Math.sin(b)*this.pinDist}else a=this.pinObject.x+Math.cos(this.pinObject.angle+this.pinAngle)*this.pinDist,b=this.pinObject.y+Math.sin(this.pinObject.angle+this.pinAngle)*this.pinDist;this.lastKnownAngle=
e=cr.clamp_angle(this.myStartAngle+(this.pinObject.angle-this.theirStartAngle));0!==this.mode&&1!==this.mode&&3!==this.mode&&4!==this.mode||this.inst.x===a&&this.inst.y===b||(this.inst.x=a,this.inst.y=b,this.inst.set_bbox_changed());0!==this.mode&&2!==this.mode||this.inst.angle===e||(this.inst.angle=e,this.inst.set_bbox_changed())}};a.prototype.IsPinned=function(){return!!this.pinObject};l.cnds=new a;b.prototype.Pin=function(a,b){if(a){var e=a.getFirstPicked(this.inst);e&&(this.pinObject=e,this.pinAngle=
cr.angleTo(e.x,e.y,this.inst.x,this.inst.y)-e.angle,this.pinDist=cr.distanceTo(e.x,e.y,this.inst.x,this.inst.y),this.lastKnownAngle=this.myStartAngle=this.inst.angle,this.theirStartAngle=e.angle,this.mode=b)}};b.prototype.Unpin=function(){this.pinObject=null};l.acts=new b;e.prototype.PinnedUID=function(a){a.set_int(this.pinObject?this.pinObject.uid:-1)};l.exps=new e})();cr.behaviors.Rotate=function(a){this.runtime=a};
(function(){function a(){}function b(){}var e=cr.behaviors.Rotate.prototype;e.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var l=e.Instance.prototype;l.onCreate=function(){this.speed=cr.to_radians(this.properties[0]);this.acc=cr.to_radians(this.properties[1])};l.saveToJSON=function(){return{speed:this.speed,acc:this.acc}};l.loadFromJSON=
function(a){this.speed=a.speed;this.acc=a.acc};l.tick=function(){var a=this.runtime.getDt(this.inst);0!==a&&(0!==this.acc&&(this.speed+=this.acc*a),0!==this.speed&&(this.inst.angle=cr.clamp_angle(this.inst.angle+this.speed*a),this.inst.set_bbox_changed()))};e.cnds=new function(){};a.prototype.SetSpeed=function(a){this.speed=cr.to_radians(a)};a.prototype.SetAcceleration=function(a){this.acc=cr.to_radians(a)};e.acts=new a;b.prototype.Speed=function(a){a.set_float(cr.to_degrees(this.speed))};b.prototype.Acceleration=
function(a){a.set_float(cr.to_degrees(this.acc))};e.exps=new b})();cr.behaviors.Sin=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(){}var l=cr.behaviors.Sin.prototype;l.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};l.Type.prototype.onCreate=function(){};l.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime;this.i=0};var g=l.Instance.prototype,m=2*Math.PI,c=Math.PI/2,p=3*Math.PI/2;g.onCreate=function(){this.active=1===this.properties[0];this.movement=this.properties[1];this.wave=this.properties[2];this.period=
this.properties[3];this.period+=Math.random()*this.properties[4];0===this.period?this.i=0:(this.i=this.properties[5]/this.period*m,this.i+=Math.random()*this.properties[6]/this.period*m);this.mag=this.properties[7];this.mag+=Math.random()*this.properties[8];this.ratio=this.initialValue2=this.initialValue=0;this.init()};g.saveToJSON=function(){return{i:this.i,a:this.active,mv:this.movement,w:this.wave,p:this.period,mag:this.mag,iv:this.initialValue,iv2:this.initialValue2,r:this.ratio,lkv:this.lastKnownValue,
lkv2:this.lastKnownValue2}};g.loadFromJSON=function(a){this.i=a.i;this.active=a.a;this.movement=a.mv;this.wave=a.w;this.period=a.p;this.mag=a.mag;this.initialValue=a.iv;this.initialValue2=a.iv2||0;this.ratio=a.r;this.lastKnownValue=a.lkv;this.lastKnownValue2=a.lkv2||0};g.init=function(){switch(this.movement){case 0:this.initialValue=this.inst.x;break;case 1:this.initialValue=this.inst.y;break;case 2:this.initialValue=this.inst.width;this.ratio=this.inst.height/this.inst.width;break;case 3:this.initialValue=
this.inst.width;break;case 4:this.initialValue=this.inst.height;break;case 5:this.initialValue=this.inst.angle;this.mag=cr.to_radians(this.mag);break;case 6:this.initialValue=this.inst.opacity;break;case 7:this.initialValue=0;break;case 8:this.initialValue=this.inst.x,this.initialValue2=this.inst.y}this.lastKnownValue=this.initialValue;this.lastKnownValue2=this.initialValue2};g.waveFunc=function(a){a%=m;switch(this.wave){case 0:return Math.sin(a);case 1:return a<=c?a/c:a<=p?1-2*(a-c)/Math.PI:(a-p)/
c-1;case 2:return 2*a/m-1;case 3:return-2*a/m+1;case 4:return a<Math.PI?-1:1}return 0};g.tick=function(){var a=this.runtime.getDt(this.inst);if(this.active&&0!==a){0===this.period?this.i=0:(this.i+=a/this.period*m,this.i%=m);switch(this.movement){case 0:this.inst.x!==this.lastKnownValue&&(this.initialValue+=this.inst.x-this.lastKnownValue);this.inst.x=this.initialValue+this.waveFunc(this.i)*this.mag;this.lastKnownValue=this.inst.x;break;case 1:this.inst.y!==this.lastKnownValue&&(this.initialValue+=
this.inst.y-this.lastKnownValue);this.inst.y=this.initialValue+this.waveFunc(this.i)*this.mag;this.lastKnownValue=this.inst.y;break;case 2:this.inst.width=this.initialValue+this.waveFunc(this.i)*this.mag;this.inst.height=this.inst.width*this.ratio;break;case 3:this.inst.width=this.initialValue+this.waveFunc(this.i)*this.mag;break;case 4:this.inst.height=this.initialValue+this.waveFunc(this.i)*this.mag;break;case 5:this.inst.angle!==this.lastKnownValue&&(this.initialValue=cr.clamp_angle(this.initialValue+
(this.inst.angle-this.lastKnownValue)));this.inst.angle=cr.clamp_angle(this.initialValue+this.waveFunc(this.i)*this.mag);this.lastKnownValue=this.inst.angle;break;case 6:this.inst.opacity=this.initialValue+this.waveFunc(this.i)*this.mag/100;0>this.inst.opacity?this.inst.opacity=0:1<this.inst.opacity&&(this.inst.opacity=1);break;case 8:this.inst.x!==this.lastKnownValue&&(this.initialValue+=this.inst.x-this.lastKnownValue),this.inst.y!==this.lastKnownValue2&&(this.initialValue2+=this.inst.y-this.lastKnownValue2),
this.inst.x=this.initialValue+Math.cos(this.inst.angle)*this.waveFunc(this.i)*this.mag,this.inst.y=this.initialValue2+Math.sin(this.inst.angle)*this.waveFunc(this.i)*this.mag,this.lastKnownValue=this.inst.x,this.lastKnownValue2=this.inst.y}this.inst.set_bbox_changed()}};g.onSpriteFrameChanged=function(a,b){switch(this.movement){case 2:this.initialValue*=b.width/a.width;this.ratio=b.height/b.width;break;case 3:this.initialValue*=b.width/a.width;break;case 4:this.initialValue*=b.height/a.height}};a.prototype.IsActive=
function(){return this.active};a.prototype.CompareMovement=function(a){return this.movement===a};a.prototype.ComparePeriod=function(a,b){return cr.do_cmp(this.period,a,b)};a.prototype.CompareMagnitude=function(a,b){return 5===this.movement?cr.do_cmp(this.mag,a,cr.to_radians(b)):cr.do_cmp(this.mag,a,b)};a.prototype.CompareWave=function(a){return this.wave===a};l.cnds=new a;b.prototype.SetActive=function(a){this.active=1===a};b.prototype.SetPeriod=function(a){this.period=a};b.prototype.SetMagnitude=
function(a){this.mag=a;5===this.movement&&(this.mag=cr.to_radians(this.mag))};b.prototype.SetMovement=function(a){5===this.movement&&(this.mag=cr.to_degrees(this.mag));this.movement=a;this.init()};b.prototype.SetWave=function(a){this.wave=a};l.acts=new b;e.prototype.CyclePosition=function(a){a.set_float(this.i/m)};e.prototype.Period=function(a){a.set_float(this.period)};e.prototype.Magnitude=function(a){5===this.movement?a.set_float(cr.to_degrees(this.mag)):a.set_float(this.mag)};e.prototype.Value=
function(a){a.set_float(this.waveFunc(this.i)*this.mag)};l.exps=new e})();cr.behaviors.Timer=function(a){this.runtime=a};
(function(){function a(){}function b(){}function e(){}var l=cr.behaviors.Timer.prototype;l.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};l.Type.prototype.onCreate=function(){};l.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var g=l.Instance.prototype;g.onCreate=function(){this.timers={}};g.onDestroy=function(){cr.wipe(this.timers)};g.saveToJSON=function(){var a={},b,e;for(b in this.timers)this.timers.hasOwnProperty(b)&&
(e=this.timers[b],a[b]={c:e.current.sum,t:e.total.sum,d:e.duration,r:e.regular});return a};g.loadFromJSON=function(a){this.timers={};for(var b in a)a.hasOwnProperty(b)&&(this.timers[b]={current:new cr.KahanAdder,total:new cr.KahanAdder,duration:a[b].d,regular:a[b].r},this.timers[b].current.sum=a[b].c,this.timers[b].total.sum=a[b].t)};g.tick=function(){var a=this.runtime.getDt(this.inst),b,e;for(b in this.timers)this.timers.hasOwnProperty(b)&&(e=this.timers[b],e.current.add(a),e.total.add(a))};g.tick2=
function(){var a,b;for(a in this.timers)this.timers.hasOwnProperty(a)&&(b=this.timers[a],b.current.sum>=b.duration&&(b.regular?b.current.sum-=b.duration:delete this.timers[a]))};a.prototype.OnTimer=function(a){a=a.toLowerCase();return(a=this.timers[a])?a.current.sum>=a.duration:!1};l.cnds=new a;b.prototype.StartTimer=function(a,b,e){this.timers[e.toLowerCase()]={current:new cr.KahanAdder,total:new cr.KahanAdder,duration:a,regular:1===b}};b.prototype.StopTimer=function(a){a=a.toLowerCase();this.timers.hasOwnProperty(a)&&
delete this.timers[a]};l.acts=new b;e.prototype.CurrentTime=function(a,b){var e=this.timers[b.toLowerCase()];a.set_float(e?e.current.sum:0)};e.prototype.TotalTime=function(a,b){var e=this.timers[b.toLowerCase()];a.set_float(e?e.total.sum:0)};e.prototype.Duration=function(a,b){var e=this.timers[b.toLowerCase()];a.set_float(e?e.duration:0)};l.exps=new e})();cr.behaviors.bound=function(a){this.runtime=a};
(function(){var a=cr.behaviors.bound.prototype;a.Type=function(a,e){this.behavior=a;this.objtype=e;this.runtime=a.runtime};a.Type.prototype.onCreate=function(){};a.Instance=function(a,e){this.type=a;this.behavior=a.behavior;this.inst=e;this.runtime=a.runtime;this.mode=0};a=a.Instance.prototype;a.onCreate=function(){this.mode=this.properties[0]};a.tick=function(){};a.tick2=function(){this.inst.update_bbox();var a=this.inst.bbox,e=this.inst.layer.layout,l=!1;0===this.mode?(0>this.inst.x&&(this.inst.x=
0,l=!0),0>this.inst.y&&(this.inst.y=0,l=!0),this.inst.x>e.width&&(this.inst.x=e.width,l=!0),this.inst.y>e.height&&(this.inst.y=e.height,l=!0)):(0>a.left&&(this.inst.x-=a.left,l=!0),0>a.top&&(this.inst.y-=a.top,l=!0),a.right>e.width&&(this.inst.x-=a.right-e.width,l=!0),a.bottom>e.height&&(this.inst.y-=a.bottom-e.height,l=!0));l&&this.inst.set_bbox_changed()}})();cr.behaviors.destroy=function(a){this.runtime=a};
(function(){var a=cr.behaviors.destroy.prototype;a.Type=function(a,e){this.behavior=a;this.objtype=e;this.runtime=a.runtime};a.Type.prototype.onCreate=function(){};a.Instance=function(a,e){this.type=a;this.behavior=a.behavior;this.inst=e;this.runtime=a.runtime};a=a.Instance.prototype;a.onCreate=function(){};a.tick=function(){this.inst.update_bbox();var a=this.inst.bbox,e=this.inst.layer.layout;(0>a.right||0>a.bottom||a.left>e.width||a.top>e.height)&&this.runtime.DestroyInstance(this.inst)}})();
cr.getProjectModel=function(){return[null,"Loading",[[cr.plugins_.NinePatch,!1,!0,!0,!0,!1,!0,!0,!0,!0],[cr.plugins_.AJAX,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Arr,!1,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Audio,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.CocoonJSAppForCocoonJS,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.CJSAds,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Dictionary,!1,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Browser,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.GameConfig,!0,!1,!1,!1,!1,!1,!1,!1,
!1],[cr.plugins_.Mouse,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Function,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Spriter,!1,!0,!0,!1,!0,!1,!0,!1,!1],[cr.plugins_.Text,!1,!0,!0,!0,!0,!0,!0,!0,!1],[cr.plugins_.Spritefont2,!1,!0,!0,!0,!0,!0,!0,!0,!0],[cr.plugins_.TiledBg,!1,!0,!0,!0,!0,!0,!0,!0,!0],[cr.plugins_.ShakeItUtils,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.WebStorage,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.win8,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Sprite,!1,!0,!0,!0,!0,!0,!0,!0,!1],[cr.plugins_.Touch,
!0,!1,!1,!1,!1,!1,!1,!1,!1]],[["t0",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,9763594638431152,[["welcometitle_rl1-sheet0.png",7142,0,0,174,136,1,0,0,[],[0.1896550059318543,0.2426470071077347,0.5,0.07352939993143082,0.8275859951972961,0.2205879986286163,0.9310349822044373,0.5,0.7471259832382202,0.6764709949493408,0.5,0.7794119715690613,0.1206900030374527,0.8455880284309387,0.005747130140662193,0.5],0]]]],[],!1,!1,0x9799fe156cdae,[],null],["t1",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
0,!1,1,0,!1,6567802832616715,[["welcometitle_rl4-sheet0.png",15575,0,0,146,154,1,0,0,[],[0.04109590128064156,0.03896100074052811,0.5,0.03896100074052811,0.7808219790458679,0.2077919989824295,0.9520549774169922,0.5,0.910959005355835,0.9155840277671814,0.5,0.8116880059242249,0.3493149876594544,0.6688309907913208,0.1506849974393845,0.5],0]]]],[],!1,!1,0xc2117d4df8bdd,[],null],["t2",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0x8b2980fbe51d7,[["welcometitle_rl3-sheet0.png",11012,0,0,156,
82,1,0,0,[],[0.1666669994592667,0.3170729875564575,0.5,0.0243902001529932,0.8589739799499512,0.2682929933071137,0.9679489731788635,0.5,0.9230769872665405,0.8536589741706848,0.5,0.9756100177764893,0.1025639995932579,0.8048779964447021,0.05128210037946701,0.5],0]]]],[],!1,!1,0xe059e50383c25,[],null],["t3",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,8579052705604636,[["welcometitle_rl2-sheet0.png",8639,0,0,128,77,1,0,0,[],[0.171875,0.2857140004634857,0.5,0.02597399987280369,0.890625,0.1818179935216904,
0.9921879768371582,0.4935060143470764,0.8125,0.6883119940757751,0.5,0.8831170201301575,0.1015629991889,0.8311690092086792,0.125,0.4935060143470764],0]]]],[],!1,!1,7677404869028101,[],null],["t4",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,843392656416685,[["welcometitle_ll3-sheet0.png",6839,0,0,174,127,1,0,0,[],[0.1551720052957535,0.2125979959964752,0.9022989869117737,0.1338579952716827,0.9942529797554016,0.4960629940032959,0.8965520262718201,0.8582680225372314,0.09195400029420853,0.8740159869194031,
0.05172409862279892,0.4960629940032959],0]]]],[],!1,!1,0xce02099f9ac97,[],null],["t5",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,6057449610445546,[["welcometitle_ll2-sheet0.png",14162,0,0,184,110,1,0,0,[],[0.1684779971837997,0.2818180024623871,0.5,0.01818180084228516,0.8369569778442383,0.2727270126342773,0.9402170181274414,0.5,0.8532609939575195,0.7545449733734131,0.5,0.9181820154190063,0.03260869905352593,0.945455014705658,0.05978259816765785,0.5],0]]]],[],!1,!1,7746901693099408,[],
null],["t6",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,9594274433859194,[["welcometitle_ll1-sheet0.png",11895,0,0,122,122,1,0,0,[],[0.08196719735860825,0.08196719735860825,0.5,0.05737699940800667,0.7868850231170654,0.213115006685257,0.9590160250663757,0.5,0.967212975025177,0.967212975025177,0.5,0.8852459788322449,0.3360660076141357,0.6639339923858643,0.1967210024595261,0.5],0]]]],[],!1,!1,7052206392516068,[],null],["t7",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0xfea59f42f2ccf,
[["welcometitle_umbrella-sheet0.png",3241,0,0,127,107,1,0,0,[],[0.03149610012769699,0.03738319873809815,0.4960629940032959,0.0934578999876976,0.7637799978256226,0.2803739905357361,0.8818899989128113,0.4953269958496094,0.9842519760131836,0.9813079833984375,0.4173229932785034,0.5046730041503906,0.4173229932785034,0.4953269958496094],0]]]],[],!1,!1,0xe94a87e9a601b,[],null],["t8",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0x5351c20f95535,[["welcometitle_text-sheet0.png",57354,0,0,408,310,
1,0,0,[],[0.03282830119132996,0.04467349871993065,0.5,0.08591070026159286,0.8257579803466797,0.2371129989624023,0.9772729873657227,0.4982819855213165,0.8939390182495117,0.8556699752807617,0.5,0.9106529951095581,0.05808079987764359,0.9209619760513306],0]]]],[],!1,!1,7676029573256754,[],null],["t9",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,6850414080618734,[["welcometitle_cherry-sheet0.png",3618,0,0,106,123,1,0,0,[],[0.0849056988954544,0.07317069917917252,0.5,0.3170729875564575,0.5471699833869934,
0.3902440071105957,0.9056599736213684,0.4959349930286408,0.8773580193519592,0.8943089842796326,0.5,0.9512190222740173,0.3207550048828125,0.7235770225524902,0.4622640013694763,0.4959349930286408],0]]]],[],!1,!1,0x7954836ddb346,[],null],["t10",cr.plugins_.Sprite,!1,[9864496025830156,4796633116966646,7509804640143008,618760461470411],1,0,null,[["Default",5,!1,1,0,!1,470441786768804,[["btnleaderboard-sheet0.png",23844,0,0,151,158,1,0.503311276435852,0.5,[],[-0.3377482891082764,-0.3417720198631287,-0.006622284650802612,
-0.4746834933757782,0.3245037198066711,-0.3354430198669434,0.4701987504959106,0,0.3377487063407898,0.348101019859314,-0.006622284650802612,0.4683539867401123,-0.3178812861442566,0.3227850198745728,-0.4635761678218842,0],0]]]],[["Persist",cr.behaviors.Persist,9254686496235424]],!1,!1,5850309396678974,[],null],["t11",cr.plugins_.Sprite,!1,[9864496025830156,4796633116966646,7509804640143008,618760461470411],1,0,null,[["Default",5,!1,1,0,!1,6867797037335015,[["btnhowtoplay-sheet0.png",23249,0,0,151,158,
1,0.503311276435852,0.5,[],[-0.3178812861442566,-0.3227850198745728,-0.006622284650802612,-0.4683544039726257,0.3377487063407898,-0.348101019859314,0.476820707321167,0,0.3178807497024536,0.3291140198707581,-0.006622284650802612,0.4683539867401123,-0.3377482891082764,0.3417720198631287,-0.4635761678218842,0],0]]]],[["Persist",cr.behaviors.Persist,9117436927793644]],!1,!1,0xead25e1a6c9f,[],null],["t12",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9796659817152528,[["btnquit-sheet0.png",
7157,0,0,71,78,1,0.5070422291755676,0.5,[],[-0.2957742214202881,-0.3076919913291931,-0.01408421993255615,-0.4230768978595734,0.2957747578620911,-0.3205130100250244,0.436619758605957,0,0.2957747578620911,0.3205130100250244,-0.01408421993255615,0.4358969926834106,-0.3098592162132263,0.3205130100250244,-0.422535240650177,0],0]]],["Hover",5,!1,1,0,!1,8944535114295382,[["btnquit-sheet1.png",7746,0,0,71,78,1,0.5070422291755676,0.5,[],[-0.3239432275295258,-0.3333330154418945,-0.01408421993255615,-0.4487178921699524,
0.3239437937736511,-0.3461540043354034,0.4647887945175171,0,0.3239437937736511,0.3461539745330811,-0.01408421993255615,0.4615380167961121,-0.3239432275295258,0.3333330154418945,-0.4647887349128723,0],0]]]],[],!1,!1,8251078852570319,[],null],["t13",cr.plugins_.Spriter,!1,[],0,0,null,null,[],!1,!1,4958387377317258,[],null],["t14",cr.plugins_.Sprite,!1,[9864496025830156,4796633116966646,7509804640143008,618760461470411,4965048360070996],1,0,null,[["Default",5,!1,1,0,!1,0x3ed2cf4a7b4f7,[["btnplay-sheet0.png",
33010,0,0,214,232,1,0.4953271150588989,0.4913793206214905,[],[-0.3411211371421814,-0.3491383194923401,0.004672884941101074,-0.482758641242981,0.3504669070243835,-0.3491383194923401,0.4859808683395386,0.008620679378509521,0.3411219120025635,0.3577587008476257,0.004672884941101074,0.4827587008476257,-0.3317761123180389,0.3577587008476257,-0.4766355156898499,0.008620679378509521],0]]]],[["Persist",cr.behaviors.Persist,8942535480095462]],!1,!1,0xebfaccef86c8b,[],null],["t15",cr.plugins_.Sprite,!1,[0xaf44ae6b36006],
0,0,null,[["Default",5,!1,1,0,!1,0x7025d0a957846,[["btnprofile-sheet0.png",3032,0,0,99,94,1,0.5050504803657532,0.5,[],[],0]]],["Hover",5,!1,1,0,!1,8284310562738718,[["btnprofile-sheet1.png",3032,0,0,99,94,1,0.5050504803657532,0.5,[],[],0]]]],[],!1,!1,7044675491096877,[],null],["t16",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8465173588222558,[["btngamelist-sheet0.png",2699,0,0,99,94,1,0.5050504803657532,0.5,[],[],0]]],["Hover",5,!1,1,0,!1,0xd7ed480f28ef4,[["btngamelist-sheet1.png",
2700,0,0,99,94,1,0.5050504803657532,0.5,[],[],0]]]],[],!1,!1,5238003733362685,[],null],["t17",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8218970623161466,[["btntinizen-sheet0.png",9901,0,0,117,106,1,0.504273533821106,0.5,[],[],0]]],["Hover",5,!1,1,0,!1,0xa18434552f890,[["btntinizen-sheet1.png",16376,0,0,117,106,1,0.504273533821106,0.5,[],[],0]]]],[],!1,!1,0xbc68977d7422e,[],null],["t18",cr.plugins_.Sprite,!1,[9864496025830156,4796633116966646,7509804640143008,618760461470411,9370590454054224],
0,0,null,[["state0",5,!1,1,0,!1,0xeba4077dbfb18,[["btnselectlevel-sheet0.png",33613,1,1,95,115,1,0.4526315927505493,0.3478260934352875,[],[],0]]],["state1",5,!1,1,0,!1,7240737580555556,[["btnselectlevel-sheet0.png",33613,97,1,95,115,1,0.4526315927505493,0.3478260934352875,[],[],0]]],["state2",5,!1,1,0,!1,5824568902439108,[["btnselectlevel-sheet0.png",33613,1,117,95,115,1,0.4526315927505493,0.3478260934352875,[],[],0]]],["state3",5,!1,1,0,!1,0x7233e9ead2c33,[["btnselectlevel-sheet0.png",33613,97,117,
95,115,1,0.4526315927505493,0.3478260934352875,[],[],0]]],["state4",5,!1,1,0,!1,0x7e7c32d796146,[["btnselectlevel-sheet1.png",19594,1,1,95,115,1,0.4526315927505493,0.3478260934352875,[],[],0]]],["state5",5,!1,1,0,!1,9731221069759054,[["btnselectlevel-sheet1.png",19594,97,1,95,115,1,0.4526315927505493,0.3478260934352875,[],[],0]]]],[],!1,!1,9260762863551380,[],null],["t19",cr.plugins_.Spritefont2,!1,[0xca8747ad9bb25],1,0,["levelfont.png",3550,0],null,[["Pin",cr.behaviors.Pin,5555020934332937]],!1,
!1,0x6d2d3446b982a,[],null],["t20",cr.plugins_.Sprite,!1,[9864496025830156,4796633116966646,7509804640143008,618760461470411],0,0,null,[["Default",5,!1,1,0,!1,0xc9d9015a502af,[["titleselectlevel-sheet0.png",16430,0,0,250,62,1,0.5,0.5,[],[-0.4440000057220459,-0.2741940021514893,0.4599999785423279,-0.3387100100517273,0.4160000085830689,0,0.484000027179718,0.435483992099762,-0.4799999892711639,0.4193549752235413,-0.4280000030994415,0],0]]]],[],!1,!1,6320688204027835,[],null],["t21",cr.plugins_.Sprite,
!1,[0x7534ad5acd71e,5252477848814831,0x863a04003b645,0x7847ae9c3aefa,4687849139865124,8206021773019529,7787530681080265,4593361125132821,5694437029417438,7937148352324737],0,0,null,[["Coming",5,!1,1,0,!1,7501664707637955,[["normalgirl-sheet0.png",39980,1,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Ordered",5,!1,1,0,!1,7181214361294957,[["normalgirl-sheet0.png",39980,180,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",
0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting1",5,!1,1,0,!1,0xf095677754aeb,[["normalgirl-sheet0.png",39980,1,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting2",5,!1,1,0,!1,9512001166224676,[["normalgirl-sheet0.png",39980,180,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting3",5,!1,1,0,!1,0x76627ac81b8be,[["normalgirl-sheet1.png",34486,1,1,178,
197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Served",5,!1,1,0,!1,6384480188483756,[["normalgirl-sheet1.png",34486,180,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Leaving",5,!1,1,0,!1,8508749537271039,[["normalgirl-sheet1.png",34486,1,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]]],[],!1,!1,9442917562550652,
[],null],["t22",cr.plugins_.Sprite,!1,[0x7534ad5acd71e,5252477848814831,0x863a04003b645,0x7847ae9c3aefa,4687849139865124,8206021773019529,7787530681080265,4593361125132821,5694437029417438,7937148352324737],0,0,null,[["Coming",5,!1,1,0,!1,9031654325284532,[["specialboy-sheet0.png",48712,1,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Ordered",5,!1,1,0,!1,5899530536645874,[["specialboy-sheet0.png",48712,180,1,178,197,1,0.5,1,[["Bubble",
0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting1",5,!1,1,0,!1,6712724842721825,[["specialboy-sheet0.png",48712,1,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting2",5,!1,1,0,!1,4941285438486418,[["specialboy-sheet0.png",48712,180,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting3",5,!1,1,0,!1,0xe182de177ab76,[["specialboy-sheet1.png",
40430,1,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Served",5,!1,1,0,!1,811645453645454,[["specialboy-sheet1.png",40430,180,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Leaving",5,!1,1,0,!1,6552390187550943,[["specialboy-sheet1.png",40430,1,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]]],[],!1,!1,0x5f97d1599a61c,
[],null],["t23",cr.plugins_.Sprite,!1,[0x7534ad5acd71e,5252477848814831,0x863a04003b645,0x7847ae9c3aefa,4687849139865124,8206021773019529,7787530681080265,4593361125132821,5694437029417438,7937148352324737],0,0,null,[["Coming",5,!1,1,0,!1,8772944072440276,[["specialgirl-sheet0.png",49788,1,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Ordered",5,!1,1,0,!1,4597207908837437,[["specialgirl-sheet0.png",49788,180,1,178,197,1,0.5,1,[["Bubble",
0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting1",5,!1,1,0,!1,0x7f648e22bc818,[["specialgirl-sheet0.png",49788,1,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting2",5,!1,1,0,!1,7703434867150248,[["specialgirl-sheet0.png",49788,180,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting3",5,!1,1,0,!1,4888302441933224,[["specialgirl-sheet1.png",
44151,1,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Served",5,!1,1,0,!1,0x4e62fc2d5d417,[["specialgirl-sheet1.png",44151,180,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Leaving",5,!1,1,0,!1,0x393568188f328,[["specialgirl-sheet1.png",44151,1,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]]],[],!1,!1,4691250005089292,
[],null],["t24",cr.plugins_.Sprite,!1,[0x7534ad5acd71e,5252477848814831,0x863a04003b645,0x7847ae9c3aefa,4687849139865124,8206021773019529,7787530681080265,4593361125132821,5694437029417438,7937148352324737],0,0,null,[["Coming",5,!1,1,0,!1,0x3e389ced7fd09,[["normalboy-sheet0.png",37416,1,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Ordered",5,!1,1,0,!1,5775063412846841,[["normalboy-sheet0.png",37416,180,1,178,197,1,0.5,1,[["Bubble",
0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting1",5,!1,1,0,!1,5116493941569025,[["normalboy-sheet0.png",37416,1,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting2",5,!1,1,0,!1,9508382907229564,[["normalboy-sheet0.png",37416,180,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting3",5,!1,1,0,!1,0xc46dd1a28a1b3,[["normalboy-sheet1.png",
31556,1,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Served",5,!1,1,0,!1,0x60385a09fb01b,[["normalboy-sheet1.png",31556,180,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Leaving",5,!1,1,0,!1,9838167177701212,[["normalboy-sheet1.png",31556,1,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]]],[],!1,!1,6600591350534733,
[],null],["t25",cr.plugins_.Sprite,!1,[0x7534ad5acd71e,5252477848814831,0x863a04003b645,0x7847ae9c3aefa,4687849139865124,8206021773019529,7787530681080265,4593361125132821,5694437029417438,7937148352324737],0,0,null,[["Coming",5,!1,1,0,!1,7346883329845082,[["vipgirl-sheet0.png",50152,1,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Ordered",5,!1,1,0,!1,5978748240447071,[["vipgirl-sheet0.png",50152,180,1,178,197,1,0.5,1,[["Bubble",0.5,
0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting1",5,!1,1,0,!1,0x7360bd125aad6,[["vipgirl-sheet0.png",50152,1,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting2",5,!1,1,0,!1,9801122327886976,[["vipgirl-sheet0.png",50152,180,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting3",5,!1,1,0,!1,983227324785229,[["vipgirl-sheet1.png",
41203,1,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Served",5,!1,1,0,!1,5185121036863388,[["vipgirl-sheet1.png",41203,180,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Leaving",5,!1,1,0,!1,9725470299832338,[["vipgirl-sheet1.png",41203,1,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]]],[],!1,!1,0xaa541466db32e,
[],null],["t26",cr.plugins_.Sprite,!1,[0x7534ad5acd71e,5252477848814831,0x863a04003b645,0x7847ae9c3aefa,4687849139865124,8206021773019529,7787530681080265,4593361125132821,5694437029417438,7937148352324737],0,0,null,[["Coming",5,!1,1,0,!1,0xbc2c10a010b91,[["vipboy-sheet0.png",56269,1,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Ordered",5,!1,1,0,!1,972807009189933,[["vipboy-sheet0.png",56269,180,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],
["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting1",5,!1,1,0,!1,356557352192153,[["vipboy-sheet0.png",56269,1,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting2",5,!1,1,0,!1,8897262069736008,[["vipboy-sheet0.png",56269,180,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Waiting3",5,!1,1,0,!1,23253789223061,[["vipboy-sheet1.png",46548,1,1,178,197,
1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Served",5,!1,1,0,!1,6051773049983161,[["vipboy-sheet1.png",46548,180,1,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]],["Leaving",5,!1,1,0,!1,9799923308704024,[["vipboy-sheet1.png",46548,1,199,178,197,1,0.5,1,[["Bubble",0.5,0.1015228405594826],["Glass",0.8426966071128845,0.8121827244758606]],[],0]]]],[],!1,!1,0x577af5354d539,[],null],["t27",
cr.plugins_.Sprite,!1,[0x7534ad5acd71e,5252477848814831,0x863a04003b645,0x7847ae9c3aefa,4687849139865124,8206021773019529,7787530681080265,4593361125132821,5694437029417438,7937148352324737],0,0,null,[["Coming",5,!1,1,0,!1,0x568e5c00332a8,[["juno-sheet0.png",55244,1,1,181,230,1,0.5027624368667603,0.947826087474823,[["Bubble",0.5027624368667603,0.1913043409585953],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Ordered",5,!1,1,0,!1,9489362074893284,[["juno-sheet0.png",55244,183,1,181,230,
1,0.5027624368667603,0.947826087474823,[["Bubble",0.5027624368667603,0.1913043409585953],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Waiting1",5,!1,1,0,!1,7910228170016916,[["juno-sheet0.png",55244,1,232,181,230,1,0.5027624368667603,0.947826087474823,[["Bubble",0.5027624368667603,0.1913043409585953],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Waiting2",5,!1,1,0,!1,0x87b25d675a927,[["juno-sheet0.png",55244,183,232,181,230,1,0.5027624368667603,0.947826087474823,[["Bubble",
0.5027624368667603,0.1913043409585953],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Waiting3",5,!1,1,0,!1,0x3e3347e1a3962,[["juno-sheet1.png",42151,1,1,181,230,1,0.5027624368667603,0.947826087474823,[["Bubble",0.5027624368667603,0.1913043409585953],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Served",5,!1,1,0,!1,9309992186136478,[["juno-sheet1.png",42151,183,1,181,230,1,0.5027624368667603,0.947826087474823,[["Bubble",0.5027624368667603,0.1913043409585953],["Glass",0.8453038930892944,
0.813043475151062]],[],0]]],["Leaving",5,!1,1,0,!1,8068885020641725,[["juno-sheet1.png",42151,1,232,181,230,1,0.5027624368667603,0.947826087474823,[["Bubble",0.5027624368667603,0.1913043409585953],["Glass",0.8453038930892944,0.813043475151062]],[],0]]]],[],!1,!1,6940993424549631,[],null],["t28",cr.plugins_.Sprite,!1,[0x7534ad5acd71e,5252477848814831,0x863a04003b645,0x7847ae9c3aefa,4687849139865124,8206021773019529,7787530681080265,4593361125132821,5694437029417438,7937148352324737],0,0,null,[["Coming",
5,!1,1,0,!1,0x7a73f26d72005,[["tera-sheet0.png",90361,1,1,181,230,1,0.5027624368667603,0.9739130139350891,[["Bubble",0.5027624368667603,0.2043478190898895],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Ordered",5,!1,1,0,!1,7196437357260355,[["tera-sheet0.png",90361,183,1,181,230,1,0.5027624368667603,0.9739130139350891,[["Bubble",0.5027624368667603,0.2043478190898895],["Glass",0.8397790193557739,0.813043475151062]],[],0]]],["Waiting1",5,!1,1,0,!1,0x49c24956cd340,[["tera-sheet0.png",90361,
1,232,181,230,1,0.5027624368667603,0.9739130139350891,[["Bubble",0.5027624368667603,0.2043478190898895],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Waiting2",5,!1,1,0,!1,0xe4b9b2ff85101,[["tera-sheet0.png",90361,183,232,181,230,1,0.5027624368667603,0.9739130139350891,[["Bubble",0.5027624368667603,0.2043478190898895],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Waiting3",5,!1,1,0,!1,8133732364449469,[["tera-sheet1.png",67549,1,1,181,230,1,0.5027624368667603,0.9739130139350891,
[["Bubble",0.5027624368667603,0.2043478190898895],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Served",5,!1,1,0,!1,6484093788966164,[["tera-sheet1.png",67549,183,1,181,230,1,0.5027624368667603,0.9739130139350891,[["Bubble",0.5027624368667603,0.2043478190898895],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Leaving",5,!1,1,0,!1,0x4640a8c062ed3,[["tera-sheet1.png",67549,1,232,181,230,1,0.5027624368667603,0.9739130139350891,[["Bubble",0.5027624368667603,0.2043478190898895],["Glass",
0.8453038930892944,0.813043475151062]],[],0]]]],[],!1,!1,9848646519958304,[],null],["t29",cr.plugins_.Sprite,!1,[0x7534ad5acd71e,5252477848814831,0x863a04003b645,0x7847ae9c3aefa,4687849139865124,8206021773019529,7787530681080265,4593361125132821,5694437029417438,7937148352324737],0,0,null,[["Coming",5,!1,1,0,!1,0x6f1050b7c63be,[["kilo-sheet0.png",79756,1,1,181,230,1,0.5027624368667603,0.8826087117195129,[["Bubble",0.5027624368667603,0.1130434796214104],["Glass",0.8453038930892944,0.813043475151062]],
[],0]]],["Ordered",5,!1,1,0,!1,8548952122569673,[["kilo-sheet0.png",79756,183,1,181,230,1,0.5027624368667603,0.8826087117195129,[["Bubble",0.5027624368667603,0.1130434796214104],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Waiting1",5,!1,1,0,!1,4634571015272425,[["kilo-sheet0.png",79756,1,232,181,230,1,0.5027624368667603,0.8826087117195129,[["Bubble",0.5027624368667603,0.1130434796214104],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Waiting2",5,!1,1,0,!1,330984983719138,
[["kilo-sheet0.png",79756,183,232,181,230,1,0.5027624368667603,0.8826087117195129,[["Bubble",0.5027624368667603,0.1130434796214104],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Waiting3",5,!1,1,0,!1,4759642348700692,[["kilo-sheet1.png",62511,1,1,181,230,1,0.5027624368667603,0.8826087117195129,[["Bubble",0.5027624368667603,0.1130434796214104],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Served",5,!1,1,0,!1,7564626517545492,[["kilo-sheet1.png",62511,183,1,181,230,1,0.5027624368667603,
0.8826087117195129,[["Bubble",0.5027624368667603,0.1130434796214104],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Leaving",5,!1,1,0,!1,6646743322231026,[["kilo-sheet1.png",62511,1,232,181,230,1,0.5027624368667603,0.8826087117195129,[["Bubble",0.5027624368667603,0.1130434796214104],["Glass",0.8453038930892944,0.813043475151062]],[],0]]]],[],!1,!1,7445036602813094,[],null],["t30",cr.plugins_.Sprite,!1,[0x7534ad5acd71e,5252477848814831,0x863a04003b645,0x7847ae9c3aefa,4687849139865124,8206021773019529,
7787530681080265,4593361125132821,5694437029417438,7937148352324737],0,0,null,[["Coming",5,!1,1,0,!1,0x7e1b440b25cf7,[["pica-sheet0.png",59683,1,1,181,230,1,0.5027624368667603,0.969565212726593,[["Bubble",0.5027624368667603,0.2000000029802322],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Ordered",5,!1,1,0,!1,9040475038869076,[["pica-sheet0.png",59683,183,1,181,230,1,0.5027624368667603,0.969565212726593,[["Bubble",0.5027624368667603,0.2000000029802322],["Glass",0.8453038930892944,0.813043475151062]],
[],0]]],["Waiting1",5,!1,1,0,!1,5766286198342219,[["pica-sheet0.png",59683,1,232,181,230,1,0.5027624368667603,0.969565212726593,[["Bubble",0.5027624368667603,0.2000000029802322],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Waiting2",5,!1,1,0,!1,8008722343263897,[["pica-sheet0.png",59683,183,232,181,230,1,0.5027624368667603,0.969565212726593,[["Bubble",0.5027624368667603,0.2000000029802322],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Waiting3",5,!1,1,0,!1,861391508651544,
[["pica-sheet1.png",64449,1,1,181,230,1,0.5027624368667603,0.969565212726593,[["Bubble",0.5027624368667603,0.2000000029802322],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Served",5,!1,1,0,!1,8935009772324411,[["pica-sheet1.png",64449,183,1,181,230,1,0.5027624368667603,0.969565212726593,[["Bubble",0.5027624368667603,0.2000000029802322],["Glass",0.8453038930892944,0.813043475151062]],[],0]]],["Leaving",5,!1,1,0,!1,0xdd6c49053ced1,[["pica-sheet1.png",64449,1,232,181,230,1,0.5027624368667603,
0.969565212726593,[["Bubble",0.5027624368667603,0.2000000029802322],["Glass",0.8453038930892944,0.813043475151062]],[],0]]]],[],!1,!1,7109027449926905,[],null],["t31",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9635846970017428,[["scorebox-sheet0.png",15064,0,0,367,65,1,0.5013623833656311,0.5076923370361328,[],[-0.479563981294632,-0.3846153318881989,-0.002724379301071167,-0.461538553237915,0.4822885990142822,-0.4153846502304077,0.4931876063346863,-0.01538434624671936,0.4795635938644409,
0.3846156597137451,-0.002724379301071167,0.4461536407470703,-0.479563981294632,0.3692306876182556,-0.4904631972312927,-0.01538434624671936],0]]]],[],!1,!1,6419250538135345,[],null],["t32",cr.plugins_.Spritefont2,!1,[0x6240b692adf90],0,0,["scorefont.png",6246,0],null,[],!1,!1,919716290106576,[],null],["t33",cr.plugins_.Spritefont2,!1,[],0,0,["scorefont.png",6246,0],null,[],!1,!1,327849979011289,[],null],["t34",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xd8255e1f6567c,[["timebox-sheet0.png",
9293,0,0,218,65,1,0.5045871734619141,0.5076923370361328,[],[-0.4724770784378052,-0.4000003337860107,-0.004587173461914063,-0.4769231379032135,0.4678898453712463,-0.4153846502304077,0.4908258318901062,-0.01538434624671936,0.4633028507232666,0.3846156597137451,-0.004587173461914063,0.430769681930542,-0.4678899645805359,0.3692306876182556,-0.4954128563404083,-0.01538434624671936],0]]]],[],!1,!1,8599642908630507,[],null],["t35",cr.plugins_.Spritefont2,!1,[9847918482695012,0xde5fa05dad47f],1,0,["scorefont.png",
6246,0],null,[["Timer",cr.behaviors.Timer,5171962205723899]],!1,!1,6389559071350331,[],null],["t36",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6101497956604208,[["btnpause-sheet0.png",7108,0,0,71,78,1,0.5070422291755676,0.5,[],[-0.2957742214202881,-0.3076919913291931,-0.01408421993255615,-0.4230768978595734,0.2957747578620911,-0.3205130100250244,0.436619758605957,0,0.2957747578620911,0.3205130100250244,-0.01408421993255615,0.4230769872665405,-0.2957742214202881,0.3076919913291931,-0.422535240650177,
0],0]]],["Hover",5,!1,1,0,!1,9675347914590332,[["btnpause-sheet1.png",7713,0,0,71,78,1,0.5070422291755676,0.5,[],[-0.3239432275295258,-0.3333330154418945,-0.01408421993255615,-0.4615384936332703,0.3239437937736511,-0.3461540043354034,0.4647887945175171,0,0.3239437937736511,0.3461539745330811,-0.01408421993255615,0.4615380167961121,-0.3239432275295258,0.3333330154418945,-0.4647887349128723,0],0]]]],[],!1,!1,8555338571971479,[],null],["t37",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,
0x77195dc58388d,[["btnresume-sheet0.png",9604,0,0,89,97,1,0.5056179761886597,0.5051546096801758,[],[-0.3146069645881653,-0.3298966288566589,-0.01123598217964172,-0.4432989060878754,0.303371012210846,-0.3298966288566589,0.4382020235061646,-0.0103096067905426,0.2921350002288818,0.3092783689498901,-0.01123598217964172,0.4123713970184326,-0.2921349704265595,0.2989693880081177,-0.4269662797451019,-0.0103096067905426],0]]],["Hover",5,!1,1,0,!1,6936543830310964,[["btnresume-sheet1.png",10459,0,0,89,97,1,
0.5056179761886597,0.5051546096801758,[],[-0.3258429765701294,-0.3402066230773926,-0.01123598217964172,-0.4742268025875092,0.3258430361747742,-0.350515604019165,0.4606740474700928,-0.0103096067905426,0.3146070241928101,0.329897403717041,-0.01123598217964172,0.4329894185066223,-0.3146069645881653,0.3195874094963074,-0.4606741666793823,-0.0103096067905426],0]]]],[],!1,!1,0xe10e950eb5fd6,[],null],["t38",cr.plugins_.Sprite,!1,[6723803989352219,5741053672722837,8231228434636449,5412557656467499,0xa53853d9a63c2],
0,0,null,[["Default",5,!1,1,0,!1,8231348379829352,[["pausegamedecor-sheet0.png",4226,0,0,348,67,1,0.5,0.5074626803398132,[["ToSelectLevel",0.2126436829566956,0],["Resume",0.5,0],["Replay",0.7873563170433044,-0.02985074557363987]],[-0.4425286948680878,-0.2089556753635407,0,-0.4626865684986115,0.442529022693634,-0.2089556753635407,0.488506019115448,-0.01492568850517273,0.4454020261764526,0.2089553475379944,0,0.477612316608429,-0.4454022943973541,0.2089553475379944,-0.4942528605461121,-0.01492568850517273],
0]]]],[],!1,!1,7800980161348764,[],null],["t39",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5380777262016642,[["gameprogressbar-sheet0.png",947,0,0,242,20,1,0.5,0.5,[["TopLeft",0.01652892492711544,0.05000000074505806]],[-0.4834710955619812,-0.300000011920929,0,-0.4000000059604645,0.4834709763526917,-0.300000011920929,0.4958680272102356,0,0.4876030087471008,0.3500000238418579,0,0.3999999761581421,-0.4834710955619812,0.300000011920929,-0.4958677589893341,0],0]]]],[],!1,!1,0x60429c87b7fd2,
[],null],["t40",cr.plugins_.TiledBg,!1,[],1,0,["gameprogress.png",420,0],null,[["Pin",cr.behaviors.Pin,8407087471217714]],!1,!1,0xb51684fbebe8d,[],null],["t41",cr.plugins_.Sprite,!1,[0x58183a808c6a2],0,0,null,[["Inactive",5,!1,1,0,!1,6786677284904493,[["gameprogresswin-sheet0.png",680,0,0,21,21,1,0.523809552192688,0.523809552192688,[],[-0.3333335518836975,-0.3333335518836975,-0.04761955142021179,-0.1904765665531158,0.333333432674408,-0.3809525370597839,0.476190447807312,-0.04761955142021179,0.2380954623222351,
0.2380954623222351,-0.04761955142021179,0.3809524178504944,-0.2857145667076111,0.2380954623222351,-0.4761905670166016,-0.04761955142021179],0]]],["Active",5,!1,1,0,!1,8446507208139866,[["gameprogresswin-sheet1.png",713,0,0,21,21,1,0.523809552192688,0.523809552192688,[],[-0.3333335518836975,-0.3333335518836975,-0.04761955142021179,-0.1904765665531158,0.333333432674408,-0.3809525370597839,0.476190447807312,-0.04761955142021179,0.2380954623222351,0.2380954623222351,-0.04761955142021179,0.3809524178504944,
-0.2857145667076111,0.2380954623222351,-0.4761905670166016,-0.04761955142021179],0]]]],[],!1,!1,8704062216364254,[],null],["t42",cr.plugins_.Sprite,!1,[0x58183a808c6a2],0,0,null,[["Inactive",5,!1,1,0,!1,19202704484617,[["gameprogressstar1-sheet0.png",845,0,0,21,21,1,0.523809552192688,0.523809552192688,[],[],0]]],["Active",5,!1,1,0,!1,0x442a59b36fe55,[["gameprogressstar1-sheet1.png",879,0,0,21,21,1,0.523809552192688,0.523809552192688,[],[],0]]]],[],!1,!1,0x48cc8089386dc,[],null],["t43",cr.plugins_.Sprite,
!1,[0x58183a808c6a2],0,0,null,[["Inactive",5,!1,1,0,!1,0xa6fd8f42af892,[["gameprogressstar1-sheet0.png",845,0,0,21,21,1,0.523809552192688,0.523809552192688,[],[],0]]],["Active",5,!1,1,0,!1,6909168221513507,[["gameprogressstar1-sheet1.png",879,0,0,21,21,1,0.523809552192688,0.523809552192688,[],[],0]]]],[],!1,!1,0xc13c5016d3c3d,[],null],["t44",cr.plugins_.Sprite,!1,[0x58183a808c6a2],0,0,null,[["Inactive",5,!1,1,0,!1,4885807784052595,[["gameprogressstar1-sheet0.png",845,0,0,21,21,1,0.523809552192688,
0.523809552192688,[],[],0]]],["Active",5,!1,1,0,!1,0x60baa1362f215,[["gameprogressstar1-sheet1.png",879,0,0,21,21,1,0.523809552192688,0.523809552192688,[],[],0]]]],[],!1,!1,0x95b61d90c3dba,[],null],["t45",cr.plugins_.NinePatch,!1,[],0,0,["9patch.png",406,0],null,[],!1,!1,5709353190212223,[],null],["t46",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,8929219646054341,[["coin_-sheet0.png",2341,0,0,39,44,1,0.5384615659713745,0.4772727191448212,[],[-0.3076925873756409,-0.2727277278900147,-0.05128255486488342,
-0.3863636255264282,0.2564104199409485,-0.295454740524292,0.384615421295166,0.02272728085517883,0.2051284313201904,0.2954542934894562,-0.05128255486488342,0.3636362850666046,-0.2820515632629395,0.2954542934894562,-0.4615384638309479,0.02272728085517883],0]]]],[],!1,!1,5629639057580708,[],null],["t47",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,8742675116854937,[["coin_1_000-sheet0.png",2442,0,0,39,44,1,0.5128205418586731,0.5,[],[-0.2820515632629395,-0.2954549789428711,-0.02564153075218201,
-0.4090909063816071,0.2820514440536499,-0.3181819915771484,0.4358974695205689,0,0.2564104795455933,0.2954549789428711,-0.02564153075218201,0.3409090042114258,-0.256410539150238,0.2727270126342773,-0.4102565348148346,0],0]]]],[],!1,!1,4860255097601106,[],null],["t48",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,420724969606032,[["coin_1_000-sheet0.png",2442,0,0,39,44,1,0,0,[],[0.2307689934968948,0.2045450061559677,0.4871790111064911,0.09090910106897354,0.794871985912323,0.1818179935216904,
0.9487180113792419,0.5,0.7692310214042664,0.7954549789428711,0.4871790111064911,0.8409090042114258,0.2564100027084351,0.7727270126342773,0.1025639995932579,0.5],0]]]],[],!1,!1,693847165793709,[],null],["t49",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,8474741466828644,[["coin_3-sheet0.png",2385,0,0,39,44,1,0,0,[],[0.2307689934968948,0.2045450061559677,0.4871790111064911,0.09090910106897354,0.794871985912323,0.1818179935216904,0.9230769872665405,0.5,0.7435899972915649,0.7727270126342773,
0.4871790111064911,0.8409090042114258,0.2564100027084351,0.7727270126342773,0.1025639995932579,0.5],0]]]],[],!1,!1,8875815040019501,[],null],["t50",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,7027286850719728,[["coin_4-sheet0.png",2044,0,0,39,44,1,0,0,[],[0.2564100027084351,0.2272730022668839,0.4871790111064911,0.09090910106897354,0.7692310214042664,0.2045450061559677,0.8717949986457825,0.5,0.7435899972915649,0.7727270126342773,0.4871790111064911,0.8409090042114258,0.2820509970188141,
0.75,0.1794870048761368,0.5],0]]]],[],!1,!1,0xd92d64e820058,[],null],["t51",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,9717693986571246,[["coin_5-sheet0.png",1607,0,0,39,44,1,0,0,[],[0.2820509970188141,0.25,0.4871790111064911,0.09090910106897354,0.7179489731788635,0.25,0.7692310214042664,0.5,0.6923080086708069,0.7272729873657227,0.4871790111064911,0.8409090042114258,0.3076919913291931,0.7272729873657227,0.2564100027084351,0.5],0]]]],[],!1,!1,6310552371172318,[],null],["t52",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",0,!1,1,0,!1,5201416226289372,[["coin_6-sheet0.png",1245,0,0,39,44,1,0,0,[],[0.3589740097522736,0.3181819915771484,0.4871790111064911,0.09090910106897354,0.6410260200500488,0.3181819915771484,0.6666669845581055,0.5,0.6410260200500488,0.6818180084228516,0.4871790111064911,0.8409090042114258,0.3846150040626526,0.6590909957885742,0.3589740097522736,0.5],0]]]],[],!1,!1,0xb8b195e818394,[],null],["t53",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0x7917acc9f4d52,[["coin_7-sheet0.png",
452,0,0,39,44,1,0,0,[],[0.4358969926834106,0.3863640129566193,0.4871790111064911,0.09090910106897354,0.6153849959373474,0.3409090042114258,0.6153849959373474,0.6590909957885742,0.4871790111064911,0.8409090042114258,0.4358969926834106,0.6136360168457031],0]]]],[],!1,!1,0xb82a57b427327,[],null],["t54",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0x3cd2ad29f17c3,[["coin_8-sheet0.png",1189,0,0,39,44,1,0,0,[],[0.3846150040626526,0.3409090042114258,0.4871790111064911,0.09090910106897354,0.6666669845581055,
0.2954550087451935,0.6923080086708069,0.5,0.6666669845581055,0.7045450210571289,0.4871790111064911,0.8409090042114258,0.3846150040626526,0.6590909957885742],0]]]],[],!1,!1,0x44a6098f981e5,[],null],["t55",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,468285380397533,[["coin_9-sheet0.png",1615,0,0,39,44,1,0,0,[],[0.3076919913291931,0.2727270126342773,0.4871790111064911,0.09090910106897354,0.7435899972915649,0.2272730022668839,0.7692310214042664,0.5,0.7179489731788635,0.75,0.4871790111064911,
0.8409090042114258,0.3333329856395721,0.7045450210571289,0.2820509970188141,0.5],0]]]],[],!1,!1,0x9aa659a838671,[],null],["t56",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,5548318308246023,[["coin_10-sheet0.png",2416,0,0,39,44,1,0,0,[],[0.2307689934968948,0.2045450061559677,0.4871790111064911,0.09090910106897354,0.794871985912323,0.1818179935216904,0.9230769872665405,0.5,0.7692310214042664,0.7954549789428711,0.4871790111064911,0.8409090042114258,0.2564100027084351,0.7727270126342773,
0.1282050013542175,0.5],0]]]],[],!1,!1,636100132707602,[],null],["t57",cr.plugins_.Sprite,!1,[],2,0,null,[["Bubble1",5,!1,1,0,!1,7262301793014423,[["bubble-sheet0.png",9947,1,102,174,66,1,0.5,1,[["Order",0.5,0.3939394056797028]],[],0]]],["Bubble2",5,!1,1,0,!1,7197157514417658,[["bubble-sheet0.png",9947,1,1,174,100,1,0.5,1,[["Order",0.5,0.4399999976158142]],[],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,8591073092141803],["Pin",cr.behaviors.Pin,9660349504026416]],!1,!1,4803038746260393,[],
null],["t58",cr.plugins_.Spritefont2,!1,[],2,0,["bubbleorder.png",15124,0],null,[["DestroyOutsideLayout",cr.behaviors.destroy,8102775619417853],["Pin",cr.behaviors.Pin,8516482485904024]],!1,!1,5477253572582037,[],null],["t59",cr.plugins_.Sprite,!1,[6859197501008199],0,0,null,[["Default",5,!1,1,0,!1,690741032987003,[["drink-sheet0.png",27634,1,1,92,98,1,0.5,0.5,[],[],0]]],["Juice",0,!1,1,0,!1,0x6d01c35ef03d9,[["drink-sheet0.png",27634,94,1,92,98,1,0.5,0.5,[],[],0],["drink-sheet0.png",27634,1,100,92,
98,1,0.5,0.5,[],[],0],["drink-sheet0.png",27634,94,100,92,98,1,0.5,0.5,[],[],0]]],["Water",0,!1,1,0,!1,395915211374905,[["drink-sheet1.png",21618,1,1,92,98,1,0.5,0.5,[],[],0],["drink-sheet1.png",21618,94,1,92,98,1,0.5,0.5,[],[],0],["drink-sheet1.png",21618,1,100,92,98,1,0.5,0.5,[],[],0]]],["Milk",0,!1,1,0,!1,4730138756750839,[["drink-sheet1.png",21618,94,100,92,98,1,0.5,0.5,[],[],0],["drink-sheet2.png",12378,1,1,92,98,1,0.5,0.5,[],[],0],["drink-sheet2.png",12378,94,1,92,98,1,0.5,0.5,[],[],0]]]],[],
!1,!1,891916029848815,[],null],["t60",cr.plugins_.Sprite,!1,[0xce3d314edff5d],0,0,null,[["Default",5,!1,1,0,!1,4630101149216624,[["fruit-sheet0.png",169551,1,1,120,79,1,0.5,0.5063291192054749,[],[-0.3666670024394989,-0.3037971258163452,0,-0.4556962251663208,0.375,-0.316456139087677,0.4916669726371765,-0.01265811920166016,0.3916670083999634,0.3291139006614685,0,0.4810128808021545,-0.3833329975605011,0.3164559006690979,-0.4749999940395355,-0.01265811920166016],0]]],["Banana",5,!1,1,0,!1,4961346084996903,
[["fruit-sheet0.png",169551,122,1,120,79,1,0.5,0.5063291192054749,[],[],0],["fruit-sheet0.png",169551,243,1,120,79,1,0.5,0.5063291192054749,[],[],0],["fruit-sheet0.png",169551,364,1,120,79,1,0.5,0.5063291192054749,[],[],0]]],["Kiwi",5,!1,1,0,!1,4845604513347338,[["fruit-sheet0.png",169551,1,81,120,79,1,0.5,0.5063291192054749,[],[],0],["fruit-sheet0.png",169551,122,81,120,79,1,0.5,0.5063291192054749,[],[],0],["fruit-sheet0.png",169551,243,81,120,79,1,0.5,0.5063291192054749,[],[],0]]],["Tomato",5,!1,
1,0,!1,7989362365110289,[["fruit-sheet0.png",169551,364,81,120,79,1,0.5,0.5063291192054749,[],[],0],["fruit-sheet0.png",169551,1,161,120,79,1,0.5,0.5063291192054749,[],[],0],["fruit-sheet0.png",169551,122,161,120,79,1,0.5,0.5063291192054749,[],[],0]]],["Chocolate",5,!1,1,0,!1,0xee549cc53cfe2,[["fruit-sheet0.png",169551,243,161,120,79,1,0.5,0.5063291192054749,[],[],0],["fruit-sheet0.png",169551,364,161,120,79,1,0.5,0.5063291192054749,[],[],0],["fruit-sheet0.png",169551,1,241,120,79,1,0.5,0.5063291192054749,
[],[],0]]],["Candy",5,!1,1,0,!1,0x4d5b27f60f45a,[["fruit-sheet0.png",169551,122,241,120,79,1,0.5,0.5063291192054749,[],[],0],["fruit-sheet0.png",169551,243,241,120,79,1,0.5,0.5063291192054749,[],[],0],["fruit-sheet0.png",169551,364,241,120,79,1,0.5,0.5063291192054749,[],[],0]]],["IceCream",5,!1,1,0,!1,5293958983422071,[["fruit-sheet0.png",169551,1,321,120,79,1,0.5,0.5063291192054749,[],[],0],["fruit-sheet0.png",169551,122,321,120,79,1,0.5,0.5063291192054749,[],[],0],["fruit-sheet0.png",169551,243,
321,120,79,1,0.5,0.5063291192054749,[],[],0]]]],[],!1,!1,0xb3cc5bf9b1520,[],null],["t61",cr.plugins_.Sprite,!1,[535754656809885],2,0,null,[["Empty",5,!1,1,0,!1,0xfcca1458f4552,[["glassdrink-sheet0.png",2841,1,1,39,58,1,0.5384615659713745,0.9655172228813171,[],[-0.435897558927536,-0.8965517282485962,-0.05128255486488342,-0.9482758045196533,0.3589744567871094,-0.8965517282485962,0.4615384340286255,-0.4655172228813171,0.384615421295166,-0.01724123954772949,-0.05128255486488342,0.03448277711868286,-0.435897558927536,
-0.03448224067687988,-0.4871794581413269,-0.4655172228813171],0]]],["Filled",5,!1,1,0,!1,0xb5b7c0898b90,[["glassdrink-sheet0.png",2841,41,1,39,58,1,0.5384615659713745,0.9655172228813171,[],[],0]]],["Filling",22.5,!1,1,0,!1,0x9836ca128d53b,[["glassdrink-sheet0.png",2841,81,1,39,58,1,0.5384615659713745,0.9655172228813171,[],[],0],["glassdrink-sheet0.png",2841,1,60,39,58,1,0.5384615659713745,0.9655172228813171,[],[],0],["glassdrink-sheet0.png",2841,41,60,39,58,1,0.5384615659713745,0.9655172228813171,
[],[],0],["glassdrink-sheet0.png",2841,81,60,39,58,1,0.5384615659713745,0.9655172228813171,[],[],0],["glassdrink-sheet1.png",3180,1,1,39,58,1,0.5384615659713745,0.9655172228813171,[],[],0],["glassdrink-sheet1.png",3180,41,1,39,58,1,0.5384615659713745,0.9655172228813171,[],[],0],["glassdrink-sheet1.png",3180,81,1,39,58,1,0.5384615659713745,0.9655172228813171,[],[],0],["glassdrink-sheet1.png",3180,1,60,39,58,1,0.5384615659713745,0.9655172228813171,[],[],0],["glassdrink-sheet1.png",3180,41,60,39,58,
1,0.5384615659713745,0.9655172228813171,[],[],0]]]],[["Pin",cr.behaviors.Pin,6393555203393224],["Fade",cr.behaviors.Fade,8120196191606572]],!1,!1,0x565a9b3244039,[],null],["t62",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4854525497454559,[["mixerbase-sheet0.png",18325,0,0,194,112,1,0.5,0.5,[],[-0.3762890100479126,-0.2857140004634857,0,-0.4642857015132904,0.3762890100479126,-0.2857140004634857,0.4793810248374939,0,0.4432989954948425,0.4017859697341919,0,0.3928570151329041,-0.4690721929073334,
0.4464290142059326,-0.4793814122676849,0],0]]]],[],!1,!1,7442957363975265,[],null],["t63",cr.plugins_.Sprite,!1,[],6,0,null,[["Default",5,!1,1,0,!1,6600282010052176,[["glass-sheet0.png",5095,0,0,88,117,1,0.3068181872367859,0.9572649598121643,[],[-0.04545417428016663,-0.8974361419677734,0.2613638043403626,-0.9572649598121643,0.579545795917511,-0.8717948794364929,0.579545795917511,-0.4358979463577271,0.4772728085517883,-0.1025639772415161,0.2499998211860657,0.04273504018783569,-0.3068181872367859,0.04273504018783569,
-0.3068181872367859,-0.8205129504203796],0]]]],[["DragDrop",cr.behaviors.DragnDrop,0xf3ffc02f76ad0],["Sine",cr.behaviors.Sin,8819210541456048],["Timer",cr.behaviors.Timer,0xacb426d3bd53a],["Pin",cr.behaviors.Pin,4770244040678005],["Fade",cr.behaviors.Fade,9480084635459868],["BoundToLayout",cr.behaviors.bound,0x776ed0a50911a]],!1,!1,7268972316553724,[],null],["t64",cr.plugins_.Sprite,!1,[6374660358708245,6220052557403154],0,0,null,[["Default",5,!1,1,0,!1,7894195306745613,[["mixerdrink-sheet0.png",
42038,1,1,122,132,1,0.5081967115402222,0.5,[],[-0.204917699098587,-0.2196969985961914,-0.008196711540222168,-0.25,0.1639342904090881,-0.1969699859619141,0.4344263076782227,0,0.3442623019218445,0.3636360168457031,-0.008196711540222168,0.5,-0.3934427201747894,0.3939390182495117,-0.4590164124965668,0],0]]],["Juice",5,!1,1,0,!1,9168743183499216,[["mixerdrink-sheet0.png",42038,124,1,122,132,1,0.5081967115402222,0.5,[],[-0.2131147086620331,-0.2272729873657227,-0.008196711540222168,-0.25,0.1721312999725342,
-0.2045449912548065,0.4344263076782227,0,0.3524593114852905,0.3712120056152344,-0.008196711540222168,0.5,-0.4016396999359131,0.401515007019043,-0.4590164124965668,0],0]]],["Milk",5,!1,1,0,!1,0x69d59433e4adb,[["mixerdrink-sheet0.png",42038,247,1,122,132,1,0.5081967115402222,0.5227272510528564,[],[-0.2131147086620331,-0.2500002384185791,-0.008196711540222168,-0.2651512622833252,0.1639342904090881,-0.2196972370147705,0.4262292981147766,-0.02272725105285645,0.3442623019218445,0.3409087657928467,-0.008196711540222168,
0.4772727489471436,-0.4016396999359131,0.3787877559661865,-0.4672131240367889,-0.02272725105285645],0]]],["Water",5,!1,1,0,!1,5819250065480266,[["mixerdrink-sheet0.png",42038,370,1,122,132,1,0.5081967115402222,0.5,[],[-0.2131147086620331,-0.2272729873657227,-0.008196711540222168,-0.25,0.1721312999725342,-0.2045449912548065,0.4344263076782227,0,0.3524593114852905,0.3712120056152344,-0.008196711540222168,0.5,-0.4016396999359131,0.401515007019043,-0.4590164124965668,0],0]]],["Twirl",20,!1,5,0,!1,8673031121319729,
[["mixerdrink-sheet0.png",42038,1,134,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet0.png",42038,124,134,122,132,1,0.5,0.5,[],[],0]]],["Done",40,!1,0,0,!1,4805945140909729,[["mixerdrink-sheet0.png",42038,247,134,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet0.png",42038,370,134,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet0.png",42038,1,267,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet0.png",42038,124,267,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet0.png",42038,247,267,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet0.png",
42038,370,267,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet1.png",2502,1,1,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet1.png",2502,124,1,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet1.png",2502,247,1,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet1.png",2502,370,1,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet1.png",2502,1,134,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet1.png",2502,124,134,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet1.png",2502,247,134,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet1.png",
2502,370,134,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet1.png",2502,1,267,122,132,1,0.5,0.5,[],[],0],["mixerdrink-sheet1.png",2502,124,267,122,132,1,0.5,0.5,[],[],0]]]],[],!1,!1,9758542443069204,[],null],["t65",cr.plugins_.Sprite,!1,[9396212253068248],0,0,null,[["Default",5,!1,1,0,!1,0xfc5d7e0f7f358,[["mixerfront-sheet0.png",8950,0,0,199,158,1,0.5025125741958618,0.5,[],[-0.2713565826416016,-0.2088609933853149,-0.005025565624237061,-0.4430379867553711,0.4170854091644287,-0.3987340033054352,0.4271354079246521,
0,0.3718594312667847,0.3417720198631287,-0.005025565624237061,0.4556959867477417,-0.1608035862445831,0.06962001323699951,-0.2361805737018585,0],0]]]],[],!1,!1,7820842394937243,[],null],["t66",cr.plugins_.Sprite,!1,[0x407572096e81d],2,0,null,[["Default",5,!1,1,0,!1,7396396765478601,[["mixerfruit-sheet0.png",2401,1,1,29,24,1,0.517241358757019,0.5,[],[-0.1379313468933106,-0.04166701436042786,-0.03448235988616943,-0.125,0.4137936234474182,-0.4166666865348816,0.0689656138420105,0,0.3448276519775391,0.3333330154418945,
-0.03448235988616943,0.08333301544189453,-0.4827585518360138,0.4583330154418945,-0.4137933552265167,0],0]]],["Banana",5,!1,1,0,!1,0x6ee3a5d0f502d,[["mixerfruit-sheet0.png",2401,31,1,29,24,1,0.517241358757019,0.5,[],[-0.3103443384170532,-0.25,-0.03448235988616943,-0.4166666865348816,0.2068966627120972,-0.1666670143604279,0.2758616209030151,0,0.3103446364402771,0.2916669845581055,-0.03448235988616943,0.4583330154418945,-0.2413793504238129,0.1666669845581055,-0.3103443384170532,0],0]]],["Kiwi",5,!1,
1,0,!1,0xfa264166babe0,[["mixerfruit-sheet0.png",2401,1,26,29,24,1,0.517241358757019,0.5,[],[-0.3103443384170532,-0.25,-0.03448235988616943,-0.3333330154418945,0.2758616209030151,-0.25,0.379310667514801,0,0.2758616209030151,0.25,-0.03448235988616943,0.3333330154418945,-0.2758623659610748,0.2083330154418945,-0.3793103694915772,0],0]]],["Tomato",5,!1,1,0,!1,0xe67d3e08ee794,[["mixerfruit-sheet0.png",2401,31,26,29,24,1,0.517241358757019,0.5,[],[-0.103448361158371,0,-0.03448235988616943,-0.125,0.3103446364402771,
-0.2916669845581055,0.3448276519775391,0,0.2758616209030151,0.25,-0.03448235988616943,0.5,-0.3448273539543152,0.2916669845581055,-0.1379313468933106,0],0]]],["Chocolate",5,!1,1,0,!1,0x8cea73323d63b,[["mixerfruit-sheet1.png",2440,1,1,29,24,1,0.517241358757019,0.5,[],[-0.3103443384170532,-0.25,-0.03448235988616943,-0.375,0.2758616209030151,-0.25,0.379310667514801,0,0.3103446364402771,0.2916669845581055,-0.03448235988616943,0.4583330154418945,-0.3103443384170532,0.25,-0.3793103694915772,0],0]]],["Candy",
5,!1,1,0,!1,0x8f357e62ce8e0,[["mixerfruit-sheet1.png",2440,31,1,29,24,1,0.517241358757019,0.5,[],[-0.1379313468933106,-0.04166701436042786,-0.03448235988616943,-0.125,0.4137936234474182,-0.4166666865348816,0.0689656138420105,0,0.3448276519775391,0.3333330154418945,-0.03448235988616943,0.08333301544189453,-0.4827585518360138,0.4583330154418945,-0.4137933552265167,0],0]]],["IceCream",5,!1,1,0,!1,0x82abd966d5b5e,[["mixerfruit-sheet1.png",2440,1,26,29,24,1,0.517241358757019,0.5,[],[-0.2758623659610748,
-0.2083329856395721,-0.03448235988616943,-0.3333330154418945,0.2413796186447144,-0.2083329856395721,0.379310667514801,0,0.3448276519775391,0.3333330154418945,-0.03448235988616943,0.4583330154418945,-0.3793103694915772,0.3333330154418945,-0.3793103694915772,0],0]]]],[["SineVertical",cr.behaviors.Sin,5251711427626458],["SineHorizontal",cr.behaviors.Sin,6248337065808956]],!1,!1,996260066662934,[],null],["t67",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xabf2b3ad83c54,[["trash-sheet0.png",
11940,1,1,118,61,1,0.5,0.5081967115402222,[],[],0]]],["Active",5,!1,1,0,!1,7327927866552612,[["trash-sheet0.png",11940,1,63,118,61,1,0.5,0.5081967115402222,[],[],0]]]],[],!1,!1,6859483231638059,[],null],["t68",cr.plugins_.Spriter,!1,[],0,0,null,null,[],!1,!1,5422752262972657,[],null],["t69",cr.plugins_.Spritefont2,!1,[],2,0,["cashfont.png",23025,0],null,[["Bullet",cr.behaviors.Bullet,6816454491947272],["Fade",cr.behaviors.Fade,0x96f824befbb98]],!1,!1,0xc283e8b840eb3,[],null],["t70",cr.plugins_.Arr,
!1,[],0,0,null,null,[],!0,!1,0xc3fb4adc34a2f,[],null],["t71",cr.plugins_.Sprite,!1,[],0,0,null,[["Dawn",5,!1,1,0,!1,5040993968571087,[["background-sheet0.png",1261324,1,1,1080,720,1,0.5,0.5,[],[],0]]],["Afternoon",5,!1,1,0,!1,0x5f4766065ba5c,[["background-sheet0.png",1261324,1,722,1080,720,1,0.5,0.5,[],[],0]]],["Sunset",5,!1,1,0,!1,0x7ff05ad7bf90,[["background-sheet1.png",673182,0,0,1080,720,1,0.5,0.5,[],[],1]]]],[],!1,!1,0x9bbf90eb9a4a0,[],null],["t72",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,9512783127846804,[["table-sheet0.png",286752,0,0,1080,720,1,0.5,0.5,[["Glass",0.7064814567565918,0.7902777791023254],["Customer1",0.2546296417713165,0.5902777910232544],["Customer2",0.4972222149372101,0.5902777910232544],["Customer3",0.7314814925193787,0.5902777910232544]],[-0.4222221970558167,-0.3833329975605011,0,0.01805597543716431,0.4203699827194214,-0.3805559873580933,0.4009259939193726,0,0.5,0.5,-0.5,0.5,-0.4027777910232544,0],0]]]],[],!1,!1,4755549201717408,[],null],["t73",cr.plugins_.Text,
!1,[],0,0,null,null,[],!1,!0,449491146088631,[],null],["t74",cr.plugins_.Text,!1,[6430110689074295],0,0,null,null,[],!1,!0,649015402051535,[],null],["t75",cr.plugins_.Sprite,!1,[],2,0,null,[["Blue",5,!1,1,0,!1,0x8ad6b4e4e2a9d,[["loadingcircle-sheet0.png",1239,1,1,50,50,1,0.5,3.5,[],[-0.3400000035762787,-3.339999914169312,0,-3.480000019073486,0.3600000143051148,-3.359999895095825,0.5,-3,0.3600000143051148,-2.639999866485596,0,-2.519999980926514,-0.3400000035762787,-2.660000085830689,-0.4799999892711639,
-3],0]]],["Pink",5,!1,1,0,!1,453082489831669,[["loadingcircle-sheet0.png",1239,52,1,50,50,1,-2.5,0.5,[],[2.660000085830689,-0.3400000035762787,3,-0.4799999892711639,3.339999914169312,-0.3400000035762787,3.5,0,3.360000133514404,0.3600000143051148,3,0.5,2.660000085830689,0.3399999737739563,2.519999980926514,0],0]]],["Yellow",5,!1,1,0,!1,727474685029514,[["loadingcircle-sheet0.png",1239,1,52,50,50,1,0.5,-2.5,[],[-0.3199999928474426,2.680000066757202,0,2.519999980926514,0.3399999737739563,2.660000085830689,
0.5,3,0.3600000143051148,3.360000133514404,0,3.5,-0.3400000035762787,3.339999914169312,-0.4799999892711639,3],0]]],["Green",5,!1,1,0,!1,0xf8e18f646e352,[["loadingcircle-sheet0.png",1239,52,52,50,50,1,3.5,0.5,[],[-3.339999914169312,-0.3400000035762787,-3,-0.4799999892711639,-2.639999866485596,-0.3600000143051148,-2.5,0,-2.639999866485596,0.3600000143051148,-3,0.4800000190734863,-3.339999914169312,0.3399999737739563,-3.480000019073486,0],0]]]],[["Rotate",cr.behaviors.Rotate,8025368097098624],["Sine",
cr.behaviors.Sin,9991345988041400]],!1,!0,8291843309776138,[],null],["t76",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,5234326775798592,[["endgamegoldstar_s2-sheet0.png",375,0,0,23,22,1,0,0,[],[0.3478260040283203,0.3636359870433807,0.4782609939575195,0.09090910106897354,0.6521739959716797,0.3636359870433807,0.9130430221557617,0.5,0.7391300201416016,0.7272729873657227,0.4782609939575195,0.8636360168457031,0.2173909991979599,0.7727270126342773,0.1304350048303604,0.5],0]]]],[],!1,!1,9435831979574206,
[],null],["t77",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,5020822204971355,[["endgamegoldstar_s2-sheet0.png",375,0,0,23,22,1,0.52173912525177,0.5,[],[-0.1739131212234497,-0.1363640129566193,-0.04347813129425049,-0.4090909063816071,0.1304348707199097,-0.1363640129566193,0.3913038969039917,0,0.2173908948898315,0.2272729873657227,-0.04347813129425049,0.3636360168457031,-0.3043481111526489,0.2727270126342773,-0.3913041353225708,0],0]]]],[],!1,!1,7803522843733708,[],null],["t78",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",0,!1,1,0,!1,0x92e032f37e37c,[["endgamegoldstar_s5-sheet0.png",187,0,0,7,8,1,0,0,[],[0.4285709857940674,0.375,0.4285709857940674,0.125,0.7142860293388367,0.25,1,0.5,0.857142984867096,0.875,0.4285709857940674,0.875,0.4285709857940674,0.625,0.1428570002317429,0.5],0]]]],[],!1,!1,0xb361f518ebab1,[],null],["t79",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0xe9ab533330e69,[["endgamegoldstar_s4-sheet0.png",275,0,0,13,14,1,0,0,[],[0.3076919913291931,0.2857140004634857,
0.4615379869937897,0.07142859697341919,0.7692310214042664,0.2142859995365143,0.846153974533081,0.5,0.7692310214042664,0.7857139706611633,0.4615379869937897,0.9285709857940674,0.3076919913291931,0.7142860293388367,0.07692310214042664,0.5],0]]]],[],!1,!1,0xf358f2eef5423,[],null],["t80",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0x407fb663d1a76,[["endgamegoldstar_s3-sheet0.png",202,0,0,9,10,1,0,0,[],[0.4444440007209778,0.4000000059604645,0.4444440007209778,0.300000011920929,0.6666669845581055,
0.300000011920929,0.8888890147209167,0.5,0.7777779698371887,0.800000011920929,0.4444440007209778,1,0.3333329856395721,0.699999988079071,0.1111110001802445,0.5],0]]]],[],!1,!1,4966112766784638,[],null],["t81",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0xdcff2a3f1f65e,[["endgamegoldstar_s6-sheet0.png",211,0,0,10,12,1,0,0,[],[0.4000000059604645,0.3333329856395721,0.5,0.25,0.6000000238418579,0.3333329856395721,1,0.5,0.8999999761581421,0.9166669845581055,0.5,0.8333330154418945,0.2000000029802322,
0.8333330154418945,0.300000011920929,0.5],0]]]],[],!1,!1,0x81a087922f9cd,[],null],["t82",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,6297266326896493,[["endgamegoldstar_s1-sheet0.png",3821,0,0,56,58,1,0.5178571343421936,0.517241358757019,[],[-0.2321431338787079,-0.2413793504238129,-0.0178571343421936,-0.4655172526836395,0.178571879863739,-0.2241383492946625,0.4642858505249023,-0.01724135875701904,0.3571428656578064,0.3620686531066895,-0.0178571343421936,0.379310667514801,-0.3750001192092896,
0.3448276519775391,-0.482142835855484,-0.01724135875701904],0]]]],[],!1,!1,7905717347889116,[],null],["t83",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,6250810610395728,[["endgamegraystar_s7-sheet0.png",3252,0,0,56,58,1,0.4821428656578064,0.517241358757019,[],[0.0178571343421936,-0.4482758641242981,0.2142861485481262,-0.2241383492946625,0.5000001192092896,-0.01724135875701904,0.3928571343421936,0.3620686531066895,0.0178571343421936,0.379310667514801,-0.3392858505249023,0.3448276519775391,
-0.4464285671710968,-0.01724135875701904],0]]]],[],!1,!1,0x933a4703dcd23,[],null],["t84",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,9628630343548416,[["resultmessagelose_bg-sheet0.png",17590,0,0,1080,207,1,0,0,[],[0,0,1,0,0.9933329820632935,0.970874011516571,0.006666670087724924,0.970874011516571],0]]]],[],!1,!1,7017009469424867,[],null],["t85",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,501392737599764,[["resultmessagelose_message-sheet0.png",51368,0,0,510,167,1,0,0,
[],[0.07058820128440857,0.2155690044164658,0.5,0.2335329949855804,0.9843140244483948,0.04790420085191727,0.9725490212440491,0.9161679744720459,0.5,0.9341319799423218,0.03333330154418945,0.8982040286064148,0.02745099924504757,0.4970059990882874],0]]]],[],!1,!1,8803999487506392,[],null],["t86",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,5471742323886378,[["resultmessagelose_bg-sheet0.png",17590,0,0,1080,207,1,0,0,[],[0,0,1,0,0.9933329820632935,0.970874011516571,0.006666670087724924,0.970874011516571],
0]]]],[],!1,!1,7762023870975025,[],null],["t87",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,7675964635661054,[["resultmessagewin_left-sheet0.png",17323,0,0,185,191,1,0,0,[],[0.1081079989671707,0.104712001979351,0.4972969889640808,0.2617799937725067,0.7405409812927246,0.2513090074062347,0.8864859938621521,0.8900520205497742,0.4972969889640808,0.9842929840087891,0.3837839961051941,0.6282719969749451,0.3945949971675873,0.4973819851875305],0]]]],[],!1,!1,0x65fac800263e5,[],null],["t88",
cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,7677741228746067,[["resultmessagewin_right-sheet0.png",19239,0,0,120,169,1,0,0,[],[0.2166669964790344,0.1538459956645966,0.5,0.01775150001049042,0.5416669845581055,0.3254440128803253,0.949999988079071,0.4970409870147705,0.9583330154418945,0.9704139828681946,0.5,0.9230769872665405,0.2083330005407333,0.8520709872245789,0.1166670024394989,0.4970409870147705],0]]]],[],!1,!1,0xd132a33263a27,[],null],["t89",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
0,!1,1,0,!1,816773221595418,[["resultmessagewin_message-sheet0.png",54587,0,0,488,185,1,0,0,[],[0.07377050071954727,0.194594994187355,0.5,0.1891890019178391,0.9795079827308655,0.05405410006642342,0.9651640057563782,0.9081079959869385,0.03483609855175018,0.9081079959869385],0]]]],[],!1,!1,0xc1713de45a931,[],null],["t90",cr.plugins_.Sprite,!1,[6723803989352219,5741053672722837,8231228434636449,5412557656467499,0xa53853d9a63c2,5051588670201652],0,0,null,[["Default",5,!1,1,0,!1,5860026123246793,[["endgamedecor-sheet0.png",
9799,0,0,659,124,1,0.500758707523346,0.5,[],[-0.4461305141448975,-0.2096770107746124,-0.001517713069915772,-0.4758065044879913,0.4446132779121399,-0.2096770107746124,0.4946892857551575,0,0.4461302757263184,0.2177420258522034,-0.001517713069915772,0.4919350147247315,-0.447647899389267,0.2177420258522034,-0.4962063431739807,0],0]]]],[],!1,!1,0xfb828245e985d,[],null],["t91",cr.plugins_.Sprite,!1,[6723803989352219,5741053672722837,8231228434636449,5412557656467499,0xa53853d9a63c2,7379715781952493],0,
0,null,[["Default",5,!1,1,0,!1,6669077222751895,[["endgameresultframe-sheet0.png",48140,0,0,440,430,1,0.5,0.5,[["Placeholder",0.5772727131843567,0.4116279184818268],["BtnToSelectLevel",0.3636363744735718,0.9767441749572754],["BtnNextLevel",0.5795454382896423,0.9767441749572754],["BtnReplay",0.7954545617103577,0.9767441749572754]],[-0.3295450210571289,-0.3255810141563416,0,-0.4790697991847992,0.4431819915771484,-0.4418604969978333,0.4568179845809937,0,0.4318180084228516,0.4302330017089844,0,0.490697979927063,
-0.4522727131843567,0.4511629939079285,-0.4181818068027496,0],0]]]],[],!1,!1,4672279331646734,[],null],["t92",cr.plugins_.Sprite,!1,[6723803989352219,5741053672722837,8231228434636449,5412557656467499,0xa53853d9a63c2],0,0,null,[["Default",5,!1,1,0,!1,0xbbaf26088a8f0,[["endgamehighscoreframe-sheet0.png",42484,0,0,366,374,1,0.5,0.5,[["Title",0.404371589422226,0.0989304780960083],["Rank",0.4535519182682037,0.2834224700927734]],[-0.4480873942375183,-0.4491978883743286,0,-0.4812833964824677,0.3087430000305176,
-0.3128339946269989,0.4153010249137878,0,0.4480869770050049,0.4491980075836182,-0.4016392827033997,0.4037430286407471,-0.4644809067249298,0],0]]]],[],!1,!1,0x43f37070380f2,[],null],["t93",cr.plugins_.Sprite,!1,[],1,0,null,[["Online",5,!1,1,0,!1,7580553431857272,[["endgameresultplaceholder-sheet0.png",67746,0,0,392,440,1,0.5,0.5,[["Level",0.5408163070678711,0.0522727258503437],["Star1",0.3469387888908386,0.2613636255264282],["Star2",0.5,0.2613636255264282],["Star3",0.6530612111091614,0.2613636255264282],
["Score",0.4948979616165161,0.4681818187236786],["Energy",0.3188775479793549,0.5522727370262146],["Achievement1",0.2806122303009033,0.800000011920929],["Achievement2",0.5,0.800000011920929],["Achievement3",0.7219387888908386,0.800000011920929]],[-0.4566327035427094,-0.4613636136054993,0,-0.1545450091362,0.4668369889259338,-0.4704545140266419,0.2882649898529053,0,0.3163269758224487,0.3363639712333679,0,0.3795449733734131,-0.3137760162353516,0.3340910077095032,-0.3010199964046478,0],0]]],["Offline",
5,!1,1,0,!1,574745766208289,[["endgameresultplaceholder-sheet1.png",61148,0,0,392,440,1,0.5,0.5,[["Level",0.5408163070678711,0.0522727258503437],["Star1",0.3469387888908386,0.2613636255264282],["Star2",0.5,0.2613636255264282],["Star3",0.6530612111091614,0.2613636255264282],["Score",0.4948979616165161,0.4681818187236786],["Achievement1",0.2806122303009033,0.6318181753158569],["Achievement2",0.5,0.6318181753158569],["Achievement3",0.7219387888908386,0.6318181753158569]],[-0.4566327035427094,-0.4613636136054993,
0,-0.1545450091362,0.4668369889259338,-0.4704545140266419,0.2882649898529053,0,0.1760200262069702,0.2113639712333679,-0.1760199964046478,0.2113639712333679,-0.3010199964046478,0],0]]]],[["Pin",cr.behaviors.Pin,8048947518627465]],!1,!1,7353132647795851,[],null],["t94",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6421364037646672,[["endgamehighscoretitle-sheet0.png",15146,0,0,272,67,1,0.5,0.5074626803398132,[],[-0.444852888584137,-0.2835816740989685,0,-0.4626865684986115,0.4154409766197205,
-0.1641786694526672,0.4889709949493408,-0.01492568850517273,0.4669119715690613,0.3582093119621277,0,0.283582329750061,-0.444852888584137,0.268656313419342,-0.4852941036224365,-0.01492568850517273],0]]]],[["Pin",cr.behaviors.Pin,6977587986400596]],!1,!1,5819256657158989,[],null],["t95",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x52e24b7359be3,[["btntoselectlevel-sheet0.png",9896,0,0,89,97,1,0.5056179761886597,0.5051546096801758,[],[],0]]],["Hover",5,!1,1,0,!1,5420224914399598,[["btntoselectlevel-sheet1.png",
10784,0,0,89,97,1,0.5056179761886597,0.5051546096801758,[],[],0]]]],[],!1,!1,0x4ce1a9924e930,[],null],["t96",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9071260153219418,[["btnreplay-sheet0.png",9817,0,0,89,97,1,0.5056179761886597,0.5051546096801758,[],[],0]]],["Hover",5,!1,1,0,!1,0xadea236dc14a6,[["btnreplay-sheet1.png",10693,0,0,89,97,1,0.5056179761886597,0.5051546096801758,[],[],0]]]],[],!1,!1,6126610453871778,[],null],["t97",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,
!1,9393185454432888,[["btnnextlevel-sheet0.png",9903,0,0,89,97,1,0.5056179761886597,0.5051546096801758,[],[],0]]],["Hover",5,!1,1,0,!1,0x3f13517bb7ab4,[["btnnextlevel-sheet1.png",10548,0,0,89,97,1,0.5056179761886597,0.5051546096801758,[],[],0]]]],[],!1,!1,8972683463553609,[],null],["t98",cr.plugins_.Spritefont2,!1,[],1,0,["endgamelevel.png",19725,0],null,[["Pin",cr.behaviors.Pin,8731266463346391]],!1,!1,8447692169816211,[],null],["t99",cr.plugins_.Text,!1,[314502147227465],0,0,null,null,[],!1,!1,
0xd3cf9ea59b99d,[],null],["t100",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8211624671078752,[],null],["t101",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xee46d1530cbfe,[["endgamerankframe-sheet0.png",3262,0,0,184,58,1,0.5,0.5,[["Rank",-0.1521739065647125,0.5],["Name",0.5,0.3103448152542114],["Score",0.5,0.7068965435028076]],[-0.4619565010070801,-0.3793100118637085,0,-0.4482758939266205,0.4673910140991211,-0.3965519964694977,0.4945650100708008,0,0.4728260040283203,0.4137930274009705,
0,0.4827589988708496,-0.467391312122345,0.3965520262718201,-0.4836956858634949,0],0]]]],[],!1,!1,0xe9395a9b50e20,[],null],["t102",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xe426c60decce5,[],null],["t103",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xe41b01b0ff0f9,[],null],["t104",cr.plugins_.Spriter,!1,[],1,0,null,null,[["Pin",cr.behaviors.Pin,876873368496566]],!1,!1,6416625187101266,[],null],["t105",cr.plugins_.Spriter,!1,[],1,0,null,null,[["Pin",cr.behaviors.Pin,7898866649250162]],!1,!1,
9774531259620572,[],null],["t106",cr.plugins_.Spriter,!1,[],0,0,null,null,[],!1,!1,0xc6ba34c2c94d9,[],null],["t107",cr.plugins_.Spriter,!1,[],0,0,null,null,[],!1,!1,6490154719966662,[],null],["t108",cr.plugins_.Text,!1,[314502147227465],0,0,null,null,[],!1,!1,5832394562718875,[],null],["t109",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9486976344870894,[["endgamefail-sheet0.png",10169,0,0,277,66,1,0.5018050670623779,0.5,[],[-0.429602861404419,-0.1969699859619141,-0.003610074520111084,
-0.1363640129566193,0.4765339493751526,-0.4090909063816071,0.4512639045715332,0.3030300140380859,-0.4584837555885315,0.3181819915771484,-0.4909747540950775,0],0]]]],[],!1,!1,4575087517375456,[],null],["t110",cr.plugins_.Sprite,!1,[9864496025830156,4796633116966646,7509804640143008,618760461470411],0,0,null,[["Default",5,!1,1,0,!1,8635315068551901,[["titleleaderboard-sheet0.png",36424,0,0,544,108,1,0.5,0.5,[],[-0.4411765038967133,-0.2037039995193481,0,-0.4629629850387573,0.4503679871559143,-0.25,0.454043984413147,
0,0.483456015586853,0.4166669845581055,0,0.2962960004806519,-0.4724265038967133,0.3611109852790833,-0.4632352888584137,0],0]]]],[],!1,!1,814262756812174,[],null],["t111",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xc6a78f6ae82fd,[["lbinfoframe-sheet0.png",10450,0,0,276,182,1,0.5,0.5,[],[-0.4601449072360992,-0.4395604133605957,0,-0.4670329988002777,0.4637680053710938,-0.4450548887252808,0.4927539825439453,0,0.4637680053710938,0.4450550079345703,0,0.4670330286026001,-0.4637680947780609,
0.4450550079345703,-0.4891304075717926,0],0]]]],[],!1,!1,0x8e1ecda3c3769,[],null],["t112",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xe973724e321ec,[["lbbadgeframe-sheet0.png",10992,0,0,278,132,1,0.5035971403121948,0.4924242496490479,[["Achievement1",0.1942446082830429,0.5984848737716675],["Achievement2",0.5035971403121948,0.5984848737716675],["Achievement3",0.8129496574401855,0.5984848737716675]],[-0.4640288352966309,-0.439393937587738,-0.003597140312194824,-0.4848484992980957,0.4604318737983704,
-0.439393937587738,0.4856118559837341,-0.007576256990432739,0.4640288352966309,0.4393937587738037,-0.003597140312194824,0.4848487377166748,-0.4676259458065033,0.4393937587738037,-0.4856115281581879,-0.007576256990432739],0]]]],[],!1,!1,0xbc45111a9568d,[],null],["t113",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xb3fa8087bf587,[["lbrankframe-sheet0.png",4708,0,0,247,67,1,0.5020242929458618,0.5074626803398132,[["Rank",0.1295546591281891,0.4776119291782379],["Name",0.623481810092926,0.2835820913314819],
["Score",0.623481810092926,0.7313432693481445]],[-0.4655870795249939,-0.3731346726417542,-0.004048287868499756,-0.4776119887828827,0.4696357250213623,-0.4029846787452698,0.4898787140846252,-0.01492568850517273,0.4655867218971252,0.3731343150138855,-0.004048287868499756,0.4179103374481201,-0.4615384936332703,0.3432832956314087,-0.4858299791812897,-0.01492568850517273],0]]]],[],!1,!1,8031656251576801,[],null],["t114",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xc1fc48f0a0c08,[],null],["t115",cr.plugins_.Text,
!1,[],0,0,null,null,[],!1,!1,4581033756454082,[],null],["t116",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,5204322917547639,[],null],["t117",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xa5b40da01ef99,[],null],["t118",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8178735697738936,[],null],["t119",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x800e98fef05e4,[],null],["t120",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,9753196320118044,[],null],["t121",cr.plugins_.Sprite,!1,[6723803989352219,
5741053672722837,8231228434636449,5412557656467499,0xa53853d9a63c2],0,0,null,[["Default",5,!1,1,0,!1,4565437141585177,[["endgameresultframe-sheet0.png",48140,0,0,440,430,1,0.5,0.5,[["Placeholder",0.5772727131843567,0.4116279184818268],["BtnPlay",0.5772727131843567,1.058139562606812]],[-0.3295450210571289,-0.3255810141563416,0,-0.4790697991847992,0.4431819915771484,-0.4418604969978333,0.4568179845809937,0,0.4318180084228516,0.4302330017089844,0,0.490697979927063,-0.4522727131843567,0.4511629939079285,
-0.4181818068027496,0],0]]]],[],!1,!1,0xa7b8408d2c083,[],null],["t122",cr.plugins_.Sprite,!1,[6723803989352219,5741053672722837,8231228434636449,5412557656467499,0xa53853d9a63c2],1,0,null,[["Default",5,!1,1,0,!1,9919400704132408,[["endgamehighscoreframe-sheet0.png",42484,0,0,366,374,1,0.5,0.5,[["Title",0.4098360538482666,-0.02673796750605106],["Placeholder",0.4125683009624481,0.5053476095199585]],[-0.4480873942375183,-0.4491978883743286,0,-0.4812833964824677,0.3087430000305176,-0.3128339946269989,
0.4153010249137878,0,0.4480869770050049,0.4491980075836182,-0.4016392827033997,0.4037430286407471,-0.4644809067249298,0],0]]]],[["Pin",cr.behaviors.Pin,0xbba6c3371d74e]],!1,!1,0x9756114fc7a47,[],null],["t123",cr.plugins_.Sprite,!1,[6723803989352219,5741053672722837,8231228434636449,5412557656467499,0xa53853d9a63c2],0,0,null,[["Default",5,!1,1,0,!1,8402434097833631,[["endgamedecor-sheet0.png",9799,0,0,659,124,1,0.500758707523346,0.5,[],[-0.4461305141448975,-0.2096770107746124,-0.001517713069915772,
-0.4758065044879913,0.4446132779121399,-0.2096770107746124,0.4946892857551575,0,0.4461302757263184,0.2177420258522034,-0.001517713069915772,0.4919350147247315,-0.447647899389267,0.2177420258522034,-0.4962063431739807,0],0]]]],[],!1,!1,0xc61e8b30e8234,[],null],["t124",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,4856633716001802,[["levelintroinfoplaceholder-sheet0.png",64775,0,0,392,440,1,0.5,0.5,[["Level",0.5408163070678711,0.0522727258503437],["Target",0.3188775479793549,0.415909081697464],
["Booster1",0.2959183752536774,0.8999999761581421],["Booster2",0.5,0.8999999761581421],["Booster3",0.704081654548645,0.8999999761581421],["Achievement1",0.2806122303009033,0.6704545617103577],["Achievement2",0.5,0.6704545617103577],["Achievement3",0.7193877696990967,0.6704545617103577],["Star1",0.3469387888908386,0.2613636255264282],["Star2",0.5,0.2613636255264282],["Star3",0.6530612111091614,0.2613636255264282]],[-0.4566327035427094,-0.4613636136054993,0,-0.1136359870433807,0.4668369889259338,-0.4704545140266419,
0.2882649898529053,0,0.2193880081176758,0.25,-0.2193880081176758,0.25],0]]]],[["Pin",cr.behaviors.Pin,0xc50a827fb53a5]],!1,!1,0xdee154d6af9e,[],null],["t125",cr.plugins_.Spritefont2,!1,[],1,0,["endgamelevel.png",19725,0],null,[["Pin",cr.behaviors.Pin,0xdcb637dbb2459]],!1,!1,4777857102075949,[],null],["t126",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x6ded0749c7f40,[["shoppingplaceholder-sheet0.png",18437,0,0,187,248,1,0.5026738047599792,0.5,[["PlayerCashLabel",-0.1443850249052048,
-0.1532258093357086],["PlayerCashIcon",0.4973261952400208,-0.1088709682226181],["PlayerCash",0.614973247051239,-0.1895161271095276],["Slider",0.5133689641952515,0.2419354766607285],["BtnPrevious",-0.09090909361839294,0.2419354766607285],["BtnNext",1.11229944229126,0.2419354766607285],["Description",0.51871657371521,0.6209677457809448],["PriceIcon",0.165775403380394,0.8830645084381104],["Price",0.2834224700927734,0.7862903475761414],["BtnBuy",0.8609625697135925,0.8790322542190552]],[-0.4438503086566925,
-0.4556452035903931,-0.00534781813621521,-0.4879032075405121,0.4545451998710632,-0.4677419066429138,0.4224601984024048,0,0.171123206615448,0.2540320158004761,-0.00534781813621521,0.4838709831237793,-0.4438503086566925,0.4556450247764587,-0.3903748095035553,0],0]]]],[["Pin",cr.behaviors.Pin,0x6fe58c9332d18]],!1,!1,8379365091270195,[],null],["t127",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6019554701817916,[["shoppingtitle-sheet0.png",11039,0,0,272,67,1,0.5,0.5074626803398132,[],[-0.4154412150382996,
-0.1641786694526672,0,-0.1492536664009094,0.4154409766197205,-0.1641786694526672,0.4705880284309387,-0.01492568850517273,0.4485290050506592,0.283582329750061,0,0.2238802909851074,-0.4338234961032867,0.2238802909851074,-0.4595587849617004,-0.01492568850517273],0]]]],[["Pin",cr.behaviors.Pin,6044071619208936]],!1,!1,7867128704739944,[],null],["t128",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6034011898453258,[["shoppingbtnprevious-sheet0.png",3314,0,0,40,58,1,0.5,0.5,[],[-0.1500000059604645,
-0.2586210072040558,0,-0.3620690107345581,0.3500000238418579,-0.3965519964694977,0.449999988079071,0,0.3500000238418579,0.3965520262718201,0,0.3620690107345581,-0.1500000059604645,0.2586209774017334,-0.4000000059604645,0],0]]],["Hover",5,!1,1,0,!1,0x93f9f459d70c0,[["shoppingbtnprevious-sheet1.png",3812,0,0,40,58,1,0.5,0.5,[],[-0.199999988079071,-0.2931029796600342,0,-0.4137930870056152,0.425000011920929,-0.4482758939266205,0.5,0,0.425000011920929,0.4482759833335877,0,0.4137930274009705,-0.199999988079071,
0.2931029796600342,-0.4749999940395355,0],0]]]],[["Pin",cr.behaviors.Pin,0xa4e4a3dac9441]],!1,!1,8973218610443048,[],null],["t129",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6136224078976074,[["shoppingbtnnext-sheet0.png",3308,0,0,40,58,1,0.5,0.5,[],[-0.324999988079071,-0.3793100118637085,0,-0.3793100118637085,0.175000011920929,-0.2758619785308838,0.449999988079071,0,0.175000011920929,0.2758619785308838,0,0.3793100118637085,-0.324999988079071,0.3793100118637085,-0.425000011920929,0],
0]]],["Hover",5,!1,1,0,!1,5064710688403822,[["shoppingbtnnext-sheet1.png",3811,0,0,40,58,1,0.5,0.5,[],[-0.4000000059604645,-0.4310345053672791,0,-0.4310345053672791,0.199999988079071,-0.2931029796600342,0.5,0,0.2250000238418579,0.3103449940681458,0,0.4310349822044373,-0.4000000059604645,0.4310349822044373,-0.4749999940395355,0],0]]]],[["Pin",cr.behaviors.Pin,8948674856961248]],!1,!1,6478628117613688,[],null],["t130",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,8833642056715094,[["shoppingbtnbuy-sheet0.png",
5238,0,0,52,56,1,0.5,0.5,[],[-0.3076919913291931,-0.3214290142059326,0,-0.4464285969734192,0.3269230127334595,-0.3392859995365143,0.4807689785957336,0,0.3269230127334595,0.3392860293388367,0,0.4642859697341919,-0.3076919913291931,0.3214290142059326,-0.4230768978595734,0],0]]],["Hover",5,!1,1,0,!1,5124400298332013,[["shoppingbtnbuy-sheet1.png",5453,0,0,52,56,1,0.5,0.5,[],[-0.3269230127334595,-0.3392859995365143,0,-0.4821428954601288,0.3461539745330811,-0.357142984867096,0.5,0,0.3461539745330811,0.357142984867096,
0,0.482142984867096,-0.3269230127334595,0.3392860293388367,-0.4615384936332703,0],0]]]],[["Pin",cr.behaviors.Pin,0x3c616483251fa]],!1,!1,0xddd19d1368371,[],null],["t131",cr.plugins_.Text,!1,[],1,0,null,null,[["Pin",cr.behaviors.Pin,0xb9d7e72173544]],!1,!1,6019320276985226,[],null],["t132",cr.plugins_.Text,!1,[],2,0,null,null,[["Pin",cr.behaviors.Pin,7977259747183714],["Flash",cr.behaviors.Flash,9006135378745679]],!1,!1,18656733624617,[],null],["t133",cr.plugins_.Sprite,!1,[0x79249475f0b3a,4600056225985118],
1,0,null,[["Default",0,!0,1,0,!1,0x6fee87c0c293,[["shoppingslider-sheet0.png",33232,1,1,95,95,1,0.5052631497383118,0.5052631497383118,[],[-0.08421015739440918,-0.08421015739440918,-0.0105261504650116,-0.4315789341926575,0.2526318430900574,-0.2631581425666809,0.4526318311691284,-0.0105261504650116,0.3684208393096924,0.3684208393096924,-0.2947371602058411,0.2842108607292175,-0.4526315331459045,-0.0105261504650116],0],["shoppingslider-sheet0.png",33232,97,1,95,95,1,0.5052631497383118,0.5052631497383118,
[],[-0.2105261385440826,-0.2105261385440826,-0.0105261504650116,-0.2421051561832428,0.3473688364028931,-0.3578951358795166,0.421052873134613,-0.0105261504650116,0.3052628636360169,0.3052628636360169,-0.3263161480426788,0.3157898783683777,-0.4315789341926575,-0.0105261504650116],0],["shoppingslider-sheet0.png",33232,1,97,95,95,1,0.5052631497383118,0.5052631497383118,[],[-0.1789471507072449,-0.1789471507072449,-0.0105261504650116,-0.3157891631126404,0.06315785646438599,-0.07368415594100952,0.1263158321380615,
-0.0105261504650116,0.2210528254508972,0.2210528254508972,-0.0105261504650116,0.4105258584022522,-0.1578951478004456,0.147368848323822,-0.1368421614170075,-0.0105261504650116],0]]],["extratime",5,!1,1,0,!1,0xb6cd84a606366,[["shoppingslider-sheet0.png",33232,97,97,95,95,1,0.5052631497383118,0.5052631497383118,[],[-0.08421015739440918,-0.08421015739440918,-0.0105261504650116,-0.4315789341926575,0.2526318430900574,-0.2631581425666809,0.4526318311691284,-0.0105261504650116,0.3684208393096924,0.3684208393096924,
-0.2947371602058411,0.2842108607292175,-0.4526315331459045,-0.0105261504650116],0]]],["doublecash",5,!1,1,0,!1,6482815129228758,[["shoppingslider-sheet1.png",15394,1,1,95,95,1,0.5052631497383118,0.5052631497383118,[],[-0.2105261385440826,-0.2105261385440826,-0.0105261504650116,-0.2421051561832428,0.3473688364028931,-0.3578951358795166,0.421052873134613,-0.0105261504650116,0.3052628636360169,0.3052628636360169,-0.3263161480426788,0.3157898783683777,-0.4315789341926575,-0.0105261504650116],0]]],["goodmood",
5,!1,1,0,!1,9999648463541104,[["shoppingslider-sheet1.png",15394,97,1,95,95,1,0.5052631497383118,0.5052631497383118,[],[-0.1789471507072449,-0.1789471507072449,-0.0105261504650116,-0.3157891631126404,0.06315785646438599,-0.07368415594100952,0.1263158321380615,-0.0105261504650116,0.2210528254508972,0.2210528254508972,-0.0105261504650116,0.4105258584022522,-0.1578951478004456,0.147368848323822,-0.1368421614170075,-0.0105261504650116],0]]]],[["Pin",cr.behaviors.Pin,9227351762039602]],!1,!1,6786993032775201,
[],null],["t134",cr.plugins_.Text,!1,[],1,0,null,null,[["Pin",cr.behaviors.Pin,0x9514e0f2273db]],!1,!1,0xe923997da52c5,[],null],["t135",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8047493635119453,[],null],["t136",cr.plugins_.Sprite,!1,[0x6e6eb0b861297,6363859354090057,6102315593477598],0,0,null,[["Default",5,!1,1,0,!1,0xccd78c1b67b11,[["boosterextratime-sheet0.png",7147,0,0,65,74,1,0.5076923370361328,0.5,[["Number",0.9692307710647583,0.1756756752729416]],[-0.3230773210525513,-0.3378379940986633,
-0.01538434624671936,-0.4459458887577057,0.3076926469802856,-0.3378379940986633,0.4769226908683777,0,0.3076926469802856,0.3378379940986633,-0.01538434624671936,0.4459459781646729,-0.3230773210525513,0.3378379940986633,-0.4769231379032135,0],0]]],["Hover",5,!1,1,0,!1,4884953516776038,[["boosterextratime-sheet1.png",7445,0,0,65,74,1,0.5076923370361328,0.5,[["Number",0.9692307710647583,0.1756756752729416]],[-0.3384613394737244,-0.3513509929180145,-0.01538434624671936,-0.4729729890823364,0.3384616374969482,
-0.3648650050163269,0.4923076629638672,0,0.3076926469802856,0.3378379940986633,-0.01538434624671936,0.4459459781646729,-0.3230773210525513,0.3378379940986633,-0.492307722568512,0],0]]]],[],!1,!1,5995222052463072,[],null],["t137",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xad31f1660c67c,[["boosternumberframe-sheet0.png",1023,0,0,27,27,1,0.5185185074806213,0.5185185074806213,[],[-0.3333334922790527,-0.3333334922790527,-0.03703752160072327,-0.4814814925193787,0.3333334922790527,-0.3703705072402954,
0.4814814925193787,-0.03703752160072327,0.3333334922790527,0.3333334922790527,-0.03703752160072327,0.4814814925193787,-0.3333334922790527,0.2962964773178101,-0.4814814925193787,-0.03703752160072327],0]]]],[["Pin",cr.behaviors.Pin,0xe741cbd10175c]],!1,!1,0xe66de2942a233,[],null],["t138",cr.plugins_.Text,!1,[0xdb333c1fd32cb,8704066234950458],1,0,null,null,[["Pin",cr.behaviors.Pin,0xcdfa1bb88cd9]],!1,!1,5947271715953654,[],null],["t139",cr.plugins_.Sprite,!1,[0x6e6eb0b861297,6363859354090057,6102315593477598],
0,0,null,[["Default",5,!1,1,0,!1,0xe643535928fac,[["boostergoodmood-sheet0.png",6237,0,0,65,74,1,0.5076923370361328,0.5,[["Number",0.9692307710647583,0.1756756752729416]],[-0.3230773210525513,-0.3378379940986633,-0.01538434624671936,-0.4459458887577057,0.3230766654014587,-0.3513509929180145,0.4769226908683777,0,0.3076926469802856,0.3378379940986633,-0.01538434624671936,0.4324319958686829,-0.3076923489570618,0.3243240118026733,-0.4769231379032135,0],0]]],["Hover",5,!1,1,0,!1,8955612276322048,[["boostergoodmood-sheet1.png",
6532,0,0,65,74,1,0.5076923370361328,0.5,[["Number",0.9692307710647583,0.1756756752729416]],[-0.3384613394737244,-0.3513509929180145,-0.01538434624671936,-0.4864864945411682,0.3384616374969482,-0.3648650050163269,0.4923076629638672,0,0.3076926469802856,0.3378379940986633,-0.01538434624671936,0.4324319958686829,-0.3230773210525513,0.3378379940986633,-0.492307722568512,0],0]]]],[],!1,!1,8525097532702078,[],null],["t140",cr.plugins_.Sprite,!1,[0x6e6eb0b861297,6363859354090057,6102315593477598,0xab967ea31240f,
5796829512712026],1,0,null,[["Default",5,!1,1,0,!1,7188239892643701,[["boosterdoublecash-sheet0.png",6956,0,0,65,74,1,0.5076923370361328,0.5,[["Number",0.9692307710647583,0.1756756752729416]],[-0.3230773210525513,-0.3378379940986633,-0.01538434624671936,-0.4459458887577057,0.3076926469802856,-0.3378379940986633,0.4769226908683777,0,0.3076926469802856,0.3378379940986633,-0.01538434624671936,0.4324319958686829,-0.3230773210525513,0.3378379940986633,-0.4769231379032135,0],0]]],["Hover",5,!1,1,0,!1,6635993487592568,
[["boosterdoublecash-sheet1.png",7388,0,0,65,74,1,0.5076923370361328,0.5,[["Number",0.9692307710647583,0.1756756752729416]],[-0.3384613394737244,-0.3513509929180145,-0.01538434624671936,-0.4729729890823364,0.3384616374969482,-0.3648650050163269,0.4923076629638672,0,0.3076926469802856,0.3378379940986633,-0.01538434624671936,0.4324319958686829,-0.3230773210525513,0.3378379940986633,-0.492307722568512,0],0]]]],[["Timer",cr.behaviors.Timer,0xd6c5edb086db6]],!1,!1,0x53f5499b62261,[],null],["t141",cr.plugins_.Dictionary,
!1,[],0,0,null,null,[],!0,!1,47125279801554,[],null],["t142",cr.plugins_.Dictionary,!1,[],0,0,null,null,[],!0,!1,7212581911575106,[],null],["t143",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,567792526189782,[["boosterframe-sheet0.png",1999,0,0,237,86,1,0.502109706401825,0.5,[],[-0.4556961953639984,-0.3720930218696594,-0.004219710826873779,-0.4651162922382355,0.4514772891998291,-0.3720930218696594,0.4894512891769409,0,0.4556962847709656,0.3837209939956665,-0.004219710826873779,0.4767439961433411,
-0.4556961953639984,0.3720930218696594,-0.4894514977931976,0],0]]]],[],!1,!1,5110650735676193,[],null],["t144",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x80536cb8ab107,[["boostergoodmood-sheet0.png",6237,0,0,65,74,1,0.5076923370361328,0.5,[],[-0.3230773210525513,-0.3378379940986633,-0.01538434624671936,-0.4459458887577057,0.3230766654014587,-0.3513509929180145,0.4769226908683777,0,0.3076926469802856,0.3378379940986633,-0.01538434624671936,0.4324319958686829,-0.3076923489570618,0.3243240118026733,
-0.4769231379032135,0],0]]]],[["DragDrop",cr.behaviors.DragnDrop,8548567616587115]],!1,!1,0x4dd51e7fa57f2,[],null],["t145",cr.plugins_.Dictionary,!1,[],0,0,null,null,[],!0,!1,7701772775688493,[],null],["t146",cr.plugins_.Dictionary,!1,[],0,0,null,null,[],!0,!1,6394438880060885,[],null],["t147",cr.plugins_.Dictionary,!1,[],0,0,null,null,[],!0,!1,6775445483470478,[],null],["t148",cr.plugins_.Dictionary,!1,[],0,0,null,null,[],!0,!1,0xbebe5a94aa1cf,[],null],["t149",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,9719769611519474,[["achievement-sheet0.png",40174,1,1,120,120,1,0.5,0.5,[],[-0.300000011920929,-0.300000011920929,0,-0.3916670083999634,0.3166670203208923,-0.3166670203208923,0.4666669964790344,0,0.3666669726371765,0.3666669726371765,0,0.449999988079071,-0.3583329916000366,0.3583329916000366,-0.4833332896232605,0],0]]],["firsttimeplayer",5,!1,1,0,!1,6060589218173572,[["achievement-sheet0.png",40174,122,1,120,120,1,0.5,0.5,[],[-0.2416670024394989,-0.2416670024394989,0,-0.3416669964790344,
0.2416669726371765,-0.2416670024394989,0.324999988079071,0,0.2416669726371765,0.2416669726371765,0,0.3583329916000366,-0.2416670024394989,0.2416669726371765,-0.3333330154418945,0],0]]],["proplayer",5,!1,1,0,!1,5288487296896598,[["achievement-sheet0.png",40174,1,122,120,120,1,0.5,0.5,[],[-0.375,-0.375,0,-0.2916669845581055,0.3999999761581421,-0.4000000059604645,0.3416669964790344,0,0.375,0.375,0,0.4083330035209656,-0.3583329916000366,0.3583329916000366,-0.3083329796791077,0],0]]],["allstarplayer",
5,!1,1,0,!1,8491928583756366,[["achievement-sheet0.png",40174,122,122,120,120,1,0.5,0.5,[],[-0.300000011920929,-0.300000011920929,0,-0.3916670083999634,0.3166670203208923,-0.3166670203208923,0.4666669964790344,0,0.3666669726371765,0.3666669726371765,0,0.449999988079071,-0.3583329916000366,0.3583329916000366,-0.4833332896232605,0],0]]]],[],!1,!1,7527382459467733,[],null],["t150",cr.plugins_.Sprite,!1,[9864496025830156,4796633116966646,7509804640143008,618760461470411],0,0,null,[["Default",5,!1,1,0,
!1,638436781265974,[["titlehowtoplay-sheet0.png",11172,0,0,250,62,1,0.5,0.5,[],[-0.4399999976158142,-0.2580649852752686,0,-0.1935479938983917,0.4599999785423279,-0.3387100100517273,0.4919999837875366,0.4677420258522034,0,0.3387100100517273,-0.4760000109672546,0.4032260179519653,-0.4280000030994415,0],0]]]],[],!1,!1,0xe2810e4be6c25,[],null],["t151",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0xdcfd9e403c64e,[["howtoplayslider-sheet0.png",1198188,1,1,555,444,1,0.50090092420578,0.5,[],
[-0.4666667282581329,-0.457207202911377,-0.001801937818527222,-0.4887386858463287,0.4684680700302124,-0.4617117047309876,0.4900900721549988,0,0.4684680700302124,0.4617120027542114,-0.001801937818527222,0.4842339754104614,-0.4666667282581329,0.4572070240974426,-0.4846847355365753,0],0],["howtoplayslider-sheet0.png",1198188,557,1,555,444,1,0.50090092420578,0.5,[],[-0.4666667282581329,-0.457207202911377,-0.001801937818527222,-0.4887386858463287,0.4684680700302124,-0.4617117047309876,0.4900900721549988,
0,0.4684680700302124,0.4617120027542114,-0.001801937818527222,0.4842339754104614,-0.4666667282581329,0.4572070240974426,-0.4846847355365753,0],0],["howtoplayslider-sheet0.png",1198188,1113,1,555,444,1,0.50090092420578,0.5,[],[-0.4666667282581329,-0.457207202911377,-0.001801937818527222,-0.4887386858463287,0.4684680700302124,-0.4617117047309876,0.4900900721549988,0,0.4684680700302124,0.4617120027542114,-0.001801937818527222,0.4842339754104614,-0.4666667282581329,0.4572070240974426,-0.4846847355365753,
0],0],["howtoplayslider-sheet0.png",1198188,1,446,555,444,1,0.50090092420578,0.5,[],[-0.4666667282581329,-0.457207202911377,-0.001801937818527222,-0.4887386858463287,0.4684680700302124,-0.4617117047309876,0.4900900721549988,0,0.4684680700302124,0.4617120027542114,-0.001801937818527222,0.4842339754104614,-0.4666667282581329,0.4572070240974426,-0.4846847355365753,0],0],["howtoplayslider-sheet0.png",1198188,557,446,555,444,1,0.50090092420578,0.5,[],[-0.4648649096488953,-0.4549550116062164,-0.001801937818527222,
-0.4864864945411682,0.4666670560836792,-0.4594594836235046,0.4900900721549988,0,0.4684680700302124,0.4617120027542114,-0.001801937818527222,0.48648601770401,-0.4666667282581329,0.4572070240974426,-0.4846847355365753,0],0],["howtoplayslider-sheet0.png",1198188,1113,446,555,444,1,0.50090092420578,0.5,[],[],0],["howtoplayslider-sheet0.png",1198188,1,891,555,444,1,0.50090092420578,0.5,[],[],0]]]],[],!1,!1,6977120687825469,[],null],["t152",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,9295852223860684,
[["howtoplaybtnnext-sheet0.png",7493,0,0,79,112,1,0.5063291192054749,0.5,[],[-0.3037971258163452,-0.357142984867096,-0.01265811920166016,-0.3303570151329041,0.1265819072723389,-0.2410709857940674,0.4050628542900085,0,0.1772148609161377,0.2767860293388367,-0.01265811920166016,0.3839290142059326,-0.3417721390724182,0.3839290142059326,-0.40506312251091,0],0]]],["Hover",5,!1,1,0,!1,0x6f132c30031a,[["howtoplaybtnnext-sheet1.png",9047,0,0,79,112,1,0.5063291192054749,0.5,[],[-0.3924051225185394,-0.4196428954601288,
-0.01265811920166016,-0.4107142984867096,0.1898738741874695,-0.2857140004634857,0.4683548808097839,0,0.2025318741798401,0.294642984867096,-0.01265811920166016,0.419642984867096,-0.40506312251091,0.4285709857940674,-0.4810126125812531,0],0]]]],[["Pin",cr.behaviors.Pin,4531980125381847]],!1,!1,8150637783640692,[],null],["t153",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xe3632365fb4e3,[["howtoplaybtnprevious-sheet0.png",7560,0,0,79,112,1,0.5063291192054749,0.5,[],[-0.1392401158809662,
-0.2410709857940674,-0.01265811920166016,-0.3214290142059326,0.3037979006767273,-0.3660709857940674,0.4050628542900085,0,0.3417719006538391,0.3928570151329041,-0.01265811920166016,0.3839290142059326,-0.1772151291370392,0.2678570151329041,-0.40506312251091,0],0]]],["Hover",5,!1,1,0,!1,0x4dc99cb10be44,[["howtoplaybtnprevious-sheet1.png",9084,0,0,79,112,1,0.5063291192054749,0.5,[],[-0.1898731291294098,-0.2767859995365143,-0.01265811920166016,-0.4017857015132904,0.3924048542976379,-0.4285714030265808,
0.4683548808097839,0,0.3924048542976379,0.4285709857940674,-0.01265811920166016,0.4107139706611633,-0.2025321125984192,0.2857139706611633,-0.4683544039726257,0],0]]]],[["Pin",cr.behaviors.Pin,565486981810988]],!1,!1,809420050646897,[],null],["t154",cr.plugins_.Sprite,!1,[5051588670201652,7079665166280771,9327309189858922],0,0,null,[["Info",5,!1,1,0,!1,0x5f11e3e2e92ac,[["dialoginfo-sheet0.png",20937,1,1,424,229,1,0.5,0.5021833777427673,[["Text",0.5,0.3930130898952484],["Button",0.5,0.6986899375915527]],
[-0.4481132030487061,-0.406113475561142,0.471697986125946,-0.4497816860675812,0.4834910035133362,0.4672486186027527,0,0.4759826064109802,-0.4716981053352356,0.4454146027565002],0]]],["Error",5,!1,1,0,!1,0x7b8d2b877cdc0,[["dialoginfo-sheet0.png",20937,1,231,424,229,1,0.5,0.5021833777427673,[["Text",0.5,0.3493449687957764],["Button",0.5,0.6986899375915527]],[-0.4646226167678833,-0.4366811811923981,0.471697986125946,-0.4497816860675812,0.4811319708824158,0.4628816246986389,0,0.4759826064109802,-0.4716981053352356,
0.4454146027565002],0]]]],[],!1,!1,931249529582762,[],null],["t155",cr.plugins_.Text,!1,[],1,0,null,null,[["Pin",cr.behaviors.Pin,0xedaa52a1c1f41]],!1,!1,0xc68f71d89363f,[],null],["t156",cr.plugins_.Sprite,!1,[5051588670201652,7079665166280771,9327309189858922,0xb1d931eb4b202],0,0,null,[["Shopping",5,!1,1,0,!1,550737630589179,[["dialogconfirm-sheet0.png",7908,0,0,417,241,1,0.5011990666389465,0.5020747184753418,[["Text",0.5011990666389465,0.4564315378665924],["Button1",0.3357314169406891,0.7468879818916321],
["Button2",0.6642686128616333,0.7468879818916321]],[-0.4676259756088257,-0.443983405828476,-0.002398073673248291,-0.390041708946228,0.4460429549217224,-0.4107884168624878,0.4820139408111572,-0.004149705171585083,0.4820139408111572,0.4688792824745178,-0.4844124615192413,0.4688792824745178],0]]]],[],!1,!1,0xe955a588ec6d9,[],null],["t157",cr.plugins_.Text,!1,[],1,0,null,null,[["Pin",cr.behaviors.Pin,0x6f08734d9fc73]],!1,!1,7757906118467075,[],null],["t158",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",
5,!1,1,0,!1,0x6171267ff9f7,[["dialogconfirmbuttonyes-sheet0.png",3824,1,1,132,50,1,0.5,0.5,[],[],0]]],["Hover",5,!1,1,0,!1,8525297111763896,[["dialogconfirmbuttonyes-sheet0.png",3824,1,52,132,50,1,0.5,0.5,[],[],0]]]],[["Pin",cr.behaviors.Pin,9850783487278248]],!1,!1,5878812830096462,[],null],["t159",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xd63e29c90b0a0,[["dialogconfirmbuttonno-sheet0.png",3667,1,1,132,50,1,0.5,0.5,[],[],0]]],["Hover",5,!1,1,0,!1,0x951c0de2bbb09,[["dialogconfirmbuttonno-sheet0.png",
3667,1,52,132,50,1,0.5,0.5,[],[],0]]]],[["Pin",cr.behaviors.Pin,0xa336a90b615d1]],!1,!1,0xab8e02021cf53,[],null],["t160",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x6be8ed3e5d786,[["dialoginfobuttonclose-sheet0.png",3453,1,1,132,50,1,0.5,0.5,[],[],0]]],["Hover",5,!1,1,0,!1,0x929a0b68901b1,[["dialoginfobuttonclose-sheet0.png",3453,1,52,132,50,1,0.5,0.5,[],[],0]]]],[["Pin",cr.behaviors.Pin,4672907684273565]],!1,!1,9354454946785972,[],null],["t161",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
0,!1,1,0,!1,8779285040569259,[["commonbackgroundanim_ice4-sheet0.png",20215,0,0,210,197,1,0.5142857432365417,0.5126903653144836,[],[-0.3809527456760407,-0.3705583810806274,-0.01428574323654175,-0.4923857748508453,0.3714282512664795,-0.3908633589744568,0.480952262878418,-0.01522836089134216,0.3714282512664795,0.3654826283454895,-0.01428574323654175,0.4771576523780823,-0.3619047403335571,0.324872612953186,-0.5047619342803955,-0.01522836089134216],0]]]],[],!1,!1,7876246005668388,[],null],["t162",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",0,!1,1,0,!1,7340469215655023,[["commonbackgroundanim_ice3-sheet0.png",15547,0,0,166,151,1,0.4939759075641632,0.503311276435852,[],[-0.3433738946914673,-0.3377482891082764,0.006024092435836792,-0.4437086880207062,0.4277110993862152,-0.4172185659408569,0.4819280803203583,-0.006622284650802612,0.3795181214809418,0.3576157093048096,0.006024092435836792,0.496688723564148,-0.4156626164913178,0.410595715045929,-0.4879518151283264,-0.006622284650802612],0]]]],[],!1,!1,588011625132655,
[],null],["t163",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,55520088012299,[["commonbackgroundanim_ice2-sheet0.png",17750,0,0,190,172,1,0.5,0.5058139562606812,[],[-0.3368420004844666,-0.3255809545516968,0,-0.4825581610202789,0.273684024810791,-0.2558139562606812,0.4631580114364624,-0.005813956260681152,0.3210530281066895,0.2965120673179627,0,0.4883720278739929,-0.3052629828453064,0.2790700197219849,-0.4157894849777222,-0.005813956260681152],0]]]],[],!1,!1,8299383821436531,[],null],
["t164",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,8581557476450533,[["commonbackgroundanim_ice1-sheet0.png",14639,0,0,159,149,1,0.5157232880592346,0.4966442883014679,[],[-0.3836482763290405,-0.3557043075561523,-0.01886829733848572,-0.47651007771492,0.3710687160491943,-0.3758392930030823,0.4779877066612244,-2.980232238769531E-7,0.3647797107696533,0.3758387267589569,-0.01886829733848572,0.4899326860904694,-0.3584902882575989,0.3355707228183746,-0.5094339847564697,-2.980232238769531E-7],
0]]]],[],!1,!1,0xd2a8c807e618,[],null],["t165",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,9671332862030160,[["commonbackgroundanim_bubble3-sheet0.png",352,0,0,26,26,1,0,0,[],[0.1538459956645966,0.1538459956645966,0.5,0.115385003387928,0.7307689785957336,0.269230991601944,0.3461540043354034,0.3461540043354034,0.5,1,0.1538459956645966,0.846153974533081],0]]]],[],!1,!1,0x8796ce0cec42f,[],null],["t166",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,6617631065539643,[["commonbackgroundanim_bubble4-sheet0.png",
407,0,0,31,31,1,0,0,[],[0.1612900048494339,0.1612900048494339,0.6129029989242554,0.3870970010757446,1,0.4838710129261017,0.8709679841995239,0.8709679841995239,0.4838710129261017,0.3548389971256256,0.5806450247764587,0.4193550050258637,0.9677420258522034,0.4838710129261017],0]]]],[],!1,!1,7425303417695683,[],null],["t167",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,9661107290708352,[["commonbackgroundanim_bubble2-sheet0.png",416,0,0,31,31,1,0,0,[],[0.1612900048494339,0.1612900048494339,
0.4838710129261017,0.3548389971256256,0.7419350147247314,0.2580649852752686,1,0.4838710129261017,0.8709679841995239,0.8709679841995239,0.4838710129261017,0.3870970010757446,0.645160973072052,0.3548389971256256,0.9677420258522034,0.4838710129261017],0]]]],[],!1,!1,5895893313132767,[],null],["t168",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,4819440730195993,[["commonbackgroundanim_bubble1-sheet0.png",400,0,0,31,31,1,0,0,[],[0.2903229892253876,0.2903229892253876,0.4838710129261017,0.03225810080766678,
0.6774190068244934,0.3225809931755066,0.0645160973072052,0.4838710129261017,0.3548389971256256,0.3548389971256256,0.4838710129261017,0.3870970010757446,0.6129029989242554,0.3870970010757446,0.03225810080766678,0.4838710129261017],0]]]],[],!1,!1,4565991922863709,[],null],["t169",cr.plugins_.TiledBg,!1,[],0,0,["commonbackground.png",209803,1],null,[],!1,!1,539060601043246,[],null],["t170",cr.plugins_.Spriter,!1,[],0,0,null,null,[],!1,!1,4824851999305722,[],null],["t171",cr.plugins_.TiledBg,!1,[],0,
0,["backgroundoverlay.png",156,4],null,[],!1,!1,6877658823155165,[],null],["t172",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5600563059185597,[["safezone-sheet0.png",3460,0,0,1080,720,1,0.5,0.5,[],[],0]]]],[],!1,!0,6084013552068731,[],null],["t173",cr.plugins_.Sprite,!1,[5051588670201652],0,0,null,[["Default",5,!1,1,0,!1,8342414206947187,[["settingsframe-sheet0.png",16613,0,0,430,275,1,0.5,0.5018181800842285,[["Music",0.7325581312179565,0.800000011920929],["Sound",0.2325581461191177,
0.800000011920929],["Close",0.9767441749572754,0.036363635212183]],[-0.455814003944397,-0.4327272772789002,0,-0.490909069776535,0.4581400156021118,-0.436363697052002,0.4930229783058167,-0.003636181354522705,0.4604650139808655,0.4363638162612915,0,0.4945458173751831,-0.4581395089626312,0.4327268004417419,-0.4906976819038391,-0.003636181354522705],0]]]],[],!1,!1,9456863576931064,[],null],["t174",cr.plugins_.Sprite,!1,[],0,0,null,[["Checked",5,!1,1,0,!1,9085832236370728,[["settingsenablesound-sheet0.png",
5572,0,0,72,72,1,0.5,0.5,[],[-0.375,-0.375,0,-0.3611109852790833,0.4305559992790222,-0.4305555820465088,0.4305559992790222,0,0.3333330154418945,0.3333330154418945,0,0.4861109852790833,-0.3333330154418945,0.3333330154418945,-0.4166666865348816,0],0]]],["Unchecked",5,!1,1,0,!1,0xaa52f8180d40c,[["settingsenablesound-sheet1.png",2736,0,0,72,72,1,0.5,0.5,[],[-0.2638890147209168,-0.2638890147209168,0,-0.3611109852790833,0.2638890147209168,-0.2638890147209168,0.4305559992790222,0,0.3333330154418945,0.3333330154418945,
0,0.4861109852790833,-0.3333330154418945,0.3333330154418945,-0.4166666865348816,0],0]]]],[],!1,!1,7646559403854913,[],null],["t175",cr.plugins_.Sprite,!1,[],0,0,null,[["Checked",5,!1,1,0,!1,482121797565173,[["settingsenablesound-sheet0.png",5572,0,0,72,72,1,0.5,0.5,[],[-0.375,-0.375,0,-0.3611109852790833,0.4305559992790222,-0.4305555820465088,0.4305559992790222,0,0.3333330154418945,0.3333330154418945,0,0.4861109852790833,-0.3333330154418945,0.3333330154418945,-0.4166666865348816,0],0]]],["Unchecked",
5,!1,1,0,!1,9130826618669424,[["settingsenablesound-sheet1.png",2736,0,0,72,72,1,0.5,0.5,[],[-0.2638890147209168,-0.2638890147209168,0,-0.3611109852790833,0.2638890147209168,-0.2638890147209168,0.4305559992790222,0,0.3333330154418945,0.3333330154418945,0,0.4861109852790833,-0.3333330154418945,0.3333330154418945,-0.4166666865348816,0],0]]]],[],!1,!1,7728027833687778,[],null],["t176",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7969768535768271,[["btnsettings-sheet0.png",6989,0,0,71,78,
1,0.5070422291755676,0.5,[],[-0.2957742214202881,-0.3076919913291931,-0.01408421993255615,-0.4102563858032227,0.2957747578620911,-0.3205130100250244,0.436619758605957,0,0.2957747578620911,0.3205130100250244,-0.01408421993255615,0.4358969926834106,-0.3098592162132263,0.3205130100250244,-0.4366197288036346,0],0]]],["Hover",5,!1,1,0,!1,9214063045738178,[["btnsettings-sheet1.png",7790,0,0,71,78,1,0.5070422291755676,0.5,[],[-0.3098592162132263,-0.3205130100250244,-0.01408421993255615,-0.4487178921699524,
0.3098587989807129,-0.3333330154418945,0.4647887945175171,0,0.3239437937736511,0.3461539745330811,-0.01408421993255615,0.4615380167961121,-0.3239432275295258,0.3333330154418945,-0.4507042169570923,0],0]]]],[],!1,!1,0xe859b3757c691,[],null],["t177",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xee737474a2c20,[["btnquit-sheet0.png",7157,0,0,71,78,1,0.5070422291755676,0.5,[],[-0.2957742214202881,-0.3076919913291931,-0.01408421993255615,-0.4230768978595734,0.2957747578620911,-0.3205130100250244,
0.436619758605957,0,0.2957747578620911,0.3205130100250244,-0.01408421993255615,0.4358969926834106,-0.3098592162132263,0.3205130100250244,-0.422535240650177,0],0]]],["Hover",5,!1,1,0,!1,9974176881797646,[["btnquit-sheet1.png",7746,0,0,71,78,1,0.5070422291755676,0.5,[],[-0.3239432275295258,-0.3333330154418945,-0.01408421993255615,-0.4487178921699524,0.3239437937736511,-0.3461540043354034,0.4647887945175171,0,0.3239437937736511,0.3461539745330811,-0.01408421993255615,0.4615380167961121,-0.3239432275295258,
0.3333330154418945,-0.4647887349128723,0],0]]]],[],!1,!1,8139928924624056,[],null],["t178",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x7dd64dee7ac6b,[["litotalscoreframe-sheet0.png",9855,0,0,372,246,1,0.5,0.5,[],[-0.456989198923111,-0.4349594116210938,0,-0.4715447127819061,0.462365984916687,-0.4430893957614899,0.4892470240592957,0,0.4650539755821228,0.4471539855003357,0,0.4796749949455261,-0.462365597486496,0.4430890083312988,-0.4784945845603943,0],0]]]],[],!1,!1,9700654015572696,
[],null],["t179",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x94ccc51075a87,[],null],["t180",cr.plugins_.Sprite,!1,[9864496025830156,4796633116966646,7509804640143008,618760461470411],0,0,null,[["Default",5,!1,1,0,!1,968109648904468,[["titlelocalinfo-sheet0.png",29176,0,0,406,108,1,0.5,0.5,[],[-0.4211823046207428,-0.2037039995193481,0,0.0277780294418335,0.4359610080718994,-0.2592589855194092,0.4359610080718994,0,0.477832019329071,0.4166669845581055,0,0.1018519997596741,-0.4630542099475861,0.3611109852790833,
-0.4507389068603516,0],0]]]],[],!1,!1,8204379888625106,[],null],["t181",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,6363623120840926,[],null],["t182",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,9257609820750152,[["story_bg-sheet0.png",146542,0,0,900,600,1,0.5,0.5,[],[],1]]]],[],!1,!1,0xdea0debcd79de,[],null],["t183",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0x984177646eee5,[["story_test-sheet0.png",18369,0,0,900,600,1,0.5,0.5,[],[],0]]]],[],!1,!1,8641550528283455,[],
null],["t184",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,6337504388767895,[["story_bg_000-sheet0.png",87292,0,0,900,600,1,0.5,0.5,[],[],1]]]],[],!1,!1,0xe467257c89d6,[],null],["t185",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,7057902860439009,[["story_test_000-sheet0.png",29584,0,0,900,600,1,0.5,0.5,[],[0,-0.4733332991600037,0.02666699886322022,-0.2100000083446503,-0.02666699886322022,-0.2100000083446503],0]]]],[],!1,!1,5709402616189434,[],null],["t186",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",0,!1,1,0,!1,0x5d05c2928f5f2,[["story_ki_001-sheet0.png",239407,0,0,900,600,1,0.5,0.5,[],[0.1377779841423035,0.4566670060157776,0.3677780032157898,-0.3016670048236847,0.5,0,0.5,0.5,0.1788889765739441,0],0]]]],[],!1,!1,4561081727378762,[],null],["t187",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,8113014784076144,[["story_bg_001-sheet0.png",138368,0,0,900,600,1,0.5,0.5,[],[],1]]]],[],!1,!1,6796666395741686,[],null],["t188",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
0,!1,1,0,!1,0x61b05a44c981c,[["story_test01-sheet0.png",6680,0,0,900,600,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xfe42c63b5949f,[],null],["t189",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0x54a54fd00876b,[["story_test02-sheet0.png",11736,0,0,900,600,1,0.5,0.5,[],[],0]]]],[],!1,!1,6370565017198438,[],null],["t190",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,5176429761755603,[["story_bg_002-sheet0.png",139226,0,0,900,600,1,0.5,0.5,[],[],1]]]],[],!1,!1,0xa3048fba5154b,[],null],["t191",
cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0xfac79c3420730,[["story_char01-sheet0.png",81529,0,0,900,600,1,0.5,0.5,[],[-0.3155559897422791,-0.2233330011367798,-0.2888889908790588,0,-0.5,0.5,-0.4888888895511627,0],0]]]],[],!1,!1,0xc10117a114704,[],null],["t192",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,5323525409473798,[["story_char02-sheet0.png",107221,0,0,900,600,1,0.5,0.5,[],[0.3999999761581421,-0.3499999940395355,0.4777780175209045,0,0.4811109900474548,0.4716669917106628,
0.2200000286102295,0],0]]]],[],!1,!1,386863001017058,[],null],["t193",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,6576142565909224,[["story_yeah-sheet0.png",4354,0,0,900,600,1,0.5,0.5,[],[],0]]]],[],!1,!1,837541913473188,[],null],["t194",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,7663649674913614,[["story_ki-sheet0.png",123426,0,0,900,600,1,0.5,0.5,[],[-0.2022219896316528,-0.05333301424980164,-0.1011109948158264,0.4016669988632202,-0.1911109983921051,0,-0.5,0.5,-0.3988890051841736,
0],0]]]],[],!1,!1,0x9a57ebaaf262,[],null],["t195",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,6671284133669133,[["story_te_000-sheet0.png",255162,0,0,900,600,1,0.5,0.5,[],[-0.3400000035762787,-0.2599999904632568,-0.1911109983921051,0,-0.5,0.5,-0.4822221994400024,0],0]]]],[],!1,!1,0xf07bedd07937a,[],null],["t196",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,8642688187738188,[["story_ki_002-sheet0.png",325026,0,0,900,600,1,0.5,0.5,[],[-0.2277779877185822,-0.09166699647903442,
0,-0.338333010673523,0.2022219896316528,-0.05333301424980164,0.1911110281944275,0.03666698932647705,0,0.5,-0.2755559980869293,0.163332998752594,-0.2622219920158386,0],0]]]],[],!1,!1,8334708461115171,[],null],["t197",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0xc0895dade3a9d,[["story_ki_003-sheet0.png",87305,0,0,900,600,1,0.5,0.5,[],[-0.086667001247406,0.1200000047683716,0,-0.1433329880237579,0.06888902187347412,0.1466670036315918,0.0744439959526062,0,0,0.324999988079071,-0.09555599093437195,
-0.1066670119762421],0]]]],[],!1,!1,0xe550bf9ca862c,[],null],["t198",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,8427381714808441,[["story_te-sheet0.png",147100,0,0,900,600,1,0.5,0.5,[],[0.4555559754371643,0,0.4766669869422913,0.4649999737739563,0.2633330225944519,0],0]]]],[],!1,!1,5298183182104888,[],null],["t199",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,4865385411063925,[["story_light-sheet0.png",139911,0,0,900,600,1,0.5,0.5,[],[0.2622219920158386,0,0.0277780294418335,
-0.2916669845581055,0.2444440126419067,0],0]]]],[],!1,!1,0xb58edb1958928,[],null],["t200",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0xa23a2db8b4cfb,[["story_group-sheet0.png",123580,0,0,900,600,1,0.5,0.5,[],[-0.2044439911842346,-0.05666700005531311,0,0.04166698455810547,0.2144439816474915,-0.07166698575019836,0.5,0,0.5,0.5,-0.4855555891990662,0.4783329963684082,-0.5,0],0]]]],[],!1,!1,7576191230487131,[],null],["t201",cr.plugins_.Spriter,!1,[],0,0,null,null,[],!1,!1,0xc8101f1455406,
[],null],["t202",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x5ebd90a8fbcab,[["storyborder-sheet0.png",147381,0,0,1080,720,1,0.5,0.5,[],[],0]]]],[],!1,!1,8814709562227182,[],null],["t203",cr.plugins_.Arr,!1,[],0,0,null,null,[],!0,!1,0x9746e65a3eb51,[],null],["t204",cr.plugins_.ShakeItUtils,!1,[],0,0,null,null,[],!1,!1,0xac476bbd177c6,[],null,[]],["t205",cr.plugins_.GameConfig,!1,[],0,0,null,null,[],!1,!1,0xc283529750a9d,[],null,["192.168.12.7",8181,"/api/systems/getenvironment","khanh",
"game/shake-it","Khanh","test",1]],["t206",cr.plugins_.Browser,!1,[],0,0,null,null,[],!1,!1,0x3e63e63b2916a,[],null,[]],["t207",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5304827651502881,[["btnback-sheet0.png",7475,0,0,71,78,1,0.5070422291755676,0.5,[],[-0.2957742214202881,-0.3076919913291931,-0.01408421993255615,-0.4230768978595734,0.2957747578620911,-0.3205130100250244,0.436619758605957,0,0.2957747578620911,0.3205130100250244,-0.01408421993255615,0.4230769872665405,-0.2957742214202881,
0.3076919913291931,-0.422535240650177,0],0]]],["Hover",5,!1,1,0,!1,8996775954132889,[["btnback-sheet1.png",8216,0,0,71,78,1,0.5070422291755676,0.5,[],[-0.3239432275295258,-0.3333330154418945,-0.01408421993255615,-0.4615384936332703,0.3239437937736511,-0.3461540043354034,0.4647887945175171,0,0.3239437937736511,0.3461539745330811,-0.01408421993255615,0.4615380167961121,-0.3239432275295258,0.3333330154418945,-0.4647887349128723,0],0]]]],[],!1,!1,4939249181350246,[],null],["t208",cr.plugins_.Function,
!1,[],0,0,null,null,[],!1,!1,0xf4163ccbca831,[],null,[]],["t209",cr.plugins_.Arr,!1,[],0,0,null,null,[],!0,!1,8308999780693739,[],null],["t210",cr.plugins_.Audio,!1,[],0,0,null,null,[],!1,!1,0x46015b13b1474,[],null,[0,0,1,1,600,600,1E4,1,5E3,1]],["t211",cr.plugins_.AJAX,!1,[],0,0,null,null,[],!1,!1,0x488ba32b55ef1,[],null,[]],["t212",cr.plugins_.Mouse,!1,[],0,0,null,null,[],!1,!1,7634469580211607,[],null,[]],["t213",cr.plugins_.Touch,!1,[],0,0,null,null,[],!1,!1,0x9aafac9798213,[],null,[1]],["t214",
cr.plugins_.CocoonJSAppForCocoonJS,!1,[],0,0,null,null,[],!1,!1,7692766299999488,[],null,[]],["t215",cr.plugins_.win8,!1,[],0,0,null,null,[],!1,!1,0xf3dd639e90f3b,[],null,[1,1,1,1]],["t216",cr.plugins_.WebStorage,!1,[],0,0,null,null,[],!1,!1,9234603153960732,[],null,[]],["t217",cr.plugins_.Sprite,!1,[],0,0,null,[["Coin",5,!1,1,0,!1,0xcf4c480228458,[["iconcurrency-sheet0.png",3975,0,0,65,65,1,0.4923076927661896,0.4769230782985687,[],[-0.1573967039585114,-0.3230770826339722,-0.007494688034057617,-0.4307692646980286,
0.1424063146114349,-0.3230770826339722,0.2323472797870636,-0.01538509130477905,0.1424063146114349,0.307691901922226,-0.007494688034057617,0.4153849184513092,-0.1573967039585114,0.307691901922226,-0.2323466837406158,-0.01538509130477905],0]]],["Tinidiem",5,!1,1,0,!1,9921837276636416,[["iconcurrency-sheet1.png",2611,0,0,65,65,1,0.5076923370361328,0.4923076927661896,[],[-0.2461543381214142,-0.2461536973714829,-0.01538434624671936,-0.3692306876182556,0.2307696342468262,-0.2461536973714829,0.4615386724472046,
-0.01538470387458801,0.1999996900558472,0.2000003159046173,-0.01538434624671936,0.2923072874546051,-0.3384613394737244,0.3230772912502289,-0.4769231379032135,-0.01538470387458801],0]]],["TXu",5,!1,1,0,!1,5470958909080822,[["iconcurrency-sheet2.png",3452,0,0,65,65,1,0.4923076927661896,0.5076923370361328,[],[-0.230769693851471,-0.2153843343257904,2.980232238769531E-7,-0.2923073172569275,0.2307693064212799,-0.2153843343257904,0.3230772912502289,-0.01538434624671936,0.2307693064212799,0.1999996900558472,
2.980232238769531E-7,0.2769226431846619,-0.230769693851471,0.1999996900558472,-0.3230766952037811,-0.01538434624671936],0]]]],[],!1,!1,0xd88dab58750d6,[],null],["t218",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,7486293034637823,[],null],["t219",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x9642bbe8afc0a,[],null],["t220",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6078015991039439,[["btnskip-sheet0.png",7079,0,0,71,78,1,0.5070422291755676,0.5,[],[-0.2957742214202881,-0.3076919913291931,
-0.01408421993255615,-0.4230768978595734,0.2957747578620911,-0.3205130100250244,0.436619758605957,0,0.2957747578620911,0.3205130100250244,-0.01408421993255615,0.4230769872665405,-0.2957742214202881,0.3076919913291931,-0.422535240650177,0],0]]],["Hover",5,!1,1,0,!1,0xbe52992eee17c,[["btnskip-sheet1.png",7580,0,0,71,78,1,0.5070422291755676,0.5,[],[-0.3239432275295258,-0.3333330154418945,-0.01408421993255615,-0.4487178921699524,0.3098587989807129,-0.3333330154418945,0.4647887945175171,0,0.3239437937736511,
0.3461539745330811,-0.01408421993255615,0.4615380167961121,-0.3239432275295258,0.3333330154418945,-0.4507042169570923,0],0]]]],[],!1,!1,9804820497445044,[],null],["t221",cr.plugins_.Sprite,!1,[],0,0,null,[["Gray",5,!1,1,0,!1,6139339985568197,[["star-sheet0.png",3306,0,0,56,58,1,0.5,0.5,[],[0,-0.4310345053672791,0.1964290142059326,-0.2068969905376434,0.482142984867096,0,0.375,0.3793100118637085,0,0.3965520262718201,-0.357142984867096,0.3620690107345581,-0.4642857015132904,0],0]]],["Gold",5,!1,1,0,
!1,9154707565741156,[["star-sheet1.png",3896,0,0,56,58,1,0.5,0.5,[],[-0.2142859995365143,-0.2241379916667938,0,-0.4482758939266205,0.1964290142059326,-0.2068969905376434,0.482142984867096,0,0.375,0.3793100118637085,0,0.3965520262718201,-0.357142984867096,0.3620690107345581,-0.4642857015132904,0],0]]]],[],!1,!1,6491168050390057,[],null],["t222",cr.plugins_.CJSAds,!1,[],0,0,null,null,[],!1,!1,882917722771892,[],null,[0,0,0,1,""]],["t223",cr.plugins_.Sprite,!0,[0x7534ad5acd71e,5252477848814831,0x863a04003b645,
0x7847ae9c3aefa,4687849139865124,8206021773019529,7787530681080265,4593361125132821,5694437029417438,7937148352324737],6,0,null,null,[["DestroyOutsideLayout",cr.behaviors.destroy,0xeba4db81078e3],["Bullet",cr.behaviors.Bullet,4534104296800623],["Timer",cr.behaviors.Timer,355462734390441],["Cheering",cr.behaviors.Sin,9509785330396352],["Angry",cr.behaviors.Sin,7581519319899163],["GoodMood",cr.behaviors.Flash,5676956494395194]],!1,!1,5299367256152061,[],null],["t224",cr.plugins_.Sprite,!0,[],0,0,null,
null,[],!1,!1,0xaed40b87b429d,[],null],["t225",cr.plugins_.Sprite,!0,[9864496025830156,4796633116966646,7509804640143008,618760461470411],2,0,null,null,[["SineHorizontal",cr.behaviors.Sin,5914131885436668],["SineVertical",cr.behaviors.Sin,0x7e24b5018e646]],!1,!1,0xbc1141d610ef2,[],null],["t226",cr.plugins_.Sprite,!0,[6723803989352219,5741053672722837,8231228434636449,5412557656467499,0xa53853d9a63c2],1,0,null,null,[["Slide",cr.behaviors.Bullet,8036660603715804]],!1,!1,0x46faee8dc2875,[],null],["t227",
cr.plugins_.Sprite,!0,[],1,0,null,null,[["Fade",cr.behaviors.Fade,6785345375979534]],!1,!1,7782013417354473,[],null],["t228",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,9896611548318668,[],null],["t229",cr.plugins_.Text,!0,[314502147227465],2,0,null,null,[["Fade",cr.behaviors.Fade,7343305753864957],["Pin",cr.behaviors.Pin,8070486056660455]],!1,!1,0xab5e72a868c1e,[],null],["t230",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,904527912069135,[],null],["t231",cr.plugins_.Sprite,!0,[],0,0,null,
null,[],!1,!1,0xbd81d6064b9a7,[],null],["t232",cr.plugins_.Sprite,!0,[0x6e6eb0b861297,6363859354090057,6102315593477598],1,0,null,null,[["Pin",cr.behaviors.Pin,5700624758403442]],!1,!1,9501322448827380,[],null],["t233",cr.plugins_.Text,!0,[],1,0,null,null,[["Pin",cr.behaviors.Pin,0x72d8464f17b49]],!1,!1,0x4478391ce8b93,[],null],["t234",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,7714728802281918,[],null],["t235",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,6982469941048853,[],null],["t236",
cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,430406981007142,[],null],["t237",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,0xc46045f2c3353,[],null],["t238",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,0x51e5841f051e0,[],null],["t239",cr.plugins_.Sprite,!0,[0x58183a808c6a2],1,0,null,null,[["Sine",cr.behaviors.Sin,6796180591600012]],!1,!1,0xe624626bb5ef9,[],null],["t240",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,7632496535503603,[],null],["t241",cr.plugins_.Sprite,!0,[],0,0,null,null,
[],!1,!1,9339337108135096,[],null],["t242",cr.plugins_.Sprite,!0,[5051588670201652],0,0,null,null,[],!1,!1,0x397a6d831c916,[],null],["t243",cr.plugins_.Text,!0,[],1,0,null,null,[["Pin",cr.behaviors.Pin,6583348860004109]],!1,!1,0x528ef9b1bd3a1,[],null],["t244",cr.plugins_.Sprite,!0,[],1,0,null,null,[["Pin",cr.behaviors.Pin,0xa903538ee1900]],!1,!1,0x764480977c7e2,[],null],["t245",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,4761656973135716,[],null],["t246",cr.plugins_.Sprite,!0,[7079665166280771,
9327309189858922],0,0,null,null,[],!1,!1,9208311643894404,[],null],["t247",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,0xed155f4d7cdeb,[],null],["t248",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,8505203747412526,[],null],["t249",cr.plugins_.Spriter,!0,[],0,0,null,null,[],!1,!1,0x7158e46e1441,[],null],["t250",cr.plugins_.Sprite,!0,[],1,0,null,null,[["SineSize",cr.behaviors.Sin,5556836510604225]],!1,!1,9842757055377908,[],null],["t251",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,811829164906421,
[],null],["t252",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,7311690744514801,[],null],["t253",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,0xb93cca1a6b823,[],null]],[[223,27,29,24,21,30,22,23,28,26,25],[224,140,136,139,207,16,11,10,36,14,15,12,37,18,176,220,17,177,175,174,130,129,128],[225,11,10,14,18,150,110,180,20],[226,90,92,91,123,121,38,122],[227,11,10,97,14,96,37,95],[228,140,136,139,207,16,97,36,15,12,96,37,176,220,17,95,159,158,160,152,153,177,130,129,128],[229,108,99],[230,168,167,
165,166,164,163,162,161],[231,9,6,5,4,0,3,2,1,8,7],[232,140,136,139],[233,100,102,103],[234,82,76,77,80,79,78,81],[235,83],[236,86,87,89,88],[237,84,85],[238,59,60],[239,42,43,44,41],[240,46,56,47,48,49,50,51,52,53,54,55],[241,207,16,11,10,97,36,14,15,12,96,37,18,176,220,17,95,159,158,160,152,153,177,175,174,130,129,128],[242,156,154,90,173],[243,218,135],[244,149,109,101,217,221],[245,75],[246,156,154],[247,182,184,187,190,191,192,200,194,186,196,197,199,198,195,183,188,189,185,193],[248,93,112,
124],[249,106,107],[250,11,10,14,18],[251,207,36,12,176,220],[252,36,176,220,17],[253,207,16,15,12]],[["Loading",1080,720,!1,"LoadingEvent",6325780731321275,[["Layer 0",0,7357828492537108,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],172,111,[],[],[0,"Default",0,0]],[[540,332.5,0,100,50,0,0,1,0.5,0.5,0,0,[]],73,49,[],[],["0%",0,"24pt Arial","rgb(120,120,120)",1,1,1,0,0]],[[540,442.5,0,800,30,0,0,1,0.5,0.5,0,0,[]],74,51,[[""]],[],["T\u1ea3i h\u00ecnh \u1ea3nh tr\u00f2 ch\u01a1i...",
0,"16pt Arial","rgb(120,120,120)",1,1,1,0,0]],[[540,332.5,0,20,20,0,0,0.5199999809265137,0.5,3.5,0,0,[]],75,332,[],[[318,0],[1,7,0,3.67,0,0,0,18,0]],[0,"Blue",0,1]],[[540,332.5,0,20,20,0,0,0.5199999809265137,-2.5,0.5,0,0,[]],75,333,[],[[193,0],[1,7,0,4.29,0,0,0,18,0]],[0,"Pink",0,1]],[[540,332.5,0,20,20,0,0,0.5199999809265137,0.5,-2.5,0,0,[]],75,334,[],[[248,0],[1,7,0,5.12,0,0,0,18,0]],[0,"Yellow",0,1]],[[540,332.5,0,20,20,0,0,0.5199999809265137,3.5,0.5,0,0,[]],75,335,[],[[209,0],[1,7,0,5.25,0,0,
0,18,0]],[0,"Green",0,1]]],[]],["Dialog",1,6634278517099541,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]]],[[null,70,48,[],[],[3,1,1]],[null,141,174,[],[],[]],[null,142,175,[],[],[]],[null,147,185,[],[],[]],[null,148,186,[],[],[]],[null,145,206,[],[],[]],[null,146,207,[],[],[]],[null,209,264,[],[],[10,1,1]]],[]],["MainMenu",1080,720,!1,"MainMenuEvent",9869284546547656,[["Background",0,0xae4e2d7333280,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[0,0,0,1080,720,0,0,1,0,0,0,0,[]],169,4,[],[],[0,0]],[[0,720,0,50,
50,0,0,1,0.5,0.5,0,0,[]],170,109,[],[],["CommonBackgroundAnim.scml","",""]],[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],172,110,[],[],[0,"Default",0,1]]],[]],["Title",1,9772763850754794,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[90,645,0,50,50,0,0,1,0.5,0.5,0,0,[]],13,152,[],[],["WelcomeTitle.scml","",""]]],[]],["Entities",2,6080905531620399,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[954,100,0,71,78,0,0,1,0.5070422291755676,0.5,0,0,[]],176,305,[],[],[0,"Default",0,1]],[[540,510,0,214,232,0,0,1,0.4953271150588989,
0.4913793206214905,0,0,[]],14,317,[[0],[0],[1],[0],[0]],[[1,0,0,4,0,0,4,5,0],[1,1,0,4,0,0,4,10,0],[1,0.4,0,0,1],[0,2,0,0.75,0,0,0,5,0],[]],[0,"Default",0,0]],[[780,570,0,151,158,0,0,1,0.503311276435852,0.5,0,0,[]],11,318,[[0],[0],[1],[0]],[[1,0,0,4,0,0,4,5,0],[1,1,0,4,0,0,4,10,0],[1,0.4,0,0,1],[0,2,0,0.75,0,0,0,5,0],[]],[0,"Default",0,0]],[[300,570,0,151,158,0,0,1,0.503311276435852,0.5,0,0,[]],10,319,[[0],[0],[1],[0]],[[1,0,0,4,0,0,4,5,0],[1,1,0,4,0,0,4,10,0],[1,0.4,0,0,1],[0,2,0,0.75,0,0,0,5,0],
[]],[0,"Default",0,0]]],[]],["Dialog",3,0x44035680d2cac,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]]],[],[]],["Story",1080,720,!1,"StoryEvent",7817962208713065,[["Background",0,0x660beb22fb535,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],172,117,[],[],[0,"Default",0,1]]],[]],["Entities",1,0x86e7da6a84c6,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[90,660,0,50,50,0,0,1,0.5,0.5,0,0,[]],201,360,[],[],["Story.scml","",""]],[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],202,120,[],
[],[0,"Default",0,1]],[[980,100,0,71,78,0,0,1,0.5070422291755676,0.5,0,0,[]],220,361,[],[],[0,"Default",0,1]]],[]],["Dialog",2,0x41bbf2a939638,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]]],[],[]],["Intro",1080,720,!1,"IntroEvent",5427001648539738,[["Background",0,4807073348653586,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[0,0,0,1080,720,0,0,1,0,0,0,0,[]],169,306,[],[],[0,0]],[[0,720,0,50,50,0,0,1,0.5,0.5,0,0,[]],170,307,[],[],["CommonBackgroundAnim.scml","",""]],[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],
172,113,[],[],[0,"Default",0,1]],[[90,645,0,50,50,0,0,1,0.5,0.5,0,0,[]],13,316,[],[],["WelcomeTitle.scml","",""]]],[]],["Dialog",1,0xb01dc64ed862c,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]]],[],[]],["SelectLevel",1080,720,!1,"SelectLevelEvent",0xd02a392f110dd,[["Background",0,0xf15f0f0ccb5a7,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[0,0,0,1080,720,0,0,1,0,0,0,0,[]],169,30,[],[],[0,0]],[[0,720,0,50,50,0,0,1,0.5,0.5,0,0,[]],170,122,[],[],["CommonBackgroundAnim.scml","",""]],[[540,360,0,1080,720,0,0,1,0.5,
0.5,0,0,[]],172,121,[],[],[0,"Default",0,1]]],[]],["Entities",1,9196834576764194,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[540,100,0,250,62,0,0,1,0.5,0.5,0,0,[]],20,2,[[0],[0],[0],[0]],[[1,0,0,4,0,0,4,5,0],[1,1,0,4,0,0,4,10,0]],[0,"Default",0,1]],[[100,100,0,71,78,0,0,1,0.5070422291755676,0.5,0,0,[]],207,8,[],[],[0,"Default",0,1]]],[]],["Dialog",2,6321046281722079,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]]],[[null,203,28,[],[],[1,1,1]]],[]],["LeaderBoard",1080,720,!1,"LeaderBoardEvent",0xc47653ac40979,
[["Background",0,0xbdf5e7bb83a19,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[0,0,0,1080,720,0,0,1,0,0,0,0,[]],169,56,[],[],[0,0]],[[0,720,0,50,50,0,0,1,0.5,0.5,0,0,[]],170,143,[],[],["CommonBackgroundAnim.scml","",""]],[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],172,144,[],[],[0,"Default",0,1]]],[]],["Entities",1,0x73e63e0536325,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[100,100,0,71,78,0,0,1,0.5070422291755676,0.5,0,0,[]],207,116,[],[],[0,"Default",0,1]],[[540,135,0,544,108,0,0,1,0.5,0.5,0,0,[]],110,118,[[0],
[0],[0],[0]],[[1,0,0,4,0,0,4,5,0],[1,1,0,4,0,0,4,10,0]],[0,"Default",0,1]],[[692,291,0,276,182,0,0,1,0.5,0.5,0,0,[]],111,115,[],[],[0,"Default",0,1]],[[691,504,0,278,132,0,0,1,0.5035971403121948,0.4924242496490479,0,0,[]],112,119,[],[],[0,"Default",0,1]],[[618,312,0,106,88,0,0,1,0.5,0.5,0,0,[]],114,125,[],[],["",0,"bold 36pt Arial","rgb(255,255,255)",1,1,1,1,0]],[[750,289,0,134,30,0,0,1,0.5,0.5,0,0,[]],115,126,[],[],["",0,"bold 14pt Arial","rgb(255,255,255)",1,2,1,0,0]],[[750,329,0,134,45,0,0,1,0.5,
0.5,0,0,[]],116,127,[],[],["",0,"bold 22pt Arial","rgb(255,255,255)",1,0,1,1,0]],[[725,218,0,92,39,0,0,1,0,0,0,0,[]],218,331,[],[[]],["",0,"bold 16pt Arial","rgb(51,153,153)",0,1,0,1,0]],[[619,236,0,105,42,0,0,1,0.5,0.5,0,0,[]],120,362,[],[],["TH\u1ee8 H\u1ea0NG C\u1ee6A B\u1ea0N",0,"bold 12pt Arial","rgb(51,153,153)",1,1,1,0,0]],[[703,237,0,40,40,0,0,1,0.4923076927661896,0.5076923370361328,0,0,[]],217,363,[],[[]],[0,"TXu",0,1]],[[692,462,0,268,42,0,0,1,0.5,0.5,0,0,[]],120,192,[],[],["HUY HI\u1ec6U",
0,"bold 20pt Arial","rgb(51,153,153)",1,1,1,0,0]]],[]],["Dialog",2,0x519ca8d45137a,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]]],[],[]],["LocalInfo",1080,720,!1,"LocalInfoEvent",0x73299bb7fda14,[["Background",0,7959670811041505,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[0,0,0,1080,720,0,0,1,0,0,0,0,[]],169,280,[],[],[0,0]],[[0,720,0,50,50,0,0,1,0.5,0.5,0,0,[]],170,281,[],[],["CommonBackgroundAnim.scml","",""]],[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],172,145,[],[],[0,"Default",0,1]]],[]],["Entities",1,
8514157743675188,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[540,330,0,372,246,0,0,1,0.5,0.5,0,0,[]],178,294,[],[],[0,"Default",0,1]],[[100,100,0,71,78,0,0,1,0.5070422291755676,0.5,0,0,[]],207,292,[],[],[0,"Default",0,1]],[[540.5,540,0,278,132,0,0,1,0.5035971403121948,0.4924242496490479,0,0,[]],112,295,[],[],[0,"Default",0,1]],[[542,367,0,297,103,0,0,1,0.5,0.5,0,0,[]],179,296,[],[],["0",0,"bold 26pt Arial","rgb(255,255,255)",1,1,1,1,0]],[[540,135,0,406,108,0,0,1,0.5,0.5,0,0,[]],180,297,[[0],[0],[0],[0]],
[[1,0,0,4,0,0,4,5,0],[1,1,0,4,0,0,4,10,0]],[0,"Default",0,1]],[[542,266,0,357,76,0,0,1,0.5,0.5,0,0,[]],181,321,[],[],["T\u1ed4NG \u0110I\u1ec2M C\u1ee6A B\u1ea0N",0,"bold 20pt Arial","rgb(51,153,153)",1,1,1,0,0]],[[541,498,0,268,42,0,0,1,0.5,0.5,0,0,[]],120,193,[],[],["HUY HI\u1ec6U",0,"bold 20pt Arial","rgb(51,153,153)",1,1,1,0,0]]],[]],["Dialog",2,4803294020060696,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]]],[],[]],["HowToPlay",1080,720,!1,"HowToPlayEvent",0x595b5fb9c8731,[["Background",0,6814688541652221,
!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[0,0,0,1080,720,0,0,1,0,0,0,0,[]],169,229,[],[],[0,0]],[[0,720,0,50,50,0,0,1,0.5,0.5,0,0,[]],170,230,[],[],["CommonBackgroundAnim.scml","",""]],[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],172,114,[],[],[0,"Default",0,1]]],[]],["Entities",1,0x407ab7a82963c,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[90,630,0,200,30,0,0,1,0,0,0,0,[]],219,322,[],[],["",0,"10pt Arial","rgb(200,200,200)",0,1,0,0,0]],[[100,100,0,71,78,0,0,1,0.5070422291755676,0.5,0,0,[]],207,239,[],[],[0,"Default",
0,1]],[[540,120,0,250,62,0,0,1,0.5,0.5,0,0,[]],150,240,[[0],[0],[0],[0]],[[1,0,0,4,0,0,4,5,0],[1,1,0,4,0,0,4,10,0]],[0,"Default",0,1]],[[540,390,0,555,444,0,0,1,0.50090092420578,0.5,0,0,[]],151,241,[],[],[0,"Default",0,1]],[[860,390,0,79,112,0,0,1,0.5063291192054749,0.5,0,0,[]],152,242,[],[[]],[0,"Default",0,1]],[[220,390,0,79,112,0,0,1,0.5063291192054749,0.5,0,0,[]],153,243,[],[[]],[0,"Default",0,1]]],[]],["Dialog",2,0x55c2da1a04772,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]]],[],[]],["Game",1080,
720,!1,"GameEvent",4542653107802367,[["Background",0,0x3e0aeb5681b78,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],71,55,[],[],[0,"Default",0,0]]],[]],["Customer",1,6156843194072783,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]],["Table",2,8504317508192828,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],72,29,[],[],[0,"Default",0,0]],[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],172,124,[],[],[0,"Default",0,1]]],[]],["Ingredient",3,0xdc92ffc3852d0,
!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[420,450,0,92,98,0,0,1,0.5,0.5,0,0,[]],59,42,[[""]],[],[0,"Default",0,0]],[[510,450,0,92,98,0,0,1,0.5,0.5,0,0,[]],59,43,[[""]],[],[0,"Default",0,0]],[[600,450,0,92,98,0,0,1,0.5,0.5,0,0,[]],59,44,[[""]],[],[0,"Default",0,0]],[[389,534,0,120,79,0,0,1,0.5,0.5063291192054749,0,0,[]],60,34,[[""]],[],[0,"Default",0,0]],[[509,534,0,120,79,0,0,1,0.5,0.5063291192054749,0,0,[]],60,35,[[""]],[],[0,"Default",0,0]],[[629,534,0,120,79,0,0,1,0.5,0.5063291192054749,0,0,[]],60,
36,[[""]],[],[0,"Default",0,0]],[[389,615,0,120,79,0,0,1,0.5,0.5063291192054749,0,0,[]],60,37,[[""]],[],[0,"Default",0,0]],[[509,615,0,120,79,0,0,1,0.5,0.5063291192054749,0,0,[]],60,38,[[""]],[],[0,"Default",0,0]],[[629,615,0,120,79,0,0,1,0.5,0.5063291192054749,0,0,[]],60,39,[[""]],[],[0,"Default",0,0]],[[895,536,0,194,112,0,0,1,0.5,0.5,0,0,[]],62,23,[],[],[0,"Default",0,0]],[[896,445,0,122,132,0,0,1,0.5081967115402222,0.5,0,0,[]],64,33,[[""],[-1]],[],[0,"Default",0,0]],[[873,488,0,29,24,0,0,1,0.517241358757019,
0.5,0,0,[]],66,17,[[""]],[[0,1,0,2,0,0,0,2,0],[0,0,0,0,3,0,0,0,1]],[0,"Default",0,0]],[[910,490,0,29,24,0,0,1,0.517241358757019,0.5,0,0,[]],66,18,[[""]],[[0,1,0,2,0,0,0,2,0],[0,0,0,0,3,0,0,0,1]],[0,"Default",0,0]],[[894,463,0,29,24,0,0,1,0.517241358757019,0.5,0,0,[]],66,19,[[""]],[[0,1,0,2,0,0,0,2,0],[0,0,0,0,3,0,0,0,1]],[0,"Default",0,0]],[[927,465,0,29,24,0,0,1,0.517241358757019,0.5,0,0,[]],66,20,[[""]],[[0,1,0,2,0,0,0,2,0],[0,0,0,0,3,0,0,0,1]],[0,"Default",0,0]],[[917,434,0,29,24,0,0,1,0.517241358757019,
0.5,0,0,[]],66,21,[[""]],[[0,1,0,2,0,0,0,2,0],[0,0,0,0,3,0,0,0,1]],[0,"Default",0,0]],[[869,440,0,199,158,0,0,1,0.5025125741958618,0.5,0,0,[]],65,31,[[0]],[],[0,"Default",0,0]],[[905,629,0,118,61,0,0,1,0.5,0.5081967115402222,0,0,[]],67,24,[],[],[0,"Default",0,1]],[[763,570,0,88,117,0,0,1,0.3068181872367859,0.9572649598121643,0,0,[]],63,27,[],[[0,0],[1,2,0,0.2,0,0,0,5,0],[],[],[0,0,0,0.5,1],[1]],[0,"Default",0,1]],[[763,570,0,39,58,0,0,1,0.5384615659713745,0.9655172228813171,0,0,[]],61,32,[[""]],[[],
[0,0,0,0.5,1]],[0,"Default",0,1]]],[]],["HUD",4,5008036013547489,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[280,100,0,367,65,0,0,1,0.5013623833656311,0.5076923370361328,0,0,[]],31,40,[],[],[0,"Default",0,0]],[[140,80,0,140,34,0,0,1,0,0,0,0,[]],32,45,[[0]],[],[28,34,"0123456789","0",1,0,0,1,0,0,0,0]],[[611,100,0,218,65,0,0,1,0.5045871734619141,0.5076923370361328,0,0,[]],34,47,[],[],[0,"Default",0,0]],[[308,80,0,140,34,0,0,1,0,0,0,0,[]],33,50,[],[],[28,34,"0123456789","0",1,0,0,1,0,0,0,0]],[[560,80,0,140,
34,0,0,1,0,0,0,0,[]],35,53,[[0],[0]],[[]],[28,34,"0123456789:","00:00",1,0,0,1,0,0,0,0]],[[980,100,0,71,78,0,0,1,0.5070422291755676,0.5,0,0,[]],36,131,[],[],[0,"Default",0,0]],[[203,616,0,237,86,0,0,1,0.502109706401825,0.5,0,0,[]],143,176,[],[],[0,"Default",0,1]],[[128,617,0,65,74,0,0,1,0.5076923370361328,0.5,0,0,[]],136,181,[[-1],[""],["extra-time"]],[[]],[0,"Default",0,1]],[[204,617,0,65,74,0,0,1,0.5076923370361328,0.5,0,0,[]],140,182,[[-1],[""],["double-cash"],[0],[0]],[[],[]],[0,"Default",0,1]],
[[279,617,0,65,74,0,0,1,0.5076923370361328,0.5,0,0,[]],139,183,[[-1],[""],["good-mood"]],[[]],[0,"Default",0,1]],[[289,146,0,242,20,0,0,1,0.5,0.5,0,0,[]],39,251,[],[],[0,"Default",0,0]],[[172,137,0,235,16,0,0,1,0,0,0,0,[]],40,252,[],[[]],[0,0]],[[172,145,0,21,21,0,0,1,0.523809552192688,0.523809552192688,0,0,[]],41,253,[[0]],[[0,2,0,0.2,0,0,0,5,0]],[0,"Default",0,0]],[[220,145,0,21,21,0,0,1,0.523809552192688,0.523809552192688,0,0,[]],42,254,[[0]],[[0,2,0,0.2,0,0,0,5,0]],[0,"Default",0,0]],[[273,145,
0,21,21,0,0,1,0.523809552192688,0.523809552192688,0,0,[]],43,255,[[0]],[[0,2,0,0.2,0,0,0,5,0]],[0,"Default",0,0]],[[303,145,0,21,21,0,0,1,0.523809552192688,0.523809552192688,0,0,[]],44,256,[[0]],[[0,2,0,0.2,0,0,0,5,0]],[0,"Default",0,0]]],[]],["Dialog",5,6896302374087267,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]]],[],[]],["LevelIntro",1080,720,!1,"LevelIntroEvent",0xb181dc781a86c,[["Background",0,0xde2d7cd54f7a9,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],71,1,[],
[],[0,"Default",0,0]],[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],72,3,[],[],[0,"Default",0,0]],[[0,0,0,1080,720,0,0,0.6000000238418579,0,0,0,0,[]],171,169,[],[],[0,0]],[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],172,123,[],[],[0,"Default",0,1]]],[]],["Table",1,0xbbda320c49f06,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]],["HUD",2,0x5559a337b2d5b,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[540,783,0,659,124,0,0,1,0.500758707523346,0.5,0,0,[]],123,5,[[0.5],[540],[525],[540],[783]],[[400,0,0,0,0,1]],[0,"Default",
0,1]],[[-232,335,0,440,430,0,0,1,0.5,0.5,0,0,[]],121,157,[[0.5],[390],[335],[-232],[335]],[[400,0,0,0,0,1]],[0,"Default",0,1]],[[1264,385,0,366,374,0,0,1,0.5,0.5,0,0,[]],122,156,[[0.5],[725],[385],[1264],[385]],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[-198,297,0,392,440,0,0,1,0.5,0.5,0,0,[]],124,158,[],[[]],[0,"Default",0,1]],[[100,100,0,71,78,0,0,1,0.5070422291755676,0.5,0,0,[]],207,162,[],[],[0,"Default",0,1]]],[]],["Dialog",3,6079970473011165,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]]],[],[]],
["zDraft",1080,720,!1,null,0xc167da09a86e7,[["Background",0,825996243280745,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[0,0,0,1080,720,0,0,1,0,0,0,0,[]],169,57,[],[],[0,0]],[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],172,128,[],[],[0,"Default",0,1]]],[]],["Story",1,928630540659854,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[839,542,0,50,50,0,0,1,0.5,0.5,0,0,[]],201,340,[],[],["Story.scml","",""]],[[839,-57,0,900,600,0,-0,1,0.5,0.5,0,0,[]],182,341,[],[],[1,"Default",0,1]],[[839,542,0,900,600,0,0,1,0.5,0.5,0,0,
[]],183,342,[],[],[1,"Default",0,1]],[[840,-56,0,900,600,0,-0,1,0.5,0.5,0,0,[]],184,343,[],[],[1,"Default",0,1]],[[839,542,0,900,600,0,0,1,0.5,0.5,0,0,[]],185,344,[],[],[1,"Default",0,1]],[[839,542,0,900,600,0,0,1,0.5,0.5,0,0,[]],186,345,[],[],[1,"Default",0,1]],[[839,-57,0,900,600,0,-0,1,0.5,0.5,0,0,[]],187,346,[],[],[1,"Default",0,1]],[[839,542,0,900,600,0,0,1,0.5,0.5,0,0,[]],188,347,[],[],[1,"Default",0,1]],[[839,542,0,900,600,0,0,1,0.5,0.5,0,0,[]],189,348,[],[],[1,"Default",0,1]],[[838,-135,0,
900,600,0,-0,1,0.5,0.5,0,0,[]],190,349,[],[],[1,"Default",0,1]],[[839,542,0,900,600,0,0,1,0.5,0.5,0,0,[]],191,350,[],[],[1,"Default",0,1]],[[839,542,0,900,600,0,0,1,0.5,0.5,0,0,[]],192,351,[],[],[1,"Default",0,1]],[[839,542,0,900,600,0,0,1,0.5,0.5,0,0,[]],193,352,[],[],[1,"Default",0,1]],[[439,81,0,900,600,0,-0,0,0.5,0.5,0,0,[]],194,353,[],[],[1,"Default",0,1]],[[842,-55,0,900,600,0,-0,0,0.5,0.5,0,0,[]],195,354,[],[],[1,"Default",0,1]],[[840,510,0,900,600,0,-0,1,0.5,0.5,0,0,[]],196,355,[],[],[1,"Default",
0,1]],[[838,-135,0,900,600,0,-0,1,0.5,0.5,0,0,[]],197,356,[],[],[1,"Default",0,1]],[[1154,84,0,900,600,0,-0,0,0.5,0.5,0,0,[]],198,357,[],[],[1,"Default",0,1]],[[841,-56,0,900,600,0,-0.5633224844932556,1,0.5,0.5,0,0,[]],199,358,[],[],[1,"Default",0,1]],[[839,-57,0,900,600,0,-0,1,0.5,0.5,0,0,[]],200,359,[],[],[1,"Default",0,1]]],[]],["BackgroundAnim",2,0xd97ded5cecd39,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[0,600,0,50,50,0,0,1,0.5,0.5,0,0,[]],170,58,[],[],["CommonBackgroundAnim.scml","",""]],[[774,454,
0,210,197,0,-0,1,0.5142857432365417,0.5126903653144836,0,0,[]],161,59,[],[],[1,"Default",0,1]],[[573,240,0,166,151,0,-0,1,0.4939759075641632,0.503311276435852,0,0,[]],162,60,[],[],[1,"Default",0,1]],[[272,323,0,190,172,0,-0,1,0.5,0.5058139562606812,0,0,[]],163,61,[],[],[1,"Default",0,1]],[[111,121,0,159,149,0,-0,1,0.5157232880592346,0.4966442883014679,0,0,[]],164,62,[],[],[1,"Default",0,1]],[[21,426,0,26,26,0,-0,1,0,0,0,0,[]],165,63,[],[],[1,"Default",0,1]],[[851,328,0,31,31,0,-0,1,0,0,0,0,[]],166,
64,[],[],[1,"Default",0,1]],[[621,509,0,31,31,0,-0,1,0,0,0,0,[]],167,65,[],[],[1,"Default",0,1]],[[227,486,0,31,31,0,-0,1,0,0,0,0,[]],168,66,[],[],[1,"Default",0,1]]],[]],["Customers",3,0xc866dca604bc9,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[100,400,0,178,197,0,0,1,0.5,1,0,0,[]],21,25,[[30],['""'],[2],[0],[1],["Coming"],[0],[-1],[-1],[0]],[[],[400,0,0,0,0,1],[],[0,1,0,0.5,0,0,0,5,0],[0,5,0,0.25,0,0,0,5,0],[]],[0,"Default",0,1]],[[100,200,0,178,197,0,0,1,0.5,1,0,0,[]],24,9,[[30],['""'],[2],[0],[1],["Coming"],
[0],[-1],[-1],[0]],[[],[400,0,0,0,0,1],[],[0,1,0,0.5,0,0,0,5,0],[0,5,0,0.25,0,0,0,5,0],[]],[0,"Default",0,1]],[[300,200,0,178,197,0,0,1,0.5,1,0,0,[]],22,46,[[30],['""'],[2],[0],[1],["Coming"],[0],[-1],[-1],[0]],[[],[400,0,0,0,0,1],[],[0,1,0,0.5,0,0,0,5,0],[0,5,0,0.25,0,0,0,5,0],[]],[0,"Default",0,1]],[[300,400,0,178,197,0,0,1,0.5,1,0,0,[]],23,244,[[30],['""'],[2],[0],[1],["Coming"],[0],[-1],[-1],[0]],[[],[400,0,0,0,0,1],[],[0,1,0,0.5,0,0,0,5,0],[0,5,0,0.25,0,0,0,5,0],[]],[0,"Default",0,1]],[[500,
200,0,178,197,0,0,1,0.5,1,0,0,[]],26,245,[[30],['""'],[2],[0],[1],["Coming"],[0],[-1],[-1],[0]],[[],[400,0,0,0,0,1],[],[0,1,0,0.5,0,0,0,5,0],[0,5,0,0.25,0,0,0,5,0],[]],[0,"Default",0,1]],[[500,400,0,178,197,0,0,1,0.5,1,0,0,[]],25,246,[[30],['""'],[2],[0],[1],["Coming"],[0],[-1],[-1],[0]],[[],[400,0,0,0,0,1],[],[0,1,0,0.5,0,0,0,5,0],[0,5,0,0.25,0,0,0,5,0],[]],[0,"Default",0,1]],[[100,650,0,181,230,0,0,1,0.5027624368667603,0.947826087474823,0,0,[]],27,247,[[30],['""'],[2],[0],[1],["Coming"],[0],[-1],
[-1],[0]],[[],[400,0,0,0,0,1],[],[0,1,0,0.5,0,0,0,5,0],[0,5,0,0.25,0,0,0,5,0],[]],[0,"Default",0,1]],[[700,650,0,181,230,0,0,1,0.5027624368667603,0.8826087117195129,0,0,[]],29,248,[[30],['""'],[2],[0],[1],["Coming"],[0],[-1],[-1],[0]],[[],[400,0,0,0,0,1],[],[0,1,0,0.5,0,0,0,5,0],[0,5,0,0.25,0,0,0,5,0],[]],[0,"Default",0,1]],[[300,650,0,181,230,0,0,1,0.5027624368667603,0.9739130139350891,0,0,[]],28,249,[[30],['""'],[2],[0],[1],["Coming"],[0],[-1],[-1],[0]],[[],[400,0,0,0,0,1],[],[0,1,0,0.5,0,0,0,5,
0],[0,5,0,0.25,0,0,0,5,0],[]],[0,"Default",0,1]],[[500,650,0,181,230,0,0,1,0.5027624368667603,0.969565212726593,0,0,[]],30,250,[[30],['""'],[2],[0],[1],["Coming"],[0],[-1],[-1],[0]],[[],[400,0,0,0,0,1],[],[0,1,0,0.5,0,0,0,5,0],[0,5,0,0.25,0,0,0,5,0],[]],[0,"Default",0,1]]],[]],["WelcomeTitle",4,320991052615409,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[0,600,0,50,50,0,0,1,0.5,0.5,0,0,[]],13,67,[],[],["WelcomeTitle.scml","",""]],[[493,156,0,174,136,0,-0,0,0,0,0,0,[]],0,68,[],[],[1,"Default",0,1]],[[551,
332,0,146,154,0,-0,0,0,0,0,0,[]],1,69,[],[],[1,"Default",0,1]],[[580,300,0,156,82,0,-0,0,0,0,0,0,[]],2,70,[],[],[1,"Default",0,1]],[[584,237,0,128,77,0,-0,0,0,0,0,0,[]],3,71,[],[],[1,"Default",0,1]],[[216,358,0,174,127,0,-0,0,0,0,0,0,[]],4,72,[],[],[1,"Default",0,1]],[[164,303,0,184,110,0,-0,0,0,0,0,0,[]],5,73,[],[],[1,"Default",0,1]],[[185,229,0,122,122,0,-0,0,0,0,0,0,[]],6,105,[],[],[1,"Default",0,1]],[[460,288,0,127,107,0,-0,0,0,0,0,0,[]],7,106,[],[],[1,"Default",0,1]],[[432,287,0,396,291,0,-0,
0,0,0,0,0,[]],8,107,[],[],[1,"Default",0,1]],[[290,-129,0,106,123,0,-0,1,0,0,0,0,[]],9,108,[],[],[1,"Default",0,1]]],[]],["WelcomeBtns",5,0x7e7f93bacf3d9,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[450,420,0,214,232,0,0,1,0.4953271150588989,0.4913793206214905,0,0,[]],14,153,[[0],[0],[1],[0],[0]],[[1,0,0,4,0,0,4,5,0],[1,1,0,4,0,0,4,10,0],[1,0.4,0,0,1],[0,2,0,0.75,0,0,0,5,0],[]],[0,"Default",0,0]],[[210,480,0,151,158,0,0,1,0.503311276435852,0.5,0,0,[]],10,154,[[0],[0],[1],[0]],[[1,0,0,4,0,0,4,5,0],[1,1,0,
4,0,0,4,10,0],[1,0.4,0,0,1],[0,2,0,0.75,0,0,0,5,0],[]],[0,"Default",0,0]],[[690,480,0,151,158,0,0,1,0.503311276435852,0.5,0,0,[]],11,155,[[0],[0],[1],[0]],[[1,0,0,4,0,0,4,5,0],[1,1,0,4,0,0,4,10,0],[1,0.4,0,0,1],[0,2,0,0.75,0,0,0,5,0],[]],[0,"Default",0,0]],[[100,100,0,71,78,0,0,1,0.5070422291755676,0.5,0,0,[]],12,257,[],[],[0,"Default",0,0]],[[100,300,0,99,94,0,0,1,0.5050504803657532,0.5,0,0,[]],15,300,[[0]],[],[0,"Default",0,0]],[[960,250,0,117,106,0,0,1,0.504273533821106,0.5,0,0,[]],17,129,[],[],
[0,"Default",0,0]],[[100,200,0,99,94,0,0,1,0.5050504803657532,0.5,0,0,[]],16,130,[],[],[0,"Default",0,0]]],[]],["SelectLevel",6,9282499620929320,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[58,60,0,95,115,0,0,1,0.4526315927505493,0.3478260934352875,0,0,[]],18,6,[[0],[0],[0],[1],[-1]],[[0,0,0,4,0,0,4,0,0],[0,1,0,1,0,0,0,5,0],[0,2,0,0.75,0,0,0,5,0]],[0,"Default",0,1]],[[58,60,0,86,80,0,0,1,0.5,0.5,0,0,[]],19,54,[[-1]],[[]],[25,32,"0123456789","",1,0,1,1,1,0,0,0]]],[]],["PauseGameDialog",7,0x6517d7676dce1,
!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[540,508,0,348,67,0,0,1,0.5,0.5074626803398132,0,0,[]],38,139,[[0.3],[540],[393],[540],[720]],[[400,0,0,0,0,1]],[0,"Default",0,0]],[[450,300,0,89,97,0,0,1,0.5056179761886597,0.5051546096801758,0,0,[]],37,132,[],[[1,0.4,0,0,1]],[0,"Default",0,0]],[[560,300,0,89,97,0,0,1,0.5056179761886597,0.5051546096801758,0,0,[]],37,133,[],[[1,0.4,0,0,1]],[0,"Default",0,0]],[[340,300,0,89,97,0,0,1,0.5056179761886597,0.5051546096801758,0,0,[]],37,134,[],[[1,0.4,0,0,1]],[0,"Default",
0,0]]],[]],["GameEntities",8,0x492bb84cbe65e,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[122,393,0,174,66,0,0,1,0.5,1,0,0,[]],57,12,[],[[],[]],[0,"Default",0,0]],[[240,420,0,29,24,0,0,0.800000011920929,0.517241358757019,0.5,0,0,[]],66,15,[[""]],[[0,1,0,2,0,0,0,2,0],[0,0,0,0,3,0,0,0,1]],[0,"Default",0,0]],[[123,350,0,147,32,0,0,1,0.5,0.5,0,0,[]],58,13,[],[[],[]],[49,32,"123ABCDEF","ABC",1,0,1,1,1,1,0,0]],[[131,510,0,88,117,0,0,1,0.3068181872367859,0.9572649598121643,0,0,[]],63,16,[],[[0,0],[1,2,0,0.2,0,
0,0,5,0],[],[],[0,0,0,0.5,1],[1]],[0,"Default",0,1]],[[60,480,0,39,58,0,0,0.800000011920929,0.5384615659713745,0.9655172228813171,0,0,[]],61,26,[[""]],[[],[0,0,0,0.5,1]],[0,"Default",0,1]]],[]],["BoosterPanel",9,6668760474199067,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[91,44,0,237,86,0,0,1,0.502109706401825,0.5,0,0,[]],143,177,[],[],[0,"Default",0,1]],[[34,44,0,65,74,0,0,1,0.5076923370361328,0.5,0,0,[]],136,178,[[-1],[""],["extra-time"]],[[]],[0,"Default",0,1]],[[101,44,0,65,74,0,0,1,0.5076923370361328,
0.5,0,0,[]],140,179,[[-1],[""],["double-cash"],[0],[0]],[[],[]],[0,"Default",0,1]],[[168,44,0,65,74,0,0,1,0.5076923370361328,0.5,0,0,[]],139,180,[[-1],[""],["good-mood"]],[[]],[0,"Default",0,1]],[[119,132,0,65,74,0,0,1,0.5076923370361328,0.5,0,0,[]],144,184,[],[[0,1]],[0,"Default",0,1]]],[]],["Dialog",10,6399069839703266,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[450,150,0,424,229,0,0,1,0.5,0.5021833777427673,0,0,[]],154,0,[[-1],[""],[""]],[],[0,"Default",0,1]],[[450,150,0,300,75,0,0,1,0.5,0.5,0,0,[]],
155,258,[],[[]],["Text",0,"16pt Arial","rgb(0,0,0)",1,1,1,0,0]],[[450,400,0,417,241,0,0,1,0.5011990666389465,0.5020747184753418,0,0,[]],156,259,[[-1],[""],[""],[""]],[],[0,"Default",0,1]],[[450,400,0,300,75,0,0,1,0.5,0.5,0,0,[]],157,260,[],[[]],["Text",0,"16pt Arial","rgb(0,0,0)",1,1,1,0,0]],[[400,450,0,132,50,0,0,1,0.5,0.5,0,0,[]],158,261,[],[[]],[0,"Default",0,1]],[[550,450,0,132,50,0,0,1,0.5,0.5,0,0,[]],159,262,[],[[]],[0,"Default",0,1]],[[450,200,0,132,50,0,0,1,0.5,0.5,0,0,[]],160,263,[],[[]],
[0,"Default",0,1]]],[]],["Coin",11,0x453865538b6de,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[250,200,0,50,50,0,0,1,0.5,0.5,0,0,[]],68,266,[],[],["Coin.scml","",""]],[[257.6470336914063,193.4248962402344,0,39,44,0,-0,1,0.5384615659713745,0.4772727191448212,0,0,[]],46,267,[],[],[1,"Default",0,0]],[[250,200,0,39,44,0,0,1,0.5128205418586731,0.5,0,0,[]],47,268,[],[],[1,"Default",0,0]],[[271.6315307617188,268.1545104980469,0,39,44,0,-0,0,0,0,0,0,[]],48,269,[],[],[1,"Default",0,0]],[[277.3060913085938,268.1812438964844,
0,39,44,0,-0,0,0,0,0,0,[]],49,270,[],[],[1,"Default",0,0]],[[281.2664794921875,268.6763000488281,0,39,44,0,-0,0,0,0,0,0,[]],50,271,[],[],[1,"Default",0,0]],[[288.1971740722656,268.4287719726563,0,39,44,0,-0,0,0,0,0,0,[]],51,272,[],[],[1,"Default",0,0]],[[293.8902587890625,268.1812438964844,0,39,44,0,-0,0,0,0,0,0,[]],52,273,[],[],[1,"Default",0,0]],[[297.6031188964844,268.6763000488281,0,39,44,0,-0,0,0,0,0,0,[]],53,274,[],[],[1,"Default",0,0]],[[304.0387573242188,268.6763000488281,0,39,44,0,-0,0,0,
0,0,0,[]],54,275,[],[],[1,"Default",0,0]],[[300.2169799804688,268.6763000488281,0,39,44,0,-0,0,0,0,0,0,[]],55,276,[],[],[1,"Default",0,0]],[[291.6229248046875,268.4188842773438,0,39,44,0,-0,0,0,0,0,0,[]],56,277,[],[],[1,"Default",0,0]],[[325,150,0,150,45,0,0,1,0.5,0.5,0,0,[]],69,278,[],[[1,1E3,0,0,0,0],[0,0,0,1,1]],[34,45,"$0123456789","$0",1,0,1,1,1,0,-7,0]]],[]],["Login",12,5667404052892135,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[],[]],["SoundPanel",13,0xb0d1fb7124c21,!0,[255,255,255],!0,1,1,1,!1,1,
0,0,[[[450,300,0,430,275,0,0,1,0.5,0.5018181800842285,0,0,[]],173,293,[[-1]],[],[0,"Default",0,1]],[[350,375,0,72,72,0,0,1,0.5,0.5,0,0,[]],174,302,[],[],[0,"Default",0,1]],[[550,375,0,72,72,0,0,1,0.5,0.5,0,0,[]],175,303,[],[],[0,"Default",0,1]],[[860,40,0,71,78,0,0,1,0.5070422291755676,0.5,0,0,[]],176,304,[],[],[0,"Default",0,1]],[[650,200,0,71,78,0,0,1,0.5070422291755676,0.5,0,0,[]],177,320,[],[],[0,"Default",0,1]]],[]],["Achievement",14,5457386410888824,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[140,
65,0,278,132,0,0,1,0.5035971403121948,0.4924242496490479,0,0,[]],112,187,[],[],[0,"Default",0,1]],[[54,79,0,74,74,0,0,1,0.5,0.5,0,0,[]],149,189,[],[[]],[0,"Default",0,0]],[[140,79,0,74,74,0,0,1,0.5,0.5,0,0,[]],149,190,[],[[]],[0,"Default",0,0]],[[226,79,0,74,74,0,0,1,0.5,0.5,0,0,[]],149,191,[],[[]],[0,"Default",0,0]]],[]]],[],[]],["DraftEndGameDialog",900,600,!1,null,0x7554f9c688f62,[["Background",0,7466780110121602,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[0,0,0,1080,720,0,0,0.6000000238418579,0,0,0,
0,[]],171,74,[],[],[0,0]]],[]],["EndGame",1,6249824040766089,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[540,783,0,659,124,0,0,1,0.500758707523346,0.5,0,0,[]],90,75,[[0.5],[540],[525],[540],[783],[-1]],[[400,0,0,0,0,1]],[0,"Default",0,1]],[[162,258,0,440,430,0,0,1,0.5,0.5,0,0,[]],91,76,[[0.5],[390],[335],[-232],[335],[0]],[[400,0,0,0,0,1]],[0,"Default",0,1]],[[-284,591,0,366,374,0,0,1,0.5,0.5,0,0,[]],92,77,[[0.5],[725],[385],[1264],[385]],[[400,0,0,0,0,1]],[0,"Default",0,1]],[[196,220,0,392,440,0,0,1,0.5,
0.5,0,0,[]],93,78,[],[[]],[0,"Offline",0,1]],[[-318,414,0,272,67,0,0,1,0.5,0.5074626803398132,0,0,[]],94,79,[],[[]],[0,"Default",0,1]],[[107,463,0,89,97,0,0,1,0.5056179761886597,0.5051546096801758,0,0,[]],95,80,[],[[1,0.4,0,0,1]],[0,"Default",0,1]],[[287,463,0,89,97,0,0,1,0.5056179761886597,0.5051546096801758,0,0,[]],96,81,[],[[1,0.4,0,0,1]],[0,"Default",0,1]],[[197,463,0,89,97,0,0,1,0.5056179761886597,0.5051546096801758,0,0,[]],97,82,[],[[1,0.4,0,0,1]],[0,"Default",0,1]],[[212,23,0,135,60,0,0,1,
0,0,0,0,[]],98,83,[],[[]],[45,60,"0123456789","1",1,0,0,1,0,1,0,0]],[[194,206,0,235,43,0,0,1,0.5,0.5,0,0,[]],99,84,[[0]],[[1,0.4,0,0,1],[]],["0",0,"bold 28pt Arial","rgb(255,255,255)",1,1,1,1,0]],[[-436,-140,0,47,41,0,0,1,0.5,0.5,0,0,[]],100,89,[],[[]],["1",0,"bold 26pt Arial","rgb(255,255,255)",2,1,1,0,0]],[[-316,-140,0,184,58,0,0,1,0.5,0.5,0,0,[]],101,90,[],[[]],[0,"Default",0,1]],[[-316,-151,0,160,22,0,0,1,0.5,0.5,0,0,[]],102,91,[],[[]],["Text",0,"bold 14pt Arial","rgb(255,255,255)",2,1,1,0,0]],
[[-316,-128,0,160,22,0,0,1,0.5,0.5,0,0,[]],103,92,[],[[]],["0",0,"bold 14pt Arial","rgb(255,255,255)",2,1,1,0,0]],[[-421,567,0,47,41,0,0,1,0.5,0.5,0,0,[]],100,93,[],[[]],["0",0,"26pt Arial Rounded MT Bold","rgb(255,255,255)",2,1,1,0,0]],[[-301,567,0,184,58,0,0,1,0.5,0.5,0,0,[]],101,94,[],[[]],[0,"Default",0,1]],[[-301,556,0,160,22,0,0,1,0.5,0.5,0,0,[]],102,95,[],[[]],["Text",0,"14pt Arial Rounded MT Bold","rgb(255,255,255)",2,1,1,0,0]],[[-301,579,0,160,22,0,0,1,0.5,0.5,0,0,[]],103,96,[],[[]],["Text",
0,"14pt Arial Rounded MT Bold","rgb(255,255,255)",2,1,1,0,0]],[[-421,626,0,47,41,0,0,1,0.5,0.5,0,0,[]],100,97,[],[[]],["0",0,"26pt Arial Rounded MT Bold","rgb(255,255,255)",2,1,1,0,0]],[[-301,626,0,184,58,0,0,1,0.5,0.5,0,0,[]],101,98,[],[[]],[0,"Default",0,1]],[[-301,615,0,160,22,0,0,1,0.5,0.5,0,0,[]],102,99,[],[[]],["Text",0,"14pt Arial Rounded MT Bold","rgb(255,255,255)",2,1,1,0,0]],[[-301,638,0,160,22,0,0,1,0.5,0.5,0,0,[]],103,100,[],[[]],["Text",0,"14pt Arial Rounded MT Bold","rgb(255,255,255)",
2,1,1,0,0]],[[-421,684,0,47,41,0,0,1,0.5,0.5,0,0,[]],100,101,[],[[]],["0",0,"26pt Arial Rounded MT Bold","rgb(255,255,255)",2,1,1,0,0]],[[-301,684,0,184,58,0,0,1,0.5,0.5,0,0,[]],101,102,[],[[]],[0,"Default",0,1]],[[-301,673,0,160,22,0,0,1,0.5,0.5,0,0,[]],102,103,[],[[]],["Text",0,"14pt Arial Rounded MT Bold","rgb(255,255,255)",2,1,1,0,0]],[[-301,696,0,160,22,0,0,1,0.5,0.5,0,0,[]],103,104,[],[[]],["Text",0,"14pt Arial Rounded MT Bold","rgb(255,255,255)",2,1,1,0,0]],[[110,278,0,74,74,0,0,1,0.5,0.5,
0,0,[]],149,188,[],[[]],[0,"Default",0,0]],[[196,120,0,50,50,0,0,1,0.5,0.5,0,0,[]],104,209,[],[[]],["EndGameGoldStar.scml","",""]],[[619,76,0,23,22,0,-0,0,0,0,0,0,[]],76,210,[],[],[1,"Default",0,1]],[[582,134,0,23,22,0,0,1,0.52173912525177,0.5,0,0,[]],77,211,[],[],[1,"Default",0,1]],[[626,88,0,7,8,0,-0,0,0,0,0,0,[]],78,212,[],[],[1,"Default",0,1]],[[622,85,0,13,14,0,-0,0,0,0,0,0,[]],79,213,[],[],[1,"Default",0,1]],[[625,83,0,9,10,0,-0,0,0,0,0,0,[]],80,214,[],[],[1,"Default",0,1]],[[623,86,0,10,12,
0,-0,0,0,0,0,0,[]],81,215,[],[],[1,"Default",0,1]],[[632,90,0,56,58,0,-0,0,0.5178571343421936,0.517241358757019,0,0,[]],82,216,[],[],[1,"Default",0,1]],[[602,298,0,50,50,0,0,1,0.5,0.5,0,0,[]],105,217,[],[[]],["EndGameGrayStar.scml","",""]],[[601.0175170898438,298.9830627441406,0,56,58,0,0,0,0.4821428656578064,0.517241358757019,0,0,[]],83,218,[],[],[1,"Default",0,1]],[[146,120,0,50,50,0,0,1,0.5,0.5,0,0,[]],104,219,[],[[]],["EndGameGoldStar.scml","",""]],[[246,120,0,50,50,0,0,1,0.5,0.5,0,0,[]],104,
220,[],[[]],["EndGameGoldStar.scml","",""]],[[125,529,0,189,58,0,0,1,0,0,0,0,[]],108,323,[[0]],[[1,0.4,0,0,1],[]],["0",0,"bold 28pt Arial","rgb(255,255,255)",0,1,0,1,0]],[[196,278,0,74,74,0,0,1,0.5,0.5,0,0,[]],149,324,[],[[]],[0,"Default",0,0]],[[283,278,0,74,74,0,0,1,0.5,0.5,0,0,[]],149,325,[],[[]],[0,"Default",0,0]],[[196,120,0,277,66,0,0,1,0.5018050670623779,0.5,0,0,[]],109,85,[],[[]],[0,"Default",0,1]]],[]],["LevelIntro",2,0xa28bbc4e55d45,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[162,258,0,440,430,
0,0,1,0.5,0.5,0,0,[]],121,159,[[0.5],[390],[335],[-232],[335]],[[400,0,0,0,0,1]],[0,"Default",0,1]],[[196,220,0,392,440,0,0,1,0.5,0.5,0,0,[]],124,160,[],[[]],[0,"Default",0,1]],[[116,396,0,65,74,0,0,1,0.5076923370361328,0.5,0,0,[]],136,164,[[-1],[""],["extra-time"]],[[]],[0,"Default",0,1]],[[196,396,0,65,74,0,0,1,0.5076923370361328,0.5,0,0,[]],140,167,[[-1],[""],["double-cash"],[0],[0]],[[],[]],[0,"Default",0,1]],[[276,396,0,65,74,0,0,1,0.5076923370361328,0.5,0,0,[]],139,168,[[-1],[""],["good-mood"]],
[[]],[0,"Default",0,1]],[[146,372,0,27,27,0,0,1,0.5185185074806213,0.5185185074806213,0,0,[]],137,165,[],[[]],[0,"Default",0,1]],[[146,372,0,27,27,0,0,1,0.5,0.5,0,0,[]],138,166,[[""],[0]],[[]],["0",0,"15pt Arial","rgb(51,153,153)",1,1,1,1,0]],[[196,498,0,89,97,0,0,1,0.5056179761886597,0.5051546096801758,0,0,[]],37,161,[],[[1,0.4,0,0,1]],[0,"Default",0,0]],[[212,23,0,135,60,0,0,1,0,0,0,0,[]],125,163,[],[[]],[45,60,"0123456789","1",1,0,0,1,0,1,0,0]],[[227,372,0,27,27,0,0,1,0.5185185074806213,0.5185185074806213,
0,0,[]],137,170,[],[[]],[0,"Default",0,1]],[[227,372,0,27,27,0,0,1,0.5,0.5,0,0,[]],138,171,[[""],[0]],[[]],["0",0,"15pt Arial","rgb(51,153,153)",1,1,1,1,0]],[[307,372,0,27,27,0,0,1,0.5185185074806213,0.5185185074806213,0,0,[]],137,172,[],[[]],[0,"Default",0,1]],[[307,372,0,27,27,0,0,1,0.5,0.5,0,0,[]],138,173,[[""],[0]],[[]],["0",0,"15pt Arial","rgb(51,153,153)",1,1,1,1,0]],[[623,346,0,366,374,0,0,1,0.5,0.5,0,0,[]],122,197,[[0.5],[725],[385],[1264],[385]],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[591,
348,0,187,248,0,0,1,0.5026738047599792,0.5,0,0,[]],126,198,[],[[]],[0,"Default",0,1]],[[590,149,0,272,67,0,0,1,0.5,0.5074626803398132,0,0,[]],127,199,[],[[]],[0,"Default",0,1]],[[480,284,0,40,58,0,0,1,0.5,0.5,0,0,[]],128,200,[],[[]],[0,"Default",0,1]],[[705,284,0,40,58,0,0,1,0.5,0.5,0,0,[]],129,201,[],[[]],[0,"Default",0,1]],[[658,442,0,52,56,0,0,1,0.5,0.5,0,0,[]],130,202,[],[[]],[0,"Default",0,1]],[[594,378,0,173,55,0,0,1,0.5,0.5,0,0,[]],131,203,[],[[]],["",0,"bold 14pt Arial","rgb(51,153,153)",
1,1,1,0,0]],[[550,419,0,72,48,0,0,1,0,0,0,0,[]],132,204,[],[[],[]],["0",0,"bold 24pt Arial","rgb(255,255,255)",0,1,0,1,0]],[[593,284,0,95,95,0,0,1,0.5052631497383118,0.5052631497383118,0,0,[]],133,205,[["extra-time|double-cash|good-mood"],[""]],[[]],[0,"Default",0,1]],[[125,183,0,170,49,0,0,1,0,0,0,0,[]],134,208,[],[[]],["",0,"bold 26pt Arial","rgb(255,255,255)",0,1,0,1,0]],[[528,443,0,40,40,0,0,1,0.4923076927661896,0.5076923370361328,0,0,[]],217,327,[],[[]],[0,"TXu",0,1]],[[470,186,0,90,32,0,0,1,
0,0,0,0,[]],135,328,[],[[]],["\u0110ang c\u00f3",0,"bold 16pt Arial","rgb(51,153,153)",0,1,0,0,0]],[[590,197,0,40,40,0,0,1,0.4923076927661896,0.5076923370361328,0,0,[]],217,329,[],[[]],[0,"TXu",0,1]],[[612,177,0,105,46,0,0,1,0,0,0,0,[]],218,330,[],[[]],["0",0,"bold 24pt Arial","rgb(51,153,153)",0,1,0,1,0]],[[110,295,0,74,74,0,0,1,0.5,0.5,0,0,[]],149,86,[],[[]],[0,"Default",0,0]],[[196,295,0,74,74,0,0,1,0.5,0.5,0,0,[]],149,87,[],[[]],[0,"Default",0,0]],[[282,295,0,74,74,0,0,1,0.5,0.5,0,0,[]],149,88,
[],[[]],[0,"Default",0,0]],[[126,115,0,56,58,0,0,1,0.5,0.5,0,0,[]],221,194,[],[[]],[0,"Default",0,1]],[[196,115,0,56,58,0,0,1,0.5,0.5,0,0,[]],221,195,[],[[]],[0,"Default",0,1]],[[266,115,0,56,58,0,0,1,0.5,0.5,0,0,[]],221,196,[],[[]],[0,"Default",0,1]]],[]],["LeaderBoardRank",3,8407680252316143,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[124,34,0,247,67,0,0,1,0.5020242929458618,0.5074626803398132,0,0,[]],113,135,[],[],[0,"Default",0,1]],[[154,19,0,150,30,0,0,1,0.5,0.5,0,0,[]],117,136,[],[],["",0,"bold 12pt Arial",
"rgb(51,153,153)",2,2,1,0,0]],[[154,49,0,150,30,0,0,1,0.5,0.5,0,0,[]],118,137,[],[],["0",0,"bold 14pt Arial","rgb(51,153,153)",2,0,1,0,0]],[[32,32,0,60,60,0,0,1,0.5,0.5,0,0,[]],119,138,[],[],["1",0,"bold 28pt Arial","rgb(255,255,255)",1,1,1,0,0]]],[]],["ResultMessageWin",4,6061884265354798,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[0,600,0,50,50,0,0,1,0.5,0.5,0,0,[]],107,221,[],[],["ResultMessageWin.scml","",""]],[[0,-218,0,900,206,0,-0,1,0,0,0,0,[]],86,222,[],[],[1,"Default",0,1]],[[388,193,0,185,191,
0,-0,0,0,0,0,0,[]],87,223,[],[],[1,"Default",0,1]],[[638,226,0,120,169,0,-0,0,0,0,0,0,[]],88,224,[],[],[1,"Default",0,1]],[[208,-213,0,488,185,0,-0,1,0,0,0,0,[]],89,225,[],[],[1,"Default",0,1]]],[]],["ResultMessageLose",5,6567346851943127,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[0,600,0,50,50,0,0,1,0.5,0.5,0,0,[]],106,226,[],[],["ResultMessageLose.scml","",""]],[[0,-217,0,900,206,0,-0,1,0,0,0,0,[]],84,227,[],[],[1,"Default",0,1]],[[192,-209,0,510,167,0,-0,1,0,0,0,0,[]],85,228,[],[],[1,"Default",0,1]]],
[]]],[],[]],["Login",1080,720,!1,"LoginEvent",8866800514486942,[["Background",0,0xeb9878c342eed,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[540,360,0,1080,720,0,0,1,0.5,0.5,0,0,[]],172,112,[],[],[0,"Default",0,1]]],[]],["Entities",1,0x8f646aaca8763,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[540,360,0,20,20,0,0,0.5199999809265137,0.5,3.5,0,0,[]],75,336,[],[[318,0],[1,7,0,3.67,0,0,0,18,0]],[0,"Blue",0,1]],[[540,360,0,20,20,0,0,0.5199999809265137,-2.5,0.5,0,0,[]],75,337,[],[[193,0],[1,7,0,4.29,0,0,0,18,0]],[0,
"Pink",0,1]],[[540,360,0,20,20,0,0,0.5199999809265137,0.5,-2.5,0,0,[]],75,338,[],[[248,0],[1,7,0,5.12,0,0,0,18,0]],[0,"Yellow",0,1]],[[540,360,0,20,20,0,0,0.5199999809265137,3.5,0.5,0,0,[]],75,339,[],[[209,0],[1,7,0,5.25,0,0,0,18,0]],[0,"Green",0,1]]],[]]],[],[]]],[["SelectLevelEvent",[[2,"GlobalEvent",!1],[0,null,!1,null,8362377017377853,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xadd715fed530b,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,62592483084415,
!1,[[1,[2,"showAd"]],[13]]]],[[1,"MARGIN_TOP",0,0,!0,!1,0xedc7079129d88,!1],[1,"MARGIN_BOTTOM",0,0,!0,!1,5715804760138605,!1],[1,"AREA_WIDTH",0,700,!0,!0,57767818490822,!1],[1,"AREA_HEIGHT",0,0,!0,!1,0xdcd40d68a1823,!1],[1,"BTN_WIDTH",0,95,!0,!0,6016997518381403,!1],[1,"BTN_HEIGHT",0,115,!0,!0,6474246286316654,!1],[1,"StartX",0,0,!0,!1,6846242575160775,!1],[1,"StartY",0,0,!0,!1,617206856556217,!1],[1,"DX",0,0,!0,!1,5458741710039117,!1],[1,"DY",0,0,!0,!1,4903862186772335,!1],[1,"Length",0,0,!0,!1,
8480877230969167,!1],[1,"Rows",0,0,!0,!1,6019338489801173,!1],[1,"Cols",0,0,!0,!1,6662383739383841,!1],[1,"MaxCols",0,0,!0,!1,6917797582591583,!1],[0,null,!1,null,6921012722117948,[],[[-1,cr.system_object.prototype.acts.SetVar,null,0x7d7af37d260d6,!1,[[11,"MARGIN_TOP"],[7,[4,[4,[21,20,!1,null,1],[7,[20,20,cr.plugins_.Sprite.prototype.exps.Height,!1,null],[0,2]]],[0,10]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9774148158020356,!1,[[11,"MARGIN_BOTTOM"],[7,[4,[4,[23,"AdHeight"],[23,"ScreenOffsetY"]],
[0,10]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,99044847767553,!1,[[11,"AREA_HEIGHT"],[7,[5,[5,[19,cr.system_object.prototype.exps.layoutheight],[23,"MARGIN_TOP"]],[23,"MARGIN_BOTTOM"]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8698052839040004,!1,[[11,"StartX"],[7,[7,[4,[5,[19,cr.system_object.prototype.exps.layoutwidth],[23,"AREA_WIDTH"]],[23,"BTN_WIDTH"]],[0,2]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7419634113658251,!1,[[11,"StartY"],[7,[4,[23,"MARGIN_TOP"],[7,
[23,"BTN_HEIGHT"],[0,2]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x7d533b43026e9,!1,[[11,"Length"],[7,[20,203,cr.plugins_.Arr.prototype.exps.Width,!1,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8559272550594317,!1,[[11,"Rows"],[7,[19,cr.system_object.prototype.exps.floor,[[7,[23,"AREA_HEIGHT"],[23,"BTN_HEIGHT"]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xcf06c1ce3d48e,!1,[[11,"DY"],[7,[4,[7,[5,[23,"AREA_HEIGHT"],[6,[23,"Rows"],[23,"BTN_HEIGHT"]]],[5,[23,"Rows"],
[0,1]]],[23,"BTN_HEIGHT"]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7672839608693494,!1,[[11,"MaxCols"],[7,[19,cr.system_object.prototype.exps.floor,[[7,[23,"AREA_WIDTH"],[23,"BTN_WIDTH"]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xcbbea21d1537,!1,[[11,"Cols"],[7,[19,cr.system_object.prototype.exps.min,[[23,"MaxCols"],[19,cr.system_object.prototype.exps.ceil,[[7,[23,"Length"],[23,"Rows"]]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x4ba99ce49a47b,!1,[[11,"DX"],[7,
[4,[7,[5,[23,"AREA_WIDTH"],[6,[23,"Cols"],[23,"BTN_WIDTH"]]],[5,[23,"Cols"],[0,1]]],[23,"BTN_WIDTH"]]]]]]],[0,null,!1,null,5421870593257327,[[203,cr.plugins_.Arr.prototype.cnds.ArrForEach,null,0,!0,!1,!1,7671846538914714,!1,[[3,2]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x4a5d4aecbc3e7,!1,[[4,18],[5,[2,"Entities"]],[0,[4,[23,"StartX"],[6,[23,"DX"],[8,[20,203,cr.plugins_.Arr.prototype.exps.CurX,!1,null],[23,"Cols"]]]]],[0,[4,[23,"StartY"],[6,[23,"DY"],[19,cr.system_object.prototype.exps.floor,
[[7,[20,203,cr.plugins_.Arr.prototype.exps.CurX,!1,null],[23,"Cols"]]]]]]]]],[18,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,0x51c5884a29806,!1,[[10,0],[7,[5,[7,[20,18,cr.plugins_.Sprite.prototype.exps.Width,!1,null],[0,2]],[5,[20,18,cr.plugins_.Sprite.prototype.exps.ImagePointX,!1,null,[[0,0]]],[20,18,cr.plugins_.Sprite.prototype.exps.BBoxLeft,!1,null]]]]]],[18,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,0x7cd426cb9ddc0,!1,[[10,1],[7,[5,[7,[20,18,cr.plugins_.Sprite.prototype.exps.Height,
!1,null],[0,2]],[5,[20,18,cr.plugins_.Sprite.prototype.exps.ImagePointY,!1,null,[[0,0]]],[20,18,cr.plugins_.Sprite.prototype.exps.BBoxTop,!1,null]]]]]],[18,cr.plugins_.Sprite.prototype.acts.SetAnim,null,4972929394024161,!1,[[1,[10,[2,"state"],[20,203,cr.plugins_.Arr.prototype.exps.CurValue,!1,null]]],[3,1]]],[19,cr.plugins_.Spritefont2.prototype.acts.SetInstanceVar,null,0xb2f75cee8eed7,!1,[[10,0],[7,[20,203,cr.plugins_.Arr.prototype.exps.CurX,!1,null]]]]],[[0,null,!1,null,0x97c905dc1d6,[[203,cr.plugins_.Arr.prototype.cnds.CompareCurrent,
null,0,!1,!1,!1,7856763604420696,!1,[[8,4],[7,[0,0]]]]],[[19,cr.plugins_.Spritefont2.prototype.acts.SetText,null,450188667103359,!1,[[7,[4,[21,19,!1,null,0],[0,1]]]]]]]]],[0,null,!1,null,8404777971092581,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xe2b80e1344b3d,!1,[[11,"ShowFullScreenAd"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7465260796473226,!1,[[11,"FULL_SCREEN_AD_RATE"],[8,4],[7,[19,cr.system_object.prototype.exps.random,[[0,1]]]]]]],
[[222,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,7649484375424021,!1]]],[0,null,!1,null,5481011162883505,[],[[-1,cr.system_object.prototype.acts.SetVar,null,418602112534183,!1,[[11,"ShowFullScreenAd"],[7,[0,1]]]]]]]],[0,null,!1,null,9863608693059516,[[19,cr.plugins_.Spritefont2.prototype.cnds.OnCreated,null,1,!1,!1,!1,39185476879587,!1]],[[19,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0x51dd1db0b8433,!1,[[4,18],[3,0]]]]],[0,null,!1,null,5604366669886991,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,
null,1,!1,!1,!1,779546467023729,!1]],[],[[0,null,!1,null,7001181167871777,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,7710609419626868,!1,[[4,18]]],[18,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,650721241884994,!1,[[1,[2,"state0"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,874784620610456,!1,[[1,[2,"PlayLevel"]],[13,[7,[21,19,!1,null,0]]]]]]],[0,null,!1,null,8080438296224048,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,0xc684951b435f4,!1,[[4,207]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x933700759d834,!1,[[6,"MainMenu"]]]]]]],[0,null,!1,null,8270377631128626,[[212,cr.plugins_.Mouse.prototype.cnds.IsOverObject,null,0,!1,!1,!1,4795286721356228,!1,[[4,18]]]],[],[[0,null,!1,null,0xf65824caa8472,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!0,!1,0xf7b02f218af4e,!1,[[4,18]]]],[[18,cr.behaviors.Sin.prototype.acts.SetActive,"SineVertical",5821703437306424,!1,[[3,1]]]]],
[0,null,!1,null,0xfe22c83524c50,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,5642473625578734,!1]],[[18,cr.behaviors.Sin.prototype.acts.SetActive,"SineVertical",6880064473410479,!1,[[3,0]]],[18,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xc714ab9a045b5,!1,[[0,[21,18,!1,null,0]],[0,[21,18,!1,null,1]]]]]]]],[0,null,!1,null,79650117373339,[[212,cr.plugins_.Mouse.prototype.cnds.IsOverObject,null,0,!1,!0,!1,0xc6df19c54df43,!1,[[4,18]]]],[[18,cr.behaviors.Sin.prototype.acts.SetActive,"SineVertical",
6874162191785294,!1,[[3,0]]],[18,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xfdc143a202c0a,!1,[[0,[21,18,!1,null,0]],[0,[21,18,!1,null,1]]]],[18,cr.plugins_.Sprite.prototype.acts.SetScale,null,9068272269886056,!1,[[0,[0,1]]]]]],[0,null,!1,null,0x8b6d72e80e118,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0x4bdb9f718f8bf,!1,[[4,18]]]],[]],[0,null,!1,null,622647646370553,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0xdfa159c4945c2,!1]],[[18,cr.plugins_.Sprite.prototype.acts.SetScale,
null,0x5c3227299a02,!1,[[0,[0,1]]]]]]]],["MainMenuEvent",[[2,"GlobalEvent",!1],[0,null,!1,null,536509577489308,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xc14201eca702e,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,7147865758152617,!1,[[1,[2,"hideAd"]],[13]]]],[[0,null,!1,null,0xc988898191447,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xfc3ccd337358f,!1,[[11,"EXIT_BUTTON"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,7690096799767209,!1,[[4,12],[5,[2,"Entities"]],[0,[0,100]],[0,[0,100]]]]]],[0,null,!1,null,8410416066661343,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6232464344645169,!1,[[11,"OnlineMode"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x7c1baf77d00f6,!1,[[1,[2,"Online-MainMenu"]],[3,1]]]]],[0,null,!1,null,8281288241008994,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,9353846353581004,!1]],[[-1,cr.system_object.prototype.acts.SetGroupActive,
null,4591537868665766,!1,[[1,[2,"Online-MainMenu"]],[3,0]]]]],[0,null,!1,null,9798078791526460,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6927632074305038,!1,[[11,"PLATFORM"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,7978275943157504,!1,[[1,[2,"App-MainMenu"]],[3,0]]]]],[0,null,!1,null,0xdde4f711c9b3f,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,9237366098747524,!1]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,8470587302396728,
!1,[[1,[2,"App-MainMenu"]],[3,1]]]]]]],[0,null,!1,null,8375089935021137,[[13,cr.plugins_.Spriter.prototype.cnds.OnCreated,null,1,!1,!1,!1,5938306912753697,!1]],[[13,cr.plugins_.Spriter.prototype.acts.setAnimationTime,null,0x9f6576c46e8ef,!1,[[3,1],[0,[0,1]]]]]],[0,null,!1,null,0x7fc52b790994e,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,5531605082888271,!1]],[],[[0,null,!1,null,0xd55be9fc6addc,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0x51e852abfa03b,!1,[[7,
[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,14,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6131635992741664,!1,[[6,"Story"]]]]],[0,null,!1,null,8075920765729834,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xc672ef8527ee3,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,10,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],
[],[[0,null,!1,null,4627711364728007,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x5452dd4f7f3ed,!1,[[11,"OnlineMode"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xcc4a33dbfd16e,!1,[[6,"LeaderBoard"]]]]],[0,null,!1,null,8348800874690622,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,5202446824431297,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6995685096279334,!1,[[6,"LocalInfo"]]]]]]],[0,null,!1,null,9743406159798968,[[-1,cr.system_object.prototype.cnds.Compare,
null,0,!1,!1,!1,0x6894ffa9a95ae,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,11,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xf755380af126e,!1,[[6,"HowToPlay"]]]]],[0,null,!1,null,7758484891987658,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,4925607430940256,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,12,cr.plugins_.Sprite.prototype.exps.UID,
!1,null]]]],[8,0],[7,[0,1]]]]],[],[[0,null,!1,null,0x5332888c8bca7,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8285865618582154,!1,[[11,"PLATFORM"],[8,0],[7,[0,0]]]]],[[205,cr.plugins_.GameConfig.prototype.acts.BackToScene,null,537200317207673,!1]]],[0,null,!1,null,0xf3f52c905b5d6,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,4991111180357481,!1]],[],[[0,null,!1,null,0xe7fe8eda83534,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x598e85c282242,!1,
[[11,"OnlineMode"],[8,0],[7,[0,1]]]]],[[205,cr.plugins_.GameConfig.prototype.acts.DisconnectSocketIO,null,9573148790681204,!1]]],[0,null,!1,null,0xf416e34de5aae,[],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9712082904671824,!1,[[6,"Login"]]]]]]]]],[0,null,!1,null,7977967509959088,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,8585658840950241,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,15,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],
[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0x737dce4f22b59,!1,[[7,[21,15,!1,null,0]],[8,0],[7,[0,0]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,4545334195508379,!1,[[3,0],[7,[10,[10,[19,cr.system_object.prototype.exps.windowwidth],[2," "]],[19,cr.system_object.prototype.exps.windowheight]]]]],[15,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x9cc194042a0ec,!1,[[10,0],[7,[0,1]]]],[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.acts.CreateWebDialog,
null,0xb3cbbb315378a,!1,[[1,[2,"profile"]],[12,"profile.html"]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,935440268690993,!1,[[1,[2,"setProfileData"]],[13,[7,[2,"name"]],[7,[23,"PlayerName"]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,9552832801047188,!1,[[1,[2,"setProfileData"]],[13,[7,[2,"level"]],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetPlayerInfoAtKey,!1,null,[[2,"level"]]]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x6d75c154da9f7,
!1,[[1,[2,"setProfileData"]],[13,[7,[2,"energy"]],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetPlayerInfoAtKey,!1,null,[[2,"energy"]]]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x866ce80c0532,!1,[[1,[2,"setProfileData"]],[13,[7,[2,"txu"]],[7,[23,"PlayerCash"]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,4603321571490645,!1,[[1,[2,"setProfileData"]],[13,[7,[2,"tinidiem"]],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetPlayerInfoAtKey,!1,null,[[2,"tinidiem"]]]]]]],
[208,cr.plugins_.Function.prototype.acts.CallFunction,null,5084765517148167,!1,[[1,[2,"showAd"]],[13]]],[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0x4407fce068444,!1,[[3,0],[7,[10,[10,[19,cr.system_object.prototype.exps.windowwidth],[2," "]],[19,cr.system_object.prototype.exps.windowheight]]]]]]],[0,null,!1,null,7434005915652064,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,7390015207999739,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],
[20,16,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,8146453385016634,!1,[[3,0],[7,[2,"open App store"]]]]],[[0,null,!1,null,6735411220576509,[[-1,cr.system_object.prototype.cnds.IsOnPlatform,null,0,!1,!1,!1,9618075743285098,!1,[[3,1]]]],[[206,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,481955586626565,!1,[[1,[23,"APP_STORE_IOS"]],[1,[2,"appstore"]]]]]],[0,null,!1,null,6710986001628102,[[-1,cr.system_object.prototype.cnds.Else,
null,0,!1,!1,!1,9267689310801432,!1],[-1,cr.system_object.prototype.cnds.IsOnPlatform,null,0,!1,!1,!1,0xc54daa1d2eef4,!1,[[3,2]]]],[[206,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,4602078273761834,!1,[[1,[23,"APP_STORE_ANDROID"]],[1,[2,"appstore"]]]]]]]],[0,null,!1,null,7700863148986029,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xf631d72f4a800,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,17,cr.plugins_.Sprite.prototype.exps.UID,
!1,null]]]],[8,0],[7,[0,1]]]]],[[206,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,8992997362525618,!1,[[1,[10,[23,"Host"],[19,cr.system_object.prototype.exps.replace,[[19,cr.system_object.prototype.exps.replace,[[23,"API_CONNECT_TINIZEN"],[2,"<name>"],[23,"PlayerName"]]],[2,"<uuid>"],[20,205,cr.plugins_.GameConfig.prototype.exps.GetPlayerInfoAtKey,!1,null,[[2,"uuid"]]]]]]],[1,[2,"tinizen"]]]]]]]],[0,null,!1,null,0x650c1fb7a6c5,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,
!1,!1,0xfac686a2b269,!1,[[1,[2,"setProfileData"]]]]],[[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.acts.WDEval,null,0x5a7b6d5a3e6f4,!1,[[1,[2,"profile"]],[1,[10,[10,[10,[10,[2,"setData('"],[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[2,"', '"]],[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,1]]]],[2,"');"]]]]]]],[0,null,!1,null,0x5ef26bf691072,[[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.cnds.OnWebDialogClosed,null,1,!1,!1,!1,0xc9952f8ebcb9e,!1,[[1,
[2,"profile"]]]]],[[15,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,6588414068263262,!1,[[10,0],[7,[0,0]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xbbe2db72ddd8a,!1,[[1,[2,"hideAd"]],[13]]]]],[0,null,!1,null,0x9d553578a1eb2,[[173,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,9418533675548900,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,7914971691789602,!1,[[1,[2,"showAd"]],[13]]]]],[0,null,!1,null,6313057360076668,[[173,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
null,1,!1,!1,!1,4554002832720229,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,8736546014808857,!1,[[1,[2,"hideAd"]],[13]]]]],[0,null,!1,null,6183178222071647,[[212,cr.plugins_.Mouse.prototype.cnds.IsOverObject,null,0,!1,!1,!1,0xe88ae7dd0190d,!1,[[4,225]]]],[[225,cr.behaviors.Sin.prototype.acts.SetActive,"SineHorizontal",0xdf244a1a040d1,!1,[[3,0]]],[225,cr.behaviors.Sin.prototype.acts.SetActive,"SineVertical",8830667885466333,!1,[[3,0]]],[225,cr.plugins_.Sprite.prototype.acts.SetPos,
null,0xc2cf9e78c3e9,!1,[[0,[21,225,!1,null,0]],[0,[21,225,!1,null,1]]]]]],[0,null,!1,null,0xd7104ca3946f5,[[212,cr.plugins_.Mouse.prototype.cnds.IsOverObject,null,0,!1,!1,!1,5209145945499194,!1,[[4,225]]]],[[225,cr.behaviors.Sin.prototype.acts.SetActive,"SineHorizontal",8996290067394231,!1,[[3,1]]],[225,cr.behaviors.Sin.prototype.acts.SetActive,"SineVertical",9503363579058584,!1,[[3,1]]]]],[0,[!1,"Online-MainMenu"],!1,null,0x54ddd99fcaa8a,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,
!1,!1,!1,0x54ddd99fcaa8a,!1,[[1,[2,"Online-MainMenu"]]]]],[],[[0,null,!1,null,9384417888653328,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xb2ea6c552b242,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x9919c142fab96,!1,[[4,15],[5,[2,"Entities"]],[0,[0,100]],[0,[0,300]]]]],[[0,null,!1,null,347094570834776,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,653313835516928,!1,[[7,[23,"IsTinizenConnected"]],[8,0],[7,[0,1]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,
null,0x9d38af987e957,!1,[[3,0],[7,[2,"connected"]]]],[17,cr.plugins_.Sprite.prototype.acts.Destroy,null,8129318451973001,!1]]],[0,null,!1,null,6523579482101913,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,446607810335122,!1],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0x543a41afdca40,!1,[[7,[20,17,cr.plugins_.Sprite.prototype.exps.Count,!1,null]],[8,0],[7,[0,0]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,5942129343865147,!1,[[3,0],[7,[2,"not connected"]]]],
[-1,cr.system_object.prototype.acts.CreateObject,null,0x558312f2d4379,!1,[[4,17],[5,[2,"Entities"]],[0,[0,960]],[0,[0,250]]]]]]]],[0,null,!1,null,0xe175845f27fd7,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,8400169927362519,!1,[[1,[2,"onIsTinizenConnected"]]]]],[],[[0,null,!1,null,0xeb967a909cf36,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,5630136679586039,!1,[[7,[23,"IsTinizenConnected"]],[8,0],[7,[0,1]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,
null,0xb5a90ef11d8a,!1,[[3,0],[7,[2,"connected"]]]],[17,cr.plugins_.Sprite.prototype.acts.Destroy,null,43428025819064,!1]]],[0,null,!1,null,0xe068aaad1238c,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,4722979658620945,!1],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,5349001549709033,!1,[[7,[20,17,cr.plugins_.Sprite.prototype.exps.Count,!1,null]],[8,0],[7,[0,0]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0xb6be1ff314f75,!1,[[3,0],[7,[2,"not connected"]]]],
[-1,cr.system_object.prototype.acts.CreateObject,null,8491260351992604,!1,[[4,17],[5,[2,"Entities"]],[0,[0,960]],[0,[0,250]]]]]]]]]],[0,[!1,"App-MainMenu"],!1,null,4884109108979274,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,4884109108979274,!1,[[1,[2,"App-MainMenu"]]]]],[],[[0,null,!1,null,9384417888653328,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xb2ea6c552b242,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x9919c142fab96,!1,[[4,16],
[5,[2,"Entities"]],[0,[0,100]],[0,[0,200]]]]]]]]]],["GameEvent",[[1,"CUSTOMER_POSITION_Y",0,0,!1,!1,0xe14b8a258446e,!1],[1,"scoreBoost",0,1,!1,!1,9682484879431806,!1],[1,"targetScore",0,0,!1,!1,7497165630604287,!1],[1,"currentTarget",0,0,!1,!1,8453181510396047,!1],[1,"score",0,0,!1,!1,0xacf388380c163,!1],[1,"result",0,0,!1,!1,9758584850050472,!1],[2,"GlobalEvent",!1],[2,"Functions",!1],[0,null,!1,null,8673049953902004,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7641031676219529,
!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,8943006625933121,!1,[[1,[2,"hideAd"]],[13]]],[-1,cr.system_object.prototype.acts.SetVar,null,7208180115462789,!1,[[11,"CUSTOMER_POSITION_Y"],[7,[20,72,cr.plugins_.Sprite.prototype.exps.ImagePointY,!1,null,[[2,"Customer1"]]]]]],[70,cr.plugins_.Arr.prototype.acts.SetX,null,0xdebae85656941,!1,[[0,[0,0]],[7,[20,72,cr.plugins_.Sprite.prototype.exps.ImagePointX,!1,null,[[2,"Customer1"]]]]]],[70,cr.plugins_.Arr.prototype.acts.SetX,null,0x47a68fdd67d23,
!1,[[0,[0,1]],[7,[20,72,cr.plugins_.Sprite.prototype.exps.ImagePointX,!1,null,[[2,"Customer2"]]]]]],[70,cr.plugins_.Arr.prototype.acts.SetX,null,5473342784072072,!1,[[0,[0,2]],[7,[20,72,cr.plugins_.Sprite.prototype.exps.ImagePointX,!1,null,[[2,"Customer3"]]]]]],[71,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8692931175606477,!1,[[1,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[10,[2,"backgrounds."],[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,
[[2,"config.background"]]]]]]],[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,6376954401798248,!1,[[11,"scoreBoost"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,5321065893252497,!1,[[1,[2,"Main"]],[3,1]]]],[[0,null,!1,null,0xa142112657a8b,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8223796335258002,!1,[[4,59]]]],[[59,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xd1b7d63b86d7,!1,[[10,0],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,
!1,null,[[10,[2,"drinks."],[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,[[10,[2,"config.drinks."],[19,cr.system_object.prototype.exps.loopindex]]]]]]]]]],[59,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xea56d34b5fcb2,!1,[[1,[21,59,!0,null,0]],[3,1]]]]],[0,null,!1,null,0xf318412cb33c7,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,528369856793459,!1,[[4,60]]]],[[60,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9262725111113048,!1,[[10,0],[7,[20,204,
cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[10,[2,"fruits."],[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,[[10,[2,"config.fruits."],[19,cr.system_object.prototype.exps.loopindex]]]]]]]]]],[60,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x41e159c323e2e,!1,[[1,[21,60,!0,null,0]],[3,1]]]]],[0,null,!1,null,8661452390896263,[],[[204,cr.plugins_.ShakeItUtils.prototype.acts.StartLevel,null,8434594104477634,!1]]]]],[2,"GameEventHUD",!1],[2,"GameEventCustomer",
!1],[2,"GameEventBubble",!1],[2,"GameEventGlass",!1],[2,"GameEventMixer",!1],[2,"GameEventCash",!1],[2,"ScoreEvent",!1],[2,"GameEventBooster",!1],[2,"AchievementEvent",!1],[2,"GameEventEndGameDialog",!1],[0,[!0,"Main"],!1,null,7204949950663005,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7204949950663005,!1,[[1,[2,"Main"]]]]],[],[[0,null,!1,null,0xa32d8a9db119b,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xfff254d3e6bc2,!1,[[0,[0,3]]]]],[[204,cr.plugins_.ShakeItUtils.prototype.acts.AddCustomerToQueue,
null,5158790733627817,!1]]],[0,null,!1,null,0x50b1c96e48d24,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0x70d0b51ac5fac,!1,[[7,[20,223,cr.plugins_.Sprite.prototype.exps.Count,!1,null]],[8,2],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,[[2,"config.maxActiveCustomers"]]]]]]],[[204,cr.plugins_.ShakeItUtils.prototype.acts.AddCustomer,null,5675320750749708,!1,[[7,[2,"Customer"]],[0,[19,cr.system_object.prototype.exps.canvastolayerx,[[2,"Customer"],[19,cr.system_object.prototype.exps.windowwidth],
[19,cr.system_object.prototype.exps.windowheight]]]],[0,[23,"CUSTOMER_POSITION_Y"]]]]]],[0,null,!1,null,0xace94208f76a0,[[223,cr.behaviors.Timer.prototype.cnds.OnTimer,"Timer",0,!1,!1,!1,0x73e34105f610f,!1,[[1,[2,"Ordered"]]]]],[[223,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7847378481283288,!1,[[1,[2,"Waiting1"]],[3,1]]],[223,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9388737491667556,!1,[[10,4],[7,[1,0.8]]]],[223,cr.behaviors.Timer.prototype.acts.StartTimer,"Timer",7456875431684856,
!1,[[0,[21,223,!1,null,2]],[3,0],[1,[2,"Waiting1"]]]]]],[0,null,!1,null,9228059922652356,[[223,cr.behaviors.Timer.prototype.cnds.OnTimer,"Timer",0,!1,!1,!1,7969813808616697,!1,[[1,[2,"Waiting1"]]]]],[[223,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xec3b72b0d4d92,!1,[[1,[2,"Waiting2"]],[3,1]]],[223,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xae43cb737e162,!1,[[10,4],[7,[1,0.65]]]],[223,cr.behaviors.Timer.prototype.acts.StartTimer,"Timer",4787098462933163,!1,[[0,[21,223,!1,null,2]],
[3,0],[1,[2,"Waiting2"]]]]]],[0,null,!1,null,4874790857851252,[[223,cr.behaviors.Timer.prototype.cnds.OnTimer,"Timer",0,!1,!1,!1,0x7b8c78a76f287,!1,[[1,[2,"Waiting2"]]]]],[[223,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x6e20923ca468f,!1,[[1,[2,"Waiting3"]],[3,1]]],[223,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,908448378383425,!1,[[10,4],[7,[1,0.5]]]],[223,cr.behaviors.Timer.prototype.acts.StartTimer,"Timer",6213639353161152,!1,[[0,[21,223,!1,null,2]],[3,0],[1,[2,"Waiting3"]]]]]],
[0,null,!1,null,7380827837203709,[[223,cr.behaviors.Timer.prototype.cnds.OnTimer,"Timer",0,!1,!1,!1,6790655044912168,!1,[[1,[2,"Waiting3"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,8976689194454369,!1,[[1,[2,"DestroyBubble"]],[13,[7,[21,223,!1,null,7]]]]],[223,cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,null,5866249104962461,!1,[[10,3],[3,1]]],[223,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9914901456755476,!1,[[1,[2,"Leaving"]],[3,1]]],[223,cr.behaviors.Sin.prototype.acts.SetActive,
"Angry",9998558301334146,!1,[[3,1]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,803501333828588,!1,[[1,[2,"playSound"]],[13,[7,[2,"customer-angry"]],[7,[0,0]]]]],[223,cr.behaviors.Timer.prototype.acts.StartTimer,"Timer",5279348447562527,!1,[[0,[1,0.75]],[3,0],[1,[2,"Leaving"]]]]]],[0,null,!1,null,0x84ed74bd6cacd,[[223,cr.behaviors.Timer.prototype.cnds.OnTimer,"Timer",0,!1,!1,!1,0x7d60eda77a778,!1,[[1,[2,"Served"]]]]],[[223,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",5756137704312687,
!1,[[3,1]]]]],[0,null,!1,null,6116695401150296,[[223,cr.behaviors.Timer.prototype.cnds.OnTimer,"Timer",0,!1,!1,!1,0xbc8e3f714b46a,!1,[[1,[2,"Leaving"]]]]],[[223,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8132306350700826,!1,[[3,1]]]]],[0,null,!1,null,9836832838288560,[[223,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,0x4bd30d21469cb,!1]],[[204,cr.plugins_.ShakeItUtils.prototype.acts.MarkLeavingCustomer,null,9362664126542298,!1,[[0,[20,223,cr.plugins_.Sprite.prototype.exps.UID,
!1,null]]]]],[[0,null,!1,null,6848764016194567,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0x5f5eb19860c39,!1,[[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,[[2,"activeCustomers.length"]]]],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xbf6a250adb1d7,!1,[[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,[[2,"queueingCustomers.length"]]]],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Compare,null,
0,!1,!1,!1,4576548600776115,!1,[[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,[[2,"remainingCustomers.length"]]]],[8,0],[7,[0,0]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xc7605e8056a88,!1,[[1,[2,"EndGame"]],[13]]]]],[0,null,!1,null,0x69e355f8da897,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0xf1a2ef835a9b9,!1],[-1,cr.system_object.prototype.cnds.PickAll,null,0,!1,!1,!1,0xe1f3c406e78e,!1,[[4,223]]]],[[223,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",9616709868052200,!1,[[3,1]]]]]]],[0,null,!1,null,0x74dff8d6d4708,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0xf327fdc1c68ed,!1]],[],[[0,null,!1,null,465156361668483,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xb4d09f066b484,!1,[[4,59]]],[59,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x57c9b630d94b8,!1,[[10,0],[8,1],[7,[2,"Default"]]]],[65,cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,null,0,!1,!0,!1,8144546316715052,
!1,[[10,0]]]],[],[[0,null,!1,null,0x4cbabb4ecacbe,[[-1,cr.system_object.prototype.cnds.PickNth,null,0,!1,!1,!1,5301802990909629,!1,[[4,64],[0,[0,0]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,583950548893506,!1,[[1,[2,"playSound"]],[13,[7,[2,"ingredient"]],[7,[0,10]]]]]],[[0,null,!1,null,5248485490801142,[[64,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8110980204292305,!1,[[10,0],[8,0],[7,[2,""]]]]],[[64,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
null,0x6ab204da9b872,!1,[[10,0],[7,[21,59,!0,null,0]]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.AddDrink,null,0xf6bf856b843cf,!1,[[1,[21,59,!0,null,0]]]]]]]]]],[0,null,!1,null,798540434679177,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,9029907862718744,!1,[[4,60]]],[60,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,4537488606519885,!1,[[10,0],[8,1],[7,[2,"Default"]]]],[65,cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,null,0,!1,!0,!1,
0x48b319ce2156c,!1,[[10,0]]]],[],[[0,null,!1,null,0x422f53c27a5df,[[-1,cr.system_object.prototype.cnds.PickByEvaluate,null,0,!1,!1,!1,6053921963039942,!1,[[4,66],[0,[12,[21,66,!0,null,0],[2,""]]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,86653767059699,!1,[[1,[2,"playSound"]],[13,[7,[2,"ingredient"]],[7,[0,10]]]]]],[[0,null,!1,null,0x619327a352b7a,[[-1,cr.system_object.prototype.cnds.PickNth,null,0,!1,!1,!1,5638696901379897,!1,[[4,66],[0,[0,0]]]]],[[66,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
null,5150191146447008,!1,[[10,0],[7,[21,60,!0,null,0]]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.AddFruit,null,6054309075642988,!1,[[1,[21,60,!0,null,0]]]]]]]]]],[0,null,!1,null,0x51bf9b7320687,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,5676746772176656,!1,[[4,65]]]],[],[[0,null,!1,null,7487613075496489,[[64,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0xeaca48b9b661a,!1,[[10,0],[8,1],[7,[2,""]]]],[61,cr.plugins_.Sprite.prototype.cnds.PickByUID,
null,0,!1,!1,!0,5292043792732327,!1,[[0,[21,64,!1,null,1]]]],[61,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,6267924137235737,!1,[[10,0],[8,0],[7,[2,""]]]],[-1,cr.system_object.prototype.cnds.PickByEvaluate,null,0,!1,!1,!1,4900571303165372,!1,[[4,66],[0,[13,[21,66,!0,null,0],[2,""]]]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xe70d1011ecf28,!1,[[7,[20,66,cr.plugins_.Sprite.prototype.exps.PickedCount,!1,null]],[8,4],[7,[0,0]]]]],[[66,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
null,9527760114604732,!1,[[10,0],[7,[2,""]]]],[66,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x3ed3dacc7cea8,!1,[[1,[2,"Default"]],[3,1]]],[64,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xa1f53c04854d8,!1,[[10,0],[7,[2,""]]]],[64,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9796020170563536,!1,[[1,[2,"Twirl"]],[3,1]]],[65,cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,null,9466154674696724,!1,[[10,0],[3,1]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,5432580829347773,
!1,[[1,[2,"playSound"]],[13,[7,[2,"mixer"]],[7,[0,10]]]]]]]]],[0,null,!1,null,0xe486216b9b1f0,[],[]]]],[0,null,!1,null,290182216034576,[[63,cr.behaviors.DragnDrop.prototype.cnds.OnDrop,"DragDrop",1,!1,!1,!1,6534808211225645,!1]],[],[[0,null,!1,null,0x4cbe6b6e3338d,[[63,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,5694340978367358,!1,[[4,223]]],[223,cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,null,0,!1,!1,!1,0xa1ba88bd96744,!1,[[10,6]]],[223,cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
null,0,!1,!0,!1,0xe2362ff2709e5,!1,[[10,3]]],[204,cr.plugins_.ShakeItUtils.prototype.cnds.CompareDrinkStrings,null,0,!1,!1,!1,7980766401212011,!1,[[1,[21,61,!0,null,0]],[1,[21,223,!0,null,1]]]]],[[63,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xa71f721ee75cd,!1,[[4,223],[7,[2,"Glass"]]]],[63,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0x4f817f2ef4875,!1,[[4,223],[3,0]]],[223,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7991851774634089,!1,[[10,8],[7,[20,63,cr.plugins_.Sprite.prototype.exps.UID,
!1,null]]]],[223,cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,null,5792164636235883,!1,[[10,3],[3,1]]],[223,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8277014073479966,!1,[[1,[2,"Served"]],[3,1]]],[223,cr.behaviors.Sin.prototype.acts.SetActive,"Cheering",0x47d7046c77e93,!1,[[3,1]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xd8bb668bcebbf,!1,[[1,[2,"playSound"]],[13,[7,[2,"customer-cheering"]],[7,[0,0]]]]],[223,cr.behaviors.Timer.prototype.acts.StopTimer,"Timer",0xa9f34fba1feb3,
!1,[[1,[2,"Ordered"]]]],[223,cr.behaviors.Timer.prototype.acts.StopTimer,"Timer",0x4c972939938c1,!1,[[1,[2,"Waiting1"]]]],[223,cr.behaviors.Timer.prototype.acts.StopTimer,"Timer",663390714907198,!1,[[1,[2,"Waiting2"]]]],[223,cr.behaviors.Timer.prototype.acts.StopTimer,"Timer",8023265971618931,!1,[[1,[2,"Waiting3"]]]],[72,cr.plugins_.Sprite.prototype.acts.Spawn,null,8296477389574319,!1,[[4,63],[5,[2,"Ingredient"]],[7,[2,"Glass"]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,296816915094728,
!1,[[4,68],[5,[2,"HUD"]],[0,[20,223,cr.plugins_.Sprite.prototype.exps.ImagePointX,!1,null,[[2,"Origin"]]]],[0,[5,[20,223,cr.plugins_.Sprite.prototype.exps.ImagePointY,!1,null,[[2,"Origin"]]],[0,130]]]]],[223,cr.plugins_.Sprite.prototype.acts.Spawn,null,5552851198546585,!1,[[4,69],[5,[2,"HUD"]],[7,[2,"Bubble"]]]],[223,cr.behaviors.Timer.prototype.acts.StartTimer,"Timer",9504658871982952,!1,[[0,[0,1]],[3,0],[1,[2,"Served"]]]]],[[1,"servingScore",0,0,!1,!1,8170032878994465,!1],[0,null,!1,null,7435163902595252,
[],[[-1,cr.system_object.prototype.acts.SetVar,null,0xc3ddc5aebd42f,!1,[[11,"servingScore"],[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"calculateFinalScore"],[6,[21,223,!1,null,0],[21,223,!1,null,4]]]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,9795707234086512,!1,[[1,[2,"addToScore"]],[13,[7,[23,"servingScore"]]]]],[69,cr.plugins_.Spritefont2.prototype.acts.SetText,null,8145011030106454,!1,[[7,[10,[2,"$"],[23,"servingScore"]]]]]]],[0,null,!1,null,0x7b859807f3c04,
[[57,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x4609a1ef0c8be,!1,[[0,[21,223,!1,null,7]]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,7827265689138432,!1]]]]],[0,null,!1,null,6600988190300948,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,655276968273531,!1],[63,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0x8c552ca8db157,!1,[[4,67]]]],[[63,cr.behaviors.Fade.prototype.acts.StartFade,"Fade",0xae5c60598f2db,!1],[61,cr.behaviors.Fade.prototype.acts.StartFade,
"Fade",564277416474166,!1],[72,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x9b3f73aa9b70d,!1,[[4,63],[5,[2,"Ingredient"]],[7,[2,"Glass"]]]]]],[0,null,!1,null,634098656644902,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,7578654873261425,!1]],[[63,cr.plugins_.Sprite.prototype.acts.SetPos,null,5488116096279016,!1,[[0,[20,72,cr.plugins_.Sprite.prototype.exps.ImagePointX,!1,null,[[2,"Glass"]]]],[0,[20,72,cr.plugins_.Sprite.prototype.exps.ImagePointY,!1,null,[[2,"Glass"]]]]]]]]]]]],[0,null,
!1,null,6989443056417371,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0x67911c0654772,!1,[[1,[2,"deactivateMainGroups"]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x91896fde48a6a,!1,[[1,[2,"Main"]],[3,0]]],[63,cr.behaviors.DragnDrop.prototype.acts.SetEnabled,"DragDrop",9733210909890824,!1,[[3,0]]],[66,cr.behaviors.Sin.prototype.acts.SetActive,"SineHorizontal",7742588073133435,!1,[[3,0]]],[66,cr.behaviors.Sin.prototype.acts.SetActive,"SineVertical",517674256893012,
!1,[[3,0]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,7512274652182327,!1,[[1,[2,"showAd"]],[13]]]]],[0,null,!1,null,0xa0fdc75a835bd,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0x6cb4145e42c3e,!1,[[1,[2,"activateMainGroups"]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,820261167215397,!1,[[1,[2,"Main"]],[3,1]]],[63,cr.behaviors.DragnDrop.prototype.acts.SetEnabled,"DragDrop",0x3d273bcb67c23,!1,[[3,1]]],[66,cr.behaviors.Sin.prototype.acts.SetActive,
"SineHorizontal",0xb8c2b1af5c79,!1,[[3,1]]],[66,cr.behaviors.Sin.prototype.acts.SetActive,"SineVertical",7561617062142956,!1,[[3,1]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,9953880496278964,!1,[[1,[2,"hideAd"]],[13]]]]],[0,null,!1,null,0xdf0dfe0dcd7b9,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0xa2eab2d38a6f9,!1,[[1,[2,"EndGame"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,7947371930245794,!1,[[1,[2,"deactivateMainGroups"]],[13]]]],
[[0,null,!1,null,0x47a0732e734f9,[[35,cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x713a265bde151,!1,[[10,0],[8,4],[7,[0,0]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x5f8cc0957ad13,!1,[[1,[2,"addToScore"]],[13,[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"calculateFinalScore"],[6,[21,35,!1,null,0],[0,2]]]]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xda5daab7e43de,!1,[[1,[2,"SetTime"]],[13,[7,[21,35,!1,null,
0]],[7,[2,"set"]],[7,[1,0.05]]]]]]],[0,null,!1,null,0x7b3de68817d91,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,6556128369175351,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,9261399571090924,!1,[[11,"result"],[7,[23,"currentTarget"]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,9070495377134936,!1,[[1,[2,"finishLevel"]],[13]]]]]]],[0,null,!1,null,6535115747591106,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0xb8b5d3c9d1fa8,!1,[[1,[2,"addToScore"]]]]],
[[-1,cr.system_object.prototype.acts.AddVar,null,0x6e1b0bef86ec4,!1,[[11,"score"],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]]],[[0,null,!1,null,7675000351926857,[[-1,cr.system_object.prototype.cnds.While,null,0,!0,!1,!1,7830121411685727,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6564905327209698,!1,[[11,"currentTarget"],[8,3],[7,[0,3]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5714194890875945,!1,[[11,"score"],[8,5],[7,[23,
"targetScore"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6742908013252652,!1,[[1,[2,"setTarget"]],[13,[7,[4,[23,"currentTarget"],[0,1]]]]]]]]]]]],["LoadingEvent",[[1,"initializingCompleted",0,0,!1,!1,9339355383076664,!1],[1,"loadingError",0,0,!1,!1,7313743150243473,!1],[2,"GlobalEvent",!1],[2,"InitializeEvent",!1],[0,null,!1,null,7118442077388358,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x6156a8c1bf586,!1]],[[74,cr.plugins_.Text.prototype.acts.SetInstanceVar,
null,7213667282004747,!1,[[10,0],[7,[2,"Initializing game settings"]]]]],[[0,null,!1,null,0xa9541b1fda13f,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xc7346b8b0bf82,!1,[[11,"PLATFORM"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,8612106894442069,!1,[[1,[2,"Web-LoadingCompleted"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x69bd2883ad080,!1,[[1,[2,"App-LoadingCompleted"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,
0x3c197fa530390,!1,[[11,"AdHeight"],[7,[0,0]]]]]],[0,null,!1,null,0xf71f5d8f6d612,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,6269234334331879,!1]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xecbfe48671f79,!1,[[1,[2,"App-LoadingCompleted"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,7982954175267228,!1,[[1,[2,"Web-LoadingCompleted"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xeb8835d032a91,!1,[[11,"AdHeight"],[7,[0,100]]]]]],[0,null,
!1,null,0x4a38faa080827,[],[[-1,cr.system_object.prototype.acts.SetVar,null,425023406212799,!1,[[11,"ScreenOffsetX"],[7,[19,cr.system_object.prototype.exps.viewportleft,[[0,0]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x8a0d6c038eee2,!1,[[11,"ScreenOffsetY"],[7,[19,cr.system_object.prototype.exps.viewporttop,[[0,0]]]]]]]],[0,null,!1,null,6521269835536273,[],[[211,cr.plugins_.AJAX.prototype.acts.RequestFile,null,0xa062e1de9a4fd,!1,[[1,[2,"loadSettingsJSON"]],[12,"settings.json"]]]]]]],[0,
null,!1,null,8585396065897447,[[211,cr.plugins_.AJAX.prototype.cnds.OnError,null,1,!1,!1,!1,8544831068526366,!1,[[1,[2,"loadSettingsJSON"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,758175369415223,!1,[[11,"loadingError"],[7,[0,1]]]],[74,cr.plugins_.Text.prototype.acts.SetInstanceVar,null,7810761620502624,!1,[[10,0],[7,[2,"Load settings file failed"]]]]]],[0,null,!1,null,4952852500406963,[[211,cr.plugins_.AJAX.prototype.cnds.OnComplete,null,1,!1,!1,!1,6346189576067942,!1,[[1,[2,"loadSettingsJSON"]]]]],
[[204,cr.plugins_.ShakeItUtils.prototype.acts.LoadSettingsFromJson,null,9495185541857014,!1,[[1,[20,211,cr.plugins_.AJAX.prototype.exps.LastData,!0,null]]]]]],[0,null,!1,null,0xf42876628206b,[[204,cr.plugins_.ShakeItUtils.prototype.cnds.OnInitializingFailed,null,1,!1,!1,!1,0x8367a6eaf9fe2,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,0x67d1d6c05eedb,!1,[[11,"loadingError"],[7,[0,1]]]],[74,cr.plugins_.Text.prototype.acts.SetInstanceVar,null,0xe2973ca5f5090,!1,[[10,0],[7,[2,"Initializing game settings failed"]]]]]],
[0,null,!1,null,0x4d465f5ae8d8b,[[204,cr.plugins_.ShakeItUtils.prototype.cnds.OnInitialized,null,1,!1,!1,!1,0xe0434ab479854,!1]],[[74,cr.plugins_.Text.prototype.acts.SetInstanceVar,null,7241336140115427,!1,[[10,0],[7,[2,"Initializing customers"]]]]],[[0,null,!1,null,0xf7519d33aee00,[],[[204,cr.plugins_.ShakeItUtils.prototype.acts.RegisterCustomer,null,8749435138153893,!1,[[1,[2,"NormalBoy"]],[4,24]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.RegisterCustomer,null,0xdb4b58d6e275f,!1,[[1,[2,"NormalGirl"]],
[4,21]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.RegisterCustomer,null,0x77e722336861c,!1,[[1,[2,"SpecialBoy"]],[4,22]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.RegisterCustomer,null,6824128740750696,!1,[[1,[2,"SpecialGirl"]],[4,23]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.RegisterCustomer,null,6274333036262934,!1,[[1,[2,"VipBoy"]],[4,26]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.RegisterCustomer,null,6603043721266903,!1,[[1,[2,"VipGirl"]],[4,25]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.RegisterCustomer,
null,7098796990935863,!1,[[1,[2,"juNo"]],[4,27]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.RegisterCustomer,null,4676830096321806,!1,[[1,[2,"teRa"]],[4,28]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.RegisterCustomer,null,0xa6f87f71091ac,!1,[[1,[2,"piCa"]],[4,30]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.RegisterCustomer,null,8210184992351706,!1,[[1,[2,"kiLo"]],[4,29]]]]],[0,null,!1,null,7909377188222932,[],[[74,cr.plugins_.Text.prototype.acts.SetInstanceVar,null,0x5a7bd3d180585,!1,[[10,
0],[7,[2,"Initializing boosters"]]]],[141,cr.plugins_.Dictionary.prototype.acts.AddKey,null,5477432110682538,!1,[[1,[2,"extra-time"]],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"boosters.extra-time.id"]]]]]],[141,cr.plugins_.Dictionary.prototype.acts.AddKey,null,9951318931742158,!1,[[1,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"boosters.extra-time.id"]]]],[7,[2,"extra-time"]]]],[141,cr.plugins_.Dictionary.prototype.acts.AddKey,
null,0xc83438e7b240c,!1,[[1,[2,"double-cash"]],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"boosters.double-cash.id"]]]]]],[141,cr.plugins_.Dictionary.prototype.acts.AddKey,null,9157054309316366,!1,[[1,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"boosters.double-cash.id"]]]],[7,[2,"double-cash"]]]],[141,cr.plugins_.Dictionary.prototype.acts.AddKey,null,0xa02b15cc0a194,!1,[[1,[2,"good-mood"]],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,
!1,null,[[2,"boosters.good-mood.id"]]]]]],[141,cr.plugins_.Dictionary.prototype.acts.AddKey,null,0xe1b0f9c3550a4,!1,[[1,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"boosters.good-mood.id"]]]],[7,[2,"good-mood"]]]]]],[0,null,!1,null,9555894152043656,[],[[74,cr.plugins_.Text.prototype.acts.SetInstanceVar,null,0xee31712905c24,!1,[[10,0],[7,[2,"Initializing achievements"]]]],[147,cr.plugins_.Dictionary.prototype.acts.AddKey,null,4691592311223392,!1,[[1,[2,"first-time-player"]],
[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"achievements.first-time-player"]]]]]],[147,cr.plugins_.Dictionary.prototype.acts.AddKey,null,5952476338589659,!1,[[1,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"achievements.first-time-player"]]]],[7,[2,"first-time-player"]]]],[147,cr.plugins_.Dictionary.prototype.acts.AddKey,null,0x797706f171a45,!1,[[1,[2,"pro-player"]],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,
!1,null,[[2,"achievements.pro-player"]]]]]],[147,cr.plugins_.Dictionary.prototype.acts.AddKey,null,0xa6a07eb4f77,!1,[[1,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"achievements.pro-player"]]]],[7,[2,"pro-player"]]]],[147,cr.plugins_.Dictionary.prototype.acts.AddKey,null,5623289552523837,!1,[[1,[2,"all-star-player"]],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"achievements.all-star-player"]]]]]],[147,cr.plugins_.Dictionary.prototype.acts.AddKey,
null,0x6f79341716f76,!1,[[1,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"achievements.all-star-player"]]]],[7,[2,"all-star-player"]]]]]],[0,null,!1,null,871603484676144,[],[[74,cr.plugins_.Text.prototype.acts.SetInstanceVar,null,6490813067311726,!1,[[10,0],[7,[2,"Initializing game settings"]]]],[203,cr.plugins_.Arr.prototype.acts.SetSize,null,0xef16579b1f99c,!1,[[0,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"levels.length"]]]],[0,[0,
1]],[0,[0,1]]]],[209,cr.plugins_.Arr.prototype.acts.SetSize,null,9552896489496444,!1,[[0,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"levels.length"]]]],[0,[0,1]],[0,[0,1]]]]]],[0,null,!1,null,4686656230594033,[[216,cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,null,0,!1,!1,!1,0x7bb12b832e02e,!1,[[1,[2,"si.enableMusic"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x49a60b33117c7,!1,[[1,[2,"setEnableMusic"]],[13,[7,[20,216,cr.plugins_.WebStorage.prototype.exps.LocalValue,
!0,null,[[2,"si.enableMusic"]]]]]]]]],[0,null,!1,null,388731908034975,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0x88815e29c766a,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,9407444950411704,!1,[[1,[2,"setEnableMusic"]],[13,[7,[0,1]]]]]]],[0,null,!1,null,4822864096072354,[[216,cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,null,0,!1,!1,!1,0xab2d4bd70d125,!1,[[1,[2,"si.enableSound"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,7992244190691993,
!1,[[1,[2,"setEnableSound"]],[13,[7,[20,216,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"si.enableSound"]]]]]]]]],[0,null,!1,null,0x85dddfe1b99b3,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,7242832629978108,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,8614579177466616,!1,[[1,[2,"setEnableSound"]],[13,[7,[0,1]]]]]]],[0,null,!1,null,9310906127296032,[],[[-1,cr.system_object.prototype.acts.SetVar,null,5902952645439338,!1,[[11,"initializingCompleted"],
[7,[0,1]]]]]]]],[0,null,!1,null,8869311726224621,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0xaddaa93401343,!1]],[[73,cr.plugins_.Text.prototype.acts.SetText,null,7649546226572141,!1,[[7,[10,[19,cr.system_object.prototype.exps.round,[[6,[19,cr.system_object.prototype.exps.loadingprogress],[0,100]]]],[2,"%"]]]]]],[[0,null,!1,null,0x6a82cd17c7832,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,6302344440831286,!1,[[7,[19,cr.system_object.prototype.exps.loadingprogress]],
[8,5],[7,[0,1]]]]],[],[[0,null,!1,null,0xcb1ffc3b69a0e,[[74,cr.plugins_.Text.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x9a38f978f28fa,!1,[[10,0],[8,1],[7,[2,""]]]]],[[74,cr.plugins_.Text.prototype.acts.SetText,null,8817514742688752,!1,[[7,[21,74,!0,null,0]]]]]],[0,null,!1,null,0x4624029572294,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4762007046227819,!1,[[11,"loadingError"],[8,1],[7,[0,0]]]]],[[74,cr.plugins_.Text.prototype.acts.SetFontColor,null,0x7b296e9d2e732,!1,
[[0,[19,cr.system_object.prototype.exps.rgb,[[0,255],[0,0],[0,0]]]]]]]],[0,null,!1,null,0xaae3bfff231db,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xa59c37c463197,!1,[[11,"initializingCompleted"],[8,0],[7,[0,1]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,466309249936961,!1,[[1,[2,"loadingCompleted"]],[13]]],[-1,cr.system_object.prototype.acts.SetVar,null,9476513913704114,!1,[[11,"initializingCompleted"],[7,[0,0]]]]]]]]]],[0,[!1,"Web-LoadingCompleted"],!1,null,
0x48e7c3cb1773a,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x48e7c3cb1773a,!1,[[1,[2,"Web-LoadingCompleted"]]]]],[],[[0,null,!1,null,9922942723349012,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0x5da296ead6cf5,!1,[[1,[2,"loadingCompleted"]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0x8188345141d00,!1,[[3,0],[7,[2,"Get environment"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8065347563199709,!1,[[11,"OnlineMode"],[7,[0,1]]]],
[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xa8b3d03400fb9,!1,[[1,[2,"OnlineModeUpdated"]],[13]]],[205,cr.plugins_.GameConfig.prototype.acts.GetWebEnvironment,null,5307649514884536,!1]]],[0,null,!1,null,0xd72e8c9341816,[[205,cr.plugins_.GameConfig.prototype.cnds.OnGetEnvironmentFailed,null,1,!1,!1,!1,9147047562581762,!1]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0x69a5c26ad1de6,!1,[[3,2],[7,[2,"Get environment failed"]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,
null,5227115590654921,!1,[[1,[2,"createInfoDialog"]],[13,[7,[2,"Error"]],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"messages.connectFailed"]]]],[7,[23,"CenterX"]],[7,[23,"CenterY"]],[7,[2,"connectError"]]]]]]],[0,null,!1,null,694972102580038,[[205,cr.plugins_.GameConfig.prototype.cnds.OnGetEnvironmentSucceed,null,1,!1,!1,!1,7297068826066496,!1]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,5289485317029556,!1,[[3,0],[7,[2,"Get environment suceed"]]]],
[205,cr.plugins_.GameConfig.prototype.acts.ConnectSocketIO,null,9838690435801786,!1,[[1,[2,""]]]]]],[0,null,!1,null,9657861704339796,[[205,cr.plugins_.GameConfig.prototype.cnds.OnConnectSocketIOFailed,null,1,!1,!1,!1,0x722c5ca5a33ed,!1]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0x86625f624fd1,!1,[[3,2],[7,[2,"Connect socket IO failed"]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,7648249925670382,!1,[[1,[2,"createInfoDialog"]],[13,[7,[2,"Error"]],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,
!1,null,[[2,"messages.connectFailed"]]]],[7,[23,"CenterX"]],[7,[23,"CenterY"]],[7,[2,"socketConnectError"]]]]]]],[0,null,!1,null,0xd324554089c1a,[[205,cr.plugins_.GameConfig.prototype.cnds.OnConnectSocketIOSucceed,null,1,!1,!1,!1,4828595694370729,!1]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,8356106578488319,!1,[[3,0],[7,[2,"Connect socket IO succeed"]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x60cbeed7efe48,!1,[[1,[2,"initializeGame"]],[13]]]]],[0,null,!1,null,
0xf3f8e1d7b7846,[[154,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,5377730331319782,!1]],[],[[0,null,!0,null,0x58a68971c7223,[[154,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0xf4501c2404406,!1,[[10,1],[8,0],[7,[2,"connectError"]]]],[154,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,9953080464171618,!1,[[10,1],[8,0],[7,[2,"socketConnectError"]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,6648881575026279,!1,[[3,0],[7,
[10,[2,"go back "],[21,154,!0,null,1]]]]],[205,cr.plugins_.GameConfig.prototype.acts.BackToScene,null,0xd49170b3616af,!1]]]]],[0,null,!1,null,970504158985804,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,4508516346569752,!1,[[1,[2,"initializeGameDone"]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,8049518458804112,!1,[[3,0],[7,[2,"hide loading mask"]]]],[205,cr.plugins_.GameConfig.prototype.acts.HideLoadingMask,null,7828691879037354,!1]]]]],[0,[!1,"App-LoadingCompleted"],
!1,null,7218918171534458,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7218918171534458,!1,[[1,[2,"App-LoadingCompleted"]]]]],[],[[0,null,!1,null,0x641a7f3d5c75d,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,9069872141637224,!1,[[1,[2,"loadingCompleted"]]]]],[[222,cr.plugins_.CJSAds.prototype.acts.PreloadBanner,null,8237512099297418,!1],[222,cr.plugins_.CJSAds.prototype.acts.RefreshBanner,null,6246875900076901,!1],[222,cr.plugins_.CJSAds.prototype.acts.PreloadFullscreen,
null,7224393062293045,!1],[222,cr.plugins_.CJSAds.prototype.acts.RefreshFullScreen,null,0x7604790c8829b,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,4642552332636825,!1,[[6,"Login"]]]]]]]]],["GlobalEvent",[[1,"PLATFORM",0,1,!1,!0,0x48a5e6a085dff,!1],[1,"DEV_MODE",0,0,!1,!0,7164419823027698,!1],[1,"EXIT_BUTTON",0,1,!1,!0,8304001241441525,!1],[1,"SHOW_SAFE_ZONE",0,0,!1,!0,9284769489792952,!1],[1,"FULL_SCREEN_AD_RATE",0,0.3,!1,!0,9039259536409956,!1],[1,"PROD_HOST",1,"http://www.tiniplanet.com",
!1,!0,0x4eb061751399f,!1],[1,"DEV_HOST",1,"http://192.168.12.7:8181",!1,!0,7516392061279436,!1],[1,"API_GET_ENVIRONMENT",1,"/api/systems/getenvironment",!1,!0,972844328988283,!1],[1,"API_MOBILE_LOGIN",1,"/mobile/login",!1,!0,0x8d035d51c2193,!1],[1,"API_MOBILE_REGISTER",1,"/register",!1,!0,0x6bd7b6c54b492,!1],[1,"API_CONNECT_TINIZEN",1,"/tinizen/connect?_id=<name>&uuid=<uuid>",!1,!0,6518303351646605,!1],[1,"APP_STORE_IOS",1,"https://itunes.apple.com/us/artist/tiniplanet/id902955912",!1,!0,677820057400708,
!1],[1,"APP_STORE_ANDROID",1,"https://play.google.com/store/apps/developer?id=tiNiPlanet",!1,!0,0x4200503a6cf8d,!1],[1,"OnlineMode",0,0,!1,!1,779700747220266,!1],[1,"Host",1,"",!1,!1,7316612382070403,!1],[1,"EnableSound",0,1,!1,!1,7474886154735458,!1],[1,"EnableMusic",0,1,!1,!1,0xca0950e1b5941,!1],[1,"PlayerName",1,"",!1,!1,9197953066120538,!1],[1,"IsTinizenConnected",0,0,!1,!1,7155919924874435,!1],[1,"MessageSubmitScore",1,"",!1,!1,5360068281340717,!1],[1,"PlayerCash",0,0,!1,!1,5635586274512251,
!1],[1,"currentLevel",0,0,!1,!1,0xd03c231502b29,!1],[1,"ScreenOffsetX",0,0,!1,!1,6517230105114314,!1],[1,"ScreenOffsetY",0,0,!1,!1,0x6ab72cd524866,!1],[1,"ShowFullScreenAd",0,1,!1,!1,0xb07981e254d59,!1],[1,"AdHeight",0,0,!1,!1,8620637036345425,!1],[0,null,!1,null,5938528827404958,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5855121600778412,!1]],[],[[0,null,!1,null,724333282992058,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7320760942870841,!1,[[11,"DEV_MODE"],
[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,6832888036344761,!1,[[11,"Host"],[7,[23,"DEV_HOST"]]]]]],[0,null,!1,null,0x5ebac882c935d,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,9834074393495654,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,0x97b931bf90b9b,!1,[[11,"Host"],[7,[23,"PROD_HOST"]]]]]],[0,null,!0,null,5933986681702009,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5573702813196218,!1,[[11,"DEV_MODE"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0xab164e1b6ff89,!1,[[11,"SHOW_SAFE_ZONE"],[8,0],[7,[0,0]]]]],[[172,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc5c91bed687d6,!1]]]]],[0,null,!1,null,4799115889207491,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0x8275d0c310c05,!1,[[1,[2,"showAd"]]]]],[],[[0,null,!1,null,5048993437168964,[[222,cr.plugins_.CJSAds.prototype.cnds.IsShowingBanner,null,0,!1,!0,!1,6209088916303064,!1]],[[222,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,0xcb77be3f56746,!1,
[[3,1]]]]]]],[0,null,!1,null,8464123346265739,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,9892663543612678,!1,[[1,[2,"hideAd"]]]]],[],[[0,null,!1,null,9678788583343880,[[222,cr.plugins_.CJSAds.prototype.cnds.IsShowingBanner,null,0,!1,!1,!1,6300902486172368,!1]],[[222,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0x8fabc77fbfd18,!1]]]]],[0,null,!1,null,0x9851cf00920e8,[[170,cr.plugins_.Spriter.prototype.cnds.readyForSetup,null,1,!1,!1,!1,0xf5567654a21f7,!1]],[[170,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,
null,7732951605750538,!1,[[4,161],[1,[2,"ice4"]]]],[170,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,7716193286326348,!1,[[4,162],[1,[2,"ice3"]]]],[170,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,7756595193751711,!1,[[4,163],[1,[2,"ice2"]]]],[170,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,8841857867261729,!1,[[4,164],[1,[2,"ice1"]]]],[170,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,7094683272090025,!1,[[4,165],[1,[2,"bubble3"]]]],
[170,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,5686274775090321,!1,[[4,166],[1,[2,"bubble4"]]]],[170,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,6602636321970168,!1,[[4,167],[1,[2,"bubble2"]]]],[170,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0x40a27c2f02dab,!1,[[4,168],[1,[2,"bubble1"]]]]]],[0,null,!1,null,4679545936724389,[[170,cr.plugins_.Spriter.prototype.cnds.OnCreated,null,1,!1,!1,!1,5255621812508935,!1]],[[170,cr.plugins_.Spriter.prototype.acts.setPlaybackSpeedRatio,
null,0xd942716a4b51,!1,[[0,[1,0.07]]]]]],[0,null,!1,null,0xdcf1b4308240a,[[225,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x5001a4373d7d5,!1]],[[225,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7783338379401881,!1,[[10,0],[7,[20,225,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[225,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7835536573767636,!1,[[10,1],[7,[20,225,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,8077961624789889,[[212,cr.plugins_.Mouse.prototype.cnds.IsOverObject,
null,0,!1,!1,!1,830836897054012,!1,[[4,228]]]],[[228,cr.plugins_.Sprite.prototype.acts.SetAnim,null,4729741232860614,!1,[[1,[2,"Hover"]],[3,1]]]]],[0,null,!1,null,0x5b475a9bce0b,[[212,cr.plugins_.Mouse.prototype.cnds.IsOverObject,null,0,!1,!0,!1,7837319976917603,!1,[[4,228]]]],[[228,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9056715434075744,!1,[[1,[2,"Default"]],[3,1]]]]],[0,null,!1,null,5813216000453288,[[212,cr.plugins_.Mouse.prototype.cnds.IsOverObject,null,0,!1,!1,!1,5547317197340045,!1,
[[4,238]]]],[[238,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6393117925214688,!1,[[0,[0,1]]]]]],[0,null,!1,null,0xcc379a88306c3,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,7712946432449639,!1,[[4,238]]]],[[238,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x58e9f77794fe8,!1,[[0,[0,2]]]]]],[0,null,!1,null,0x8061695878968,[[-1,cr.system_object.prototype.cnds.PickOverlappingPoint,null,0,!1,!0,!1,4797978112136314,!1,[[4,238],[0,[20,212,cr.plugins_.Mouse.prototype.exps.X,
!1,null]],[0,[20,212,cr.plugins_.Mouse.prototype.exps.Y,!1,null]]]]],[[238,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6026492204817107,!1,[[0,[0,0]]]]]],[0,null,!1,null,8063766483606224,[[226,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0xc7dc7be64f6f1,!1]],[[226,cr.plugins_.Sprite.prototype.acts.SetPos,null,386772954893493,!1,[[0,[21,226,!1,null,3]],[0,[21,226,!1,null,4]]]]],[[1,"dx",0,0,!1,!1,8163530456055097,!1],[1,"dy",0,0,!1,!1,7035614913155178,!1],[0,null,!1,null,6496104939372155,
[],[[-1,cr.system_object.prototype.acts.SetVar,null,734616069847798,!1,[[11,"dx"],[7,[5,[21,226,!1,null,1],[20,226,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,453206687284684,!1,[[11,"dy"],[7,[5,[21,226,!1,null,2],[20,226,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]]],[0,null,!1,null,0xcb52f8819de55,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6068334309316119,!1,[[11,"dx"],[8,0],[7,[0,0]]]]],[[226,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
"Slide",828541692631795,!1,[[0,[0,90]]]],[226,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Slide",0x43e2ed93fb10a,!1,[[0,[7,[23,"dy"],[21,226,!1,null,0]]]]]]],[0,null,!1,null,7404057676388325,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,6826249754566621,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x3da442f081ae5,!1,[[11,"dy"],[8,0],[7,[0,0]]]]],[[226,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Slide",8820554241410742,!1,[[0,[7,[23,"dx"],[21,226,!1,null,0]]]]]]],
[0,null,!1,null,6672335327987161,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0xdb0aaa8740b85,!1]],[[226,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Slide",9217615311720062,!1,[[0,[19,cr.system_object.prototype.exps.atan,[[7,[23,"dy"],[23,"dx"]]]]]]],[226,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Slide",0x8fe14d6eb7670,!1,[[0,[7,[19,cr.system_object.prototype.exps.sqrt,[[4,[6,[23,"dx"],[23,"dx"]],[6,[23,"dy"],[23,"dy"]]]]],[21,226,!1,null,0]]]]]]],[0,null,!1,null,9109238739779946,
[],[[-1,cr.system_object.prototype.acts.Wait,null,4594277860791014,!1,[[0,[21,226,!1,null,0]]]],[226,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Slide",8338891972860257,!1,[[3,0]]],[226,cr.plugins_.Sprite.prototype.acts.SetPos,null,4701343239683621,!1,[[0,[21,226,!1,null,1]],[0,[21,226,!1,null,2]]]]]]]],[0,null,!1,null,9744449746993712,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,8660294346908207,!1]],[],[[0,null,!1,null,0x3c17becb4c8b7,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,7687370579342377,!1,[[4,241]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6152674941193022,!1,[[1,[2,"playSound"]],[13,[7,[2,"button"]],[7,[0,0]]]]]]]]],[0,null,!1,null,7651421013980122,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0x4e39288abebb7,!1,[[1,[2,"IsTouched"]]]]],[],[[0,null,!1,null,0x6fe3953b8af1f,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0x570f225e78344,!1,[[4,224]]]],[],[[0,null,!1,null,6119463506130308,
[[224,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0xb7e7deeea2771,!1,[[3,0]]]],[],[[0,null,!1,null,0x5d770294b4d17,[[208,cr.plugins_.Function.prototype.cnds.CompareParam,null,0,!1,!1,!1,4621003382755596,!1,[[0,[0,0]],[8,0],[7,[20,224,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]]],[],[[0,null,!1,null,6272759567634035,[[171,cr.plugins_.TiledBg.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x9c0361eb4a94a,!1,[[3,0]]]],[],[[0,null,!1,null,8107258409111809,[[-1,cr.system_object.prototype.cnds.Compare,
null,0,!1,!1,!1,0x58b22fc0ffc8c,!1,[[7,[20,224,cr.plugins_.Sprite.prototype.exps.LayerNumber,!1,null]],[8,4],[7,[20,171,cr.plugins_.TiledBg.prototype.exps.LayerNumber,!1,null]]]]],[[208,cr.plugins_.Function.prototype.acts.SetReturnValue,null,8209496865430737,!1,[[7,[0,1]]]]]],[0,null,!1,null,0xa35cd656e6946,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0xfcd626d091c34,!1],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0x4659ee3806a26,!1,[[7,[20,224,cr.plugins_.Sprite.prototype.exps.LayerNumber,
!1,null]],[8,2],[7,[20,171,cr.plugins_.TiledBg.prototype.exps.LayerNumber,!1,null]]]]],[[208,cr.plugins_.Function.prototype.acts.SetReturnValue,null,0xb7f47af49728b,!1,[[7,[0,0]]]]]],[0,null,!1,null,5122247473051433,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,6717853531058179,!1],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,4943113679538342,!1,[[7,[20,224,cr.plugins_.Sprite.prototype.exps.ZIndex,!1,null]],[8,4],[7,[20,171,cr.plugins_.TiledBg.prototype.exps.ZIndex,!1,null]]]]],
[[208,cr.plugins_.Function.prototype.acts.SetReturnValue,null,9888043657630672,!1,[[7,[0,1]]]]]]]],[0,null,!1,null,0x55c53962f73e0,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0x7d5e087131ffd,!1]],[[208,cr.plugins_.Function.prototype.acts.SetReturnValue,null,0x6f09f33a66898,!1,[[7,[0,1]]]]]]]],[0,null,!1,null,0xd73e1ed200921,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,5948413196540812,!1]],[[208,cr.plugins_.Function.prototype.acts.SetReturnValue,null,0xc87fa1140517a,!1,
[[7,[0,0]]]]]]]]]],[0,null,!1,null,0xf019c1d19a045,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,6798680699669699,!1]],[[208,cr.plugins_.Function.prototype.acts.SetReturnValue,null,0x6617a48fc36cd,!1,[[7,[0,0]]]]]]]],[0,null,!1,null,0xe303e5b160154,[[242,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,6674145666529127,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xfb32cba829475,!1,[[4,171],[5,[20,242,cr.plugins_.Sprite.prototype.exps.LayerName,!0,null]],[0,[0,
0]],[0,[0,0]]]],[171,cr.plugins_.TiledBg.prototype.acts.ZMoveToObject,null,8752615535620735,!1,[[3,1],[4,242]]],[242,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7377492185534212,!1,[[10,0],[7,[20,171,cr.plugins_.TiledBg.prototype.exps.UID,!1,null]]]]]],[0,null,!1,null,0xe97da3d7d4aeb,[[242,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,5962165503378265,!1]],[],[[0,null,!1,null,6600867441235847,[[171,cr.plugins_.TiledBg.prototype.cnds.PickByUID,null,0,!1,!1,!0,0xd22f2706c89ab,
!1,[[0,[21,242,!1,null,0]]]]],[[171,cr.plugins_.TiledBg.prototype.acts.Destroy,null,0x9a1ea64b563e6,!1]]]]],[0,null,!1,null,978967898852226,[[212,cr.plugins_.Mouse.prototype.cnds.IsOverObject,null,0,!1,!1,!1,5912606769508194,!1,[[4,250]]]],[],[[0,null,!1,null,0xbb0f39142dd98,[[213,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!0,!1,8532243871092515,!1]],[[250,cr.plugins_.Sprite.prototype.acts.SetScale,null,8298984676743753,!1,[[0,[1,1.02]]]]]]]],[0,null,!1,null,7201479078775007,[[212,cr.plugins_.Mouse.prototype.cnds.IsOverObject,
null,0,!1,!0,!1,0x790999ef23347,!1,[[4,250]]]],[[250,cr.behaviors.Sin.prototype.acts.SetActive,"SineSize",0x5b91e22291282,!1,[[3,0]]],[250,cr.plugins_.Sprite.prototype.acts.SetScale,null,8432941621892519,!1,[[0,[0,1]]]]]],[0,null,!1,null,6955734849933147,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0x3fefc62d6992a,!1,[[4,250]]]],[[250,cr.behaviors.Sin.prototype.acts.SetActive,"SineSize",0xc4a1e8af8d3df,!1,[[3,1]]]]],[0,null,!1,null,9454266400371872,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,
null,1,!1,!1,!1,466253147726913,!1]],[[250,cr.behaviors.Sin.prototype.acts.SetActive,"SineSize",8564482592202111,!1,[[3,0]]]]],[0,null,!1,null,6816884549942087,[[149,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,9715148487968966,!1]],[]],[0,null,!1,null,6756959432665999,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,950892880763003,!1,[[1,[2,"PlayLevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,328663633159324,!1,[[11,"currentLevel"],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,
!1,null,[[0,0]]]]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.SetCurrentLevel,null,528896707159586,!1,[[0,[23,"currentLevel"]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x7922174f65ff0,!1,[[6,"LevelIntro"]]]]],[0,null,!1,null,0x9d64b1d4256b6,[[217,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,9147461221102968,!1]],[],[[0,null,!1,null,0xc22ff7c1d121,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xe2942d35786ae,!1,[[11,"OnlineMode"],[8,0],[7,[0,1]]]]],
[[217,cr.plugins_.Sprite.prototype.acts.SetAnim,null,55058946287335,!1,[[1,[2,"TXu"]],[3,1]]]]],[0,null,!1,null,4938771214772992,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0xcef1cfeafa632,!1]],[[217,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6526509424505923,!1,[[1,[2,"Coin"]],[3,1]]]]]]],[0,null,!1,null,0x8c4c3e618a1b,[[218,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x3f7392ff1589f,!1]],[[218,cr.plugins_.Text.prototype.acts.SetText,null,0xa3c649afcfc30,!1,[[7,[23,
"PlayerCash"]]]]]],[0,null,!1,null,5222078318743561,[[219,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,7731004229954939,!1]],[[219,cr.plugins_.Text.prototype.acts.SetText,null,9514383022525938,!1,[[7,[10,[2,"Version "],[19,cr.system_object.prototype.exps.projectversion]]]]]]],[0,null,!1,null,0x8967ce2c7826b,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,6536992045428271,!1]],[[75,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,5350673594277071,!1,[[0,[4,[0,70],[22,75,
"Sine",cr.behaviors.Sin.prototype.exps.Value,!1,null]]]]]]],[0,null,!1,null,9592610857185388,[[251,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,7563609236601798,!1]],[[251,cr.plugins_.Sprite.prototype.acts.SetY,null,5552949481763469,!1,[[0,[4,[19,cr.system_object.prototype.exps.viewporttop,[[20,251,cr.plugins_.Sprite.prototype.exps.LayerName,!0,null]]],[7,[20,251,cr.plugins_.Sprite.prototype.exps.Height,!1,null],[0,2]]]]]]]],[0,null,!1,null,7322824120809771,[[252,cr.plugins_.Sprite.prototype.cnds.OnCreated,
null,1,!1,!1,!1,6162374070853224,!1]],[[252,cr.plugins_.Sprite.prototype.acts.SetX,null,6330294982714973,!1,[[0,[5,[19,cr.system_object.prototype.exps.viewportright,[[20,252,cr.plugins_.Sprite.prototype.exps.LayerName,!0,null]]],[7,[20,252,cr.plugins_.Sprite.prototype.exps.Width,!1,null],[0,2]]]]]]]],[0,null,!1,null,7455661638182192,[[253,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,5028419051182425,!1]],[[253,cr.plugins_.Sprite.prototype.acts.SetX,null,0xcbce7bf71ed33,!1,[[0,[4,[19,
cr.system_object.prototype.exps.viewportleft,[[20,253,cr.plugins_.Sprite.prototype.exps.LayerName,!0,null]]],[7,[20,253,cr.plugins_.Sprite.prototype.exps.Width,!1,null],[0,2]]]]]]]],[2,"Dialog",!1],[2,"Functions",!1],[2,"SoundEvent",!1],[2,"SocketEvent",!1]]],["TODO",[]],["Functions",[[0,null,!1,null,0x59d0581391e0a,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8653139796565478,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,8909425609525165,!1,[[1,[2,"OnlineModeUpdated"]],
[13]]]]],[0,null,!1,null,0xe8f01b808ff05,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,6888719974739873,!1,[[1,[2,"OnlineModeUpdated"]]]]],[],[[0,null,!1,null,6334819439585078,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8063568500376489,!1,[[11,"OnlineMode"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,9555199057448024,!1,[[1,[2,"Online-Functions"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,6370542985680187,
!1,[[1,[2,"Offline-Functions"]],[3,0]]]]],[0,null,!1,null,922295042485821,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,8686476614268975,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x8504b5a991683,!1,[[11,"OnlineMode"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,283721969348544,!1,[[1,[2,"Offline-Functions"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xda7d5a4a25b24,!1,[[1,[2,"Online-Functions"]],[3,0]]]]],[0,
null,!1,null,4985208393750901,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,6172144156107601,!1]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x5d616a35bf7fc,!1,[[1,[2,"Online-Functions"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,9509635265986716,!1,[[1,[2,"Offline-Functions"]],[3,0]]]]]]],[0,null,!1,null,5064059327984605,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,741283733308487,!1,[[1,[2,"updatePlayerCash"]]]]],[],[[0,null,
!1,null,0x8c2fafddf2d14,[[208,cr.plugins_.Function.prototype.cnds.CompareParam,null,0,!1,!1,!1,0x6d7c42af7743d,!1,[[0,[0,1]],[8,0],[7,[2,"add"]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,7865182085130748,!1,[[11,"PlayerCash"],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]]]],[0,null,!1,null,0xfb77b50b84991,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0xace096e05338e,!1],[208,cr.plugins_.Function.prototype.cnds.CompareParam,null,0,!1,!1,!1,8677437874034087,
!1,[[0,[0,1]],[8,0],[7,[2,"set"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5927613800307835,!1,[[11,"PlayerCash"],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]]]],[0,null,!1,null,8311056568285336,[],[[218,cr.plugins_.Text.prototype.acts.SetText,null,0x4990ebb5b734d,!1,[[7,[23,"PlayerCash"]]]]]]]],[0,[!1,"Online-Functions"],!1,null,938228921013685,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,938228921013685,!1,[[1,[2,"Online-Functions"]]]]],
[]],[0,[!1,"Offline-Functions"],!1,null,6594461164896646,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6594461164896646,!1,[[1,[2,"Offline-Functions"]]]]],[],[[0,null,!1,null,7462170365284068,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0xe354b1db94e22,!1,[[1,[2,"updatePlayerCash"]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,7774313925707077,!1,[[3,0],[7,[2,"update storage"]]]],[216,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,
6636791805461497,!1,[[1,[2,"si.playerCash"]],[7,[23,"PlayerCash"]]]]]]]]]],["GameEventGlass",[[0,null,!1,null,0x86ed9ba2b48d,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x3e4cb0520bd4d,!1]],[],[[0,null,!1,null,0x916c2ebfd0123,[[63,cr.behaviors.Sin.prototype.cnds.IsActive,"Sine",0,!1,!1,!1,9192846872579768,!1]],[[63,cr.behaviors.Sin.prototype.acts.SetActive,"Sine",648735410240853,!1,[[3,0]]]]]]],[0,null,!1,null,0x9ab9d2726ffb9,[[63,cr.plugins_.Sprite.prototype.cnds.OnCreated,
null,1,!1,!1,!1,0x716b94480d078,!1]],[[61,cr.behaviors.Pin.prototype.acts.Pin,"Pin",5034660360773455,!1,[[4,63],[3,0]]]],[[0,null,!1,null,5268231818418703,[[-1,cr.system_object.prototype.cnds.PickNth,null,0,!1,!1,!1,6451252985131715,!1,[[4,64],[0,[0,0]]]]],[[64,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x7faa9ce9f4b0a,!1,[[10,1],[7,[20,61,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]]]],[0,null,!1,null,5684837508020186,[],[[-1,cr.system_object.prototype.acts.Wait,null,0x7b4a943fc783,
!1,[[0,[1,0.6]]]],[63,cr.behaviors.Sin.prototype.acts.SetActive,"Sine",0xf372631e9fef3,!1,[[3,0]]]]]]],[0,null,!1,null,0xc29c5693f5046,[[61,cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,null,1,!1,!1,!1,450759528496898,!1,[[1,[2,"Filling"]]]]],[[63,cr.behaviors.DragnDrop.prototype.acts.SetEnabled,"DragDrop",0x4c17621464651,!1,[[3,1]]]]],[0,null,!1,null,325388731139444,[[67,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,445438004082084,!1,[[4,63]]]],[],[[0,null,!1,null,8211149300281789,
[[67,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,8589250088806605,!1,[[1,[2,"Active"]]]]],[[67,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6799919277351997,!1,[[1,[2,"Active"]],[3,1]]]]]]],[0,null,!1,null,0xb712aba73c315,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,7918294890594335,!1]],[],[[0,null,!1,null,6108333627555243,[[67,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,5783863823968129,!1,[[1,[2,"Default"]]]]],[[67,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,0x94bd917e6b8ff,!1,[[1,[2,"Default"]],[3,1]]]]]]]]],["GameEventBubble",[[0,null,!1,null,960330142816143,[[57,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,8568736330053067,!1]],[[58,cr.plugins_.Spritefont2.prototype.acts.SetPosToObject,null,5906349963185384,!1,[[4,57],[7,[2,"Order"]]]],[58,cr.behaviors.Pin.prototype.acts.Pin,"Pin",7068474596281469,!1,[[4,57],[3,0]]]]],[0,null,!1,null,6038424221746762,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,7045761730619779,
!1,[[1,[2,"DestroyBubble"]]]]],[],[[0,null,!1,null,7803227229682908,[[57,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x784b465f366e9,!1,[[0,[21,223,!1,null,7]]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,692633319994384,!1]]]]]]],["GameEventMixer",[[0,null,!1,null,7688449840049518,[[64,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!0,!1,6633071889938855,!1,[[10,0],[8,0],[7,[2,""]]]]],[],[[0,null,!1,null,9195838978245400,[[64,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
null,0,!1,!0,!1,0xa9d526a6b799d,!1,[[1,[21,64,!0,null,0]]]]],[[64,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6739373347684333,!1,[[1,[21,64,!0,null,0]],[3,1]]]]],[0,null,!1,null,0x74641c99a5d5f,[[66,cr.behaviors.Sin.prototype.cnds.IsActive,"SineVertical",0,!1,!0,!1,4504403980233629,!1]],[[66,cr.behaviors.Sin.prototype.acts.SetActive,"SineVertical",0xc8b5216268e68,!1,[[3,1]]]]],[0,null,!1,null,4739838996638876,[[66,cr.behaviors.Sin.prototype.cnds.IsActive,"SineHorizontal",0,!1,!0,!1,7548154898426064,
!1]],[[66,cr.behaviors.Sin.prototype.acts.SetActive,"SineHorizontal",9532609099891606,!1,[[3,1]]]]]]],[0,null,!1,null,0x822e5e128251,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,7948925832919342,!1]],[[66,cr.behaviors.Sin.prototype.acts.SetActive,"SineVertical",6354023763181839,!1,[[3,0]]],[66,cr.behaviors.Sin.prototype.acts.SetActive,"SineHorizontal",0x4d006e23f5f8d,!1,[[3,0]]]]],[0,null,!1,null,0xbbf853a85683b,[[66,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,5346121451802282,
!1,[[1,[21,66,!0,null,0]]]]],[[66,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x6ec2d0b59638b,!1,[[1,[21,66,!0,null,0]],[3,1]]]]],[0,null,!1,null,8377343900113003,[[64,cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,null,1,!1,!1,!1,8513646185807199,!1,[[1,[2,"Twirl"]]]]],[[64,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,8275897392870334,!1,[[10,0],[7,[2,""]]]],[64,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xe4506b695bad8,!1,[[1,[2,"Done"]],[3,1]]]],[[0,null,!1,null,8279584887842515,
[[61,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,5536330518978246,!1,[[0,[21,64,!1,null,1]]]]],[[61,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,652531276588335,!1,[[10,0],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetDrink,!0,null]]]],[61,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7212266421598304,!1,[[1,[2,"Filling"]],[3,1]]]]],[0,null,!1,null,0x6aae1bfb2f403,[],[[65,cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,null,5322347483235701,!1,[[10,0],[3,0]]]]]]]]],
["GameEventHUD",[[0,null,!1,null,0xf73dc2ec4654d,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x56fd837c0d997,!1]],[[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,0x7078f7ab93168,!1,[[4,32],[0,[0,10]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,4844669957544724,!1,[[1,[2,"SetTime"]],[13,[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,[[2,"config.time"]]]],[7,[2,"init"]],[7,[0,1]]]]]]],[0,null,!1,null,0xb7d37ba4a350c,[[208,
cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0xc6e3a6a7b3ba,!1,[[1,[2,"SetTime"]]]]],[],[[0,null,!1,null,8865297252340803,[[208,cr.plugins_.Function.prototype.cnds.CompareParam,null,0,!1,!1,!1,6264811932752156,!1,[[0,[0,1]],[8,0],[7,[2,"init"]]]]],[[35,cr.plugins_.Spritefont2.prototype.acts.SetInstanceVar,null,0x79a31f3671f01,!1,[[10,0],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]],[35,cr.plugins_.Spritefont2.prototype.acts.SetInstanceVar,null,0xe5eba71677a9c,
!1,[[10,1],[7,[5,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]],[0,1]]]]]]],[0,null,!1,null,7896443821564911,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,5755395369652492,!1],[208,cr.plugins_.Function.prototype.cnds.CompareParam,null,0,!1,!1,!1,9695901209042728,!1,[[0,[0,1]],[8,0],[7,[2,"set"]]]]],[[35,cr.plugins_.Spritefont2.prototype.acts.SetInstanceVar,null,0xe65a4d45c3a51,!1,[[10,0],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]]]],[0,
null,!1,null,8118393055642642,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,7579535285570734,!1],[208,cr.plugins_.Function.prototype.cnds.CompareParam,null,0,!1,!1,!1,0x3c6b0dded5864,!1,[[0,[0,1]],[8,0],[7,[2,"append"]]]]],[[35,cr.plugins_.Spritefont2.prototype.acts.AddInstanceVar,null,0xd4208b82b9f77,!1,[[10,0],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]],[35,cr.behaviors.Timer.prototype.acts.StartTimer,"Timer",0xc570630c95ecf,!1,[[0,[1,0.025]],[3,1],[1,[2,
"Increase"]]]]]],[0,null,!1,null,844150971215415,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,4922630738702175,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,2]]]],[8,4],[7,[0,0]]]]],[[35,cr.behaviors.Timer.prototype.acts.StopTimer,"Timer",0xae243586909b7,!1,[[1,[2,"Timer"]]]],[35,cr.behaviors.Timer.prototype.acts.StartTimer,"Timer",5777744845717194,!1,[[0,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,2]]]],[3,1],[1,[2,"Timer"]]]]]],[1,"seconds",
0,0,!1,!1,5833490917853805,!1],[0,null,!1,null,9889086923121504,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xe7300582613e3,!1,[[7,[21,35,!1,null,0]],[8,1],[7,[21,35,!1,null,1]]]]],[],[[0,null,!1,null,7024147489911035,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xf8e635f9841aa,!1,[[7,[21,35,!1,null,1]],[8,2],[7,[21,35,!1,null,0]]]]],[[35,cr.plugins_.Spritefont2.prototype.acts.AddInstanceVar,null,7275610906090137,!1,[[10,1],[7,[0,1]]]]]],[0,null,!1,null,9870389618068338,
[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,9121452824792380,!1,[[7,[21,35,!1,null,1]],[8,4],[7,[21,35,!1,null,0]]]]],[[35,cr.plugins_.Spritefont2.prototype.acts.SubInstanceVar,null,5137925335788372,!1,[[10,1],[7,[0,1]]]]]],[0,null,!1,null,8185871221391677,[],[[-1,cr.system_object.prototype.acts.SetVar,null,0x8bacabaf4e7bd,!1,[[11,"seconds"],[7,[8,[21,35,!1,null,1],[0,60]]]]],[35,cr.plugins_.Spritefont2.prototype.acts.SetText,null,9867819861708828,!1,[[7,[10,[10,[19,cr.system_object.prototype.exps.zeropad,
[[7,[5,[21,35,!1,null,1],[23,"seconds"]],[0,60]],[0,2]]],[2,":"]],[19,cr.system_object.prototype.exps.zeropad,[[23,"seconds"],[0,2]]]]]]]]]]]]],[0,null,!1,null,0x3c4d1895bf92d,[[35,cr.behaviors.Timer.prototype.cnds.OnTimer,"Timer",0,!1,!1,!1,0x73d421e5ec59a,!1,[[1,[2,"Timer"]]]]],[],[[0,null,!1,null,0xc2cdb1025327e,[[35,cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,7790730752429299,!1,[[10,0],[8,4],[7,[0,0]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,
0xd389b55785384,!1,[[1,[2,"SetTime"]],[13,[7,[0,-1]],[7,[2,"append"]],[7,[0,0]]]]]]],[0,null,!1,null,8117008241463692,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,7170489482937157,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,9079612614488498,!1,[[1,[2,"EndGame"]],[13]]]]]]],[0,null,!1,null,0x88cb228910e79,[[35,cr.behaviors.Timer.prototype.cnds.OnTimer,"Timer",0,!1,!1,!1,5751119615590746,!1,[[1,[2,"Increase"]]]]],[],[[0,null,!1,null,0x7083af12eca74,[[35,cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
null,0,!1,!1,!1,0xb70d4dbe57ddc,!1,[[10,0],[8,4],[7,[21,35,!1,null,1]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x4156eee936f1e,!1,[[1,[2,"SetTime"]],[13,[7,[0,0]],[7,[2,"show"]],[7,[0,0]]]]]]],[0,null,!1,null,0xfbb2d655de25d,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0x73fb7dac77c13,!1]],[[35,cr.behaviors.Timer.prototype.acts.StopTimer,"Timer",0xcacd399644859,!1,[[1,[2,"Increase"]]]]]]]],[0,null,!1,null,4822202951128033,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,
null,2,!1,!1,!1,0x4293d0968028f,!1,[[1,[2,"deactivateMainGroups"]]]]],[[35,cr.behaviors.Timer.prototype.acts.StopTimer,"Timer",720487758417605,!1,[[1,[2,"Timer"]]]]]],[0,null,!1,null,0xb4570aaeaa808,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0x9d8b54ad7b1e8,!1,[[1,[2,"activateMainGroups"]]]]],[[35,cr.behaviors.Timer.prototype.acts.StartTimer,"Timer",0xdeda9d1f42759,!1,[[0,[1,1]],[3,1],[1,[2,"Timer"]]]]]],[0,null,!1,null,78297663179133,[[40,cr.plugins_.TiledBg.prototype.cnds.OnCreated,
null,1,!1,!1,!1,0x9e4a51c92b6b3,!1]],[[40,cr.plugins_.TiledBg.prototype.acts.SetPosToObject,null,6083370332805889,!1,[[4,39],[7,[2,"TopLeft"]]]],[40,cr.plugins_.TiledBg.prototype.acts.SetWidth,null,0xca5617524bbd5,!1,[[0,[0,0]]]],[40,cr.behaviors.Pin.prototype.acts.Pin,"Pin",7140347786676825,!1,[[4,39],[3,0]]],[41,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xccbc866443deb,!1,[[10,0],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,[[2,"config.targets.0"]]]]]],[42,
cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,905741637848082,!1,[[10,0],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,[[2,"config.targets.1"]]]]]],[43,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x60a8feaae1bcd,!1,[[10,0],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,[[2,"config.targets.2"]]]]]],[44,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5673061769633858,!1,[[10,0],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,
!1,null,[[2,"config.targets.3"]]]]]],[239,cr.plugins_.Sprite.prototype.acts.SetY,null,0xb7c66ef19bf64,!1,[[0,[4,[20,40,cr.plugins_.TiledBg.prototype.exps.Y,!1,null],[7,[20,40,cr.plugins_.TiledBg.prototype.exps.ImageHeight,!1,null],[0,2]]]]]],[41,cr.plugins_.Sprite.prototype.acts.SetX,null,0x6960efbc06cc8,!1,[[0,[4,[20,40,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[6,[7,[21,41,!1,null,0],[21,44,!1,null,0]],[20,40,cr.plugins_.TiledBg.prototype.exps.ImageWidth,!1,null]]]]]],[42,cr.plugins_.Sprite.prototype.acts.SetX,
null,0xe5ed10f9692d,!1,[[0,[4,[20,40,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[6,[7,[21,42,!1,null,0],[21,44,!1,null,0]],[20,40,cr.plugins_.TiledBg.prototype.exps.ImageWidth,!1,null]]]]]],[43,cr.plugins_.Sprite.prototype.acts.SetX,null,7166108757113042,!1,[[0,[4,[20,40,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[6,[7,[21,43,!1,null,0],[21,44,!1,null,0]],[20,40,cr.plugins_.TiledBg.prototype.exps.ImageWidth,!1,null]]]]]],[44,cr.plugins_.Sprite.prototype.acts.SetX,null,7574507238520417,!1,[[0,
[4,[20,40,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[20,40,cr.plugins_.TiledBg.prototype.exps.ImageWidth,!1,null]]]]]]],[0,null,!1,null,6937117894477098,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xba67f60913fe2,!1,[[7,[7,[20,40,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[20,40,cr.plugins_.TiledBg.prototype.exps.ImageWidth,!1,null]]],[8,2],[7,[7,[19,cr.system_object.prototype.exps["int"],[[20,32,cr.plugins_.Spritefont2.prototype.exps.Text,!0,null]]],[21,44,!1,null,0]]]]],
[40,cr.plugins_.TiledBg.prototype.cnds.CompareWidth,null,0,!1,!1,!1,6802964219978612,!1,[[8,2],[0,[20,40,cr.plugins_.TiledBg.prototype.exps.ImageWidth,!1,null]]]]],[[40,cr.plugins_.TiledBg.prototype.acts.SetWidth,null,6170874494250306,!1,[[0,[4,[20,40,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[0,1]]]]]]],[0,null,!1,null,4950971415816888,[[239,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0xb1e572715b779,!1,[[10,0],[8,3],[7,[19,cr.system_object.prototype.exps["int"],
[[20,32,cr.plugins_.Spritefont2.prototype.exps.Text,!0,null]]]]]],[239,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!0,!1,5176084974415396,!1,[[1,[2,"Active"]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0x3c1bface95aaa,!1,[[3,0],[7,[2,"add start"]]]],[239,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7629673556914347,!1,[[1,[2,"Active"]],[3,1]]],[239,cr.behaviors.Sin.prototype.acts.SetActive,"Sine",9720368141141014,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,
null,0xca8969097fa70,!1,[[0,[1,0.4]]]],[239,cr.behaviors.Sin.prototype.acts.SetActive,"Sine",0x6027d45db6caf,!1,[[3,0]]],[239,cr.plugins_.Sprite.prototype.acts.SetScale,null,638390436684566,!1,[[0,[0,1]]]]]],[0,null,!1,null,0x93823010e8a7b,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,5775292757419934,!1]],[],[[0,null,!1,null,4630157193825579,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xecb1179ef3588,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,
null,[[2,"IsTouched"],[20,36,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x73392772c31ba,!1,[[1,[2,"deactivateMainGroups"]],[13]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xcfead5b9b7d56,!1,[[4,171],[5,[2,"HUD"]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,8900453120826065,!1,[[4,38],[5,[2,"HUD"]],[0,[7,[19,cr.system_object.prototype.exps.layoutwidth],[0,2]]],[0,[19,cr.system_object.prototype.exps.layoutheight]]]],
[-1,cr.system_object.prototype.acts.Wait,null,4712773732218935,!1,[[0,[21,38,!1,null,0]]]],[38,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x3fce508bd4d3a,!1,[[4,95],[5,[2,"HUD"]],[7,[2,"ToSelectLevel"]]]],[38,cr.plugins_.Sprite.prototype.acts.Spawn,null,6840781019234827,!1,[[4,37],[5,[2,"HUD"]],[7,[2,"Resume"]]]],[38,cr.plugins_.Sprite.prototype.acts.Spawn,null,9406502691707856,!1,[[4,96],[5,[2,"HUD"]],[7,[2,"Replay"]]]]]],[0,null,!1,null,0x75f6b3d95c1ec,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,8430182204748665,!1,[[4,37]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,7078694207719482,!1,[[1,[2,"activateMainGroups"]],[13]]],[171,cr.plugins_.TiledBg.prototype.acts.Destroy,null,0x561e431b95fc6,!1],[38,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x724c6b51f9204,!1],[95,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc04e556b377cf,!1],[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,9562349929628792,!1],[96,cr.plugins_.Sprite.prototype.acts.Destroy,null,
5334953911311283,!1]]]]]]],["GameEventCustomer",[[0,null,!1,null,7776908417327132,[[223,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x98baae1d0e589,!1]],[[223,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",99309281647941,!1,[[0,[0,-180]]]]]],[0,null,!1,null,0x94550c412898a,[[-1,cr.system_object.prototype.cnds.ForEachOrdered,null,0,!0,!1,!1,0x6979782e12da8,!1,[[4,223],[7,[20,223,cr.plugins_.Sprite.prototype.exps.UID,!1,null]],[3,0]]]],[],[[0,null,!1,null,720799797245715,
[[223,cr.plugins_.Sprite.prototype.cnds.CompareX,null,0,!1,!1,!1,6007577084989194,!1,[[8,3],[0,[20,70,cr.plugins_.Arr.prototype.exps.At,!1,null,[[19,cr.system_object.prototype.exps.loopindex]]]]]]],[],[[0,null,!0,null,0xc3a70da7cc47d,[[223,cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,null,0,!1,!0,!1,6738039067452563,!1,[[10,6]]],[223,cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,null,0,!1,!0,!1,7224582383823484,!1,[[10,3]]]],[[223,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",
8851030509295586,!1,[[3,0]]]]],[0,null,!1,null,9744441595794202,[[223,cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,null,0,!1,!0,!1,9414024110719992,!1,[[10,6]]]],[[223,cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,null,556316431827213,!1,[[10,6],[3,1]]],[223,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7106606611716973,!1,[[1,[2,"Ordered"]],[3,1]]],[223,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x8d50773184742,!1,[[4,57],[5,[2,"Customer"]],[7,[2,"Bubble"]]]],[57,cr.behaviors.Pin.prototype.acts.Pin,
"Pin",0x64dc4032f5988,!1,[[4,223],[3,0]]],[58,cr.plugins_.Spritefont2.prototype.acts.SetText,null,0xc69b9310ef900,!1,[[7,[21,223,!0,null,1]]]],[223,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,911628027068258,!1,[[10,7],[7,[20,57,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[223,cr.behaviors.Timer.prototype.acts.StartTimer,"Timer",0x6a57e4f8a9809,!1,[[0,[21,223,!1,null,2]],[3,0],[1,[2,"Ordered"]]]]],[[0,null,!1,null,0xa8f207ee10cc1,[[-1,cr.system_object.prototype.cnds.Compare,null,0,
!1,!1,!1,5926996226661803,!1,[[7,[19,cr.system_object.prototype.exps.len,[[20,58,cr.plugins_.Spritefont2.prototype.exps.Text,!0,null]]]],[8,4],[7,[0,3]]]]],[[57,cr.plugins_.Sprite.prototype.acts.SetAnim,null,544348265805873,!1,[[1,[2,"Bubble2"]],[3,1]]],[58,cr.behaviors.Pin.prototype.acts.Unpin,"Pin",0x671eff30b8bef,!1],[58,cr.plugins_.Spritefont2.prototype.acts.SetHeight,null,9180656938779446,!1,[[0,[6,[20,58,cr.plugins_.Spritefont2.prototype.exps.CharacterHeight,!1,null],[0,2]]]]],[58,cr.plugins_.Spritefont2.prototype.acts.SetPosToObject,
null,0x97570a07a70e5,!1,[[4,57],[7,[2,"Order"]]]],[58,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0x8c4b4a2ab9aa9,!1,[[4,57],[3,0]]]]]]]]]]],[0,null,!1,null,4890543708027653,[[223,cr.behaviors.Timer.prototype.cnds.OnTimer,"Timer",0,!1,!1,!1,0xc0ceeb8c57339,!1,[[1,[2,"Served"]]]]],[[223,cr.behaviors.Sin.prototype.acts.SetActive,"Cheering",7167851606752209,!1,[[3,0]]]]],[0,null,!1,null,0x6b92bbf9f781f,[[223,cr.behaviors.Timer.prototype.cnds.OnTimer,"Timer",0,!1,!1,!1,9540324221385264,!1,[[1,[2,"Leaving"]]]]],
[[223,cr.behaviors.Sin.prototype.acts.SetActive,"Angry",0x8f95c15a3c063,!1,[[3,0]]]]],[0,null,!1,null,5858058747396118,[[223,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,6235644567940518,!1]],[],[[0,null,!1,null,7363418788284751,[[63,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,7383756601364754,!1,[[0,[21,223,!1,null,8]]]]],[[63,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x8ca9358f89d53,!1]]]]],[0,null,!1,null,6112033287830449,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,
null,2,!1,!1,!1,4909734687740634,!1,[[1,[2,"deactivateMainGroups"]]]]],[],[[0,null,!1,null,7728640351514104,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,0x46b0beef023ec,!1,[[4,223]]]],[[223,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x73f88559b3dfd,!1,[[10,9],[7,[5,[22,223,"Timer",cr.behaviors.Timer.prototype.exps.Duration,!1,null,[[20,223,cr.plugins_.Sprite.prototype.exps.AnimationName,!0,null]]],[22,223,"Timer",cr.behaviors.Timer.prototype.exps.TotalTime,!1,null,[[20,
223,cr.plugins_.Sprite.prototype.exps.AnimationName,!0,null]]]]]]],[223,cr.behaviors.Timer.prototype.acts.StopTimer,"Timer",848986521386025,!1,[[1,[20,223,cr.plugins_.Sprite.prototype.exps.AnimationName,!0,null]]]],[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0xe576b43ea77f1,!1,[[3,0],[7,[20,223,cr.plugins_.Sprite.prototype.exps.AnimationName,!0,null]]]]]]]],[0,null,!1,null,8770827443312661,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0x880c7647ba8b,!1,[[1,[2,"activateMainGroups"]]]]],
[],[[0,null,!1,null,4807994469234605,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,9210408662073996,!1,[[4,223]]]],[[223,cr.behaviors.Timer.prototype.acts.StartTimer,"Timer",4822632835864027,!1,[[0,[21,223,!1,null,9]],[3,0],[1,[20,223,cr.plugins_.Sprite.prototype.exps.AnimationName,!0,null]]]],[223,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,4933789898098566,!1,[[10,9],[7,[0,0]]]]]]]]]],["GameEventEndGameDialog",[[0,null,!1,null,8320558617740963,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,7041990105746764,!1]],[],[[0,null,!1,null,5001946504560791,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4680326030083588,!1,[[11,"OnlineMode"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xecc8697f665da,!1,[[1,[2,"Online-EndGameDialog"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,5168925611260748,!1,[[1,[2,"Offline-EndGameDialog"]],[3,0]]]]],[0,null,!1,null,7790705714422872,[[-1,cr.system_object.prototype.cnds.Else,
null,0,!1,!1,!1,6952005273152173,!1]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x5fcbe4ab1ca4,!1,[[1,[2,"Offline-EndGameDialog"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,5805146048198271,!1,[[1,[2,"Online-EndGameDialog"]],[3,0]]]]]]],[0,null,!1,null,7141124194127643,[[104,cr.plugins_.Spriter.prototype.cnds.readyForSetup,null,1,!1,!1,!1,6808648395376874,!1]],[[104,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,9194819727199540,!1,[[4,76],[1,[2,
"s2"]]]],[104,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,5289495116669345,!1,[[4,77],[1,[2,"s2_000"]]]],[104,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,4979970552465349,!1,[[4,78],[1,[2,"s5"]]]],[104,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0x63c8022cbe77b,!1,[[4,79],[1,[2,"s4"]]]],[104,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,4804781340853653,!1,[[4,80],[1,[2,"s3"]]]],[104,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,
null,0x91ecd24345cb6,!1,[[4,81],[1,[2,"s6"]]]],[104,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,7632790647485698,!1,[[4,82],[1,[2,"s1"]]]],[104,cr.plugins_.Spriter.prototype.acts.setAnimationLoop,null,7470757285680125,!1,[[3,0]]]]],[0,null,!1,null,0x8c9f39c4367fd,[[104,cr.plugins_.Spriter.prototype.cnds.OnCreated,null,1,!1,!1,!1,763537239440521,!1]],[[104,cr.plugins_.Spriter.prototype.acts.setPlaybackSpeedRatio,null,0xb1620bd39c285,!1,[[0,[1,0.3]]]],[104,cr.behaviors.Pin.prototype.acts.Pin,
"Pin",4894113906951296,!1,[[4,93],[3,0]]]]],[0,null,!1,null,9963873941530136,[[105,cr.plugins_.Spriter.prototype.cnds.readyForSetup,null,1,!1,!1,!1,455401037820987,!1]],[[105,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,9725613178681002,!1,[[4,83],[1,[2,"s7"]]]],[105,cr.plugins_.Spriter.prototype.acts.setAnimationLoop,null,8239329061962539,!1,[[3,0]]]]],[0,null,!1,null,0xcdae2465c7979,[[105,cr.plugins_.Spriter.prototype.cnds.OnCreated,null,1,!1,!1,!1,9770065371311912,!1]],[[105,cr.plugins_.Spriter.prototype.acts.setPlaybackSpeedRatio,
null,0xd46907664d0d7,!1,[[0,[1,0.3]]]],[105,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0xde2cc33270b52,!1,[[4,93],[3,0]]]]],[0,null,!1,null,0xe39cab45c4dd4,[[107,cr.plugins_.Spriter.prototype.cnds.readyForSetup,null,1,!1,!1,!1,0xe9ffb304cd561,!1]],[[107,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,494130160957785,!1,[[4,86],[1,[2,"bg"]]]],[107,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0xea7d2f6c8200f,!1,[[4,87],[1,[2,"left"]]]],[107,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,
null,0xd5eccbff7c7bc,!1,[[4,88],[1,[2,"right"]]]],[107,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,8267916889566495,!1,[[4,89],[1,[2,"message"]]]],[107,cr.plugins_.Spriter.prototype.acts.setAnimationLoop,null,424982494487421,!1,[[3,0]]]]],[0,null,!1,null,0x3df3973f8d69b,[[107,cr.plugins_.Spriter.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x7d2ffa45725b6,!1]],[[107,cr.plugins_.Spriter.prototype.acts.setPlaybackSpeedRatio,null,8107673164707096,!1,[[0,[1,0.3]]]]]],[0,null,!1,null,8986250889263257,
[[106,cr.plugins_.Spriter.prototype.cnds.readyForSetup,null,1,!1,!1,!1,0x8bbbb2daf612,!1]],[[106,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,5708252821767075,!1,[[4,84],[1,[2,"bg"]]]],[106,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,460866152490658,!1,[[4,85],[1,[2,"message"]]]],[106,cr.plugins_.Spriter.prototype.acts.setAnimationLoop,null,0x6845715ec50c1,!1,[[3,0]]]]],[0,null,!1,null,5563508617595801,[[106,cr.plugins_.Spriter.prototype.cnds.OnCreated,null,1,!1,
!1,!1,7228927096968402,!1]],[[106,cr.plugins_.Spriter.prototype.acts.setPlaybackSpeedRatio,null,8811184168395806,!1,[[0,[1,0.3]]]]]],[0,null,!1,null,9646827711867604,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,8919102826471584,!1,[[1,[2,"ShowEndGameDialog"]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,8853707998779655,!1,[[4,171],[5,[2,"HUD"]],[0,[0,0]],[0,[0,0]]]]],[[0,null,!1,null,5349149902307295,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,
!1,0x530d3e8eedc78,!1,[[11,"result"],[8,4],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x8be9f986926d5,!1,[[4,107],[5,[2,"HUD"]],[0,[23,"CenterX"]],[0,[23,"CenterY"]]]]]],[0,null,!1,null,0xc22c713d8c7f4,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0xfe41274ce9324,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,9724249939075144,!1,[[4,106],[5,[2,"HUD"]],[0,[23,"CenterX"]],[0,[23,"CenterY"]]]]]],[0,null,!1,null,9913936035682352,[],[[-1,cr.system_object.prototype.acts.Wait,
null,8754111866877297,!1,[[0,[1,2.5]]]],[249,cr.plugins_.Spriter.prototype.acts.Destroy,null,9656338112300068,!1],[171,cr.plugins_.TiledBg.prototype.acts.Destroy,null,0xdb06f0e03d90,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,6725190228129059,!1,[[4,90],[5,[2,"HUD"]],[0,[7,[19,cr.system_object.prototype.exps.layoutwidth],[0,2]]],[0,[19,cr.system_object.prototype.exps.layoutheight]]]],[98,cr.plugins_.Spritefont2.prototype.acts.SetText,null,9975884142779964,!1,[[7,[4,[23,"currentLevel"],
[0,1]]]]]]]]],[0,null,!1,null,6772660383756371,[[93,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,9952167624982640,!1]],[[93,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6509341227216207,!1,[[4,91],[7,[2,"Placeholder"]]]],[93,cr.behaviors.Pin.prototype.acts.Pin,"Pin",7522403136299472,!1,[[4,91],[3,0]]]]],[0,null,!1,null,7346876748015121,[[98,cr.plugins_.Spritefont2.prototype.cnds.OnCreated,null,1,!1,!1,!1,0xfb525a9b2a3cb,!1]],[[98,cr.plugins_.Spritefont2.prototype.acts.SetPosToObject,
null,5347203043936773,!1,[[4,93],[7,[2,"Level"]]]],[98,cr.behaviors.Pin.prototype.acts.Pin,"Pin",766248747373933,!1,[[4,93],[3,0]]]]],[0,null,!1,null,282400790666984,[[94,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,4633229308495576,!1]],[[94,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x905da99161efe,!1,[[4,92],[7,[2,"Title"]]]],[94,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0x4630d98436b4c,!1,[[4,92],[3,0]]]]],[0,null,!1,null,0xd226ee0701f7a,[[92,cr.plugins_.Sprite.prototype.cnds.OnCreated,
null,1,!1,!1,!1,6155742873375475,!1]],[[92,cr.plugins_.Sprite.prototype.acts.ZMoveToObject,null,0x834d5cb097329,!1,[[3,0],[4,91]]],[94,cr.plugins_.Sprite.prototype.acts.ZMoveToObject,null,8832300761186654,!1,[[3,0],[4,92]]]]],[0,null,!1,null,9863030901093860,[[91,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,8108278376767129,!1]],[[91,cr.plugins_.Sprite.prototype.acts.ZMoveToObject,null,4943450684975502,!1,[[3,0],[4,90]]],[93,cr.plugins_.Sprite.prototype.acts.ZMoveToObject,null,0xa952a0c3a309e,
!1,[[3,0],[4,91]]],[98,cr.plugins_.Spritefont2.prototype.acts.ZMoveToObject,null,0x552eb9e71ba80,!1,[[3,0],[4,93]]],[-1,cr.system_object.prototype.acts.Wait,null,0x89852d3811fdb,!1,[[0,[21,91,!1,null,0]]]],[93,cr.plugins_.Sprite.prototype.acts.Spawn,null,5864626418213552,!1,[[4,99],[5,[2,"HUD"]],[7,[2,"Score"]]]],[99,cr.plugins_.Text.prototype.acts.SetInstanceVar,null,7746712913821604,!1,[[10,0],[7,[23,"score"]]]]],[[0,null,!1,null,4653363568863001,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,9600046557773564,!1,[[11,"currentLevel"],[8,2],[7,[5,[20,203,cr.plugins_.Arr.prototype.exps.Width,!1,null],[0,1]]]]],[203,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,8782361985110602,!1,[[0,[4,[23,"currentLevel"],[0,1]]],[8,5],[7,[0,1]]]]],[[91,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x99882134a48a,!1,[[4,97],[5,[2,"HUD"]],[7,[2,"BtnNextLevel"]]]]]],[0,null,!1,null,6014621916142888,[],[[91,cr.plugins_.Sprite.prototype.acts.Spawn,null,9472381464963264,!1,[[4,95],[5,
[2,"HUD"]],[7,[2,"BtnToSelectLevel"]]]],[91,cr.plugins_.Sprite.prototype.acts.Spawn,null,9982228410335520,!1,[[4,96],[5,[2,"HUD"]],[7,[2,"BtnReplay"]]]]]],[0,null,!1,null,9346415307505732,[],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,9203309171524944,!1,[[1,[2,"showAchievements"]],[13,[7,[20,93,cr.plugins_.Sprite.prototype.exps.UID,!1,null]],[7,[2,"Achievement"]]]]]]],[0,null,!1,null,6129036441949884,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9449821165165640,
!1,[[11,"result"],[8,4],[7,[0,0]]]]],[],[[0,null,!1,null,5713213339861412,[[-1,cr.system_object.prototype.cnds.For,null,0,!0,!1,!1,0xaf1ddd8a725ae,!1,[[1,[2,"star"]],[0,[0,1]],[0,[0,3]]]]],[],[[0,null,!1,null,0x84e9490379705,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x5d937052b1f7a,!1,[[11,"result"],[8,4],[7,[19,cr.system_object.prototype.exps.loopindex]]]]],[[93,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x44a58e989fb74,!1,[[4,104],[5,[2,"HUD"]],[7,[10,[2,"Star"],[19,cr.system_object.prototype.exps.loopindex]]]]]]],
[0,null,!1,null,0x829a62b3a75a1,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0x6a5eb5151ce97,!1]],[[93,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xc6887dfadb4b3,!1,[[4,105],[5,[2,"HUD"]],[7,[10,[2,"Star"],[19,cr.system_object.prototype.exps.loopindex]]]]]]]]]]],[0,null,!1,null,0x9287bf1942f49,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,9406041712915328,!1]],[[93,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xc63184d41ca3f,!1,[[4,109],[5,[2,"HUD"]],[7,[2,"Star2"]]]],[109,
cr.behaviors.Pin.prototype.acts.Pin,"Pin",5994592341446547,!1,[[4,93],[3,0]]]]]]],[0,null,!1,null,6566096723333424,[[229,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,0xb33247635476c,!1]],[[229,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0xc085305223b9e,!1,[[4,93],[3,0]]]]],[0,null,!1,null,6463130948124653,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7925836284077414,!1,[[0,[1,0.025]]]],[229,cr.plugins_.Text.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x73ab9ceef0214,
!1,[[10,0],[8,4],[7,[19,cr.system_object.prototype.exps["int"],[[20,229,cr.plugins_.Text.prototype.exps.Text,!0,null]]]]]]],[[229,cr.plugins_.Text.prototype.acts.SetText,null,6093210874476453,!1,[[7,[19,cr.system_object.prototype.exps.min,[[4,[19,cr.system_object.prototype.exps["int"],[[20,229,cr.plugins_.Text.prototype.exps.Text,!0,null]]],[19,cr.system_object.prototype.exps.ceil,[[7,[21,229,!1,null,0],[1,80]]]]],[21,229,!1,null,0]]]]]]]],[0,null,!1,null,8202235163792193,[[101,cr.plugins_.Sprite.prototype.cnds.OnCreated,
null,1,!1,!1,!1,4642292759128354,!1]],[[101,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0xdc87179312f97,!1,[[4,92],[3,0]]]]],[0,null,!1,null,0x8d72b8d908c60,[[100,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x57d0821a6f3a4,!1]],[[100,cr.plugins_.Text.prototype.acts.SetPosToObject,null,8331406438585648,!1,[[4,101],[7,[2,"Rank"]]]]]],[0,null,!1,null,0x3925786ea61a8,[[102,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,0xeb2409c3f41d4,!1]],[[102,cr.plugins_.Text.prototype.acts.SetPosToObject,
null,8820352128432605,!1,[[4,101],[7,[2,"Name"]]]]]],[0,null,!1,null,9058491230351120,[[103,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,6020056296987648,!1]],[[103,cr.plugins_.Text.prototype.acts.SetPosToObject,null,8707038115795242,!1,[[4,101],[7,[2,"Score"]]]]]],[0,null,!1,null,0xa1bbd28b1a2a5,[[233,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,8736415382592938,!1]],[[233,cr.behaviors.Pin.prototype.acts.Pin,"Pin",6707374477511027,!1,[[4,101],[3,0]]]]],[0,null,!1,null,0x718102e4ce8ed,
[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0xe038b502685a6,!1]],[],[[0,null,!1,null,7373463977041038,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,7473150499873449,!1,[[4,95]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9556251778837098,!1,[[6,"SelectLevel"]]]]],[0,null,!1,null,0xbb8e86b1b3d37,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,6658725316519789,!1,[[4,97]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,
null,7571635567810562,!1,[[1,[2,"PlayLevel"]],[13,[7,[4,[23,"currentLevel"],[0,1]]]]]]]],[0,null,!1,null,0x735e305b1f3e,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,8662852566842066,!1,[[4,96]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xd20ed42da3582,!1,[[1,[2,"PlayLevel"]],[13,[7,[23,"currentLevel"]]]]]]]]],[0,[!1,"Online-EndGameDialog"],!1,null,0x63a04073af0b7,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x63a04073af0b7,!1,[[1,
[2,"Online-EndGameDialog"]]]]],[],[[0,null,!1,null,9098310354676718,[[93,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,7781797276561481,!1]],[[93,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x437f7625fddd4,!1,[[1,[2,"Online"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,5137268560485237,!1,[[0,[21,91,!1,null,0]]]],[93,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xe240d649a26df,!1,[[4,108],[5,[2,"HUD"]],[7,[2,"Energy"]]]],[108,cr.plugins_.Text.prototype.acts.SetInstanceVar,
null,0x9bbef18e27ed1,!1,[[10,0],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[23,"MessageSubmitScore"],[2,"player.energy"]]]]]]],[[0,null,!1,null,6435326057324105,[[-1,cr.system_object.prototype.cnds.For,null,0,!0,!1,!1,4580044710547784,!1,[[1,[2,"rank"]],[0,[0,0]],[0,[5,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[23,"MessageSubmitScore"],[2,"highscore.length"]]],[0,1]]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xac2b6f44456b4,!1,
[[4,101],[5,[2,"HUD"]],[0,[20,92,cr.plugins_.Sprite.prototype.exps.ImagePointX,!1,null,[[2,"Rank"]]]],[0,[4,[20,92,cr.plugins_.Sprite.prototype.exps.ImagePointY,!1,null,[[2,"Rank"]]],[6,[19,cr.system_object.prototype.exps.loopindex],[0,58]]]]]],[100,cr.plugins_.Text.prototype.acts.SetText,null,4811673824249902,!1,[[7,[4,[19,cr.system_object.prototype.exps.loopindex],[0,1]]]]],[102,cr.plugins_.Text.prototype.acts.SetText,null,0x98381efc47fda,!1,[[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,
!1,null,[[23,"MessageSubmitScore"],[10,[10,[2,"highscore."],[19,cr.system_object.prototype.exps.loopindex]],[2,"._id"]]]]]]],[103,cr.plugins_.Text.prototype.acts.SetText,null,7540722675804358,!1,[[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[23,"MessageSubmitScore"],[10,[10,[2,"highscore."],[19,cr.system_object.prototype.exps.loopindex]],[2,".score"]]]]]]]]]]]]],[0,[!1,"Offline-EndGameDialog"],!1,null,4867179975915489,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,
0,!1,!1,!1,4867179975915489,!1,[[1,[2,"Offline-EndGameDialog"]]]]],[],[[0,null,!1,null,9830816402029332,[[93,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x999988af340f2,!1]],[[93,cr.plugins_.Sprite.prototype.acts.SetAnim,null,857407541996407,!1,[[1,[2,"Offline"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,8588238697694454,!1,[[0,[21,91,!1,null,0]]]]],[[0,null,!1,null,818842523790992,[],[[92,cr.plugins_.Sprite.prototype.acts.Spawn,null,7027521576336104,!1,[[4,101],[5,[2,
"HUD"]],[7,[2,"Rank"]]]],[100,cr.plugins_.Text.prototype.acts.SetText,null,6618111820965741,!1,[[7,[2,""]]]],[102,cr.plugins_.Text.prototype.acts.SetFontSize,null,5086258295753002,!1,[[0,[0,10]]]],[102,cr.plugins_.Text.prototype.acts.SetText,null,0xf7928a25028d3,!1,[[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"messages.highestScore"]]]]]],[103,cr.plugins_.Text.prototype.acts.SetText,null,8816204779324476,!1,[[7,[20,209,cr.plugins_.Arr.prototype.exps.At,!1,null,[[23,
"currentLevel"]]]]]]]]]]]]]],["LeaderBoardEvent",[[1,"MessageHighscore",1,"",!1,!1,4787373572662076,!1],[2,"GlobalEvent",!1],[2,"Functions",!1],[2,"AchievementEvent",!1],[0,[!0,"LeaderBoard"],!1,null,0xe4fbad727739b,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xe4fbad727739b,!1,[[1,[2,"LeaderBoard"]]]]],[],[[1,"MAX_FRAMES",0,5,!1,!0,805476030522253,!1],[1,"RANK_FRAME_WIDTH",0,247,!1,!0,7614977165323935,!1],[1,"RANK_FRAME_HEIGHT",0,67,!1,!0,8127480466866096,!1],[1,"RankFrameX",
0,0,!0,!1,5416845255996899,!1],[1,"RankFrameTopY",0,0,!0,!1,6852005823479918,!1],[1,"RankFrameBottomY",0,0,!0,!1,5317685455469145,!1],[1,"RankFrameDY",0,0,!0,!1,513970681811684,!1],[0,null,!1,null,8863051218060348,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9678845577223988,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6140873296809918,!1,[[1,[2,"showAd"]],[13]]],[-1,cr.system_object.prototype.acts.SetVar,null,98517674207448,!1,[[11,"MessageHighscore"],[7,
[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,!1,null,[[2,"Common.Game.HIGH_SCORE"]]]]]]],[[0,null,!1,null,424602452453701,[],[[-1,cr.system_object.prototype.acts.SetVar,null,4999727828057915,!1,[[11,"RankFrameX"],[7,[4,[5,[19,cr.system_object.prototype.exps.layoutwidth],[20,111,cr.plugins_.Sprite.prototype.exps.BBoxRight,!1,null]],[7,[23,"RANK_FRAME_WIDTH"],[0,2]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,368559221851157,!1,[[11,"RankFrameTopY"],[7,[4,[20,111,cr.plugins_.Sprite.prototype.exps.BBoxTop,
!1,null],[7,[23,"RANK_FRAME_HEIGHT"],[0,2]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5446655714944733,!1,[[11,"RankFrameBottomY"],[7,[5,[20,112,cr.plugins_.Sprite.prototype.exps.BBoxBottom,!1,null],[7,[23,"RANK_FRAME_HEIGHT"],[0,2]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9774511591485108,!1,[[11,"RankFrameDY"],[7,[7,[5,[23,"RankFrameBottomY"],[23,"RankFrameTopY"]],[5,[23,"MAX_FRAMES"],[0,1]]]]]]]],[0,null,!1,null,0x45d757f25e00c,[],[[205,cr.plugins_.GameConfig.prototype.acts.Send,
null,0xf3f223f02a58d,!1,[[1,[23,"MessageHighscore"]],[7,[2,""]]]]]],[0,null,!1,null,657613418195265,[],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,8298844538599258,!1,[[1,[2,"showAchievements"]],[13,[7,[20,112,cr.plugins_.Sprite.prototype.exps.UID,!1,null]],[7,[2,"Achievement"]]]]]]]]],[0,null,!1,null,0x84bdda8b15293,[[218,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,7620359782951337,!1]],[[218,cr.plugins_.Text.prototype.acts.SetFontFace,null,0x3df77043474b1,!1,[[1,[2,
"Arial"]],[3,1]]],[218,cr.plugins_.Text.prototype.acts.SetFontSize,null,566043415577905,!1,[[0,[0,16]]]],[218,cr.plugins_.Text.prototype.acts.SetFontColor,null,4912107727085989,!1,[[0,[19,cr.system_object.prototype.exps.rgb,[[0,51],[0,153],[0,153]]]]]]]],[0,null,!1,null,0xee9bf94914cf6,[[205,cr.plugins_.GameConfig.prototype.cnds.OnEvent,null,1,!1,!1,!1,5315895834903432,!1,[[1,[23,"MessageHighscore"]]]]],[[114,cr.plugins_.Text.prototype.acts.SetText,null,66437518944953,!1,[[7,[4,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,
!1,null,[[23,"MessageHighscore"],[2,"rank"]]],[0,1]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,8027016730422701,!1,[[1,[2,"updatePlayerCash"]],[13,[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[23,"MessageHighscore"],[2,"txu"]]]],[7,[2,"set"]]]]],[115,cr.plugins_.Text.prototype.acts.SetText,null,5564105845800674,!1,[[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[23,"MessageHighscore"],[2,"player._id"]]]]]],[116,cr.plugins_.Text.prototype.acts.SetText,
null,0xa13f0909615b2,!1,[[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[23,"MessageHighscore"],[2,"player.score"]]]]]]],[[0,null,!1,null,0xd0967b5777195,[[-1,cr.system_object.prototype.cnds.For,null,0,!0,!1,!1,0xa4ba7ff0aa289,!1,[[1,[2,"rank"]],[0,[0,0]],[0,[19,cr.system_object.prototype.exps.clamp,[[5,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[23,"MessageHighscore"],[2,"highscore.length"]]],[0,1]],[0,0],[5,[23,"MAX_FRAMES"],[0,1]]]]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,9880506527445624,!1,[[4,113],[5,[2,"Entities"]],[0,[23,"RankFrameX"]],[0,[4,[23,"RankFrameTopY"],[6,[19,cr.system_object.prototype.exps.loopindex],[23,"RankFrameDY"]]]]]],[119,cr.plugins_.Text.prototype.acts.SetText,null,5470067724802751,!1,[[7,[4,[19,cr.system_object.prototype.exps.loopindex],[0,1]]]]],[117,cr.plugins_.Text.prototype.acts.SetText,null,5000043608978131,!1,[[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[23,"MessageHighscore"],[10,[10,[2,"highscore."],
[19,cr.system_object.prototype.exps.loopindex]],[2,"._id"]]]]]]],[118,cr.plugins_.Text.prototype.acts.SetText,null,6213421730381882,!1,[[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[23,"MessageHighscore"],[10,[10,[2,"highscore."],[19,cr.system_object.prototype.exps.loopindex]],[2,".score"]]]]]]]]]]],[0,null,!1,null,8219279574585932,[[119,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,7202790833412694,!1]],[[119,cr.plugins_.Text.prototype.acts.SetPosToObject,null,
5931936600492684,!1,[[4,113],[7,[2,"Rank"]]]]]],[0,null,!1,null,545482518041342,[[117,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,0xa9358355365e6,!1]],[[117,cr.plugins_.Text.prototype.acts.SetPosToObject,null,8247391992645132,!1,[[4,113],[7,[2,"Name"]]]]]],[0,null,!1,null,8691662676076372,[[118,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x6c6bd9a91a390,!1]],[[118,cr.plugins_.Text.prototype.acts.SetPosToObject,null,9919922077074724,!1,[[4,113],[7,[2,"Score"]]]]]],[0,null,
!1,null,0x738a78d1630fd,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,9217408464677016,!1],[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,7927761699023786,!1,[[4,207]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,7380416598430713,!1,[[6,"MainMenu"]]]]]]]]],["LevelIntroEvent",[[2,"GlobalEvent",!1],[2,"AchievementEvent",!1],[2,"BoosterEvent",!1],[2,"Functions",!1],[0,null,!1,null,6810967986741572,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,5418667403955431,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x6303f7e1604ff,!1,[[1,[2,"showAd"]],[13]]],[-1,cr.system_object.prototype.acts.Wait,null,0xdb9ec37121343,!1,[[0,[1,0.5]]]],[121,cr.plugins_.Sprite.prototype.acts.Spawn,null,5618703335251512,!1,[[4,37],[5,[2,"HUD"]],[7,[2,"BtnPlay"]]]],[134,cr.plugins_.Text.prototype.acts.SetText,null,0x92c3c060ee988,!1,[[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,[[2,"config.targets.0"]]]]]],
[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xe4ea3002edf33,!1,[[1,[2,"ShowBoosterInfo"]],[13,[7,[0,0]]]]]]],[0,null,!1,null,7642022479927124,[[124,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,8540236084983012,!1]],[[124,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6843573769053999,!1,[[4,121],[7,[2,"Placeholder"]]]],[124,cr.behaviors.Pin.prototype.acts.Pin,"Pin",7555594953298241,!1,[[4,121],[3,0]]]],[[0,null,!1,null,5084851167318221,[[-1,cr.system_object.prototype.cnds.For,
null,0,!0,!1,!1,8902792537229242,!1,[[1,[2,"star"]],[0,[0,1]],[0,[0,3]]]]],[[124,cr.plugins_.Sprite.prototype.acts.Spawn,null,4786749838331585,!1,[[4,221],[5,[2,"HUD"]],[7,[10,[2,"Star"],[19,cr.system_object.prototype.exps.loopindex]]]]],[221,cr.behaviors.Pin.prototype.acts.Pin,"Pin",7603178607659016,!1,[[4,124],[3,0]]]],[[0,null,!1,null,9488457788068378,[[203,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,399759311192019,!1,[[0,[23,"currentLevel"]],[8,5],[7,[4,[19,cr.system_object.prototype.exps.loopindex],
[0,2]]]]]],[[221,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7368541219500187,!1,[[1,[2,"Gold"]],[3,1]]]]]]],[0,null,!1,null,7195015357011571,[],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xb5cb26188b55c,!1,[[1,[2,"showAchievements"]],[13,[7,[20,124,cr.plugins_.Sprite.prototype.exps.UID,!1,null]],[7,[2,"Achievement"]]]]]]],[0,null,!1,null,0xff2a9347ea675,[],[[124,cr.plugins_.Sprite.prototype.acts.Spawn,null,9585440816476884,!1,[[4,136],[5,[2,"HUD"]],[7,[2,"Booster1"]]]],[124,cr.plugins_.Sprite.prototype.acts.Spawn,
null,0x5c15eefe6bdfc,!1,[[4,140],[5,[2,"HUD"]],[7,[2,"Booster2"]]]],[124,cr.plugins_.Sprite.prototype.acts.Spawn,null,9178237507082718,!1,[[4,139],[5,[2,"HUD"]],[7,[2,"Booster3"]]]]]]]],[0,null,!1,null,0x4b1a19fd53e60,[[125,cr.plugins_.Spritefont2.prototype.cnds.OnCreated,null,1,!1,!1,!1,8579081033521472,!1]],[[125,cr.plugins_.Spritefont2.prototype.acts.SetPosToObject,null,0xbf98606aab4dd,!1,[[4,124],[7,[2,"Level"]]]],[125,cr.behaviors.Pin.prototype.acts.Pin,"Pin",5383699935059032,!1,[[4,124],[3,
0]]],[125,cr.plugins_.Spritefont2.prototype.acts.SetText,null,0x850ca56ad9000,!1,[[7,[4,[23,"currentLevel"],[0,1]]]]]]],[0,null,!1,null,9488967225927268,[[134,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x93b0d99e0ff82,!1]],[[134,cr.plugins_.Text.prototype.acts.SetPosToObject,null,0xc93526f86496f,!1,[[4,124],[7,[2,"Target"]]]],[134,cr.behaviors.Pin.prototype.acts.Pin,"Pin",8012249300570223,!1,[[4,124],[3,0]]]]],[0,null,!1,null,746682339186285,[[232,cr.plugins_.Sprite.prototype.cnds.OnCreated,
null,1,!1,!1,!1,0xcc46da0dfe253,!1]],[[232,cr.behaviors.Pin.prototype.acts.Pin,"Pin",9947157074705996,!1,[[4,124],[3,0]]]]],[0,null,!1,null,0x8fe623e6934bd,[[127,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,7612304779189633,!1]],[[127,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,734333531583862,!1,[[4,122],[7,[2,"Title"]]]],[127,cr.behaviors.Pin.prototype.acts.Pin,"Pin",6626436373878049,!1,[[4,122],[3,0]]]]],[0,null,!1,null,8639253897095035,[[126,cr.plugins_.Sprite.prototype.cnds.OnCreated,
null,1,!1,!1,!1,4648969061427337,!1]],[[126,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,7534085917189967,!1,[[4,122],[7,[2,"Placeholder"]]]],[126,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0x9b367b249a85f,!1,[[4,122],[3,0]]],[126,cr.plugins_.Sprite.prototype.acts.Spawn,null,9626454558323032,!1,[[4,217],[5,[2,"HUD"]],[7,[2,"PlayerCashIcon"]]]],[126,cr.plugins_.Sprite.prototype.acts.Spawn,null,524644530623394,!1,[[4,218],[5,[2,"HUD"]],[7,[2,"PlayerCash"]]]],[218,cr.plugins_.Text.prototype.acts.SetText,
null,7151173850693119,!1,[[7,[23,"PlayerCash"]]]],[126,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x6423a27965607,!1,[[4,217],[5,[2,"HUD"]],[7,[2,"PriceIcon"]]]]]],[0,null,!1,null,8998478953460024,[[135,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x7013068d86c1,!1]],[[135,cr.plugins_.Text.prototype.acts.SetPosToObject,null,5157740073681493,!1,[[4,126],[7,[2,"PlayerCashLabel"]]]]]],[0,null,!1,null,7835114402964351,[[218,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,6271197244711119,
!1]],[[218,cr.plugins_.Text.prototype.acts.SetFontFace,null,5619628221405375,!1,[[1,[2,"Arial"]],[3,1]]],[218,cr.plugins_.Text.prototype.acts.SetFontSize,null,0xba009ade8058f,!1,[[0,[0,24]]]],[218,cr.plugins_.Text.prototype.acts.SetFontColor,null,8686526477787583,!1,[[0,[19,cr.system_object.prototype.exps.rgb,[[0,51],[0,153],[0,153]]]]]]]],[0,null,!1,null,6503561013204435,[[243,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,9489413448129546,!1]],[[243,cr.behaviors.Pin.prototype.acts.Pin,
"Pin",603019797530338,!1,[[4,126],[3,0]]],[243,cr.plugins_.Text.prototype.acts.ZMoveToObject,null,6442629025573162,!1,[[3,0],[4,126]]]]],[0,null,!1,null,5519873756229246,[[244,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,8575879520289462,!1]],[[244,cr.behaviors.Pin.prototype.acts.Pin,"Pin",6031178344510747,!1,[[4,126],[3,0]]],[244,cr.plugins_.Sprite.prototype.acts.ZMoveToObject,null,8900300123148819,!1,[[3,0],[4,126]]]]],[0,null,!1,null,6960202823794403,[[133,cr.plugins_.Sprite.prototype.cnds.OnCreated,
null,1,!1,!1,!1,5050736576524015,!1]],[[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x61f0a0580cf8e,!1,[[4,126],[7,[2,"Slider"]]]],[133,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0x5da32642fdf23,!1,[[4,126],[3,0]]],[133,cr.plugins_.Sprite.prototype.acts.ZMoveToObject,null,9204437877606784,!1,[[3,0],[4,126]]]]],[0,null,!1,null,5004957475994335,[[128,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,7716852806805533,!1]],[[128,cr.plugins_.Sprite.prototype.acts.SetPosToObject,
null,5110424430286294,!1,[[4,126],[7,[2,"BtnPrevious"]]]],[128,cr.behaviors.Pin.prototype.acts.Pin,"Pin",9816668924859334,!1,[[4,126],[3,0]]]]],[0,null,!1,null,0xe4f81d9bd0eb6,[[129,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,6810064331593723,!1]],[[129,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5982780977805723,!1,[[4,126],[7,[2,"BtnNext"]]]],[129,cr.behaviors.Pin.prototype.acts.Pin,"Pin",821715637344595,!1,[[4,126],[3,0]]]]],[0,null,!1,null,0x65624070afb9c,[[131,cr.plugins_.Text.prototype.cnds.OnCreated,
null,1,!1,!1,!1,0xef0d8c5eec746,!1]],[[131,cr.plugins_.Text.prototype.acts.SetPosToObject,null,444231827784271,!1,[[4,126],[7,[2,"Description"]]]],[131,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0xca45f16c3a00f,!1,[[4,126],[3,0]]],[131,cr.plugins_.Text.prototype.acts.ZMoveToObject,null,0x9e0e1ac79eef2,!1,[[3,0],[4,126]]]]],[0,null,!1,null,0xb421c04430679,[[132,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x5857a5fc5fe50,!1]],[[132,cr.plugins_.Text.prototype.acts.SetPosToObject,null,6833372152736718,
!1,[[4,126],[7,[2,"Price"]]]],[132,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0x6f704ad7dafb5,!1,[[4,126],[3,0]]],[132,cr.plugins_.Text.prototype.acts.ZMoveToObject,null,7907027336083368,!1,[[3,0],[4,126]]]]],[0,null,!1,null,0xe97adc747a235,[[130,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x7ec948fe265d7,!1]],[[130,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xa15f9ac0f74ad,!1,[[4,126],[7,[2,"BtnBuy"]]]],[130,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0xceb866fa8dabc,!1,[[4,
126],[3,0]]]]],[0,null,!1,null,0xb7b1a55caa9aa,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,7406098072471761,!1,[[1,[2,"ShowBoosterInfo"]]]]],[[133,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,66534520040404,!1,[[0,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]]],[[1,"currentBooster",1,"",!1,!1,6921553900444727,!1],[0,null,!1,null,5118671510902365,[],[[-1,cr.system_object.prototype.acts.SetVar,null,7194860560844052,!1,[[11,"currentBooster"],[7,
[19,cr.system_object.prototype.exps.tokenat,[[21,133,!0,null,0],[20,133,cr.plugins_.Sprite.prototype.exps.AnimationFrame,!1,null],[2,"|"]]]]]],[133,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5786227795905176,!1,[[10,1],[7,[23,"currentBooster"]]]],[131,cr.plugins_.Text.prototype.acts.SetText,null,0xc4d6abfba959,!1,[[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[10,[10,[2,"boosters."],[23,"currentBooster"]],[2,".description"]]]]]]],[132,cr.plugins_.Text.prototype.acts.SetText,
null,4567558983802319,!1,[[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[10,[10,[2,"boosters."],[23,"currentBooster"]],[2,".price_txu"]]]]]]]]],[0,null,!1,null,0x65cc500b1288c,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x48dc1378bf5c4,!1,[[11,"PlayerCash"],[8,2],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[10,[10,[2,"boosters."],[23,"currentBooster"]],[2,".price_txu"]]]]]]]],[[132,cr.plugins_.Text.prototype.acts.SetFontColor,
null,545067589475177,!1,[[0,[19,cr.system_object.prototype.exps.rgb,[[0,200],[0,200],[0,200]]]]]]]],[0,null,!1,null,0x8801c64bc0aff,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0x5b8518edf7cd1,!1]],[[132,cr.plugins_.Text.prototype.acts.SetFontColor,null,6189650141489917,!1,[[0,[19,cr.system_object.prototype.exps.rgb,[[0,255],[0,255],[0,255]]]]]]]]]],[0,null,!1,null,0x9dd1440045d39,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0xe582afa366039,!1]],[],[[0,null,!1,null,
0x63197aab2fddb,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,6092563909341081,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,207,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xa69f55df309b,!1,[[6,"SelectLevel"]]]]],[0,null,!1,null,9939167620386894,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,8643952543479495,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,
!1,null,[[2,"IsTouched"],[20,37,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9899540932560214,!1,[[6,"Game"]]]]],[0,null,!1,null,0x71818aaaee7e8,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,5515650081418204,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,129,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,
null,0x8764af3cbc542,!1,[[1,[2,"ShowBoosterInfo"]],[13,[7,[18,[14,[20,133,cr.plugins_.Sprite.prototype.exps.AnimationFrame,!1,null],[5,[20,133,cr.plugins_.Sprite.prototype.exps.AnimationFrameCount,!1,null],[0,1]]],[4,[20,133,cr.plugins_.Sprite.prototype.exps.AnimationFrame,!1,null],[0,1]],[0,0]]]]]]]],[0,null,!1,null,5245530149785283,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,6662967343215677,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,128,
cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6915729744519085,!1,[[1,[2,"ShowBoosterInfo"]],[13,[7,[18,[16,[20,133,cr.plugins_.Sprite.prototype.exps.AnimationFrame,!1,null],[0,0]],[5,[20,133,cr.plugins_.Sprite.prototype.exps.AnimationFrame,!1,null],[0,1]],[5,[20,133,cr.plugins_.Sprite.prototype.exps.AnimationFrameCount,!1,null],[0,1]]]]]]]]],[0,null,!1,null,764895006703416,[[-1,cr.system_object.prototype.cnds.Compare,
null,0,!1,!1,!1,8923478674573418,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,130,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,8035681784187046,!1,[[1,[2,"buyBooster"]],[13,[7,[21,133,!0,null,1]],[7,[20,141,cr.plugins_.Dictionary.prototype.exps.Get,!1,null,[[21,133,!0,null,1]]]]]]]]]]]]],["GameEventBooster",[[2,"BoosterEvent",!1],[0,null,!1,null,6802490118679609,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,0x92a57d4b4fb15,!1]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,5586547276877336,!1,[[1,[2,"Main-Booster"]],[3,1]]]]],[0,null,!1,null,0xfabc4b32bc9b9,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,6131299885842892,!1,[[1,[2,"setDoubleCashTimer"]]]]],[],[[0,null,!1,null,7386939601885687,[[208,cr.plugins_.Function.prototype.cnds.CompareParam,null,0,!1,!1,!1,9147060432720060,!1,[[0,[0,0]],[8,0],[7,[2,"start"]]]]],[[140,cr.behaviors.Timer.prototype.acts.StartTimer,
"Timer",7949554980671547,!1,[[0,[0,10]],[3,0],[1,[2,"Active"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xe5b8e01dcf0fd,!1,[[11,"scoreBoost"],[7,[0,2]]]],[140,cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,null,0xf77fcc009539e,!1,[[10,3],[3,1]]]]],[0,null,!1,null,9790096319771660,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,8730329120768732,!1],[208,cr.plugins_.Function.prototype.cnds.CompareParam,null,0,!1,!1,!1,5488301100242063,!1,[[0,[0,0]],[8,0],[7,[2,"pause"]]]]],
[[140,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9470165370080688,!1,[[10,4],[7,[5,[22,140,"Timer",cr.behaviors.Timer.prototype.exps.Duration,!1,null,[[2,"Active"]]],[22,140,"Timer",cr.behaviors.Timer.prototype.exps.TotalTime,!1,null,[[2,"Active"]]]]]]],[140,cr.behaviors.Timer.prototype.acts.StopTimer,"Timer",0x863823382a67f,!1,[[1,[2,"Active"]]]]]],[0,null,!1,null,4924756146553122,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,9534864938705736,!1],[208,cr.plugins_.Function.prototype.cnds.CompareParam,
null,0,!1,!1,!1,0xa899541c2c1c9,!1,[[0,[0,0]],[8,0],[7,[2,"resume"]]]]],[[140,cr.behaviors.Timer.prototype.acts.StartTimer,"Timer",0x3d4f5ab05c2ab,!1,[[0,[21,140,!1,null,4]],[3,0],[1,[2,"Active"]]]],[140,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x553cea6f67b66,!1,[[10,4],[7,[0,0]]]]]]]],[0,null,!1,null,6416810466825242,[[140,cr.behaviors.Timer.prototype.cnds.OnTimer,"Timer",0,!1,!1,!1,0x498e331068942,!1,[[1,[2,"Active"]]]]],[[140,cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,null,
7864061390307302,!1,[[10,3],[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x8c12b98f184b2,!1,[[11,"scoreBoost"],[7,[0,1]]]]]],[0,[!0,"Main-Booster"],!1,null,0xd9e2c121fa0e6,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xd9e2c121fa0e6,!1,[[1,[2,"Main-Booster"]]]]],[],[[0,null,!1,null,5027163717871457,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0xde29a4e67624,!1]],[],[[0,null,!1,null,0xb15ea57e4776b,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,8320815285150268,!1,[[4,232]]]],[],[[0,null,!1,null,5782159441007591,[[142,cr.plugins_.Dictionary.prototype.cnds.CompareValue,null,0,!1,!1,!1,5916402243119977,!1,[[1,[21,232,!0,null,2]],[8,4],[7,[0,0]]]]],[],[[0,null,!1,null,5764916581956125,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0x4628eceffb5f2,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,136,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,
null,4892516572790263,!1,[[1,[2,"SetTime"]],[13,[7,[0,10]],[7,[2,"append"]],[7,[0,0]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,5580476579040256,!1,[[1,[2,"useBooster"]],[13,[7,[21,232,!0,null,2]],[7,[21,232,!0,null,1]]]]]]],[0,null,!1,null,414478079122052,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,7334454429844833,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,140,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,
[0,1]]]],[140,cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,null,0,!1,!0,!1,0x8664e69e3e7c6,!1,[[10,3]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,8392650035590849,!1,[[1,[2,"setDoubleCashTimer"]],[13,[7,[2,"start"]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x84616a775dd9e,!1,[[1,[2,"useBooster"]],[13,[7,[21,232,!0,null,2]],[7,[21,232,!0,null,1]]]]]]],[0,null,!1,null,0xd449a5b4c736,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0x570741453cc0d,
!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,139,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,9294145297370772,!1,[[7,[20,144,cr.plugins_.Sprite.prototype.exps.Count,!1,null]],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6045536309588843,!1,[[4,144],[5,[2,"HUD"]],[0,[20,139,cr.plugins_.Sprite.prototype.exps.ImagePointX,!1,null,[[0,0]]]],[0,[5,[20,
139,cr.plugins_.Sprite.prototype.exps.ImagePointY,!1,null,[[0,0]]],[20,139,cr.plugins_.Sprite.prototype.exps.Height,!1,null]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,2314492652538,!1,[[1,[2,"updateBoosterNumber"]],[13,[7,[21,232,!0,null,2]],[7,[0,0]],[7,[0,1]]]]]]]]]]]]],[0,null,!1,null,0x6eb416da8c7dd,[[144,cr.behaviors.DragnDrop.prototype.cnds.OnDrop,"DragDrop",1,!1,!1,!1,789641837315102,!1]],[],[[0,null,!1,null,0xf610b37461bb6,[[144,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,9089682699681154,!1,[[4,223]]],[223,cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,null,0,!1,!1,!1,9474582332174206,!1,[[10,6]]],[223,cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,null,0,!1,!0,!1,8252471840847358,!1,[[10,3]]]],[[223,cr.behaviors.Timer.prototype.acts.StopTimer,"Timer",0xd88ad7fd2a19c,!1,[[1,[2,"Ordered"]]]],[223,cr.behaviors.Timer.prototype.acts.StopTimer,"Timer",668865040534101,!1,[[1,[2,"Waiting1"]]]],[223,cr.behaviors.Timer.prototype.acts.StopTimer,
"Timer",0x9752090c54207,!1,[[1,[2,"Waiting2"]]]],[223,cr.behaviors.Timer.prototype.acts.StopTimer,"Timer",6988885245076007,!1,[[1,[2,"Waiting3"]]]],[223,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6971001734766501,!1,[[1,[2,"Ordered"]],[3,1]]],[223,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9876254540315834,!1,[[10,4],[7,[0,1]]]],[223,cr.behaviors.Flash.prototype.acts.Flash,"GoodMood",0x4ab1c4a14a725,!1,[[0,[1,0.1]],[0,[1,0.1]],[0,[1,1]]]],[223,cr.behaviors.Timer.prototype.acts.StartTimer,
"Timer",5573552798961159,!1,[[0,[21,223,!1,null,2]],[3,0],[1,[2,"Ordered"]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6719047137557255,!1,[[1,[2,"useBooster"]],[13,[7,[21,139,!0,null,2]],[7,[21,139,!0,null,1]]]]]]],[0,null,!1,null,7600348646351835,[],[[144,cr.plugins_.Sprite.prototype.acts.Destroy,null,5315457145498814,!1],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,4681253864909647,!1,[[1,[2,"updateBoosterNumber"]],[13,[7,[21,139,!0,null,2]],[7,[0,0]],[7,[0,-1]]]]]]]]]]],
[0,null,!1,null,0xc975edfe65f47,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,7225625306950517,!1,[[1,[2,"EndGame"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,486187043726999,!1,[[1,[2,"updateBoosterNumber"]],[13,[7,[21,139,!0,null,2]],[7,[0,0]],[7,[3,[20,144,cr.plugins_.Sprite.prototype.exps.Count,!1,null]]]]]],[144,cr.plugins_.Sprite.prototype.acts.Destroy,null,9062720505301426,!1]]],[0,null,!1,null,0xb06e16a31bd07,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,
null,2,!1,!1,!1,4992900222554377,!1,[[1,[2,"deactivateMainGroups"]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,5187948962793251,!1,[[1,[2,"Main-Booster"]],[3,0]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,5453562840407539,!1,[[1,[2,"setDoubleCashTimer"]],[13,[7,[2,"pause"]]]]],[144,cr.behaviors.DragnDrop.prototype.acts.SetEnabled,"DragDrop",0xd0efe5399669f,!1,[[3,0]]]]],[0,null,!1,null,0xfa9c96ce3e6bd,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,
!1,!1,0x7d35a312411bf,!1,[[1,[2,"activateMainGroups"]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x6b0519ab5a76f,!1,[[1,[2,"Main-Booster"]],[3,1]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,7707200220067655,!1,[[1,[2,"setDoubleCashTimer"]],[13,[7,[2,"resume"]]]]],[144,cr.behaviors.DragnDrop.prototype.acts.SetEnabled,"DragDrop",0xfdb5abc77d7dc,!1,[[3,1]]]]]]],["HowToPlayEvent",[[2,"GlobalEvent",!1],[0,null,!1,null,0x406f6b2de9b60,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,7147214243679526,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x7f7b93d268076,!1,[[1,[2,"showAd"]],[13]]]]],[0,null,!1,null,649133214815211,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0xa71fa23e446ed,!1]],[],[[0,null,!1,null,9998691943091766,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0x655a45a614207,!1,[[4,207]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9045875590606436,!1,[[6,"MainMenu"]]]]],[0,null,
!1,null,4873321178219923,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,9544346634147144,!1,[[4,153]]]],[[151,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6317014039923368,!1,[[0,[5,[20,151,cr.plugins_.Sprite.prototype.exps.AnimationFrame,!1,null],[0,1]]]]]]],[0,null,!1,null,574709157027784,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xf2d5e0ca1e1a2,!1,[[4,152]]]],[[151,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6684405233977743,
!1,[[0,[4,[20,151,cr.plugins_.Sprite.prototype.exps.AnimationFrame,!1,null],[0,1]]]]]]]]]]],["Dialog",[[1,"CenterX",0,0,!1,!1,5133580867369045,!1],[1,"CenterY",0,0,!1,!1,0x41ecc9d5693bf,!1],[0,null,!1,null,8840653937171683,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5759049376145022,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,0x5cf3c471247d8,!1,[[11,"CenterX"],[7,[19,cr.system_object.prototype.exps.canvastolayerx,[[2,"Dialog"],[7,[19,cr.system_object.prototype.exps.windowwidth],
[0,2]],[7,[19,cr.system_object.prototype.exps.windowheight],[0,2]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6502121775913366,!1,[[11,"CenterY"],[7,[19,cr.system_object.prototype.exps.canvastolayery,[[2,"Dialog"],[7,[19,cr.system_object.prototype.exps.windowwidth],[0,2]],[7,[19,cr.system_object.prototype.exps.windowheight],[0,2]]]]]]]]],[0,null,!1,null,4897707599668705,[[156,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x8e525260c4320,!1]],[[157,cr.plugins_.Text.prototype.acts.SetPosToObject,
null,6073198167184773,!1,[[4,156],[7,[2,"Text"]]]],[158,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9584184166635712,!1,[[4,156],[7,[2,"Button1"]]]],[159,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,7788999157214687,!1,[[4,156],[7,[2,"Button2"]]]],[157,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0x7d7fc7652e1b5,!1,[[4,156],[3,0]]],[158,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0xc318479e972e5,!1,[[4,156],[3,0]]],[159,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0xc9445f78e09a1,!1,[[4,
156],[3,0]]]]],[0,null,!1,null,0x9e0353425599e,[[154,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,7803476184654906,!1]],[[155,cr.plugins_.Text.prototype.acts.SetPosToObject,null,0x866a082d9e2dc,!1,[[4,154],[7,[2,"Text"]]]],[160,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x74a18b80b0b44,!1,[[4,154],[7,[2,"Button"]]]],[155,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0xc87bd80077d07,!1,[[4,154],[3,0]]],[160,cr.behaviors.Pin.prototype.acts.Pin,"Pin",4728867162448181,!1,[[4,154],
[3,0]]]]],[0,null,!1,null,6912801653148632,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,7220011086719864,!1]],[],[[0,null,!1,null,0x741824cd0f377,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,4662892261896223,!1,[[4,160]]]],[[154,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,403134548488981,!1,[[10,2],[7,[2,"ok"]]]],[154,cr.plugins_.Sprite.prototype.acts.Destroy,null,9790872567150236,!1]]],[0,null,!1,null,0xab3fef15c2a7d,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,5727759222435112,!1,[[4,159]]]],[[156,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xc738ca732c290,!1,[[10,2],[7,[2,"no"]]]],[156,cr.plugins_.Sprite.prototype.acts.Destroy,null,8059300524603963,!1]]],[0,null,!1,null,8036363883081265,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,7394258866292558,!1,[[4,158]]]],[[156,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5069448485098645,!1,[[10,2],[7,[2,"yes"]]]],[156,cr.plugins_.Sprite.prototype.acts.Destroy,
null,5256813455511955,!1]]]]],[0,null,!1,null,7295506860445846,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,7580804436735428,!1,[[1,[2,"createInfoDialog"]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6603410230025446,!1,[[4,154],[5,[2,"Dialog"]],[0,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,2]]]],[0,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,3]]]]]],[154,cr.plugins_.Sprite.prototype.acts.SetAnim,null,21288624757615,!1,[[1,
[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[3,1]]],[155,cr.plugins_.Text.prototype.acts.SetText,null,0xf2679843e3083,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,1]]]]]],[154,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9839884132484008,!1,[[10,1],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,4]]]]]]]],[0,null,!1,null,8777864276621318,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,5269832556736729,!1,
[[1,[2,"createConfirmDialog"]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,946697381835237,!1,[[4,156],[5,[2,"Dialog"]],[0,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,2]]]],[0,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,3]]]]]],[156,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xa74861db7803f,!1,[[1,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[3,1]]],[157,cr.plugins_.Text.prototype.acts.SetText,null,5365528099710068,!1,[[7,
[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,1]]]]]],[156,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5613376628784461,!1,[[10,3],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,4]]]]]],[156,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9483478104097108,!1,[[10,1],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,5]]]]]]]],[0,null,!1,null,0xf4e75e608fe7,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0xcdd786f3b7f75,
!1,[[1,[2,"deleteInfoDialog"]]]]],[],[[0,null,!1,null,9524419301585800,[[-1,cr.system_object.prototype.cnds.PickByEvaluate,null,0,!1,!1,!1,6850805439059239,!1,[[4,154],[0,[12,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]],[21,154,!0,null,1]]]]]],[[154,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xf81e282ce5c0,!1,[[10,2],[7,[2,"deleted"]]]],[154,cr.plugins_.Sprite.prototype.acts.Destroy,null,399766564123803,!1]]]]]]],["GameEventCash",[[0,null,!1,null,8451398505615834,
[[68,cr.plugins_.Spriter.prototype.cnds.readyForSetup,null,1,!1,!1,!1,8750244558069867,!1]],[[68,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,7415918360833717,!1,[[4,46],[1,[2,"0"]]]],[68,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,7134055349303506,!1,[[4,47],[1,[2,"1_000"]]]],[68,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,296293478913782,!1,[[4,48],[1,[2,"1"]]]],[68,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,7745584004973904,
!1,[[4,49],[1,[2,"2"]]]],[68,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0xc21e2562de34a,!1,[[4,50],[1,[2,"3"]]]],[68,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,9102315675118220,!1,[[4,51],[1,[2,"4"]]]],[68,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0xfdba7a87c69df,!1,[[4,52],[1,[2,"5"]]]],[68,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,8337624133379818,!1,[[4,53],[1,[2,"6"]]]],[68,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,
null,0xee26d79781336,!1,[[4,54],[1,[2,"7"]]]],[68,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0xf4f95cb839ec5,!1,[[4,55],[1,[2,"8"]]]],[68,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,9271765462839638,!1,[[4,56],[1,[2,"10"]]]]]],[0,null,!1,null,777309203037444,[[68,cr.plugins_.Spriter.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x993cda55bb233,!1]],[[68,cr.plugins_.Spriter.prototype.acts.setPlaybackSpeedRatio,null,0x60d460dedb3c4,!1,[[0,[1,0.2]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,
null,5102835598104764,!1,[[1,[2,"playSound"]],[13,[7,[2,"coin2"]],[7,[0,10]]]]]]],[0,null,!1,null,0x9c59dc1ea17d2,[[68,cr.plugins_.Spriter.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,5658843643997815,!1]],[[68,cr.plugins_.Spriter.prototype.acts.Destroy,null,0x80ba2f09de3a2,!1]]],[0,null,!1,null,0xd83ed1c4b03a6,[[69,cr.plugins_.Spritefont2.prototype.cnds.OnCreated,null,1,!1,!1,!1,7307763837047348,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,0x45f7b890fb853,!1,[[0,[1,1]]]],[69,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
"Bullet",0x97a09259fe1ec,!1,[[0,[19,cr.system_object.prototype.exps.angle,[[20,69,cr.plugins_.Spritefont2.prototype.exps.X,!1,null],[20,69,cr.plugins_.Spritefont2.prototype.exps.Y,!1,null],[4,[20,31,cr.plugins_.Sprite.prototype.exps.BBoxLeft,!1,null],[0,50]],[20,31,cr.plugins_.Sprite.prototype.exps.BBoxBottom,!1,null]]]]]],[69,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x609d9884bc8f9,!1,[[0,[7,[19,cr.system_object.prototype.exps.distance,[[20,69,cr.plugins_.Spritefont2.prototype.exps.X,
!1,null],[20,69,cr.plugins_.Spritefont2.prototype.exps.Y,!1,null],[4,[20,31,cr.plugins_.Sprite.prototype.exps.BBoxLeft,!1,null],[0,50]],[20,31,cr.plugins_.Sprite.prototype.exps.BBoxBottom,!1,null]]],[1,0.5]]]]],[69,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",4719613226371236,!1,[[3,1]]]]],[0,null,!1,null,9733572928205748,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,635764337060572,!1,[[4,69]]]],[[69,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xdaab591e69a24,
!1,[[3,0]]],[69,cr.behaviors.Fade.prototype.acts.StartFade,"Fade",0x8090237679ac5,!1]]]]],["LoginEvent",[[2,"GlobalEvent",!1],[2,"InitializeEvent",!1],[0,null,!1,null,0x5aa1f03931e4e,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,6824274301821915,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xab0214200ac56,!1,[[11,"OnlineMode"],[7,[0,-1]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,9497618973901376,!1,[[1,[2,"OnlineModeUpdated"]],[13]]],[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.acts.LoadInTheWebView,
null,9939213322236318,!1,[[12,"account.html"]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,7548049449994814,!1,[[1,[2,"Online-Connect"]],[3,0]]]],[[0,null,!0,null,352491662908684,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x569937beff02d,!1,[[11,"DEV_MODE"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6199767201788757,!1,[[11,"SHOW_SAFE_ZONE"],[8,0],[7,[0,0]]]]],[[172,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xabf278afc608d,
!1]]]]],[0,null,!1,null,7911478571707784,[[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.cnds.OnLoadInTheWebViewFailed,null,1,!1,!1,!1,9302773188247184,!1]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0xcc834c19286e8,!1,[[3,2],[7,[2,"Can't load web view"]]]]]],[0,null,!1,null,0xe7bad28a8a90,[[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.cnds.OnLoadInTheWebViewSucceed,null,1,!1,!1,!1,0xb83b17179b4c2,!1]],[[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.acts.Forward,null,7474392828385068,
!1,[[1,[10,[10,[10,[2,"AC.setUrl('login', '"],[23,"Host"]],[23,"API_MOBILE_LOGIN"]],[2,"');"]]]]],[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.acts.Forward,null,7754454318240704,!1,[[1,[10,[10,[10,[2,"AC.setUrl('register', '"],[23,"Host"]],[23,"API_MOBILE_REGISTER"]],[2,"');"]]]]],[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.acts.ShowTheWebView,null,6111555850193777,!1]]],[0,null,!1,null,9304113144259188,[[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.cnds.OnEvent,null,1,!1,!1,!1,0xe0920fb773d25,
!1,[[1,[2,"playOffline"]]]]],[[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.acts.Forward,null,4947100860063598,!1,[[1,[2,"AC.showLoading();"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9107773905300208,!1,[[11,"OnlineMode"],[7,[0,0]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,9779684357207986,!1,[[1,[2,"OnlineModeUpdated"]],[13]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x41cddf1cd4043,!1,[[1,[2,"initializeGame"]],[13]]]]],[0,null,!1,null,7887240490318465,
[[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.cnds.OnEvent,null,1,!1,!1,!1,6495767365223928,!1,[[1,[2,"loginSucceed"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5821884525252634,!1,[[11,"OnlineMode"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,7430359782903426,!1,[[1,[2,"Online-Connect"]],[3,1]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xc169cb9182c39,!1,[[1,[2,"OnlineModeUpdated"]],[13]]],[205,cr.plugins_.GameConfig.prototype.acts.SetPlayer_id,
null,0xcabd55603dd0a,!1,[[1,[20,214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.exps.GetLastEventData,!1,null,[[2,"_id"]]]]]],[205,cr.plugins_.GameConfig.prototype.acts.SetPlayerUuid,null,9020206266927104,!1,[[1,[20,214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.exps.GetLastEventData,!1,null,[[2,"uuid"]]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6132795021096355,!1,[[1,[2,"connectServer"]],[13]]]]],[0,[!1,"Online-Connect"],!1,null,0xaced00a3dbbd8,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,0xaced00a3dbbd8,!1,[[1,[2,"Online-Connect"]]]]],[],[[0,null,!1,null,9621433462157716,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,6947974228256484,!1,[[1,[2,"connectServer"]]]]],[],[[0,null,!1,null,9082638933283844,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8887029937100134,!1,[[11,"DEV_MODE"],[8,0],[7,[0,1]]]]],[[205,cr.plugins_.GameConfig.prototype.acts.GetAppEnvironment,null,0x465527b629414,!1,[[1,[2,""]]]]]],[0,null,!1,null,0xc24afafbfa2d,
[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,545255844722855,!1]],[[205,cr.plugins_.GameConfig.prototype.acts.GetAppEnvironment,null,5158447488004179,!1,[[1,[10,[23,"Host"],[23,"API_GET_ENVIRONMENT"]]]]]]]]],[0,null,!1,null,0xc7fb60c0853dd,[[205,cr.plugins_.GameConfig.prototype.cnds.OnGetEnvironmentFailed,null,1,!1,!1,!1,0xd5ae4f2dbf2d9,!1]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0x6cb2ed4b8a8d3,!1,[[3,0],[7,[2,"Get environment failed"]]]],[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.acts.Forward,
null,0xb39a610c45fcd,!1,[[1,[10,[10,[2,"AC.hideLoading();alert('"],[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"messages.connectFailed"]]]],[2,"');"]]]]]]],[0,null,!1,null,7237430965282507,[[205,cr.plugins_.GameConfig.prototype.cnds.OnGetEnvironmentSucceed,null,1,!1,!1,!1,0xa5231ef38f9c1,!1]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,5271476913620639,!1,[[3,0],[7,[2,"Get environment succeed"]]]],[205,cr.plugins_.GameConfig.prototype.acts.ConnectSocketIO,
null,5411203555065385,!1,[[1,[20,214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.exps.GetLastEventData,!1,null,[[2,"sessionID"]]]]]]]],[0,null,!1,null,0x8cfbdcb157e6d,[[205,cr.plugins_.GameConfig.prototype.cnds.OnConnectSocketIOFailed,null,1,!1,!1,!1,0xf04082561787,!1]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0xd20224e5e8976,!1,[[3,2],[7,[2,"Connect socket IO failed"]]]],[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.acts.Forward,null,0x47ac57361205f,!1,[[1,[10,[10,[2,"AC.hideLoading();alert('"],
[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"messages.connectFailed"]]]],[2,"');"]]]]]]],[0,null,!1,null,6239159891953718,[[205,cr.plugins_.GameConfig.prototype.cnds.OnConnectSocketIOSucceed,null,1,!1,!1,!1,0x57aaa669ab5d7,!1]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,8565376144726748,!1,[[3,0],[7,[2,"Connect socket IO succeed"]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,9677734518077804,!1,[[1,[2,"initializeGame"]],[13]]]]],[0,null,
!1,null,0x978753d4505f9,[[205,cr.plugins_.GameConfig.prototype.cnds.OnSocketError,null,1,!1,!1,!1,0xabadecaeb71a6,!1]],[],[[1,"error",1,"",!1,!1,0x98d2c66728e66,!1],[1,"localMessage",1,"",!1,!1,6535540406218994,!1],[0,null,!1,null,8774891708402281,[],[[-1,cr.system_object.prototype.acts.SetVar,null,0x853fe7109afb4,!1,[[11,"error"],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetSocketErrorMessage,!0,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8834372885350671,!1,[[11,"localMessage"],
[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[10,[2,"systemErrors."],[23,"error"]]]]]]],[214,cr.plugins_.CocoonJSAppForCocoonJS.prototype.acts.Forward,null,8642698192069769,!1,[[1,[10,[10,[2,"AC.hideLoading();alert('"],[18,[13,[23,"localMessage"],[2,"0"]],[23,"localMessage"],[23,"error"]]],[2,"');"]]]]]]]]]]],[0,null,!1,null,0xd0874db551b99,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,7339537423039557,!1,[[1,[2,"initializeGameDone"]]]]],[[214,
cr.plugins_.CocoonJSAppForCocoonJS.prototype.acts.HideTheWebView,null,0x6c526ad9a8e43,!1]]]]],["SoundEvent",[[0,null,!1,null,6927194474183226,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,9392302833309756,!1,[[1,[2,"playSound"]]]]],[],[[0,null,!1,null,0xe3a38cf38a3c5,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6971111950132807,!1,[[11,"EnableSound"],[8,0],[7,[0,1]]]],[210,cr.plugins_.Audio.prototype.cnds.IsTagPlaying,null,0,!1,!0,!1,9724360856337140,!1,[[1,
[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]]],[[210,cr.plugins_.Audio.prototype.acts.PlayByName,null,8984045518957625,!1,[[3,0],[1,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[3,0],[0,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,1]]]],[1,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]]]]]],[0,null,!1,null,0xb0608975b3b4f,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,5405943981888407,!1,[[1,
[2,"setEnableMusic"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,339773650493962,!1,[[11,"EnableMusic"],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]],[216,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,7181031029584166,!1,[[1,[2,"si.enableMusic"]],[7,[23,"EnableMusic"]]]]],[[0,null,!1,null,0x57ef80af485f9,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6791307850891833,!1,[[11,"EnableMusic"],[8,0],[7,[0,1]]]]],[],[[0,null,!1,null,0xf6a64f18cb5b2,
[[210,cr.plugins_.Audio.prototype.cnds.IsTagPlaying,null,0,!1,!0,!1,0x3adf9af3c55f6,!1,[[1,[2,"theme-song"]]]]],[[210,cr.plugins_.Audio.prototype.acts.Play,null,0x78649ab21c846,!1,[[2,["theme-song",!0]],[3,1],[0,[0,0]],[1,[2,"theme-song"]]]]]]]],[0,null,!1,null,0x88a35a817046c,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0xdd757ff41ba6d,!1]],[[210,cr.plugins_.Audio.prototype.acts.Stop,null,5342547299906884,!1,[[1,[2,"theme-song"]]]]]]]],[0,null,!1,null,9254948720429316,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,
null,2,!1,!1,!1,6760395919216179,!1,[[1,[2,"setEnableSound"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0x68b14a9e783bf,!1,[[11,"EnableSound"],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]],[216,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xe9d1874aeba6f,!1,[[1,[2,"si.enableSound"]],[7,[23,"EnableSound"]]]]]],[0,null,!1,null,0x94392a99a05f6,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0xabfc4438e94fa,!1]],[],[[0,null,!1,null,7480580434571765,
[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,952564789485099,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,176,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xd74f0e2d3c0d9,!1,[[4,173],[5,[2,"Dialog"]],[0,[19,cr.system_object.prototype.exps.canvastolayerx,[[2,"Dialog"],[7,[19,cr.system_object.prototype.exps.windowwidth],[0,2]],[7,[19,cr.system_object.prototype.exps.windowheight],
[0,2]]]]],[0,[19,cr.system_object.prototype.exps.canvastolayery,[[2,"Dialog"],[7,[19,cr.system_object.prototype.exps.windowwidth],[0,2]],[7,[19,cr.system_object.prototype.exps.windowheight],[0,2]]]]]]],[175,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x3cb9b907a1a83,!1,[[4,173],[7,[2,"Music"]]]],[174,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,7667777575088496,!1,[[4,173],[7,[2,"Sound"]]]],[177,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9106574930865412,!1,[[4,173],
[7,[2,"Close"]]]]],[[0,null,!1,null,0x59ffd19c0613a,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5893296488494716,!1,[[11,"EnableMusic"],[8,0],[7,[0,0]]]]],[[175,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xa2e52d7e6f786,!1,[[1,[2,"Unchecked"]],[3,1]]]]],[0,null,!1,null,0xc9bac58fca8c7,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5158579182125043,!1,[[11,"EnableSound"],[8,0],[7,[0,0]]]]],[[174,cr.plugins_.Sprite.prototype.acts.SetAnim,null,4654531546825024,
!1,[[1,[2,"Unchecked"]],[3,1]]]]]]],[0,null,!1,null,0xdf369b568b89d,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,5004878914966811,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,177,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[173,cr.plugins_.Sprite.prototype.acts.Destroy,null,4987957142965729,!1]]],[0,null,!1,null,0x6629cf43fdd2b,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xb53b6266e660a,!1,[[7,[20,208,
cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,175,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[],[[0,null,!1,null,5627144948123312,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8470329988726225,!1,[[11,"EnableMusic"],[8,0],[7,[0,1]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,8729533188190536,!1,[[1,[2,"setEnableMusic"]],[13,[7,[0,0]]]]],[175,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8836946701892205,!1,[[1,
[2,"Unchecked"]],[3,1]]]]],[0,null,!1,null,4695526699703234,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,4852861940263851,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,7506096901521739,!1,[[1,[2,"setEnableMusic"]],[13,[7,[0,1]]]]],[175,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6722768933643234,!1,[[1,[2,"Checked"]],[3,1]]]]]]],[0,null,!1,null,0x542e8f228ee57,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,8574967045640963,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,
!1,null,[[2,"IsTouched"],[20,174,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[],[[0,null,!1,null,0xc89f479a54996,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x5682707616cb0,!1,[[11,"EnableSound"],[8,0],[7,[0,1]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x621424f5450f3,!1,[[1,[2,"setEnableSound"]],[13,[7,[0,0]]]]],[174,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6059479680499142,!1,[[1,[2,"Unchecked"]],[3,1]]]]],[0,null,!1,null,
8313994736813138,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,9414821514579016,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,299255440211692,!1,[[1,[2,"setEnableSound"]],[13,[7,[0,1]]]]],[174,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x6470d9eec6b60,!1,[[1,[2,"Checked"]],[3,1]]]]]]]]]]],["LocalInfoEvent",[[2,"GlobalEvent",!1],[2,"AchievementEvent",!1],[0,null,!1,null,377410538528152,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9660233639171752,
!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xce15d9e48d9d2,!1,[[1,[2,"showAd"]],[13]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xfa4c860b043d6,!1,[[11,"MessageHighscore"],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,!1,null,[[2,"Common.Game.HIGH_SCORE"]]]]]],[205,cr.plugins_.GameConfig.prototype.acts.Send,null,9072255310460736,!1,[[1,[23,"MessageHighscore"]],[7,[2,""]]]]],[[1,"totalScore",0,0,!1,!1,0x45658b6016118,!1],[0,null,!1,null,7142549810073316,
[[209,cr.plugins_.Arr.prototype.cnds.ArrForEach,null,0,!0,!1,!1,9737951215024228,!1,[[3,2]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0xb232015a35d1,!1,[[11,"totalScore"],[7,[20,209,cr.plugins_.Arr.prototype.exps.CurValue,!1,null]]]]]],[0,null,!1,null,0xcfa2b0a8fe485,[],[[179,cr.plugins_.Text.prototype.acts.SetText,null,0xd7dfac31b8d6d,!1,[[7,[23,"totalScore"]]]]]],[0,null,!1,null,7679276200212857,[],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x88df0b34eb6b4,!1,[[1,[2,"showAchievements"]],
[13,[7,[20,112,cr.plugins_.Sprite.prototype.exps.UID,!1,null]],[7,[2,"Achievement"]]]]]]]]],[0,null,!1,null,5656026483542033,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0xf4e04c8b12dcf,!1]],[],[[0,null,!1,null,0x68fdab3ef9bb9,[[213,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,6717774883182304,!1,[[4,207]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,7262126698604865,!1,[[6,"MainMenu"]]]]]]]]],["IntroEvent",[[2,"GlobalEvent",!1],[0,null,!1,null,
293428465651762,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7354677480387759,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,593469174391659,!1,[[1,[2,"showAd"]],[13]]]]],[0,null,!1,null,0xf395cbb388eb5,[[13,cr.plugins_.Spriter.prototype.cnds.readyForSetup,null,1,!1,!1,!1,0x6a10bef6f524c,!1]],[[13,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0xe45d87945e096,!1,[[4,0],[1,[2,"rl1"]]]],[13,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,
null,0xfc57505325f36,!1,[[4,1],[1,[2,"rl4"]]]],[13,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0x5d8b2351db06e,!1,[[4,2],[1,[2,"rl3"]]]],[13,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,6903196704761736,!1,[[4,3],[1,[2,"rl2"]]]],[13,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,5509522415932413,!1,[[4,4],[1,[2,"ll3"]]]],[13,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,9871695827074812,!1,[[4,5],[1,[2,"ll2"]]]],[13,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,
null,7218903438046199,!1,[[4,6],[1,[2,"ll1"]]]],[13,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,7883852254743518,!1,[[4,7],[1,[2,"umbrella"]]]],[13,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,8681810781110255,!1,[[4,8],[1,[2,"text"]]]],[13,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,5243501993880198,!1,[[4,9],[1,[2,"cherry"]]]]]],[0,null,!1,null,8584186549296409,[[13,cr.plugins_.Spriter.prototype.cnds.OnCreated,null,1,!1,!1,!1,7621206140297044,
!1]],[[13,cr.plugins_.Spriter.prototype.acts.setPlaybackSpeedRatio,null,4932358720843679,!1,[[0,[1,0.2]]]]]],[0,null,!1,null,0x50fb5076d6f10,[[13,cr.plugins_.Spriter.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,9004394024723388,!1]],[],[[0,null,!1,null,0xba1d64735ef1,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,7126192163483153,!1,[[7,[20,246,cr.plugins_.Sprite.prototype.exps.Count,!1,null]],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,5617507647055255,
!1,[[6,"MainMenu"]]]]]]],[0,null,!1,null,8100547244630929,[[205,cr.plugins_.GameConfig.prototype.cnds.OnSocketReconnect,null,1,!1,!1,!1,0x98d85c7da4fbe,!1],[13,cr.plugins_.Spriter.prototype.cnds.CompareCurrentTime,null,0,!1,!1,!1,0xc85e4d91f5c27,!1,[[8,5],[0,[0,1]],[3,1]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6216399891305544,!1,[[6,"MainMenu"]]]]]]],["BoosterEvent",[[0,null,!1,null,9987714131011826,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9053691208582906,
!1]],[],[[0,null,!1,null,5562353083923484,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x85f2c355a7b6,!1,[[11,"OnlineMode"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xbc14b01ae8259,!1,[[1,[2,"Online-Booster"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,5000668145856484,!1,[[1,[2,"Offline-Booster"]],[3,0]]]]],[0,null,!1,null,4962018364571259,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,5229230101845023,!1]],[[-1,
cr.system_object.prototype.acts.SetGroupActive,null,0x81c20935249b0,!1,[[1,[2,"Offline-Booster"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xc3dcd9eb7dcda,!1,[[1,[2,"Online-Booster"]],[3,0]]]]]]],[0,null,!1,null,0xd2c2c1b6243b4,[[232,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,8627357791537765,!1]],[[232,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,8579283793296445,!1,[[10,1],[7,[20,141,cr.plugins_.Dictionary.prototype.exps.Get,!1,null,[[21,232,!0,null,
2]]]]]],[232,cr.plugins_.Sprite.prototype.acts.Spawn,null,7917164669585716,!1,[[4,137],[5,[20,232,cr.plugins_.Sprite.prototype.exps.LayerName,!0,null]],[7,[2,"Number"]]]],[137,cr.behaviors.Pin.prototype.acts.Pin,"Pin",7081828595278686,!1,[[4,232],[3,0]]],[232,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,57728294775144,!1,[[10,0],[7,[20,138,cr.plugins_.Text.prototype.exps.UID,!1,null]]]],[138,cr.plugins_.Text.prototype.acts.SetInstanceVar,null,0x99fb43a1aeeb8,!1,[[10,0],[7,[21,232,!0,null,
2]]]],[138,cr.plugins_.Text.prototype.acts.SetText,null,7522185055557314,!1,[[7,[5,[20,142,cr.plugins_.Dictionary.prototype.exps.Get,!1,null,[[21,232,!0,null,2]]],[21,138,!1,null,1]]]]]]],[0,null,!1,null,9645079874844560,[[138,cr.plugins_.Text.prototype.cnds.OnCreated,null,1,!1,!1,!1,7617869510178513,!1]],[[138,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0xa72037dbca306,!1,[[4,137],[3,0]]]]],[0,null,!1,null,324583707241245,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,9413966279935984,
!1,[[1,[2,"updateBoosterNumber"]]]]],[[142,cr.plugins_.Dictionary.prototype.acts.SetKey,null,9497666989896668,!1,[[1,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[7,[4,[20,142,cr.plugins_.Dictionary.prototype.exps.Get,!1,null,[[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]],[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,1]]]]]]]],[[0,null,!1,null,7262262117583154,[[-1,cr.system_object.prototype.cnds.PickByEvaluate,null,0,!1,!1,!1,5582018231685804,
!1,[[4,138],[0,[12,[21,138,!0,null,0],[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]]]],[[138,cr.plugins_.Text.prototype.acts.AddInstanceVar,null,4847536206549269,!1,[[10,1],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,2]]]]]],[138,cr.plugins_.Text.prototype.acts.SetText,null,6829882308956234,!1,[[7,[5,[20,142,cr.plugins_.Dictionary.prototype.exps.Get,!1,null,[[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]],[21,138,!1,null,1]]]]]]]]],
[0,null,!1,null,0xefe71dd84501,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,6482180186132101,!1,[[1,[2,"confirmBuyBooster"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,5744503143730557,!1,[[1,[2,"createConfirmDialog"]],[13,[7,[2,"Shopping"]],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"messages.shoppingConfirmation"]]]],[7,[23,"CenterX"]],[7,[23,"CenterY"]],[7,[10,[10,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,
null,[[0,0]]],[2,"|"]],[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,1]]]]],[7,[2,"confirmBuyBooster"]]]]]]],[0,null,!1,null,7459991594235529,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,8372500221320784,!1,[[1,[2,"buyBoosterOK"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x8240bf504a794,!1,[[1,[2,"updateBoosterNumber"]],[13,[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[7,[0,1]],[7,[0,0]]]]]],[[0,null,!1,null,0xb71426e0db931,
[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7863843201866191,!1,[[11,"PlayerCash"],[8,2],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[10,[10,[2,"boosters."],[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[2,".price_txu"]]]]]]]],[[132,cr.plugins_.Text.prototype.acts.SetFontColor,null,5326057944065697,!1,[[0,[19,cr.system_object.prototype.exps.rgb,[[0,200],[0,200],[0,200]]]]]]]]]],[0,null,!1,null,0x9781b6c043bb8,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,
null,2,!1,!1,!1,7430776669612645,!1,[[1,[2,"useBooster"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6606823387254484,!1,[[1,[2,"updateBoosterNumber"]],[13,[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[7,[0,-1]],[7,[0,0]]]]]]],[0,[!1,"Online-Booster"],!1,null,0xfb835c5a3b72f,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xfb835c5a3b72f,!1,[[1,[2,"Online-Booster"]]]]],[],[[0,null,!1,null,7139004392557787,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,
null,2,!1,!1,!1,5010818051157995,!1,[[1,[2,"buyBooster"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,4606286441150128,!1,[[1,[2,"confirmBuyBooster"]],[13,[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,1]]]]]]]]],[0,null,!1,null,7212299297349657,[[156,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,5999508959217852,!1],[156,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
null,0,!1,!1,!1,7716100131302518,!1,[[10,1],[8,0],[7,[2,"confirmBuyBooster"]]]],[156,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,29364414111268,!1,[[10,2],[8,0],[7,[2,"yes"]]]]],[],[[1,"params",1,"",!1,!1,0xb11c8cfa7a01a,!1],[0,null,!1,null,5097448638483076,[],[[-1,cr.system_object.prototype.acts.SetVar,null,6512891277754708,!1,[[11,"params"],[7,[21,156,!0,null,3]]]],[205,cr.plugins_.GameConfig.prototype.acts.Send,null,493205896784445,!1,[[1,[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,
!1,null,[[2,"Common.Game.BUY_BOOSTER"]]]],[7,[10,[10,[2,'{"itemId":"'],[19,cr.system_object.prototype.exps.tokenat,[[23,"params"],[0,1],[2,"|"]]]],[2,'"}']]]]]]]]],[0,null,!1,null,8478232490786102,[[205,cr.plugins_.GameConfig.prototype.cnds.OnEvent,null,1,!1,!1,!1,6671075067328774,!1,[[1,[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,!1,null,[[2,"Common.Game.BUY_BOOSTER"]]]]]]],[],[[1,"boosterId",1,"",!1,!1,0x6840c84a4ab61,!1],[1,"boosterType",1,"",!1,!1,8997274264837884,!1],[0,null,
!1,null,0x3fb3820e2509e,[],[[-1,cr.system_object.prototype.acts.SetVar,null,0xdd2c482ca63cd,!1,[[11,"boosterId"],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,!1,null,[[2,"Common.Game.BUY_BOOSTER"]]],[2,"item._id"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x6dee9a6f632df,!1,[[11,"boosterType"],[7,[20,141,cr.plugins_.Dictionary.prototype.exps.Get,!1,null,[[23,"boosterId"]]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,
null,0x5622b09d68d49,!1,[[1,[2,"updatePlayerCash"]],[13,[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,!1,null,[[2,"Common.Game.BUY_BOOSTER"]]],[2,"txu"]]]],[7,[2,"set"]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x4c54a9dbcfad1,!1,[[1,[2,"buyBoosterOK"]],[13,[7,[23,"boosterType"]]]]]]]]],[0,null,!1,null,8402182821859741,[[205,cr.plugins_.GameConfig.prototype.cnds.OnEventError,null,1,!1,!1,!1,
621350350733182,!1,[[1,[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,!1,null,[[2,"Common.Game.BUY_BOOSTER"]]]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6625910350878001,!1,[[1,[2,"buyBoosterError"]],[13,[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,!1,null,[[2,"Common.Game.BUY_BOOSTER"]]],[2,"message"]]]]]]]]],[0,null,!1,null,8893339405260685,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,
null,2,!1,!1,!1,0x779cb63287249,!1,[[1,[2,"buyBoosterError"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xd0b0b21e77d3e,!1,[[1,[2,"createInfoDialog"]],[13,[7,[2,"Error"]],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[7,[19,cr.system_object.prototype.exps.canvastolayerx,[[0,0],[7,[19,cr.system_object.prototype.exps.windowwidth],[0,2]],[7,[19,cr.system_object.prototype.exps.windowheight],[0,2]]]]],[7,[19,cr.system_object.prototype.exps.canvastolayery,[[0,
0],[7,[19,cr.system_object.prototype.exps.windowwidth],[0,2]],[7,[19,cr.system_object.prototype.exps.windowheight],[0,2]]]]],[7,[2,"buyBoosterError"]]]]],[132,cr.behaviors.Flash.prototype.acts.Flash,"Flash",5995152781429023,!1,[[0,[1,0.1]],[0,[1,0.1]],[0,[1,0.5]]]]]],[0,null,!1,null,0x7c941e931b7f6,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,9646424850647264,!1,[[1,[2,"useBooster"]]]]],[[205,cr.plugins_.GameConfig.prototype.acts.Send,null,794194127615696,!1,[[1,[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,
!1,null,[[2,"Common.Game.USE_BOOSTER"]]]],[7,[10,[10,[2,'{"itemId":"'],[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,1]]]],[2,'"}']]]]]]]]],[0,[!1,"Offline-Booster"],!1,null,0x51bcadd1335e6,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x51bcadd1335e6,!1,[[1,[2,"Offline-Booster"]]]]],[],[[0,null,!1,null,6890517027740097,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,8437842890137827,!1,[[1,[2,"updateBoosterNumber"]]]]],[[216,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,4717064042600573,!1,[[1,[2,"si.playerBoosters"]],[7,[20,142,cr.plugins_.Dictionary.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,null,5950891658366153,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0xe48bf06452fbb,!1,[[1,[2,"buyBooster"]]]]],[],[[1,"boosterPrice",0,0,!1,!1,0xaef3a8160831b,!1],[0,null,!1,null,7449865042985434,[],[[-1,cr.system_object.prototype.acts.SetVar,null,5068653060273507,!1,[[11,"boosterPrice"],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,
!1,null,[[10,[10,[2,"boosters."],[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[2,".price_txu"]]]]]]]]],[0,null,!1,null,9444347421870614,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xa8e41844d1f38,!1,[[11,"PlayerCash"],[8,5],[7,[23,"boosterPrice"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xca29eae53d3da,!1,[[1,[2,"confirmBuyBooster"]],[13,[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,
!1,null,[[0,1]]]]]]]]],[0,null,!1,null,7211289156692871,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,8100527705486117,!1]],[[132,cr.behaviors.Flash.prototype.acts.Flash,"Flash",7984171704893585,!1,[[0,[1,0.1]],[0,[1,0.1]],[0,[1,0.5]]]]]]]],[0,null,!1,null,7048439674323777,[[156,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,6300009671988104,!1],[156,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8337637177657284,!1,[[10,1],[8,0],[7,[2,"confirmBuyBooster"]]]],
[156,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0xcbd16f29670b6,!1,[[10,2],[8,0],[7,[2,"yes"]]]]],[],[[1,"params",1,"",!1,!1,4714294782891968,!1],[1,"boosterType",1,"",!1,!1,4852834606588764,!1],[1,"boosterPrice",0,0,!1,!1,5905903026082425,!1],[0,null,!1,null,7051287076643906,[],[[-1,cr.system_object.prototype.acts.SetVar,null,0x6dc27ef79e78,!1,[[11,"params"],[7,[21,156,!0,null,3]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x47d13ad921800,!1,[[11,"boosterType"],[7,
[19,cr.system_object.prototype.exps.tokenat,[[23,"params"],[0,0],[2,"|"]]]]]],[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,6863405987948996,!1,[[3,0],[7,[23,"boosterType"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8434082005375765,!1,[[11,"boosterPrice"],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[10,[10,[2,"boosters."],[23,"boosterType"]],[2,".price_txu"]]]]]]],[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,9549581410354306,!1,[[3,0],
[7,[23,"boosterPrice"]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xaab7d45e10df4,!1,[[1,[2,"updatePlayerCash"]],[13,[7,[3,[23,"boosterPrice"]]],[7,[2,"add"]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6238046475202667,!1,[[1,[2,"buyBoosterOK"]],[13,[7,[19,cr.system_object.prototype.exps.tokenat,[[23,"params"],[0,0],[2,"|"]]]]]]]]]]]]]]],["ScoreEvent",[[0,null,!1,null,0x43422a711b8b5,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xb584046c906d,
!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6506340693976266,!1,[[1,[2,"setTarget"]],[13,[7,[0,0]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,737440634108007,!1,[[11,"score"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4767054636453763,!1,[[11,"result"],[7,[0,0]]]]],[[0,null,!1,null,0xf171a7b16d8eb,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x66e97b259cce,!1,[[11,"OnlineMode"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,
null,0x73c83df782a4a,!1,[[1,[2,"Online-Score"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,7379374003293603,!1,[[1,[2,"Offline-Score"]],[3,0]]]]],[0,null,!1,null,0x3fed2de6f2cc0,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0x419c078a8db05,!1]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xea1a2211ef913,!1,[[1,[2,"Offline-Score"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,5806869814867514,!1,[[1,[2,"Online-Score"]],[3,0]]]]],[0,null,
!1,null,5990551211451617,[],[]]]],[0,null,!1,null,5206035418096676,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,6864135804899962,!1,[[1,[2,"setTarget"]]]]],[],[[0,null,!1,null,0x4ca9117b96e7a,[[208,cr.plugins_.Function.prototype.cnds.CompareParam,null,0,!1,!1,!1,4520532926230159,!1,[[0,[0,0]],[8,3],[7,[0,4]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,8628486184365104,!1,[[11,"currentTarget"],[7,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]]]],
[0,null,!1,null,5905709251440806,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5735929371358645,!1,[[11,"currentTarget"],[8,3],[7,[0,3]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,7770366647021996,!1,[[11,"targetScore"],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetLevelData,!1,null,[[10,[2,"config.targets."],[23,"currentTarget"]]]]]]],[33,cr.plugins_.Spritefont2.prototype.acts.SetText,null,7363738144384598,!1,[[7,[23,"targetScore"]]]]]]]],[0,null,!1,null,381211523722835,
[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,8371934509751904,!1,[[1,[2,"calculateFinalScore"]]]]],[[208,cr.plugins_.Function.prototype.acts.SetReturnValue,null,5567857786300063,!1,[[7,[19,cr.system_object.prototype.exps.round,[[6,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]],[23,"scoreBoost"]]]]]]]]],[0,null,!1,null,0x974626c2fe0b8,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,846095661537877,!1,[[0,[1,0.025]]]],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,8788433150736998,!1,[[11,"score"],[8,4],[7,[19,cr.system_object.prototype.exps["int"],[[20,32,cr.plugins_.Spritefont2.prototype.exps.Text,!0,null]]]]]]],[[32,cr.plugins_.Spritefont2.prototype.acts.SetText,null,0x6c4f673d3461b,!1,[[7,[4,[19,cr.system_object.prototype.exps["int"],[[20,32,cr.plugins_.Spritefont2.prototype.exps.Text,!0,null]]],[0,1]]]]]]],[0,null,!1,null,0xcd1695b4f7b1,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,9772214941377328,!1,[[1,[2,"finishLevel"]]]]],
[],[[0,null,!1,null,0x4b33ea4b90303,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xc64b747584b,!1,[[11,"result"],[8,5],[7,[0,1]]]]],[],[[0,null,!1,null,915646572869795,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,691640220329719,!1,[[11,"currentLevel"],[8,2],[7,[5,[20,203,cr.plugins_.Arr.prototype.exps.Width,!1,null],[0,1]]]]],[203,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,0xbb0a4ee08a7dc,!1,[[0,[4,[23,"currentLevel"],[0,1]]],[8,3],[7,[0,0]]]]],
[[203,cr.plugins_.Arr.prototype.acts.SetX,null,0xfd4d63ffbd710,!1,[[0,[4,[23,"currentLevel"],[0,1]]],[7,[0,1]]]]]],[0,null,!1,null,4750583848243632,[[203,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,0xc5f675961644d,!1,[[0,[23,"currentLevel"]],[8,2],[7,[4,[23,"result"],[0,1]]]]]],[[203,cr.plugins_.Arr.prototype.acts.SetX,null,6225153309841075,!1,[[0,[23,"currentLevel"]],[7,[4,[23,"result"],[0,1]]]]]]],[0,null,!1,null,8788859015365636,[],[[208,cr.plugins_.Function.prototype.acts.CallFunction,
null,9209026199751928,!1,[[1,[2,"calculateAchievement"]],[13]]]]]]]]],[0,[!1,"Online-Score"],!1,null,0x7c540751c8bff,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x7c540751c8bff,!1,[[1,[2,"Online-Score"]]]]],[],[[0,null,!1,null,6761373161264863,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,5734029504437374,!1,[[1,[2,"finishLevel"]]]]],[[205,cr.plugins_.GameConfig.prototype.acts.Send,null,8442288628916362,!1,[[1,[23,"MessageSubmitScore"]],[7,[10,[10,[10,
[10,[10,[10,[2,'{"score":'],[23,"score"]],[2,',"result":']],[23,"result"]],[2,',"level":']],[23,"currentLevel"]],[2,"}"]]]]]]],[0,null,!1,null,0x4a7f81341dada,[[205,cr.plugins_.GameConfig.prototype.cnds.OnEvent,null,1,!1,!1,!1,0xaa6ba389172d4,!1,[[1,[23,"MessageSubmitScore"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x736cef40e8ee6,!1,[[1,[2,"ShowEndGameDialog"]],[13,[7,[23,"result"]],[7,[23,"currentLevel"]]]]]]]]],[0,[!1,"Offline-Score"],!1,null,5839743559619494,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,5839743559619494,!1,[[1,[2,"Offline-Score"]]]]],[],[[0,null,!1,null,0x995611c1a890c,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,345981337197627,!1,[[1,[2,"finishLevel"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x681d1ecf3a275,!1,[[1,[2,"updatePlayerCash"]],[13,[7,[23,"score"]],[7,[2,"add"]]]]]],[[0,null,!1,null,0x44f21753a2f63,[[209,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,0xd00b9b8e6666e,!1,[[0,[23,"currentLevel"]],[8,
2],[7,[23,"score"]]]]],[[209,cr.plugins_.Arr.prototype.acts.SetX,null,0xc2e015d7e8291,!1,[[0,[23,"currentLevel"]],[7,[23,"score"]]]]]],[0,null,!1,null,6703588974635082,[],[[216,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x6c4d8444f2255,!1,[[1,[2,"si.scores"]],[7,[20,209,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]],[216,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,856114346145645,!1,[[1,[2,"si.levels"]],[7,[20,203,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,
null,4988170959181485,!1,[[1,[2,"ShowEndGameDialog"]],[13,[7,[23,"result"]],[7,[23,"currentLevel"]]]]]]]]]]]]],["AchievementEvent",[[0,null,!1,null,804707825117562,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4fbf591223bc9,!1]],[],[[0,null,!1,null,456371694645882,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7418892029683759,!1,[[11,"OnlineMode"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,7051552088825994,!1,[[1,[2,"Online-Achievement"]],
[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,5850997611715415,!1,[[1,[2,"Offline-Achievement"]],[3,0]]]]],[0,null,!1,null,4864763810432978,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,9729998569706286,!1]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x8ebc18dbcc728,!1,[[1,[2,"Offline-Achievement"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,8593869013231929,!1,[[1,[2,"Online-Achievement"]],[3,0]]]]]]],[0,null,!1,null,5120520973727336,
[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0x41089fae162ba,!1,[[1,[2,"calculateAchievement"]]]]],[],[[0,null,!1,null,0x58200c3318b05,[[148,cr.plugins_.Dictionary.prototype.cnds.CompareValue,null,0,!1,!1,!1,8083464650274332,!1,[[1,[2,"first-time-player"]],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5478133129338238,!1,[[11,"currentLevel"],[8,0],[7,[0,0]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x61e39efba24b8,!1,
[[1,[2,"addAchievement"]],[13,[7,[2,"first-time-player"]]]]]]],[0,null,!1,null,0xa8aca9df3785c,[[148,cr.plugins_.Dictionary.prototype.cnds.CompareValue,null,0,!1,!1,!1,8680392089204663,!1,[[1,[2,"pro-player"]],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5234131228992747,!1,[[11,"currentLevel"],[8,0],[7,[0,19]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,5390597658913397,!1,[[1,[2,"addAchievement"]],[13,[7,[2,"pro-player"]]]]]]],[0,null,!1,null,
5044233265330722,[[148,cr.plugins_.Dictionary.prototype.cnds.CompareValue,null,0,!1,!1,!1,7139112195411377,!1,[[1,[2,"all-star-player"]],[8,0],[7,[0,0]]]]],[],[[1,"ok",0,1,!1,!1,8590086285842232,!1],[0,null,!1,null,8713291874743425,[[-1,cr.system_object.prototype.cnds.While,null,0,!0,!1,!1,4576838876779448,!1],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,9426042056402972,!1,[[7,[19,cr.system_object.prototype.exps.loopindex]],[8,2],[7,[20,203,cr.plugins_.Arr.prototype.exps.Width,!1,
null]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xa8e0e7719737b,!1,[[11,"ok"],[8,0],[7,[0,1]]]]],[],[[0,null,!1,null,9072237188220712,[[203,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,463898308285166,!1,[[0,[19,cr.system_object.prototype.exps.loopindex]],[8,2],[7,[0,5]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xfd43774c51cd,!1,[[11,"ok"],[7,[0,0]]]]]]]],[0,null,!1,null,0xc8dab252a79f4,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xeca6f56aa9071,
!1,[[11,"ok"],[8,0],[7,[0,1]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0x4ffd54c8b8cc2,!1,[[1,[2,"addAchievement"]],[13,[7,[2,"all-star-player"]]]]]]]]]]],[0,null,!1,null,0x94ac618d7cf63,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0x7e0fd8b1cfa5c,!1,[[1,[2,"addAchievement"]]]]],[[148,cr.plugins_.Dictionary.prototype.acts.SetKey,null,8278282145796861,!1,[[1,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]],[7,[0,1]]]]]],[0,null,!1,null,
8803942000975933,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,494317872468621,!1,[[1,[2,"showAchievements"]]]]],[],[[0,null,!1,null,6322467842907757,[[248,cr.plugins_.Sprite.prototype.cnds.PickByUID,null,0,!1,!1,!0,0x3d03e7d80025b,!1,[[0,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]]],[]],[1,"index",0,1,!1,!1,5809792592499379,!1],[0,null,!1,null,0xb793e5ffbb6f5,[[148,cr.plugins_.Dictionary.prototype.cnds.ForEachKey,null,0,!0,!1,!1,4607000231763086,!1]],
[],[[0,null,!1,null,4683156944849221,[[148,cr.plugins_.Dictionary.prototype.cnds.CompareCurrentValue,null,0,!1,!1,!1,8054504141658763,!1,[[8,4],[7,[0,0]]]]],[[248,cr.plugins_.Sprite.prototype.acts.Spawn,null,728703479166308,!1,[[4,149],[5,[20,248,cr.plugins_.Sprite.prototype.exps.LayerName,!0,null]],[7,[10,[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,1]]],[23,"index"]]]]],[149,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xd2a2aceb5778a,!1,[[1,[19,cr.system_object.prototype.exps.replace,
[[20,148,cr.plugins_.Dictionary.prototype.exps.CurrentKey,!0,null],[2,"-"],[2,""]]]],[3,1]]],[149,cr.behaviors.Pin.prototype.acts.Pin,"Pin",5301894904706552,!1,[[4,248],[3,0]]],[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,6864576583672332,!1,[[3,0],[7,[19,cr.system_object.prototype.exps.replace,[[20,148,cr.plugins_.Dictionary.prototype.exps.CurrentKey,!0,null],[2,"-"],[2,""]]]]]]]],[0,null,!1,null,7894492047663595,[],[[-1,cr.system_object.prototype.acts.AddVar,null,5634568360529888,!1,
[[11,"index"],[7,[0,1]]]]]]]]]],[0,[!1,"Online-Achievement"],!1,null,8399399514670733,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8399399514670733,!1,[[1,[2,"Online-Achievement"]]]]],[],[[0,null,!1,null,4526552328435828,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,7536658612431966,!1,[[1,[2,"addAchievement"]]]]],[[205,cr.plugins_.GameConfig.prototype.acts.Send,null,8581961074104117,!1,[[1,[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,
!1,null,[[2,"Common.Game.ADD_ACHIEVEMENT"]]]],[7,[10,[10,[2,'{"achievement_name":"'],[20,147,cr.plugins_.Dictionary.prototype.exps.Get,!1,null,[[20,208,cr.plugins_.Function.prototype.exps.Param,!1,null,[[0,0]]]]]],[2,'"}']]]]]]]]],[0,[!1,"Offline-Achievement"],!1,null,9775602943447412,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9775602943447412,!1,[[1,[2,"Offline-Achievement"]]]]],[],[[0,null,!1,null,4987466015336131,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,
2,!1,!1,!1,0xe4ba5c46f420,!1,[[1,[2,"addAchievement"]]]]],[[216,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x48db60e51bea2,!1,[[1,[2,"si.playerAchievements"]],[7,[20,148,cr.plugins_.Dictionary.prototype.exps.AsJSON,!0,null]]]]]]]]]],["InitializeEvent",[[0,null,!1,null,7657915430917376,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,7125854270999522,!1,[[1,[2,"OnlineModeUpdated"]]]]],[],[[0,null,!1,null,0x65259f6767cd5,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,6033894034871494,!1,[[11,"OnlineMode"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xc6de96f208849,!1,[[1,[2,"Online-Initialize"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xb737d8115ebf1,!1,[[1,[2,"Offline-Initialize"]],[3,0]]]]],[0,null,!1,null,0x751003d9f4966,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0x4a0333634fc0d,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,870542062029039,!1,[[11,"OnlineMode"],
[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,564098255952467,!1,[[1,[2,"Offline-Initialize"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,9257630461570556,!1,[[1,[2,"Online-Initialize"]],[3,0]]]]],[0,null,!1,null,8195972508921764,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0xb3f63351bf09a,!1]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,8841050310715143,!1,[[1,[2,"Online-Initialize"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,
null,6617128369054319,!1,[[1,[2,"Offline-Initialize"]],[3,0]]]]]]],[0,null,!1,null,7087058443081983,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0x8a912a70c2487,!1,[[1,[2,"initializeGame"]]]]],[[205,cr.plugins_.GameConfig.prototype.acts.ClearEventsData,null,6608939306845802,!1],[204,cr.plugins_.ShakeItUtils.prototype.acts.ReloadSettingsFromJson,null,0x3ac50c5ee28fc,!1]]],[0,[!1,"Online-Initialize"],!1,null,0xd4860448ee0ef,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,0xd4860448ee0ef,!1,[[1,[2,"Online-Initialize"]]]]],[],[[0,null,!1,null,5909239964432093,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,5690197489553626,!1,[[1,[2,"initializeGame"]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0xa096c4fc6baca,!1,[[3,0],[7,[2,"Initialize player data"]]]],[203,cr.plugins_.Arr.prototype.acts.JSONLoad,null,0x954355fdacc7c,!1,[[1,[20,205,cr.plugins_.GameConfig.prototype.exps.GetGameConfigAsArrayJSONAtKey,!1,null,[[2,
"playerProgress.progress.levels"],[0,1]]]]]],[203,cr.plugins_.Arr.prototype.acts.SetSize,null,0x3f0cf9c004859,!1,[[0,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"levels.length"]]]],[0,[0,1]],[0,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,986743210165502,!1,[[11,"PlayerName"],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetGameConfigAtKey,!1,null,[[2,"playerProgress.progress._id"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,308443818825414,
!1,[[11,"MessageSubmitScore"],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,!1,null,[[2,"Common.Game.SUBMIT_SCORE"]]]]]],[204,cr.plugins_.ShakeItUtils.prototype.acts.InitializeBoosters,null,8518921331792011,!1,[[1,[20,205,cr.plugins_.GameConfig.prototype.exps.GetGameConfigAtKey,!1,null,[[2,"gameConfig.boosters"]]]]]],[142,cr.plugins_.Dictionary.prototype.acts.AddKey,null,6543377963709121,!1,[[1,[2,"extra-time"]],[7,[0,0]]]],[142,cr.plugins_.Dictionary.prototype.acts.AddKey,null,
0x6dbcab5a25679,!1,[[1,[2,"double-cash"]],[7,[0,0]]]],[142,cr.plugins_.Dictionary.prototype.acts.AddKey,null,0xb329c770c9c45,!1,[[1,[2,"good-mood"]],[7,[0,0]]]],[148,cr.plugins_.Dictionary.prototype.acts.AddKey,null,6074737955567551,!1,[[1,[2,"first-time-player"]],[7,[0,0]]]],[148,cr.plugins_.Dictionary.prototype.acts.AddKey,null,6478295784968706,!1,[[1,[2,"pro-player"]],[7,[0,0]]]],[148,cr.plugins_.Dictionary.prototype.acts.AddKey,null,0xe796986e5b3cb,!1,[[1,[2,"all-star-player"]],[7,[0,0]]]]],[[1,
"boosterType",1,"",!1,!1,6868908306222878,!1],[0,null,!1,null,8967137342693503,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xefbf04a75b4a8,!1,[[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetGameConfigAtKey,!1,null,[[2,"playerProgress.boosters.length"]]]],[8,4],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.For,null,0,!0,!1,!1,6350242157393082,!1,[[1,[2,"booster"]],[0,[0,0]],[0,[5,[20,205,cr.plugins_.GameConfig.prototype.exps.GetGameConfigAtKey,!1,null,[[2,"playerProgress.boosters.length"]]],
[0,1]]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,986316542650299,!1,[[11,"boosterType"],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetGameConfigAtKey,!1,null,[[10,[10,[2,"playerProgress.boosters."],[19,cr.system_object.prototype.exps.loopindex]],[2,"._id"]]]]]]],[142,cr.plugins_.Dictionary.prototype.acts.SetKey,null,7913598903919761,!1,[[1,[20,141,cr.plugins_.Dictionary.prototype.exps.Get,!1,null,[[23,"boosterType"]]]],[7,[4,[20,142,cr.plugins_.Dictionary.prototype.exps.Get,!1,null,
[[20,141,cr.plugins_.Dictionary.prototype.exps.Get,!1,null,[[23,"boosterType"]]]]],[0,1]]]]]]],[1,"achievementType",1,"",!1,!1,8022330301566931,!1],[0,null,!1,null,0x59fcaf5f785e3,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,6253899419184874,!1,[[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetGameConfigAtKey,!1,null,[[2,"playerProgress.achievements.length"]]]],[8,4],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.For,null,0,!0,!1,!1,9668685935134154,!1,[[1,[2,"achievement"]],[0,
[0,0]],[0,[5,[20,205,cr.plugins_.GameConfig.prototype.exps.GetGameConfigAtKey,!1,null,[[2,"playerProgress.achievements.length"]]],[0,1]]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9565076336562918,!1,[[11,"achievementType"],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetGameConfigAtKey,!1,null,[[10,[10,[2,"playerProgress.achievements."],[19,cr.system_object.prototype.exps.loopindex]],[2,"._id"]]]]]]],[148,cr.plugins_.Dictionary.prototype.acts.SetKey,null,0xc867bb0dd3f2,!1,[[1,[20,147,
cr.plugins_.Dictionary.prototype.exps.Get,!1,null,[[23,"achievementType"]]]],[7,[0,1]]]]]],[0,null,!1,null,5638414507973423,[],[[205,cr.plugins_.GameConfig.prototype.acts.Send,null,750129285720096,!1,[[1,[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,!1,null,[[2,"Common.Game.PLAY"]]]],[7,[2,""]]]]]]]],[0,null,!1,null,9595469007201848,[[205,cr.plugins_.GameConfig.prototype.cnds.OnEvent,null,1,!1,!1,!1,0xa19dd641c4381,!1,[[1,[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,
!1,null,[[2,"Common.Game.WELCOME"]]]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,8478253868801969,!1,[[1,[2,"initializeGameDone"]],[13]]]]]]],[0,[!1,"Offline-Initialize"],!1,null,0xc01039ef75390,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xc01039ef75390,!1,[[1,[2,"Offline-Initialize"]]]]],[],[[0,null,!1,null,575145973433149,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,639549750855895,!1,[[1,[2,"initializeGame"]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,
null,877551281785995,!1,[[3,0],[7,[2,"Initialize local data"]]]]],[[0,null,!1,null,73780750437106,[[216,cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,null,0,!1,!1,!1,4834057553486415,!1,[[1,[2,"si.levels"]]]]],[[203,cr.plugins_.Arr.prototype.acts.JSONLoad,null,5319517728328112,!1,[[1,[20,216,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"si.levels"]]]]]]]],[0,null,!1,null,8494518056940087,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,8644110388870359,!1]],[[203,
cr.plugins_.Arr.prototype.acts.Clear,null,7654778361901673,!1]]],[0,null,!1,null,7627259976885142,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xdb48e5faefb07,!1,[[7,[20,203,cr.plugins_.Arr.prototype.exps.Width,!1,null]],[8,1],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"levels.length"]]]]]]],[[203,cr.plugins_.Arr.prototype.acts.SetSize,null,8001524106391305,!1,[[0,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"levels.length"]]]],
[0,[0,1]],[0,[0,1]]]]]],[0,null,!1,null,9785176976577060,[[203,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,8786426759490864,!1,[[0,[0,0]],[8,2],[7,[0,1]]]]],[[203,cr.plugins_.Arr.prototype.acts.SetX,null,5994797297953469,!1,[[0,[0,0]],[7,[0,1]]]]]],[0,null,!1,null,5470454870742072,[],[[216,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x7374bedb1bfbf,!1,[[1,[2,"si.levels"]],[7,[20,203,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,null,9428656803944766,[[216,cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
null,0,!1,!1,!1,0xe2e9b47cc56eb,!1,[[1,[2,"si.playerCash"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0x673b456cf5261,!1,[[11,"PlayerCash"],[7,[20,216,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"si.playerCash"]]]]]]]],[0,null,!1,null,9192615712157184,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,614427007961712,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,5857677722492149,!1,[[11,"PlayerCash"],[7,[0,0]]]]]],[0,null,!1,null,9519729835917076,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0xeaa826fc6a623,!1,[[11,"PlayerCash"],[8,2],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,7882540563133109,!1,[[11,"PlayerCash"],[7,[0,0]]]]]],[0,null,!1,null,0x7b77275faecdb,[],[[216,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x695ac4063d47b,!1,[[1,[2,"si.playerCash"]],[7,[23,"PlayerCash"]]]]]],[0,null,!1,null,8987879123714657,[[216,cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,null,0,!1,!1,!1,0xcf786251dc82d,!1,[[1,[2,"si.scores"]]]]],[[209,
cr.plugins_.Arr.prototype.acts.JSONLoad,null,0x8296025144d5d,!1,[[1,[20,216,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"si.scores"]]]]]]]],[0,null,!1,null,0xbb4cc690ea7fc,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,6429168401681756,!1]],[[209,cr.plugins_.Arr.prototype.acts.Clear,null,6069359358350016,!1]]],[0,null,!1,null,0x9f6237be043a0,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,7447592134621345,!1,[[7,[20,209,cr.plugins_.Arr.prototype.exps.Width,
!1,null]],[8,1],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"levels.length"]]]]]]],[[209,cr.plugins_.Arr.prototype.acts.SetSize,null,5934450664154098,!1,[[0,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[2,"levels.length"]]]],[0,[0,1]],[0,[0,1]]]]]],[0,null,!1,null,0xf34aeeb78c61b,[],[[216,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6621672694448717,!1,[[1,[2,"si.scores"]],[7,[20,209,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],
[0,null,!1,null,6753739296111759,[[216,cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,null,0,!1,!1,!1,0x6c64070ba4217,!1,[[1,[2,"si.playerBoosters"]]]]],[[142,cr.plugins_.Dictionary.prototype.acts.JSONLoad,null,5065489451565624,!1,[[1,[20,216,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"si.playerBoosters"]]]]]]]],[0,null,!1,null,7075296254123963,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0x3d512cdcff896,!1]],[[142,cr.plugins_.Dictionary.prototype.acts.Clear,
null,8300772628459311,!1]]],[0,null,!1,null,9345108480031942,[[142,cr.plugins_.Dictionary.prototype.cnds.HasKey,null,0,!1,!0,!1,0xb0765bfa9a5c0,!1,[[1,[2,"extra-time"]]]]],[[142,cr.plugins_.Dictionary.prototype.acts.AddKey,null,9405951393128716,!1,[[1,[2,"extra-time"]],[7,[0,0]]]]]],[0,null,!1,null,0xe5f010365b43,[[142,cr.plugins_.Dictionary.prototype.cnds.HasKey,null,0,!1,!0,!1,7082215371041337,!1,[[1,[2,"double-cash"]]]]],[[142,cr.plugins_.Dictionary.prototype.acts.AddKey,null,9406383999094994,
!1,[[1,[2,"double-cash"]],[7,[0,0]]]]]],[0,null,!1,null,0xe367db3e907f1,[[142,cr.plugins_.Dictionary.prototype.cnds.HasKey,null,0,!1,!0,!1,0xcfe1ba3bd01c0,!1,[[1,[2,"good-mood"]]]]],[[142,cr.plugins_.Dictionary.prototype.acts.AddKey,null,0xd96a6388923d5,!1,[[1,[2,"good-mood"]],[7,[0,0]]]]]],[0,null,!1,null,9916668581796268,[],[[216,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8451165927492047,!1,[[1,[2,"si.playerBoosters"]],[7,[20,142,cr.plugins_.Dictionary.prototype.exps.AsJSON,!0,null]]]]]],
[0,null,!1,null,7412696203009516,[[216,cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,null,0,!1,!1,!1,7803891484776989,!1,[[1,[2,"si.playerAchievements"]]]]],[[148,cr.plugins_.Dictionary.prototype.acts.JSONLoad,null,0x8bb9c111edd48,!1,[[1,[20,216,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"si.playerAchievements"]]]]]]]],[0,null,!1,null,5159543233401495,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,0xd3f54ddcfcdd9,!1]],[[148,cr.plugins_.Dictionary.prototype.acts.Clear,
null,5988729554994425,!1]]],[0,null,!1,null,6369755879248726,[[148,cr.plugins_.Dictionary.prototype.cnds.HasKey,null,0,!1,!0,!1,7392077341032723,!1,[[1,[2,"first-time-player"]]]]],[[148,cr.plugins_.Dictionary.prototype.acts.AddKey,null,6275961315626945,!1,[[1,[2,"first-time-player"]],[7,[0,0]]]]]],[0,null,!1,null,0xbcc9c7c44244b,[[148,cr.plugins_.Dictionary.prototype.cnds.HasKey,null,0,!1,!0,!1,7030674401778424,!1,[[1,[2,"pro-player"]]]]],[[148,cr.plugins_.Dictionary.prototype.acts.AddKey,null,7581351013991793,
!1,[[1,[2,"pro-player"]],[7,[0,0]]]]]],[0,null,!1,null,7337288116586598,[[148,cr.plugins_.Dictionary.prototype.cnds.HasKey,null,0,!1,!0,!1,8046607283105908,!1,[[1,[2,"all-star-player"]]]]],[[148,cr.plugins_.Dictionary.prototype.acts.AddKey,null,6697207136941821,!1,[[1,[2,"all-star-player"]],[7,[0,0]]]]]],[0,null,!1,null,0x4c0323022e758,[],[[216,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,7486242184733202,!1,[[1,[2,"si.playerAchievements"]],[7,[20,148,cr.plugins_.Dictionary.prototype.exps.AsJSON,
!0,null]]]]]],[0,null,!1,null,0xee92f717f7537,[],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,5095756648725495,!1,[[1,[2,"initializeGameDone"]],[13]]]]]]]]],[0,null,!1,null,0xec7e5e98b588d,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0xf0fb5264369c7,!1,[[1,[2,"initializeGameDone"]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,8560193713578459,!1,[[3,0],[7,[2,"Initialize game done"]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9737372877319588,
!1,[[6,"Intro"]]]]]]],["SocketEvent",[[2,"Dialog",!1],[0,null,!1,null,6829202401497919,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5975624433720167,!1]],[],[[0,null,!1,null,7554846207496094,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7262671709462688,!1,[[11,"PLATFORM"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,5953197588957332,!1,[[1,[2,"Web-Socket"]],[3,1]]]]],[0,null,!1,null,8619195615888109,[[-1,cr.system_object.prototype.cnds.Else,
null,0,!1,!1,!1,5890297973900562,!1]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x41e850a4bcfe9,!1,[[1,[2,"App-Socket"]],[3,1]]]]]]],[0,null,!1,null,6915858960982313,[[205,cr.plugins_.GameConfig.prototype.cnds.OnSocketError,null,1,!1,!1,!1,6269768174756511,!1],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,5296402488751519,!1,[[7,[19,cr.system_object.prototype.exps.layoutname]],[8,1],[7,[2,"Login"]]]],[-1,cr.system_object.prototype.cnds.PickByEvaluate,null,0,!1,!1,!1,0xf8ffc4535d373,
!1,[[4,154],[0,[12,[21,154,!0,null,1],[2,"socketDisconnect"]]]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0x77fc8267738ea,!1,[[7,[20,154,cr.plugins_.Sprite.prototype.exps.PickedCount,!1,null]],[8,0],[7,[0,0]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0x90bb594c71f96,!1,[[3,0],[7,[2,"Show dialog socket error"]]]]],[[1,"error",1,"",!1,!1,811418912595532,!1],[1,"localMessage",1,"",!1,!1,0xc5977fbd318ef,!1],[0,null,!1,null,0x91abd252d6c4a,[],[[-1,cr.system_object.prototype.acts.SetVar,
null,9859187606491528,!1,[[11,"error"],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetSocketErrorMessage,!0,null]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xf2345e3e405d,!1,[[11,"localMessage"],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,!1,null,[[10,[2,"systemErrors."],[23,"error"]]]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6463668557280979,!1,[[1,[2,"createInfoDialog"]],[13,[7,[2,"Error"]],[7,[18,[13,[23,"localMessage"],[2,"0"]],[23,"localMessage"],
[23,"error"]]],[7,[23,"CenterX"]],[7,[23,"CenterY"]],[7,[2,"socketError"]]]]]]]]],[0,null,!1,null,8719123398867874,[[205,cr.plugins_.GameConfig.prototype.cnds.OnSocketDisconnect,null,1,!1,!1,!1,8633159784107354,!1]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,8375698490278751,!1,[[3,0],[7,[2,"Show dialog socket disconnect"]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xe5e309baf8051,!1,[[1,[2,"createInfoDialog"]],[13,[7,[2,"Error"]],[7,[20,204,cr.plugins_.ShakeItUtils.prototype.exps.GetSettingsData,
!1,null,[[2,"messages.socketDisconnected"]]]],[7,[23,"CenterX"]],[7,[23,"CenterY"]],[7,[2,"socketDisconnect"]]]]]],[[0,null,!1,null,8511957513924903,[[-1,cr.system_object.prototype.cnds.PickByEvaluate,null,0,!1,!1,!1,6545161813780497,!1,[[4,154],[0,[12,[21,154,!0,null,1],[2,"socketError"]]]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,7443700464191715,!1,[[7,[20,154,cr.plugins_.Sprite.prototype.exps.PickedCount,!1,null]],[8,4],[7,[0,0]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,
null,9261342539188672,!1,[[1,[2,"deleteInfoDialog"]],[13,[7,[2,"socketError"]]]]]]]]],[0,null,!1,null,4977144429419373,[[205,cr.plugins_.GameConfig.prototype.cnds.OnSocketReconnect,null,1,!1,!1,!1,9504656364578540,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6400649430165716,!1,[[1,[2,"deleteInfoDialog"]],[13,[7,[2,"socketDisconnect"]]]]]]],[0,null,!1,null,6896715475017345,[[205,cr.plugins_.GameConfig.prototype.cnds.OnEvent,null,1,!1,!1,!1,5890027540060336,!1,[[1,[2,"Control"]]]]],
[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,8242142085128035,!1,[[3,0],[7,[2,"Control message"]]]]],[[1,"type",1,"",!0,!1,6904775912667149,!1],[0,null,!1,null,0x7149f28c45f70,[],[[-1,cr.system_object.prototype.acts.SetVar,null,5591612266671987,!1,[[11,"type"],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[2,"Control"],[2,"type"]]]]]]]],[0,null,!0,null,5024264937776215,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xb189af94a347a,!1,[[7,[23,"type"]],
[8,0],[7,[2,"FORCE_LOGOUT"]]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,5123269074338021,!1,[[7,[23,"type"]],[8,0],[7,[2,"FORCE_LOGIN"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,6991634769832359,!1,[[1,[2,"createInfoDialog"]],[13,[7,[2,"Error"]],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetEventData,!1,null,[[2,"Control"],[2,"message"]]]],[7,[23,"CenterX"]],[7,[23,"CenterY"]],[7,[2,"forceLogout"]]]]]]]]],[0,null,!1,null,0xa1ba9c0340471,[[205,cr.plugins_.GameConfig.prototype.cnds.OnPlayerInfo,
null,1,!1,!1,!1,7534966312109145,!1]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0xc47feecfff136,!1,[[3,0],[7,[2,"Player info"]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,501347418186471,!1,[[1,[2,"updatePlayerCash"]],[13,[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetPlayerInfoAtKey,!1,null,[[2,"txu"]]]],[7,[2,"set"]]]]]]],[0,null,!1,null,0xe0e726a161113,[[205,cr.plugins_.GameConfig.prototype.cnds.OnEvent,null,1,!1,!1,!1,8498562754906407,!1,[[1,[20,205,cr.plugins_.GameConfig.prototype.exps.GetMessageByKey,
!1,null,[[2,"Common.Game.IS_TINIZEN_CONNECTED"]]]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,9575039542111878,!1,[[3,0],[7,[2,"onconnected"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5082708377060252,!1,[[11,"IsTinizenConnected"],[7,[20,205,cr.plugins_.GameConfig.prototype.exps.GetLastEventData,!1,null,[[2,"connected"]]]]]],[208,cr.plugins_.Function.prototype.acts.CallFunction,null,5967697791894052,!1,[[1,[2,"onIsTinizenConnected"]],[13]]]]],[0,[!1,"Web-Socket"],!1,null,
7135379710985191,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7135379710985191,!1,[[1,[2,"Web-Socket"]]]]],[],[[0,null,!1,null,0xf813f1bb00eab,[[154,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,8982708248752153,!1],[154,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,9649559767923760,!1,[[10,2],[8,0],[7,[2,"ok"]]]]],[],[[0,null,!0,null,0xb315afd0f8498,[[154,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,6680307484365861,
!1,[[10,1],[8,0],[7,[2,"socketDisconnect"]]]],[154,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0xbb534e4422f5d,!1,[[10,1],[8,0],[7,[2,"socketError"]]]]],[[206,cr.plugins_.Browser.prototype.acts.ConsoleLog,null,0x816370437d0cc,!1,[[3,0],[7,[10,[2,"go back "],[21,154,!0,null,1]]]]],[205,cr.plugins_.GameConfig.prototype.acts.BackToScene,null,5315674647553315,!1]]],[0,null,!1,null,424558976916154,[[154,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x460616a5a58cf,
!1,[[10,1],[8,0],[7,[2,"forceLogout"]]]]],[[206,cr.plugins_.Browser.prototype.acts.ExecJs,null,6597966548319493,!1,[[1,[2,"window.top.location.href = '/logout';"]]]]]]]]]],[0,[!1,"App-Socket"],!1,null,7070541388085863,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7070541388085863,!1,[[1,[2,"App-Socket"]]]]],[],[[0,null,!1,null,0xcfd21234ede29,[[154,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,627120606483774,!1],[154,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
null,0,!1,!1,!1,5679601871881623,!1,[[10,2],[8,0],[7,[2,"ok"]]]]],[],[[0,null,!1,null,6722864035097248,[[154,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,6261979124235613,!1,[[10,1],[8,0],[7,[2,"socketError"]]]]],[[205,cr.plugins_.GameConfig.prototype.acts.DisconnectSocketIO,null,5067783717574822,!1]]],[0,null,!1,null,0xe7f0443450a2e,[[154,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,5253824951812532,!1,[[10,1],[8,0],[7,[2,"socketDisconnect"]]]]],[[206,
cr.plugins_.Browser.prototype.acts.ConsoleLog,null,8726825197155302,!1,[[3,0],[7,[10,[2,"back to login "],[21,154,!0,null,1]]]]],[205,cr.plugins_.GameConfig.prototype.acts.DisconnectSocketIO,null,0x9bafdd446dd81,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,7817497779973357,!1,[[6,"Login"]]]]],[0,null,!1,null,8422253233846143,[[154,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8900002294485879,!1,[[10,1],[8,0],[7,[2,"forceLogout"]]]]],[[205,cr.plugins_.GameConfig.prototype.acts.DisconnectSocketIO,
null,292174372333374,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,9289301406407746,!1,[[6,"Login"]]]]]]]]]]],["StoryEvent",[[2,"GlobalEvent",!1],[0,null,!1,null,8169746552672118,[[201,cr.plugins_.Spriter.prototype.cnds.readyForSetup,null,1,!1,!1,!1,7605211148538918,!1]],[[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0xa9dd04015dfd2,!1,[[4,182],[1,[2,"BG"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,638575376654218,!1,[[4,183],[1,[2,"Test"]]]],
[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,5721501360943819,!1,[[4,184],[1,[2,"BG_000"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,7149297236578131,!1,[[4,185],[1,[2,"Test_000"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0xbc949f3a7fea7,!1,[[4,186],[1,[2,"ki_001"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,9354887652219092,!1,[[4,187],[1,[2,"BG_001"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,
null,5096172778865406,!1,[[4,188],[1,[2,"Test01"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,9307425047223844,!1,[[4,189],[1,[2,"Test02"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,9532222940806460,!1,[[4,190],[1,[2,"BG_002"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0xda80ef66db533,!1,[[4,191],[1,[2,"char01"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,7290792651356752,!1,[[4,192],[1,[2,"char02"]]]],
[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0x429f897c34fb0,!1,[[4,193],[1,[2,"yeah"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0xd662b67c9f7be,!1,[[4,194],[1,[2,"ki"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,9413654980211860,!1,[[4,195],[1,[2,"te_000"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,7727534120790781,!1,[[4,196],[1,[2,"ki_002"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,
null,8783497330942922,!1,[[4,197],[1,[2,"ki_003"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,6713497919035993,!1,[[4,198],[1,[2,"te"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,0xba7c28b234f54,!1,[[4,199],[1,[2,"light"]]]],[201,cr.plugins_.Spriter.prototype.acts.associateTypeWithName,null,7480717210589385,!1,[[4,200],[1,[2,"group"]]]]]],[0,null,!1,null,8567919007196184,[[201,cr.plugins_.Spriter.prototype.cnds.OnAnimFinished,null,1,!1,!1,!1,5272777887261256,
!1,[[1,[2,"scene-1"]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,8224627894349903,!1,[[0,[1,0.3]]]],[201,cr.plugins_.Spriter.prototype.acts.setAnim,null,0x4def9692eb6d7,!1,[[1,[2,"scene-2"]],[3,0],[0,[0,0]]]]]],[0,null,!1,null,0x7402f066d69cd,[[201,cr.plugins_.Spriter.prototype.cnds.OnAnimFinished,null,1,!1,!1,!1,746716820437456,!1,[[1,[2,"scene-2"]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,5608756959506608,!1,[[0,[1,0.3]]]],[201,cr.plugins_.Spriter.prototype.acts.setAnim,null,0xa9813bdc9383d,
!1,[[1,[2,"scene-3"]],[3,0],[0,[0,0]]]]]],[0,null,!1,null,0xb88048b8014b4,[[201,cr.plugins_.Spriter.prototype.cnds.OnAnimFinished,null,1,!1,!1,!1,0xc4ad21c2ccf52,!1,[[1,[2,"scene-3"]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0x55429dcaa9a54,!1,[[0,[1,0.3]]]],[201,cr.plugins_.Spriter.prototype.acts.setAnim,null,889298363897411,!1,[[1,[2,"scene-4"]],[3,0],[0,[0,0]]]]]],[0,null,!1,null,0x8b12272bb4378,[[201,cr.plugins_.Spriter.prototype.cnds.OnAnimFinished,null,1,!1,!1,!1,5932003642821447,!1,
[[1,[2,"scene-4"]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,0xaa615746c6cad,!1,[[1,[2,"endStory"]],[13]]]]],[0,null,!1,null,8354208141688746,[[201,cr.plugins_.Spriter.prototype.cnds.OnCreated,null,1,!1,!1,!1,8271832817970215,!1]],[[201,cr.plugins_.Spriter.prototype.acts.setPlaybackSpeedRatio,null,422032530632197,!1,[[0,[1,0.3]]]]]],[0,null,!1,null,7504113037882202,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9020833854104936,!1]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,
null,6230315816178521,!1,[[1,[2,"hideAd"]],[13]]]]],[0,null,!1,null,58674453018519,[[213,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,26420936057895,!1]],[],[[0,null,!1,null,5864093020813198,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,5807768261621443,!1,[[7,[20,208,cr.plugins_.Function.prototype.exps.Call,!1,null,[[2,"IsTouched"],[20,220,cr.plugins_.Sprite.prototype.exps.UID,!1,null]]]],[8,0],[7,[0,1]]]]],[[208,cr.plugins_.Function.prototype.acts.CallFunction,null,
7925111619063336,!1,[[1,[2,"endStory"]],[13]]]]]]],[0,null,!1,null,0xfae77803d7a97,[[208,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,7355689245205615,!1,[[1,[2,"endStory"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9152991909797860,!1,[[11,"ShowFullScreenAd"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,6483862013139832,!1,[[6,"SelectLevel"]]]]]]],["Changelog",[]]],"",!1,1080,720,2,!0,!0,!1,"1.0.0",!0,!0,0,0,364,!1,!0,[[0,1,2,3,4,5,6,7,8,9,13],[39,43,
40,41,42,44],[47,48,49,51,52,53,46,54,50,68,55,56],[33,31,32],[18,19],[58,57],[64,65],[77,78,79,76,80,81,82,104],[61,63],[100,101,102,103],[87,107,86,89,88],[105,83],[106,84,85],[91,93,92,94,90,98],[138,137],[117,119,113,118],[121,124,134,125],[131,126,129,130,132,122,127,133,128,135],[158,156,159,157],[164,165,166,162,161,163,168,167,170],[154,155,160],[175,173,177,174],[186,191,192,193,194,189,190,182,185,188,183,184,187,201,197,195,200,198,196,199]]]};

createCocoonJSRuntime();

})();
